/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern0 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern0 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_HFmode:
      if (pattern0 (x3, 
E_HFmode) != 0)
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    case E_DImode:
      if (pattern3 (x3) != 0)
        return -1;
      return 4;

    case E_RVVM8QImode:
      if (pattern0 (x3, 
E_RVVM8QImode) != 0)
        return -1;
      return 5;

    case E_RVVM4QImode:
      if (pattern0 (x3, 
E_RVVM4QImode) != 0)
        return -1;
      return 6;

    case E_RVVM2QImode:
      if (pattern0 (x3, 
E_RVVM2QImode) != 0)
        return -1;
      return 7;

    case E_RVVM1QImode:
      if (pattern0 (x3, 
E_RVVM1QImode) != 0)
        return -1;
      return 8;

    case E_RVVM8HImode:
      if (pattern0 (x3, 
E_RVVM8HImode) != 0)
        return -1;
      return 9;

    case E_RVVM4HImode:
      if (pattern0 (x3, 
E_RVVM4HImode) != 0)
        return -1;
      return 10;

    case E_RVVM2HImode:
      if (pattern0 (x3, 
E_RVVM2HImode) != 0)
        return -1;
      return 11;

    case E_RVVM1HImode:
      if (pattern0 (x3, 
E_RVVM1HImode) != 0)
        return -1;
      return 12;

    case E_RVVM8SImode:
      if (pattern0 (x3, 
E_RVVM8SImode) != 0)
        return -1;
      return 13;

    case E_RVVM4SImode:
      if (pattern0 (x3, 
E_RVVM4SImode) != 0)
        return -1;
      return 14;

    case E_RVVM2SImode:
      if (pattern0 (x3, 
E_RVVM2SImode) != 0)
        return -1;
      return 15;

    case E_RVVM1SImode:
      if (pattern0 (x3, 
E_RVVM1SImode) != 0)
        return -1;
      return 16;

    case E_RVVM8DImode:
      if (pattern0 (x3, 
E_RVVM8DImode) != 0)
        return -1;
      return 17;

    case E_RVVM4DImode:
      if (pattern0 (x3, 
E_RVVM4DImode) != 0)
        return -1;
      return 18;

    case E_RVVM2DImode:
      if (pattern0 (x3, 
E_RVVM2DImode) != 0)
        return -1;
      return 19;

    case E_RVVM1DImode:
      if (pattern0 (x3, 
E_RVVM1DImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2QImode:
      if (pattern0 (x3, 
E_RVVMF2QImode) != 0)
        return -1;
      return 21;

    case E_RVVMF4QImode:
      if (pattern0 (x3, 
E_RVVMF4QImode) != 0)
        return -1;
      return 22;

    case E_RVVMF8QImode:
      if (pattern0 (x3, 
E_RVVMF8QImode) != 0)
        return -1;
      return 23;

    case E_RVVMF2HImode:
      if (pattern0 (x3, 
E_RVVMF2HImode) != 0)
        return -1;
      return 24;

    case E_RVVMF4HImode:
      if (pattern0 (x3, 
E_RVVMF4HImode) != 0)
        return -1;
      return 25;

    case E_RVVMF2SImode:
      if (pattern0 (x3, 
E_RVVMF2SImode) != 0)
        return -1;
      return 26;

    case E_V1QImode:
      if (pattern0 (x3, 
E_V1QImode) != 0)
        return -1;
      return 27;

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 28;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 29;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 30;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 31;

    case E_V32QImode:
      if (pattern0 (x3, 
E_V32QImode) != 0)
        return -1;
      return 32;

    case E_V64QImode:
      if (pattern0 (x3, 
E_V64QImode) != 0)
        return -1;
      return 33;

    case E_V128QImode:
      if (pattern0 (x3, 
E_V128QImode) != 0)
        return -1;
      return 34;

    case E_V256QImode:
      if (pattern0 (x3, 
E_V256QImode) != 0)
        return -1;
      return 35;

    case E_V512QImode:
      if (pattern0 (x3, 
E_V512QImode) != 0)
        return -1;
      return 36;

    case E_V1024QImode:
      if (pattern0 (x3, 
E_V1024QImode) != 0)
        return -1;
      return 37;

    case E_V2048QImode:
      if (pattern0 (x3, 
E_V2048QImode) != 0)
        return -1;
      return 38;

    case E_V4096QImode:
      if (pattern0 (x3, 
E_V4096QImode) != 0)
        return -1;
      return 39;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 40;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 41;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 42;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 43;

    case E_V16HImode:
      if (pattern0 (x3, 
E_V16HImode) != 0)
        return -1;
      return 44;

    case E_V32HImode:
      if (pattern0 (x3, 
E_V32HImode) != 0)
        return -1;
      return 45;

    case E_V64HImode:
      if (pattern0 (x3, 
E_V64HImode) != 0)
        return -1;
      return 46;

    case E_V128HImode:
      if (pattern0 (x3, 
E_V128HImode) != 0)
        return -1;
      return 47;

    case E_V256HImode:
      if (pattern0 (x3, 
E_V256HImode) != 0)
        return -1;
      return 48;

    case E_V512HImode:
      if (pattern0 (x3, 
E_V512HImode) != 0)
        return -1;
      return 49;

    case E_V1024HImode:
      if (pattern0 (x3, 
E_V1024HImode) != 0)
        return -1;
      return 50;

    case E_V2048HImode:
      if (pattern0 (x3, 
E_V2048HImode) != 0)
        return -1;
      return 51;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 52;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 53;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 54;

    case E_V8SImode:
      if (pattern0 (x3, 
E_V8SImode) != 0)
        return -1;
      return 55;

    case E_V16SImode:
      if (pattern0 (x3, 
E_V16SImode) != 0)
        return -1;
      return 56;

    case E_V32SImode:
      if (pattern0 (x3, 
E_V32SImode) != 0)
        return -1;
      return 57;

    case E_V64SImode:
      if (pattern0 (x3, 
E_V64SImode) != 0)
        return -1;
      return 58;

    case E_V128SImode:
      if (pattern0 (x3, 
E_V128SImode) != 0)
        return -1;
      return 59;

    case E_V256SImode:
      if (pattern0 (x3, 
E_V256SImode) != 0)
        return -1;
      return 60;

    case E_V512SImode:
      if (pattern0 (x3, 
E_V512SImode) != 0)
        return -1;
      return 61;

    case E_V1024SImode:
      if (pattern0 (x3, 
E_V1024SImode) != 0)
        return -1;
      return 62;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 63;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 64;

    case E_V4DImode:
      if (pattern0 (x3, 
E_V4DImode) != 0)
        return -1;
      return 65;

    case E_V8DImode:
      if (pattern0 (x3, 
E_V8DImode) != 0)
        return -1;
      return 66;

    case E_V16DImode:
      if (pattern0 (x3, 
E_V16DImode) != 0)
        return -1;
      return 67;

    case E_V32DImode:
      if (pattern0 (x3, 
E_V32DImode) != 0)
        return -1;
      return 68;

    case E_V64DImode:
      if (pattern0 (x3, 
E_V64DImode) != 0)
        return -1;
      return 69;

    case E_V128DImode:
      if (pattern0 (x3, 
E_V128DImode) != 0)
        return -1;
      return 70;

    case E_V256DImode:
      if (pattern0 (x3, 
E_V256DImode) != 0)
        return -1;
      return 71;

    case E_V512DImode:
      if (pattern0 (x3, 
E_V512DImode) != 0)
        return -1;
      return 72;

    case E_RVVM8HFmode:
      if (pattern0 (x3, 
E_RVVM8HFmode) != 0)
        return -1;
      return 73;

    case E_RVVM4HFmode:
      if (pattern0 (x3, 
E_RVVM4HFmode) != 0)
        return -1;
      return 74;

    case E_RVVM2HFmode:
      if (pattern0 (x3, 
E_RVVM2HFmode) != 0)
        return -1;
      return 75;

    case E_RVVM1HFmode:
      if (pattern0 (x3, 
E_RVVM1HFmode) != 0)
        return -1;
      return 76;

    case E_RVVMF2HFmode:
      if (pattern0 (x3, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 77;

    case E_RVVMF4HFmode:
      if (pattern0 (x3, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 78;

    case E_RVVM8SFmode:
      if (pattern0 (x3, 
E_RVVM8SFmode) != 0)
        return -1;
      return 79;

    case E_RVVM4SFmode:
      if (pattern0 (x3, 
E_RVVM4SFmode) != 0)
        return -1;
      return 80;

    case E_RVVM2SFmode:
      if (pattern0 (x3, 
E_RVVM2SFmode) != 0)
        return -1;
      return 81;

    case E_RVVM1SFmode:
      if (pattern0 (x3, 
E_RVVM1SFmode) != 0)
        return -1;
      return 82;

    case E_RVVMF2SFmode:
      if (pattern0 (x3, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 83;

    case E_RVVM8DFmode:
      if (pattern0 (x3, 
E_RVVM8DFmode) != 0)
        return -1;
      return 84;

    case E_RVVM4DFmode:
      if (pattern0 (x3, 
E_RVVM4DFmode) != 0)
        return -1;
      return 85;

    case E_RVVM2DFmode:
      if (pattern0 (x3, 
E_RVVM2DFmode) != 0)
        return -1;
      return 86;

    case E_RVVM1DFmode:
      if (pattern0 (x3, 
E_RVVM1DFmode) != 0)
        return -1;
      return 87;

    case E_V1HFmode:
      if (pattern0 (x3, 
E_V1HFmode) != 0)
        return -1;
      return 88;

    case E_V2HFmode:
      if (pattern0 (x3, 
E_V2HFmode) != 0)
        return -1;
      return 89;

    case E_V4HFmode:
      if (pattern0 (x3, 
E_V4HFmode) != 0)
        return -1;
      return 90;

    case E_V8HFmode:
      if (pattern0 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 91;

    case E_V16HFmode:
      if (pattern0 (x3, 
E_V16HFmode) != 0)
        return -1;
      return 92;

    case E_V32HFmode:
      if (pattern0 (x3, 
E_V32HFmode) != 0)
        return -1;
      return 93;

    case E_V64HFmode:
      if (pattern0 (x3, 
E_V64HFmode) != 0)
        return -1;
      return 94;

    case E_V128HFmode:
      if (pattern0 (x3, 
E_V128HFmode) != 0)
        return -1;
      return 95;

    case E_V256HFmode:
      if (pattern0 (x3, 
E_V256HFmode) != 0)
        return -1;
      return 96;

    case E_V512HFmode:
      if (pattern0 (x3, 
E_V512HFmode) != 0)
        return -1;
      return 97;

    case E_V1024HFmode:
      if (pattern0 (x3, 
E_V1024HFmode) != 0)
        return -1;
      return 98;

    case E_V2048HFmode:
      if (pattern0 (x3, 
E_V2048HFmode) != 0)
        return -1;
      return 99;

    case E_V1SFmode:
      if (pattern0 (x3, 
E_V1SFmode) != 0)
        return -1;
      return 100;

    case E_V2SFmode:
      if (pattern0 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 101;

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 102;

    case E_V8SFmode:
      if (pattern0 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 103;

    case E_V16SFmode:
      if (pattern0 (x3, 
E_V16SFmode) != 0)
        return -1;
      return 104;

    case E_V32SFmode:
      if (pattern0 (x3, 
E_V32SFmode) != 0)
        return -1;
      return 105;

    case E_V64SFmode:
      if (pattern0 (x3, 
E_V64SFmode) != 0)
        return -1;
      return 106;

    case E_V128SFmode:
      if (pattern0 (x3, 
E_V128SFmode) != 0)
        return -1;
      return 107;

    case E_V256SFmode:
      if (pattern0 (x3, 
E_V256SFmode) != 0)
        return -1;
      return 108;

    case E_V512SFmode:
      if (pattern0 (x3, 
E_V512SFmode) != 0)
        return -1;
      return 109;

    case E_V1024SFmode:
      if (pattern0 (x3, 
E_V1024SFmode) != 0)
        return -1;
      return 110;

    case E_V1DFmode:
      if (pattern0 (x3, 
E_V1DFmode) != 0)
        return -1;
      return 111;

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 112;

    case E_V4DFmode:
      if (pattern0 (x3, 
E_V4DFmode) != 0)
        return -1;
      return 113;

    case E_V8DFmode:
      if (pattern0 (x3, 
E_V8DFmode) != 0)
        return -1;
      return 114;

    case E_V16DFmode:
      if (pattern0 (x3, 
E_V16DFmode) != 0)
        return -1;
      return 115;

    case E_V32DFmode:
      if (pattern0 (x3, 
E_V32DFmode) != 0)
        return -1;
      return 116;

    case E_V64DFmode:
      if (pattern0 (x3, 
E_V64DFmode) != 0)
        return -1;
      return 117;

    case E_V128DFmode:
      if (pattern0 (x3, 
E_V128DFmode) != 0)
        return -1;
      return 118;

    case E_V256DFmode:
      if (pattern0 (x3, 
E_V256DFmode) != 0)
        return -1;
      return 119;

    case E_V512DFmode:
      if (pattern0 (x3, 
E_V512DFmode) != 0)
        return -1;
      return 120;

    default:
      return -1;
    }
}

int
pattern120 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 2)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XEXP (x6, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i5)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != SET)
    return -1;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != MEM)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != PLUS)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 2)
    return -1;
  x16 = XEXP (x14, 1);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XEXP (x12, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != i4)
    return -1;
  x18 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x18) != SET)
    return -1;
  x19 = XEXP (x18, 1);
  if (GET_CODE (x19) != MEM)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_CODE (x20) != PLUS)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 2)
    return -1;
  x22 = XEXP (x20, 1);
  if (GET_CODE (x22) != CONST_INT)
    return -1;
  x23 = XEXP (x18, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != i3)
    return -1;
  x24 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x24) != SET)
    return -1;
  x25 = XEXP (x24, 1);
  if (GET_CODE (x25) != MEM)
    return -1;
  x26 = XEXP (x25, 0);
  if (GET_CODE (x26) != PLUS)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 2)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_CODE (x28) != CONST_INT)
    return -1;
  x29 = XEXP (x24, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != i2)
    return -1;
  x30 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x30) != SET)
    return -1;
  x31 = XEXP (x30, 1);
  if (GET_CODE (x31) != MEM)
    return -1;
  x32 = XEXP (x31, 0);
  if (GET_CODE (x32) != PLUS)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 2)
    return -1;
  x34 = XEXP (x32, 1);
  if (GET_CODE (x34) != CONST_INT)
    return -1;
  x35 = XEXP (x30, 0);
  if (GET_CODE (x35) != REG
      || REGNO (x35) != i1)
    return -1;
  return 0;
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern53 (x1); /* [-1, 1] */

    case E_RVVM4HFmode:
      res = pattern54 (x1);
      if (res >= 0)
        return res + 2; /* [2, 4] */
      return -1;

    case E_RVVM2HFmode:
      res = pattern55 (x1);
      if (res >= 0)
        return res + 5; /* [5, 7] */
      return -1;

    case E_RVVM1HFmode:
      res = pattern56 (x1);
      if (res >= 0)
        return res + 8; /* [8, 10] */
      return -1;

    case E_RVVMF2HFmode:
      res = pattern57 (x1);
      if (res >= 0)
        return res + 11; /* [11, 13] */
      return -1;

    case E_RVVMF4HFmode:
      res = pattern58 (x1);
      if (res >= 0)
        return res + 14; /* [14, 16] */
      return -1;

    case E_RVVM8SFmode:
      res = pattern59 (x1);
      if (res >= 0)
        return res + 17; /* [17, 18] */
      return -1;

    case E_RVVM4SFmode:
      res = pattern60 (x1);
      if (res >= 0)
        return res + 19; /* [19, 21] */
      return -1;

    case E_RVVM2SFmode:
      res = pattern61 (x1);
      if (res >= 0)
        return res + 22; /* [22, 24] */
      return -1;

    case E_RVVM1SFmode:
      res = pattern62 (x1);
      if (res >= 0)
        return res + 25; /* [25, 27] */
      return -1;

    case E_RVVMF2SFmode:
      res = pattern63 (x1);
      if (res >= 0)
        return res + 28; /* [28, 30] */
      return -1;

    case E_RVVM8DFmode:
      res = pattern64 (x1);
      if (res >= 0)
        return res + 31; /* [31, 32] */
      return -1;

    case E_RVVM4DFmode:
      res = pattern65 (x1);
      if (res >= 0)
        return res + 33; /* [33, 34] */
      return -1;

    case E_RVVM2DFmode:
      res = pattern66 (x1);
      if (res >= 0)
        return res + 35; /* [35, 36] */
      return -1;

    case E_RVVM1DFmode:
      res = pattern67 (x1);
      if (res >= 0)
        return res + 37; /* [37, 38] */
      return -1;

    case E_V1HFmode:
      res = pattern68 (x1);
      if (res >= 0)
        return res + 39; /* [39, 41] */
      return -1;

    case E_V2HFmode:
      res = pattern69 (x1);
      if (res >= 0)
        return res + 42; /* [42, 44] */
      return -1;

    case E_V4HFmode:
      res = pattern70 (x1);
      if (res >= 0)
        return res + 45; /* [45, 47] */
      return -1;

    case E_V8HFmode:
      res = pattern71 (x1);
      if (res >= 0)
        return res + 48; /* [48, 50] */
      return -1;

    case E_V16HFmode:
      res = pattern72 (x1);
      if (res >= 0)
        return res + 51; /* [51, 53] */
      return -1;

    case E_V32HFmode:
      res = pattern73 (x1);
      if (res >= 0)
        return res + 54; /* [54, 56] */
      return -1;

    case E_V64HFmode:
      res = pattern74 (x1);
      if (res >= 0)
        return res + 57; /* [57, 59] */
      return -1;

    case E_V128HFmode:
      res = pattern75 (x1);
      if (res >= 0)
        return res + 60; /* [60, 62] */
      return -1;

    case E_V256HFmode:
      res = pattern76 (x1);
      if (res >= 0)
        return res + 63; /* [63, 65] */
      return -1;

    case E_V512HFmode:
      res = pattern77 (x1);
      if (res >= 0)
        return res + 66; /* [66, 68] */
      return -1;

    case E_V1024HFmode:
      res = pattern78 (x1);
      if (res >= 0)
        return res + 69; /* [69, 71] */
      return -1;

    case E_V2048HFmode:
      res = pattern79 (x1);
      if (res >= 0)
        return res + 72; /* [72, 73] */
      return -1;

    case E_V1SFmode:
      res = pattern80 (x1);
      if (res >= 0)
        return res + 74; /* [74, 76] */
      return -1;

    case E_V2SFmode:
      res = pattern81 (x1);
      if (res >= 0)
        return res + 77; /* [77, 79] */
      return -1;

    case E_V4SFmode:
      res = pattern82 (x1);
      if (res >= 0)
        return res + 80; /* [80, 82] */
      return -1;

    case E_V8SFmode:
      res = pattern83 (x1);
      if (res >= 0)
        return res + 83; /* [83, 85] */
      return -1;

    case E_V16SFmode:
      res = pattern84 (x1);
      if (res >= 0)
        return res + 86; /* [86, 88] */
      return -1;

    case E_V32SFmode:
      res = pattern85 (x1);
      if (res >= 0)
        return res + 89; /* [89, 91] */
      return -1;

    case E_V64SFmode:
      res = pattern86 (x1);
      if (res >= 0)
        return res + 92; /* [92, 94] */
      return -1;

    case E_V128SFmode:
      res = pattern87 (x1);
      if (res >= 0)
        return res + 95; /* [95, 97] */
      return -1;

    case E_V256SFmode:
      res = pattern88 (x1);
      if (res >= 0)
        return res + 98; /* [98, 100] */
      return -1;

    case E_V512SFmode:
      res = pattern89 (x1);
      if (res >= 0)
        return res + 101; /* [101, 103] */
      return -1;

    case E_V1024SFmode:
      res = pattern90 (x1);
      if (res >= 0)
        return res + 104; /* [104, 105] */
      return -1;

    case E_V1DFmode:
      res = pattern91 (x1);
      if (res >= 0)
        return res + 106; /* [106, 107] */
      return -1;

    case E_V2DFmode:
      res = pattern92 (x1);
      if (res >= 0)
        return res + 108; /* [108, 109] */
      return -1;

    case E_V4DFmode:
      res = pattern93 (x1);
      if (res >= 0)
        return res + 110; /* [110, 111] */
      return -1;

    case E_V8DFmode:
      res = pattern94 (x1);
      if (res >= 0)
        return res + 112; /* [112, 113] */
      return -1;

    case E_V16DFmode:
      res = pattern95 (x1);
      if (res >= 0)
        return res + 114; /* [114, 115] */
      return -1;

    case E_V32DFmode:
      res = pattern96 (x1);
      if (res >= 0)
        return res + 116; /* [116, 117] */
      return -1;

    case E_V64DFmode:
      res = pattern97 (x1);
      if (res >= 0)
        return res + 118; /* [118, 119] */
      return -1;

    case E_V128DFmode:
      res = pattern98 (x1);
      if (res >= 0)
        return res + 120; /* [120, 121] */
      return -1;

    case E_V256DFmode:
      res = pattern99 (x1);
      if (res >= 0)
        return res + 122; /* [122, 123] */
      return -1;

    case E_V512DFmode:
      res = pattern100 (x1);
      if (res >= 0)
        return res + 124; /* [124, 125] */
      return -1;

    default:
      return -1;
    }
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MULT)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern143 (x1, 
E_RVVM8HFmode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern143 (x1, 
E_RVVM4HFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern143 (x1, 
E_RVVM2HFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern143 (x1, 
E_RVVM1HFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern143 (x1, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern143 (x1, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern143 (x1, 
E_RVVM8SFmode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern143 (x1, 
E_RVVM4SFmode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern143 (x1, 
E_RVVM2SFmode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern143 (x1, 
E_RVVM1SFmode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern143 (x1, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern143 (x1, 
E_RVVM8DFmode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern143 (x1, 
E_RVVM4DFmode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern143 (x1, 
E_RVVM2DFmode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern143 (x1, 
E_RVVM1DFmode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern143 (x1, 
E_V1HFmode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern143 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern143 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern143 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern143 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern143 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern143 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern143 (x1, 
E_V128HFmode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern143 (x1, 
E_V256HFmode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern143 (x1, 
E_V512HFmode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern143 (x1, 
E_V1024HFmode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern143 (x1, 
E_V2048HFmode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern143 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern143 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern143 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern143 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern143 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern143 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern143 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern143 (x1, 
E_V128SFmode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern143 (x1, 
E_V256SFmode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern143 (x1, 
E_V512SFmode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern143 (x1, 
E_V1024SFmode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern143 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern143 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern143 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern143 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern143 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern143 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern143 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern143 (x1, 
E_V128DFmode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern143 (x1, 
E_V256DFmode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern143 (x1, 
E_V512DFmode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      return pattern145 (x1); /* [-1, 47] */

    case REG:
    case SUBREG:
      res = pattern153 (x1);
      if (res >= 0)
        return res + 48; /* [48, 95] */
      return -1;

    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern154 (x1, 
E_RVVM4QImode, 
E_RVVM8HImode) != 0)
            return -1;
          return 96;

        case E_RVVM4HImode:
          if (pattern154 (x1, 
E_RVVM2QImode, 
E_RVVM4HImode) != 0)
            return -1;
          return 97;

        case E_RVVM2HImode:
          if (pattern154 (x1, 
E_RVVM1QImode, 
E_RVVM2HImode) != 0)
            return -1;
          return 98;

        case E_RVVM1HImode:
          if (pattern154 (x1, 
E_RVVMF2QImode, 
E_RVVM1HImode) != 0)
            return -1;
          return 99;

        case E_RVVMF2HImode:
          if (pattern154 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HImode) != 0)
            return -1;
          return 100;

        case E_RVVMF4HImode:
          if (pattern154 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HImode) != 0)
            return -1;
          return 101;

        case E_RVVM8SImode:
          if (pattern154 (x1, 
E_RVVM4HImode, 
E_RVVM8SImode) != 0)
            return -1;
          return 102;

        case E_RVVM4SImode:
          if (pattern154 (x1, 
E_RVVM2HImode, 
E_RVVM4SImode) != 0)
            return -1;
          return 103;

        case E_RVVM2SImode:
          if (pattern154 (x1, 
E_RVVM1HImode, 
E_RVVM2SImode) != 0)
            return -1;
          return 104;

        case E_RVVM1SImode:
          if (pattern154 (x1, 
E_RVVMF2HImode, 
E_RVVM1SImode) != 0)
            return -1;
          return 105;

        case E_RVVMF2SImode:
          if (pattern154 (x1, 
E_RVVMF4HImode, 
E_RVVMF2SImode) != 0)
            return -1;
          return 106;

        case E_RVVM8DImode:
          if (pattern154 (x1, 
E_RVVM4SImode, 
E_RVVM8DImode) != 0)
            return -1;
          return 107;

        case E_RVVM4DImode:
          if (pattern154 (x1, 
E_RVVM2SImode, 
E_RVVM4DImode) != 0)
            return -1;
          return 108;

        case E_RVVM2DImode:
          if (pattern154 (x1, 
E_RVVM1SImode, 
E_RVVM2DImode) != 0)
            return -1;
          return 109;

        case E_RVVM1DImode:
          if (pattern154 (x1, 
E_RVVMF2SImode, 
E_RVVM1DImode) != 0)
            return -1;
          return 110;

        case E_V1HImode:
          if (pattern154 (x1, 
E_V1QImode, 
E_V1HImode) != 0)
            return -1;
          return 111;

        case E_V2HImode:
          if (pattern154 (x1, 
E_V2QImode, 
E_V2HImode) != 0)
            return -1;
          return 112;

        case E_V4HImode:
          if (pattern154 (x1, 
E_V4QImode, 
E_V4HImode) != 0)
            return -1;
          return 113;

        case E_V8HImode:
          if (pattern154 (x1, 
E_V8QImode, 
E_V8HImode) != 0)
            return -1;
          return 114;

        case E_V16HImode:
          if (pattern154 (x1, 
E_V16QImode, 
E_V16HImode) != 0)
            return -1;
          return 115;

        case E_V32HImode:
          if (pattern154 (x1, 
E_V32QImode, 
E_V32HImode) != 0)
            return -1;
          return 116;

        case E_V64HImode:
          if (pattern154 (x1, 
E_V64QImode, 
E_V64HImode) != 0)
            return -1;
          return 117;

        case E_V128HImode:
          if (pattern154 (x1, 
E_V128QImode, 
E_V128HImode) != 0)
            return -1;
          return 118;

        case E_V256HImode:
          if (pattern154 (x1, 
E_V256QImode, 
E_V256HImode) != 0)
            return -1;
          return 119;

        case E_V512HImode:
          if (pattern154 (x1, 
E_V512QImode, 
E_V512HImode) != 0)
            return -1;
          return 120;

        case E_V1024HImode:
          if (pattern154 (x1, 
E_V1024QImode, 
E_V1024HImode) != 0)
            return -1;
          return 121;

        case E_V2048HImode:
          if (pattern154 (x1, 
E_V2048QImode, 
E_V2048HImode) != 0)
            return -1;
          return 122;

        case E_V1SImode:
          if (pattern154 (x1, 
E_V1HImode, 
E_V1SImode) != 0)
            return -1;
          return 123;

        case E_V2SImode:
          if (pattern154 (x1, 
E_V2HImode, 
E_V2SImode) != 0)
            return -1;
          return 124;

        case E_V4SImode:
          if (pattern154 (x1, 
E_V4HImode, 
E_V4SImode) != 0)
            return -1;
          return 125;

        case E_V8SImode:
          if (pattern154 (x1, 
E_V8HImode, 
E_V8SImode) != 0)
            return -1;
          return 126;

        case E_V16SImode:
          if (pattern154 (x1, 
E_V16HImode, 
E_V16SImode) != 0)
            return -1;
          return 127;

        case E_V32SImode:
          if (pattern154 (x1, 
E_V32HImode, 
E_V32SImode) != 0)
            return -1;
          return 128;

        case E_V64SImode:
          if (pattern154 (x1, 
E_V64HImode, 
E_V64SImode) != 0)
            return -1;
          return 129;

        case E_V128SImode:
          if (pattern154 (x1, 
E_V128HImode, 
E_V128SImode) != 0)
            return -1;
          return 130;

        case E_V256SImode:
          if (pattern154 (x1, 
E_V256HImode, 
E_V256SImode) != 0)
            return -1;
          return 131;

        case E_V512SImode:
          if (pattern154 (x1, 
E_V512HImode, 
E_V512SImode) != 0)
            return -1;
          return 132;

        case E_V1024SImode:
          if (pattern154 (x1, 
E_V1024HImode, 
E_V1024SImode) != 0)
            return -1;
          return 133;

        case E_V1DImode:
          if (pattern154 (x1, 
E_V1SImode, 
E_V1DImode) != 0)
            return -1;
          return 134;

        case E_V2DImode:
          if (pattern154 (x1, 
E_V2SImode, 
E_V2DImode) != 0)
            return -1;
          return 135;

        case E_V4DImode:
          if (pattern154 (x1, 
E_V4SImode, 
E_V4DImode) != 0)
            return -1;
          return 136;

        case E_V8DImode:
          if (pattern154 (x1, 
E_V8SImode, 
E_V8DImode) != 0)
            return -1;
          return 137;

        case E_V16DImode:
          if (pattern154 (x1, 
E_V16SImode, 
E_V16DImode) != 0)
            return -1;
          return 138;

        case E_V32DImode:
          if (pattern154 (x1, 
E_V32SImode, 
E_V32DImode) != 0)
            return -1;
          return 139;

        case E_V64DImode:
          if (pattern154 (x1, 
E_V64SImode, 
E_V64DImode) != 0)
            return -1;
          return 140;

        case E_V128DImode:
          if (pattern154 (x1, 
E_V128SImode, 
E_V128DImode) != 0)
            return -1;
          return 141;

        case E_V256DImode:
          if (pattern154 (x1, 
E_V256SImode, 
E_V256DImode) != 0)
            return -1;
          return 142;

        case E_V512DImode:
          if (pattern154 (x1, 
E_V512SImode, 
E_V512DImode) != 0)
            return -1;
          return 143;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern188 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1QImode:
      if (!register_operand (operands[3], E_RVVM1QImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      if (!register_operand (operands[3], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM4SImode:
      if (!register_operand (operands[3], E_RVVM4SImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      if (!register_operand (operands[3], E_RVVM8DImode))
        return -1;
      return 3;

    case E_RVVM2BFmode:
      if (!register_operand (operands[3], E_RVVM2BFmode))
        return -1;
      return 4;

    case E_RVVM2HFmode:
      if (!register_operand (operands[3], E_RVVM2HFmode))
        return -1;
      return 5;

    case E_RVVM4SFmode:
      if (!register_operand (operands[3], E_RVVM4SFmode))
        return -1;
      return 6;

    case E_RVVM8DFmode:
      if (!register_operand (operands[3], E_RVVM8DFmode))
        return -1;
      return 7;

    case E_RVVM1x2QImode:
      if (!register_operand (operands[3], E_RVVM1x2QImode))
        return -1;
      return 8;

    case E_RVVM1x3QImode:
      if (!register_operand (operands[3], E_RVVM1x3QImode))
        return -1;
      return 9;

    case E_RVVM1x4QImode:
      if (!register_operand (operands[3], E_RVVM1x4QImode))
        return -1;
      return 10;

    case E_RVVM1x5QImode:
      if (!register_operand (operands[3], E_RVVM1x5QImode))
        return -1;
      return 11;

    case E_RVVM1x6QImode:
      if (!register_operand (operands[3], E_RVVM1x6QImode))
        return -1;
      return 12;

    case E_RVVM1x7QImode:
      if (!register_operand (operands[3], E_RVVM1x7QImode))
        return -1;
      return 13;

    case E_RVVM1x8QImode:
      if (!register_operand (operands[3], E_RVVM1x8QImode))
        return -1;
      return 14;

    case E_RVVM2x2HImode:
      if (!register_operand (operands[3], E_RVVM2x2HImode))
        return -1;
      return 15;

    case E_RVVM2x3HImode:
      if (!register_operand (operands[3], E_RVVM2x3HImode))
        return -1;
      return 16;

    case E_RVVM2x4HImode:
      if (!register_operand (operands[3], E_RVVM2x4HImode))
        return -1;
      return 17;

    case E_RVVM4x2SImode:
      if (!register_operand (operands[3], E_RVVM4x2SImode))
        return -1;
      return 18;

    case E_RVVM2x2BFmode:
      if (!register_operand (operands[3], E_RVVM2x2BFmode))
        return -1;
      return 19;

    case E_RVVM2x3BFmode:
      if (!register_operand (operands[3], E_RVVM2x3BFmode))
        return -1;
      return 20;

    case E_RVVM2x4BFmode:
      if (!register_operand (operands[3], E_RVVM2x4BFmode))
        return -1;
      return 21;

    case E_RVVM2x2HFmode:
      if (!register_operand (operands[3], E_RVVM2x2HFmode))
        return -1;
      return 22;

    case E_RVVM2x3HFmode:
      if (!register_operand (operands[3], E_RVVM2x3HFmode))
        return -1;
      return 23;

    case E_RVVM2x4HFmode:
      if (!register_operand (operands[3], E_RVVM2x4HFmode))
        return -1;
      return 24;

    case E_RVVM4x2SFmode:
      if (!register_operand (operands[3], E_RVVM4x2SFmode))
        return -1;
      return 25;

    default:
      return -1;
    }
}

int
pattern194 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_merge_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !reg_or_0_operand (operands[4], i3))
    return -1;
  return 0;
}

int
pattern197 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 7
      || XINT (x3, 1) != 93)
    return -1;
  x4 = XVECEXP (x3, 0, 5);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x3, 0, 6);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XVECEXP (x3, 0, 0);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 1);
  operands[5] = x8;
  if (!vector_length_operand (operands[5], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x3, 0, 2);
  operands[6] = x9;
  if (!const_int_operand (operands[6], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 3);
  operands[7] = x10;
  if (!const_int_operand (operands[7], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x3, 0, 4);
  operands[8] = x11;
  if (!const_int_operand (operands[8], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x2, 0, 1);
  operands[2] = x12;
  x13 = XVECEXP (x2, 0, 2);
  operands[3] = x13;
  x14 = XVECEXP (x2, 0, 3);
  operands[4] = x14;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern196 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern196 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern196 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern196 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern196 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern196 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern196 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode, 
E_SFmode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern196 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern196 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern196 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern196 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern196 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode, 
E_DFmode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern196 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode, 
E_DFmode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern196 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode, 
E_DFmode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern196 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode, 
E_DFmode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern196 (x2, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern196 (x2, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern196 (x2, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern196 (x2, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern196 (x2, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern196 (x2, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern196 (x2, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern196 (x2, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern196 (x2, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern196 (x2, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern196 (x2, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern196 (x2, 
E_V2048HFmode, 
E_V2048BImode, 
E_HFmode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern196 (x2, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern196 (x2, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern196 (x2, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern196 (x2, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern196 (x2, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern196 (x2, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern196 (x2, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern196 (x2, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern196 (x2, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern196 (x2, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern196 (x2, 
E_V1024SFmode, 
E_V1024BImode, 
E_SFmode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern196 (x2, 
E_V1DFmode, 
E_V1BImode, 
E_DFmode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern196 (x2, 
E_V2DFmode, 
E_V2BImode, 
E_DFmode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern196 (x2, 
E_V4DFmode, 
E_V4BImode, 
E_DFmode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern196 (x2, 
E_V8DFmode, 
E_V8BImode, 
E_DFmode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern196 (x2, 
E_V16DFmode, 
E_V16BImode, 
E_DFmode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern196 (x2, 
E_V32DFmode, 
E_V32BImode, 
E_DFmode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern196 (x2, 
E_V64DFmode, 
E_V64BImode, 
E_DFmode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern196 (x2, 
E_V128DFmode, 
E_V128BImode, 
E_DFmode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern196 (x2, 
E_V256DFmode, 
E_V256BImode, 
E_DFmode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern196 (x2, 
E_V512DFmode, 
E_V512BImode, 
E_DFmode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern219 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[3] = x3;
      x4 = XEXP (x1, 2);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          return pattern206 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

        case E_RVVM4QImode:
          if (pattern206 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2QImode:
          if (pattern206 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1QImode:
          if (pattern206 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 3;

        case E_RVVM8HImode:
          if (pattern206 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 4;

        case E_RVVM4HImode:
          if (pattern206 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 5;

        case E_RVVM2HImode:
          if (pattern206 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 6;

        case E_RVVM1HImode:
          if (pattern206 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 7;

        case E_RVVM8SImode:
          if (pattern206 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 8;

        case E_RVVM4SImode:
          if (pattern206 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 9;

        case E_RVVM2SImode:
          if (pattern206 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 10;

        case E_RVVM1SImode:
          if (pattern206 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 11;

        case E_RVVM8DImode:
          if (pattern206 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 12;

        case E_RVVM4DImode:
          if (pattern206 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 13;

        case E_RVVM2DImode:
          if (pattern206 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 14;

        case E_RVVM1DImode:
          if (pattern206 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 15;

        case E_RVVMF2QImode:
          if (pattern206 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 16;

        case E_RVVMF4QImode:
          if (pattern206 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 17;

        case E_RVVMF8QImode:
          if (pattern206 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 18;

        case E_RVVMF2HImode:
          if (pattern206 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 19;

        case E_RVVMF4HImode:
          if (pattern206 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 20;

        case E_RVVMF2SImode:
          if (pattern206 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 21;

        case E_RVVM8BFmode:
          if (pattern206 (x1, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 22;

        case E_RVVM4BFmode:
          if (pattern206 (x1, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 23;

        case E_RVVM2BFmode:
          if (pattern206 (x1, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 24;

        case E_RVVM1BFmode:
          if (pattern206 (x1, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 25;

        case E_RVVMF2BFmode:
          if (pattern206 (x1, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 26;

        case E_RVVMF4BFmode:
          if (pattern206 (x1, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 27;

        case E_RVVM8HFmode:
          if (pattern206 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 28;

        case E_RVVM4HFmode:
          if (pattern206 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 29;

        case E_RVVM2HFmode:
          if (pattern206 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 30;

        case E_RVVM1HFmode:
          if (pattern206 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 31;

        case E_RVVMF2HFmode:
          if (pattern206 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 32;

        case E_RVVMF4HFmode:
          if (pattern206 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 33;

        case E_RVVM8SFmode:
          if (pattern206 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 34;

        case E_RVVM4SFmode:
          if (pattern206 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 35;

        case E_RVVM2SFmode:
          if (pattern206 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 36;

        case E_RVVM1SFmode:
          if (pattern206 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 37;

        case E_RVVMF2SFmode:
          if (pattern206 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 38;

        case E_RVVM8DFmode:
          if (pattern206 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 39;

        case E_RVVM4DFmode:
          if (pattern206 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 40;

        case E_RVVM2DFmode:
          if (pattern206 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 41;

        case E_RVVM1DFmode:
          if (pattern206 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 42;

        case E_V1QImode:
          if (pattern206 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
            return -1;
          return 43;

        case E_V2QImode:
          if (pattern206 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
            return -1;
          return 44;

        case E_V4QImode:
          if (pattern206 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
            return -1;
          return 45;

        case E_V8QImode:
          if (pattern206 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
            return -1;
          return 46;

        case E_V16QImode:
          if (pattern206 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 47;

        case E_V32QImode:
          if (pattern206 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
            return -1;
          return 48;

        case E_V64QImode:
          if (pattern206 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
            return -1;
          return 49;

        case E_V128QImode:
          if (pattern206 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
            return -1;
          return 50;

        case E_V256QImode:
          if (pattern206 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
            return -1;
          return 51;

        case E_V512QImode:
          if (pattern206 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
            return -1;
          return 52;

        case E_V1024QImode:
          if (pattern206 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
            return -1;
          return 53;

        case E_V2048QImode:
          if (pattern206 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
            return -1;
          return 54;

        case E_V4096QImode:
          if (pattern206 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
            return -1;
          return 55;

        case E_V1HImode:
          if (pattern206 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
            return -1;
          return 56;

        case E_V2HImode:
          if (pattern206 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
            return -1;
          return 57;

        case E_V4HImode:
          if (pattern206 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
            return -1;
          return 58;

        case E_V8HImode:
          if (pattern206 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 59;

        case E_V16HImode:
          if (pattern206 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
            return -1;
          return 60;

        case E_V32HImode:
          if (pattern206 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
            return -1;
          return 61;

        case E_V64HImode:
          if (pattern206 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
            return -1;
          return 62;

        case E_V128HImode:
          if (pattern206 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
            return -1;
          return 63;

        case E_V256HImode:
          if (pattern206 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
            return -1;
          return 64;

        case E_V512HImode:
          if (pattern206 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
            return -1;
          return 65;

        case E_V1024HImode:
          if (pattern206 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
            return -1;
          return 66;

        case E_V2048HImode:
          if (pattern206 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
            return -1;
          return 67;

        case E_V1SImode:
          if (pattern206 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
            return -1;
          return 68;

        case E_V2SImode:
          if (pattern206 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
            return -1;
          return 69;

        case E_V4SImode:
          if (pattern206 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 70;

        case E_V8SImode:
          if (pattern206 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
            return -1;
          return 71;

        case E_V16SImode:
          if (pattern206 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
            return -1;
          return 72;

        case E_V32SImode:
          if (pattern206 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
            return -1;
          return 73;

        case E_V64SImode:
          if (pattern206 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
            return -1;
          return 74;

        case E_V128SImode:
          if (pattern206 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
            return -1;
          return 75;

        case E_V256SImode:
          if (pattern206 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
            return -1;
          return 76;

        case E_V512SImode:
          if (pattern206 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
            return -1;
          return 77;

        case E_V1024SImode:
          if (pattern206 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
            return -1;
          return 78;

        case E_V1DImode:
          if (pattern206 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
            return -1;
          return 79;

        case E_V2DImode:
          if (pattern206 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
            return -1;
          return 80;

        case E_V4DImode:
          if (pattern206 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
            return -1;
          return 81;

        case E_V8DImode:
          if (pattern206 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
            return -1;
          return 82;

        case E_V16DImode:
          if (pattern206 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
            return -1;
          return 83;

        case E_V32DImode:
          if (pattern206 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
            return -1;
          return 84;

        case E_V64DImode:
          if (pattern206 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
            return -1;
          return 85;

        case E_V128DImode:
          if (pattern206 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
            return -1;
          return 86;

        case E_V256DImode:
          if (pattern206 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
            return -1;
          return 87;

        case E_V512DImode:
          if (pattern206 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
            return -1;
          return 88;

        case E_V1HFmode:
          if (pattern206 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 89;

        case E_V2HFmode:
          if (pattern206 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 90;

        case E_V4HFmode:
          if (pattern206 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 91;

        case E_V8HFmode:
          if (pattern206 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 92;

        case E_V16HFmode:
          if (pattern206 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 93;

        case E_V32HFmode:
          if (pattern206 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 94;

        case E_V64HFmode:
          if (pattern206 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 95;

        case E_V128HFmode:
          if (pattern206 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 96;

        case E_V256HFmode:
          if (pattern206 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 97;

        case E_V512HFmode:
          if (pattern206 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 98;

        case E_V1024HFmode:
          if (pattern206 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 99;

        case E_V2048HFmode:
          if (pattern206 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 100;

        case E_V1SFmode:
          if (pattern206 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 101;

        case E_V2SFmode:
          if (pattern206 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 102;

        case E_V4SFmode:
          if (pattern206 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 103;

        case E_V8SFmode:
          if (pattern206 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 104;

        case E_V16SFmode:
          if (pattern206 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 105;

        case E_V32SFmode:
          if (pattern206 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 106;

        case E_V64SFmode:
          if (pattern206 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 107;

        case E_V128SFmode:
          if (pattern206 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 108;

        case E_V256SFmode:
          if (pattern206 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 109;

        case E_V512SFmode:
          if (pattern206 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 110;

        case E_V1024SFmode:
          if (pattern206 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 111;

        case E_V1DFmode:
          if (pattern206 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 112;

        case E_V2DFmode:
          if (pattern206 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 113;

        case E_V4DFmode:
          if (pattern206 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 114;

        case E_V8DFmode:
          if (pattern206 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 115;

        case E_V16DFmode:
          if (pattern206 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 116;

        case E_V32DFmode:
          if (pattern206 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 117;

        case E_V64DFmode:
          if (pattern206 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 118;

        case E_V128DFmode:
          if (pattern206 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 119;

        case E_V256DFmode:
          if (pattern206 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 120;

        case E_V512DFmode:
          if (pattern206 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 121;

        default:
          return -1;
        }

    case ABS:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern207 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 122;

        case E_RVVM4HFmode:
          if (pattern207 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 123;

        case E_RVVM2HFmode:
          if (pattern207 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 124;

        case E_RVVM1HFmode:
          if (pattern207 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 125;

        case E_RVVMF2HFmode:
          if (pattern207 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 126;

        case E_RVVMF4HFmode:
          if (pattern207 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 127;

        case E_RVVM8SFmode:
          if (pattern207 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 128;

        case E_RVVM4SFmode:
          if (pattern207 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 129;

        case E_RVVM2SFmode:
          if (pattern207 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 130;

        case E_RVVM1SFmode:
          if (pattern207 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 131;

        case E_RVVMF2SFmode:
          if (pattern207 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 132;

        case E_RVVM8DFmode:
          if (pattern207 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 133;

        case E_RVVM4DFmode:
          if (pattern207 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 134;

        case E_RVVM2DFmode:
          if (pattern207 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 135;

        case E_RVVM1DFmode:
          if (pattern207 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 136;

        case E_V1HFmode:
          if (pattern207 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 137;

        case E_V2HFmode:
          if (pattern207 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 138;

        case E_V4HFmode:
          if (pattern207 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 139;

        case E_V8HFmode:
          if (pattern207 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 140;

        case E_V16HFmode:
          if (pattern207 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 141;

        case E_V32HFmode:
          if (pattern207 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 142;

        case E_V64HFmode:
          if (pattern207 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 143;

        case E_V128HFmode:
          if (pattern207 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 144;

        case E_V256HFmode:
          if (pattern207 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 145;

        case E_V512HFmode:
          if (pattern207 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 146;

        case E_V1024HFmode:
          if (pattern207 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 147;

        case E_V2048HFmode:
          if (pattern207 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 148;

        case E_V1SFmode:
          if (pattern207 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 149;

        case E_V2SFmode:
          if (pattern207 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 150;

        case E_V4SFmode:
          if (pattern207 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 151;

        case E_V8SFmode:
          if (pattern207 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 152;

        case E_V16SFmode:
          if (pattern207 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 153;

        case E_V32SFmode:
          if (pattern207 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 154;

        case E_V64SFmode:
          if (pattern207 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 155;

        case E_V128SFmode:
          if (pattern207 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 156;

        case E_V256SFmode:
          if (pattern207 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 157;

        case E_V512SFmode:
          if (pattern207 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 158;

        case E_V1024SFmode:
          if (pattern207 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 159;

        case E_V1DFmode:
          if (pattern207 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 160;

        case E_V2DFmode:
          if (pattern207 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 161;

        case E_V4DFmode:
          if (pattern207 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 162;

        case E_V8DFmode:
          if (pattern207 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 163;

        case E_V16DFmode:
          if (pattern207 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 164;

        case E_V32DFmode:
          if (pattern207 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 165;

        case E_V64DFmode:
          if (pattern207 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 166;

        case E_V128DFmode:
          if (pattern207 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 167;

        case E_V256DFmode:
          if (pattern207 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 168;

        case E_V512DFmode:
          if (pattern207 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 169;

        default:
          return -1;
        }

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern208 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 170;

        case E_RVVM4HFmode:
          if (pattern208 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 171;

        case E_RVVM2HFmode:
          if (pattern208 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 172;

        case E_RVVM1HFmode:
          if (pattern208 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 173;

        case E_RVVMF2HFmode:
          if (pattern208 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 174;

        case E_RVVMF4HFmode:
          if (pattern208 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 175;

        case E_RVVM8SFmode:
          if (pattern208 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 176;

        case E_RVVM4SFmode:
          if (pattern208 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 177;

        case E_RVVM2SFmode:
          if (pattern208 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 178;

        case E_RVVM1SFmode:
          if (pattern208 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 179;

        case E_RVVMF2SFmode:
          if (pattern208 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 180;

        case E_RVVM8DFmode:
          if (pattern208 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 181;

        case E_RVVM4DFmode:
          if (pattern208 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 182;

        case E_RVVM2DFmode:
          if (pattern208 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 183;

        case E_RVVM1DFmode:
          if (pattern208 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 184;

        case E_V1HFmode:
          if (pattern208 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 185;

        case E_V2HFmode:
          if (pattern208 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 186;

        case E_V4HFmode:
          if (pattern208 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 187;

        case E_V8HFmode:
          if (pattern208 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 188;

        case E_V16HFmode:
          if (pattern208 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 189;

        case E_V32HFmode:
          if (pattern208 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 190;

        case E_V64HFmode:
          if (pattern208 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 191;

        case E_V128HFmode:
          if (pattern208 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 192;

        case E_V256HFmode:
          if (pattern208 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 193;

        case E_V512HFmode:
          if (pattern208 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 194;

        case E_V1024HFmode:
          if (pattern208 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 195;

        case E_V2048HFmode:
          if (pattern208 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 196;

        case E_V1SFmode:
          if (pattern208 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 197;

        case E_V2SFmode:
          if (pattern208 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 198;

        case E_V4SFmode:
          if (pattern208 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 199;

        case E_V8SFmode:
          if (pattern208 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 200;

        case E_V16SFmode:
          if (pattern208 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 201;

        case E_V32SFmode:
          if (pattern208 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 202;

        case E_V64SFmode:
          if (pattern208 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 203;

        case E_V128SFmode:
          if (pattern208 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 204;

        case E_V256SFmode:
          if (pattern208 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 205;

        case E_V512SFmode:
          if (pattern208 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 206;

        case E_V1024SFmode:
          if (pattern208 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 207;

        case E_V1DFmode:
          if (pattern208 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 208;

        case E_V2DFmode:
          if (pattern208 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 209;

        case E_V4DFmode:
          if (pattern208 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 210;

        case E_V8DFmode:
          if (pattern208 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 211;

        case E_V16DFmode:
          if (pattern208 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 212;

        case E_V32DFmode:
          if (pattern208 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 213;

        case E_V64DFmode:
          if (pattern208 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 214;

        case E_V128DFmode:
          if (pattern208 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 215;

        case E_V256DFmode:
          if (pattern208 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 216;

        case E_V512DFmode:
          if (pattern208 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 217;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      res = pattern210 (x1);
      if (res >= 0)
        return res + 218; /* [218, 309] */
      return -1;

    case ZERO_EXTEND:
      res = pattern210 (x1);
      if (res >= 0)
        return res + 310; /* [310, 401] */
      return -1;

    case TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          x4 = XEXP (x1, 2);
          operands[3] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM4QImode:
              if (pattern209 (x1, 
E_RVVM4QImode, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
                return -1;
              return 402;

            case E_RVVM2QImode:
              if (pattern209 (x1, 
E_RVVM2QImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 403;

            case E_RVVM1QImode:
              if (pattern209 (x1, 
E_RVVM1QImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 404;

            case E_RVVMF2QImode:
              if (pattern209 (x1, 
E_RVVMF2QImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 405;

            case E_RVVMF4QImode:
              if (pattern209 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 406;

            case E_RVVMF8QImode:
              if (pattern209 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 407;

            case E_RVVM4HImode:
              if (pattern209 (x1, 
E_RVVM4HImode, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 408;

            case E_RVVM2HImode:
              if (pattern209 (x1, 
E_RVVM2HImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 409;

            case E_RVVM1HImode:
              if (pattern209 (x1, 
E_RVVM1HImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 410;

            case E_RVVMF2HImode:
              if (pattern209 (x1, 
E_RVVMF2HImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 411;

            case E_RVVMF4HImode:
              if (pattern209 (x1, 
E_RVVMF4HImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 412;

            case E_RVVM4SImode:
              if (pattern209 (x1, 
E_RVVM4SImode, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 413;

            case E_RVVM2SImode:
              if (pattern209 (x1, 
E_RVVM2SImode, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 414;

            case E_RVVM1SImode:
              if (pattern209 (x1, 
E_RVVM1SImode, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 415;

            case E_RVVMF2SImode:
              if (pattern209 (x1, 
E_RVVMF2SImode, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 416;

            case E_V1QImode:
              if (pattern209 (x1, 
E_V1QImode, 
E_V1HImode, 
E_V1BImode) != 0)
                return -1;
              return 417;

            case E_V2QImode:
              if (pattern209 (x1, 
E_V2QImode, 
E_V2HImode, 
E_V2BImode) != 0)
                return -1;
              return 418;

            case E_V4QImode:
              if (pattern209 (x1, 
E_V4QImode, 
E_V4HImode, 
E_V4BImode) != 0)
                return -1;
              return 419;

            case E_V8QImode:
              if (pattern209 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V8BImode) != 0)
                return -1;
              return 420;

            case E_V16QImode:
              if (pattern209 (x1, 
E_V16QImode, 
E_V16HImode, 
E_V16BImode) != 0)
                return -1;
              return 421;

            case E_V32QImode:
              if (pattern209 (x1, 
E_V32QImode, 
E_V32HImode, 
E_V32BImode) != 0)
                return -1;
              return 422;

            case E_V64QImode:
              if (pattern209 (x1, 
E_V64QImode, 
E_V64HImode, 
E_V64BImode) != 0)
                return -1;
              return 423;

            case E_V128QImode:
              if (pattern209 (x1, 
E_V128QImode, 
E_V128HImode, 
E_V128BImode) != 0)
                return -1;
              return 424;

            case E_V256QImode:
              if (pattern209 (x1, 
E_V256QImode, 
E_V256HImode, 
E_V256BImode) != 0)
                return -1;
              return 425;

            case E_V512QImode:
              if (pattern209 (x1, 
E_V512QImode, 
E_V512HImode, 
E_V512BImode) != 0)
                return -1;
              return 426;

            case E_V1024QImode:
              if (pattern209 (x1, 
E_V1024QImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
                return -1;
              return 427;

            case E_V2048QImode:
              if (pattern209 (x1, 
E_V2048QImode, 
E_V2048HImode, 
E_V2048BImode) != 0)
                return -1;
              return 428;

            case E_V1HImode:
              if (pattern209 (x1, 
E_V1HImode, 
E_V1SImode, 
E_V1BImode) != 0)
                return -1;
              return 429;

            case E_V2HImode:
              if (pattern209 (x1, 
E_V2HImode, 
E_V2SImode, 
E_V2BImode) != 0)
                return -1;
              return 430;

            case E_V4HImode:
              if (pattern209 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V4BImode) != 0)
                return -1;
              return 431;

            case E_V8HImode:
              if (pattern209 (x1, 
E_V8HImode, 
E_V8SImode, 
E_V8BImode) != 0)
                return -1;
              return 432;

            case E_V16HImode:
              if (pattern209 (x1, 
E_V16HImode, 
E_V16SImode, 
E_V16BImode) != 0)
                return -1;
              return 433;

            case E_V32HImode:
              if (pattern209 (x1, 
E_V32HImode, 
E_V32SImode, 
E_V32BImode) != 0)
                return -1;
              return 434;

            case E_V64HImode:
              if (pattern209 (x1, 
E_V64HImode, 
E_V64SImode, 
E_V64BImode) != 0)
                return -1;
              return 435;

            case E_V128HImode:
              if (pattern209 (x1, 
E_V128HImode, 
E_V128SImode, 
E_V128BImode) != 0)
                return -1;
              return 436;

            case E_V256HImode:
              if (pattern209 (x1, 
E_V256HImode, 
E_V256SImode, 
E_V256BImode) != 0)
                return -1;
              return 437;

            case E_V512HImode:
              if (pattern209 (x1, 
E_V512HImode, 
E_V512SImode, 
E_V512BImode) != 0)
                return -1;
              return 438;

            case E_V1024HImode:
              if (pattern209 (x1, 
E_V1024HImode, 
E_V1024SImode, 
E_V1024BImode) != 0)
                return -1;
              return 439;

            case E_V1SImode:
              if (pattern209 (x1, 
E_V1SImode, 
E_V1DImode, 
E_V1BImode) != 0)
                return -1;
              return 440;

            case E_V2SImode:
              if (pattern209 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V2BImode) != 0)
                return -1;
              return 441;

            case E_V4SImode:
              if (pattern209 (x1, 
E_V4SImode, 
E_V4DImode, 
E_V4BImode) != 0)
                return -1;
              return 442;

            case E_V8SImode:
              if (pattern209 (x1, 
E_V8SImode, 
E_V8DImode, 
E_V8BImode) != 0)
                return -1;
              return 443;

            case E_V16SImode:
              if (pattern209 (x1, 
E_V16SImode, 
E_V16DImode, 
E_V16BImode) != 0)
                return -1;
              return 444;

            case E_V32SImode:
              if (pattern209 (x1, 
E_V32SImode, 
E_V32DImode, 
E_V32BImode) != 0)
                return -1;
              return 445;

            case E_V64SImode:
              if (pattern209 (x1, 
E_V64SImode, 
E_V64DImode, 
E_V64BImode) != 0)
                return -1;
              return 446;

            case E_V128SImode:
              if (pattern209 (x1, 
E_V128SImode, 
E_V128DImode, 
E_V128BImode) != 0)
                return -1;
              return 447;

            case E_V256SImode:
              if (pattern209 (x1, 
E_V256SImode, 
E_V256DImode, 
E_V256BImode) != 0)
                return -1;
              return 448;

            case E_V512SImode:
              if (pattern209 (x1, 
E_V512SImode, 
E_V512DImode, 
E_V512BImode) != 0)
                return -1;
              return 449;

            default:
              return -1;
            }

        case ASHIFTRT:
          res = pattern214 (x1);
          if (res >= 0)
            return res + 450; /* [450, 593] */
          return -1;

        case LSHIFTRT:
          res = pattern214 (x1);
          if (res >= 0)
            return res + 594; /* [594, 737] */
          return -1;

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SFmode:
          if (pattern209 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 738;

        case E_RVVM4SFmode:
          if (pattern209 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 739;

        case E_RVVM2SFmode:
          if (pattern209 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 740;

        case E_RVVM1SFmode:
          if (pattern209 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 741;

        case E_RVVMF2SFmode:
          if (pattern209 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 742;

        case E_RVVM8DFmode:
          if (pattern209 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 743;

        case E_RVVM4DFmode:
          if (pattern209 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 744;

        case E_RVVM2DFmode:
          if (pattern209 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 745;

        case E_RVVM1DFmode:
          if (pattern209 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 746;

        case E_V1SFmode:
          if (pattern209 (x1, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 747;

        case E_V2SFmode:
          if (pattern209 (x1, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 748;

        case E_V4SFmode:
          if (pattern209 (x1, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 749;

        case E_V8SFmode:
          if (pattern209 (x1, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 750;

        case E_V16SFmode:
          if (pattern209 (x1, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 751;

        case E_V32SFmode:
          if (pattern209 (x1, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 752;

        case E_V64SFmode:
          if (pattern209 (x1, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 753;

        case E_V128SFmode:
          if (pattern209 (x1, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 754;

        case E_V256SFmode:
          if (pattern209 (x1, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 755;

        case E_V512SFmode:
          if (pattern209 (x1, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 756;

        case E_V1024SFmode:
          if (pattern209 (x1, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 757;

        case E_V1DFmode:
          if (pattern209 (x1, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 758;

        case E_V2DFmode:
          if (pattern209 (x1, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 759;

        case E_V4DFmode:
          if (pattern209 (x1, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 760;

        case E_V8DFmode:
          if (pattern209 (x1, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 761;

        case E_V16DFmode:
          if (pattern209 (x1, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 762;

        case E_V32DFmode:
          if (pattern209 (x1, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 763;

        case E_V64DFmode:
          if (pattern209 (x1, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 764;

        case E_V128DFmode:
          if (pattern209 (x1, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 765;

        case E_V256DFmode:
          if (pattern209 (x1, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 766;

        case E_V512DFmode:
          if (pattern209 (x1, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 767;

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      x5 = XEXP (x2, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4HFmode:
          if (pattern209 (x1, 
E_RVVM4HFmode, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 768;

        case E_RVVM2HFmode:
          if (pattern209 (x1, 
E_RVVM2HFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 769;

        case E_RVVM1HFmode:
          if (pattern209 (x1, 
E_RVVM1HFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 770;

        case E_RVVMF2HFmode:
          if (pattern209 (x1, 
E_RVVMF2HFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 771;

        case E_RVVMF4HFmode:
          if (pattern209 (x1, 
E_RVVMF4HFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 772;

        case E_RVVM4SFmode:
          if (pattern209 (x1, 
E_RVVM4SFmode, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 773;

        case E_RVVM2SFmode:
          if (pattern209 (x1, 
E_RVVM2SFmode, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 774;

        case E_RVVM1SFmode:
          if (pattern209 (x1, 
E_RVVM1SFmode, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 775;

        case E_RVVMF2SFmode:
          if (pattern209 (x1, 
E_RVVMF2SFmode, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 776;

        case E_V1HFmode:
          if (pattern209 (x1, 
E_V1HFmode, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 777;

        case E_V2HFmode:
          if (pattern209 (x1, 
E_V2HFmode, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 778;

        case E_V4HFmode:
          if (pattern209 (x1, 
E_V4HFmode, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 779;

        case E_V8HFmode:
          if (pattern209 (x1, 
E_V8HFmode, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 780;

        case E_V16HFmode:
          if (pattern209 (x1, 
E_V16HFmode, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 781;

        case E_V32HFmode:
          if (pattern209 (x1, 
E_V32HFmode, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 782;

        case E_V64HFmode:
          if (pattern209 (x1, 
E_V64HFmode, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 783;

        case E_V128HFmode:
          if (pattern209 (x1, 
E_V128HFmode, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 784;

        case E_V256HFmode:
          if (pattern209 (x1, 
E_V256HFmode, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 785;

        case E_V512HFmode:
          if (pattern209 (x1, 
E_V512HFmode, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 786;

        case E_V1024HFmode:
          if (pattern209 (x1, 
E_V1024HFmode, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 787;

        case E_V1SFmode:
          if (pattern209 (x1, 
E_V1SFmode, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 788;

        case E_V2SFmode:
          if (pattern209 (x1, 
E_V2SFmode, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 789;

        case E_V4SFmode:
          if (pattern209 (x1, 
E_V4SFmode, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 790;

        case E_V8SFmode:
          if (pattern209 (x1, 
E_V8SFmode, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 791;

        case E_V16SFmode:
          if (pattern209 (x1, 
E_V16SFmode, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 792;

        case E_V32SFmode:
          if (pattern209 (x1, 
E_V32SFmode, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 793;

        case E_V64SFmode:
          if (pattern209 (x1, 
E_V64SFmode, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 794;

        case E_V128SFmode:
          if (pattern209 (x1, 
E_V128SFmode, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 795;

        case E_V256SFmode:
          if (pattern209 (x1, 
E_V256SFmode, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 796;

        case E_V512SFmode:
          if (pattern209 (x1, 
E_V512SFmode, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 797;

        default:
          return -1;
        }

    case FIX:
      res = pattern215 (x1);
      if (res >= 0)
        return res + 798; /* [798, 923] */
      return -1;

    case UNSIGNED_FIX:
      res = pattern215 (x1);
      if (res >= 0)
        return res + 924; /* [924, 1049] */
      return -1;

    case FLOAT:
      res = pattern216 (x1);
      if (res >= 0)
        return res + 1050; /* [1050, 1175] */
      return -1;

    case UNSIGNED_FLOAT:
      res = pattern216 (x1);
      if (res >= 0)
        return res + 1176; /* [1176, 1301] */
      return -1;

    case SMUL_HIGHPART:
      res = pattern218 (x1);
      if (res >= 0)
        return res + 1302; /* [1302, 1369] */
      return -1;

    case UMUL_HIGHPART:
      res = pattern218 (x1);
      if (res >= 0)
        return res + 1370; /* [1370, 1437] */
      return -1;

    default:
      return -1;
    }
}

int
pattern433 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern439 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != ASHIFT
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x4, 0);
  return pattern341 (x6); /* [-1, 3] */
}

int
pattern446 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8SImode:
      if (!register_operand (operands[1], E_RVVM8SImode))
        return -1;
      return 0;

    case E_RVVM4SImode:
      if (!register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 1;

    case E_RVVM2SImode:
      if (!register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 2;

    case E_RVVM1SImode:
      if (!register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 3;

    case E_RVVMF2SImode:
      if (!register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 4;

    case E_V1SImode:
      if (!register_operand (operands[1], E_V1SImode))
        return -1;
      return 5;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 6;

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 7;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 8;

    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      return 9;

    case E_V32SImode:
      if (!register_operand (operands[1], E_V32SImode))
        return -1;
      return 10;

    case E_V64SImode:
      if (!register_operand (operands[1], E_V64SImode))
        return -1;
      return 11;

    case E_V128SImode:
      if (!register_operand (operands[1], E_V128SImode))
        return -1;
      return 12;

    case E_V256SImode:
      if (!register_operand (operands[1], E_V256SImode))
        return -1;
      return 13;

    case E_V512SImode:
      if (!register_operand (operands[1], E_V512SImode))
        return -1;
      return 14;

    case E_V1024SImode:
      if (!register_operand (operands[1], E_V1024SImode))
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern456 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!autovec_length_operand (operands[4], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x3, 0, 4);
  operands[5] = x8;
  if (!const_0_operand (operands[5], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x2, 0, 1);
  operands[6] = x9;
  if (!autovec_length_operand (operands[6], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern455 (x1, 
E_SImode); /* [-1, 19] */

    case E_DImode:
      res = pattern455 (x1, 
E_DImode);
      if (res >= 0)
        return res + 20; /* [20, 39] */
      return -1;

    default:
      return -1;
    }
}

int
pattern466 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  if (!branch_on_bit_operand (operands[3], E_VOIDmode))
    return -1;
  return pattern464 (x1); /* [-1, 1] */
}

int
pattern470 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i3)
      || !vector_merge_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern474 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[5] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[6] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[7] = x6;
  x7 = XEXP (x1, 1);
  operands[3] = x7;
  x8 = XEXP (x1, 2);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern473 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern473 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern473 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern473 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern473 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern473 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern473 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern473 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern473 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern473 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern473 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern473 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern473 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern473 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern473 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern473 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern473 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern473 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern473 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern473 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern473 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern473 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_RVVM8BFmode:
      if (pattern473 (x1, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 22;

    case E_RVVM4BFmode:
      if (pattern473 (x1, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 23;

    case E_RVVM2BFmode:
      if (pattern473 (x1, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 24;

    case E_RVVM1BFmode:
      if (pattern473 (x1, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 25;

    case E_RVVMF2BFmode:
      if (pattern473 (x1, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 26;

    case E_RVVMF4BFmode:
      if (pattern473 (x1, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 27;

    case E_RVVM8HFmode:
      if (pattern473 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 28;

    case E_RVVM4HFmode:
      if (pattern473 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 29;

    case E_RVVM2HFmode:
      if (pattern473 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 30;

    case E_RVVM1HFmode:
      if (pattern473 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 31;

    case E_RVVMF2HFmode:
      if (pattern473 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 32;

    case E_RVVMF4HFmode:
      if (pattern473 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 33;

    case E_RVVM8SFmode:
      if (pattern473 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 34;

    case E_RVVM4SFmode:
      if (pattern473 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 35;

    case E_RVVM2SFmode:
      if (pattern473 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 36;

    case E_RVVM1SFmode:
      if (pattern473 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 37;

    case E_RVVMF2SFmode:
      if (pattern473 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 38;

    case E_RVVM8DFmode:
      if (pattern473 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 39;

    case E_RVVM4DFmode:
      if (pattern473 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 40;

    case E_RVVM2DFmode:
      if (pattern473 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 41;

    case E_RVVM1DFmode:
      if (pattern473 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 42;

    case E_V1QImode:
      if (pattern473 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 43;

    case E_V2QImode:
      if (pattern473 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 44;

    case E_V4QImode:
      if (pattern473 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 45;

    case E_V8QImode:
      if (pattern473 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 46;

    case E_V16QImode:
      if (pattern473 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 47;

    case E_V32QImode:
      if (pattern473 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 48;

    case E_V64QImode:
      if (pattern473 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 49;

    case E_V128QImode:
      if (pattern473 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 50;

    case E_V256QImode:
      if (pattern473 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 51;

    case E_V512QImode:
      if (pattern473 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 52;

    case E_V1024QImode:
      if (pattern473 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 53;

    case E_V2048QImode:
      if (pattern473 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 54;

    case E_V4096QImode:
      if (pattern473 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 55;

    case E_V1HImode:
      if (pattern473 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 56;

    case E_V2HImode:
      if (pattern473 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 57;

    case E_V4HImode:
      if (pattern473 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 58;

    case E_V8HImode:
      if (pattern473 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 59;

    case E_V16HImode:
      if (pattern473 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 60;

    case E_V32HImode:
      if (pattern473 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 61;

    case E_V64HImode:
      if (pattern473 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 62;

    case E_V128HImode:
      if (pattern473 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 63;

    case E_V256HImode:
      if (pattern473 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 64;

    case E_V512HImode:
      if (pattern473 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 65;

    case E_V1024HImode:
      if (pattern473 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 66;

    case E_V2048HImode:
      if (pattern473 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 67;

    case E_V1SImode:
      if (pattern473 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 68;

    case E_V2SImode:
      if (pattern473 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 69;

    case E_V4SImode:
      if (pattern473 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 70;

    case E_V8SImode:
      if (pattern473 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 71;

    case E_V16SImode:
      if (pattern473 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 72;

    case E_V32SImode:
      if (pattern473 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 73;

    case E_V64SImode:
      if (pattern473 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 74;

    case E_V128SImode:
      if (pattern473 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 75;

    case E_V256SImode:
      if (pattern473 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 76;

    case E_V512SImode:
      if (pattern473 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 77;

    case E_V1024SImode:
      if (pattern473 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 78;

    case E_V1DImode:
      if (pattern473 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 79;

    case E_V2DImode:
      if (pattern473 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 80;

    case E_V4DImode:
      if (pattern473 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 81;

    case E_V8DImode:
      if (pattern473 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 82;

    case E_V16DImode:
      if (pattern473 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 83;

    case E_V32DImode:
      if (pattern473 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 84;

    case E_V64DImode:
      if (pattern473 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 85;

    case E_V128DImode:
      if (pattern473 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 86;

    case E_V256DImode:
      if (pattern473 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 87;

    case E_V512DImode:
      if (pattern473 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 88;

    case E_V1HFmode:
      if (pattern473 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 89;

    case E_V2HFmode:
      if (pattern473 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 90;

    case E_V4HFmode:
      if (pattern473 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 91;

    case E_V8HFmode:
      if (pattern473 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 92;

    case E_V16HFmode:
      if (pattern473 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 93;

    case E_V32HFmode:
      if (pattern473 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 94;

    case E_V64HFmode:
      if (pattern473 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 95;

    case E_V128HFmode:
      if (pattern473 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 96;

    case E_V256HFmode:
      if (pattern473 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 97;

    case E_V512HFmode:
      if (pattern473 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 98;

    case E_V1024HFmode:
      if (pattern473 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 99;

    case E_V2048HFmode:
      if (pattern473 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 100;

    case E_V1SFmode:
      if (pattern473 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
        return -1;
      return 101;

    case E_V2SFmode:
      if (pattern473 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
        return -1;
      return 102;

    case E_V4SFmode:
      if (pattern473 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
        return -1;
      return 103;

    case E_V8SFmode:
      if (pattern473 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
        return -1;
      return 104;

    case E_V16SFmode:
      if (pattern473 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
        return -1;
      return 105;

    case E_V32SFmode:
      if (pattern473 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
        return -1;
      return 106;

    case E_V64SFmode:
      if (pattern473 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
        return -1;
      return 107;

    case E_V128SFmode:
      if (pattern473 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
        return -1;
      return 108;

    case E_V256SFmode:
      if (pattern473 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
        return -1;
      return 109;

    case E_V512SFmode:
      if (pattern473 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
        return -1;
      return 110;

    case E_V1024SFmode:
      if (pattern473 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
        return -1;
      return 111;

    case E_V1DFmode:
      if (pattern473 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
        return -1;
      return 112;

    case E_V2DFmode:
      if (pattern473 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
        return -1;
      return 113;

    case E_V4DFmode:
      if (pattern473 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
        return -1;
      return 114;

    case E_V8DFmode:
      if (pattern473 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
        return -1;
      return 115;

    case E_V16DFmode:
      if (pattern473 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
        return -1;
      return 116;

    case E_V32DFmode:
      if (pattern473 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
        return -1;
      return 117;

    case E_V64DFmode:
      if (pattern473 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
        return -1;
      return 118;

    case E_V128DFmode:
      if (pattern473 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
        return -1;
      return 119;

    case E_V256DFmode:
      if (pattern473 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
        return -1;
      return 120;

    case E_V512DFmode:
      if (pattern473 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
        return -1;
      return 121;

    default:
      return -1;
    }
}

int
pattern509 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ZERO_EXTEND
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!immediate_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern511 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM4QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM4QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVM4QImode))
        return -1;
      return 0;

    case E_RVVM8HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern513 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM1QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVM1QImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM4SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM4SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM8DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern516 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVMF8QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF8QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 0;

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 1;

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF2SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 2;

    case E_RVVM1DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVM1DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM1DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern519 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V4QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 0;

    case E_V4HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V4SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern522 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V32QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V32QImode))
        return -1;
      return 0;

    case E_V32HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V32HImode))
        return -1;
      return 1;

    case E_V32SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V32SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern525 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V256QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V256QImode))
        return -1;
      return 0;

    case E_V256HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V256HImode))
        return -1;
      return 1;

    case E_V256SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256SImode
          || !reg_or_0_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_V256SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern528 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V2048QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2048QImode
          || !reg_or_0_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_V2048QImode))
        return -1;
      return 0;

    case E_V2048HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2048HImode
          || !reg_or_0_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_V2048HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern532 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !reg_or_0_operand (operands[4], i3)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern534 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          return pattern531 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode); /* [-1, 0] */

        case E_RVVM4HImode:
          if (pattern531 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2HImode:
          if (pattern531 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1HImode:
          if (pattern531 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 3;

        case E_RVVMF2HImode:
          if (pattern531 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 4;

        case E_RVVMF4HImode:
          if (pattern531 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 5;

        case E_RVVM8SImode:
          if (pattern531 (x1, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 6;

        case E_RVVM4SImode:
          if (pattern531 (x1, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 7;

        case E_RVVM2SImode:
          if (pattern531 (x1, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 8;

        case E_RVVM1SImode:
          if (pattern531 (x1, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 9;

        case E_RVVMF2SImode:
          if (pattern531 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 10;

        case E_RVVM8DImode:
          if (pattern531 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 11;

        case E_RVVM4DImode:
          if (pattern531 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 12;

        case E_RVVM2DImode:
          if (pattern531 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 13;

        case E_RVVM1DImode:
          if (pattern531 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 14;

        case E_V1HImode:
          if (pattern531 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
            return -1;
          return 15;

        case E_V2HImode:
          if (pattern531 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
            return -1;
          return 16;

        case E_V4HImode:
          if (pattern531 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
            return -1;
          return 17;

        case E_V8HImode:
          if (pattern531 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
            return -1;
          return 18;

        case E_V16HImode:
          if (pattern531 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 19;

        case E_V32HImode:
          if (pattern531 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
            return -1;
          return 20;

        case E_V64HImode:
          if (pattern531 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
            return -1;
          return 21;

        case E_V128HImode:
          if (pattern531 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
            return -1;
          return 22;

        case E_V256HImode:
          if (pattern531 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
            return -1;
          return 23;

        case E_V512HImode:
          if (pattern531 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
            return -1;
          return 24;

        case E_V1024HImode:
          if (pattern531 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
            return -1;
          return 25;

        case E_V2048HImode:
          if (pattern531 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
            return -1;
          return 26;

        case E_V1SImode:
          if (pattern531 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode) != 0)
            return -1;
          return 27;

        case E_V2SImode:
          if (pattern531 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode) != 0)
            return -1;
          return 28;

        case E_V4SImode:
          if (pattern531 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode) != 0)
            return -1;
          return 29;

        case E_V8SImode:
          if (pattern531 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 30;

        case E_V16SImode:
          if (pattern531 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode) != 0)
            return -1;
          return 31;

        case E_V32SImode:
          if (pattern531 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode) != 0)
            return -1;
          return 32;

        case E_V64SImode:
          if (pattern531 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode) != 0)
            return -1;
          return 33;

        case E_V128SImode:
          if (pattern531 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode) != 0)
            return -1;
          return 34;

        case E_V256SImode:
          if (pattern531 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode) != 0)
            return -1;
          return 35;

        case E_V512SImode:
          if (pattern531 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode) != 0)
            return -1;
          return 36;

        case E_V1024SImode:
          if (pattern531 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
            return -1;
          return 37;

        case E_V1DImode:
          if (pattern531 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode) != 0)
            return -1;
          return 38;

        case E_V2DImode:
          if (pattern531 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode) != 0)
            return -1;
          return 39;

        case E_V4DImode:
          if (pattern531 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 40;

        case E_V8DImode:
          if (pattern531 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode) != 0)
            return -1;
          return 41;

        case E_V16DImode:
          if (pattern531 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode) != 0)
            return -1;
          return 42;

        case E_V32DImode:
          if (pattern531 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode) != 0)
            return -1;
          return 43;

        case E_V64DImode:
          if (pattern531 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode) != 0)
            return -1;
          return 44;

        case E_V128DImode:
          if (pattern531 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode) != 0)
            return -1;
          return 45;

        case E_V256DImode:
          if (pattern531 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode) != 0)
            return -1;
          return 46;

        case E_V512DImode:
          if (pattern531 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x4, 0);
      operands[4] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern533 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0)
            return -1;
          return 48;

        case E_RVVM4HImode:
          if (pattern533 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0)
            return -1;
          return 49;

        case E_RVVM2HImode:
          if (pattern533 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0)
            return -1;
          return 50;

        case E_RVVM1HImode:
          if (pattern533 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0)
            return -1;
          return 51;

        case E_RVVMF2HImode:
          if (pattern533 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0)
            return -1;
          return 52;

        case E_RVVMF4HImode:
          if (pattern533 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0)
            return -1;
          return 53;

        case E_RVVM8SImode:
          if (pattern533 (x1, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
            return -1;
          return 54;

        case E_RVVM4SImode:
          if (pattern533 (x1, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
            return -1;
          return 55;

        case E_RVVM2SImode:
          if (pattern533 (x1, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
            return -1;
          return 56;

        case E_RVVM1SImode:
          if (pattern533 (x1, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
            return -1;
          return 57;

        case E_RVVMF2SImode:
          if (pattern533 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
            return -1;
          return 58;

        case E_RVVM8DImode:
          if (pattern533 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
            return -1;
          return 59;

        case E_RVVM4DImode:
          if (pattern533 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
            return -1;
          return 60;

        case E_RVVM2DImode:
          if (pattern533 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
            return -1;
          return 61;

        case E_RVVM1DImode:
          if (pattern533 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
            return -1;
          return 62;

        case E_V1HImode:
          if (pattern533 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0)
            return -1;
          return 63;

        case E_V2HImode:
          if (pattern533 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0)
            return -1;
          return 64;

        case E_V4HImode:
          if (pattern533 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0)
            return -1;
          return 65;

        case E_V8HImode:
          if (pattern533 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0)
            return -1;
          return 66;

        case E_V16HImode:
          if (pattern533 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0)
            return -1;
          return 67;

        case E_V32HImode:
          if (pattern533 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0)
            return -1;
          return 68;

        case E_V64HImode:
          if (pattern533 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0)
            return -1;
          return 69;

        case E_V128HImode:
          if (pattern533 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0)
            return -1;
          return 70;

        case E_V256HImode:
          if (pattern533 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0)
            return -1;
          return 71;

        case E_V512HImode:
          if (pattern533 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0)
            return -1;
          return 72;

        case E_V1024HImode:
          if (pattern533 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0)
            return -1;
          return 73;

        case E_V2048HImode:
          if (pattern533 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0)
            return -1;
          return 74;

        case E_V1SImode:
          if (pattern533 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0)
            return -1;
          return 75;

        case E_V2SImode:
          if (pattern533 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0)
            return -1;
          return 76;

        case E_V4SImode:
          if (pattern533 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0)
            return -1;
          return 77;

        case E_V8SImode:
          if (pattern533 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0)
            return -1;
          return 78;

        case E_V16SImode:
          if (pattern533 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
            return -1;
          return 79;

        case E_V32SImode:
          if (pattern533 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
            return -1;
          return 80;

        case E_V64SImode:
          if (pattern533 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
            return -1;
          return 81;

        case E_V128SImode:
          if (pattern533 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0)
            return -1;
          return 82;

        case E_V256SImode:
          if (pattern533 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
            return -1;
          return 83;

        case E_V512SImode:
          if (pattern533 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
            return -1;
          return 84;

        case E_V1024SImode:
          if (pattern533 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0)
            return -1;
          return 85;

        case E_V1DImode:
          if (pattern533 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0)
            return -1;
          return 86;

        case E_V2DImode:
          if (pattern533 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
            return -1;
          return 87;

        case E_V4DImode:
          if (pattern533 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
            return -1;
          return 88;

        case E_V8DImode:
          if (pattern533 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0)
            return -1;
          return 89;

        case E_V16DImode:
          if (pattern533 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
            return -1;
          return 90;

        case E_V32DImode:
          if (pattern533 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0)
            return -1;
          return 91;

        case E_V64DImode:
          if (pattern533 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
            return -1;
          return 92;

        case E_V128DImode:
          if (pattern533 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
            return -1;
          return 93;

        case E_V256DImode:
          if (pattern533 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
            return -1;
          return 94;

        case E_V512DImode:
          if (pattern533 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
            return -1;
          return 95;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern566 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  return pattern534 (x1); /* [-1, 95] */
}

int
pattern568 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i4
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern571 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (!comparison_except_ge_operator (x3, i1))
    return -1;
  return 0;
}

int
pattern573 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern575 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x1, 2);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern493 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern493 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern493 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern493 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern493 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern493 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern493 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern493 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern493 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern493 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern493 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern493 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern493 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern493 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern493 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern493 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern493 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern493 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern493 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern493 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern493 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern493 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern493 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern493 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern493 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern493 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern493 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern493 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern493 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern493 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern493 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern493 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern493 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern493 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern493 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern493 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern493 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern493 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern493 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern493 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern493 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern493 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern493 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern493 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern493 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern493 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern493 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern493 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern590 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[3], i2)
      || !register_operand (operands[2], i1)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern594 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  if (!register_operand (operands[4], i2))
    return -1;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  if (!vector_neg_arith_operand (operands[5], i2))
    return -1;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern599 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern603 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern606 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern608 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!register_operand (operands[4], i1))
    return -1;
  x9 = XEXP (x1, 2);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  return 0;
}

int
pattern610 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF8BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM2HFmode:
      if (!register_operand (operands[4], E_RVVM2HFmode)
          || !register_operand (operands[5], E_RVVM2HFmode))
        return -1;
      return 0;

    case E_RVVM4SFmode:
      if (!register_operand (operands[4], E_RVVM4SFmode)
          || !register_operand (operands[5], E_RVVM4SFmode))
        return -1;
      return 1;

    case E_RVVM8DFmode:
      if (!register_operand (operands[4], E_RVVM8DFmode)
          || !register_operand (operands[5], E_RVVM8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern612 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF32BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF32BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF2HFmode:
      if (!register_operand (operands[4], E_RVVMF2HFmode)
          || !register_operand (operands[5], E_RVVMF2HFmode))
        return -1;
      return 0;

    case E_RVVM1SFmode:
      if (!register_operand (operands[4], E_RVVM1SFmode)
          || !register_operand (operands[5], E_RVVM1SFmode))
        return -1;
      return 1;

    case E_RVVM2DFmode:
      if (!register_operand (operands[4], E_RVVM2DFmode)
          || !register_operand (operands[5], E_RVVM2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern615 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V2BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V2BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V2HFmode:
      if (!register_operand (operands[4], E_V2HFmode)
          || !register_operand (operands[5], E_V2HFmode))
        return -1;
      return 0;

    case E_V2SFmode:
      if (!register_operand (operands[4], E_V2SFmode)
          || !register_operand (operands[5], E_V2SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!register_operand (operands[4], E_V2DFmode)
          || !register_operand (operands[5], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern618 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V16BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V16BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V16HFmode:
      if (!register_operand (operands[4], E_V16HFmode)
          || !register_operand (operands[5], E_V16HFmode))
        return -1;
      return 0;

    case E_V16SFmode:
      if (!register_operand (operands[4], E_V16SFmode)
          || !register_operand (operands[5], E_V16SFmode))
        return -1;
      return 1;

    case E_V16DFmode:
      if (!register_operand (operands[4], E_V16DFmode)
          || !register_operand (operands[5], E_V16DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern621 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V128BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V128BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V128HFmode:
      if (!register_operand (operands[4], E_V128HFmode)
          || !register_operand (operands[5], E_V128HFmode))
        return -1;
      return 0;

    case E_V128SFmode:
      if (!register_operand (operands[4], E_V128SFmode)
          || !register_operand (operands[5], E_V128SFmode))
        return -1;
      return 1;

    case E_V128DFmode:
      if (!register_operand (operands[4], E_V128DFmode)
          || !register_operand (operands[5], E_V128DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern625 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!register_operand (operands[4], i3))
    return -1;
  x10 = XEXP (x1, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  return 0;
}

int
pattern629 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM4QImode:
      if (!register_operand (operands[1], E_RVVM4QImode)
          || !vector_arith_operand (operands[2], E_RVVM4QImode))
        return -1;
      return 0;

    case E_RVVM8HImode:
      if (!register_operand (operands[1], E_RVVM8HImode)
          || !vector_arith_operand (operands[2], E_RVVM8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern633 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1SImode:
      if (!register_operand (operands[1], E_RVVM1SImode)
          || !vector_arith_operand (operands[2], E_RVVM1SImode))
        return -1;
      return 0;

    case E_RVVM2DImode:
      if (!register_operand (operands[1], E_RVVM2DImode)
          || !vector_arith_operand (operands[2], E_RVVM2DImode))
        return -1;
      return 1;

    case E_RVVMF4QImode:
      if (!register_operand (operands[1], E_RVVMF4QImode)
          || !vector_arith_operand (operands[2], E_RVVMF4QImode))
        return -1;
      return 2;

    case E_RVVMF2HImode:
      if (!register_operand (operands[1], E_RVVMF2HImode)
          || !vector_arith_operand (operands[2], E_RVVMF2HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern637 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM1QImode:
      if (!register_operand (operands[1], E_RVVM1QImode)
          || !register_operand (operands[2], E_RVVM1QImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      if (!register_operand (operands[1], E_RVVM2HImode)
          || !register_operand (operands[2], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM4SImode:
      if (!register_operand (operands[1], E_RVVM4SImode)
          || !register_operand (operands[2], E_RVVM4SImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      if (!register_operand (operands[1], E_RVVM8DImode)
          || !register_operand (operands[2], E_RVVM8DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern642 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i2
      || !vector_mask_operand (operands[1], i2)
      || !vector_eew16_stride_operand (operands[2], E_VOIDmode)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern645 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i3)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern652 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF64BImode
      || !vector_mask_operand (operands[1], E_RVVMF64BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF8QImode:
      if (!register_operand (operands[4], E_RVVMF8QImode))
        return -1;
      return 0;

    case E_RVVMF4HImode:
      if (!register_operand (operands[4], E_RVVMF4HImode))
        return -1;
      return 1;

    case E_RVVMF2SImode:
      if (!register_operand (operands[4], E_RVVMF2SImode))
        return -1;
      return 2;

    case E_RVVM1DImode:
      if (!register_operand (operands[4], E_RVVM1DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern659 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF4BImode
      || !vector_mask_operand (operands[1], E_RVVMF4BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM8SImode:
      if (!register_operand (operands[4], E_RVVM8SImode))
        return -1;
      return 0;

    case E_RVVM4HImode:
      if (!register_operand (operands[4], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (!register_operand (operands[4], E_RVVM2QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern663 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF64BImode
      || !vector_mask_operand (operands[1], E_RVVMF64BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVMF2SImode:
      if (!register_operand (operands[4], E_RVVMF2SImode))
        return -1;
      return 0;

    case E_RVVMF4HImode:
      if (!register_operand (operands[4], E_RVVMF4HImode))
        return -1;
      return 1;

    case E_RVVMF8QImode:
      if (!register_operand (operands[4], E_RVVMF8QImode))
        return -1;
      return 2;

    case E_RVVM1DImode:
      if (!register_operand (operands[4], E_RVVM1DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern670 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern675 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  return 0;
}

int
pattern680 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1DImode)
      || GET_MODE (x1) != E_RVVM1DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != E_RVVM1DImode
      || !register_operand (operands[4], E_RVVM1DImode)
      || !vector_merge_operand (operands[2], E_RVVM1DImode))
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[3], E_RVVM8DImode))
        return -1;
      return 0;

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[3], E_RVVM4DImode))
        return -1;
      return 1;

    case E_RVVMF32BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[3], E_RVVM2DImode))
        return -1;
      return 2;

    case E_RVVMF64BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[3], E_RVVM1DImode))
        return -1;
      return 3;

    case E_V1BImode:
      if (!vector_mask_operand (operands[1], E_V1BImode)
          || !register_operand (operands[3], E_V1DImode))
        return -1;
      return 4;

    case E_V2BImode:
      if (!vector_mask_operand (operands[1], E_V2BImode)
          || !register_operand (operands[3], E_V2DImode))
        return -1;
      return 5;

    case E_V4BImode:
      if (!vector_mask_operand (operands[1], E_V4BImode)
          || !register_operand (operands[3], E_V4DImode))
        return -1;
      return 6;

    case E_V8BImode:
      if (!vector_mask_operand (operands[1], E_V8BImode)
          || !register_operand (operands[3], E_V8DImode))
        return -1;
      return 7;

    case E_V16BImode:
      if (!vector_mask_operand (operands[1], E_V16BImode)
          || !register_operand (operands[3], E_V16DImode))
        return -1;
      return 8;

    case E_V32BImode:
      if (!vector_mask_operand (operands[1], E_V32BImode)
          || !register_operand (operands[3], E_V32DImode))
        return -1;
      return 9;

    case E_V64BImode:
      if (!vector_mask_operand (operands[1], E_V64BImode)
          || !register_operand (operands[3], E_V64DImode))
        return -1;
      return 10;

    case E_V128BImode:
      if (!vector_mask_operand (operands[1], E_V128BImode)
          || !register_operand (operands[3], E_V128DImode))
        return -1;
      return 11;

    case E_V256BImode:
      if (!vector_mask_operand (operands[1], E_V256BImode)
          || !register_operand (operands[3], E_V256DImode))
        return -1;
      return 12;

    case E_V512BImode:
      if (!vector_mask_operand (operands[1], E_V512BImode)
          || !register_operand (operands[3], E_V512DImode))
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern684 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern688 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern695 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  return 0;
}

int
pattern704 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[3], i4))
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[4], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern711 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern714 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern717 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[3], i1)
      || !vector_eew16_stride_operand (operands[4], E_VOIDmode)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern721 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern726 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2))
    return -1;
  x5 = XEXP (x3, 1);
  return pattern725 (x5, 
i1, 
i2, 
i4); /* [-1, 0] */
}

int
pattern728 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern542 (x1, 
E_RVVM8HFmode, 
E_HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern542 (x1, 
E_RVVM4HFmode, 
E_HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern542 (x1, 
E_RVVM2HFmode, 
E_HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern542 (x1, 
E_RVVM1HFmode, 
E_HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern542 (x1, 
E_RVVMF2HFmode, 
E_HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern542 (x1, 
E_RVVMF4HFmode, 
E_HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern542 (x1, 
E_RVVM8SFmode, 
E_SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern542 (x1, 
E_RVVM4SFmode, 
E_SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern542 (x1, 
E_RVVM2SFmode, 
E_SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern542 (x1, 
E_RVVM1SFmode, 
E_SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern542 (x1, 
E_RVVMF2SFmode, 
E_SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern542 (x1, 
E_RVVM8DFmode, 
E_DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern542 (x1, 
E_RVVM4DFmode, 
E_DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern542 (x1, 
E_RVVM2DFmode, 
E_DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern542 (x1, 
E_RVVM1DFmode, 
E_DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern729 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern671 (x1, 
E_RVVM8HImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x1) != E_RVVM4HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM4HImode
          || !vector_merge_operand (operands[2], E_RVVM4HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HFmode:
          if (!register_operand (operands[3], E_RVVM4HFmode))
            return -1;
          return 1;

        case E_RVVM8SFmode:
          if (!register_operand (operands[3], E_RVVM8SFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x1) != E_RVVM2HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM2HImode
          || !vector_merge_operand (operands[2], E_RVVM2HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HFmode:
          if (!register_operand (operands[3], E_RVVM2HFmode))
            return -1;
          return 3;

        case E_RVVM4SFmode:
          if (!register_operand (operands[3], E_RVVM4SFmode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x1) != E_RVVM1HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM1HImode
          || !vector_merge_operand (operands[2], E_RVVM1HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HFmode:
          if (!register_operand (operands[3], E_RVVM1HFmode))
            return -1;
          return 5;

        case E_RVVM2SFmode:
          if (!register_operand (operands[3], E_RVVM2SFmode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x1) != E_RVVMF2HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVMF2HImode
          || !vector_merge_operand (operands[2], E_RVVMF2HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HFmode:
          if (!register_operand (operands[3], E_RVVMF2HFmode))
            return -1;
          return 7;

        case E_RVVM1SFmode:
          if (!register_operand (operands[3], E_RVVM1SFmode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x1) != E_RVVMF4HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVMF4HImode
          || !vector_merge_operand (operands[2], E_RVVMF4HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF4HFmode:
          if (!register_operand (operands[3], E_RVVMF4HFmode))
            return -1;
          return 9;

        case E_RVVMF2SFmode:
          if (!register_operand (operands[3], E_RVVMF2SFmode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM8SImode
          || !vector_merge_operand (operands[2], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM8SFmode:
          if (!register_operand (operands[3], E_RVVM8SFmode))
            return -1;
          return 11;

        case E_RVVM4HFmode:
          if (!register_operand (operands[3], E_RVVM4HFmode))
            return -1;
          return 12;

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM4SImode
          || !vector_merge_operand (operands[2], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4SFmode:
          if (!register_operand (operands[3], E_RVVM4SFmode))
            return -1;
          return 13;

        case E_RVVM2HFmode:
          if (!register_operand (operands[3], E_RVVM2HFmode))
            return -1;
          return 14;

        case E_RVVM8DFmode:
          if (!register_operand (operands[3], E_RVVM8DFmode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM2SImode
          || !vector_merge_operand (operands[2], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2SFmode:
          if (!register_operand (operands[3], E_RVVM2SFmode))
            return -1;
          return 16;

        case E_RVVM1HFmode:
          if (!register_operand (operands[3], E_RVVM1HFmode))
            return -1;
          return 17;

        case E_RVVM4DFmode:
          if (!register_operand (operands[3], E_RVVM4DFmode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM1SImode
          || !vector_merge_operand (operands[2], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1SFmode:
          if (!register_operand (operands[3], E_RVVM1SFmode))
            return -1;
          return 19;

        case E_RVVMF2HFmode:
          if (!register_operand (operands[3], E_RVVMF2HFmode))
            return -1;
          return 20;

        case E_RVVM2DFmode:
          if (!register_operand (operands[3], E_RVVM2DFmode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVMF2SImode
          || !vector_merge_operand (operands[2], E_RVVMF2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2SFmode:
          if (!register_operand (operands[3], E_RVVMF2SFmode))
            return -1;
          return 22;

        case E_RVVMF4HFmode:
          if (!register_operand (operands[3], E_RVVMF4HFmode))
            return -1;
          return 23;

        case E_RVVM1DFmode:
          if (!register_operand (operands[3], E_RVVM1DFmode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM8DImode
          || !vector_merge_operand (operands[2], E_RVVM8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM8DFmode:
          if (!register_operand (operands[3], E_RVVM8DFmode))
            return -1;
          return 25;

        case E_RVVM4SFmode:
          if (!register_operand (operands[3], E_RVVM4SFmode))
            return -1;
          return 26;

        default:
          return -1;
        }

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM4DImode
          || !vector_merge_operand (operands[2], E_RVVM4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4DFmode:
          if (!register_operand (operands[3], E_RVVM4DFmode))
            return -1;
          return 27;

        case E_RVVM2SFmode:
          if (!register_operand (operands[3], E_RVVM2SFmode))
            return -1;
          return 28;

        default:
          return -1;
        }

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM2DImode
          || !vector_merge_operand (operands[2], E_RVVM2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2DFmode:
          if (!register_operand (operands[3], E_RVVM2DFmode))
            return -1;
          return 29;

        case E_RVVM1SFmode:
          if (!register_operand (operands[3], E_RVVM1SFmode))
            return -1;
          return 30;

        default:
          return -1;
        }

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_RVVM1DImode
          || !vector_merge_operand (operands[2], E_RVVM1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1DFmode:
          if (!register_operand (operands[3], E_RVVM1DFmode))
            return -1;
          return 31;

        case E_RVVMF2SFmode:
          if (!register_operand (operands[3], E_RVVMF2SFmode))
            return -1;
          return 32;

        default:
          return -1;
        }

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1HImode
          || !vector_merge_operand (operands[2], E_V1HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1HFmode:
          if (!register_operand (operands[3], E_V1HFmode))
            return -1;
          return 33;

        case E_V1SFmode:
          if (!register_operand (operands[3], E_V1SFmode))
            return -1;
          return 34;

        default:
          return -1;
        }

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2HImode
          || !vector_merge_operand (operands[2], E_V2HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2HFmode:
          if (!register_operand (operands[3], E_V2HFmode))
            return -1;
          return 35;

        case E_V2SFmode:
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          return 36;

        default:
          return -1;
        }

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4HImode
          || !vector_merge_operand (operands[2], E_V4HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HFmode:
          if (!register_operand (operands[3], E_V4HFmode))
            return -1;
          return 37;

        case E_V4SFmode:
          if (!register_operand (operands[3], E_V4SFmode))
            return -1;
          return 38;

        default:
          return -1;
        }

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V8HImode
          || !vector_merge_operand (operands[2], E_V8HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[3], E_V8HFmode))
            return -1;
          return 39;

        case E_V8SFmode:
          if (!register_operand (operands[3], E_V8SFmode))
            return -1;
          return 40;

        default:
          return -1;
        }

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V16HImode
          || !vector_merge_operand (operands[2], E_V16HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16HFmode:
          if (!register_operand (operands[3], E_V16HFmode))
            return -1;
          return 41;

        case E_V16SFmode:
          if (!register_operand (operands[3], E_V16SFmode))
            return -1;
          return 42;

        default:
          return -1;
        }

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V32HImode
          || !vector_merge_operand (operands[2], E_V32HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32HFmode:
          if (!register_operand (operands[3], E_V32HFmode))
            return -1;
          return 43;

        case E_V32SFmode:
          if (!register_operand (operands[3], E_V32SFmode))
            return -1;
          return 44;

        default:
          return -1;
        }

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x1) != E_V64HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V64HImode
          || !vector_merge_operand (operands[2], E_V64HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64HFmode:
          if (!register_operand (operands[3], E_V64HFmode))
            return -1;
          return 45;

        case E_V64SFmode:
          if (!register_operand (operands[3], E_V64SFmode))
            return -1;
          return 46;

        default:
          return -1;
        }

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x1) != E_V128HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V128HImode
          || !vector_merge_operand (operands[2], E_V128HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128HFmode:
          if (!register_operand (operands[3], E_V128HFmode))
            return -1;
          return 47;

        case E_V128SFmode:
          if (!register_operand (operands[3], E_V128SFmode))
            return -1;
          return 48;

        default:
          return -1;
        }

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x1) != E_V256HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V256HImode
          || !vector_merge_operand (operands[2], E_V256HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256HFmode:
          if (!register_operand (operands[3], E_V256HFmode))
            return -1;
          return 49;

        case E_V256SFmode:
          if (!register_operand (operands[3], E_V256SFmode))
            return -1;
          return 50;

        default:
          return -1;
        }

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x1) != E_V512HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V512HImode
          || !vector_merge_operand (operands[2], E_V512HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512HFmode:
          if (!register_operand (operands[3], E_V512HFmode))
            return -1;
          return 51;

        case E_V512SFmode:
          if (!register_operand (operands[3], E_V512SFmode))
            return -1;
          return 52;

        default:
          return -1;
        }

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x1) != E_V1024HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1024HImode
          || !vector_merge_operand (operands[2], E_V1024HImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1024HFmode:
          if (!register_operand (operands[3], E_V1024HFmode))
            return -1;
          return 53;

        case E_V1024SFmode:
          if (!register_operand (operands[3], E_V1024SFmode))
            return -1;
          return 54;

        default:
          return -1;
        }

    case E_V2048HImode:
      if (pattern671 (x1, 
E_V2048HImode, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 55;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1SImode
          || !vector_merge_operand (operands[2], E_V1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1SFmode:
          if (!register_operand (operands[3], E_V1SFmode))
            return -1;
          return 56;

        case E_V1HFmode:
          if (!register_operand (operands[3], E_V1HFmode))
            return -1;
          return 57;

        case E_V1DFmode:
          if (!register_operand (operands[3], E_V1DFmode))
            return -1;
          return 58;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2SImode
          || !vector_merge_operand (operands[2], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2SFmode:
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          return 59;

        case E_V2HFmode:
          if (!register_operand (operands[3], E_V2HFmode))
            return -1;
          return 60;

        case E_V2DFmode:
          if (!register_operand (operands[3], E_V2DFmode))
            return -1;
          return 61;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4SImode
          || !vector_merge_operand (operands[2], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[3], E_V4SFmode))
            return -1;
          return 62;

        case E_V4HFmode:
          if (!register_operand (operands[3], E_V4HFmode))
            return -1;
          return 63;

        case E_V4DFmode:
          if (!register_operand (operands[3], E_V4DFmode))
            return -1;
          return 64;

        default:
          return -1;
        }

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V8SImode
          || !vector_merge_operand (operands[2], E_V8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[3], E_V8SFmode))
            return -1;
          return 65;

        case E_V8HFmode:
          if (!register_operand (operands[3], E_V8HFmode))
            return -1;
          return 66;

        case E_V8DFmode:
          if (!register_operand (operands[3], E_V8DFmode))
            return -1;
          return 67;

        default:
          return -1;
        }

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V16SImode
          || !vector_merge_operand (operands[2], E_V16SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16SFmode:
          if (!register_operand (operands[3], E_V16SFmode))
            return -1;
          return 68;

        case E_V16HFmode:
          if (!register_operand (operands[3], E_V16HFmode))
            return -1;
          return 69;

        case E_V16DFmode:
          if (!register_operand (operands[3], E_V16DFmode))
            return -1;
          return 70;

        default:
          return -1;
        }

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V32SImode
          || !vector_merge_operand (operands[2], E_V32SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32SFmode:
          if (!register_operand (operands[3], E_V32SFmode))
            return -1;
          return 71;

        case E_V32HFmode:
          if (!register_operand (operands[3], E_V32HFmode))
            return -1;
          return 72;

        case E_V32DFmode:
          if (!register_operand (operands[3], E_V32DFmode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V64SImode
          || !vector_merge_operand (operands[2], E_V64SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64SFmode:
          if (!register_operand (operands[3], E_V64SFmode))
            return -1;
          return 74;

        case E_V64HFmode:
          if (!register_operand (operands[3], E_V64HFmode))
            return -1;
          return 75;

        case E_V64DFmode:
          if (!register_operand (operands[3], E_V64DFmode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V128SImode
          || !vector_merge_operand (operands[2], E_V128SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128SFmode:
          if (!register_operand (operands[3], E_V128SFmode))
            return -1;
          return 77;

        case E_V128HFmode:
          if (!register_operand (operands[3], E_V128HFmode))
            return -1;
          return 78;

        case E_V128DFmode:
          if (!register_operand (operands[3], E_V128DFmode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V256SImode
          || !vector_merge_operand (operands[2], E_V256SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256SFmode:
          if (!register_operand (operands[3], E_V256SFmode))
            return -1;
          return 80;

        case E_V256HFmode:
          if (!register_operand (operands[3], E_V256HFmode))
            return -1;
          return 81;

        case E_V256DFmode:
          if (!register_operand (operands[3], E_V256DFmode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V512SImode
          || !vector_merge_operand (operands[2], E_V512SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512SFmode:
          if (!register_operand (operands[3], E_V512SFmode))
            return -1;
          return 83;

        case E_V512HFmode:
          if (!register_operand (operands[3], E_V512HFmode))
            return -1;
          return 84;

        case E_V512DFmode:
          if (!register_operand (operands[3], E_V512DFmode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1024SImode
          || !vector_merge_operand (operands[2], E_V1024SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1024SFmode:
          if (!register_operand (operands[3], E_V1024SFmode))
            return -1;
          return 86;

        case E_V1024HFmode:
          if (!register_operand (operands[3], E_V1024HFmode))
            return -1;
          return 87;

        default:
          return -1;
        }

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1DImode
          || !vector_merge_operand (operands[2], E_V1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1DFmode:
          if (!register_operand (operands[3], E_V1DFmode))
            return -1;
          return 88;

        case E_V1SFmode:
          if (!register_operand (operands[3], E_V1SFmode))
            return -1;
          return 89;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2DImode
          || !vector_merge_operand (operands[2], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[3], E_V2DFmode))
            return -1;
          return 90;

        case E_V2SFmode:
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          return 91;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4DImode
          || !vector_merge_operand (operands[2], E_V4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4DFmode:
          if (!register_operand (operands[3], E_V4DFmode))
            return -1;
          return 92;

        case E_V4SFmode:
          if (!register_operand (operands[3], E_V4SFmode))
            return -1;
          return 93;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V8DImode
          || !vector_merge_operand (operands[2], E_V8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[3], E_V8DFmode))
            return -1;
          return 94;

        case E_V8SFmode:
          if (!register_operand (operands[3], E_V8SFmode))
            return -1;
          return 95;

        default:
          return -1;
        }

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V16DImode
          || !vector_merge_operand (operands[2], E_V16DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16DFmode:
          if (!register_operand (operands[3], E_V16DFmode))
            return -1;
          return 96;

        case E_V16SFmode:
          if (!register_operand (operands[3], E_V16SFmode))
            return -1;
          return 97;

        default:
          return -1;
        }

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V32DImode
          || !vector_merge_operand (operands[2], E_V32DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32DFmode:
          if (!register_operand (operands[3], E_V32DFmode))
            return -1;
          return 98;

        case E_V32SFmode:
          if (!register_operand (operands[3], E_V32SFmode))
            return -1;
          return 99;

        default:
          return -1;
        }

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V64DImode
          || !vector_merge_operand (operands[2], E_V64DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64DFmode:
          if (!register_operand (operands[3], E_V64DFmode))
            return -1;
          return 100;

        case E_V64SFmode:
          if (!register_operand (operands[3], E_V64SFmode))
            return -1;
          return 101;

        default:
          return -1;
        }

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V128DImode
          || !vector_merge_operand (operands[2], E_V128DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128DFmode:
          if (!register_operand (operands[3], E_V128DFmode))
            return -1;
          return 102;

        case E_V128SFmode:
          if (!register_operand (operands[3], E_V128SFmode))
            return -1;
          return 103;

        default:
          return -1;
        }

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V256DImode
          || !vector_merge_operand (operands[2], E_V256DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256DFmode:
          if (!register_operand (operands[3], E_V256DFmode))
            return -1;
          return 104;

        case E_V256SFmode:
          if (!register_operand (operands[3], E_V256SFmode))
            return -1;
          return 105;

        default:
          return -1;
        }

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V512DImode
          || !vector_merge_operand (operands[2], E_V512DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512DFmode:
          if (!register_operand (operands[3], E_V512DFmode))
            return -1;
          return 106;

        case E_V512SFmode:
          if (!register_operand (operands[3], E_V512SFmode))
            return -1;
          return 107;

        default:
          return -1;
        }

    case E_RVVM4QImode:
      if (pattern671 (x1, 
E_RVVM4QImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 108;

    case E_RVVM2QImode:
      if (pattern671 (x1, 
E_RVVM2QImode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 109;

    case E_RVVM1QImode:
      if (pattern671 (x1, 
E_RVVM1QImode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 110;

    case E_RVVMF2QImode:
      if (pattern671 (x1, 
E_RVVMF2QImode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 111;

    case E_RVVMF4QImode:
      if (pattern671 (x1, 
E_RVVMF4QImode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 112;

    case E_RVVMF8QImode:
      if (pattern671 (x1, 
E_RVVMF8QImode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 113;

    case E_V1QImode:
      if (pattern671 (x1, 
E_V1QImode, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 114;

    case E_V2QImode:
      if (pattern671 (x1, 
E_V2QImode, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 115;

    case E_V4QImode:
      if (pattern671 (x1, 
E_V4QImode, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 116;

    case E_V8QImode:
      if (pattern671 (x1, 
E_V8QImode, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 117;

    case E_V16QImode:
      if (pattern671 (x1, 
E_V16QImode, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 118;

    case E_V32QImode:
      if (pattern671 (x1, 
E_V32QImode, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 119;

    case E_V64QImode:
      if (pattern671 (x1, 
E_V64QImode, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 120;

    case E_V128QImode:
      if (pattern671 (x1, 
E_V128QImode, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 121;

    case E_V256QImode:
      if (pattern671 (x1, 
E_V256QImode, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 122;

    case E_V512QImode:
      if (pattern671 (x1, 
E_V512QImode, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 123;

    case E_V1024QImode:
      if (pattern671 (x1, 
E_V1024QImode, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 124;

    case E_V2048QImode:
      if (pattern671 (x1, 
E_V2048QImode, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 125;

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (XINT (x3, 1))
        {
        case 23:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2186 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 179; /* lrintsfsi2_sext */

            case 1:
              if (!(
#line 2186 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 180; /* lrintdfsi2_sext */

            case 2:
              if (!(
#line 2186 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 181; /* lrinthfsi2_sext */

            default:
              return -1;
            }

        case 17:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 203; /* lroundsfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 209; /* lrounddfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 215; /* lroundhfsi2_sext */

            default:
              return -1;
            }

        case 18:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 204; /* lfloorsfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 210; /* lfloordfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 216; /* lfloorhfsi2_sext */

            default:
              return -1;
            }

        case 19:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 205; /* lceilsfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 211; /* lceildfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 217; /* lceilhfsi2_sext */

            default:
              return -1;
            }

        case 20:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 206; /* lbtruncsfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 212; /* lbtruncdfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 218; /* lbtrunchfsi2_sext */

            default:
              return -1;
            }

        case 21:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 207; /* lroundevensfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 213; /* lroundevendfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 219; /* lroundevenhfsi2_sext */

            default:
              return -1;
            }

        case 22:
          switch (pattern400 ())
            {
            case 0:
              if (!(
#line 2235 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
                return -1;
              return 208; /* lnearbyintsfsi2_sext */

            case 1:
              if (!(
#line 2235 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                return -1;
              return 214; /* lnearbyintdfsi2_sext */

            case 2:
              if (!(
#line 2235 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                return -1;
              return 220; /* lnearbyinthfsi2_sext */

            default:
              return -1;
            }

        case 62:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 336 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
            return -1;
          return 698; /* riscv_sha256sig0_di_extended */

        case 63:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 336 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
            return -1;
          return 699; /* riscv_sha256sig1_di_extended */

        case 64:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 336 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
            return -1;
          return 700; /* riscv_sha256sum0_di_extended */

        case 65:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 336 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKNH && TARGET_64BIT))
            return -1;
          return 701; /* riscv_sha256sum1_di_extended */

        case 76:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 465 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKSH && TARGET_64BIT))
            return -1;
          return 714; /* riscv_sm3p0_di_extended */

        case 77:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 465 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKSH && TARGET_64BIT))
            return -1;
          return 715; /* riscv_sm3p1_di_extended */

        default:
          return -1;
        }

    case 3:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_0_3_operand (operands[3], E_SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 78:
          if (!
#line 510 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKSED && TARGET_64BIT))
            return -1;
          return 718; /* riscv_sm4ed_di_extended */

        case 79:
          if (!
#line 510 "../../gcc/config/riscv/crypto.md"
(TARGET_ZKSED && TARGET_64BIT))
            return -1;
          return 719; /* riscv_sm4ks_di_extended */

        default:
          return -1;
        }

    case 2:
      return recog_15 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_SImode) != 0)
        return -1;
      if ((
#line 350 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 907; /* *th_mulssi */
      if (
#line 373 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC && TARGET_64BIT))
        return 910; /* *th_mulswsi2 */
      if (!
#line 209 "../../gcc/config/riscv/corev.md"
(TARGET_XCVMAC && !TARGET_64BIT))
        return -1;
      return 33906; /* riscv_cv_mac_msu */

    case E_DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_DImode) != 0
          || !(
#line 350 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMAC) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 908; /* *th_mulsdi */

    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8QImode) != 0
          || !
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27247; /* fnmarvvm8qi4 */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4QImode) != 0
          || !
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27248; /* fnmarvvm4qi4 */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2QImode) != 0
          || !
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27249; /* fnmarvvm2qi4 */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1QImode) != 0
          || !
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27250; /* fnmarvvm1qi4 */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8HImode) != 0
          || !
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27251; /* fnmarvvm8hi4 */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4HImode) != 0
          || !
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27252; /* fnmarvvm4hi4 */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2HImode) != 0
          || !
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27253; /* fnmarvvm2hi4 */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1HImode) != 0
          || !
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27254; /* fnmarvvm1hi4 */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8SImode) != 0
          || !
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27255; /* fnmarvvm8si4 */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4SImode) != 0
          || !
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27256; /* fnmarvvm4si4 */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2SImode) != 0
          || !
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27257; /* fnmarvvm2si4 */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1SImode) != 0
          || !
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27258; /* fnmarvvm1si4 */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8DImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27259; /* fnmarvvm8di4 */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4DImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27260; /* fnmarvvm4di4 */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2DImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27261; /* fnmarvvm2di4 */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1DImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27262; /* fnmarvvm1di4 */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2QImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 27263; /* fnmarvvmf2qi4 */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF4QImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 27264; /* fnmarvvmf4qi4 */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF8QImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 27265; /* fnmarvvmf8qi4 */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2HImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 27266; /* fnmarvvmf2hi4 */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF4HImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 27267; /* fnmarvvmf4hi4 */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2SImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 27268; /* fnmarvvmf2si4 */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1QImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 27269; /* fnmav1qi4 */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2QImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 27270; /* fnmav2qi4 */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4QImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 27271; /* fnmav4qi4 */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8QImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 27272; /* fnmav8qi4 */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16QImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 27273; /* fnmav16qi4 */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32QImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 27274; /* fnmav32qi4 */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64QImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27275; /* fnmav64qi4 */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128QImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27276; /* fnmav128qi4 */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256QImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27277; /* fnmav256qi4 */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512QImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27278; /* fnmav512qi4 */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024QImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27279; /* fnmav1024qi4 */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2048QImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27280; /* fnmav2048qi4 */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4096QImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27281; /* fnmav4096qi4 */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1HImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 27282; /* fnmav1hi4 */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2HImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 27283; /* fnmav2hi4 */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4HImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 27284; /* fnmav4hi4 */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8HImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 27285; /* fnmav8hi4 */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16HImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 27286; /* fnmav16hi4 */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32HImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27287; /* fnmav32hi4 */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64HImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27288; /* fnmav64hi4 */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128HImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27289; /* fnmav128hi4 */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256HImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27290; /* fnmav256hi4 */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512HImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27291; /* fnmav512hi4 */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024HImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27292; /* fnmav1024hi4 */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2048HImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27293; /* fnmav2048hi4 */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1SImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 27294; /* fnmav1si4 */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2SImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 27295; /* fnmav2si4 */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4SImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 27296; /* fnmav4si4 */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8SImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 27297; /* fnmav8si4 */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16SImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27298; /* fnmav16si4 */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32SImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27299; /* fnmav32si4 */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64SImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27300; /* fnmav64si4 */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128SImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27301; /* fnmav128si4 */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256SImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27302; /* fnmav256si4 */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512SImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27303; /* fnmav512si4 */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024SImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27304; /* fnmav1024si4 */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1DImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27305; /* fnmav1di4 */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2DImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27306; /* fnmav2di4 */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4DImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27307; /* fnmav4di4 */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8DImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27308; /* fnmav8di4 */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16DImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27309; /* fnmav16di4 */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32DImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27310; /* fnmav32di4 */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64DImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27311; /* fnmav64di4 */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128DImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27312; /* fnmav128di4 */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256DImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27313; /* fnmav256di4 */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512DImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27314; /* fnmav512di4 */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8HFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27363; /* fnmarvvm8hf4 */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4HFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27364; /* fnmarvvm4hf4 */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2HFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27365; /* fnmarvvm2hf4 */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1HFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27366; /* fnmarvvm1hf4 */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2HFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27367; /* fnmarvvmf2hf4 */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF4HFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27368; /* fnmarvvmf4hf4 */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8SFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27369; /* fnmarvvm8sf4 */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4SFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27370; /* fnmarvvm4sf4 */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2SFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27371; /* fnmarvvm2sf4 */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1SFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27372; /* fnmarvvm1sf4 */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2SFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27373; /* fnmarvvmf2sf4 */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8DFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27374; /* fnmarvvm8df4 */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4DFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27375; /* fnmarvvm4df4 */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2DFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27376; /* fnmarvvm2df4 */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1DFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27377; /* fnmarvvm1df4 */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1HFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27378; /* fnmav1hf4 */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2HFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27379; /* fnmav2hf4 */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4HFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27380; /* fnmav4hf4 */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8HFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27381; /* fnmav8hf4 */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16HFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27382; /* fnmav16hf4 */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32HFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27383; /* fnmav32hf4 */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64HFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27384; /* fnmav64hf4 */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128HFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27385; /* fnmav128hf4 */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256HFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27386; /* fnmav256hf4 */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512HFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27387; /* fnmav512hf4 */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024HFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27388; /* fnmav1024hf4 */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2048HFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27389; /* fnmav2048hf4 */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1SFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27390; /* fnmav1sf4 */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2SFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27391; /* fnmav2sf4 */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4SFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27392; /* fnmav4sf4 */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8SFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27393; /* fnmav8sf4 */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16SFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27394; /* fnmav16sf4 */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32SFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27395; /* fnmav32sf4 */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64SFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27396; /* fnmav64sf4 */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128SFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27397; /* fnmav128sf4 */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256SFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27398; /* fnmav256sf4 */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512SFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27399; /* fnmav512sf4 */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024SFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27400; /* fnmav1024sf4 */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1DFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27401; /* fnmav1df4 */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2DFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27402; /* fnmav2df4 */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4DFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27403; /* fnmav4df4 */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8DFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27404; /* fnmav8df4 */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16DFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27405; /* fnmav16df4 */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32DFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27406; /* fnmav32df4 */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64DFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27407; /* fnmav64df4 */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128DFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27408; /* fnmav128df4 */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256DFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27409; /* fnmav256df4 */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512DFmode) != 0
          || !(
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27410; /* fnmav512df4 */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_SImode) != 0
          || !
#line 1416 "../../gcc/config/riscv/riscv.md"
(TARGET_DIV))
        return -1;
      return 36; /* *divsi3 */

    case E_DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_DImode) != 0
          || !
#line 1443 "../../gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 40; /* divdi3 */

    case E_SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_SFmode) != 0
          || !(
#line 1478 "../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && TARGET_FDIV) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
        return -1;
      return 48; /* divsf3 */

    case E_DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_DFmode) != 0
          || !(
#line 1478 "../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && TARGET_FDIV) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 49; /* divdf3 */

    case E_HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_HFmode) != 0
          || !(
#line 1478 "../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && TARGET_FDIV) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 50; /* divhf3 */

    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8QImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24551; /* divrvvm8qi3 */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4QImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24565; /* divrvvm4qi3 */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2QImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24579; /* divrvvm2qi3 */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1QImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24593; /* divrvvm1qi3 */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24607; /* divrvvm8hi3 */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24621; /* divrvvm4hi3 */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24635; /* divrvvm2hi3 */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24649; /* divrvvm1hi3 */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24663; /* divrvvm8si3 */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24677; /* divrvvm4si3 */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24691; /* divrvvm2si3 */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24705; /* divrvvm1si3 */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24719; /* divrvvm8di3 */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24733; /* divrvvm4di3 */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24747; /* divrvvm2di3 */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24761; /* divrvvm1di3 */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24775; /* divrvvmf2qi3 */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24789; /* divrvvmf4qi3 */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF8QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24803; /* divrvvmf8qi3 */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24817; /* divrvvmf2hi3 */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24831; /* divrvvmf4hi3 */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24845; /* divrvvmf2si3 */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24859; /* divv1qi3 */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24873; /* divv2qi3 */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24887; /* divv4qi3 */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24901; /* divv8qi3 */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24915; /* divv16qi3 */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24929; /* divv32qi3 */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24943; /* divv64qi3 */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24957; /* divv128qi3 */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24971; /* divv256qi3 */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24985; /* divv512qi3 */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24999; /* divv1024qi3 */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25013; /* divv2048qi3 */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4096QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25027; /* divv4096qi3 */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25041; /* divv1hi3 */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25055; /* divv2hi3 */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25069; /* divv4hi3 */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25083; /* divv8hi3 */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25097; /* divv16hi3 */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25111; /* divv32hi3 */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25125; /* divv64hi3 */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25139; /* divv128hi3 */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25153; /* divv256hi3 */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25167; /* divv512hi3 */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25181; /* divv1024hi3 */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25195; /* divv2048hi3 */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25209; /* divv1si3 */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25223; /* divv2si3 */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25237; /* divv4si3 */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25251; /* divv8si3 */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25265; /* divv16si3 */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25279; /* divv32si3 */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25293; /* divv64si3 */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25307; /* divv128si3 */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25321; /* divv256si3 */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25335; /* divv512si3 */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25349; /* divv1024si3 */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25363; /* divv1di3 */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25377; /* divv2di3 */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25391; /* divv4di3 */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25405; /* divv8di3 */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25419; /* divv16di3 */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25433; /* divv32di3 */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25447; /* divv64di3 */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25461; /* divv128di3 */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25475; /* divv256di3 */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25489; /* divv512di3 */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27510; /* divrvvm8hf3 */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27514; /* divrvvm4hf3 */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27518; /* divrvvm2hf3 */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27522; /* divrvvm1hf3 */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27526; /* divrvvmf2hf3 */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27530; /* divrvvmf4hf3 */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27534; /* divrvvm8sf3 */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27538; /* divrvvm4sf3 */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27542; /* divrvvm2sf3 */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27546; /* divrvvm1sf3 */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27550; /* divrvvmf2sf3 */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27554; /* divrvvm8df3 */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27558; /* divrvvm4df3 */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27562; /* divrvvm2df3 */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27566; /* divrvvm1df3 */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27570; /* divv1hf3 */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27574; /* divv2hf3 */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27578; /* divv4hf3 */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27582; /* divv8hf3 */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27586; /* divv16hf3 */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27590; /* divv32hf3 */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27594; /* divv64hf3 */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27598; /* divv128hf3 */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27602; /* divv256hf3 */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27606; /* divv512hf3 */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27610; /* divv1024hf3 */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27614; /* divv2048hf3 */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27618; /* divv1sf3 */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27622; /* divv2sf3 */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27626; /* divv4sf3 */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27630; /* divv8sf3 */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27634; /* divv16sf3 */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27638; /* divv32sf3 */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27642; /* divv64sf3 */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27646; /* divv128sf3 */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27650; /* divv256sf3 */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27654; /* divv512sf3 */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27658; /* divv1024sf3 */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27662; /* divv1df3 */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27666; /* divv2df3 */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27670; /* divv4df3 */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27674; /* divv8df3 */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27678; /* divv16df3 */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27682; /* divv32df3 */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27686; /* divv64df3 */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27690; /* divv128df3 */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27694; /* divv256df3 */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DFmode) != 0
          || !(
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27698; /* divv512df3 */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVMF8BImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_RVVMF8BImode
      || !register_operand (operands[3], E_RVVMF8BImode))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != E_RVVMF8BImode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x4))
    {
    case E_RVVM1QImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_RVVM1QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVM1QImode)
          || !
#line 3496 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8692; /* pred_madcrvvm1qi_scalar */

    case E_RVVM2HImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_RVVM2HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM2HImode)
          || !
#line 3496 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8698; /* pred_madcrvvm2hi_scalar */

    case E_RVVM4SImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_RVVM4SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM4SImode)
          || !
#line 3496 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8703; /* pred_madcrvvm4si_scalar */

    case E_RVVM8DImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_RVVM8DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM8DImode)
          || !(
#line 3567 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8797; /* *pred_madcrvvm8di_scalar */

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVMF4BImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_RVVMF4BImode
      || !register_operand (operands[3], E_RVVMF4BImode))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != E_RVVMF4BImode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x4))
    {
    case E_RVVM2QImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_RVVM2QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVM2QImode)
          || !
#line 3496 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8691; /* pred_madcrvvm2qi_scalar */

    case E_RVVM4HImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_RVVM4HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM4HImode)
          || !
#line 3496 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8697; /* pred_madcrvvm4hi_scalar */

    case E_RVVM8SImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_RVVM8SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM8SImode)
          || !
#line 3496 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8702; /* pred_madcrvvm8si_scalar */

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18127; /* pred_redmaxrvvm8qi */

        case 1:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18135; /* pred_redmaxrvvm4qi */

        case 2:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18143; /* pred_redmaxrvvm2qi */

        case 3:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18151; /* pred_redmaxrvvm1qi */

        case 4:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18255; /* pred_redmaxrvvmf2qi */

        case 5:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18263; /* pred_redmaxrvvmf4qi */

        case 6:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18271; /* pred_redmaxrvvmf8qi */

        case 7:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18303; /* pred_redmaxv1qi */

        case 8:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18311; /* pred_redmaxv2qi */

        case 9:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18319; /* pred_redmaxv4qi */

        case 10:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18327; /* pred_redmaxv8qi */

        case 11:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18335; /* pred_redmaxv16qi */

        case 12:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18343; /* pred_redmaxv32qi */

        case 13:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18351; /* pred_redmaxv64qi */

        case 14:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18359; /* pred_redmaxv128qi */

        case 15:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18367; /* pred_redmaxv256qi */

        case 16:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18375; /* pred_redmaxv512qi */

        case 17:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18383; /* pred_redmaxv1024qi */

        case 18:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18391; /* pred_redmaxv2048qi */

        case 19:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18399; /* pred_redmaxv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18159; /* pred_redmaxrvvm8hi */

        case 1:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18167; /* pred_redmaxrvvm4hi */

        case 2:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18175; /* pred_redmaxrvvm2hi */

        case 3:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18183; /* pred_redmaxrvvm1hi */

        case 4:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18279; /* pred_redmaxrvvmf2hi */

        case 5:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18287; /* pred_redmaxrvvmf4hi */

        case 6:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18407; /* pred_redmaxv1hi */

        case 7:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18415; /* pred_redmaxv2hi */

        case 8:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18423; /* pred_redmaxv4hi */

        case 9:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18431; /* pred_redmaxv8hi */

        case 10:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18439; /* pred_redmaxv16hi */

        case 11:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18447; /* pred_redmaxv32hi */

        case 12:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18455; /* pred_redmaxv64hi */

        case 13:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18463; /* pred_redmaxv128hi */

        case 14:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18471; /* pred_redmaxv256hi */

        case 15:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18479; /* pred_redmaxv512hi */

        case 16:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18487; /* pred_redmaxv1024hi */

        case 17:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18495; /* pred_redmaxv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18191; /* pred_redmaxrvvm8si */

        case 1:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18199; /* pred_redmaxrvvm4si */

        case 2:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18207; /* pred_redmaxrvvm2si */

        case 3:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18215; /* pred_redmaxrvvm1si */

        case 4:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18295; /* pred_redmaxrvvmf2si */

        case 5:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18503; /* pred_redmaxv1si */

        case 6:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18511; /* pred_redmaxv2si */

        case 7:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18519; /* pred_redmaxv4si */

        case 8:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18527; /* pred_redmaxv8si */

        case 9:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18535; /* pred_redmaxv16si */

        case 10:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18543; /* pred_redmaxv32si */

        case 11:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18551; /* pred_redmaxv64si */

        case 12:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18559; /* pred_redmaxv128si */

        case 13:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18567; /* pred_redmaxv256si */

        case 14:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18575; /* pred_redmaxv512si */

        case 15:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18583; /* pred_redmaxv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18223; /* pred_redmaxrvvm8di */

        case 1:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18231; /* pred_redmaxrvvm4di */

        case 2:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18239; /* pred_redmaxrvvm2di */

        case 3:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18247; /* pred_redmaxrvvm1di */

        case 4:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18591; /* pred_redmaxv1di */

        case 5:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18599; /* pred_redmaxv2di */

        case 6:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18607; /* pred_redmaxv4di */

        case 7:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18615; /* pred_redmaxv8di */

        case 8:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18623; /* pred_redmaxv16di */

        case 9:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18631; /* pred_redmaxv32di */

        case 10:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18639; /* pred_redmaxv64di */

        case 11:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18647; /* pred_redmaxv128di */

        case 12:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18655; /* pred_redmaxv256di */

        case 13:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18663; /* pred_redmaxv512di */

        default:
          return -1;
        }

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern681 (x2, 
E_RVVM1HFmode))
        {
        case 0:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19429; /* pred_redmaxrvvm8hf */

        case 1:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19431; /* pred_redmaxrvvm4hf */

        case 2:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19433; /* pred_redmaxrvvm2hf */

        case 3:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19435; /* pred_redmaxrvvm1hf */

        case 4:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19437; /* pred_redmaxrvvmf2hf */

        case 5:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19439; /* pred_redmaxrvvmf4hf */

        case 6:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 19459; /* pred_redmaxv1hf */

        case 7:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 19461; /* pred_redmaxv2hf */

        case 8:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 19463; /* pred_redmaxv4hf */

        case 9:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 19465; /* pred_redmaxv8hf */

        case 10:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 19467; /* pred_redmaxv16hf */

        case 11:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19469; /* pred_redmaxv32hf */

        case 12:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19471; /* pred_redmaxv64hf */

        case 13:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19473; /* pred_redmaxv128hf */

        case 14:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19475; /* pred_redmaxv256hf */

        case 15:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19477; /* pred_redmaxv512hf */

        case 16:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19479; /* pred_redmaxv1024hf */

        case 17:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19481; /* pred_redmaxv2048hf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern682 (x2, 
E_RVVM1SFmode))
        {
        case 0:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19441; /* pred_redmaxrvvm8sf */

        case 1:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19443; /* pred_redmaxrvvm4sf */

        case 2:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19445; /* pred_redmaxrvvm2sf */

        case 3:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19447; /* pred_redmaxrvvm1sf */

        case 4:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19449; /* pred_redmaxrvvmf2sf */

        case 5:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19483; /* pred_redmaxv1sf */

        case 6:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19485; /* pred_redmaxv2sf */

        case 7:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19487; /* pred_redmaxv4sf */

        case 8:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19489; /* pred_redmaxv8sf */

        case 9:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19491; /* pred_redmaxv16sf */

        case 10:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19493; /* pred_redmaxv32sf */

        case 11:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19495; /* pred_redmaxv64sf */

        case 12:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19497; /* pred_redmaxv128sf */

        case 13:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19499; /* pred_redmaxv256sf */

        case 14:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19501; /* pred_redmaxv512sf */

        case 15:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19503; /* pred_redmaxv1024sf */

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      switch (pattern683 (x2))
        {
        case 0:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19451; /* pred_redmaxrvvm8df */

        case 1:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19453; /* pred_redmaxrvvm4df */

        case 2:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19455; /* pred_redmaxrvvm2df */

        case 3:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19457; /* pred_redmaxrvvm1df */

        case 4:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19505; /* pred_redmaxv1df */

        case 5:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19507; /* pred_redmaxv2df */

        case 6:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19509; /* pred_redmaxv4df */

        case 7:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19511; /* pred_redmaxv8df */

        case 8:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19513; /* pred_redmaxv16df */

        case 9:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19515; /* pred_redmaxv32df */

        case 10:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19517; /* pred_redmaxv64df */

        case 11:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19519; /* pred_redmaxv128df */

        case 12:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19521; /* pred_redmaxv256df */

        case 13:
          if (!(
#line 7867 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19523; /* pred_redmaxv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18130; /* pred_redandrvvm8qi */

        case 1:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18138; /* pred_redandrvvm4qi */

        case 2:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18146; /* pred_redandrvvm2qi */

        case 3:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18154; /* pred_redandrvvm1qi */

        case 4:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18258; /* pred_redandrvvmf2qi */

        case 5:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18266; /* pred_redandrvvmf4qi */

        case 6:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18274; /* pred_redandrvvmf8qi */

        case 7:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18306; /* pred_redandv1qi */

        case 8:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18314; /* pred_redandv2qi */

        case 9:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18322; /* pred_redandv4qi */

        case 10:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18330; /* pred_redandv8qi */

        case 11:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18338; /* pred_redandv16qi */

        case 12:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18346; /* pred_redandv32qi */

        case 13:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18354; /* pred_redandv64qi */

        case 14:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18362; /* pred_redandv128qi */

        case 15:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18370; /* pred_redandv256qi */

        case 16:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18378; /* pred_redandv512qi */

        case 17:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18386; /* pred_redandv1024qi */

        case 18:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18394; /* pred_redandv2048qi */

        case 19:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18402; /* pred_redandv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18162; /* pred_redandrvvm8hi */

        case 1:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18170; /* pred_redandrvvm4hi */

        case 2:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18178; /* pred_redandrvvm2hi */

        case 3:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18186; /* pred_redandrvvm1hi */

        case 4:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18282; /* pred_redandrvvmf2hi */

        case 5:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18290; /* pred_redandrvvmf4hi */

        case 6:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18410; /* pred_redandv1hi */

        case 7:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18418; /* pred_redandv2hi */

        case 8:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18426; /* pred_redandv4hi */

        case 9:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18434; /* pred_redandv8hi */

        case 10:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18442; /* pred_redandv16hi */

        case 11:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18450; /* pred_redandv32hi */

        case 12:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18458; /* pred_redandv64hi */

        case 13:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18466; /* pred_redandv128hi */

        case 14:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18474; /* pred_redandv256hi */

        case 15:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18482; /* pred_redandv512hi */

        case 16:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18490; /* pred_redandv1024hi */

        case 17:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18498; /* pred_redandv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18194; /* pred_redandrvvm8si */

        case 1:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18202; /* pred_redandrvvm4si */

        case 2:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18210; /* pred_redandrvvm2si */

        case 3:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18218; /* pred_redandrvvm1si */

        case 4:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18298; /* pred_redandrvvmf2si */

        case 5:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18506; /* pred_redandv1si */

        case 6:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18514; /* pred_redandv2si */

        case 7:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18522; /* pred_redandv4si */

        case 8:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18530; /* pred_redandv8si */

        case 9:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18538; /* pred_redandv16si */

        case 10:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18546; /* pred_redandv32si */

        case 11:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18554; /* pred_redandv64si */

        case 12:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18562; /* pred_redandv128si */

        case 13:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18570; /* pred_redandv256si */

        case 14:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18578; /* pred_redandv512si */

        case 15:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18586; /* pred_redandv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18226; /* pred_redandrvvm8di */

        case 1:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18234; /* pred_redandrvvm4di */

        case 2:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18242; /* pred_redandrvvm2di */

        case 3:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18250; /* pred_redandrvvm1di */

        case 4:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18594; /* pred_redandv1di */

        case 5:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18602; /* pred_redandv2di */

        case 6:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18610; /* pred_redandv4di */

        case 7:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18618; /* pred_redandv8di */

        case 8:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18626; /* pred_redandv16di */

        case 9:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18634; /* pred_redandv32di */

        case 10:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18642; /* pred_redandv64di */

        case 11:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18650; /* pred_redandv128di */

        case 12:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18658; /* pred_redandv256di */

        case 13:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18666; /* pred_redandv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern681 (x2, 
E_RVVM1HFmode))
        {
        case 0:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19621; /* pred_redosumrvvm8hf */

        case 1:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19623; /* pred_redosumrvvm4hf */

        case 2:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19625; /* pred_redosumrvvm2hf */

        case 3:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19627; /* pred_redosumrvvm1hf */

        case 4:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19629; /* pred_redosumrvvmf2hf */

        case 5:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19631; /* pred_redosumrvvmf4hf */

        case 6:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 19651; /* pred_redosumv1hf */

        case 7:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 19653; /* pred_redosumv2hf */

        case 8:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 19655; /* pred_redosumv4hf */

        case 9:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 19657; /* pred_redosumv8hf */

        case 10:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 19659; /* pred_redosumv16hf */

        case 11:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19661; /* pred_redosumv32hf */

        case 12:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19663; /* pred_redosumv64hf */

        case 13:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19665; /* pred_redosumv128hf */

        case 14:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19667; /* pred_redosumv256hf */

        case 15:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19669; /* pred_redosumv512hf */

        case 16:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19671; /* pred_redosumv1024hf */

        case 17:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19673; /* pred_redosumv2048hf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern682 (x2, 
E_RVVM1SFmode))
        {
        case 0:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19633; /* pred_redosumrvvm8sf */

        case 1:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19635; /* pred_redosumrvvm4sf */

        case 2:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19637; /* pred_redosumrvvm2sf */

        case 3:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19639; /* pred_redosumrvvm1sf */

        case 4:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19641; /* pred_redosumrvvmf2sf */

        case 5:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19675; /* pred_redosumv1sf */

        case 6:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19677; /* pred_redosumv2sf */

        case 7:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19679; /* pred_redosumv4sf */

        case 8:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19681; /* pred_redosumv8sf */

        case 9:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19683; /* pred_redosumv16sf */

        case 10:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19685; /* pred_redosumv32sf */

        case 11:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19687; /* pred_redosumv64sf */

        case 12:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19689; /* pred_redosumv128sf */

        case 13:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19691; /* pred_redosumv256sf */

        case 14:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19693; /* pred_redosumv512sf */

        case 15:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19695; /* pred_redosumv1024sf */

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      switch (pattern683 (x2))
        {
        case 0:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19643; /* pred_redosumrvvm8df */

        case 1:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19645; /* pred_redosumrvvm4df */

        case 2:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19647; /* pred_redosumrvvm2df */

        case 3:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19649; /* pred_redosumrvvm1df */

        case 4:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19697; /* pred_redosumv1df */

        case 5:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19699; /* pred_redosumv2df */

        case 6:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19701; /* pred_redosumv4df */

        case 7:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19703; /* pred_redosumv8df */

        case 8:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19705; /* pred_redosumv16df */

        case 9:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19707; /* pred_redosumv32df */

        case 10:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19709; /* pred_redosumv64df */

        case 11:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19711; /* pred_redosumv128df */

        case 12:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19713; /* pred_redosumv256df */

        case 13:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19715; /* pred_redosumv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_91 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[0], E_RVVMF32BImode))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF4x2QImode:
      if (!register_operand (operands[3], E_RVVMF4x2QImode)
          || !
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21659; /* pred_strided_storervvmf4x2qi */

    case E_RVVMF4x3QImode:
      if (!register_operand (operands[3], E_RVVMF4x3QImode)
          || !
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21660; /* pred_strided_storervvmf4x3qi */

    case E_RVVMF4x4QImode:
      if (!register_operand (operands[3], E_RVVMF4x4QImode)
          || !
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21661; /* pred_strided_storervvmf4x4qi */

    case E_RVVMF4x5QImode:
      if (!register_operand (operands[3], E_RVVMF4x5QImode)
          || !
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21662; /* pred_strided_storervvmf4x5qi */

    case E_RVVMF4x6QImode:
      if (!register_operand (operands[3], E_RVVMF4x6QImode)
          || !
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21663; /* pred_strided_storervvmf4x6qi */

    case E_RVVMF4x7QImode:
      if (!register_operand (operands[3], E_RVVMF4x7QImode)
          || !
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21664; /* pred_strided_storervvmf4x7qi */

    case E_RVVMF4x8QImode:
      if (!register_operand (operands[3], E_RVVMF4x8QImode)
          || !
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21665; /* pred_strided_storervvmf4x8qi */

    case E_RVVMF2x2HImode:
      if (!register_operand (operands[3], E_RVVMF2x2HImode)
          || !
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21666; /* pred_strided_storervvmf2x2hi */

    case E_RVVMF2x3HImode:
      if (!register_operand (operands[3], E_RVVMF2x3HImode)
          || !
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21667; /* pred_strided_storervvmf2x3hi */

    case E_RVVMF2x4HImode:
      if (!register_operand (operands[3], E_RVVMF2x4HImode)
          || !
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21668; /* pred_strided_storervvmf2x4hi */

    case E_RVVMF2x5HImode:
      if (!register_operand (operands[3], E_RVVMF2x5HImode)
          || !
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21669; /* pred_strided_storervvmf2x5hi */

    case E_RVVMF2x6HImode:
      if (!register_operand (operands[3], E_RVVMF2x6HImode)
          || !
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21670; /* pred_strided_storervvmf2x6hi */

    case E_RVVMF2x7HImode:
      if (!register_operand (operands[3], E_RVVMF2x7HImode)
          || !
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21671; /* pred_strided_storervvmf2x7hi */

    case E_RVVMF2x8HImode:
      if (!register_operand (operands[3], E_RVVMF2x8HImode)
          || !
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21672; /* pred_strided_storervvmf2x8hi */

    case E_RVVM1x2SImode:
      if (!register_operand (operands[3], E_RVVM1x2SImode)
          || !
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21673; /* pred_strided_storervvm1x2si */

    case E_RVVM1x3SImode:
      if (!register_operand (operands[3], E_RVVM1x3SImode)
          || !
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21674; /* pred_strided_storervvm1x3si */

    case E_RVVM1x4SImode:
      if (!register_operand (operands[3], E_RVVM1x4SImode)
          || !
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21675; /* pred_strided_storervvm1x4si */

    case E_RVVM1x5SImode:
      if (!register_operand (operands[3], E_RVVM1x5SImode)
          || !
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21676; /* pred_strided_storervvm1x5si */

    case E_RVVM1x6SImode:
      if (!register_operand (operands[3], E_RVVM1x6SImode)
          || !
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21677; /* pred_strided_storervvm1x6si */

    case E_RVVM1x7SImode:
      if (!register_operand (operands[3], E_RVVM1x7SImode)
          || !
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21678; /* pred_strided_storervvm1x7si */

    case E_RVVM1x8SImode:
      if (!register_operand (operands[3], E_RVVM1x8SImode)
          || !
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 21679; /* pred_strided_storervvm1x8si */

    case E_RVVM2x2DImode:
      if (!register_operand (operands[3], E_RVVM2x2DImode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21680; /* pred_strided_storervvm2x2di */

    case E_RVVM2x3DImode:
      if (!register_operand (operands[3], E_RVVM2x3DImode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21681; /* pred_strided_storervvm2x3di */

    case E_RVVM2x4DImode:
      if (!register_operand (operands[3], E_RVVM2x4DImode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21682; /* pred_strided_storervvm2x4di */

    case E_RVVMF2x2BFmode:
      if (!register_operand (operands[3], E_RVVMF2x2BFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21683; /* pred_strided_storervvmf2x2bf */

    case E_RVVMF2x3BFmode:
      if (!register_operand (operands[3], E_RVVMF2x3BFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21684; /* pred_strided_storervvmf2x3bf */

    case E_RVVMF2x4BFmode:
      if (!register_operand (operands[3], E_RVVMF2x4BFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21685; /* pred_strided_storervvmf2x4bf */

    case E_RVVMF2x5BFmode:
      if (!register_operand (operands[3], E_RVVMF2x5BFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21686; /* pred_strided_storervvmf2x5bf */

    case E_RVVMF2x6BFmode:
      if (!register_operand (operands[3], E_RVVMF2x6BFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21687; /* pred_strided_storervvmf2x6bf */

    case E_RVVMF2x7BFmode:
      if (!register_operand (operands[3], E_RVVMF2x7BFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21688; /* pred_strided_storervvmf2x7bf */

    case E_RVVMF2x8BFmode:
      if (!register_operand (operands[3], E_RVVMF2x8BFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 21689; /* pred_strided_storervvmf2x8bf */

    case E_RVVMF2x2HFmode:
      if (!register_operand (operands[3], E_RVVMF2x2HFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21690; /* pred_strided_storervvmf2x2hf */

    case E_RVVMF2x3HFmode:
      if (!register_operand (operands[3], E_RVVMF2x3HFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21691; /* pred_strided_storervvmf2x3hf */

    case E_RVVMF2x4HFmode:
      if (!register_operand (operands[3], E_RVVMF2x4HFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21692; /* pred_strided_storervvmf2x4hf */

    case E_RVVMF2x5HFmode:
      if (!register_operand (operands[3], E_RVVMF2x5HFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21693; /* pred_strided_storervvmf2x5hf */

    case E_RVVMF2x6HFmode:
      if (!register_operand (operands[3], E_RVVMF2x6HFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21694; /* pred_strided_storervvmf2x6hf */

    case E_RVVMF2x7HFmode:
      if (!register_operand (operands[3], E_RVVMF2x7HFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21695; /* pred_strided_storervvmf2x7hf */

    case E_RVVMF2x8HFmode:
      if (!register_operand (operands[3], E_RVVMF2x8HFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 21696; /* pred_strided_storervvmf2x8hf */

    case E_RVVM1x2SFmode:
      if (!register_operand (operands[3], E_RVVM1x2SFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21697; /* pred_strided_storervvm1x2sf */

    case E_RVVM1x3SFmode:
      if (!register_operand (operands[3], E_RVVM1x3SFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21698; /* pred_strided_storervvm1x3sf */

    case E_RVVM1x4SFmode:
      if (!register_operand (operands[3], E_RVVM1x4SFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21699; /* pred_strided_storervvm1x4sf */

    case E_RVVM1x5SFmode:
      if (!register_operand (operands[3], E_RVVM1x5SFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21700; /* pred_strided_storervvm1x5sf */

    case E_RVVM1x6SFmode:
      if (!register_operand (operands[3], E_RVVM1x6SFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21701; /* pred_strided_storervvm1x6sf */

    case E_RVVM1x7SFmode:
      if (!register_operand (operands[3], E_RVVM1x7SFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21702; /* pred_strided_storervvm1x7sf */

    case E_RVVM1x8SFmode:
      if (!register_operand (operands[3], E_RVVM1x8SFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 21703; /* pred_strided_storervvm1x8sf */

    case E_RVVM2x2DFmode:
      if (!register_operand (operands[3], E_RVVM2x2DFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21704; /* pred_strided_storervvm2x2df */

    case E_RVVM2x3DFmode:
      if (!register_operand (operands[3], E_RVVM2x3DFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21705; /* pred_strided_storervvm2x3df */

    case E_RVVM2x4DFmode:
      if (!register_operand (operands[3], E_RVVM2x4DFmode)
          || !(
#line 8435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 21706; /* pred_strided_storervvm2x4df */

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern641 (x3, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4597; /* pred_strided_storervvm8qi */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern641 (x3, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4598; /* pred_strided_storervvm4qi */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern641 (x3, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4599; /* pred_strided_storervvm2qi */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern641 (x3, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4600; /* pred_strided_storervvm1qi */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4601; /* pred_strided_storervvm8hi */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4602; /* pred_strided_storervvm4hi */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4603; /* pred_strided_storervvm2hi */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4604; /* pred_strided_storervvm1hi */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4605; /* pred_strided_storervvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4606; /* pred_strided_storervvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4607; /* pred_strided_storervvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4608; /* pred_strided_storervvm1si */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4609; /* pred_strided_storervvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4610; /* pred_strided_storervvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4611; /* pred_strided_storervvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4612; /* pred_strided_storervvm1di */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern641 (x3, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 4613; /* pred_strided_storervvmf2qi */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern641 (x3, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 4614; /* pred_strided_storervvmf4qi */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern641 (x3, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 4615; /* pred_strided_storervvmf8qi */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 4616; /* pred_strided_storervvmf2hi */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 4617; /* pred_strided_storervvmf4hi */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 4618; /* pred_strided_storervvmf2si */

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4619; /* pred_strided_storervvm8bf */

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4620; /* pred_strided_storervvm4bf */

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4621; /* pred_strided_storervvm2bf */

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4622; /* pred_strided_storervvm1bf */

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4623; /* pred_strided_storervvmf2bf */

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4624; /* pred_strided_storervvmf4bf */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4625; /* pred_strided_storervvm8hf */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4626; /* pred_strided_storervvm4hf */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4627; /* pred_strided_storervvm2hf */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4628; /* pred_strided_storervvm1hf */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4629; /* pred_strided_storervvmf2hf */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4630; /* pred_strided_storervvmf4hf */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4631; /* pred_strided_storervvm8sf */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4632; /* pred_strided_storervvm4sf */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4633; /* pred_strided_storervvm2sf */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4634; /* pred_strided_storervvm1sf */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4635; /* pred_strided_storervvmf2sf */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4636; /* pred_strided_storervvm8df */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4637; /* pred_strided_storervvm4df */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4638; /* pred_strided_storervvm2df */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4639; /* pred_strided_storervvm1df */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern641 (x3, 
E_V1QImode, 
E_V1BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 4640; /* pred_strided_storev1qi */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern641 (x3, 
E_V2QImode, 
E_V2BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 4641; /* pred_strided_storev2qi */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern641 (x3, 
E_V4QImode, 
E_V4BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 4642; /* pred_strided_storev4qi */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern641 (x3, 
E_V8QImode, 
E_V8BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 4643; /* pred_strided_storev8qi */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern641 (x3, 
E_V16QImode, 
E_V16BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 4644; /* pred_strided_storev16qi */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern641 (x3, 
E_V32QImode, 
E_V32BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 4645; /* pred_strided_storev32qi */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern641 (x3, 
E_V64QImode, 
E_V64BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4646; /* pred_strided_storev64qi */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern641 (x3, 
E_V128QImode, 
E_V128BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4647; /* pred_strided_storev128qi */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern641 (x3, 
E_V256QImode, 
E_V256BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4648; /* pred_strided_storev256qi */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern641 (x3, 
E_V512QImode, 
E_V512BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4649; /* pred_strided_storev512qi */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern641 (x3, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4650; /* pred_strided_storev1024qi */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern641 (x3, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4651; /* pred_strided_storev2048qi */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern641 (x3, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4652; /* pred_strided_storev4096qi */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 4653; /* pred_strided_storev1hi */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 4654; /* pred_strided_storev2hi */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 4655; /* pred_strided_storev4hi */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 4656; /* pred_strided_storev8hi */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 4657; /* pred_strided_storev16hi */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4658; /* pred_strided_storev32hi */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4659; /* pred_strided_storev64hi */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4660; /* pred_strided_storev128hi */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4661; /* pred_strided_storev256hi */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4662; /* pred_strided_storev512hi */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4663; /* pred_strided_storev1024hi */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4664; /* pred_strided_storev2048hi */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_V1SImode, 
E_V1BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 4665; /* pred_strided_storev1si */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_V2SImode, 
E_V2BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 4666; /* pred_strided_storev2si */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_V4SImode, 
E_V4BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 4667; /* pred_strided_storev4si */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_V8SImode, 
E_V8BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 4668; /* pred_strided_storev8si */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_V16SImode, 
E_V16BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4669; /* pred_strided_storev16si */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_V32SImode, 
E_V32BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4670; /* pred_strided_storev32si */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_V64SImode, 
E_V64BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4671; /* pred_strided_storev64si */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_V128SImode, 
E_V128BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4672; /* pred_strided_storev128si */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_V256SImode, 
E_V256BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4673; /* pred_strided_storev256si */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_V512SImode, 
E_V512BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4674; /* pred_strided_storev512si */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4675; /* pred_strided_storev1024si */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_V1DImode, 
E_V1BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4676; /* pred_strided_storev1di */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_V2DImode, 
E_V2BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4677; /* pred_strided_storev2di */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_V4DImode, 
E_V4BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4678; /* pred_strided_storev4di */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_V8DImode, 
E_V8BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4679; /* pred_strided_storev8di */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_V16DImode, 
E_V16BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4680; /* pred_strided_storev16di */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_V32DImode, 
E_V32BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4681; /* pred_strided_storev32di */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_V64DImode, 
E_V64BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4682; /* pred_strided_storev64di */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_V128DImode, 
E_V128BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4683; /* pred_strided_storev128di */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_V256DImode, 
E_V256BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4684; /* pred_strided_storev256di */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_V512DImode, 
E_V512BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4685; /* pred_strided_storev512di */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V1HFmode, 
E_V1BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4686; /* pred_strided_storev1hf */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V2HFmode, 
E_V2BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4687; /* pred_strided_storev2hf */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V4HFmode, 
E_V4BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4688; /* pred_strided_storev4hf */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V8HFmode, 
E_V8BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4689; /* pred_strided_storev8hf */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V16HFmode, 
E_V16BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4690; /* pred_strided_storev16hf */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V32HFmode, 
E_V32BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4691; /* pred_strided_storev32hf */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V64HFmode, 
E_V64BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4692; /* pred_strided_storev64hf */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V128HFmode, 
E_V128BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4693; /* pred_strided_storev128hf */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V256HFmode, 
E_V256BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4694; /* pred_strided_storev256hf */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V512HFmode, 
E_V512BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4695; /* pred_strided_storev512hf */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4696; /* pred_strided_storev1024hf */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern642 (x3, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4697; /* pred_strided_storev2048hf */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_V1SFmode, 
E_V1BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4698; /* pred_strided_storev1sf */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_V2SFmode, 
E_V2BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4699; /* pred_strided_storev2sf */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_V4SFmode, 
E_V4BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4700; /* pred_strided_storev4sf */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_V8SFmode, 
E_V8BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4701; /* pred_strided_storev8sf */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_V16SFmode, 
E_V16BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4702; /* pred_strided_storev16sf */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_V32SFmode, 
E_V32BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4703; /* pred_strided_storev32sf */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_V64SFmode, 
E_V64BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4704; /* pred_strided_storev64sf */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_V128SFmode, 
E_V128BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4705; /* pred_strided_storev128sf */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_V256SFmode, 
E_V256BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4706; /* pred_strided_storev256sf */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_V512SFmode, 
E_V512BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 293 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4707; /* pred_strided_storev512sf */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern643 (x3, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4708; /* pred_strided_storev1024sf */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_V1DFmode, 
E_V1BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4709; /* pred_strided_storev1df */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_V2DFmode, 
E_V2BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4710; /* pred_strided_storev2df */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_V4DFmode, 
E_V4BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4711; /* pred_strided_storev4df */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_V8DFmode, 
E_V8BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4712; /* pred_strided_storev8df */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_V16DFmode, 
E_V16BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4713; /* pred_strided_storev16df */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_V32DFmode, 
E_V32BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4714; /* pred_strided_storev32df */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_V64DFmode, 
E_V64BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4715; /* pred_strided_storev64df */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_V128DFmode, 
E_V128BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4716; /* pred_strided_storev128df */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_V256DFmode, 
E_V256BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4717; /* pred_strided_storev256df */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (pattern644 (x3, 
E_V512DFmode, 
E_V512BImode) != 0
          || !(
#line 2411 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4718; /* pred_strided_storev512df */

    default:
      return -1;
    }
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern293 (x2, 
E_SImode) == 0
              && (
#line 232 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return 515; /* and_notsi3 */
          break;

        case E_DImode:
          if (pattern293 (x2, 
E_DImode) == 0
              && (
#line 232 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 517; /* and_notdi3 */
          break;

        case E_RVVMF64BImode:
          if (pattern294 (x2, 
E_RVVMF64BImode) == 0
              && (
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 32105; /* *andnotrvvmf64bi */
          break;

        case E_RVVMF32BImode:
          if (pattern294 (x2, 
E_RVVMF32BImode) == 0
              && 
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return 32107; /* *andnotrvvmf32bi */
          break;

        case E_RVVMF16BImode:
          if (pattern294 (x2, 
E_RVVMF16BImode) == 0
              && 
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return 32109; /* *andnotrvvmf16bi */
          break;

        case E_RVVMF8BImode:
          if (pattern294 (x2, 
E_RVVMF8BImode) == 0
              && 
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return 32111; /* *andnotrvvmf8bi */
          break;

        case E_RVVMF4BImode:
          if (pattern294 (x2, 
E_RVVMF4BImode) == 0
              && 
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return 32113; /* *andnotrvvmf4bi */
          break;

        case E_RVVMF2BImode:
          if (pattern294 (x2, 
E_RVVMF2BImode) == 0
              && 
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return 32115; /* *andnotrvvmf2bi */
          break;

        case E_RVVM1BImode:
          if (pattern294 (x2, 
E_RVVM1BImode) == 0
              && 
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return 32117; /* *andnotrvvm1bi */
          break;

        case E_V1BImode:
          if (pattern294 (x2, 
E_V1BImode) == 0
              && (
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return 32119; /* *andnotv1bi */
          break;

        case E_V2BImode:
          if (pattern294 (x2, 
E_V2BImode) == 0
              && (
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return 32121; /* *andnotv2bi */
          break;

        case E_V4BImode:
          if (pattern294 (x2, 
E_V4BImode) == 0
              && (
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return 32123; /* *andnotv4bi */
          break;

        case E_V8BImode:
          if (pattern294 (x2, 
E_V8BImode) == 0
              && (
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return 32125; /* *andnotv8bi */
          break;

        case E_V16BImode:
          if (pattern294 (x2, 
E_V16BImode) == 0
              && (
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return 32127; /* *andnotv16bi */
          break;

        case E_V32BImode:
          if (pattern294 (x2, 
E_V32BImode) == 0
              && (
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return 32129; /* *andnotv32bi */
          break;

        case E_V64BImode:
          if (pattern294 (x2, 
E_V64BImode) == 0
              && (
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return 32131; /* *andnotv64bi */
          break;

        case E_V128BImode:
          if (pattern294 (x2, 
E_V128BImode) == 0
              && (
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return 32133; /* *andnotv128bi */
          break;

        case E_V256BImode:
          if (pattern294 (x2, 
E_V256BImode) == 0
              && (
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return 32135; /* *andnotv256bi */
          break;

        case E_V512BImode:
          if (pattern294 (x2, 
E_V512BImode) == 0
              && (
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return 32137; /* *andnotv512bi */
          break;

        case E_V1024BImode:
          if (pattern294 (x2, 
E_V1024BImode) == 0
              && (
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return 32139; /* *andnotv1024bi */
          break;

        case E_V2048BImode:
          if (pattern294 (x2, 
E_V2048BImode) == 0
              && (
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return 32141; /* *andnotv2048bi */
          break;

        case E_V4096BImode:
          if (pattern294 (x2, 
E_V4096BImode) == 0
              && (
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return 32143; /* *andnotv4096bi */
          break;

        case E_RVVM8QImode:
          if (pattern294 (x2, 
E_RVVM8QImode) == 0
              && 
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
            return 32479; /* *vandn_rvvm8qi */
          break;

        case E_RVVM4QImode:
          if (pattern294 (x2, 
E_RVVM4QImode) == 0
              && 
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
            return 32480; /* *vandn_rvvm4qi */
          break;

        case E_RVVM2QImode:
          if (pattern294 (x2, 
E_RVVM2QImode) == 0
              && 
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
            return 32481; /* *vandn_rvvm2qi */
          break;

        case E_RVVM1QImode:
          if (pattern294 (x2, 
E_RVVM1QImode) == 0
              && 
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
            return 32482; /* *vandn_rvvm1qi */
          break;

        case E_RVVM8HImode:
          if (pattern294 (x2, 
E_RVVM8HImode) == 0
              && 
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
            return 32483; /* *vandn_rvvm8hi */
          break;

        case E_RVVM4HImode:
          if (pattern294 (x2, 
E_RVVM4HImode) == 0
              && 
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
            return 32484; /* *vandn_rvvm4hi */
          break;

        case E_RVVM2HImode:
          if (pattern294 (x2, 
E_RVVM2HImode) == 0
              && 
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
            return 32485; /* *vandn_rvvm2hi */
          break;

        case E_RVVM1HImode:
          if (pattern294 (x2, 
E_RVVM1HImode) == 0
              && 
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
            return 32486; /* *vandn_rvvm1hi */
          break;

        case E_RVVM8SImode:
          if (pattern294 (x2, 
E_RVVM8SImode) == 0
              && 
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
            return 32487; /* *vandn_rvvm8si */
          break;

        case E_RVVM4SImode:
          if (pattern294 (x2, 
E_RVVM4SImode) == 0
              && 
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
            return 32488; /* *vandn_rvvm4si */
          break;

        case E_RVVM2SImode:
          if (pattern294 (x2, 
E_RVVM2SImode) == 0
              && 
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
            return 32489; /* *vandn_rvvm2si */
          break;

        case E_RVVM1SImode:
          if (pattern294 (x2, 
E_RVVM1SImode) == 0
              && 
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
            return 32490; /* *vandn_rvvm1si */
          break;

        case E_RVVM8DImode:
          if (pattern294 (x2, 
E_RVVM8DImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 32491; /* *vandn_rvvm8di */
          break;

        case E_RVVM4DImode:
          if (pattern294 (x2, 
E_RVVM4DImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 32492; /* *vandn_rvvm4di */
          break;

        case E_RVVM2DImode:
          if (pattern294 (x2, 
E_RVVM2DImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 32493; /* *vandn_rvvm2di */
          break;

        case E_RVVM1DImode:
          if (pattern294 (x2, 
E_RVVM1DImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 32494; /* *vandn_rvvm1di */
          break;

        case E_RVVMF2QImode:
          if (pattern294 (x2, 
E_RVVMF2QImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 32495; /* *vandn_rvvmf2qi */
          break;

        case E_RVVMF4QImode:
          if (pattern294 (x2, 
E_RVVMF4QImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 32496; /* *vandn_rvvmf4qi */
          break;

        case E_RVVMF8QImode:
          if (pattern294 (x2, 
E_RVVMF8QImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 32497; /* *vandn_rvvmf8qi */
          break;

        case E_RVVMF2HImode:
          if (pattern294 (x2, 
E_RVVMF2HImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return 32498; /* *vandn_rvvmf2hi */
          break;

        case E_RVVMF4HImode:
          if (pattern294 (x2, 
E_RVVMF4HImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 32499; /* *vandn_rvvmf4hi */
          break;

        case E_RVVMF2SImode:
          if (pattern294 (x2, 
E_RVVMF2SImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return 32500; /* *vandn_rvvmf2si */
          break;

        case E_V1QImode:
          if (pattern294 (x2, 
E_V1QImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return 32501; /* *vandn_v1qi */
          break;

        case E_V2QImode:
          if (pattern294 (x2, 
E_V2QImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return 32502; /* *vandn_v2qi */
          break;

        case E_V4QImode:
          if (pattern294 (x2, 
E_V4QImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return 32503; /* *vandn_v4qi */
          break;

        case E_V8QImode:
          if (pattern294 (x2, 
E_V8QImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return 32504; /* *vandn_v8qi */
          break;

        case E_V16QImode:
          if (pattern294 (x2, 
E_V16QImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return 32505; /* *vandn_v16qi */
          break;

        case E_V32QImode:
          if (pattern294 (x2, 
E_V32QImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return 32506; /* *vandn_v32qi */
          break;

        case E_V64QImode:
          if (pattern294 (x2, 
E_V64QImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return 32507; /* *vandn_v64qi */
          break;

        case E_V128QImode:
          if (pattern294 (x2, 
E_V128QImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return 32508; /* *vandn_v128qi */
          break;

        case E_V256QImode:
          if (pattern294 (x2, 
E_V256QImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return 32509; /* *vandn_v256qi */
          break;

        case E_V512QImode:
          if (pattern294 (x2, 
E_V512QImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return 32510; /* *vandn_v512qi */
          break;

        case E_V1024QImode:
          if (pattern294 (x2, 
E_V1024QImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return 32511; /* *vandn_v1024qi */
          break;

        case E_V2048QImode:
          if (pattern294 (x2, 
E_V2048QImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return 32512; /* *vandn_v2048qi */
          break;

        case E_V4096QImode:
          if (pattern294 (x2, 
E_V4096QImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return 32513; /* *vandn_v4096qi */
          break;

        case E_V1HImode:
          if (pattern294 (x2, 
E_V1HImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return 32514; /* *vandn_v1hi */
          break;

        case E_V2HImode:
          if (pattern294 (x2, 
E_V2HImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return 32515; /* *vandn_v2hi */
          break;

        case E_V4HImode:
          if (pattern294 (x2, 
E_V4HImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return 32516; /* *vandn_v4hi */
          break;

        case E_V8HImode:
          if (pattern294 (x2, 
E_V8HImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return 32517; /* *vandn_v8hi */
          break;

        case E_V16HImode:
          if (pattern294 (x2, 
E_V16HImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return 32518; /* *vandn_v16hi */
          break;

        case E_V32HImode:
          if (pattern294 (x2, 
E_V32HImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return 32519; /* *vandn_v32hi */
          break;

        case E_V64HImode:
          if (pattern294 (x2, 
E_V64HImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return 32520; /* *vandn_v64hi */
          break;

        case E_V128HImode:
          if (pattern294 (x2, 
E_V128HImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return 32521; /* *vandn_v128hi */
          break;

        case E_V256HImode:
          if (pattern294 (x2, 
E_V256HImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return 32522; /* *vandn_v256hi */
          break;

        case E_V512HImode:
          if (pattern294 (x2, 
E_V512HImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return 32523; /* *vandn_v512hi */
          break;

        case E_V1024HImode:
          if (pattern294 (x2, 
E_V1024HImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return 32524; /* *vandn_v1024hi */
          break;

        case E_V2048HImode:
          if (pattern294 (x2, 
E_V2048HImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return 32525; /* *vandn_v2048hi */
          break;

        case E_V1SImode:
          if (pattern294 (x2, 
E_V1SImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return 32526; /* *vandn_v1si */
          break;

        case E_V2SImode:
          if (pattern294 (x2, 
E_V2SImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return 32527; /* *vandn_v2si */
          break;

        case E_V4SImode:
          if (pattern294 (x2, 
E_V4SImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return 32528; /* *vandn_v4si */
          break;

        case E_V8SImode:
          if (pattern294 (x2, 
E_V8SImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return 32529; /* *vandn_v8si */
          break;

        case E_V16SImode:
          if (pattern294 (x2, 
E_V16SImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return 32530; /* *vandn_v16si */
          break;

        case E_V32SImode:
          if (pattern294 (x2, 
E_V32SImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return 32531; /* *vandn_v32si */
          break;

        case E_V64SImode:
          if (pattern294 (x2, 
E_V64SImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return 32532; /* *vandn_v64si */
          break;

        case E_V128SImode:
          if (pattern294 (x2, 
E_V128SImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return 32533; /* *vandn_v128si */
          break;

        case E_V256SImode:
          if (pattern294 (x2, 
E_V256SImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return 32534; /* *vandn_v256si */
          break;

        case E_V512SImode:
          if (pattern294 (x2, 
E_V512SImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return 32535; /* *vandn_v512si */
          break;

        case E_V1024SImode:
          if (pattern294 (x2, 
E_V1024SImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return 32536; /* *vandn_v1024si */
          break;

        case E_V1DImode:
          if (pattern294 (x2, 
E_V1DImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return 32537; /* *vandn_v1di */
          break;

        case E_V2DImode:
          if (pattern294 (x2, 
E_V2DImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return 32538; /* *vandn_v2di */
          break;

        case E_V4DImode:
          if (pattern294 (x2, 
E_V4DImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return 32539; /* *vandn_v4di */
          break;

        case E_V8DImode:
          if (pattern294 (x2, 
E_V8DImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return 32540; /* *vandn_v8di */
          break;

        case E_V16DImode:
          if (pattern294 (x2, 
E_V16DImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return 32541; /* *vandn_v16di */
          break;

        case E_V32DImode:
          if (pattern294 (x2, 
E_V32DImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return 32542; /* *vandn_v32di */
          break;

        case E_V64DImode:
          if (pattern294 (x2, 
E_V64DImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return 32543; /* *vandn_v64di */
          break;

        case E_V128DImode:
          if (pattern294 (x2, 
E_V128DImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return 32544; /* *vandn_v128di */
          break;

        case E_V256DImode:
          if (pattern294 (x2, 
E_V256DImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return 32545; /* *vandn_v256di */
          break;

        case E_V512DImode:
          if (pattern294 (x2, 
E_V512DImode) == 0
              && (
#line 1666 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return 32546; /* *vandn_v512di */
          break;

        default:
          break;
        }
      break;

    case CONST_INT:
      switch (pattern264 (x2, pnum_clobbers))
        {
        case 0:
          if ((
#line 242 "../../gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 519; /* *and_not_constsi */
            }
          break;

        case 1:
          if ((
#line 242 "../../gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 521; /* *and_not_constdi */
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SUBREG
      || pattern290 (x2) != 0
      || !
#line 924 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBS))
    return -1;
  return 636; /* *bextseqzdisi */
}

 int
recog_126 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V64DFmode)
      && reg_or_mem_operand (operands[1], E_V64DFmode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DFmode)
       || register_operand (operands[1], V64DFmode))) && (
#line 4388 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3312; /* *movv64dfsi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64DFmode)
       || register_operand (operands[1], V64DFmode))) && (
#line 4388 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3313; /* *movv64dfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V64DFmode)
      || !register_operand (operands[1], E_V64DFmode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 3411; /* *movv64df_vls */
}

 int
recog_130 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V256SFmode)
      && reg_or_mem_operand (operands[1], E_V256SFmode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SFmode)
       || register_operand (operands[1], V256SFmode))) && (
#line 4384 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3304; /* *movv256sfsi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SFmode)
       || register_operand (operands[1], V256SFmode))) && (
#line 4384 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3305; /* *movv256sfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V256SFmode)
      || !register_operand (operands[1], E_V256SFmode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 3402; /* *movv256sf_vls */
}

 int
recog_136 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V512HFmode)
      && reg_or_mem_operand (operands[1], E_V512HFmode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HFmode)
       || register_operand (operands[1], V512HFmode))) && (
#line 4378 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3292; /* *movv512hfsi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HFmode)
       || register_operand (operands[1], V512HFmode))) && (
#line 4378 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3293; /* *movv512hfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V512HFmode)
      || !register_operand (operands[1], E_V512HFmode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 3391; /* *movv512hf_vls */
}

 int
recog_142 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V256DImode)
      && reg_or_mem_operand (operands[1], E_V256DImode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DImode)
       || register_operand (operands[1], V256DImode))) && (
#line 4372 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3280; /* *movv256disi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256DImode)
       || register_operand (operands[1], V256DImode))) && (
#line 4372 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3281; /* *movv256didi_lra */
        }
    }
  if (!register_operand (operands[0], E_V256DImode)
      || !register_operand (operands[1], E_V256DImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3380; /* *movv256di_vls */
}

 int
recog_148 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V256SImode)
      && reg_or_mem_operand (operands[1], E_V256SImode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SImode)
       || register_operand (operands[1], V256SImode))) && (
#line 4366 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3268; /* *movv256sisi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256SImode)
       || register_operand (operands[1], V256SImode))) && (
#line 4366 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3269; /* *movv256sidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V256SImode)
      || !register_operand (operands[1], E_V256SImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 3369; /* *movv256si_vls */
}

 int
recog_154 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V512HImode)
      && reg_or_mem_operand (operands[1], E_V512HImode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HImode)
       || register_operand (operands[1], V512HImode))) && (
#line 4360 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3256; /* *movv512hisi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V512HImode)
       || register_operand (operands[1], V512HImode))) && (
#line 4360 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3257; /* *movv512hidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V512HImode)
      || !register_operand (operands[1], E_V512HImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 3358; /* *movv512hi_vls */
}

 int
recog_160 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V2048QImode)
      && reg_or_mem_operand (operands[1], E_V2048QImode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048QImode)
       || register_operand (operands[1], V2048QImode))) && (
#line 4354 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3244; /* *movv2048qisi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V2048QImode)
       || register_operand (operands[1], V2048QImode))) && (
#line 4354 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3245; /* *movv2048qidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V2048QImode)
      || !register_operand (operands[1], E_V2048QImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 3347; /* *movv2048qi_vls */
}

 int
recog_166 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V32QImode)
      && reg_or_mem_operand (operands[1], E_V32QImode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32QImode)
       || register_operand (operands[1], V32QImode))) && (
#line 4348 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3232; /* *movv32qisi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32QImode)
       || register_operand (operands[1], V32QImode))) && (
#line 4348 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3233; /* *movv32qidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V32QImode)
      || !register_operand (operands[1], E_V32QImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
    return -1;
  return 3341; /* *movv32qi_vls */
}

 int
recog_173 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF64BImode)
      && register_operand (operands[1], E_RVVMF64BImode)
      && (
#line 1294 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
    return 2812; /* *movrvvmf64bi */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF64BImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF64BImode))
    return -1;
  if ((
#line 1354 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 1;
      return 2848; /* *movrvvmf64bisi_lra */
    }
  if (!(
#line 1354 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 1;
  return 2849; /* *movrvvmf64bidi_lra */
}

 int
recog_179 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF2BFmode)
      && register_operand (operands[1], E_RVVMF2BFmode)
      && (
#line 1257 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
    return 2795; /* *movrvvmf2bf_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2BFmode))
    return -1;
  if ((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 1;
      return 2831; /* *movrvvmf2bfsi_lra */
    }
  if (!(
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 1;
  return 2842; /* *movrvvmf2bfdi_lra */
}

 int
recog_186 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16BImode)
      && reg_or_mem_operand (operands[1], E_V16BImode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16BImode)
       || register_operand (operands[1], V16BImode))) && 
#line 4344 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
    return 3231; /* *movv16bi */
  if (!register_operand (operands[0], E_V16BImode)
      || !register_operand (operands[1], E_V16BImode)
      || !(
#line 1530 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
    return -1;
  return 3498; /* *movv16bi_vls */
}

 int
recog_191 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16DFmode)
      && reg_or_mem_operand (operands[1], E_V16DFmode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16DFmode)
       || register_operand (operands[1], V16DFmode))) && 
#line 4338 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return 3226; /* *movv16df */
  if (!register_operand (operands[0], E_V16DFmode)
      || !register_operand (operands[1], E_V16DFmode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 3409; /* *movv16df_vls */
}

 int
recog_199 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2SFmode)
      && reg_or_mem_operand (operands[1], E_V2SFmode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2SFmode)
       || register_operand (operands[1], V2SFmode))) && 
#line 4330 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 3218; /* *movv2sf */
  if (!register_operand (operands[0], E_V2SFmode)
      || !register_operand (operands[1], E_V2SFmode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 3395; /* *movv2sf_vls */
}

 int
recog_205 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1HFmode)
      && reg_or_mem_operand (operands[1], E_V1HFmode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1HFmode)
       || register_operand (operands[1], V1HFmode))) && 
#line 4324 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 3212; /* *movv1hf */
  if (!register_operand (operands[0], E_V1HFmode)
      || !register_operand (operands[1], E_V1HFmode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 3382; /* *movv1hf_vls */
}

 int
recog_211 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16SImode)
      && reg_or_mem_operand (operands[1], E_V16SImode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16SImode)
       || register_operand (operands[1], V16SImode))) && 
#line 4318 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 3206; /* *movv16si */
  if (!register_operand (operands[0], E_V16SImode)
      || !register_operand (operands[1], E_V16SImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 3365; /* *movv16si_vls */
}

 int
recog_218 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4HImode)
      && reg_or_mem_operand (operands[1], E_V4HImode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4HImode)
       || register_operand (operands[1], V4HImode))) && 
#line 4311 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 3199; /* *movv4hi */
  if (!register_operand (operands[0], E_V4HImode)
      || !register_operand (operands[1], E_V4HImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return -1;
  return 3351; /* *movv4hi_vls */
}

 int
recog_225 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1QImode)
      && reg_or_mem_operand (operands[1], E_V1QImode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1QImode)
       || register_operand (operands[1], V1QImode))) && 
#line 4304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return 3192; /* *movv1qi */
  if (!register_operand (operands[0], E_V1QImode)
      || !register_operand (operands[1], E_V1QImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return -1;
  return 3336; /* *movv1qi_vls */
}

 int
recog_232 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3QImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3180; /* *movrvvm2x3qi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3181; /* *movrvvm2x3qi_di */
}

 int
recog_239 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3BFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3166; /* *movrvvm2x3bf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3167; /* *movrvvm2x3bf_di */
}

 int
recog_246 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x7QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x7QImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3152; /* *movrvvm1x7qi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3153; /* *movrvvm1x7qi_di */
}

 int
recog_253 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x4SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x4SFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3138; /* *movrvvm2x4sf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3139; /* *movrvvm2x4sf_di */
}

 int
recog_260 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x4HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x4HFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1304 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3124; /* *movrvvm1x4hf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1304 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3125; /* *movrvvm1x4hf_di */
}

 int
recog_267 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x4BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x4BFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3110; /* *movrvvm1x4bf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3111; /* *movrvvm1x4bf_di */
}

 int
recog_275 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x7HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x7HImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3094; /* *movrvvm1x7hi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3095; /* *movrvvm1x7hi_di */
}

 int
recog_283 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x6QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x6QImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3078; /* *movrvvmf2x6qi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3079; /* *movrvvmf2x6qi_di */
}

 int
recog_291 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x8SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x8SFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1270 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3062; /* *movrvvm1x8sf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1270 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3063; /* *movrvvm1x8sf_di */
}

 int
recog_299 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x7HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x7HFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1262 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3046; /* *movrvvmf2x7hf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1262 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3047; /* *movrvvmf2x7hf_di */
}

 int
recog_307 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x6BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x6BFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3030; /* *movrvvmf2x6bf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3031; /* *movrvvmf2x6bf_di */
}

 int
recog_315 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x8SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x8SImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3014; /* *movrvvm1x8si_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3015; /* *movrvvm1x8si_di */
}

 int
recog_322 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x8HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x8HImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3000; /* *movrvvmf2x8hi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3001; /* *movrvvmf2x8hi_di */
}

 int
recog_330 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x7QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x7QImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2984; /* *movrvvmf4x7qi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2985; /* *movrvvmf4x7qi_di */
}

 int
recog_338 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6DFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2968; /* *movrvvm1x6df_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2969; /* *movrvvm1x6df_di */
}

 int
recog_346 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x5SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x5SFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2952; /* *movrvvmf2x5sf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2953; /* *movrvvmf2x5sf_di */
}

 int
recog_354 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x4HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x4HFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2936; /* *movrvvmf4x4hf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2937; /* *movrvvmf4x4hf_di */
}

 int
recog_362 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x3BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x3BFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2920; /* *movrvvmf4x3bf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2921; /* *movrvvmf4x3bf_di */
}

 int
recog_370 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2DImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2904; /* *movrvvm1x2di_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2905; /* *movrvvm1x2di_di */
}

 int
recog_378 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != ZERO_EXTEND)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x7 = XEXP (x1, 1);
  operands[2] = x7;
  if (!immediate_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode
          || !(
#line 817 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS
   && (operands[2] == CONST0_RTX (SImode)
       || operands[2] == CONST1_RTX (SImode))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return -1;
      return 625; /* *bsetclr_zero_extract */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode
          || !(
#line 817 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS
   && (operands[2] == CONST0_RTX (DImode)
       || operands[2] == CONST1_RTX (DImode))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 626; /* *bsetclr_zero_extract */

    default:
      return -1;
    }
}

 int
recog_384 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 2);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      operands[3] = x5;
      if (!branch_on_bit_operand (operands[3], E_VOIDmode))
        return -1;
      operands[0] = x3;
      x6 = XEXP (x2, 1);
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || !
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 383; /* *branch_on_bitsi */

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || !
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 384; /* *branch_on_bitdi */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      operands[1] = x3;
      x8 = XEXP (x5, 0);
      operands[3] = x8;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      x6 = XEXP (x2, 1);
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || GET_MODE (x5) != E_SImode
              || !(
#line 1145 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 653; /* *branchsi_bext */

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || GET_MODE (x5) != E_DImode
              || !(
#line 1145 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 654; /* *branchdi_bext */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_386 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (equality_operator (x3, E_VOIDmode))
    {
      res = recog_385 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_CODE (x3))
    {
    case EQ:
      switch (pattern365 (x2))
        {
        case 0:
          if (!(
#line 34 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33782; /* *czero.nez.sisi */

        case 1:
          if (!(
#line 34 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33784; /* *czero.nez.sidi */

        case 2:
          if (!(
#line 34 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33786; /* *czero.nez.didi */

        case 3:
          if (!(
#line 69 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && rtx_equal_p (operands[1], operands[2])) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33794; /* *czero.eqz.sisi.opt1 */

        case 4:
          if (!(
#line 69 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && rtx_equal_p (operands[1], operands[2])) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33796; /* *czero.eqz.sidi.opt1 */

        case 5:
          if (!(
#line 69 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && rtx_equal_p (operands[1], operands[2])) && (((
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
            return -1;
          return 33795; /* *czero.eqz.disi.opt1 */

        case 6:
          if (!(
#line 69 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && rtx_equal_p (operands[1], operands[2])) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33797; /* *czero.eqz.didi.opt1 */

        case 7:
          if (!(
#line 51 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33788; /* *czero.eqz.sisi */

        case 8:
          if (!(
#line 51 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33790; /* *czero.eqz.sidi */

        case 9:
          if (!(
#line 51 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33792; /* *czero.eqz.didi */

        default:
          return -1;
        }

    case NE:
      switch (pattern365 (x2))
        {
        case 0:
          if (!(
#line 34 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33783; /* *czero.eqz.sisi */

        case 1:
          if (!(
#line 34 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33785; /* *czero.eqz.sidi */

        case 2:
          if (!(
#line 34 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33787; /* *czero.eqz.didi */

        case 3:
          if (!(
#line 86 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND && rtx_equal_p (operands[1], operands[3])) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33798; /* *czero.nez.sisi.opt2 */

        case 4:
          if (!(
#line 86 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND && rtx_equal_p (operands[1], operands[3])) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33800; /* *czero.nez.sidi.opt2 */

        case 5:
          if (!(
#line 86 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND && rtx_equal_p (operands[1], operands[3])) && (((
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
            return -1;
          return 33799; /* *czero.nez.disi.opt2 */

        case 6:
          if (!(
#line 86 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND && rtx_equal_p (operands[1], operands[3])) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33801; /* *czero.nez.didi.opt2 */

        case 7:
          if (!(
#line 51 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33789; /* *czero.nez.sisi */

        case 8:
          if (!(
#line 51 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33791; /* *czero.nez.sidi */

        case 9:
          if (!(
#line 51 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33793; /* *czero.nez.didi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_389 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case LABEL_REF:
      x4 = XEXP (x2, 2);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) != PC)
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      x8 = XEXP (x6, 1);
      operands[3] = x8;
      x9 = XEXP (x3, 0);
      operands[0] = x9;
      switch (pattern414 ())
        {
        case 0:
          if (!(
#line 3262 "../../gcc/config/riscv/riscv.md"
(!TARGET_XCVBI) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 369; /* *branchsi */

        case 1:
          if (!(
#line 3262 "../../gcc/config/riscv/riscv.md"
(!TARGET_XCVBI) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 370; /* *branchdi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[3] = x3;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x2, 0);
      operands[5] = x6;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      x4 = XEXP (x2, 2);
      operands[4] = x4;
      switch (pattern338 (x2))
        {
        case 0:
          if (!register_operand (operands[3], E_SImode)
              || !sfb_alu_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !reg_or_0_operand (operands[2], E_SImode)
                  || !(
#line 31 "../../gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33802; /* *movsisicc */

            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !reg_or_0_operand (operands[2], E_DImode)
                  || !(
#line 31 "../../gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33803; /* *movsidicc */

            default:
              return -1;
            }

        case 1:
          if (!register_operand (operands[1], E_DImode)
              || !reg_or_0_operand (operands[2], E_DImode)
              || !register_operand (operands[3], E_DImode)
              || !sfb_alu_operand (operands[4], E_DImode)
              || !(
#line 31 "../../gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33804; /* *movdidicc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_390 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!vector_move_operand (operands[3], E_RVVMF64BImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[2] = x7;
  if (!vector_undef_operand (operands[2], E_RVVMF64BImode))
    return -1;
  if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
    return 1231; /* *pred_th_movrvvmf64bi */
  if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
    return -1;
  return 3816; /* pred_movrvvmf64bi */
}

 int
recog_391 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!vector_move_operand (operands[3], E_RVVMF32BImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[2] = x7;
  if (!vector_undef_operand (operands[2], E_RVVMF32BImode))
    return -1;
  if (
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return 1232; /* *pred_th_movrvvmf32bi */
  if (!
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 3817; /* pred_movrvvmf32bi */
}

 int
recog_393 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!vector_move_operand (operands[3], E_RVVMF8BImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[2] = x7;
  if (!vector_undef_operand (operands[2], E_RVVMF8BImode))
    return -1;
  if (
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return 1234; /* *pred_th_movrvvmf8bi */
  if (!
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 3819; /* pred_movrvvmf8bi */
}

 int
recog_395 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!vector_move_operand (operands[3], E_RVVMF2BImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[2] = x7;
  if (!vector_undef_operand (operands[2], E_RVVMF2BImode))
    return -1;
  if (
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return 1236; /* *pred_th_movrvvmf2bi */
  if (!
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 3821; /* pred_movrvvmf2bi */
}

 int
recog_397 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3843; /* pred_mergervvm8qi */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3844; /* pred_mergervvm4qi */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3845; /* pred_mergervvm2qi */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3846; /* pred_mergervvm1qi */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3847; /* pred_mergervvm8hi */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3848; /* pred_mergervvm4hi */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3849; /* pred_mergervvm2hi */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3850; /* pred_mergervvm1hi */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3851; /* pred_mergervvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3852; /* pred_mergervvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3853; /* pred_mergervvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 3854; /* pred_mergervvm1si */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3855; /* pred_mergervvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3856; /* pred_mergervvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3857; /* pred_mergervvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3858; /* pred_mergervvm1di */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3859; /* pred_mergervvmf2qi */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3860; /* pred_mergervvmf4qi */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3861; /* pred_mergervvmf8qi */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3862; /* pred_mergervvmf2hi */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3863; /* pred_mergervvmf4hi */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3864; /* pred_mergervvmf2si */

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3865; /* pred_mergervvm8bf */

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3866; /* pred_mergervvm4bf */

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3867; /* pred_mergervvm2bf */

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3868; /* pred_mergervvm1bf */

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3869; /* pred_mergervvmf2bf */

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3870; /* pred_mergervvmf4bf */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3871; /* pred_mergervvm8hf */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3872; /* pred_mergervvm4hf */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3873; /* pred_mergervvm2hf */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3874; /* pred_mergervvm1hf */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3875; /* pred_mergervvmf2hf */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3876; /* pred_mergervvmf4hf */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3877; /* pred_mergervvm8sf */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3878; /* pred_mergervvm4sf */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3879; /* pred_mergervvm2sf */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3880; /* pred_mergervvm1sf */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3881; /* pred_mergervvmf2sf */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3882; /* pred_mergervvm8df */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3883; /* pred_mergervvm4df */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3884; /* pred_mergervvm2df */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3885; /* pred_mergervvm1df */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 3886; /* pred_mergev1qi */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 3887; /* pred_mergev2qi */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 3888; /* pred_mergev4qi */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 3889; /* pred_mergev8qi */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 3890; /* pred_mergev16qi */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 3891; /* pred_mergev32qi */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3892; /* pred_mergev64qi */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3893; /* pred_mergev128qi */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3894; /* pred_mergev256qi */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3895; /* pred_mergev512qi */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3896; /* pred_mergev1024qi */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3897; /* pred_mergev2048qi */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3898; /* pred_mergev4096qi */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 3899; /* pred_mergev1hi */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 3900; /* pred_mergev2hi */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 3901; /* pred_mergev4hi */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 3902; /* pred_mergev8hi */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 3903; /* pred_mergev16hi */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3904; /* pred_mergev32hi */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3905; /* pred_mergev64hi */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3906; /* pred_mergev128hi */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3907; /* pred_mergev256hi */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3908; /* pred_mergev512hi */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3909; /* pred_mergev1024hi */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3910; /* pred_mergev2048hi */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 3911; /* pred_mergev1si */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 3912; /* pred_mergev2si */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 3913; /* pred_mergev4si */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 3914; /* pred_mergev8si */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3915; /* pred_mergev16si */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3916; /* pred_mergev32si */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3917; /* pred_mergev64si */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3918; /* pred_mergev128si */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3919; /* pred_mergev256si */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3920; /* pred_mergev512si */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3921; /* pred_mergev1024si */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3922; /* pred_mergev1di */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3923; /* pred_mergev2di */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3924; /* pred_mergev4di */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3925; /* pred_mergev8di */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3926; /* pred_mergev16di */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3927; /* pred_mergev32di */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3928; /* pred_mergev64di */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3929; /* pred_mergev128di */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3930; /* pred_mergev256di */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3931; /* pred_mergev512di */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3932; /* pred_mergev1hf */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3933; /* pred_mergev2hf */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3934; /* pred_mergev4hf */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3935; /* pred_mergev8hf */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3936; /* pred_mergev16hf */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3937; /* pred_mergev32hf */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3938; /* pred_mergev64hf */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3939; /* pred_mergev128hf */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3940; /* pred_mergev256hf */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3941; /* pred_mergev512hf */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3942; /* pred_mergev1024hf */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3943; /* pred_mergev2048hf */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3944; /* pred_mergev1sf */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3945; /* pred_mergev2sf */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3946; /* pred_mergev4sf */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3947; /* pred_mergev8sf */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3948; /* pred_mergev16sf */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3949; /* pred_mergev32sf */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3950; /* pred_mergev64sf */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3951; /* pred_mergev128sf */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3952; /* pred_mergev256sf */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 293 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3953; /* pred_mergev512sf */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3954; /* pred_mergev1024sf */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3955; /* pred_mergev1df */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3956; /* pred_mergev2df */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3957; /* pred_mergev4df */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3958; /* pred_mergev8df */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3959; /* pred_mergev16df */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3960; /* pred_mergev32df */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3961; /* pred_mergev64df */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3962; /* pred_mergev128df */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3963; /* pred_mergev256df */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern598 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !(
#line 2011 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3964; /* pred_mergev512df */

    default:
      return -1;
    }
}

 int
recog_412 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      return recog_410 (x1, insn, pnum_clobbers);

    case VEC_MERGE:
      return recog_409 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_408 (x1, insn, pnum_clobbers);

    case AND:
      switch (pattern442 (x2))
        {
        case 0:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14153; /* pred_andrvvmf64bi */

        case 1:
          if (!
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14156; /* pred_andrvvmf32bi */

        case 2:
          if (!
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14159; /* pred_andrvvmf16bi */

        case 3:
          if (!
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14162; /* pred_andrvvmf8bi */

        case 4:
          if (!
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14165; /* pred_andrvvmf4bi */

        case 5:
          if (!
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14168; /* pred_andrvvmf2bi */

        case 6:
          if (!
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14171; /* pred_andrvvm1bi */

        case 7:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14174; /* pred_andv1bi */

        case 8:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14177; /* pred_andv2bi */

        case 9:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14180; /* pred_andv4bi */

        case 10:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14183; /* pred_andv8bi */

        case 11:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14186; /* pred_andv16bi */

        case 12:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14189; /* pred_andv32bi */

        case 13:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14192; /* pred_andv64bi */

        case 14:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14195; /* pred_andv128bi */

        case 15:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14198; /* pred_andv256bi */

        case 16:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14201; /* pred_andv512bi */

        case 17:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14204; /* pred_andv1024bi */

        case 18:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14207; /* pred_andv2048bi */

        case 19:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14210; /* pred_andv4096bi */

        case 20:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14273; /* pred_andnotrvvmf64bi */

        case 21:
          if (!
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14275; /* pred_andnotrvvmf32bi */

        case 22:
          if (!
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14277; /* pred_andnotrvvmf16bi */

        case 23:
          if (!
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14279; /* pred_andnotrvvmf8bi */

        case 24:
          if (!
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14281; /* pred_andnotrvvmf4bi */

        case 25:
          if (!
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14283; /* pred_andnotrvvmf2bi */

        case 26:
          if (!
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14285; /* pred_andnotrvvm1bi */

        case 27:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14287; /* pred_andnotv1bi */

        case 28:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14289; /* pred_andnotv2bi */

        case 29:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14291; /* pred_andnotv4bi */

        case 30:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14293; /* pred_andnotv8bi */

        case 31:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14295; /* pred_andnotv16bi */

        case 32:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14297; /* pred_andnotv32bi */

        case 33:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14299; /* pred_andnotv64bi */

        case 34:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14301; /* pred_andnotv128bi */

        case 35:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14303; /* pred_andnotv256bi */

        case 36:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14305; /* pred_andnotv512bi */

        case 37:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14307; /* pred_andnotv1024bi */

        case 38:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14309; /* pred_andnotv2048bi */

        case 39:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14311; /* pred_andnotv4096bi */

        default:
          return -1;
        }

    case IOR:
      switch (pattern442 (x2))
        {
        case 0:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14154; /* pred_iorrvvmf64bi */

        case 1:
          if (!
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14157; /* pred_iorrvvmf32bi */

        case 2:
          if (!
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14160; /* pred_iorrvvmf16bi */

        case 3:
          if (!
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14163; /* pred_iorrvvmf8bi */

        case 4:
          if (!
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14166; /* pred_iorrvvmf4bi */

        case 5:
          if (!
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14169; /* pred_iorrvvmf2bi */

        case 6:
          if (!
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14172; /* pred_iorrvvm1bi */

        case 7:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14175; /* pred_iorv1bi */

        case 8:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14178; /* pred_iorv2bi */

        case 9:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14181; /* pred_iorv4bi */

        case 10:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14184; /* pred_iorv8bi */

        case 11:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14187; /* pred_iorv16bi */

        case 12:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14190; /* pred_iorv32bi */

        case 13:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14193; /* pred_iorv64bi */

        case 14:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14196; /* pred_iorv128bi */

        case 15:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14199; /* pred_iorv256bi */

        case 16:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14202; /* pred_iorv512bi */

        case 17:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14205; /* pred_iorv1024bi */

        case 18:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14208; /* pred_iorv2048bi */

        case 19:
          if (!(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14211; /* pred_iorv4096bi */

        case 20:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14274; /* pred_iornotrvvmf64bi */

        case 21:
          if (!
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14276; /* pred_iornotrvvmf32bi */

        case 22:
          if (!
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14278; /* pred_iornotrvvmf16bi */

        case 23:
          if (!
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14280; /* pred_iornotrvvmf8bi */

        case 24:
          if (!
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14282; /* pred_iornotrvvmf4bi */

        case 25:
          if (!
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14284; /* pred_iornotrvvmf2bi */

        case 26:
          if (!
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14286; /* pred_iornotrvvm1bi */

        case 27:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14288; /* pred_iornotv1bi */

        case 28:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14290; /* pred_iornotv2bi */

        case 29:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14292; /* pred_iornotv4bi */

        case 30:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14294; /* pred_iornotv8bi */

        case 31:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14296; /* pred_iornotv16bi */

        case 32:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14298; /* pred_iornotv32bi */

        case 33:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14300; /* pred_iornotv64bi */

        case 34:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14302; /* pred_iornotv128bi */

        case 35:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14304; /* pred_iornotv256bi */

        case 36:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14306; /* pred_iornotv512bi */

        case 37:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14308; /* pred_iornotv1024bi */

        case 38:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14310; /* pred_iornotv2048bi */

        case 39:
          if (!(
#line 6060 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14312; /* pred_iornotv4096bi */

        default:
          return -1;
        }

    case XOR:
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[5] = x6;
      if (!vector_length_operand (operands[5], E_VOIDmode))
        return -1;
      x7 = XVECEXP (x4, 0, 2);
      operands[6] = x7;
      x8 = XEXP (x3, 0);
      operands[3] = x8;
      x9 = XEXP (x3, 1);
      operands[4] = x9;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVMF64BImode:
          if (pattern440 (x2, 
E_RVVMF64BImode) != 0
              || !(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14155; /* pred_xorrvvmf64bi */

        case E_RVVMF32BImode:
          if (pattern440 (x2, 
E_RVVMF32BImode) != 0
              || !
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14158; /* pred_xorrvvmf32bi */

        case E_RVVMF16BImode:
          if (pattern440 (x2, 
E_RVVMF16BImode) != 0
              || !
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14161; /* pred_xorrvvmf16bi */

        case E_RVVMF8BImode:
          if (pattern440 (x2, 
E_RVVMF8BImode) != 0
              || !
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14164; /* pred_xorrvvmf8bi */

        case E_RVVMF4BImode:
          if (pattern440 (x2, 
E_RVVMF4BImode) != 0
              || !
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14167; /* pred_xorrvvmf4bi */

        case E_RVVMF2BImode:
          if (pattern440 (x2, 
E_RVVMF2BImode) != 0
              || !
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14170; /* pred_xorrvvmf2bi */

        case E_RVVM1BImode:
          if (pattern440 (x2, 
E_RVVM1BImode) != 0
              || !
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14173; /* pred_xorrvvm1bi */

        case E_V1BImode:
          if (pattern440 (x2, 
E_V1BImode) != 0
              || !(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
            return -1;
          return 14176; /* pred_xorv1bi */

        case E_V2BImode:
          if (pattern440 (x2, 
E_V2BImode) != 0
              || !(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
            return -1;
          return 14179; /* pred_xorv2bi */

        case E_V4BImode:
          if (pattern440 (x2, 
E_V4BImode) != 0
              || !(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
            return -1;
          return 14182; /* pred_xorv4bi */

        case E_V8BImode:
          if (pattern440 (x2, 
E_V8BImode) != 0
              || !(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
            return -1;
          return 14185; /* pred_xorv8bi */

        case E_V16BImode:
          if (pattern440 (x2, 
E_V16BImode) != 0
              || !(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
            return -1;
          return 14188; /* pred_xorv16bi */

        case E_V32BImode:
          if (pattern440 (x2, 
E_V32BImode) != 0
              || !(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
            return -1;
          return 14191; /* pred_xorv32bi */

        case E_V64BImode:
          if (pattern440 (x2, 
E_V64BImode) != 0
              || !(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14194; /* pred_xorv64bi */

        case E_V128BImode:
          if (pattern440 (x2, 
E_V128BImode) != 0
              || !(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14197; /* pred_xorv128bi */

        case E_V256BImode:
          if (pattern440 (x2, 
E_V256BImode) != 0
              || !(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14200; /* pred_xorv256bi */

        case E_V512BImode:
          if (pattern440 (x2, 
E_V512BImode) != 0
              || !(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14203; /* pred_xorv512bi */

        case E_V1024BImode:
          if (pattern440 (x2, 
E_V1024BImode) != 0
              || !(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14206; /* pred_xorv1024bi */

        case E_V2048BImode:
          if (pattern440 (x2, 
E_V2048BImode) != 0
              || !(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14209; /* pred_xorv2048bi */

        case E_V4096BImode:
          if (pattern440 (x2, 
E_V4096BImode) != 0
              || !(
#line 6018 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14212; /* pred_xorv4096bi */

        default:
          return -1;
        }

    case NOT:
      return recog_411 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_421 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V8DFmode, 
E_V8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V8BImode)
      && vector_const_0_operand (operands[3], E_V8DFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return 4346; /* *pred_broadcastv8df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V8DFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 4468; /* *pred_broadcastv8df_imm */
}

 int
recog_425 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1024BImode)
      && vector_const_0_operand (operands[3], E_V1024SFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return 4342; /* *pred_broadcastv1024sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1024BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1024SFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 4464; /* *pred_broadcastv1024sf_imm */
}

 int
recog_429 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V64SFmode, 
E_V64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V64BImode)
      && vector_const_0_operand (operands[3], E_V64SFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return 4338; /* *pred_broadcastv64sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V64SFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 4460; /* *pred_broadcastv64sf_imm */
}

 int
recog_433 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V4SFmode, 
E_V4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V4BImode)
      && vector_const_0_operand (operands[3], E_V4SFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 4334; /* *pred_broadcastv4sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V4SFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4456; /* *pred_broadcastv4sf_imm */
}

 int
recog_438 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V512HFmode, 
E_V512BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V512BImode)
      && vector_const_0_operand (operands[3], E_V512HFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
    return 4329; /* *pred_broadcastv512hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V512BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V512HFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 4451; /* *pred_broadcastv512hf_imm */
}

 int
recog_443 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V16HFmode, 
E_V16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V16BImode)
      && vector_const_0_operand (operands[3], E_V16HFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 4324; /* *pred_broadcastv16hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V16HFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4446; /* *pred_broadcastv16hf_imm */
}

 int
recog_448 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V512DImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V512BImode)
      && vector_const_0_operand (operands[3], E_V512DImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 4319; /* *pred_broadcastv512di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V512BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V512DImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 4441; /* *pred_broadcastv512di_imm */
}

 int
recog_453 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V16BImode)
      && vector_const_0_operand (operands[3], E_V16DImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 4314; /* *pred_broadcastv16di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V16DImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 4436; /* *pred_broadcastv16di_imm */
}

 int
recog_458 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1024BImode)
      && vector_const_0_operand (operands[3], E_V1024SImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return 4309; /* *pred_broadcastv1024si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1024BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1024SImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 4431; /* *pred_broadcastv1024si_imm */
}

 int
recog_464 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V16SImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V16BImode)
      && vector_const_0_operand (operands[3], E_V16SImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return 4303; /* *pred_broadcastv16si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V16BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V16SImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 4425; /* *pred_broadcastv16si_imm */
}

 int
recog_470 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1024BImode)
      && vector_const_0_operand (operands[3], E_V1024HImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return 4297; /* *pred_broadcastv1024hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1024BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1024HImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 4419; /* *pred_broadcastv1024hi_imm */
}

 int
recog_477 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V8HImode, 
E_V8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V8BImode)
      && vector_const_0_operand (operands[3], E_V8HImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return 4290; /* *pred_broadcastv8hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V8HImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
    return -1;
  return 4412; /* *pred_broadcastv8hi_imm */
}

 int
recog_485 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V256QImode, 
E_V256BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V256BImode)
      && vector_const_0_operand (operands[3], E_V256QImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return 4282; /* *pred_broadcastv256qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V256BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V256QImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 4404; /* *pred_broadcastv256qi_imm */
}

 int
recog_493 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V1QImode, 
E_V1BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1BImode)
      && vector_const_0_operand (operands[3], E_V1QImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return 4274; /* *pred_broadcastv1qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1QImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
    return -1;
  return 4396; /* *pred_broadcastv1qi_imm */
}

 int
recog_501 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF8BImode)
      && vector_const_0_operand (operands[3], E_RVVM4SFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 4266; /* *pred_broadcastrvvm4sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM4SFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4388; /* *pred_broadcastrvvm4sf_imm */
}

 int
recog_509 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern716 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4475; /* pred_strided_loadrvvm8qi */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern716 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4476; /* pred_strided_loadrvvm4qi */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern716 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4477; /* pred_strided_loadrvvm2qi */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern716 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4478; /* pred_strided_loadrvvm1qi */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4479; /* pred_strided_loadrvvm8hi */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4480; /* pred_strided_loadrvvm4hi */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4481; /* pred_strided_loadrvvm2hi */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4482; /* pred_strided_loadrvvm1hi */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4483; /* pred_strided_loadrvvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4484; /* pred_strided_loadrvvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4485; /* pred_strided_loadrvvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4486; /* pred_strided_loadrvvm1si */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4487; /* pred_strided_loadrvvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4488; /* pred_strided_loadrvvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4489; /* pred_strided_loadrvvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4490; /* pred_strided_loadrvvm1di */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern716 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 4491; /* pred_strided_loadrvvmf2qi */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern716 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 4492; /* pred_strided_loadrvvmf4qi */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern716 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 4493; /* pred_strided_loadrvvmf8qi */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 4494; /* pred_strided_loadrvvmf2hi */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 4495; /* pred_strided_loadrvvmf4hi */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 4496; /* pred_strided_loadrvvmf2si */

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4497; /* pred_strided_loadrvvm8bf */

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4498; /* pred_strided_loadrvvm4bf */

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4499; /* pred_strided_loadrvvm2bf */

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4500; /* pred_strided_loadrvvm1bf */

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4501; /* pred_strided_loadrvvmf2bf */

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4502; /* pred_strided_loadrvvmf4bf */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4503; /* pred_strided_loadrvvm8hf */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4504; /* pred_strided_loadrvvm4hf */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4505; /* pred_strided_loadrvvm2hf */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4506; /* pred_strided_loadrvvm1hf */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4507; /* pred_strided_loadrvvmf2hf */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4508; /* pred_strided_loadrvvmf4hf */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4509; /* pred_strided_loadrvvm8sf */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4510; /* pred_strided_loadrvvm4sf */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4511; /* pred_strided_loadrvvm2sf */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4512; /* pred_strided_loadrvvm1sf */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4513; /* pred_strided_loadrvvmf2sf */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4514; /* pred_strided_loadrvvm8df */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4515; /* pred_strided_loadrvvm4df */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4516; /* pred_strided_loadrvvm2df */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4517; /* pred_strided_loadrvvm1df */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern716 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 4518; /* pred_strided_loadv1qi */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern716 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 4519; /* pred_strided_loadv2qi */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern716 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 4520; /* pred_strided_loadv4qi */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern716 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 4521; /* pred_strided_loadv8qi */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern716 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 4522; /* pred_strided_loadv16qi */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern716 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 4523; /* pred_strided_loadv32qi */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern716 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4524; /* pred_strided_loadv64qi */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern716 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4525; /* pred_strided_loadv128qi */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern716 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4526; /* pred_strided_loadv256qi */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern716 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4527; /* pred_strided_loadv512qi */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern716 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4528; /* pred_strided_loadv1024qi */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern716 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4529; /* pred_strided_loadv2048qi */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern716 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4530; /* pred_strided_loadv4096qi */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 4531; /* pred_strided_loadv1hi */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 4532; /* pred_strided_loadv2hi */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 4533; /* pred_strided_loadv4hi */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 4534; /* pred_strided_loadv8hi */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 4535; /* pred_strided_loadv16hi */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4536; /* pred_strided_loadv32hi */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4537; /* pred_strided_loadv64hi */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4538; /* pred_strided_loadv128hi */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4539; /* pred_strided_loadv256hi */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4540; /* pred_strided_loadv512hi */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4541; /* pred_strided_loadv1024hi */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4542; /* pred_strided_loadv2048hi */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 4543; /* pred_strided_loadv1si */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 4544; /* pred_strided_loadv2si */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 4545; /* pred_strided_loadv4si */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 4546; /* pred_strided_loadv8si */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4547; /* pred_strided_loadv16si */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4548; /* pred_strided_loadv32si */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4549; /* pred_strided_loadv64si */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4550; /* pred_strided_loadv128si */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4551; /* pred_strided_loadv256si */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4552; /* pred_strided_loadv512si */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4553; /* pred_strided_loadv1024si */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4554; /* pred_strided_loadv1di */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4555; /* pred_strided_loadv2di */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4556; /* pred_strided_loadv4di */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4557; /* pred_strided_loadv8di */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4558; /* pred_strided_loadv16di */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4559; /* pred_strided_loadv32di */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4560; /* pred_strided_loadv64di */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4561; /* pred_strided_loadv128di */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4562; /* pred_strided_loadv256di */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4563; /* pred_strided_loadv512di */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4564; /* pred_strided_loadv1hf */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4565; /* pred_strided_loadv2hf */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4566; /* pred_strided_loadv4hf */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4567; /* pred_strided_loadv8hf */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4568; /* pred_strided_loadv16hf */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4569; /* pred_strided_loadv32hf */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4570; /* pred_strided_loadv64hf */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4571; /* pred_strided_loadv128hf */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4572; /* pred_strided_loadv256hf */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4573; /* pred_strided_loadv512hf */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4574; /* pred_strided_loadv1024hf */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern717 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4575; /* pred_strided_loadv2048hf */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4576; /* pred_strided_loadv1sf */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4577; /* pred_strided_loadv2sf */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4578; /* pred_strided_loadv4sf */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4579; /* pred_strided_loadv8sf */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4580; /* pred_strided_loadv16sf */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4581; /* pred_strided_loadv32sf */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4582; /* pred_strided_loadv64sf */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4583; /* pred_strided_loadv128sf */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4584; /* pred_strided_loadv256sf */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 293 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4585; /* pred_strided_loadv512sf */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern718 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4586; /* pred_strided_loadv1024sf */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4587; /* pred_strided_loadv1df */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4588; /* pred_strided_loadv2df */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 4589; /* pred_strided_loadv4df */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4590; /* pred_strided_loadv8df */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4591; /* pred_strided_loadv16df */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4592; /* pred_strided_loadv32df */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4593; /* pred_strided_loadv64df */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4594; /* pred_strided_loadv128df */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4595; /* pred_strided_loadv256df */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern719 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !(
#line 2388 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4596; /* pred_strided_loadv512df */

    default:
      return -1;
    }
}

 int
recog_602 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern562 (x2))
    {
    case 0:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15032; /* pred_copysignrvvm8hf */

    case 1:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15034; /* pred_copysignrvvm4hf */

    case 2:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15036; /* pred_copysignrvvm2hf */

    case 3:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15038; /* pred_copysignrvvm1hf */

    case 4:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15040; /* pred_copysignrvvmf2hf */

    case 5:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 15042; /* pred_copysignrvvmf4hf */

    case 6:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15044; /* pred_copysignrvvm8sf */

    case 7:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15046; /* pred_copysignrvvm4sf */

    case 8:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15048; /* pred_copysignrvvm2sf */

    case 9:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15050; /* pred_copysignrvvm1sf */

    case 10:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 15052; /* pred_copysignrvvmf2sf */

    case 11:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15054; /* pred_copysignrvvm8df */

    case 12:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15056; /* pred_copysignrvvm4df */

    case 13:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15058; /* pred_copysignrvvm2df */

    case 14:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15060; /* pred_copysignrvvm1df */

    case 15:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 15062; /* pred_copysignv1hf */

    case 16:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 15064; /* pred_copysignv2hf */

    case 17:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 15066; /* pred_copysignv4hf */

    case 18:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 15068; /* pred_copysignv8hf */

    case 19:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 15070; /* pred_copysignv16hf */

    case 20:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15072; /* pred_copysignv32hf */

    case 21:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15074; /* pred_copysignv64hf */

    case 22:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15076; /* pred_copysignv128hf */

    case 23:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15078; /* pred_copysignv256hf */

    case 24:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15080; /* pred_copysignv512hf */

    case 25:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15082; /* pred_copysignv1024hf */

    case 26:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15084; /* pred_copysignv2048hf */

    case 27:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15086; /* pred_copysignv1sf */

    case 28:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15088; /* pred_copysignv2sf */

    case 29:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15090; /* pred_copysignv4sf */

    case 30:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15092; /* pred_copysignv8sf */

    case 31:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15094; /* pred_copysignv16sf */

    case 32:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15096; /* pred_copysignv32sf */

    case 33:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15098; /* pred_copysignv64sf */

    case 34:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15100; /* pred_copysignv128sf */

    case 35:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15102; /* pred_copysignv256sf */

    case 36:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15104; /* pred_copysignv512sf */

    case 37:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15106; /* pred_copysignv1024sf */

    case 38:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15108; /* pred_copysignv1df */

    case 39:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15110; /* pred_copysignv2df */

    case 40:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15112; /* pred_copysignv4df */

    case 41:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15114; /* pred_copysignv8df */

    case 42:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15116; /* pred_copysignv16df */

    case 43:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15118; /* pred_copysignv32df */

    case 44:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15120; /* pred_copysignv64df */

    case 45:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15122; /* pred_copysignv128df */

    case 46:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15124; /* pred_copysignv256df */

    case 47:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15126; /* pred_copysignv512df */

    case 48:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15143; /* pred_copysignrvvm8hf_scalar */

    case 49:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15145; /* pred_copysignrvvm4hf_scalar */

    case 50:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15147; /* pred_copysignrvvm2hf_scalar */

    case 51:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15149; /* pred_copysignrvvm1hf_scalar */

    case 52:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15151; /* pred_copysignrvvmf2hf_scalar */

    case 53:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 15153; /* pred_copysignrvvmf4hf_scalar */

    case 54:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15155; /* pred_copysignrvvm8sf_scalar */

    case 55:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15157; /* pred_copysignrvvm4sf_scalar */

    case 56:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15159; /* pred_copysignrvvm2sf_scalar */

    case 57:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15161; /* pred_copysignrvvm1sf_scalar */

    case 58:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 15163; /* pred_copysignrvvmf2sf_scalar */

    case 59:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15165; /* pred_copysignrvvm8df_scalar */

    case 60:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15167; /* pred_copysignrvvm4df_scalar */

    case 61:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15169; /* pred_copysignrvvm2df_scalar */

    case 62:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15171; /* pred_copysignrvvm1df_scalar */

    case 63:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 15173; /* pred_copysignv1hf_scalar */

    case 64:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 15175; /* pred_copysignv2hf_scalar */

    case 65:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 15177; /* pred_copysignv4hf_scalar */

    case 66:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 15179; /* pred_copysignv8hf_scalar */

    case 67:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 15181; /* pred_copysignv16hf_scalar */

    case 68:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15183; /* pred_copysignv32hf_scalar */

    case 69:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15185; /* pred_copysignv64hf_scalar */

    case 70:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15187; /* pred_copysignv128hf_scalar */

    case 71:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15189; /* pred_copysignv256hf_scalar */

    case 72:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15191; /* pred_copysignv512hf_scalar */

    case 73:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15193; /* pred_copysignv1024hf_scalar */

    case 74:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15195; /* pred_copysignv2048hf_scalar */

    case 75:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15197; /* pred_copysignv1sf_scalar */

    case 76:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15199; /* pred_copysignv2sf_scalar */

    case 77:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15201; /* pred_copysignv4sf_scalar */

    case 78:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15203; /* pred_copysignv8sf_scalar */

    case 79:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15205; /* pred_copysignv16sf_scalar */

    case 80:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15207; /* pred_copysignv32sf_scalar */

    case 81:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15209; /* pred_copysignv64sf_scalar */

    case 82:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15211; /* pred_copysignv128sf_scalar */

    case 83:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15213; /* pred_copysignv256sf_scalar */

    case 84:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15215; /* pred_copysignv512sf_scalar */

    case 85:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15217; /* pred_copysignv1024sf_scalar */

    case 86:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15219; /* pred_copysignv1df_scalar */

    case 87:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15221; /* pred_copysignv2df_scalar */

    case 88:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15223; /* pred_copysignv4df_scalar */

    case 89:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15225; /* pred_copysignv8df_scalar */

    case 90:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15227; /* pred_copysignv16df_scalar */

    case 91:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15229; /* pred_copysignv32df_scalar */

    case 92:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15231; /* pred_copysignv64df_scalar */

    case 93:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15233; /* pred_copysignv128df_scalar */

    case 94:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15235; /* pred_copysignv256df_scalar */

    case 95:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15237; /* pred_copysignv512df_scalar */

    default:
      return -1;
    }
}

 int
recog_640 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V512QImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V512QImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V512QImode)
      || !(
#line 5331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13112; /* *pred_mul_plusv512qi_undef */
}

 int
recog_645 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V2HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V2HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V2HImode)
      || !(
#line 5331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return -1;
  return 13117; /* *pred_mul_plusv2hi_undef */
}

 int
recog_650 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V64HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V64HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V64HImode)
      || !(
#line 5331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13122; /* *pred_mul_plusv64hi_undef */
}

 int
recog_655 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V2048HImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V2048HImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V2048HImode)
      || !(
#line 5331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13127; /* *pred_mul_plusv2048hi_undef */
}

 int
recog_660 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V16SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V16SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V16SImode)
      || !(
#line 5331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13132; /* *pred_mul_plusv16si_undef */
}

 int
recog_666 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V1024SImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V1024SImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V1024SImode)
      || !(
#line 5331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13138; /* *pred_mul_plusv1024si_undef */
}

 int
recog_672 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!register_operand (operands[4], E_V32DImode))
    return -1;
  x11 = XEXP (x8, 1);
  operands[5] = x11;
  if (!register_operand (operands[5], E_V32DImode))
    return -1;
  x12 = XEXP (x2, 2);
  operands[2] = x12;
  if (!vector_undef_operand (operands[2], E_V32DImode)
      || !(
#line 5331 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13144; /* *pred_mul_plusv32di_undef */
}

 int
recog_678 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_675 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V256DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return 13215; /* *pred_maddv256di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13283; /* *pred_maccv256di */
}

 int
recog_684 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_669 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V4DImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 13209; /* *pred_maddv4di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13277; /* *pred_maccv4di */
}

 int
recog_690 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V128SImode, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_663 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V128SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return 13203; /* *pred_maddv128si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13271; /* *pred_maccv128si */
}

 int
recog_698 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_655 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V2048HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2048HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return 13195; /* *pred_maddv2048hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13263; /* *pred_maccv2048hi */
}

 int
recog_705 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V16HImode, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_648 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V16HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return 13188; /* *pred_maddv16hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return -1;
  return 13256; /* *pred_maccv16hi */
}

 int
recog_712 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_641 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V1024QImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1024QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
    return 13181; /* *pred_maddv1024qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13249; /* *pred_maccv1024qi */
}

 int
recog_719 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V128DImode, 
E_V128BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return 13350; /* *pred_maddv128di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13418; /* *pred_maccv128di_scalar */
}

 int
recog_726 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V1DImode, 
E_V1BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 13343; /* *pred_maddv1di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13411; /* *pred_maccv1di_scalar */
}

 int
recog_732 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return 13337; /* *pred_maddv32si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13405; /* *pred_maccv32si_scalar */
}

 int
recog_740 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return 13329; /* *pred_maddv512hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13397; /* *pred_maccv512hi_scalar */
}

 int
recog_747 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  x7 = XEXP (x4, 1);
  switch (GET_CODE (x7))
    {
    case SIGN_EXTEND:
      switch (pattern703 (x2))
        {
        case 0:
          if (!
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13817; /* pred_widen_mul_plussrvvm8hi */

        case 1:
          if (!
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13819; /* pred_widen_mul_plussrvvm4hi */

        case 2:
          if (!
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13821; /* pred_widen_mul_plussrvvm2hi */

        case 3:
          if (!
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13823; /* pred_widen_mul_plussrvvm1hi */

        case 4:
          if (!
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13825; /* pred_widen_mul_plussrvvmf2hi */

        case 5:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13827; /* pred_widen_mul_plussrvvmf4hi */

        case 6:
          if (!
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13829; /* pred_widen_mul_plussrvvm8si */

        case 7:
          if (!
#line 41 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 32547; /* pred_matrix_mul_plusrvvm8si_qoq */

        case 8:
          if (!
#line 113 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 32563; /* pred_matrix_mul_plusrvvm8si_dod */

        case 9:
          if (!
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13831; /* pred_widen_mul_plussrvvm4si */

        case 10:
          if (!
#line 41 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 32549; /* pred_matrix_mul_plusrvvm4si_qoq */

        case 11:
          if (!
#line 113 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 32565; /* pred_matrix_mul_plusrvvm4si_dod */

        case 12:
          if (!
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13833; /* pred_widen_mul_plussrvvm2si */

        case 13:
          if (!
#line 41 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 32551; /* pred_matrix_mul_plusrvvm2si_qoq */

        case 14:
          if (!
#line 113 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 32567; /* pred_matrix_mul_plusrvvm2si_dod */

        case 15:
          if (!
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 13835; /* pred_widen_mul_plussrvvm1si */

        case 16:
          if (!
#line 41 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 32553; /* pred_matrix_mul_plusrvvm1si_qoq */

        case 17:
          if (!
#line 113 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 32569; /* pred_matrix_mul_plusrvvm1si_dod */

        case 18:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13837; /* pred_widen_mul_plussrvvmf2si */

        case 19:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13839; /* pred_widen_mul_plussrvvm8di */

        case 20:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13841; /* pred_widen_mul_plussrvvm4di */

        case 21:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13843; /* pred_widen_mul_plussrvvm2di */

        case 22:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13845; /* pred_widen_mul_plussrvvm1di */

        case 23:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 13847; /* pred_widen_mul_plussv1hi */

        case 24:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 13849; /* pred_widen_mul_plussv2hi */

        case 25:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 13851; /* pred_widen_mul_plussv4hi */

        case 26:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 13853; /* pred_widen_mul_plussv8hi */

        case 27:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 13855; /* pred_widen_mul_plussv16hi */

        case 28:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 13857; /* pred_widen_mul_plussv32hi */

        case 29:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 13859; /* pred_widen_mul_plussv64hi */

        case 30:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 13861; /* pred_widen_mul_plussv128hi */

        case 31:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 13863; /* pred_widen_mul_plussv256hi */

        case 32:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 13865; /* pred_widen_mul_plussv512hi */

        case 33:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 13867; /* pred_widen_mul_plussv1024hi */

        case 34:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 13869; /* pred_widen_mul_plussv2048hi */

        case 35:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 13871; /* pred_widen_mul_plussv1si */

        case 36:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 13873; /* pred_widen_mul_plussv2si */

        case 37:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 13875; /* pred_widen_mul_plussv4si */

        case 38:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 13877; /* pred_widen_mul_plussv8si */

        case 39:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 13879; /* pred_widen_mul_plussv16si */

        case 40:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 13881; /* pred_widen_mul_plussv32si */

        case 41:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 13883; /* pred_widen_mul_plussv64si */

        case 42:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 13885; /* pred_widen_mul_plussv128si */

        case 43:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 13887; /* pred_widen_mul_plussv256si */

        case 44:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 13889; /* pred_widen_mul_plussv512si */

        case 45:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 13891; /* pred_widen_mul_plussv1024si */

        case 46:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13893; /* pred_widen_mul_plussv1di */

        case 47:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13895; /* pred_widen_mul_plussv2di */

        case 48:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13897; /* pred_widen_mul_plussv4di */

        case 49:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 13899; /* pred_widen_mul_plussv8di */

        case 50:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 13901; /* pred_widen_mul_plussv16di */

        case 51:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 13903; /* pred_widen_mul_plussv32di */

        case 52:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 13905; /* pred_widen_mul_plussv64di */

        case 53:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 13907; /* pred_widen_mul_plussv128di */

        case 54:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 13909; /* pred_widen_mul_plussv256di */

        case 55:
          if (!(
#line 5884 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 13911; /* pred_widen_mul_plussv512di */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern703 (x2))
        {
        case 0:
          if (!
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14009; /* pred_widen_mul_plussurvvm8hi */

        case 1:
          if (!
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14010; /* pred_widen_mul_plussurvvm4hi */

        case 2:
          if (!
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14011; /* pred_widen_mul_plussurvvm2hi */

        case 3:
          if (!
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14012; /* pred_widen_mul_plussurvvm1hi */

        case 4:
          if (!
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14013; /* pred_widen_mul_plussurvvmf2hi */

        case 5:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14014; /* pred_widen_mul_plussurvvmf4hi */

        case 6:
          if (!
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14015; /* pred_widen_mul_plussurvvm8si */

        case 7:
          if (!
#line 65 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 32555; /* pred_matrix_mul_plussurvvm8si_qoq */

        case 8:
          if (!
#line 137 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 32571; /* pred_matrix_mul_plussurvvm8si_dod */

        case 9:
          if (!
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14016; /* pred_widen_mul_plussurvvm4si */

        case 10:
          if (!
#line 65 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 32556; /* pred_matrix_mul_plussurvvm4si_qoq */

        case 11:
          if (!
#line 137 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 32572; /* pred_matrix_mul_plussurvvm4si_dod */

        case 12:
          if (!
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14017; /* pred_widen_mul_plussurvvm2si */

        case 13:
          if (!
#line 65 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 32557; /* pred_matrix_mul_plussurvvm2si_qoq */

        case 14:
          if (!
#line 137 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 32573; /* pred_matrix_mul_plussurvvm2si_dod */

        case 15:
          if (!
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14018; /* pred_widen_mul_plussurvvm1si */

        case 16:
          if (!
#line 65 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCQOQ))
            return -1;
          return 32558; /* pred_matrix_mul_plussurvvm1si_qoq */

        case 17:
          if (!
#line 137 "../../gcc/config/riscv/sifive-vector.md"
(TARGET_VECTOR && TARGET_XSFVQMACCDOD))
            return -1;
          return 32574; /* pred_matrix_mul_plussurvvm1si_dod */

        case 18:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14019; /* pred_widen_mul_plussurvvmf2si */

        case 19:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14020; /* pred_widen_mul_plussurvvm8di */

        case 20:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14021; /* pred_widen_mul_plussurvvm4di */

        case 21:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14022; /* pred_widen_mul_plussurvvm2di */

        case 22:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14023; /* pred_widen_mul_plussurvvm1di */

        case 23:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 14024; /* pred_widen_mul_plussuv1hi */

        case 24:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 14025; /* pred_widen_mul_plussuv2hi */

        case 25:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 14026; /* pred_widen_mul_plussuv4hi */

        case 26:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 14027; /* pred_widen_mul_plussuv8hi */

        case 27:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 14028; /* pred_widen_mul_plussuv16hi */

        case 28:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14029; /* pred_widen_mul_plussuv32hi */

        case 29:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14030; /* pred_widen_mul_plussuv64hi */

        case 30:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14031; /* pred_widen_mul_plussuv128hi */

        case 31:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14032; /* pred_widen_mul_plussuv256hi */

        case 32:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14033; /* pred_widen_mul_plussuv512hi */

        case 33:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14034; /* pred_widen_mul_plussuv1024hi */

        case 34:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14035; /* pred_widen_mul_plussuv2048hi */

        case 35:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 14036; /* pred_widen_mul_plussuv1si */

        case 36:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 14037; /* pred_widen_mul_plussuv2si */

        case 37:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 14038; /* pred_widen_mul_plussuv4si */

        case 38:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 14039; /* pred_widen_mul_plussuv8si */

        case 39:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14040; /* pred_widen_mul_plussuv16si */

        case 40:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14041; /* pred_widen_mul_plussuv32si */

        case 41:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14042; /* pred_widen_mul_plussuv64si */

        case 42:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14043; /* pred_widen_mul_plussuv128si */

        case 43:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14044; /* pred_widen_mul_plussuv256si */

        case 44:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14045; /* pred_widen_mul_plussuv512si */

        case 45:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14046; /* pred_widen_mul_plussuv1024si */

        case 46:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14047; /* pred_widen_mul_plussuv1di */

        case 47:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14048; /* pred_widen_mul_plussuv2di */

        case 48:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14049; /* pred_widen_mul_plussuv4di */

        case 49:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14050; /* pred_widen_mul_plussuv8di */

        case 50:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14051; /* pred_widen_mul_plussuv16di */

        case 51:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14052; /* pred_widen_mul_plussuv32di */

        case 52:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14053; /* pred_widen_mul_plussuv64di */

        case 53:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14054; /* pred_widen_mul_plussuv128di */

        case 54:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14055; /* pred_widen_mul_plussuv256di */

        case 55:
          if (!(
#line 5933 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14056; /* pred_widen_mul_plussuv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_755 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V512DImode, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V512DImode) == 0
      && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 13516; /* *pred_minus_mulv512di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V512DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V512DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 13584; /* *pred_nmsubv512di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 13652; /* *pred_nmsacv512di */
}

 int
recog_756 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V256DImode) == 0
      && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return 13515; /* *pred_minus_mulv256di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V256DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V256DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return 13583; /* *pred_nmsubv256di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13651; /* *pred_nmsacv256di */
}

 int
recog_757 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V128DImode) == 0
      && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return 13514; /* *pred_minus_mulv128di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V128DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V128DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return 13582; /* *pred_nmsubv128di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13650; /* *pred_nmsacv128di */
}

 int
recog_758 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V64DImode) == 0
      && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 13513; /* *pred_minus_mulv64di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V64DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V64DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return 13581; /* *pred_nmsubv64di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13649; /* *pred_nmsacv64di */
}

 int
recog_759 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V32DImode) == 0
      && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 13512; /* *pred_minus_mulv32di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V32DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V32DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V32DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return 13580; /* *pred_nmsubv32di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13648; /* *pred_nmsacv32di */
}

 int
recog_760 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V16DImode) == 0
      && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 13511; /* *pred_minus_mulv16di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V16DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V16DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 13579; /* *pred_nmsubv16di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13647; /* *pred_nmsacv16di */
}

 int
recog_762 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V4DImode) == 0
      && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 13509; /* *pred_minus_mulv4di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V4DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V4DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 13577; /* *pred_nmsubv4di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13645; /* *pred_nmsacv4di */
}

 int
recog_764 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V1DImode) == 0
      && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 13507; /* *pred_minus_mulv1di_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V1DImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V1DImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1DImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return 13575; /* *pred_nmsubv1di */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13643; /* *pred_nmsacv1di */
}

 int
recog_766 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V512SImode, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V512SImode) == 0
      && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 13505; /* *pred_minus_mulv512si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V512SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V512SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 13573; /* *pred_nmsubv512si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13641; /* *pred_nmsacv512si */
}

 int
recog_769 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V64SImode, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V64SImode) == 0
      && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 13502; /* *pred_minus_mulv64si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V64SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V64SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 13570; /* *pred_nmsubv64si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13638; /* *pred_nmsacv64si */
}

 int
recog_773 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V4SImode, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V4SImode) == 0
      && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 13498; /* *pred_minus_mulv4si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V4SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V4SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return 13566; /* *pred_nmsubv4si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
    return -1;
  return 13634; /* *pred_nmsacv4si */
}

 int
recog_779 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V256HImode) == 0
      && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 13492; /* *pred_minus_mulv256hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V256HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V256HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 13560; /* *pred_nmsubv256hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13628; /* *pred_nmsacv256hi */
}

 int
recog_785 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V4HImode, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V4HImode) == 0
      && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 13486; /* *pred_minus_mulv4hi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V4HImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 13554; /* *pred_nmsubv4hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return -1;
  return 13622; /* *pred_nmsacv4hi */
}

 int
recog_793 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V128QImode, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V128QImode) == 0
      && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return 13478; /* *pred_minus_mulv128qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V128QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V128QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return 13546; /* *pred_nmsubv128qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13614; /* *pred_nmsacv128qi */
}

 int
recog_801 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_RVVMF2SImode) == 0
      && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return 13470; /* *pred_minus_mulrvvmf2si_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_RVVMF2SImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_RVVMF2SImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF2SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return 13538; /* *pred_nmsubrvvmf2si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return -1;
  return 13606; /* *pred_nmsacrvvmf2si */
}

 int
recog_810 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V8DImode, 
E_V8BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return 13714; /* *pred_nmsubv8di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 13782; /* *pred_nmsacv8di_scalar */
}

 int
recog_819 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return 13705; /* *pred_nmsubv32si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13773; /* *pred_nmsacv32si_scalar */
}

 int
recog_827 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return 13697; /* *pred_nmsubv512hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13765; /* *pred_nmsacv512hi_scalar */
}

 int
recog_835 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  x11 = XEXP (x8, 1);
  x12 = XEXP (x11, 0);
  switch (GET_CODE (x12))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      switch (pattern501 (x2))
        {
        case 0:
          if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7343; /* pred_subrvvm8qi_scalar */

        case 1:
          if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7348; /* pred_subrvvm4qi_scalar */

        case 2:
          if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7353; /* pred_subrvvm2qi_scalar */

        case 3:
          if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7358; /* pred_subrvvm1qi_scalar */

        case 4:
          if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7363; /* pred_subrvvmf2qi_scalar */

        case 5:
          if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7368; /* pred_subrvvmf4qi_scalar */

        case 6:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 7373; /* pred_subrvvmf8qi_scalar */

        case 7:
          if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7378; /* pred_subrvvm8hi_scalar */

        case 8:
          if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7383; /* pred_subrvvm4hi_scalar */

        case 9:
          if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7388; /* pred_subrvvm2hi_scalar */

        case 10:
          if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7393; /* pred_subrvvm1hi_scalar */

        case 11:
          if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7398; /* pred_subrvvmf2hi_scalar */

        case 12:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 7403; /* pred_subrvvmf4hi_scalar */

        case 13:
          if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7408; /* pred_subrvvm8si_scalar */

        case 14:
          if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7413; /* pred_subrvvm4si_scalar */

        case 15:
          if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7418; /* pred_subrvvm2si_scalar */

        case 16:
          if (!
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 7423; /* pred_subrvvm1si_scalar */

        case 17:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 7428; /* pred_subrvvmf2si_scalar */

        case 18:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 7433; /* pred_subv1qi_scalar */

        case 19:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 7438; /* pred_subv2qi_scalar */

        case 20:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 7443; /* pred_subv4qi_scalar */

        case 21:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 7448; /* pred_subv8qi_scalar */

        case 22:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 7453; /* pred_subv16qi_scalar */

        case 23:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 7458; /* pred_subv32qi_scalar */

        case 24:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 7463; /* pred_subv64qi_scalar */

        case 25:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 7468; /* pred_subv128qi_scalar */

        case 26:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 7473; /* pred_subv256qi_scalar */

        case 27:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 7478; /* pred_subv512qi_scalar */

        case 28:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 7483; /* pred_subv1024qi_scalar */

        case 29:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 7488; /* pred_subv2048qi_scalar */

        case 30:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 7493; /* pred_subv4096qi_scalar */

        case 31:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 7498; /* pred_subv1hi_scalar */

        case 32:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 7503; /* pred_subv2hi_scalar */

        case 33:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 7508; /* pred_subv4hi_scalar */

        case 34:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 7513; /* pred_subv8hi_scalar */

        case 35:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 7518; /* pred_subv16hi_scalar */

        case 36:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 7523; /* pred_subv32hi_scalar */

        case 37:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 7528; /* pred_subv64hi_scalar */

        case 38:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 7533; /* pred_subv128hi_scalar */

        case 39:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 7538; /* pred_subv256hi_scalar */

        case 40:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 7543; /* pred_subv512hi_scalar */

        case 41:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 7548; /* pred_subv1024hi_scalar */

        case 42:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 7553; /* pred_subv2048hi_scalar */

        case 43:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 7558; /* pred_subv1si_scalar */

        case 44:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 7563; /* pred_subv2si_scalar */

        case 45:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 7568; /* pred_subv4si_scalar */

        case 46:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 7573; /* pred_subv8si_scalar */

        case 47:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 7578; /* pred_subv16si_scalar */

        case 48:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 7583; /* pred_subv32si_scalar */

        case 49:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 7588; /* pred_subv64si_scalar */

        case 50:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 7593; /* pred_subv128si_scalar */

        case 51:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 7598; /* pred_subv256si_scalar */

        case 52:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 7603; /* pred_subv512si_scalar */

        case 53:
          if (!(
#line 2802 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 7608; /* pred_subv1024si_scalar */

        case 54:
          if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 7919; /* *pred_subrvvm8di_scalar */

        case 55:
          if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 7924; /* *pred_subrvvm4di_scalar */

        case 56:
          if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 7929; /* *pred_subrvvm2di_scalar */

        case 57:
          if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 7934; /* *pred_subrvvm1di_scalar */

        case 58:
          if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 7939; /* *pred_subv1di_scalar */

        case 59:
          if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 7944; /* *pred_subv2di_scalar */

        case 60:
          if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 7949; /* *pred_subv4di_scalar */

        case 61:
          if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 7954; /* *pred_subv8di_scalar */

        case 62:
          if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 7959; /* *pred_subv16di_scalar */

        case 63:
          if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 7964; /* *pred_subv32di_scalar */

        case 64:
          if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 7969; /* *pred_subv64di_scalar */

        case 65:
          if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 7974; /* *pred_subv128di_scalar */

        case 66:
          if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 7979; /* *pred_subv256di_scalar */

        case 67:
          if (!(
#line 2955 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 7984; /* *pred_subv512di_scalar */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_754 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      x13 = XEXP (x12, 0);
      operands[4] = x13;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern543 (x2, 
E_RVVM8HImode, 
E_HImode, 
E_RVVMF2BImode, 
E_QImode) != 0
              || !
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10358; /* pred_single_widen_suburvvm8hi_extended_scalar */

        case E_RVVM4HImode:
          if (pattern543 (x2, 
E_RVVM4HImode, 
E_HImode, 
E_RVVMF4BImode, 
E_QImode) != 0
              || !
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10360; /* pred_single_widen_suburvvm4hi_extended_scalar */

        case E_RVVM2HImode:
          if (pattern543 (x2, 
E_RVVM2HImode, 
E_HImode, 
E_RVVMF8BImode, 
E_QImode) != 0
              || !
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10362; /* pred_single_widen_suburvvm2hi_extended_scalar */

        case E_RVVM1HImode:
          if (pattern543 (x2, 
E_RVVM1HImode, 
E_HImode, 
E_RVVMF16BImode, 
E_QImode) != 0
              || !
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10364; /* pred_single_widen_suburvvm1hi_extended_scalar */

        case E_RVVMF2HImode:
          if (pattern543 (x2, 
E_RVVMF2HImode, 
E_HImode, 
E_RVVMF32BImode, 
E_QImode) != 0
              || !
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10366; /* pred_single_widen_suburvvmf2hi_extended_scalar */

        case E_RVVMF4HImode:
          if (pattern543 (x2, 
E_RVVMF4HImode, 
E_HImode, 
E_RVVMF64BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10368; /* pred_single_widen_suburvvmf4hi_extended_scalar */

        case E_RVVM8SImode:
          if (pattern543 (x2, 
E_RVVM8SImode, 
E_SImode, 
E_RVVMF4BImode, 
E_HImode) != 0
              || !
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10370; /* pred_single_widen_suburvvm8si_extended_scalar */

        case E_RVVM4SImode:
          if (pattern543 (x2, 
E_RVVM4SImode, 
E_SImode, 
E_RVVMF8BImode, 
E_HImode) != 0
              || !
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10372; /* pred_single_widen_suburvvm4si_extended_scalar */

        case E_RVVM2SImode:
          if (pattern543 (x2, 
E_RVVM2SImode, 
E_SImode, 
E_RVVMF16BImode, 
E_HImode) != 0
              || !
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10374; /* pred_single_widen_suburvvm2si_extended_scalar */

        case E_RVVM1SImode:
          if (pattern543 (x2, 
E_RVVM1SImode, 
E_SImode, 
E_RVVMF32BImode, 
E_HImode) != 0
              || !
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10376; /* pred_single_widen_suburvvm1si_extended_scalar */

        case E_RVVMF2SImode:
          if (pattern543 (x2, 
E_RVVMF2SImode, 
E_SImode, 
E_RVVMF64BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10378; /* pred_single_widen_suburvvmf2si_extended_scalar */

        case E_RVVM8DImode:
          if (pattern543 (x2, 
E_RVVM8DImode, 
E_DImode, 
E_RVVMF8BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10380; /* pred_single_widen_suburvvm8di_extended_scalar */

        case E_RVVM4DImode:
          if (pattern543 (x2, 
E_RVVM4DImode, 
E_DImode, 
E_RVVMF16BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10382; /* pred_single_widen_suburvvm4di_extended_scalar */

        case E_RVVM2DImode:
          if (pattern543 (x2, 
E_RVVM2DImode, 
E_DImode, 
E_RVVMF32BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10384; /* pred_single_widen_suburvvm2di_extended_scalar */

        case E_RVVM1DImode:
          if (pattern543 (x2, 
E_RVVM1DImode, 
E_DImode, 
E_RVVMF64BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10386; /* pred_single_widen_suburvvm1di_extended_scalar */

        case E_V1HImode:
          if (pattern543 (x2, 
E_V1HImode, 
E_HImode, 
E_V1BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10388; /* pred_single_widen_subuv1hi_extended_scalar */

        case E_V2HImode:
          if (pattern543 (x2, 
E_V2HImode, 
E_HImode, 
E_V2BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10390; /* pred_single_widen_subuv2hi_extended_scalar */

        case E_V4HImode:
          if (pattern543 (x2, 
E_V4HImode, 
E_HImode, 
E_V4BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10392; /* pred_single_widen_subuv4hi_extended_scalar */

        case E_V8HImode:
          if (pattern543 (x2, 
E_V8HImode, 
E_HImode, 
E_V8BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10394; /* pred_single_widen_subuv8hi_extended_scalar */

        case E_V16HImode:
          if (pattern543 (x2, 
E_V16HImode, 
E_HImode, 
E_V16BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10396; /* pred_single_widen_subuv16hi_extended_scalar */

        case E_V32HImode:
          if (pattern543 (x2, 
E_V32HImode, 
E_HImode, 
E_V32BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10398; /* pred_single_widen_subuv32hi_extended_scalar */

        case E_V64HImode:
          if (pattern543 (x2, 
E_V64HImode, 
E_HImode, 
E_V64BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10400; /* pred_single_widen_subuv64hi_extended_scalar */

        case E_V128HImode:
          if (pattern543 (x2, 
E_V128HImode, 
E_HImode, 
E_V128BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10402; /* pred_single_widen_subuv128hi_extended_scalar */

        case E_V256HImode:
          if (pattern543 (x2, 
E_V256HImode, 
E_HImode, 
E_V256BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10404; /* pred_single_widen_subuv256hi_extended_scalar */

        case E_V512HImode:
          if (pattern543 (x2, 
E_V512HImode, 
E_HImode, 
E_V512BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10406; /* pred_single_widen_subuv512hi_extended_scalar */

        case E_V1024HImode:
          if (pattern543 (x2, 
E_V1024HImode, 
E_HImode, 
E_V1024BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10408; /* pred_single_widen_subuv1024hi_extended_scalar */

        case E_V2048HImode:
          if (pattern543 (x2, 
E_V2048HImode, 
E_HImode, 
E_V2048BImode, 
E_QImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10410; /* pred_single_widen_subuv2048hi_extended_scalar */

        case E_V1SImode:
          if (pattern543 (x2, 
E_V1SImode, 
E_SImode, 
E_V1BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10412; /* pred_single_widen_subuv1si_extended_scalar */

        case E_V2SImode:
          if (pattern543 (x2, 
E_V2SImode, 
E_SImode, 
E_V2BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10414; /* pred_single_widen_subuv2si_extended_scalar */

        case E_V4SImode:
          if (pattern543 (x2, 
E_V4SImode, 
E_SImode, 
E_V4BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10416; /* pred_single_widen_subuv4si_extended_scalar */

        case E_V8SImode:
          if (pattern543 (x2, 
E_V8SImode, 
E_SImode, 
E_V8BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10418; /* pred_single_widen_subuv8si_extended_scalar */

        case E_V16SImode:
          if (pattern543 (x2, 
E_V16SImode, 
E_SImode, 
E_V16BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10420; /* pred_single_widen_subuv16si_extended_scalar */

        case E_V32SImode:
          if (pattern543 (x2, 
E_V32SImode, 
E_SImode, 
E_V32BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10422; /* pred_single_widen_subuv32si_extended_scalar */

        case E_V64SImode:
          if (pattern543 (x2, 
E_V64SImode, 
E_SImode, 
E_V64BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10424; /* pred_single_widen_subuv64si_extended_scalar */

        case E_V128SImode:
          if (pattern543 (x2, 
E_V128SImode, 
E_SImode, 
E_V128BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10426; /* pred_single_widen_subuv128si_extended_scalar */

        case E_V256SImode:
          if (pattern543 (x2, 
E_V256SImode, 
E_SImode, 
E_V256BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10428; /* pred_single_widen_subuv256si_extended_scalar */

        case E_V512SImode:
          if (pattern543 (x2, 
E_V512SImode, 
E_SImode, 
E_V512BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10430; /* pred_single_widen_subuv512si_extended_scalar */

        case E_V1024SImode:
          if (pattern543 (x2, 
E_V1024SImode, 
E_SImode, 
E_V1024BImode, 
E_HImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10432; /* pred_single_widen_subuv1024si_extended_scalar */

        case E_V1DImode:
          if (pattern543 (x2, 
E_V1DImode, 
E_DImode, 
E_V1BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10434; /* pred_single_widen_subuv1di_extended_scalar */

        case E_V2DImode:
          if (pattern543 (x2, 
E_V2DImode, 
E_DImode, 
E_V2BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10436; /* pred_single_widen_subuv2di_extended_scalar */

        case E_V4DImode:
          if (pattern543 (x2, 
E_V4DImode, 
E_DImode, 
E_V4BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10438; /* pred_single_widen_subuv4di_extended_scalar */

        case E_V8DImode:
          if (pattern543 (x2, 
E_V8DImode, 
E_DImode, 
E_V8BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10440; /* pred_single_widen_subuv8di_extended_scalar */

        case E_V16DImode:
          if (pattern543 (x2, 
E_V16DImode, 
E_DImode, 
E_V16BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10442; /* pred_single_widen_subuv16di_extended_scalar */

        case E_V32DImode:
          if (pattern543 (x2, 
E_V32DImode, 
E_DImode, 
E_V32BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10444; /* pred_single_widen_subuv32di_extended_scalar */

        case E_V64DImode:
          if (pattern543 (x2, 
E_V64DImode, 
E_DImode, 
E_V64BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10446; /* pred_single_widen_subuv64di_extended_scalar */

        case E_V128DImode:
          if (pattern543 (x2, 
E_V128DImode, 
E_DImode, 
E_V128BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10448; /* pred_single_widen_subuv128di_extended_scalar */

        case E_V256DImode:
          if (pattern543 (x2, 
E_V256DImode, 
E_DImode, 
E_V256BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10450; /* pred_single_widen_subuv256di_extended_scalar */

        case E_V512DImode:
          if (pattern543 (x2, 
E_V512DImode, 
E_DImode, 
E_V512BImode, 
E_SImode) != 0
              || !(
#line 4137 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10452; /* pred_single_widen_subuv512di_extended_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_885 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern547 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[4], E_RVVM4QImode)
          && 
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10645; /* pred_narrow_ashrrvvm8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10741; /* pred_narrow_ashrrvvm8hi_scalar */

    case 1:
      if (vector_shift_operand (operands[4], E_RVVM2QImode)
          && 
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10647; /* pred_narrow_ashrrvvm4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10743; /* pred_narrow_ashrrvvm4hi_scalar */

    case 2:
      if (vector_shift_operand (operands[4], E_RVVM1QImode)
          && 
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10649; /* pred_narrow_ashrrvvm2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10745; /* pred_narrow_ashrrvvm2hi_scalar */

    case 3:
      if (vector_shift_operand (operands[4], E_RVVMF2QImode)
          && 
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10651; /* pred_narrow_ashrrvvm1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10747; /* pred_narrow_ashrrvvm1hi_scalar */

    case 4:
      if (vector_shift_operand (operands[4], E_RVVMF4QImode)
          && 
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10653; /* pred_narrow_ashrrvvmf2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10749; /* pred_narrow_ashrrvvmf2hi_scalar */

    case 5:
      if (vector_shift_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 10655; /* pred_narrow_ashrrvvmf4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10751; /* pred_narrow_ashrrvvmf4hi_scalar */

    case 6:
      if (vector_shift_operand (operands[4], E_RVVM4HImode)
          && 
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10657; /* pred_narrow_ashrrvvm8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10753; /* pred_narrow_ashrrvvm8si_scalar */

    case 7:
      if (vector_shift_operand (operands[4], E_RVVM2HImode)
          && 
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10659; /* pred_narrow_ashrrvvm4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10755; /* pred_narrow_ashrrvvm4si_scalar */

    case 8:
      if (vector_shift_operand (operands[4], E_RVVM1HImode)
          && 
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10661; /* pred_narrow_ashrrvvm2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10757; /* pred_narrow_ashrrvvm2si_scalar */

    case 9:
      if (vector_shift_operand (operands[4], E_RVVMF2HImode)
          && 
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 10663; /* pred_narrow_ashrrvvm1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10759; /* pred_narrow_ashrrvvm1si_scalar */

    case 10:
      if (vector_shift_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 10665; /* pred_narrow_ashrrvvmf2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10761; /* pred_narrow_ashrrvvmf2si_scalar */

    case 11:
      if (vector_shift_operand (operands[4], E_RVVM4SImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 10667; /* pred_narrow_ashrrvvm8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10763; /* pred_narrow_ashrrvvm8di_scalar */

    case 12:
      if (vector_shift_operand (operands[4], E_RVVM2SImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 10669; /* pred_narrow_ashrrvvm4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10765; /* pred_narrow_ashrrvvm4di_scalar */

    case 13:
      if (vector_shift_operand (operands[4], E_RVVM1SImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 10671; /* pred_narrow_ashrrvvm2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10767; /* pred_narrow_ashrrvvm2di_scalar */

    case 14:
      if (vector_shift_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 10673; /* pred_narrow_ashrrvvm1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10769; /* pred_narrow_ashrrvvm1di_scalar */

    case 15:
      if (vector_shift_operand (operands[4], E_V1QImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 10675; /* pred_narrow_ashrv1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 10771; /* pred_narrow_ashrv1hi_scalar */

    case 16:
      if (vector_shift_operand (operands[4], E_V2QImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 10677; /* pred_narrow_ashrv2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 10773; /* pred_narrow_ashrv2hi_scalar */

    case 17:
      if (vector_shift_operand (operands[4], E_V4QImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 10679; /* pred_narrow_ashrv4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 10775; /* pred_narrow_ashrv4hi_scalar */

    case 18:
      if (vector_shift_operand (operands[4], E_V8QImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 10681; /* pred_narrow_ashrv8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 10777; /* pred_narrow_ashrv8hi_scalar */

    case 19:
      if (vector_shift_operand (operands[4], E_V16QImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 10683; /* pred_narrow_ashrv16hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 10779; /* pred_narrow_ashrv16hi_scalar */

    case 20:
      if (vector_shift_operand (operands[4], E_V32QImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 10685; /* pred_narrow_ashrv32hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10781; /* pred_narrow_ashrv32hi_scalar */

    case 21:
      if (vector_shift_operand (operands[4], E_V64QImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 10687; /* pred_narrow_ashrv64hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 10783; /* pred_narrow_ashrv64hi_scalar */

    case 22:
      if (vector_shift_operand (operands[4], E_V128QImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 10689; /* pred_narrow_ashrv128hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 10785; /* pred_narrow_ashrv128hi_scalar */

    case 23:
      if (vector_shift_operand (operands[4], E_V256QImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 10691; /* pred_narrow_ashrv256hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 10787; /* pred_narrow_ashrv256hi_scalar */

    case 24:
      if (vector_shift_operand (operands[4], E_V512QImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 10693; /* pred_narrow_ashrv512hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 10789; /* pred_narrow_ashrv512hi_scalar */

    case 25:
      if (vector_shift_operand (operands[4], E_V1024QImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 10695; /* pred_narrow_ashrv1024hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 10791; /* pred_narrow_ashrv1024hi_scalar */

    case 26:
      if (vector_shift_operand (operands[4], E_V2048QImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 10697; /* pred_narrow_ashrv2048hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 10793; /* pred_narrow_ashrv2048hi_scalar */

    case 27:
      if (vector_shift_operand (operands[4], E_V1HImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 10699; /* pred_narrow_ashrv1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 10795; /* pred_narrow_ashrv1si_scalar */

    case 28:
      if (vector_shift_operand (operands[4], E_V2HImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 10701; /* pred_narrow_ashrv2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 10797; /* pred_narrow_ashrv2si_scalar */

    case 29:
      if (vector_shift_operand (operands[4], E_V4HImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 10703; /* pred_narrow_ashrv4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 10799; /* pred_narrow_ashrv4si_scalar */

    case 30:
      if (vector_shift_operand (operands[4], E_V8HImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 10705; /* pred_narrow_ashrv8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 10801; /* pred_narrow_ashrv8si_scalar */

    case 31:
      if (vector_shift_operand (operands[4], E_V16HImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 10707; /* pred_narrow_ashrv16si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10803; /* pred_narrow_ashrv16si_scalar */

    case 32:
      if (vector_shift_operand (operands[4], E_V32HImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 10709; /* pred_narrow_ashrv32si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 10805; /* pred_narrow_ashrv32si_scalar */

    case 33:
      if (vector_shift_operand (operands[4], E_V64HImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 10711; /* pred_narrow_ashrv64si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 10807; /* pred_narrow_ashrv64si_scalar */

    case 34:
      if (vector_shift_operand (operands[4], E_V128HImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 10713; /* pred_narrow_ashrv128si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 10809; /* pred_narrow_ashrv128si_scalar */

    case 35:
      if (vector_shift_operand (operands[4], E_V256HImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 10715; /* pred_narrow_ashrv256si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 10811; /* pred_narrow_ashrv256si_scalar */

    case 36:
      if (vector_shift_operand (operands[4], E_V512HImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 10717; /* pred_narrow_ashrv512si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 10813; /* pred_narrow_ashrv512si_scalar */

    case 37:
      if (vector_shift_operand (operands[4], E_V1024HImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 10719; /* pred_narrow_ashrv1024si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 10815; /* pred_narrow_ashrv1024si_scalar */

    case 38:
      if (vector_shift_operand (operands[4], E_V1SImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 10721; /* pred_narrow_ashrv1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10817; /* pred_narrow_ashrv1di_scalar */

    case 39:
      if (vector_shift_operand (operands[4], E_V2SImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 10723; /* pred_narrow_ashrv2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10819; /* pred_narrow_ashrv2di_scalar */

    case 40:
      if (vector_shift_operand (operands[4], E_V4SImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 10725; /* pred_narrow_ashrv4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10821; /* pred_narrow_ashrv4di_scalar */

    case 41:
      if (vector_shift_operand (operands[4], E_V8SImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 10727; /* pred_narrow_ashrv8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10823; /* pred_narrow_ashrv8di_scalar */

    case 42:
      if (vector_shift_operand (operands[4], E_V16SImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 10729; /* pred_narrow_ashrv16di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 10825; /* pred_narrow_ashrv16di_scalar */

    case 43:
      if (vector_shift_operand (operands[4], E_V32SImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 10731; /* pred_narrow_ashrv32di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 10827; /* pred_narrow_ashrv32di_scalar */

    case 44:
      if (vector_shift_operand (operands[4], E_V64SImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 10733; /* pred_narrow_ashrv64di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 10829; /* pred_narrow_ashrv64di_scalar */

    case 45:
      if (vector_shift_operand (operands[4], E_V128SImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 10735; /* pred_narrow_ashrv128di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 10831; /* pred_narrow_ashrv128di_scalar */

    case 46:
      if (vector_shift_operand (operands[4], E_V256SImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 10737; /* pred_narrow_ashrv256di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 10833; /* pred_narrow_ashrv256di_scalar */

    case 47:
      if (vector_shift_operand (operands[4], E_V512SImode)
          && (
#line 4241 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 10739; /* pred_narrow_ashrv512di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4263 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 10835; /* pred_narrow_ashrv512di_scalar */

    default:
      return -1;
    }
}

 int
recog_892 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[4] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[5] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[6] = x7;
  x8 = XVECEXP (x4, 0, 4);
  operands[7] = x8;
  x9 = XEXP (x2, 2);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      if (pattern602 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVM1BImode)
          && vector_const_0_operand (operands[3], E_RVVM8QImode)
          && 
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4231; /* *pred_broadcastrvvm8qi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVM1BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM8QImode)
          || !
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4353; /* *pred_broadcastrvvm8qi_imm */

    case E_RVVM4QImode:
      if (pattern602 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF2BImode)
          && vector_const_0_operand (operands[3], E_RVVM4QImode)
          && 
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4232; /* *pred_broadcastrvvm4qi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF2BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM4QImode)
          || !
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4354; /* *pred_broadcastrvvm4qi_imm */

    case E_RVVM2QImode:
      if (pattern602 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF4BImode)
          && vector_const_0_operand (operands[3], E_RVVM2QImode)
          && 
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4233; /* *pred_broadcastrvvm2qi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF4BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM2QImode)
          || !
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4355; /* *pred_broadcastrvvm2qi_imm */

    case E_RVVM1QImode:
      if (pattern602 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF8BImode)
          && vector_const_0_operand (operands[3], E_RVVM1QImode)
          && 
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4234; /* *pred_broadcastrvvm1qi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF8BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM1QImode)
          || !
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4356; /* *pred_broadcastrvvm1qi_imm */

    case E_RVVM8HImode:
      if (pattern602 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF2BImode)
          && vector_const_0_operand (operands[3], E_RVVM8HImode)
          && 
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4235; /* *pred_broadcastrvvm8hi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF2BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM8HImode)
          || !
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4357; /* *pred_broadcastrvvm8hi_imm */

    case E_RVVM4HImode:
      if (pattern602 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF4BImode)
          && vector_const_0_operand (operands[3], E_RVVM4HImode)
          && 
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4236; /* *pred_broadcastrvvm4hi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF4BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM4HImode)
          || !
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4358; /* *pred_broadcastrvvm4hi_imm */

    case E_RVVM2HImode:
      if (pattern602 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF8BImode)
          && vector_const_0_operand (operands[3], E_RVVM2HImode)
          && 
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4237; /* *pred_broadcastrvvm2hi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF8BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM2HImode)
          || !
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4359; /* *pred_broadcastrvvm2hi_imm */

    case E_RVVM1HImode:
      if (pattern602 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF16BImode)
          && vector_const_0_operand (operands[3], E_RVVM1HImode)
          && 
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4238; /* *pred_broadcastrvvm1hi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF16BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM1HImode)
          || !
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4360; /* *pred_broadcastrvvm1hi_imm */

    case E_RVVM8SImode:
      if (pattern602 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF4BImode)
          && vector_const_0_operand (operands[3], E_RVVM8SImode)
          && 
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4239; /* *pred_broadcastrvvm8si_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF4BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM8SImode)
          || !
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4361; /* *pred_broadcastrvvm8si_imm */

    case E_RVVM4SImode:
      if (pattern602 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF8BImode)
          && vector_const_0_operand (operands[3], E_RVVM4SImode)
          && 
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4240; /* *pred_broadcastrvvm4si_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF8BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM4SImode)
          || !
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4362; /* *pred_broadcastrvvm4si_imm */

    case E_RVVM2SImode:
      if (pattern602 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF16BImode)
          && vector_const_0_operand (operands[3], E_RVVM2SImode)
          && 
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4241; /* *pred_broadcastrvvm2si_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF16BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM2SImode)
          || !
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4363; /* *pred_broadcastrvvm2si_imm */

    case E_RVVM1SImode:
      if (pattern602 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF32BImode)
          && vector_const_0_operand (operands[3], E_RVVM1SImode)
          && 
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 4242; /* *pred_broadcastrvvm1si_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF32BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM1SImode)
          || !
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4364; /* *pred_broadcastrvvm1si_imm */

    case E_RVVM8DImode:
      if (pattern602 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF8BImode)
          && vector_const_0_operand (operands[3], E_RVVM8DImode)
          && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 4243; /* *pred_broadcastrvvm8di_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF8BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM8DImode)
          || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4365; /* *pred_broadcastrvvm8di_imm */

    case E_RVVM4DImode:
      if (pattern602 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF16BImode)
          && vector_const_0_operand (operands[3], E_RVVM4DImode)
          && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 4244; /* *pred_broadcastrvvm4di_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF16BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM4DImode)
          || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4366; /* *pred_broadcastrvvm4di_imm */

    case E_RVVM2DImode:
      if (pattern602 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF32BImode)
          && vector_const_0_operand (operands[3], E_RVVM2DImode)
          && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 4245; /* *pred_broadcastrvvm2di_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF32BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM2DImode)
          || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4367; /* *pred_broadcastrvvm2di_imm */

    case E_RVVM1DImode:
      if (pattern602 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF64BImode)
          && vector_const_0_operand (operands[3], E_RVVM1DImode)
          && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 4246; /* *pred_broadcastrvvm1di_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF64BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM1DImode)
          || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4368; /* *pred_broadcastrvvm1di_imm */

    case E_RVVMF2QImode:
      if (pattern602 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF16BImode)
          && vector_const_0_operand (operands[3], E_RVVMF2QImode)
          && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 4247; /* *pred_broadcastrvvmf2qi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF16BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF2QImode)
          || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 4369; /* *pred_broadcastrvvmf2qi_imm */

    case E_RVVMF4QImode:
      if (pattern602 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF32BImode)
          && vector_const_0_operand (operands[3], E_RVVMF4QImode)
          && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 4248; /* *pred_broadcastrvvmf4qi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF32BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF4QImode)
          || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 4370; /* *pred_broadcastrvvmf4qi_imm */

    case E_RVVMF8QImode:
      if (pattern602 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF64BImode)
          && vector_const_0_operand (operands[3], E_RVVMF8QImode)
          && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 4249; /* *pred_broadcastrvvmf8qi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF64BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF8QImode)
          || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 4371; /* *pred_broadcastrvvmf8qi_imm */

    case E_RVVMF2HImode:
      if (pattern602 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF32BImode)
          && vector_const_0_operand (operands[3], E_RVVMF2HImode)
          && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 4250; /* *pred_broadcastrvvmf2hi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF32BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF2HImode)
          || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 4372; /* *pred_broadcastrvvmf2hi_imm */

    case E_RVVMF4HImode:
      if (pattern602 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF64BImode)
          && vector_const_0_operand (operands[3], E_RVVMF4HImode)
          && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 4251; /* *pred_broadcastrvvmf4hi_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF64BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF4HImode)
          || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 4373; /* *pred_broadcastrvvmf4hi_imm */

    case E_RVVMF2SImode:
      if (pattern602 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF64BImode)
          && vector_const_0_operand (operands[3], E_RVVMF2SImode)
          && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 4252; /* *pred_broadcastrvvmf2si_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF64BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF2SImode)
          || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 4374; /* *pred_broadcastrvvmf2si_imm */

    case E_RVVM8BFmode:
      if (pattern602 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF2BImode)
          && vector_const_0_operand (operands[3], E_RVVM8BFmode)
          && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return 4253; /* *pred_broadcastrvvm8bf_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF2BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM8BFmode)
          || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4375; /* *pred_broadcastrvvm8bf_imm */

    case E_RVVM4BFmode:
      if (pattern602 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF4BImode)
          && vector_const_0_operand (operands[3], E_RVVM4BFmode)
          && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return 4254; /* *pred_broadcastrvvm4bf_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF4BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM4BFmode)
          || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4376; /* *pred_broadcastrvvm4bf_imm */

    case E_RVVM2BFmode:
      if (pattern602 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF8BImode)
          && vector_const_0_operand (operands[3], E_RVVM2BFmode)
          && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return 4255; /* *pred_broadcastrvvm2bf_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF8BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM2BFmode)
          || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4377; /* *pred_broadcastrvvm2bf_imm */

    case E_RVVM1BFmode:
      if (pattern602 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF16BImode)
          && vector_const_0_operand (operands[3], E_RVVM1BFmode)
          && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return 4256; /* *pred_broadcastrvvm1bf_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF16BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVM1BFmode)
          || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4378; /* *pred_broadcastrvvm1bf_imm */

    case E_RVVMF2BFmode:
      if (pattern602 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF32BImode)
          && vector_const_0_operand (operands[3], E_RVVMF2BFmode)
          && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return 4257; /* *pred_broadcastrvvmf2bf_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF32BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF2BFmode)
          || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4379; /* *pred_broadcastrvvmf2bf_imm */

    case E_RVVMF4BFmode:
      if (pattern602 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF64BImode)
          && vector_const_0_operand (operands[3], E_RVVMF4BFmode)
          && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
        return 4258; /* *pred_broadcastrvvmf4bf_zero */
      if (!vector_all_trues_mask_operand (operands[1], E_RVVMF64BImode)
          || !vector_const_int_or_double_0_operand (operands[3], E_RVVMF4BFmode)
          || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4380; /* *pred_broadcastrvvmf4bf_imm */

    case E_RVVM8HFmode:
      return recog_508 (x1, insn, pnum_clobbers);

    case E_RVVM4HFmode:
      return recog_507 (x1, insn, pnum_clobbers);

    case E_RVVM2HFmode:
      return recog_506 (x1, insn, pnum_clobbers);

    case E_RVVM1HFmode:
      return recog_505 (x1, insn, pnum_clobbers);

    case E_RVVMF2HFmode:
      return recog_504 (x1, insn, pnum_clobbers);

    case E_RVVMF4HFmode:
      return recog_503 (x1, insn, pnum_clobbers);

    case E_RVVM8SFmode:
      return recog_502 (x1, insn, pnum_clobbers);

    case E_RVVM4SFmode:
      return recog_501 (x1, insn, pnum_clobbers);

    case E_RVVM2SFmode:
      return recog_500 (x1, insn, pnum_clobbers);

    case E_RVVM1SFmode:
      return recog_499 (x1, insn, pnum_clobbers);

    case E_RVVMF2SFmode:
      return recog_498 (x1, insn, pnum_clobbers);

    case E_RVVM8DFmode:
      return recog_497 (x1, insn, pnum_clobbers);

    case E_RVVM4DFmode:
      return recog_496 (x1, insn, pnum_clobbers);

    case E_RVVM2DFmode:
      return recog_495 (x1, insn, pnum_clobbers);

    case E_RVVM1DFmode:
      return recog_494 (x1, insn, pnum_clobbers);

    case E_V1QImode:
      return recog_493 (x1, insn, pnum_clobbers);

    case E_V2QImode:
      return recog_492 (x1, insn, pnum_clobbers);

    case E_V4QImode:
      return recog_491 (x1, insn, pnum_clobbers);

    case E_V8QImode:
      return recog_490 (x1, insn, pnum_clobbers);

    case E_V16QImode:
      return recog_489 (x1, insn, pnum_clobbers);

    case E_V32QImode:
      return recog_488 (x1, insn, pnum_clobbers);

    case E_V64QImode:
      return recog_487 (x1, insn, pnum_clobbers);

    case E_V128QImode:
      return recog_486 (x1, insn, pnum_clobbers);

    case E_V256QImode:
      return recog_485 (x1, insn, pnum_clobbers);

    case E_V512QImode:
      return recog_484 (x1, insn, pnum_clobbers);

    case E_V1024QImode:
      return recog_483 (x1, insn, pnum_clobbers);

    case E_V2048QImode:
      return recog_482 (x1, insn, pnum_clobbers);

    case E_V4096QImode:
      return recog_481 (x1, insn, pnum_clobbers);

    case E_V1HImode:
      return recog_480 (x1, insn, pnum_clobbers);

    case E_V2HImode:
      return recog_479 (x1, insn, pnum_clobbers);

    case E_V4HImode:
      return recog_478 (x1, insn, pnum_clobbers);

    case E_V8HImode:
      return recog_477 (x1, insn, pnum_clobbers);

    case E_V16HImode:
      return recog_476 (x1, insn, pnum_clobbers);

    case E_V32HImode:
      return recog_475 (x1, insn, pnum_clobbers);

    case E_V64HImode:
      return recog_474 (x1, insn, pnum_clobbers);

    case E_V128HImode:
      return recog_473 (x1, insn, pnum_clobbers);

    case E_V256HImode:
      return recog_472 (x1, insn, pnum_clobbers);

    case E_V512HImode:
      return recog_471 (x1, insn, pnum_clobbers);

    case E_V1024HImode:
      return recog_470 (x1, insn, pnum_clobbers);

    case E_V2048HImode:
      return recog_469 (x1, insn, pnum_clobbers);

    case E_V1SImode:
      return recog_468 (x1, insn, pnum_clobbers);

    case E_V2SImode:
      return recog_467 (x1, insn, pnum_clobbers);

    case E_V4SImode:
      return recog_466 (x1, insn, pnum_clobbers);

    case E_V8SImode:
      return recog_465 (x1, insn, pnum_clobbers);

    case E_V16SImode:
      return recog_464 (x1, insn, pnum_clobbers);

    case E_V32SImode:
      return recog_463 (x1, insn, pnum_clobbers);

    case E_V64SImode:
      return recog_462 (x1, insn, pnum_clobbers);

    case E_V128SImode:
      return recog_461 (x1, insn, pnum_clobbers);

    case E_V256SImode:
      return recog_460 (x1, insn, pnum_clobbers);

    case E_V512SImode:
      return recog_459 (x1, insn, pnum_clobbers);

    case E_V1024SImode:
      return recog_458 (x1, insn, pnum_clobbers);

    case E_V1DImode:
      return recog_457 (x1, insn, pnum_clobbers);

    case E_V2DImode:
      return recog_456 (x1, insn, pnum_clobbers);

    case E_V4DImode:
      return recog_455 (x1, insn, pnum_clobbers);

    case E_V8DImode:
      return recog_454 (x1, insn, pnum_clobbers);

    case E_V16DImode:
      return recog_453 (x1, insn, pnum_clobbers);

    case E_V32DImode:
      return recog_452 (x1, insn, pnum_clobbers);

    case E_V64DImode:
      return recog_451 (x1, insn, pnum_clobbers);

    case E_V128DImode:
      return recog_450 (x1, insn, pnum_clobbers);

    case E_V256DImode:
      return recog_449 (x1, insn, pnum_clobbers);

    case E_V512DImode:
      return recog_448 (x1, insn, pnum_clobbers);

    case E_V1HFmode:
      return recog_447 (x1, insn, pnum_clobbers);

    case E_V2HFmode:
      return recog_446 (x1, insn, pnum_clobbers);

    case E_V4HFmode:
      return recog_445 (x1, insn, pnum_clobbers);

    case E_V8HFmode:
      return recog_444 (x1, insn, pnum_clobbers);

    case E_V16HFmode:
      return recog_443 (x1, insn, pnum_clobbers);

    case E_V32HFmode:
      return recog_442 (x1, insn, pnum_clobbers);

    case E_V64HFmode:
      return recog_441 (x1, insn, pnum_clobbers);

    case E_V128HFmode:
      return recog_440 (x1, insn, pnum_clobbers);

    case E_V256HFmode:
      return recog_439 (x1, insn, pnum_clobbers);

    case E_V512HFmode:
      return recog_438 (x1, insn, pnum_clobbers);

    case E_V1024HFmode:
      return recog_437 (x1, insn, pnum_clobbers);

    case E_V2048HFmode:
      return recog_436 (x1, insn, pnum_clobbers);

    case E_V1SFmode:
      return recog_435 (x1, insn, pnum_clobbers);

    case E_V2SFmode:
      return recog_434 (x1, insn, pnum_clobbers);

    case E_V4SFmode:
      return recog_433 (x1, insn, pnum_clobbers);

    case E_V8SFmode:
      return recog_432 (x1, insn, pnum_clobbers);

    case E_V16SFmode:
      return recog_431 (x1, insn, pnum_clobbers);

    case E_V32SFmode:
      return recog_430 (x1, insn, pnum_clobbers);

    case E_V64SFmode:
      return recog_429 (x1, insn, pnum_clobbers);

    case E_V128SFmode:
      return recog_428 (x1, insn, pnum_clobbers);

    case E_V256SFmode:
      return recog_427 (x1, insn, pnum_clobbers);

    case E_V512SFmode:
      return recog_426 (x1, insn, pnum_clobbers);

    case E_V1024SFmode:
      return recog_425 (x1, insn, pnum_clobbers);

    case E_V1DFmode:
      return recog_424 (x1, insn, pnum_clobbers);

    case E_V2DFmode:
      return recog_423 (x1, insn, pnum_clobbers);

    case E_V4DFmode:
      return recog_422 (x1, insn, pnum_clobbers);

    case E_V8DFmode:
      return recog_421 (x1, insn, pnum_clobbers);

    case E_V16DFmode:
      return recog_420 (x1, insn, pnum_clobbers);

    case E_V32DFmode:
      return recog_419 (x1, insn, pnum_clobbers);

    case E_V64DFmode:
      return recog_418 (x1, insn, pnum_clobbers);

    case E_V128DFmode:
      return recog_417 (x1, insn, pnum_clobbers);

    case E_V256DFmode:
      return recog_416 (x1, insn, pnum_clobbers);

    case E_V512DFmode:
      return recog_415 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_897 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XEXP (x2, 2);
  operands[2] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  switch (GET_CODE (x10))
    {
    case REG:
    case SUBREG:
      operands[3] = x10;
      switch (pattern498 (x2))
        {
        case 0:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5509; /* pred_mulrvvm8qi */

        case 1:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5526; /* pred_mulrvvm4qi */

        case 2:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5543; /* pred_mulrvvm2qi */

        case 3:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5560; /* pred_mulrvvm1qi */

        case 4:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5577; /* pred_mulrvvm8hi */

        case 5:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5594; /* pred_mulrvvm4hi */

        case 6:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5611; /* pred_mulrvvm2hi */

        case 7:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5628; /* pred_mulrvvm1hi */

        case 8:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5645; /* pred_mulrvvm8si */

        case 9:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5662; /* pred_mulrvvm4si */

        case 10:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5679; /* pred_mulrvvm2si */

        case 11:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5696; /* pred_mulrvvm1si */

        case 12:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 5713; /* pred_mulrvvm8di */

        case 13:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 5730; /* pred_mulrvvm4di */

        case 14:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 5747; /* pred_mulrvvm2di */

        case 15:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 5764; /* pred_mulrvvm1di */

        case 16:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 5781; /* pred_mulrvvmf2qi */

        case 17:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 5798; /* pred_mulrvvmf4qi */

        case 18:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 5815; /* pred_mulrvvmf8qi */

        case 19:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 5832; /* pred_mulrvvmf2hi */

        case 20:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 5849; /* pred_mulrvvmf4hi */

        case 21:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 5866; /* pred_mulrvvmf2si */

        case 22:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 5883; /* pred_mulv1qi */

        case 23:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 5900; /* pred_mulv2qi */

        case 24:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 5917; /* pred_mulv4qi */

        case 25:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 5934; /* pred_mulv8qi */

        case 26:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 5951; /* pred_mulv16qi */

        case 27:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 5968; /* pred_mulv32qi */

        case 28:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 5985; /* pred_mulv64qi */

        case 29:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 6002; /* pred_mulv128qi */

        case 30:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 6019; /* pred_mulv256qi */

        case 31:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 6036; /* pred_mulv512qi */

        case 32:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 6053; /* pred_mulv1024qi */

        case 33:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 6070; /* pred_mulv2048qi */

        case 34:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 6087; /* pred_mulv4096qi */

        case 35:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 6104; /* pred_mulv1hi */

        case 36:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 6121; /* pred_mulv2hi */

        case 37:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 6138; /* pred_mulv4hi */

        case 38:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 6155; /* pred_mulv8hi */

        case 39:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 6172; /* pred_mulv16hi */

        case 40:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 6189; /* pred_mulv32hi */

        case 41:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 6206; /* pred_mulv64hi */

        case 42:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 6223; /* pred_mulv128hi */

        case 43:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 6240; /* pred_mulv256hi */

        case 44:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 6257; /* pred_mulv512hi */

        case 45:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 6274; /* pred_mulv1024hi */

        case 46:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 6291; /* pred_mulv2048hi */

        case 47:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 6308; /* pred_mulv1si */

        case 48:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 6325; /* pred_mulv2si */

        case 49:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 6342; /* pred_mulv4si */

        case 50:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 6359; /* pred_mulv8si */

        case 51:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 6376; /* pred_mulv16si */

        case 52:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 6393; /* pred_mulv32si */

        case 53:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 6410; /* pred_mulv64si */

        case 54:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 6427; /* pred_mulv128si */

        case 55:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 6444; /* pred_mulv256si */

        case 56:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 6461; /* pred_mulv512si */

        case 57:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 6478; /* pred_mulv1024si */

        case 58:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 6495; /* pred_mulv1di */

        case 59:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 6512; /* pred_mulv2di */

        case 60:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 6529; /* pred_mulv4di */

        case 61:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 6546; /* pred_mulv8di */

        case 62:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 6563; /* pred_mulv16di */

        case 63:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 6580; /* pred_mulv32di */

        case 64:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 6597; /* pred_mulv64di */

        case 65:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 6614; /* pred_mulv128di */

        case 66:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 6631; /* pred_mulv256di */

        case 67:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 6648; /* pred_mulv512di */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x11 = XEXP (x9, 1);
      operands[3] = x11;
      x12 = XEXP (x10, 0);
      switch (GET_CODE (x12))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          switch (pattern489 (x2))
            {
            case 0:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6865; /* pred_mulrvvm8qi_scalar */

            case 1:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6874; /* pred_mulrvvm4qi_scalar */

            case 2:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6883; /* pred_mulrvvm2qi_scalar */

            case 3:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6892; /* pred_mulrvvm1qi_scalar */

            case 4:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6901; /* pred_mulrvvmf2qi_scalar */

            case 5:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6910; /* pred_mulrvvmf4qi_scalar */

            case 6:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 6919; /* pred_mulrvvmf8qi_scalar */

            case 7:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6928; /* pred_mulrvvm8hi_scalar */

            case 8:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6937; /* pred_mulrvvm4hi_scalar */

            case 9:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6946; /* pred_mulrvvm2hi_scalar */

            case 10:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6955; /* pred_mulrvvm1hi_scalar */

            case 11:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6964; /* pred_mulrvvmf2hi_scalar */

            case 12:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 6973; /* pred_mulrvvmf4hi_scalar */

            case 13:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6982; /* pred_mulrvvm8si_scalar */

            case 14:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6991; /* pred_mulrvvm4si_scalar */

            case 15:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7000; /* pred_mulrvvm2si_scalar */

            case 16:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7009; /* pred_mulrvvm1si_scalar */

            case 17:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7018; /* pred_mulrvvmf2si_scalar */

            case 18:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 7027; /* pred_mulv1qi_scalar */

            case 19:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 7036; /* pred_mulv2qi_scalar */

            case 20:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 7045; /* pred_mulv4qi_scalar */

            case 21:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 7054; /* pred_mulv8qi_scalar */

            case 22:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 7063; /* pred_mulv16qi_scalar */

            case 23:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 7072; /* pred_mulv32qi_scalar */

            case 24:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7081; /* pred_mulv64qi_scalar */

            case 25:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7090; /* pred_mulv128qi_scalar */

            case 26:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7099; /* pred_mulv256qi_scalar */

            case 27:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7108; /* pred_mulv512qi_scalar */

            case 28:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7117; /* pred_mulv1024qi_scalar */

            case 29:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7126; /* pred_mulv2048qi_scalar */

            case 30:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7135; /* pred_mulv4096qi_scalar */

            case 31:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 7144; /* pred_mulv1hi_scalar */

            case 32:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 7153; /* pred_mulv2hi_scalar */

            case 33:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 7162; /* pred_mulv4hi_scalar */

            case 34:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 7171; /* pred_mulv8hi_scalar */

            case 35:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 7180; /* pred_mulv16hi_scalar */

            case 36:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7189; /* pred_mulv32hi_scalar */

            case 37:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7198; /* pred_mulv64hi_scalar */

            case 38:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7207; /* pred_mulv128hi_scalar */

            case 39:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7216; /* pred_mulv256hi_scalar */

            case 40:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7225; /* pred_mulv512hi_scalar */

            case 41:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7234; /* pred_mulv1024hi_scalar */

            case 42:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7243; /* pred_mulv2048hi_scalar */

            case 43:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 7252; /* pred_mulv1si_scalar */

            case 44:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 7261; /* pred_mulv2si_scalar */

            case 45:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 7270; /* pred_mulv4si_scalar */

            case 46:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 7279; /* pred_mulv8si_scalar */

            case 47:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7288; /* pred_mulv16si_scalar */

            case 48:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7297; /* pred_mulv32si_scalar */

            case 49:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7306; /* pred_mulv64si_scalar */

            case 50:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7315; /* pred_mulv128si_scalar */

            case 51:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7324; /* pred_mulv256si_scalar */

            case 52:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7333; /* pred_mulv512si_scalar */

            case 53:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7342; /* pred_mulv1024si_scalar */

            case 54:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7675; /* *pred_mulrvvm8di_scalar */

            case 55:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7684; /* *pred_mulrvvm4di_scalar */

            case 56:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7693; /* *pred_mulrvvm2di_scalar */

            case 57:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7702; /* *pred_mulrvvm1di_scalar */

            case 58:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7711; /* *pred_mulv1di_scalar */

            case 59:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7720; /* *pred_mulv2di_scalar */

            case 60:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7729; /* *pred_mulv4di_scalar */

            case 61:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7738; /* *pred_mulv8di_scalar */

            case 62:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7747; /* *pred_mulv16di_scalar */

            case 63:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7756; /* *pred_mulv32di_scalar */

            case 64:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7765; /* *pred_mulv64di_scalar */

            case 65:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7774; /* *pred_mulv128di_scalar */

            case 66:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7783; /* *pred_mulv256di_scalar */

            case 67:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7792; /* *pred_mulv512di_scalar */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern491 (x2))
            {
            case 0:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7801; /* *pred_mulrvvm8di_extended_scalar */

            case 1:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7810; /* *pred_mulrvvm4di_extended_scalar */

            case 2:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7819; /* *pred_mulrvvm2di_extended_scalar */

            case 3:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7828; /* *pred_mulrvvm1di_extended_scalar */

            case 4:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7837; /* *pred_mulv1di_extended_scalar */

            case 5:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7846; /* *pred_mulv2di_extended_scalar */

            case 6:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7855; /* *pred_mulv4di_extended_scalar */

            case 7:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7864; /* *pred_mulv8di_extended_scalar */

            case 8:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7873; /* *pred_mulv16di_extended_scalar */

            case 9:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7882; /* *pred_mulv32di_extended_scalar */

            case 10:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7891; /* *pred_mulv64di_extended_scalar */

            case 11:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7900; /* *pred_mulv128di_extended_scalar */

            case 12:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7909; /* *pred_mulv256di_extended_scalar */

            case 13:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7918; /* *pred_mulv512di_extended_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_881 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_882 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_908 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[6] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[7] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      if (pattern493 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8982; /* pred_one_cmplrvvm8qi */

    case E_RVVM4QImode:
      if (pattern493 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8984; /* pred_one_cmplrvvm4qi */

    case E_RVVM2QImode:
      if (pattern493 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8986; /* pred_one_cmplrvvm2qi */

    case E_RVVM1QImode:
      if (pattern493 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8988; /* pred_one_cmplrvvm1qi */

    case E_RVVM8HImode:
      if (pattern493 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8990; /* pred_one_cmplrvvm8hi */

    case E_RVVM4HImode:
      if (pattern493 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8992; /* pred_one_cmplrvvm4hi */

    case E_RVVM2HImode:
      if (pattern493 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8994; /* pred_one_cmplrvvm2hi */

    case E_RVVM1HImode:
      if (pattern493 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8996; /* pred_one_cmplrvvm1hi */

    case E_RVVM8SImode:
      if (pattern493 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8998; /* pred_one_cmplrvvm8si */

    case E_RVVM4SImode:
      if (pattern493 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9000; /* pred_one_cmplrvvm4si */

    case E_RVVM2SImode:
      if (pattern493 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9002; /* pred_one_cmplrvvm2si */

    case E_RVVM1SImode:
      if (pattern493 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 9004; /* pred_one_cmplrvvm1si */

    case E_RVVM8DImode:
      if (pattern493 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9006; /* pred_one_cmplrvvm8di */

    case E_RVVM4DImode:
      if (pattern493 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9008; /* pred_one_cmplrvvm4di */

    case E_RVVM2DImode:
      if (pattern493 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9010; /* pred_one_cmplrvvm2di */

    case E_RVVM1DImode:
      if (pattern493 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9012; /* pred_one_cmplrvvm1di */

    case E_RVVMF2QImode:
      if (pattern493 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 9014; /* pred_one_cmplrvvmf2qi */

    case E_RVVMF4QImode:
      if (pattern493 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 9016; /* pred_one_cmplrvvmf4qi */

    case E_RVVMF8QImode:
      if (pattern493 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 9018; /* pred_one_cmplrvvmf8qi */

    case E_RVVMF2HImode:
      if (pattern493 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 9020; /* pred_one_cmplrvvmf2hi */

    case E_RVVMF4HImode:
      if (pattern493 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 9022; /* pred_one_cmplrvvmf4hi */

    case E_RVVMF2SImode:
      if (pattern493 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 9024; /* pred_one_cmplrvvmf2si */

    case E_V1QImode:
      if (pattern493 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 9026; /* pred_one_cmplv1qi */

    case E_V2QImode:
      if (pattern493 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 9028; /* pred_one_cmplv2qi */

    case E_V4QImode:
      if (pattern493 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 9030; /* pred_one_cmplv4qi */

    case E_V8QImode:
      if (pattern493 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 9032; /* pred_one_cmplv8qi */

    case E_V16QImode:
      if (pattern493 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 9034; /* pred_one_cmplv16qi */

    case E_V32QImode:
      if (pattern493 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 9036; /* pred_one_cmplv32qi */

    case E_V64QImode:
      if (pattern493 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9038; /* pred_one_cmplv64qi */

    case E_V128QImode:
      if (pattern493 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9040; /* pred_one_cmplv128qi */

    case E_V256QImode:
      if (pattern493 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9042; /* pred_one_cmplv256qi */

    case E_V512QImode:
      if (pattern493 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9044; /* pred_one_cmplv512qi */

    case E_V1024QImode:
      if (pattern493 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9046; /* pred_one_cmplv1024qi */

    case E_V2048QImode:
      if (pattern493 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9048; /* pred_one_cmplv2048qi */

    case E_V4096QImode:
      if (pattern493 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9050; /* pred_one_cmplv4096qi */

    case E_V1HImode:
      if (pattern493 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 9052; /* pred_one_cmplv1hi */

    case E_V2HImode:
      if (pattern493 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 9054; /* pred_one_cmplv2hi */

    case E_V4HImode:
      if (pattern493 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 9056; /* pred_one_cmplv4hi */

    case E_V8HImode:
      if (pattern493 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 9058; /* pred_one_cmplv8hi */

    case E_V16HImode:
      if (pattern493 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 9060; /* pred_one_cmplv16hi */

    case E_V32HImode:
      if (pattern493 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9062; /* pred_one_cmplv32hi */

    case E_V64HImode:
      if (pattern493 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9064; /* pred_one_cmplv64hi */

    case E_V128HImode:
      if (pattern493 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9066; /* pred_one_cmplv128hi */

    case E_V256HImode:
      if (pattern493 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9068; /* pred_one_cmplv256hi */

    case E_V512HImode:
      if (pattern493 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9070; /* pred_one_cmplv512hi */

    case E_V1024HImode:
      if (pattern493 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9072; /* pred_one_cmplv1024hi */

    case E_V2048HImode:
      if (pattern493 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9074; /* pred_one_cmplv2048hi */

    case E_V1SImode:
      if (pattern493 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 9076; /* pred_one_cmplv1si */

    case E_V2SImode:
      if (pattern493 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 9078; /* pred_one_cmplv2si */

    case E_V4SImode:
      if (pattern493 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 9080; /* pred_one_cmplv4si */

    case E_V8SImode:
      if (pattern493 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 9082; /* pred_one_cmplv8si */

    case E_V16SImode:
      if (pattern493 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9084; /* pred_one_cmplv16si */

    case E_V32SImode:
      if (pattern493 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9086; /* pred_one_cmplv32si */

    case E_V64SImode:
      if (pattern493 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9088; /* pred_one_cmplv64si */

    case E_V128SImode:
      if (pattern493 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9090; /* pred_one_cmplv128si */

    case E_V256SImode:
      if (pattern493 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9092; /* pred_one_cmplv256si */

    case E_V512SImode:
      if (pattern493 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9094; /* pred_one_cmplv512si */

    case E_V1024SImode:
      if (pattern493 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9096; /* pred_one_cmplv1024si */

    case E_V1DImode:
      if (pattern493 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9098; /* pred_one_cmplv1di */

    case E_V2DImode:
      if (pattern493 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9100; /* pred_one_cmplv2di */

    case E_V4DImode:
      if (pattern493 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9102; /* pred_one_cmplv4di */

    case E_V8DImode:
      if (pattern493 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9104; /* pred_one_cmplv8di */

    case E_V16DImode:
      if (pattern493 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9106; /* pred_one_cmplv16di */

    case E_V32DImode:
      if (pattern493 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9108; /* pred_one_cmplv32di */

    case E_V64DImode:
      if (pattern493 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9110; /* pred_one_cmplv64di */

    case E_V128DImode:
      if (pattern493 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9112; /* pred_one_cmplv128di */

    case E_V256DImode:
      if (pattern493 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9114; /* pred_one_cmplv256di */

    case E_V512DImode:
      if (pattern493 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !(
#line 3906 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9116; /* pred_one_cmplv512di */

    default:
      return -1;
    }
}

 int
recog_915 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ASHIFTRT:
      return recog_885 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_884 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
      operands[3] = x5;
      x6 = XEXP (x2, 0);
      x7 = XVECEXP (x6, 0, 1);
      operands[4] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[5] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[6] = x9;
      x10 = XVECEXP (x6, 0, 4);
      operands[7] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4QImode:
          if (pattern504 (x2, 
E_RVVM4QImode, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
              || !
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10837; /* pred_truncrvvm8hi */

        case E_RVVM2QImode:
          if (pattern504 (x2, 
E_RVVM2QImode, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
              || !
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10838; /* pred_truncrvvm4hi */

        case E_RVVM1QImode:
          if (pattern504 (x2, 
E_RVVM1QImode, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
              || !
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10839; /* pred_truncrvvm2hi */

        case E_RVVMF2QImode:
          if (pattern504 (x2, 
E_RVVMF2QImode, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
              || !
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10840; /* pred_truncrvvm1hi */

        case E_RVVMF4QImode:
          if (pattern504 (x2, 
E_RVVMF4QImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
              || !
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10841; /* pred_truncrvvmf2hi */

        case E_RVVMF8QImode:
          if (pattern504 (x2, 
E_RVVMF8QImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10842; /* pred_truncrvvmf4hi */

        case E_RVVM4HImode:
          if (pattern504 (x2, 
E_RVVM4HImode, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
              || !
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10843; /* pred_truncrvvm8si */

        case E_RVVM2HImode:
          if (pattern504 (x2, 
E_RVVM2HImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
              || !
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10844; /* pred_truncrvvm4si */

        case E_RVVM1HImode:
          if (pattern504 (x2, 
E_RVVM1HImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
              || !
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10845; /* pred_truncrvvm2si */

        case E_RVVMF2HImode:
          if (pattern504 (x2, 
E_RVVMF2HImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
              || !
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10846; /* pred_truncrvvm1si */

        case E_RVVMF4HImode:
          if (pattern504 (x2, 
E_RVVMF4HImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10847; /* pred_truncrvvmf2si */

        case E_RVVM4SImode:
          if (pattern504 (x2, 
E_RVVM4SImode, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10848; /* pred_truncrvvm8di */

        case E_RVVM2SImode:
          if (pattern504 (x2, 
E_RVVM2SImode, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10849; /* pred_truncrvvm4di */

        case E_RVVM1SImode:
          if (pattern504 (x2, 
E_RVVM1SImode, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10850; /* pred_truncrvvm2di */

        case E_RVVMF2SImode:
          if (pattern504 (x2, 
E_RVVMF2SImode, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10851; /* pred_truncrvvm1di */

        case E_V1QImode:
          if (pattern504 (x2, 
E_V1QImode, 
E_V1HImode, 
E_V1BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10852; /* pred_truncv1hi */

        case E_V2QImode:
          if (pattern504 (x2, 
E_V2QImode, 
E_V2HImode, 
E_V2BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10853; /* pred_truncv2hi */

        case E_V4QImode:
          if (pattern504 (x2, 
E_V4QImode, 
E_V4HImode, 
E_V4BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10854; /* pred_truncv4hi */

        case E_V8QImode:
          if (pattern504 (x2, 
E_V8QImode, 
E_V8HImode, 
E_V8BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10855; /* pred_truncv8hi */

        case E_V16QImode:
          if (pattern504 (x2, 
E_V16QImode, 
E_V16HImode, 
E_V16BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10856; /* pred_truncv16hi */

        case E_V32QImode:
          if (pattern504 (x2, 
E_V32QImode, 
E_V32HImode, 
E_V32BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10857; /* pred_truncv32hi */

        case E_V64QImode:
          if (pattern504 (x2, 
E_V64QImode, 
E_V64HImode, 
E_V64BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10858; /* pred_truncv64hi */

        case E_V128QImode:
          if (pattern504 (x2, 
E_V128QImode, 
E_V128HImode, 
E_V128BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10859; /* pred_truncv128hi */

        case E_V256QImode:
          if (pattern504 (x2, 
E_V256QImode, 
E_V256HImode, 
E_V256BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10860; /* pred_truncv256hi */

        case E_V512QImode:
          if (pattern504 (x2, 
E_V512QImode, 
E_V512HImode, 
E_V512BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10861; /* pred_truncv512hi */

        case E_V1024QImode:
          if (pattern504 (x2, 
E_V1024QImode, 
E_V1024HImode, 
E_V1024BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10862; /* pred_truncv1024hi */

        case E_V2048QImode:
          if (pattern504 (x2, 
E_V2048QImode, 
E_V2048HImode, 
E_V2048BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10863; /* pred_truncv2048hi */

        case E_V1HImode:
          if (pattern504 (x2, 
E_V1HImode, 
E_V1SImode, 
E_V1BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10864; /* pred_truncv1si */

        case E_V2HImode:
          if (pattern504 (x2, 
E_V2HImode, 
E_V2SImode, 
E_V2BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10865; /* pred_truncv2si */

        case E_V4HImode:
          if (pattern504 (x2, 
E_V4HImode, 
E_V4SImode, 
E_V4BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10866; /* pred_truncv4si */

        case E_V8HImode:
          if (pattern504 (x2, 
E_V8HImode, 
E_V8SImode, 
E_V8BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10867; /* pred_truncv8si */

        case E_V16HImode:
          if (pattern504 (x2, 
E_V16HImode, 
E_V16SImode, 
E_V16BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10868; /* pred_truncv16si */

        case E_V32HImode:
          if (pattern504 (x2, 
E_V32HImode, 
E_V32SImode, 
E_V32BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10869; /* pred_truncv32si */

        case E_V64HImode:
          if (pattern504 (x2, 
E_V64HImode, 
E_V64SImode, 
E_V64BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10870; /* pred_truncv64si */

        case E_V128HImode:
          if (pattern504 (x2, 
E_V128HImode, 
E_V128SImode, 
E_V128BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10871; /* pred_truncv128si */

        case E_V256HImode:
          if (pattern504 (x2, 
E_V256HImode, 
E_V256SImode, 
E_V256BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10872; /* pred_truncv256si */

        case E_V512HImode:
          if (pattern504 (x2, 
E_V512HImode, 
E_V512SImode, 
E_V512BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10873; /* pred_truncv512si */

        case E_V1024HImode:
          if (pattern504 (x2, 
E_V1024HImode, 
E_V1024SImode, 
E_V1024BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10874; /* pred_truncv1024si */

        case E_V1SImode:
          if (pattern504 (x2, 
E_V1SImode, 
E_V1DImode, 
E_V1BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10875; /* pred_truncv1di */

        case E_V2SImode:
          if (pattern504 (x2, 
E_V2SImode, 
E_V2DImode, 
E_V2BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10876; /* pred_truncv2di */

        case E_V4SImode:
          if (pattern504 (x2, 
E_V4SImode, 
E_V4DImode, 
E_V4BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10877; /* pred_truncv4di */

        case E_V8SImode:
          if (pattern504 (x2, 
E_V8SImode, 
E_V8DImode, 
E_V8BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10878; /* pred_truncv8di */

        case E_V16SImode:
          if (pattern504 (x2, 
E_V16SImode, 
E_V16DImode, 
E_V16BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10879; /* pred_truncv16di */

        case E_V32SImode:
          if (pattern504 (x2, 
E_V32SImode, 
E_V32DImode, 
E_V32BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10880; /* pred_truncv32di */

        case E_V64SImode:
          if (pattern504 (x2, 
E_V64SImode, 
E_V64DImode, 
E_V64BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10881; /* pred_truncv64di */

        case E_V128SImode:
          if (pattern504 (x2, 
E_V128SImode, 
E_V128DImode, 
E_V128BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10882; /* pred_truncv128di */

        case E_V256SImode:
          if (pattern504 (x2, 
E_V256SImode, 
E_V256DImode, 
E_V256BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10883; /* pred_truncv256di */

        case E_V512SImode:
          if (pattern504 (x2, 
E_V512SImode, 
E_V512DImode, 
E_V512BImode) != 0
              || !(
#line 4290 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10884; /* pred_truncv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_922 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern474 (x2))
    {
    case 0:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))))
        return -1;
      return 1256; /* *pred_mov_widthwurvvm8qi */

    case 1:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))))
        return -1;
      return 1262; /* *pred_mov_widthwurvvm4qi */

    case 2:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))))
        return -1;
      return 1268; /* *pred_mov_widthwurvvm2qi */

    case 3:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))))
        return -1;
      return 1274; /* *pred_mov_widthwurvvm1qi */

    case 4:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))))
        return -1;
      return 1280; /* *pred_mov_widthwurvvm8hi */

    case 5:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))))
        return -1;
      return 1286; /* *pred_mov_widthwurvvm4hi */

    case 6:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))))
        return -1;
      return 1292; /* *pred_mov_widthwurvvm2hi */

    case 7:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))))
        return -1;
      return 1298; /* *pred_mov_widthwurvvm1hi */

    case 8:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))))
        return -1;
      return 1304; /* *pred_mov_widthwurvvm8si */

    case 9:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))))
        return -1;
      return 1310; /* *pred_mov_widthwurvvm4si */

    case 10:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))))
        return -1;
      return 1316; /* *pred_mov_widthwurvvm2si */

    case 11:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))))
        return -1;
      return 1322; /* *pred_mov_widthwurvvm1si */

    case 12:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1328; /* *pred_mov_widthwurvvm8di */

    case 13:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1334; /* *pred_mov_widthwurvvm4di */

    case 14:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1340; /* *pred_mov_widthwurvvm2di */

    case 15:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1346; /* *pred_mov_widthwurvvm1di */

    case 16:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1352; /* *pred_mov_widthwurvvmf2qi */

    case 17:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1358; /* *pred_mov_widthwurvvmf4qi */

    case 18:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1364; /* *pred_mov_widthwurvvmf8qi */

    case 19:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1370; /* *pred_mov_widthwurvvmf2hi */

    case 20:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1376; /* *pred_mov_widthwurvvmf4hi */

    case 21:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1382; /* *pred_mov_widthwurvvmf2si */

    case 22:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1388; /* *pred_mov_widthwurvvm8bf */

    case 23:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1394; /* *pred_mov_widthwurvvm4bf */

    case 24:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1400; /* *pred_mov_widthwurvvm2bf */

    case 25:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1406; /* *pred_mov_widthwurvvm1bf */

    case 26:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1412; /* *pred_mov_widthwurvvmf2bf */

    case 27:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1418; /* *pred_mov_widthwurvvmf4bf */

    case 28:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1424; /* *pred_mov_widthwurvvm8hf */

    case 29:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1430; /* *pred_mov_widthwurvvm4hf */

    case 30:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1436; /* *pred_mov_widthwurvvm2hf */

    case 31:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1442; /* *pred_mov_widthwurvvm1hf */

    case 32:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1448; /* *pred_mov_widthwurvvmf2hf */

    case 33:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1454; /* *pred_mov_widthwurvvmf4hf */

    case 34:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1460; /* *pred_mov_widthwurvvm8sf */

    case 35:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1466; /* *pred_mov_widthwurvvm4sf */

    case 36:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1472; /* *pred_mov_widthwurvvm2sf */

    case 37:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1478; /* *pred_mov_widthwurvvm1sf */

    case 38:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1484; /* *pred_mov_widthwurvvmf2sf */

    case 39:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1490; /* *pred_mov_widthwurvvm8df */

    case 40:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1496; /* *pred_mov_widthwurvvm4df */

    case 41:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1502; /* *pred_mov_widthwurvvm2df */

    case 42:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1508; /* *pred_mov_widthwurvvm1df */

    case 43:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 1514; /* *pred_mov_widthwuv1qi */

    case 44:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 1520; /* *pred_mov_widthwuv2qi */

    case 45:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 1526; /* *pred_mov_widthwuv4qi */

    case 46:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 1532; /* *pred_mov_widthwuv8qi */

    case 47:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 1538; /* *pred_mov_widthwuv16qi */

    case 48:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 1544; /* *pred_mov_widthwuv32qi */

    case 49:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1550; /* *pred_mov_widthwuv64qi */

    case 50:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1556; /* *pred_mov_widthwuv128qi */

    case 51:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1562; /* *pred_mov_widthwuv256qi */

    case 52:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1568; /* *pred_mov_widthwuv512qi */

    case 53:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1574; /* *pred_mov_widthwuv1024qi */

    case 54:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1580; /* *pred_mov_widthwuv2048qi */

    case 55:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1586; /* *pred_mov_widthwuv4096qi */

    case 56:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 1592; /* *pred_mov_widthwuv1hi */

    case 57:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 1598; /* *pred_mov_widthwuv2hi */

    case 58:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 1604; /* *pred_mov_widthwuv4hi */

    case 59:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 1610; /* *pred_mov_widthwuv8hi */

    case 60:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 1616; /* *pred_mov_widthwuv16hi */

    case 61:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1622; /* *pred_mov_widthwuv32hi */

    case 62:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1628; /* *pred_mov_widthwuv64hi */

    case 63:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1634; /* *pred_mov_widthwuv128hi */

    case 64:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1640; /* *pred_mov_widthwuv256hi */

    case 65:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1646; /* *pred_mov_widthwuv512hi */

    case 66:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1652; /* *pred_mov_widthwuv1024hi */

    case 67:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1658; /* *pred_mov_widthwuv2048hi */

    case 68:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 1664; /* *pred_mov_widthwuv1si */

    case 69:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 1670; /* *pred_mov_widthwuv2si */

    case 70:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 1676; /* *pred_mov_widthwuv4si */

    case 71:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 1682; /* *pred_mov_widthwuv8si */

    case 72:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1688; /* *pred_mov_widthwuv16si */

    case 73:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1694; /* *pred_mov_widthwuv32si */

    case 74:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1700; /* *pred_mov_widthwuv64si */

    case 75:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1706; /* *pred_mov_widthwuv128si */

    case 76:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1712; /* *pred_mov_widthwuv256si */

    case 77:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1718; /* *pred_mov_widthwuv512si */

    case 78:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1724; /* *pred_mov_widthwuv1024si */

    case 79:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1730; /* *pred_mov_widthwuv1di */

    case 80:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1736; /* *pred_mov_widthwuv2di */

    case 81:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1742; /* *pred_mov_widthwuv4di */

    case 82:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1748; /* *pred_mov_widthwuv8di */

    case 83:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1754; /* *pred_mov_widthwuv16di */

    case 84:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1760; /* *pred_mov_widthwuv32di */

    case 85:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1766; /* *pred_mov_widthwuv64di */

    case 86:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1772; /* *pred_mov_widthwuv128di */

    case 87:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1778; /* *pred_mov_widthwuv256di */

    case 88:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1784; /* *pred_mov_widthwuv512di */

    case 89:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1790; /* *pred_mov_widthwuv1hf */

    case 90:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1796; /* *pred_mov_widthwuv2hf */

    case 91:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1802; /* *pred_mov_widthwuv4hf */

    case 92:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1808; /* *pred_mov_widthwuv8hf */

    case 93:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1814; /* *pred_mov_widthwuv16hf */

    case 94:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1820; /* *pred_mov_widthwuv32hf */

    case 95:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1826; /* *pred_mov_widthwuv64hf */

    case 96:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1832; /* *pred_mov_widthwuv128hf */

    case 97:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1838; /* *pred_mov_widthwuv256hf */

    case 98:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1844; /* *pred_mov_widthwuv512hf */

    case 99:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1850; /* *pred_mov_widthwuv1024hf */

    case 100:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1856; /* *pred_mov_widthwuv2048hf */

    case 101:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1862; /* *pred_mov_widthwuv1sf */

    case 102:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1868; /* *pred_mov_widthwuv2sf */

    case 103:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1874; /* *pred_mov_widthwuv4sf */

    case 104:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1880; /* *pred_mov_widthwuv8sf */

    case 105:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1886; /* *pred_mov_widthwuv16sf */

    case 106:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1892; /* *pred_mov_widthwuv32sf */

    case 107:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1898; /* *pred_mov_widthwuv64sf */

    case 108:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1904; /* *pred_mov_widthwuv128sf */

    case 109:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1910; /* *pred_mov_widthwuv256sf */

    case 110:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1916; /* *pred_mov_widthwuv512sf */

    case 111:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1922; /* *pred_mov_widthwuv1024sf */

    case 112:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1928; /* *pred_mov_widthwuv1df */

    case 113:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1934; /* *pred_mov_widthwuv2df */

    case 114:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1940; /* *pred_mov_widthwuv4df */

    case 115:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1946; /* *pred_mov_widthwuv8df */

    case 116:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1952; /* *pred_mov_widthwuv16df */

    case 117:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1958; /* *pred_mov_widthwuv32df */

    case 118:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1964; /* *pred_mov_widthwuv64df */

    case 119:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1970; /* *pred_mov_widthwuv128df */

    case 120:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1976; /* *pred_mov_widthwuv256df */

    case 121:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1982; /* *pred_mov_widthwuv512df */

    default:
      return -1;
    }
}

 int
recog_934 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern722 (x2))
    {
    case 0:
      if (register_operand (operands[4], E_RVVM8QImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11406; /* pred_aaddrvvm8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11882; /* pred_aaddrvvm8qi_scalar */

    case 1:
      if (register_operand (operands[4], E_RVVM4QImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11413; /* pred_aaddrvvm4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11887; /* pred_aaddrvvm4qi_scalar */

    case 2:
      if (register_operand (operands[4], E_RVVM2QImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11420; /* pred_aaddrvvm2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11892; /* pred_aaddrvvm2qi_scalar */

    case 3:
      if (register_operand (operands[4], E_RVVM1QImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11427; /* pred_aaddrvvm1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11897; /* pred_aaddrvvm1qi_scalar */

    case 4:
      if (register_operand (operands[4], E_RVVM8HImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11434; /* pred_aaddrvvm8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11917; /* pred_aaddrvvm8hi_scalar */

    case 5:
      if (register_operand (operands[4], E_RVVM4HImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11441; /* pred_aaddrvvm4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11922; /* pred_aaddrvvm4hi_scalar */

    case 6:
      if (register_operand (operands[4], E_RVVM2HImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11448; /* pred_aaddrvvm2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11927; /* pred_aaddrvvm2hi_scalar */

    case 7:
      if (register_operand (operands[4], E_RVVM1HImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11455; /* pred_aaddrvvm1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11932; /* pred_aaddrvvm1hi_scalar */

    case 8:
      if (register_operand (operands[4], E_RVVM8SImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11462; /* pred_aaddrvvm8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11947; /* pred_aaddrvvm8si_scalar */

    case 9:
      if (register_operand (operands[4], E_RVVM4SImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11469; /* pred_aaddrvvm4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11952; /* pred_aaddrvvm4si_scalar */

    case 10:
      if (register_operand (operands[4], E_RVVM2SImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11476; /* pred_aaddrvvm2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11957; /* pred_aaddrvvm2si_scalar */

    case 11:
      if (register_operand (operands[4], E_RVVM1SImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11483; /* pred_aaddrvvm1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11962; /* pred_aaddrvvm1si_scalar */

    case 12:
      if (register_operand (operands[4], E_RVVM8DImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11490; /* pred_aaddrvvm8di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12196; /* *pred_aaddrvvm8di_scalar */

    case 13:
      if (register_operand (operands[4], E_RVVM4DImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11497; /* pred_aaddrvvm4di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12201; /* *pred_aaddrvvm4di_scalar */

    case 14:
      if (register_operand (operands[4], E_RVVM2DImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11504; /* pred_aaddrvvm2di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12206; /* *pred_aaddrvvm2di_scalar */

    case 15:
      if (register_operand (operands[4], E_RVVM1DImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11511; /* pred_aaddrvvm1di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12211; /* *pred_aaddrvvm1di_scalar */

    case 16:
      if (register_operand (operands[4], E_RVVMF2QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11518; /* pred_aaddrvvmf2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11902; /* pred_aaddrvvmf2qi_scalar */

    case 17:
      if (register_operand (operands[4], E_RVVMF4QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11525; /* pred_aaddrvvmf4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11907; /* pred_aaddrvvmf4qi_scalar */

    case 18:
      if (register_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11532; /* pred_aaddrvvmf8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11912; /* pred_aaddrvvmf8qi_scalar */

    case 19:
      if (register_operand (operands[4], E_RVVMF2HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11539; /* pred_aaddrvvmf2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11937; /* pred_aaddrvvmf2hi_scalar */

    case 20:
      if (register_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11546; /* pred_aaddrvvmf4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11942; /* pred_aaddrvvmf4hi_scalar */

    case 21:
      if (register_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11553; /* pred_aaddrvvmf2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11967; /* pred_aaddrvvmf2si_scalar */

    case 22:
      if (register_operand (operands[4], E_V1QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 11560; /* pred_aaddv1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 11972; /* pred_aaddv1qi_scalar */

    case 23:
      if (register_operand (operands[4], E_V2QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 11567; /* pred_aaddv2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 11977; /* pred_aaddv2qi_scalar */

    case 24:
      if (register_operand (operands[4], E_V4QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 11574; /* pred_aaddv4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 11982; /* pred_aaddv4qi_scalar */

    case 25:
      if (register_operand (operands[4], E_V8QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 11581; /* pred_aaddv8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 11987; /* pred_aaddv8qi_scalar */

    case 26:
      if (register_operand (operands[4], E_V16QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 11588; /* pred_aaddv16qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 11992; /* pred_aaddv16qi_scalar */

    case 27:
      if (register_operand (operands[4], E_V32QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 11595; /* pred_aaddv32qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 11997; /* pred_aaddv32qi_scalar */

    case 28:
      if (register_operand (operands[4], E_V64QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 11602; /* pred_aaddv64qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12002; /* pred_aaddv64qi_scalar */

    case 29:
      if (register_operand (operands[4], E_V128QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 11609; /* pred_aaddv128qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12007; /* pred_aaddv128qi_scalar */

    case 30:
      if (register_operand (operands[4], E_V256QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 11616; /* pred_aaddv256qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12012; /* pred_aaddv256qi_scalar */

    case 31:
      if (register_operand (operands[4], E_V512QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 11623; /* pred_aaddv512qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12017; /* pred_aaddv512qi_scalar */

    case 32:
      if (register_operand (operands[4], E_V1024QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 11630; /* pred_aaddv1024qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12022; /* pred_aaddv1024qi_scalar */

    case 33:
      if (register_operand (operands[4], E_V2048QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 11637; /* pred_aaddv2048qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12027; /* pred_aaddv2048qi_scalar */

    case 34:
      if (register_operand (operands[4], E_V4096QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 11644; /* pred_aaddv4096qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12032; /* pred_aaddv4096qi_scalar */

    case 35:
      if (register_operand (operands[4], E_V1HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 11651; /* pred_aaddv1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 12037; /* pred_aaddv1hi_scalar */

    case 36:
      if (register_operand (operands[4], E_V2HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 11658; /* pred_aaddv2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12042; /* pred_aaddv2hi_scalar */

    case 37:
      if (register_operand (operands[4], E_V4HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 11665; /* pred_aaddv4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12047; /* pred_aaddv4hi_scalar */

    case 38:
      if (register_operand (operands[4], E_V8HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 11672; /* pred_aaddv8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12052; /* pred_aaddv8hi_scalar */

    case 39:
      if (register_operand (operands[4], E_V16HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 11679; /* pred_aaddv16hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12057; /* pred_aaddv16hi_scalar */

    case 40:
      if (register_operand (operands[4], E_V32HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 11686; /* pred_aaddv32hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12062; /* pred_aaddv32hi_scalar */

    case 41:
      if (register_operand (operands[4], E_V64HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 11693; /* pred_aaddv64hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12067; /* pred_aaddv64hi_scalar */

    case 42:
      if (register_operand (operands[4], E_V128HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 11700; /* pred_aaddv128hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12072; /* pred_aaddv128hi_scalar */

    case 43:
      if (register_operand (operands[4], E_V256HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 11707; /* pred_aaddv256hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12077; /* pred_aaddv256hi_scalar */

    case 44:
      if (register_operand (operands[4], E_V512HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 11714; /* pred_aaddv512hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12082; /* pred_aaddv512hi_scalar */

    case 45:
      if (register_operand (operands[4], E_V1024HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 11721; /* pred_aaddv1024hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12087; /* pred_aaddv1024hi_scalar */

    case 46:
      if (register_operand (operands[4], E_V2048HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 11728; /* pred_aaddv2048hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12092; /* pred_aaddv2048hi_scalar */

    case 47:
      if (register_operand (operands[4], E_V1SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 11735; /* pred_aaddv1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 12097; /* pred_aaddv1si_scalar */

    case 48:
      if (register_operand (operands[4], E_V2SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 11742; /* pred_aaddv2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12102; /* pred_aaddv2si_scalar */

    case 49:
      if (register_operand (operands[4], E_V4SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 11749; /* pred_aaddv4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12107; /* pred_aaddv4si_scalar */

    case 50:
      if (register_operand (operands[4], E_V8SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 11756; /* pred_aaddv8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12112; /* pred_aaddv8si_scalar */

    case 51:
      if (register_operand (operands[4], E_V16SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 11763; /* pred_aaddv16si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12117; /* pred_aaddv16si_scalar */

    case 52:
      if (register_operand (operands[4], E_V32SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 11770; /* pred_aaddv32si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12122; /* pred_aaddv32si_scalar */

    case 53:
      if (register_operand (operands[4], E_V64SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 11777; /* pred_aaddv64si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12127; /* pred_aaddv64si_scalar */

    case 54:
      if (register_operand (operands[4], E_V128SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 11784; /* pred_aaddv128si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12132; /* pred_aaddv128si_scalar */

    case 55:
      if (register_operand (operands[4], E_V256SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 11791; /* pred_aaddv256si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12137; /* pred_aaddv256si_scalar */

    case 56:
      if (register_operand (operands[4], E_V512SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 11798; /* pred_aaddv512si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12142; /* pred_aaddv512si_scalar */

    case 57:
      if (register_operand (operands[4], E_V1024SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 11805; /* pred_aaddv1024si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12147; /* pred_aaddv1024si_scalar */

    case 58:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11812; /* pred_aaddv1di */

    case 59:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11819; /* pred_aaddv2di */

    case 60:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11826; /* pred_aaddv4di */

    case 61:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11833; /* pred_aaddv8di */

    case 62:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11840; /* pred_aaddv16di */

    case 63:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11847; /* pred_aaddv32di */

    case 64:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11854; /* pred_aaddv64di */

    case 65:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11861; /* pred_aaddv128di */

    case 66:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11868; /* pred_aaddv256di */

    case 67:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11875; /* pred_aaddv512di */

    case 68:
      if (!(
#line 4679 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12216; /* *pred_aaddrvvm8di_extended_scalar */

    case 69:
      if (!(
#line 4679 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12221; /* *pred_aaddrvvm4di_extended_scalar */

    case 70:
      if (!(
#line 4679 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12226; /* *pred_aaddrvvm2di_extended_scalar */

    case 71:
      if (!(
#line 4679 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12231; /* *pred_aaddrvvm1di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_1047 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM2HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM2HFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15738; /* *pred_mul_neg_addrvvm2hf_undef */
}

 int
recog_1056 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM8DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM8DFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15756; /* *pred_mul_neg_addrvvm8df_undef */
}

 int
recog_1066 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V64HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V64HFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15776; /* *pred_mul_neg_addv64hf_undef */
}

 int
recog_1076 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V16SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V16SFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15796; /* *pred_mul_neg_addv16sf_undef */
}

 int
recog_1086 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V8DFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15816; /* *pred_mul_neg_addv8df_undef */
}

 int
recog_1096 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1089 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V64DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return 15918; /* *pred_nmsubv64df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 16014; /* *pred_nmsacv64df */
}

 int
recog_1106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1079 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V128SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V128SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return 15898; /* *pred_nmsubv128sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15994; /* *pred_nmsacv128sf */
}

 int
recog_1116 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1069 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V512HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return 15878; /* *pred_nmsubv512hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15974; /* *pred_nmsacv512hf */
}

 int
recog_1126 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1059 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM1DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM1DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15858; /* *pred_nmsubrvvm1df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15954; /* *pred_nmsacrvvm1df */
}

 int
recog_1136 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1049 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVMF2HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVMF2HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15838; /* *pred_nmsubrvvmf2hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15934; /* *pred_nmsacrvvmf2hf */
}

 int
recog_1146 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM2HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM2HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM2HFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15259; /* *pred_mul_subrvvm2hf_undef */
}

 int
recog_1153 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM1SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM1SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM1SFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15273; /* *pred_mul_subrvvm1sf_undef */
}

 int
recog_1160 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2HFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15287; /* *pred_mul_subv2hf_undef */
}

 int
recog_1167 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V256HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V256HFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15301; /* *pred_mul_subv256hf_undef */
}

 int
recog_1174 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V8SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V8SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V8SFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15315; /* *pred_mul_subv8sf_undef */
}

 int
recog_1181 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V1024SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V1024SFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15329; /* *pred_mul_subv1024sf_undef */
}

 int
recog_1188 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V64DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V64DFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15343; /* *pred_mul_subv64df_undef */
}

 int
recog_1195 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1188 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return 15439; /* *pred_msubv64df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15535; /* *pred_msacv64df */
}

 int
recog_1202 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1181 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1024SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return 15425; /* *pred_msubv1024sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15521; /* *pred_msacv1024sf */
}

 int
recog_1209 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1174 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V8SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15411; /* *pred_msubv8sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15507; /* *pred_msacv8sf */
}

 int
recog_1216 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1167 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return 15397; /* *pred_msubv256hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15493; /* *pred_msacv256hf */
}

 int
recog_1223 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1160 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return 15383; /* *pred_msubv2hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15479; /* *pred_msacv2hf */
}

 int
recog_1230 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1153 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM1SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM1SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15369; /* *pred_msubrvvm1sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15465; /* *pred_msacrvvm1sf */
}

 int
recog_1237 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1146 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM2HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15355; /* *pred_msubrvvm2hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15451; /* *pred_msacrvvm2hf */
}

 int
recog_1244 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVMF2HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVMF2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVMF2HFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15743; /* *pred_mul_neg_subrvvmf2hf_undef */
}

 int
recog_1251 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM8DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM8DFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15757; /* *pred_mul_neg_subrvvm8df_undef */
}

 int
recog_1258 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V8HFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return -1;
  return 15771; /* *pred_mul_neg_subv8hf_undef */
}

 int
recog_1265 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1024HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1024HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1024HFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15785; /* *pred_mul_neg_subv1024hf_undef */
}

 int
recog_1272 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V32SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V32SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V32SFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15799; /* *pred_mul_neg_subv32sf_undef */
}

 int
recog_1279 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V2DFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15813; /* *pred_mul_neg_subv2df_undef */
}

 int
recog_1286 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V256DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V256DFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15827; /* *pred_mul_neg_subv256df_undef */
}

 int
recog_1293 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1282 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V16DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V16DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return 15915; /* *pred_nmaddv16df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 16011; /* *pred_nmaccv16df */
}

 int
recog_1300 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1275 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V256SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V256SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return 15901; /* *pred_nmaddv256sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15997; /* *pred_nmaccv256sf */
}

 int
recog_1307 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1268 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V2SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V2SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15887; /* *pred_nmaddv2sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15983; /* *pred_nmaccv2sf */
}

 int
recog_1314 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1261 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V64HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V64HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return 15873; /* *pred_nmaddv64hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15969; /* *pred_nmaccv64hf */
}

 int
recog_1322 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1253 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM2DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM2DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15857; /* *pred_nmaddrvvm2df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15953; /* *pred_nmaccrvvm2df */
}

 int
recog_1330 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1245 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVMF4HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVMF4HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
    return 15841; /* *pred_nmaddrvvmf4hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 15937; /* *pred_nmaccrvvmf4hf */
}

 int
recog_1338 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XVECEXP (x5, 0, 5);
  operands[9] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  x12 = XEXP (x3, 1);
  switch (GET_CODE (x12))
    {
    case REG:
    case SUBREG:
      switch (pattern713 (x2))
        {
        case 0:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14500; /* pred_subrvvm8hf */

        case 1:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14504; /* pred_subrvvm4hf */

        case 2:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14508; /* pred_subrvvm2hf */

        case 3:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14512; /* pred_subrvvm1hf */

        case 4:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14516; /* pred_subrvvmf2hf */

        case 5:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14520; /* pred_subrvvmf4hf */

        case 6:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14524; /* pred_subrvvm8sf */

        case 7:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14528; /* pred_subrvvm4sf */

        case 8:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14532; /* pred_subrvvm2sf */

        case 9:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14536; /* pred_subrvvm1sf */

        case 10:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14540; /* pred_subrvvmf2sf */

        case 11:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14544; /* pred_subrvvm8df */

        case 12:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14548; /* pred_subrvvm4df */

        case 13:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14552; /* pred_subrvvm2df */

        case 14:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14556; /* pred_subrvvm1df */

        case 15:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 14560; /* pred_subv1hf */

        case 16:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 14564; /* pred_subv2hf */

        case 17:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 14568; /* pred_subv4hf */

        case 18:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 14572; /* pred_subv8hf */

        case 19:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 14576; /* pred_subv16hf */

        case 20:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14580; /* pred_subv32hf */

        case 21:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14584; /* pred_subv64hf */

        case 22:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14588; /* pred_subv128hf */

        case 23:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14592; /* pred_subv256hf */

        case 24:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14596; /* pred_subv512hf */

        case 25:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14600; /* pred_subv1024hf */

        case 26:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14604; /* pred_subv2048hf */

        case 27:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14608; /* pred_subv1sf */

        case 28:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14612; /* pred_subv2sf */

        case 29:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14616; /* pred_subv4sf */

        case 30:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14620; /* pred_subv8sf */

        case 31:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14624; /* pred_subv16sf */

        case 32:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14628; /* pred_subv32sf */

        case 33:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14632; /* pred_subv64sf */

        case 34:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14636; /* pred_subv128sf */

        case 35:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14640; /* pred_subv256sf */

        case 36:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14644; /* pred_subv512sf */

        case 37:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14648; /* pred_subv1024sf */

        case 38:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14652; /* pred_subv1df */

        case 39:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14656; /* pred_subv2df */

        case 40:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14660; /* pred_subv4df */

        case 41:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 14664; /* pred_subv8df */

        case 42:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 14668; /* pred_subv16df */

        case 43:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 14672; /* pred_subv32df */

        case 44:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 14676; /* pred_subv64df */

        case 45:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 14680; /* pred_subv128df */

        case 46:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 14684; /* pred_subv256df */

        case 47:
          if (!(
#line 6202 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 14688; /* pred_subv512df */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern728 (x2))
        {
        case 0:
          if (!(
#line 6336 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14972; /* pred_subrvvm8hf_scalar */

        case 1:
          if (!(
#line 6336 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14974; /* pred_subrvvm4hf_scalar */

        case 2:
          if (!(
#line 6336 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14976; /* pred_subrvvm2hf_scalar */

        case 3:
          if (!(
#line 6336 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14978; /* pred_subrvvm1hf_scalar */

        case 4:
          if (!(
#line 6336 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 14980; /* pred_subrvvmf2hf_scalar */

        case 5:
          if (!(
#line 6336 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14982; /* pred_subrvvmf4hf_scalar */

        case 6:
          if (!(
#line 6336 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14984; /* pred_subrvvm8sf_scalar */

        case 7:
          if (!(
#line 6336 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14986; /* pred_subrvvm4sf_scalar */

        case 8:
          if (!(
#line 6336 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14988; /* pred_subrvvm2sf_scalar */

        case 9:
          if (!(
#line 6336 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 14990; /* pred_subrvvm1sf_scalar */

        case 10:
          if (!(
#line 6336 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14992; /* pred_subrvvmf2sf_scalar */

        case 11:
          if (!(
#line 6336 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14994; /* pred_subrvvm8df_scalar */

        case 12:
          if (!(
#line 6336 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14996; /* pred_subrvvm4df_scalar */

        case 13:
          if (!(
#line 6336 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 14998; /* pred_subrvvm2df_scalar */

        case 14:
          if (!(
#line 6336 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 15000; /* pred_subrvvm1df_scalar */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x13 = XEXP (x12, 0);
      switch (GET_CODE (x13))
        {
        case REG:
        case SUBREG:
          operands[4] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern542 (x2, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16613; /* pred_single_widen_subrvvm8sf */

            case E_RVVM4SFmode:
              if (pattern542 (x2, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16614; /* pred_single_widen_subrvvm4sf */

            case E_RVVM2SFmode:
              if (pattern542 (x2, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16615; /* pred_single_widen_subrvvm2sf */

            case E_RVVM1SFmode:
              if (pattern542 (x2, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16616; /* pred_single_widen_subrvvm1sf */

            case E_RVVMF2SFmode:
              if (pattern542 (x2, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 16617; /* pred_single_widen_subrvvmf2sf */

            case E_RVVM8DFmode:
              if (pattern542 (x2, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16618; /* pred_single_widen_subrvvm8df */

            case E_RVVM4DFmode:
              if (pattern542 (x2, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16619; /* pred_single_widen_subrvvm4df */

            case E_RVVM2DFmode:
              if (pattern542 (x2, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16620; /* pred_single_widen_subrvvm2df */

            case E_RVVM1DFmode:
              if (pattern542 (x2, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16621; /* pred_single_widen_subrvvm1df */

            case E_V1SFmode:
              if (pattern542 (x2, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16622; /* pred_single_widen_subv1sf */

            case E_V2SFmode:
              if (pattern542 (x2, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16623; /* pred_single_widen_subv2sf */

            case E_V4SFmode:
              if (pattern542 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16624; /* pred_single_widen_subv4sf */

            case E_V8SFmode:
              if (pattern542 (x2, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16625; /* pred_single_widen_subv8sf */

            case E_V16SFmode:
              if (pattern542 (x2, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16626; /* pred_single_widen_subv16sf */

            case E_V32SFmode:
              if (pattern542 (x2, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16627; /* pred_single_widen_subv32sf */

            case E_V64SFmode:
              if (pattern542 (x2, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16628; /* pred_single_widen_subv64sf */

            case E_V128SFmode:
              if (pattern542 (x2, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16629; /* pred_single_widen_subv128sf */

            case E_V256SFmode:
              if (pattern542 (x2, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16630; /* pred_single_widen_subv256sf */

            case E_V512SFmode:
              if (pattern542 (x2, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16631; /* pred_single_widen_subv512sf */

            case E_V1024SFmode:
              if (pattern542 (x2, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16632; /* pred_single_widen_subv1024sf */

            case E_V1DFmode:
              if (pattern542 (x2, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16633; /* pred_single_widen_subv1df */

            case E_V2DFmode:
              if (pattern542 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16634; /* pred_single_widen_subv2df */

            case E_V4DFmode:
              if (pattern542 (x2, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16635; /* pred_single_widen_subv4df */

            case E_V8DFmode:
              if (pattern542 (x2, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16636; /* pred_single_widen_subv8df */

            case E_V16DFmode:
              if (pattern542 (x2, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16637; /* pred_single_widen_subv16df */

            case E_V32DFmode:
              if (pattern542 (x2, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16638; /* pred_single_widen_subv32df */

            case E_V64DFmode:
              if (pattern542 (x2, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16639; /* pred_single_widen_subv64df */

            case E_V128DFmode:
              if (pattern542 (x2, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16640; /* pred_single_widen_subv128df */

            case E_V256DFmode:
              if (pattern542 (x2, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16641; /* pred_single_widen_subv256df */

            case E_V512DFmode:
              if (pattern542 (x2, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0
                  || !(
#line 7115 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16642; /* pred_single_widen_subv512df */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          switch (pattern734 (x2))
            {
            case 0:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16644; /* pred_single_widen_subrvvm8sf_scalar */

            case 1:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16646; /* pred_single_widen_subrvvm4sf_scalar */

            case 2:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16648; /* pred_single_widen_subrvvm2sf_scalar */

            case 3:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16650; /* pred_single_widen_subrvvm1sf_scalar */

            case 4:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 16652; /* pred_single_widen_subrvvmf2sf_scalar */

            case 5:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16654; /* pred_single_widen_subrvvm8df_scalar */

            case 6:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16656; /* pred_single_widen_subrvvm4df_scalar */

            case 7:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16658; /* pred_single_widen_subrvvm2df_scalar */

            case 8:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16660; /* pred_single_widen_subrvvm1df_scalar */

            case 9:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16662; /* pred_single_widen_subv1sf_scalar */

            case 10:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16664; /* pred_single_widen_subv2sf_scalar */

            case 11:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16666; /* pred_single_widen_subv4sf_scalar */

            case 12:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
                return -1;
              return 16668; /* pred_single_widen_subv8sf_scalar */

            case 13:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16670; /* pred_single_widen_subv16sf_scalar */

            case 14:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16672; /* pred_single_widen_subv32sf_scalar */

            case 15:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16674; /* pred_single_widen_subv64sf_scalar */

            case 16:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16676; /* pred_single_widen_subv128sf_scalar */

            case 17:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16678; /* pred_single_widen_subv256sf_scalar */

            case 18:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16680; /* pred_single_widen_subv512sf_scalar */

            case 19:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16682; /* pred_single_widen_subv1024sf_scalar */

            case 20:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16684; /* pred_single_widen_subv1df_scalar */

            case 21:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16686; /* pred_single_widen_subv2df_scalar */

            case 22:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
                return -1;
              return 16688; /* pred_single_widen_subv4df_scalar */

            case 23:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 16690; /* pred_single_widen_subv8df_scalar */

            case 24:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 16692; /* pred_single_widen_subv16df_scalar */

            case 25:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 16694; /* pred_single_widen_subv32df_scalar */

            case 26:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 16696; /* pred_single_widen_subv64df_scalar */

            case 27:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 16698; /* pred_single_widen_subv128df_scalar */

            case 28:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 16700; /* pred_single_widen_subv256df_scalar */

            case 29:
              if (!(
#line 7141 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 16702; /* pred_single_widen_subv512df_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1362 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V512QImode:
      if (!register_operand (operands[3], E_V512QImode)
          || !vector_arith_operand (operands[4], E_V512QImode)
          || !(
#line 4769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12458; /* *pred_cmpv512qi_merge_tie_mask */

    case E_V512HImode:
      if (!register_operand (operands[3], E_V512HImode)
          || !vector_arith_operand (operands[4], E_V512HImode)
          || !(
#line 4769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12471; /* *pred_cmpv512hi_merge_tie_mask */

    case E_V512SImode:
      if (!register_operand (operands[3], E_V512SImode)
          || !vector_arith_operand (operands[4], E_V512SImode)
          || !(
#line 4769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12483; /* *pred_cmpv512si_merge_tie_mask */

    case E_V512DImode:
      if (!register_operand (operands[3], E_V512DImode)
          || !vector_arith_operand (operands[4], E_V512DImode)
          || !(
#line 4769 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12494; /* *pred_cmpv512di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1371 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern536 (x2, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V8BImode))
    {
      res = recog_1356 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V8BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V8QImode:
      if (!register_operand (operands[4], E_V8QImode)
          || !vector_arith_operand (operands[5], E_V8QImode))
        return -1;
      if ((
#line 4793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8QImode)) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 12520; /* *pred_cmpv8qi */
      if (!(
#line 4814 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8QImode)) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 12588; /* *pred_cmpv8qi_narrow */

    case E_V8HImode:
      if (!register_operand (operands[4], E_V8HImode)
          || !vector_arith_operand (operands[5], E_V8HImode))
        return -1;
      if ((
#line 4793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8HImode)) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 12533; /* *pred_cmpv8hi */
      if (!(
#line 4814 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8HImode)) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12601; /* *pred_cmpv8hi_narrow */

    case E_V8SImode:
      if (!register_operand (operands[4], E_V8SImode)
          || !vector_arith_operand (operands[5], E_V8SImode))
        return -1;
      if ((
#line 4793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8SImode)) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 12545; /* *pred_cmpv8si */
      if (!(
#line 4814 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8SImode)) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12613; /* *pred_cmpv8si_narrow */

    case E_V8DImode:
      if (!register_operand (operands[4], E_V8DImode)
          || !vector_arith_operand (operands[5], E_V8DImode))
        return -1;
      if ((
#line 4793 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8DImode)) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 12556; /* *pred_cmpv8di */
      if (!(
#line 4814 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8DImode)) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12624; /* *pred_cmpv8di_narrow */

    default:
      return -1;
    }
}

 int
recog_1378 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1SImode:
      if (!register_operand (operands[3], E_RVVM1SImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM1SImode)
          || !
#line 4851 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12642; /* *pred_ltgervvm1si_merge_tie_mask */

    case E_RVVM2DImode:
      if (!register_operand (operands[3], E_RVVM2DImode)
          || !vector_neg_arith_operand (operands[4], E_RVVM2DImode)
          || !(
#line 4851 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12645; /* *pred_ltgervvm2di_merge_tie_mask */

    case E_RVVMF4QImode:
      if (!register_operand (operands[3], E_RVVMF4QImode)
          || !vector_neg_arith_operand (operands[4], E_RVVMF4QImode)
          || !(
#line 4851 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 12648; /* *pred_ltgervvmf4qi_merge_tie_mask */

    case E_RVVMF2HImode:
      if (!register_operand (operands[3], E_RVVMF2HImode)
          || !vector_neg_arith_operand (operands[4], E_RVVMF2HImode)
          || !(
#line 4851 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 12650; /* *pred_ltgervvmf2hi_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1383 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8QImode:
      if (!register_operand (operands[3], E_V8QImode)
          || !vector_neg_arith_operand (operands[4], E_V8QImode)
          || !(
#line 4851 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 12656; /* *pred_ltgev8qi_merge_tie_mask */

    case E_V8HImode:
      if (!register_operand (operands[3], E_V8HImode)
          || !vector_neg_arith_operand (operands[4], E_V8HImode)
          || !(
#line 4851 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12669; /* *pred_ltgev8hi_merge_tie_mask */

    case E_V8SImode:
      if (!register_operand (operands[3], E_V8SImode)
          || !vector_neg_arith_operand (operands[4], E_V8SImode)
          || !(
#line 4851 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12681; /* *pred_ltgev8si_merge_tie_mask */

    case E_V8DImode:
      if (!register_operand (operands[3], E_V8DImode)
          || !vector_neg_arith_operand (operands[4], E_V8DImode)
          || !(
#line 4851 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12692; /* *pred_ltgev8di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1390 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V1024QImode:
      if (!register_operand (operands[3], E_V1024QImode)
          || !vector_neg_arith_operand (operands[4], E_V1024QImode)
          || !(
#line 4851 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12663; /* *pred_ltgev1024qi_merge_tie_mask */

    case E_V1024HImode:
      if (!register_operand (operands[3], E_V1024HImode)
          || !vector_neg_arith_operand (operands[4], E_V1024HImode)
          || !(
#line 4851 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12676; /* *pred_ltgev1024hi_merge_tie_mask */

    case E_V1024SImode:
      if (!register_operand (operands[3], E_V1024SImode)
          || !vector_neg_arith_operand (operands[4], E_V1024SImode)
          || !(
#line 4851 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12688; /* *pred_ltgev1024si_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1396 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern537 (x2, 
E_V32BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V32BImode))
    {
      res = recog_1385 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V32BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V32BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V32QImode:
      if (!register_operand (operands[4], E_V32QImode)
          || !vector_neg_arith_operand (operands[5], E_V32QImode))
        return -1;
      if ((
#line 4875 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32QImode)) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 12726; /* *pred_ltgev32qi */
      if (!(
#line 4896 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32QImode)) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 12794; /* *pred_ltgev32qi_narrow */

    case E_V32HImode:
      if (!register_operand (operands[4], E_V32HImode)
          || !vector_neg_arith_operand (operands[5], E_V32HImode))
        return -1;
      if ((
#line 4875 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32HImode)) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 12739; /* *pred_ltgev32hi */
      if (!(
#line 4896 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32HImode)) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12807; /* *pred_ltgev32hi_narrow */

    case E_V32SImode:
      if (!register_operand (operands[4], E_V32SImode)
          || !vector_neg_arith_operand (operands[5], E_V32SImode))
        return -1;
      if ((
#line 4875 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32SImode)) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 12751; /* *pred_ltgev32si */
      if (!(
#line 4896 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32SImode)) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12819; /* *pred_ltgev32si_narrow */

    case E_V32DImode:
      if (!register_operand (operands[4], E_V32DImode)
          || !vector_neg_arith_operand (operands[5], E_V32DImode))
        return -1;
      if ((
#line 4875 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V32DImode)) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 12762; /* *pred_ltgev32di */
      if (!(
#line 4896 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V32DImode)) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12830; /* *pred_ltgev32di_narrow */

    default:
      return -1;
    }
}

 int
recog_1405 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF4QImode:
      if (!register_operand (operands[3], E_RVVMF4QImode)
          || GET_MODE (x9) != E_RVVMF4QImode
          || !register_operand (operands[4], E_QImode)
          || !
#line 4935 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12840; /* *pred_cmprvvmf4qi_scalar_merge_tie_mask */

    case E_RVVMF2HImode:
      if (!register_operand (operands[3], E_RVVMF2HImode)
          || GET_MODE (x9) != E_RVVMF2HImode
          || !register_operand (operands[4], E_HImode)
          || !
#line 4935 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12846; /* *pred_cmprvvmf2hi_scalar_merge_tie_mask */

    case E_RVVM1SImode:
      if (!register_operand (operands[3], E_RVVM1SImode)
          || GET_MODE (x9) != E_RVVM1SImode
          || !register_operand (operands[4], E_SImode)
          || !
#line 4935 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12851; /* *pred_cmprvvm1si_scalar_merge_tie_mask */

    case E_RVVM2DImode:
      if (!register_operand (operands[3], E_RVVM2DImode)
          || GET_MODE (x9) != E_RVVM2DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5045 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12999; /* *pred_cmprvvm2di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1412 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V32QImode:
      if (!register_operand (operands[3], E_V32QImode)
          || GET_MODE (x9) != E_V32QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4935 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 12858; /* *pred_cmpv32qi_scalar_merge_tie_mask */

    case E_V32HImode:
      if (!register_operand (operands[3], E_V32HImode)
          || GET_MODE (x9) != E_V32HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4935 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12871; /* *pred_cmpv32hi_scalar_merge_tie_mask */

    case E_V32SImode:
      if (!register_operand (operands[3], E_V32SImode)
          || GET_MODE (x9) != E_V32SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4935 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12883; /* *pred_cmpv32si_scalar_merge_tie_mask */

    case E_V32DImode:
      if (!register_operand (operands[3], E_V32DImode)
          || GET_MODE (x9) != E_V32DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5045 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 13006; /* *pred_cmpv32di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1419 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern571 (x2, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V512BImode))
    {
      res = recog_1416 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V512BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V512BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V512QImode:
      if (!register_operand (operands[4], E_V512QImode)
          || GET_MODE (x9) != E_V512QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512QImode)) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 12916; /* *pred_cmpv512qi_scalar */
      if (!(
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512QImode)) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12970; /* *pred_cmpv512qi_scalar_narrow */

    case E_V512HImode:
      if (!register_operand (operands[4], E_V512HImode)
          || GET_MODE (x9) != E_V512HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512HImode)) && 
#line 752 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 12929; /* *pred_cmpv512hi_scalar */
      if (!(
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512HImode)) && 
#line 752 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12983; /* *pred_cmpv512hi_scalar_narrow */

    case E_V512SImode:
      if (!register_operand (operands[4], E_V512SImode)
          || GET_MODE (x9) != E_V512SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512SImode)) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 12941; /* *pred_cmpv512si_scalar */
      if (!(
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512SImode)) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12995; /* *pred_cmpv512si_scalar_narrow */

    case E_V512DImode:
      if (!register_operand (operands[4], E_V512DImode)
          || GET_MODE (x9) != E_V512DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512DImode)) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 13024; /* *pred_cmpv512di_scalar */
      if (!(
#line 5092 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512DImode)) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 13038; /* *pred_cmpv512di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1426 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern571 (x2, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V4BImode))
    {
      res = recog_1409 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V4BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V4BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V4QImode:
      if (!register_operand (operands[4], E_V4QImode)
          || GET_MODE (x9) != E_V4QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4QImode)) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 12909; /* *pred_cmpv4qi_scalar */
      if (!(
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4QImode)) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 12963; /* *pred_cmpv4qi_scalar_narrow */

    case E_V4HImode:
      if (!register_operand (operands[4], E_V4HImode)
          || GET_MODE (x9) != E_V4HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4HImode)) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 12922; /* *pred_cmpv4hi_scalar */
      if (!(
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4HImode)) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12976; /* *pred_cmpv4hi_scalar_narrow */

    case E_V4SImode:
      if (!register_operand (operands[4], E_V4SImode)
          || GET_MODE (x9) != E_V4SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4SImode)) && 
#line 757 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 12934; /* *pred_cmpv4si_scalar */
      if (!(
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4SImode)) && 
#line 757 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12988; /* *pred_cmpv4si_scalar_narrow */

    case E_V4DImode:
      if (!register_operand (operands[4], E_V4DImode)
          || GET_MODE (x9) != E_V4DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4DImode)) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 13017; /* *pred_cmpv4di_scalar */
      if (!(
#line 5092 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4DImode)) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13031; /* *pred_cmpv4di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1435 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF4HFmode:
      if (!register_operand (operands[3], E_RVVMF4HFmode)
          || !register_operand (operands[4], E_RVVMF4HFmode)
          || !(
#line 7330 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 16996; /* *pred_cmprvvmf4hf_narrow_merge_tie_mask */

    case E_RVVMF2SFmode:
      if (!register_operand (operands[3], E_RVVMF2SFmode)
          || !register_operand (operands[4], E_RVVMF2SFmode)
          || !(
#line 7330 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 17001; /* *pred_cmprvvmf2sf_narrow_merge_tie_mask */

    case E_RVVM1DFmode:
      if (!register_operand (operands[3], E_RVVM1DFmode)
          || !register_operand (operands[4], E_RVVM1DFmode)
          || !(
#line 7330 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17005; /* *pred_cmprvvm1df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1440 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V16HFmode:
      if (!register_operand (operands[3], E_V16HFmode)
          || !register_operand (operands[4], E_V16HFmode)
          || !(
#line 7330 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17010; /* *pred_cmpv16hf_narrow_merge_tie_mask */

    case E_V16SFmode:
      if (!register_operand (operands[3], E_V16SFmode)
          || !register_operand (operands[4], E_V16SFmode)
          || !(
#line 7330 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17022; /* *pred_cmpv16sf_narrow_merge_tie_mask */

    case E_V16DFmode:
      if (!register_operand (operands[3], E_V16DFmode)
          || !register_operand (operands[4], E_V16DFmode)
          || !(
#line 7330 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17033; /* *pred_cmpv16df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1445 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V512HFmode:
      if (!register_operand (operands[3], E_V512HFmode)
          || !register_operand (operands[4], E_V512HFmode)
          || !(
#line 7330 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17015; /* *pred_cmpv512hf_narrow_merge_tie_mask */

    case E_V512SFmode:
      if (!register_operand (operands[3], E_V512SFmode)
          || !register_operand (operands[4], E_V512SFmode)
          || !(
#line 7330 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17027; /* *pred_cmpv512sf_narrow_merge_tie_mask */

    case E_V512DFmode:
      if (!register_operand (operands[3], E_V512DFmode)
          || !register_operand (operands[4], E_V512DFmode)
          || !(
#line 7330 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17038; /* *pred_cmpv512df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1451 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF4HFmode:
      if (!register_operand (operands[3], E_RVVMF4HFmode)
          || GET_MODE (x9) != E_RVVMF4HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7393 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 17092; /* *pred_cmprvvmf4hf_scalar_merge_tie_mask */

    case E_RVVMF2SFmode:
      if (!register_operand (operands[3], E_RVVMF2SFmode)
          || GET_MODE (x9) != E_RVVMF2SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7393 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 17097; /* *pred_cmprvvmf2sf_scalar_merge_tie_mask */

    case E_RVVM1DFmode:
      if (!register_operand (operands[3], E_RVVM1DFmode)
          || GET_MODE (x9) != E_RVVM1DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7393 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17101; /* *pred_cmprvvm1df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1457 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[3], E_V32HFmode)
          || GET_MODE (x9) != E_V32HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7393 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17107; /* *pred_cmpv32hf_scalar_merge_tie_mask */

    case E_V32SFmode:
      if (!register_operand (operands[3], E_V32SFmode)
          || GET_MODE (x9) != E_V32SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7393 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17119; /* *pred_cmpv32sf_scalar_merge_tie_mask */

    case E_V32DFmode:
      if (!register_operand (operands[3], E_V32DFmode)
          || GET_MODE (x9) != E_V32DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7393 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17130; /* *pred_cmpv32df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1463 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern548 (x2, 
E_V512BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V512BImode))
    {
      res = recog_1461 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V512BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V512BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V512HFmode:
      if (!register_operand (operands[4], E_V512HFmode)
          || GET_MODE (x9) != E_V512HFmode
          || !register_operand (operands[5], E_HFmode))
        return -1;
      if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512HFmode)) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return 17159; /* *pred_cmpv512hf_scalar */
      if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512HFmode)) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17207; /* *pred_cmpv512hf_scalar_narrow */

    case E_V512SFmode:
      if (!register_operand (operands[4], E_V512SFmode)
          || GET_MODE (x9) != E_V512SFmode
          || !register_operand (operands[5], E_SFmode))
        return -1;
      if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512SFmode)) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return 17171; /* *pred_cmpv512sf_scalar */
      if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512SFmode)) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17219; /* *pred_cmpv512sf_scalar_narrow */

    case E_V512DFmode:
      if (!register_operand (operands[4], E_V512DFmode)
          || GET_MODE (x9) != E_V512DFmode
          || !register_operand (operands[5], E_DFmode))
        return -1;
      if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V512DFmode)) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return 17182; /* *pred_cmpv512df_scalar */
      if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V512DFmode)) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17230; /* *pred_cmpv512df_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1470 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF2BImode:
      x2 = XEXP (x1, 1);
      if (pattern548 (x2, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern625 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode, 
E_HFmode) == 0
          && (
#line 7393 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 17087; /* *pred_cmprvvm8hf_scalar_merge_tie_mask */
      operands[3] = x3;
      if (pattern626 (x2, 
E_RVVMF2BImode, 
E_RVVM8HFmode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8HFmode)) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 17135; /* *pred_cmprvvm8hf_scalar */
      if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8HFmode)) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17183; /* *pred_cmprvvm8hf_scalar_narrow */

    case E_RVVMF4BImode:
      x2 = XEXP (x1, 1);
      if (pattern548 (x2, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF4BImode))
        {
          res = recog_1447 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF4BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM4HFmode:
          if (!register_operand (operands[4], E_RVVM4HFmode)
              || GET_MODE (x9) != E_RVVM4HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4HFmode)) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return 17136; /* *pred_cmprvvm4hf_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4HFmode)) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17184; /* *pred_cmprvvm4hf_scalar_narrow */

        case E_RVVM8SFmode:
          if (!register_operand (operands[4], E_RVVM8SFmode)
              || GET_MODE (x9) != E_RVVM8SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8SFmode)) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return 17141; /* *pred_cmprvvm8sf_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8SFmode)) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17189; /* *pred_cmprvvm8sf_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF8BImode:
      x2 = XEXP (x1, 1);
      if (pattern548 (x2, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF8BImode))
        {
          res = recog_1448 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF8BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM2HFmode:
          if (!register_operand (operands[4], E_RVVM2HFmode)
              || GET_MODE (x9) != E_RVVM2HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2HFmode)) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return 17137; /* *pred_cmprvvm2hf_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2HFmode)) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17185; /* *pred_cmprvvm2hf_scalar_narrow */

        case E_RVVM4SFmode:
          if (!register_operand (operands[4], E_RVVM4SFmode)
              || GET_MODE (x9) != E_RVVM4SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4SFmode)) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return 17142; /* *pred_cmprvvm4sf_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4SFmode)) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17190; /* *pred_cmprvvm4sf_scalar_narrow */

        case E_RVVM8DFmode:
          if (!register_operand (operands[4], E_RVVM8DFmode)
              || GET_MODE (x9) != E_RVVM8DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8DFmode)) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return 17146; /* *pred_cmprvvm8df_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8DFmode)) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17194; /* *pred_cmprvvm8df_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF16BImode:
      x2 = XEXP (x1, 1);
      if (pattern548 (x2, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF16BImode))
        {
          res = recog_1449 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF16BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1HFmode:
          if (!register_operand (operands[4], E_RVVM1HFmode)
              || GET_MODE (x9) != E_RVVM1HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1HFmode)) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return 17138; /* *pred_cmprvvm1hf_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1HFmode)) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17186; /* *pred_cmprvvm1hf_scalar_narrow */

        case E_RVVM2SFmode:
          if (!register_operand (operands[4], E_RVVM2SFmode)
              || GET_MODE (x9) != E_RVVM2SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2SFmode)) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return 17143; /* *pred_cmprvvm2sf_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2SFmode)) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17191; /* *pred_cmprvvm2sf_scalar_narrow */

        case E_RVVM4DFmode:
          if (!register_operand (operands[4], E_RVVM4DFmode)
              || GET_MODE (x9) != E_RVVM4DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4DFmode)) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return 17147; /* *pred_cmprvvm4df_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4DFmode)) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17195; /* *pred_cmprvvm4df_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF32BImode:
      x2 = XEXP (x1, 1);
      if (pattern548 (x2, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF32BImode))
        {
          res = recog_1450 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF32BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVMF2HFmode:
          if (!register_operand (operands[4], E_RVVMF2HFmode)
              || GET_MODE (x9) != E_RVVMF2HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2HFmode)) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return 17139; /* *pred_cmprvvmf2hf_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2HFmode)) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 17187; /* *pred_cmprvvmf2hf_scalar_narrow */

        case E_RVVM1SFmode:
          if (!register_operand (operands[4], E_RVVM1SFmode)
              || GET_MODE (x9) != E_RVVM1SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1SFmode)) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return 17144; /* *pred_cmprvvm1sf_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1SFmode)) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17192; /* *pred_cmprvvm1sf_scalar_narrow */

        case E_RVVM2DFmode:
          if (!register_operand (operands[4], E_RVVM2DFmode)
              || GET_MODE (x9) != E_RVVM2DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2DFmode)) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return 17148; /* *pred_cmprvvm2df_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2DFmode)) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17196; /* *pred_cmprvvm2df_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF64BImode:
      x2 = XEXP (x1, 1);
      if (pattern548 (x2, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF64BImode))
        {
          res = recog_1451 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF64BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVMF4HFmode:
          if (!register_operand (operands[4], E_RVVMF4HFmode)
              || GET_MODE (x9) != E_RVVMF4HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4HFmode)) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return 17140; /* *pred_cmprvvmf4hf_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4HFmode)) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 17188; /* *pred_cmprvvmf4hf_scalar_narrow */

        case E_RVVMF2SFmode:
          if (!register_operand (operands[4], E_RVVMF2SFmode)
              || GET_MODE (x9) != E_RVVMF2SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2SFmode)) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return 17145; /* *pred_cmprvvmf2sf_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2SFmode)) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 17193; /* *pred_cmprvvmf2sf_scalar_narrow */

        case E_RVVM1DFmode:
          if (!register_operand (operands[4], E_RVVM1DFmode)
              || GET_MODE (x9) != E_RVVM1DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1DFmode)) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return 17149; /* *pred_cmprvvm1df_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1DFmode)) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17197; /* *pred_cmprvvm1df_scalar_narrow */

        default:
          return -1;
        }

    case E_V1BImode:
      x2 = XEXP (x1, 1);
      if (pattern548 (x2, 
E_V1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1BImode))
        {
          res = recog_1452 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_V1BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1HFmode:
          if (!register_operand (operands[4], E_V1HFmode)
              || GET_MODE (x9) != E_V1HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1HFmode)) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return 17150; /* *pred_cmpv1hf_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1HFmode)) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 17198; /* *pred_cmpv1hf_scalar_narrow */

        case E_V1SFmode:
          if (!register_operand (operands[4], E_V1SFmode)
              || GET_MODE (x9) != E_V1SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1SFmode)) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return 17162; /* *pred_cmpv1sf_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1SFmode)) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17210; /* *pred_cmpv1sf_scalar_narrow */

        case E_V1DFmode:
          if (!register_operand (operands[4], E_V1DFmode)
              || GET_MODE (x9) != E_V1DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1DFmode)) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return 17173; /* *pred_cmpv1df_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1DFmode)) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17221; /* *pred_cmpv1df_scalar_narrow */

        default:
          return -1;
        }

    case E_V2BImode:
      x2 = XEXP (x1, 1);
      if (pattern548 (x2, 
E_V2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V2BImode))
        {
          res = recog_1453 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V2BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_V2BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V2HFmode:
          if (!register_operand (operands[4], E_V2HFmode)
              || GET_MODE (x9) != E_V2HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2HFmode)) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return 17151; /* *pred_cmpv2hf_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2HFmode)) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 17199; /* *pred_cmpv2hf_scalar_narrow */

        case E_V2SFmode:
          if (!register_operand (operands[4], E_V2SFmode)
              || GET_MODE (x9) != E_V2SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2SFmode)) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return 17163; /* *pred_cmpv2sf_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2SFmode)) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17211; /* *pred_cmpv2sf_scalar_narrow */

        case E_V2DFmode:
          if (!register_operand (operands[4], E_V2DFmode)
              || GET_MODE (x9) != E_V2DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2DFmode)) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return 17174; /* *pred_cmpv2df_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2DFmode)) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17222; /* *pred_cmpv2df_scalar_narrow */

        default:
          return -1;
        }

    case E_V4BImode:
      x2 = XEXP (x1, 1);
      if (pattern548 (x2, 
E_V4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V4BImode))
        {
          res = recog_1454 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V4BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_V4BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V4HFmode:
          if (!register_operand (operands[4], E_V4HFmode)
              || GET_MODE (x9) != E_V4HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4HFmode)) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return 17152; /* *pred_cmpv4hf_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4HFmode)) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 17200; /* *pred_cmpv4hf_scalar_narrow */

        case E_V4SFmode:
          if (!register_operand (operands[4], E_V4SFmode)
              || GET_MODE (x9) != E_V4SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4SFmode)) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return 17164; /* *pred_cmpv4sf_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4SFmode)) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17212; /* *pred_cmpv4sf_scalar_narrow */

        case E_V4DFmode:
          if (!register_operand (operands[4], E_V4DFmode)
              || GET_MODE (x9) != E_V4DFmode
              || !register_operand (operands[5], E_DFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4DFmode)) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return 17175; /* *pred_cmpv4df_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4DFmode)) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 17223; /* *pred_cmpv4df_scalar_narrow */

        default:
          return -1;
        }

    case E_V8BImode:
      return recog_1469 (x1, insn, pnum_clobbers);

    case E_V16BImode:
      return recog_1468 (x1, insn, pnum_clobbers);

    case E_V32BImode:
      return recog_1467 (x1, insn, pnum_clobbers);

    case E_V64BImode:
      return recog_1466 (x1, insn, pnum_clobbers);

    case E_V128BImode:
      return recog_1464 (x1, insn, pnum_clobbers);

    case E_V256BImode:
      return recog_1465 (x1, insn, pnum_clobbers);

    case E_V512BImode:
      return recog_1463 (x1, insn, pnum_clobbers);

    case E_V1024BImode:
      x2 = XEXP (x1, 1);
      if (pattern548 (x2, 
E_V1024BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1024BImode))
        {
          res = recog_1462 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1024BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_V1024BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1024HFmode:
          if (!register_operand (operands[4], E_V1024HFmode)
              || GET_MODE (x9) != E_V1024HFmode
              || !register_operand (operands[5], E_HFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024HFmode)) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return 17160; /* *pred_cmpv1024hf_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024HFmode)) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 17208; /* *pred_cmpv1024hf_scalar_narrow */

        case E_V1024SFmode:
          if (!register_operand (operands[4], E_V1024SFmode)
              || GET_MODE (x9) != E_V1024SFmode
              || !register_operand (operands[5], E_SFmode))
            return -1;
          if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024SFmode)) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return 17172; /* *pred_cmpv1024sf_scalar */
          if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024SFmode)) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 17220; /* *pred_cmpv1024sf_scalar_narrow */

        default:
          return -1;
        }

    case E_V2048BImode:
      x2 = XEXP (x1, 1);
      if (pattern548 (x2, 
E_V2048BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern625 (x2, 
E_V2048HFmode, 
E_V2048BImode, 
E_HFmode) == 0
          && (
#line 7393 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return 17113; /* *pred_cmpv2048hf_scalar_merge_tie_mask */
      operands[3] = x3;
      if (pattern626 (x2, 
E_V2048BImode, 
E_V2048HFmode, 
E_HFmode) != 0)
        return -1;
      if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048HFmode)) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return 17161; /* *pred_cmpv2048hf_scalar */
      if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048HFmode)) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17209; /* *pred_cmpv2048hf_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1482 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HFmode:
          if (!register_operand (operands[1], E_HFmode)
              || !
#line 2007 "../../gcc/config/riscv/riscv.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN))
            return -1;
          return 134; /* extendhfsf2 */

        case E_BFmode:
          if (!register_operand (operands[1], E_BFmode)
              || !
#line 2016 "../../gcc/config/riscv/riscv.md"
(TARGET_ZFBFMIN))
            return -1;
          return 135; /* extendbfsf2 */

        default:
          return -1;
        }

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !
#line 2025 "../../gcc/config/riscv/riscv.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))
            return -1;
          return 136; /* extendsfdf2 */

        case E_HFmode:
          if (!register_operand (operands[1], E_HFmode)
              || !
#line 2034 "../../gcc/config/riscv/riscv.md"
((TARGET_ZFHMIN && TARGET_DOUBLE_FLOAT) ||
   (TARGET_ZHINXMIN && TARGET_ZDINX)))
            return -1;
          return 137; /* extendhfdf2 */

        default:
          return -1;
        }

    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode)
          || GET_MODE (x3) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVM4HFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26335; /* extendrvvm4hfrvvm8sf2 */

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x3) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM2HFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26336; /* extendrvvm2hfrvvm4sf2 */

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x3) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM1HFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26337; /* extendrvvm1hfrvvm2sf2 */

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x3) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVMF2HFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26338; /* extendrvvmf2hfrvvm1sf2 */

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x3) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF4HFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26339; /* extendrvvmf4hfrvvmf2sf2 */

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode)
          || GET_MODE (x3) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVM4SFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26340; /* extendrvvm4sfrvvm8df2 */

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode)
          || GET_MODE (x3) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVM2SFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26341; /* extendrvvm2sfrvvm4df2 */

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode)
          || GET_MODE (x3) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVM1SFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26342; /* extendrvvm1sfrvvm2df2 */

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode)
          || GET_MODE (x3) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVMF2SFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26343; /* extendrvvmf2sfrvvm1df2 */

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x3) != E_V1SFmode
          || !register_operand (operands[1], E_V1HFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26344; /* extendv1hfv1sf2 */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2HFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26345; /* extendv2hfv2sf2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4HFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26346; /* extendv4hfv4sf2 */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8HFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26347; /* extendv8hfv8sf2 */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x3) != E_V16SFmode
          || !register_operand (operands[1], E_V16HFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26348; /* extendv16hfv16sf2 */

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x3) != E_V32SFmode
          || !register_operand (operands[1], E_V32HFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26349; /* extendv32hfv32sf2 */

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x3) != E_V64SFmode
          || !register_operand (operands[1], E_V64HFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26350; /* extendv64hfv64sf2 */

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x3) != E_V128SFmode
          || !register_operand (operands[1], E_V128HFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1006 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26351; /* extendv128hfv128sf2 */

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x3) != E_V256SFmode
          || !register_operand (operands[1], E_V256HFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26352; /* extendv256hfv256sf2 */

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x3) != E_V512SFmode
          || !register_operand (operands[1], E_V512HFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1008 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26353; /* extendv512hfv512sf2 */

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode)
          || GET_MODE (x3) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024HFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26354; /* extendv1024hfv1024sf2 */

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x3) != E_V1DFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26355; /* extendv1sfv1df2 */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26356; /* extendv2sfv2df2 */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26357; /* extendv4sfv4df2 */

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x3) != E_V8DFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26358; /* extendv8sfv8df2 */

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x3) != E_V16DFmode
          || !register_operand (operands[1], E_V16SFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1014 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26359; /* extendv16sfv16df2 */

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x3) != E_V32DFmode
          || !register_operand (operands[1], E_V32SFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26360; /* extendv32sfv32df2 */

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x3) != E_V64DFmode
          || !register_operand (operands[1], E_V64SFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26361; /* extendv64sfv64df2 */

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode)
          || GET_MODE (x3) != E_V128DFmode
          || !register_operand (operands[1], E_V128SFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1017 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26362; /* extendv128sfv128df2 */

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode)
          || GET_MODE (x3) != E_V256DFmode
          || !register_operand (operands[1], E_V256SFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26363; /* extendv256sfv256df2 */

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode)
          || GET_MODE (x3) != E_V512DFmode
          || !register_operand (operands[1], E_V512SFmode)
          || !(
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26364; /* extendv512sfv512df2 */

    default:
      return -1;
    }
}

 int
recog_1486 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern4 (x1))
    {
    case 0:
      if (!
#line 1693 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
        return -1;
      return 102; /* smaxsf3 */

    case 1:
      if (!(
#line 1693 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 103; /* smaxdf3 */

    case 2:
      if (!(
#line 1693 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 104; /* smaxhf3 */

    case 3:
      if (reg_or_0_operand (operands[2], E_SImode)
          && (
#line 548 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 572; /* *smaxsi3 */
      if (!register_operand (operands[2], E_SImode)
          || !
#line 614 "../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
        return -1;
      return 33927; /* riscv_cv_alu_max */

    case 4:
      if (!(
#line 548 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 576; /* *smaxdi3 */

    case 5:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24546; /* smaxrvvm8qi3 */

    case 6:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24560; /* smaxrvvm4qi3 */

    case 7:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24574; /* smaxrvvm2qi3 */

    case 8:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24588; /* smaxrvvm1qi3 */

    case 9:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24602; /* smaxrvvm8hi3 */

    case 10:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24616; /* smaxrvvm4hi3 */

    case 11:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24630; /* smaxrvvm2hi3 */

    case 12:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24644; /* smaxrvvm1hi3 */

    case 13:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24658; /* smaxrvvm8si3 */

    case 14:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24672; /* smaxrvvm4si3 */

    case 15:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24686; /* smaxrvvm2si3 */

    case 16:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24700; /* smaxrvvm1si3 */

    case 17:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24714; /* smaxrvvm8di3 */

    case 18:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24728; /* smaxrvvm4di3 */

    case 19:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24742; /* smaxrvvm2di3 */

    case 20:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24756; /* smaxrvvm1di3 */

    case 21:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24770; /* smaxrvvmf2qi3 */

    case 22:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24784; /* smaxrvvmf4qi3 */

    case 23:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24798; /* smaxrvvmf8qi3 */

    case 24:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24812; /* smaxrvvmf2hi3 */

    case 25:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24826; /* smaxrvvmf4hi3 */

    case 26:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24840; /* smaxrvvmf2si3 */

    case 27:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24854; /* smaxv1qi3 */

    case 28:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24868; /* smaxv2qi3 */

    case 29:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24882; /* smaxv4qi3 */

    case 30:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24896; /* smaxv8qi3 */

    case 31:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24910; /* smaxv16qi3 */

    case 32:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24924; /* smaxv32qi3 */

    case 33:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24938; /* smaxv64qi3 */

    case 34:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24952; /* smaxv128qi3 */

    case 35:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24966; /* smaxv256qi3 */

    case 36:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24980; /* smaxv512qi3 */

    case 37:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24994; /* smaxv1024qi3 */

    case 38:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25008; /* smaxv2048qi3 */

    case 39:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25022; /* smaxv4096qi3 */

    case 40:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25036; /* smaxv1hi3 */

    case 41:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25050; /* smaxv2hi3 */

    case 42:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25064; /* smaxv4hi3 */

    case 43:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25078; /* smaxv8hi3 */

    case 44:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25092; /* smaxv16hi3 */

    case 45:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25106; /* smaxv32hi3 */

    case 46:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25120; /* smaxv64hi3 */

    case 47:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25134; /* smaxv128hi3 */

    case 48:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25148; /* smaxv256hi3 */

    case 49:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25162; /* smaxv512hi3 */

    case 50:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25176; /* smaxv1024hi3 */

    case 51:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25190; /* smaxv2048hi3 */

    case 52:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25204; /* smaxv1si3 */

    case 53:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25218; /* smaxv2si3 */

    case 54:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25232; /* smaxv4si3 */

    case 55:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25246; /* smaxv8si3 */

    case 56:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25260; /* smaxv16si3 */

    case 57:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25274; /* smaxv32si3 */

    case 58:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25288; /* smaxv64si3 */

    case 59:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25302; /* smaxv128si3 */

    case 60:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25316; /* smaxv256si3 */

    case 61:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25330; /* smaxv512si3 */

    case 62:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25344; /* smaxv1024si3 */

    case 63:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25358; /* smaxv1di3 */

    case 64:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25372; /* smaxv2di3 */

    case 65:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25386; /* smaxv4di3 */

    case 66:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25400; /* smaxv8di3 */

    case 67:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25414; /* smaxv16di3 */

    case 68:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25428; /* smaxv32di3 */

    case 69:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25442; /* smaxv64di3 */

    case 70:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25456; /* smaxv128di3 */

    case 71:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25470; /* smaxv256di3 */

    case 72:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25484; /* smaxv512di3 */

    case 73:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27699; /* smaxrvvm8hf3 */

    case 74:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27701; /* smaxrvvm4hf3 */

    case 75:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27703; /* smaxrvvm2hf3 */

    case 76:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27705; /* smaxrvvm1hf3 */

    case 77:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27707; /* smaxrvvmf2hf3 */

    case 78:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27709; /* smaxrvvmf4hf3 */

    case 79:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27711; /* smaxrvvm8sf3 */

    case 80:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27713; /* smaxrvvm4sf3 */

    case 81:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27715; /* smaxrvvm2sf3 */

    case 82:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27717; /* smaxrvvm1sf3 */

    case 83:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27719; /* smaxrvvmf2sf3 */

    case 84:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27721; /* smaxrvvm8df3 */

    case 85:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27723; /* smaxrvvm4df3 */

    case 86:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27725; /* smaxrvvm2df3 */

    case 87:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27727; /* smaxrvvm1df3 */

    case 88:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27729; /* smaxv1hf3 */

    case 89:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27731; /* smaxv2hf3 */

    case 90:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27733; /* smaxv4hf3 */

    case 91:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27735; /* smaxv8hf3 */

    case 92:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27737; /* smaxv16hf3 */

    case 93:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27739; /* smaxv32hf3 */

    case 94:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27741; /* smaxv64hf3 */

    case 95:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27743; /* smaxv128hf3 */

    case 96:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27745; /* smaxv256hf3 */

    case 97:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27747; /* smaxv512hf3 */

    case 98:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27749; /* smaxv1024hf3 */

    case 99:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27751; /* smaxv2048hf3 */

    case 100:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27753; /* smaxv1sf3 */

    case 101:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27755; /* smaxv2sf3 */

    case 102:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27757; /* smaxv4sf3 */

    case 103:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27759; /* smaxv8sf3 */

    case 104:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27761; /* smaxv16sf3 */

    case 105:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27763; /* smaxv32sf3 */

    case 106:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27765; /* smaxv64sf3 */

    case 107:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27767; /* smaxv128sf3 */

    case 108:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27769; /* smaxv256sf3 */

    case 109:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27771; /* smaxv512sf3 */

    case 110:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27773; /* smaxv1024sf3 */

    case 111:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27775; /* smaxv1df3 */

    case 112:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27777; /* smaxv2df3 */

    case 113:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27779; /* smaxv4df3 */

    case 114:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27781; /* smaxv8df3 */

    case 115:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27783; /* smaxv16df3 */

    case 116:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27785; /* smaxv32df3 */

    case 117:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27787; /* smaxv64df3 */

    case 118:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27789; /* smaxv128df3 */

    case 119:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27791; /* smaxv256df3 */

    case 120:
      if (!(
#line 1581 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27793; /* smaxv512df3 */

    default:
      return -1;
    }
}

 int
recog_1494 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern111 (x1))
    {
    case 0:
      if (reg_or_0_operand (operands[2], E_SImode)
          && (
#line 548 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 573; /* *umaxsi3 */
      if (!register_operand (operands[2], E_SImode)
          || !
#line 625 "../../gcc/config/riscv/corev.md"
(TARGET_XCVALU && !TARGET_64BIT))
        return -1;
      return 33928; /* riscv_cv_alu_maxu */

    case 1:
      if (!(
#line 548 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 577; /* *umaxdi3 */

    case 2:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24547; /* umaxrvvm8qi3 */

    case 3:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24561; /* umaxrvvm4qi3 */

    case 4:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24575; /* umaxrvvm2qi3 */

    case 5:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24589; /* umaxrvvm1qi3 */

    case 6:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24603; /* umaxrvvm8hi3 */

    case 7:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24617; /* umaxrvvm4hi3 */

    case 8:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24631; /* umaxrvvm2hi3 */

    case 9:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24645; /* umaxrvvm1hi3 */

    case 10:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24659; /* umaxrvvm8si3 */

    case 11:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24673; /* umaxrvvm4si3 */

    case 12:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24687; /* umaxrvvm2si3 */

    case 13:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24701; /* umaxrvvm1si3 */

    case 14:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24715; /* umaxrvvm8di3 */

    case 15:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24729; /* umaxrvvm4di3 */

    case 16:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24743; /* umaxrvvm2di3 */

    case 17:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24757; /* umaxrvvm1di3 */

    case 18:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24771; /* umaxrvvmf2qi3 */

    case 19:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24785; /* umaxrvvmf4qi3 */

    case 20:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24799; /* umaxrvvmf8qi3 */

    case 21:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24813; /* umaxrvvmf2hi3 */

    case 22:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24827; /* umaxrvvmf4hi3 */

    case 23:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24841; /* umaxrvvmf2si3 */

    case 24:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24855; /* umaxv1qi3 */

    case 25:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24869; /* umaxv2qi3 */

    case 26:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24883; /* umaxv4qi3 */

    case 27:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24897; /* umaxv8qi3 */

    case 28:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24911; /* umaxv16qi3 */

    case 29:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24925; /* umaxv32qi3 */

    case 30:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24939; /* umaxv64qi3 */

    case 31:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24953; /* umaxv128qi3 */

    case 32:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24967; /* umaxv256qi3 */

    case 33:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24981; /* umaxv512qi3 */

    case 34:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24995; /* umaxv1024qi3 */

    case 35:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25009; /* umaxv2048qi3 */

    case 36:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25023; /* umaxv4096qi3 */

    case 37:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25037; /* umaxv1hi3 */

    case 38:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25051; /* umaxv2hi3 */

    case 39:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25065; /* umaxv4hi3 */

    case 40:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25079; /* umaxv8hi3 */

    case 41:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25093; /* umaxv16hi3 */

    case 42:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25107; /* umaxv32hi3 */

    case 43:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25121; /* umaxv64hi3 */

    case 44:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25135; /* umaxv128hi3 */

    case 45:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25149; /* umaxv256hi3 */

    case 46:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25163; /* umaxv512hi3 */

    case 47:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25177; /* umaxv1024hi3 */

    case 48:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25191; /* umaxv2048hi3 */

    case 49:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25205; /* umaxv1si3 */

    case 50:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25219; /* umaxv2si3 */

    case 51:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25233; /* umaxv4si3 */

    case 52:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25247; /* umaxv8si3 */

    case 53:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25261; /* umaxv16si3 */

    case 54:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25275; /* umaxv32si3 */

    case 55:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25289; /* umaxv64si3 */

    case 56:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25303; /* umaxv128si3 */

    case 57:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25317; /* umaxv256si3 */

    case 58:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25331; /* umaxv512si3 */

    case 59:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25345; /* umaxv1024si3 */

    case 60:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25359; /* umaxv1di3 */

    case 61:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25373; /* umaxv2di3 */

    case 62:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25387; /* umaxv4di3 */

    case 63:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25401; /* umaxv8di3 */

    case 64:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25415; /* umaxv16di3 */

    case 65:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25429; /* umaxv32di3 */

    case 66:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25443; /* umaxv64di3 */

    case 67:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25457; /* umaxv128di3 */

    case 68:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25471; /* umaxv256di3 */

    case 69:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25485; /* umaxv512di3 */

    default:
      return -1;
    }
}

 int
recog_1502 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern118 (x3))
    {
    case 0:
      if (!
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27940; /* umulrvvm8qi3_highpart */

    case 1:
      if (!
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27942; /* umulrvvm4qi3_highpart */

    case 2:
      if (!
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27944; /* umulrvvm2qi3_highpart */

    case 3:
      if (!
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27946; /* umulrvvm1qi3_highpart */

    case 4:
      if (!
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27948; /* umulrvvmf2qi3_highpart */

    case 5:
      if (!
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27950; /* umulrvvmf4qi3_highpart */

    case 6:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 502 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27952; /* umulrvvmf8qi3_highpart */

    case 7:
      if (!
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27954; /* umulrvvm8hi3_highpart */

    case 8:
      if (!
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27956; /* umulrvvm4hi3_highpart */

    case 9:
      if (!
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27958; /* umulrvvm2hi3_highpart */

    case 10:
      if (!
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27960; /* umulrvvm1hi3_highpart */

    case 11:
      if (!
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27962; /* umulrvvmf2hi3_highpart */

    case 12:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 504 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27964; /* umulrvvmf4hi3_highpart */

    case 13:
      if (!
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27966; /* umulrvvm8si3_highpart */

    case 14:
      if (!
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27968; /* umulrvvm4si3_highpart */

    case 15:
      if (!
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27970; /* umulrvvm2si3_highpart */

    case 16:
      if (!
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 27972; /* umulrvvm1si3_highpart */

    case 17:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 506 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27974; /* umulrvvmf2si3_highpart */

    case 18:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27976; /* umulrvvm8di3_highpart */

    case 19:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27978; /* umulrvvm4di3_highpart */

    case 20:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27980; /* umulrvvm2di3_highpart */

    case 21:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 508 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_FULL_V)))
        return -1;
      return 27982; /* umulrvvm1di3_highpart */

    case 22:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 27984; /* umulv1qi3_highpart */

    case 23:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 511 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 27986; /* umulv2qi3_highpart */

    case 24:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 512 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 27988; /* umulv4qi3_highpart */

    case 25:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 513 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 27990; /* umulv8qi3_highpart */

    case 26:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 514 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 27992; /* umulv16qi3_highpart */

    case 27:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 515 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 27994; /* umulv32qi3_highpart */

    case 28:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 516 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27996; /* umulv64qi3_highpart */

    case 29:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 517 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27998; /* umulv128qi3_highpart */

    case 30:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28000; /* umulv256qi3_highpart */

    case 31:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28002; /* umulv512qi3_highpart */

    case 32:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28004; /* umulv1024qi3_highpart */

    case 33:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28006; /* umulv2048qi3_highpart */

    case 34:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28008; /* umulv4096qi3_highpart */

    case 35:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28010; /* umulv1hi3_highpart */

    case 36:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28012; /* umulv2hi3_highpart */

    case 37:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28014; /* umulv4hi3_highpart */

    case 38:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28016; /* umulv8hi3_highpart */

    case 39:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28018; /* umulv16hi3_highpart */

    case 40:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28020; /* umulv32hi3_highpart */

    case 41:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28022; /* umulv64hi3_highpart */

    case 42:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28024; /* umulv128hi3_highpart */

    case 43:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 531 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28026; /* umulv256hi3_highpart */

    case 44:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 532 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28028; /* umulv512hi3_highpart */

    case 45:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 533 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28030; /* umulv1024hi3_highpart */

    case 46:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 534 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28032; /* umulv2048hi3_highpart */

    case 47:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28034; /* umulv1si3_highpart */

    case 48:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 536 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28036; /* umulv2si3_highpart */

    case 49:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 537 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28038; /* umulv4si3_highpart */

    case 50:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 538 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28040; /* umulv8si3_highpart */

    case 51:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 539 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28042; /* umulv16si3_highpart */

    case 52:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 540 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28044; /* umulv32si3_highpart */

    case 53:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 541 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28046; /* umulv64si3_highpart */

    case 54:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 542 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28048; /* umulv128si3_highpart */

    case 55:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 543 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28050; /* umulv256si3_highpart */

    case 56:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 544 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28052; /* umulv512si3_highpart */

    case 57:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 545 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28054; /* umulv1024si3_highpart */

    case 58:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 546 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_FULL_V)))
        return -1;
      return 28056; /* umulv1di3_highpart */

    case 59:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 547 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_FULL_V)))
        return -1;
      return 28058; /* umulv2di3_highpart */

    case 60:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 548 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_FULL_V)))
        return -1;
      return 28060; /* umulv4di3_highpart */

    case 61:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 549 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28062; /* umulv8di3_highpart */

    case 62:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 550 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28064; /* umulv16di3_highpart */

    case 63:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 551 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28066; /* umulv32di3_highpart */

    case 64:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 552 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28068; /* umulv64di3_highpart */

    case 65:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 553 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28070; /* umulv128di3_highpart */

    case 66:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 554 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28072; /* umulv256di3_highpart */

    case 67:
      if (!(
#line 1704 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 555 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_FULL_V && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28074; /* umulv512di3_highpart */

    default:
      return -1;
    }
}

 int
recog_1515 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode)
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !
#line 1270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2801; /* *movrvvmf2qi_fract_vtype */

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode)
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !
#line 1270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2802; /* *movrvvmf4qi_fract_vtype */

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode)
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !(
#line 1270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2803; /* *movrvvmf8qi_fract_vtype */

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || !register_operand (operands[1], E_RVVMF2HImode)
          || !
#line 1270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 2804; /* *movrvvmf2hi_fract_vtype */

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || !register_operand (operands[1], E_RVVMF4HImode)
          || !(
#line 1270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2805; /* *movrvvmf4hi_fract_vtype */

    case E_RVVMF2BFmode:
      if (!register_operand (operands[0], E_RVVMF2BFmode)
          || !register_operand (operands[1], E_RVVMF2BFmode)
          || !(
#line 1270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 2806; /* *movrvvmf2bf_fract_vtype */

    case E_RVVMF4BFmode:
      if (!register_operand (operands[0], E_RVVMF4BFmode)
          || !register_operand (operands[1], E_RVVMF4BFmode)
          || !(
#line 1270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2807; /* *movrvvmf4bf_fract_vtype */

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || !register_operand (operands[1], E_RVVMF2HFmode)
          || !(
#line 1270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 938 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 2808; /* *movrvvmf2hf_fract_vtype */

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || !register_operand (operands[1], E_RVVMF4HFmode)
          || !(
#line 1270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 938 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2809; /* *movrvvmf4hf_fract_vtype */

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || !register_operand (operands[1], E_RVVMF2SImode)
          || !(
#line 1270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2810; /* *movrvvmf2si_fract_vtype */

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || !register_operand (operands[1], E_RVVMF2SFmode)
          || !(
#line 1270 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2811; /* *movrvvmf2sf_fract_vtype */

    case E_RVVMF64BImode:
      if (!register_operand (operands[0], E_RVVMF64BImode)
          || !register_operand (operands[1], E_RVVMF64BImode)
          || !(
#line 1307 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2819; /* *movrvvmf64bi_vtype */

    case E_RVVMF32BImode:
      if (!register_operand (operands[0], E_RVVMF32BImode)
          || !register_operand (operands[1], E_RVVMF32BImode)
          || !
#line 1307 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2820; /* *movrvvmf32bi_vtype */

    case E_RVVMF16BImode:
      if (!register_operand (operands[0], E_RVVMF16BImode)
          || !register_operand (operands[1], E_RVVMF16BImode)
          || !
#line 1307 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2821; /* *movrvvmf16bi_vtype */

    case E_RVVMF8BImode:
      if (!register_operand (operands[0], E_RVVMF8BImode)
          || !register_operand (operands[1], E_RVVMF8BImode)
          || !
#line 1307 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2822; /* *movrvvmf8bi_vtype */

    case E_RVVMF4BImode:
      if (!register_operand (operands[0], E_RVVMF4BImode)
          || !register_operand (operands[1], E_RVVMF4BImode)
          || !
#line 1307 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2823; /* *movrvvmf4bi_vtype */

    case E_RVVMF2BImode:
      if (!register_operand (operands[0], E_RVVMF2BImode)
          || !register_operand (operands[1], E_RVVMF2BImode)
          || !
#line 1307 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2824; /* *movrvvmf2bi_vtype */

    case E_RVVM1BImode:
      if (!register_operand (operands[0], E_RVVM1BImode)
          || !register_operand (operands[1], E_RVVM1BImode)
          || !
#line 1307 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 2825; /* *movrvvm1bi_vtype */

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || !register_operand (operands[1], E_V1QImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 3415; /* *movv1qi_vls_vtype */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || !register_operand (operands[1], E_V2QImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 3416; /* *movv2qi_vls_vtype */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || !register_operand (operands[1], E_V4QImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 3417; /* *movv4qi_vls_vtype */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || !register_operand (operands[1], E_V8QImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 3418; /* *movv8qi_vls_vtype */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 3419; /* *movv16qi_vls_vtype */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || !register_operand (operands[1], E_V32QImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 3420; /* *movv32qi_vls_vtype */

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || !register_operand (operands[1], E_V64QImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3421; /* *movv64qi_vls_vtype */

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode)
          || !register_operand (operands[1], E_V128QImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3422; /* *movv128qi_vls_vtype */

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode)
          || !register_operand (operands[1], E_V256QImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3423; /* *movv256qi_vls_vtype */

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode)
          || !register_operand (operands[1], E_V512QImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3424; /* *movv512qi_vls_vtype */

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode)
          || !register_operand (operands[1], E_V1024QImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3425; /* *movv1024qi_vls_vtype */

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode)
          || !register_operand (operands[1], E_V2048QImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3426; /* *movv2048qi_vls_vtype */

    case E_V4096QImode:
      if (!register_operand (operands[0], E_V4096QImode)
          || !register_operand (operands[1], E_V4096QImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3427; /* *movv4096qi_vls_vtype */

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || !register_operand (operands[1], E_V1HImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 3428; /* *movv1hi_vls_vtype */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || !register_operand (operands[1], E_V2HImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 3429; /* *movv2hi_vls_vtype */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || !register_operand (operands[1], E_V4HImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 3430; /* *movv4hi_vls_vtype */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 3431; /* *movv8hi_vls_vtype */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || !register_operand (operands[1], E_V16HImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 3432; /* *movv16hi_vls_vtype */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || !register_operand (operands[1], E_V32HImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3433; /* *movv32hi_vls_vtype */

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || !register_operand (operands[1], E_V64HImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3434; /* *movv64hi_vls_vtype */

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || !register_operand (operands[1], E_V128HImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3435; /* *movv128hi_vls_vtype */

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || !register_operand (operands[1], E_V256HImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3436; /* *movv256hi_vls_vtype */

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || !register_operand (operands[1], E_V512HImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3437; /* *movv512hi_vls_vtype */

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || !register_operand (operands[1], E_V1024HImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3438; /* *movv1024hi_vls_vtype */

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode)
          || !register_operand (operands[1], E_V2048HImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3439; /* *movv2048hi_vls_vtype */

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || !register_operand (operands[1], E_V1SImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 3440; /* *movv1si_vls_vtype */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || !register_operand (operands[1], E_V2SImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 3441; /* *movv2si_vls_vtype */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 3442; /* *movv4si_vls_vtype */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || !register_operand (operands[1], E_V8SImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 3443; /* *movv8si_vls_vtype */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || !register_operand (operands[1], E_V16SImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3444; /* *movv16si_vls_vtype */

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || !register_operand (operands[1], E_V32SImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3445; /* *movv32si_vls_vtype */

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || !register_operand (operands[1], E_V64SImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3446; /* *movv64si_vls_vtype */

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || !register_operand (operands[1], E_V128SImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3447; /* *movv128si_vls_vtype */

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || !register_operand (operands[1], E_V256SImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3448; /* *movv256si_vls_vtype */

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || !register_operand (operands[1], E_V512SImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3449; /* *movv512si_vls_vtype */

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || !register_operand (operands[1], E_V1024SImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3450; /* *movv1024si_vls_vtype */

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || !register_operand (operands[1], E_V1DImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3451; /* *movv1di_vls_vtype */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3452; /* *movv2di_vls_vtype */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || !register_operand (operands[1], E_V4DImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3453; /* *movv4di_vls_vtype */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || !register_operand (operands[1], E_V8DImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3454; /* *movv8di_vls_vtype */

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || !register_operand (operands[1], E_V16DImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3455; /* *movv16di_vls_vtype */

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || !register_operand (operands[1], E_V32DImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3456; /* *movv32di_vls_vtype */

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || !register_operand (operands[1], E_V64DImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3457; /* *movv64di_vls_vtype */

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || !register_operand (operands[1], E_V128DImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3458; /* *movv128di_vls_vtype */

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || !register_operand (operands[1], E_V256DImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3459; /* *movv256di_vls_vtype */

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || !register_operand (operands[1], E_V512DImode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3460; /* *movv512di_vls_vtype */

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || !register_operand (operands[1], E_V1HFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3461; /* *movv1hf_vls_vtype */

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || !register_operand (operands[1], E_V2HFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3462; /* *movv2hf_vls_vtype */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || !register_operand (operands[1], E_V4HFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3463; /* *movv4hf_vls_vtype */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || !register_operand (operands[1], E_V8HFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3464; /* *movv8hf_vls_vtype */

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || !register_operand (operands[1], E_V16HFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3465; /* *movv16hf_vls_vtype */

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || !register_operand (operands[1], E_V32HFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3466; /* *movv32hf_vls_vtype */

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || !register_operand (operands[1], E_V64HFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3467; /* *movv64hf_vls_vtype */

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || !register_operand (operands[1], E_V128HFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3468; /* *movv128hf_vls_vtype */

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || !register_operand (operands[1], E_V256HFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3469; /* *movv256hf_vls_vtype */

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || !register_operand (operands[1], E_V512HFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3470; /* *movv512hf_vls_vtype */

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || !register_operand (operands[1], E_V1024HFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3471; /* *movv1024hf_vls_vtype */

    case E_V2048HFmode:
      if (!register_operand (operands[0], E_V2048HFmode)
          || !register_operand (operands[1], E_V2048HFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3472; /* *movv2048hf_vls_vtype */

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || !register_operand (operands[1], E_V1SFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3473; /* *movv1sf_vls_vtype */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || !register_operand (operands[1], E_V2SFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3474; /* *movv2sf_vls_vtype */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3475; /* *movv4sf_vls_vtype */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || !register_operand (operands[1], E_V8SFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3476; /* *movv8sf_vls_vtype */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || !register_operand (operands[1], E_V16SFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3477; /* *movv16sf_vls_vtype */

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || !register_operand (operands[1], E_V32SFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3478; /* *movv32sf_vls_vtype */

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || !register_operand (operands[1], E_V64SFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3479; /* *movv64sf_vls_vtype */

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || !register_operand (operands[1], E_V128SFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3480; /* *movv128sf_vls_vtype */

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || !register_operand (operands[1], E_V256SFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3481; /* *movv256sf_vls_vtype */

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || !register_operand (operands[1], E_V512SFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 293 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3482; /* *movv512sf_vls_vtype */

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode)
          || !register_operand (operands[1], E_V1024SFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3483; /* *movv1024sf_vls_vtype */

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || !register_operand (operands[1], E_V1DFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3484; /* *movv1df_vls_vtype */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3485; /* *movv2df_vls_vtype */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || !register_operand (operands[1], E_V4DFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3486; /* *movv4df_vls_vtype */

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || !register_operand (operands[1], E_V8DFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3487; /* *movv8df_vls_vtype */

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || !register_operand (operands[1], E_V16DFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3488; /* *movv16df_vls_vtype */

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || !register_operand (operands[1], E_V32DFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3489; /* *movv32df_vls_vtype */

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || !register_operand (operands[1], E_V64DFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3490; /* *movv64df_vls_vtype */

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode)
          || !register_operand (operands[1], E_V128DFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3491; /* *movv128df_vls_vtype */

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode)
          || !register_operand (operands[1], E_V256DFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3492; /* *movv256df_vls_vtype */

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode)
          || !register_operand (operands[1], E_V512DFmode)
          || !(
#line 1522 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3493; /* *movv512df_vls_vtype */

    case E_V1BImode:
      if (!register_operand (operands[0], E_V1BImode)
          || !register_operand (operands[1], E_V1BImode)
          || !(
#line 1543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
        return -1;
      return 3507; /* *movv1bi_vls_vtype */

    case E_V2BImode:
      if (!register_operand (operands[0], E_V2BImode)
          || !register_operand (operands[1], E_V2BImode)
          || !(
#line 1543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
        return -1;
      return 3508; /* *movv2bi_vls_vtype */

    case E_V4BImode:
      if (!register_operand (operands[0], E_V4BImode)
          || !register_operand (operands[1], E_V4BImode)
          || !(
#line 1543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
        return -1;
      return 3509; /* *movv4bi_vls_vtype */

    case E_V8BImode:
      if (!register_operand (operands[0], E_V8BImode)
          || !register_operand (operands[1], E_V8BImode)
          || !(
#line 1543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
        return -1;
      return 3510; /* *movv8bi_vls_vtype */

    case E_V16BImode:
      if (!register_operand (operands[0], E_V16BImode)
          || !register_operand (operands[1], E_V16BImode)
          || !(
#line 1543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
        return -1;
      return 3511; /* *movv16bi_vls_vtype */

    case E_V32BImode:
      if (!register_operand (operands[0], E_V32BImode)
          || !register_operand (operands[1], E_V32BImode)
          || !(
#line 1543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
        return -1;
      return 3512; /* *movv32bi_vls_vtype */

    case E_V64BImode:
      if (!register_operand (operands[0], E_V64BImode)
          || !register_operand (operands[1], E_V64BImode)
          || !(
#line 1543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3513; /* *movv64bi_vls_vtype */

    case E_V128BImode:
      if (!register_operand (operands[0], E_V128BImode)
          || !register_operand (operands[1], E_V128BImode)
          || !(
#line 1543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3514; /* *movv128bi_vls_vtype */

    case E_V256BImode:
      if (!register_operand (operands[0], E_V256BImode)
          || !register_operand (operands[1], E_V256BImode)
          || !(
#line 1543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3515; /* *movv256bi_vls_vtype */

    case E_V512BImode:
      if (!register_operand (operands[0], E_V512BImode)
          || !register_operand (operands[1], E_V512BImode)
          || !(
#line 1543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3516; /* *movv512bi_vls_vtype */

    case E_V1024BImode:
      if (!register_operand (operands[0], E_V1024BImode)
          || !register_operand (operands[1], E_V1024BImode)
          || !(
#line 1543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3517; /* *movv1024bi_vls_vtype */

    case E_V2048BImode:
      if (!register_operand (operands[0], E_V2048BImode)
          || !register_operand (operands[1], E_V2048BImode)
          || !(
#line 1543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3518; /* *movv2048bi_vls_vtype */

    case E_V4096BImode:
      if (!register_operand (operands[0], E_V4096BImode)
          || !register_operand (operands[1], E_V4096BImode)
          || !(
#line 1543 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3519; /* *movv4096bi_vls_vtype */

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM8QImode) != 0
          || !(
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5225 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM4QImode) != 0
          || !(
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5226 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM2QImode) != 0
          || !(
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5227 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM1QImode) != 0
          || !(
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5228 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM8HImode) != 0
          || !(
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5229 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM4HImode) != 0
          || !(
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5230 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM2HImode) != 0
          || !(
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5231 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM1HImode) != 0
          || !(
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5232 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM8SImode) != 0
          || !(
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5233 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM4SImode) != 0
          || !(
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5234 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM2SImode) != 0
          || !(
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5235 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM1SImode) != 0
          || !(
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5236 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM8DImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5237 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM4DImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5238 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM2DImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5239 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM1DImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5240 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVMF2QImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5241 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVMF4QImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5242 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVMF8QImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5243 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVMF2HImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5244 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVMF4HImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5245 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVMF2SImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5246 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1QImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5247 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V2QImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5248 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V4QImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5249 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V8QImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5250 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V16QImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5251 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V32QImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5252 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V64QImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5253 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V128QImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5254 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V256QImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5255 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V512QImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5256 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1024QImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5257 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V2048QImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5258 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V4096QImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5259 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1HImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5260 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V2HImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5261 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V4HImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5262 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V8HImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5263 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V16HImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5264 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V32HImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5265 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V64HImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5266 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V128HImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5267 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V256HImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5268 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V512HImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5269 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1024HImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5270 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V2048HImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5271 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1SImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5272 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V2SImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5273 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V4SImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5274 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V8SImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5275 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V16SImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5276 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V32SImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5277 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V64SImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5278 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V128SImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5279 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V256SImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5280 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V512SImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5281 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1024SImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5282 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1DImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5283 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V2DImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5284 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V4DImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5285 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V8DImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5286 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V16DImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5287 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V32DImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5288 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V64DImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5289 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V128DImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5290 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V256DImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5291 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V512DImode) != 0
          || !((
#line 1180 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1182 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5292 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM8HFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5361 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM4HFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5362 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM2HFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5363 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM1HFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5364 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVMF2HFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5365 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVMF4HFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5366 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM8SFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5367 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM4SFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5368 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM2SFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5369 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM1SFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5370 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVMF2SFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5371 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM8DFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5372 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM4DFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5373 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM2DFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5374 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_RVVM1DFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5375 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1HFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5376 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V2HFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5377 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V4HFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5378 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V8HFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5379 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V16HFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5380 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V32HFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5381 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V64HFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5382 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V128HFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5383 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V256HFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5384 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V512HFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5385 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1024HFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5386 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V2048HFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5387 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1SFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5388 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V2SFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5389 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V4SFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5390 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V8SFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5391 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V16SFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5392 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V32SFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5393 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V64SFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5394 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V128SFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5395 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V256SFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5396 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V512SFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5397 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1024SFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5398 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V1DFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5399 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V2DFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5400 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V4DFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5401 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V8DFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5402 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V16DFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5403 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V32DFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5404 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V64DFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5405 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V128DFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5406 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V256DFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5407 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern136 (x2, 
E_V512DFmode) != 0
          || !((
#line 1236 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1238 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5408 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_15 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16SFmode)
      && reg_or_mem_operand (operands[1], E_V16SFmode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return gen_split_306 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16SFmode)
       || register_operand (operands[1], V16SFmode))) && 
#line 4333 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16SFmode)
       || !register_operand (operands[1], V16SFmode)))))
        return gen_split_1976 (insn, operands);
    }
  if (!register_operand (operands[0], E_V16SFmode)
      || !register_operand (operands[1], E_V16SFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2153 (insn, operands);
}

 rtx_insn *
split_19 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1SFmode)
      && reg_or_mem_operand (operands[1], E_V1SFmode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return gen_split_302 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1SFmode)
       || register_operand (operands[1], V1SFmode))) && 
#line 4329 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1SFmode)
       || !register_operand (operands[1], V1SFmode)))))
        return gen_split_1972 (insn, operands);
    }
  if (!register_operand (operands[0], E_V1SFmode)
      || !register_operand (operands[1], E_V1SFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2149 (insn, operands);
}

 rtx_insn *
split_23 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2HFmode)
      && reg_or_mem_operand (operands[1], E_V2HFmode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return gen_split_291 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2HFmode)
       || register_operand (operands[1], V2HFmode))) && 
#line 4325 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V2HFmode)
       || !register_operand (operands[1], V2HFmode)))))
        return gen_split_1968 (insn, operands);
    }
  if (!register_operand (operands[0], E_V2HFmode)
      || !register_operand (operands[1], E_V2HFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2138 (insn, operands);
}

 rtx_insn *
split_28 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2DImode)
      && reg_or_mem_operand (operands[1], E_V2DImode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return gen_split_281 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2DImode)
       || register_operand (operands[1], V2DImode))) && 
#line 4320 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V2DImode)
       || !register_operand (operands[1], V2DImode)))))
        return gen_split_1963 (insn, operands);
    }
  if (!register_operand (operands[0], E_V2DImode)
      || !register_operand (operands[1], E_V2DImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2128 (insn, operands);
}

 rtx_insn *
split_34 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1SImode)
      && reg_or_mem_operand (operands[1], E_V1SImode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return gen_split_269 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1SImode)
       || register_operand (operands[1], V1SImode))) && 
#line 4314 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1SImode)
       || !register_operand (operands[1], V1SImode)))))
        return gen_split_1957 (insn, operands);
    }
  if (!register_operand (operands[0], E_V1SImode)
      || !register_operand (operands[1], E_V1SImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2116 (insn, operands);
}

 rtx_insn *
split_40 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16QImode)
      && reg_or_mem_operand (operands[1], E_V16QImode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return gen_split_248 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16QImode)
       || register_operand (operands[1], V16QImode))) && 
#line 4308 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16QImode)
       || !register_operand (operands[1], V16QImode)))))
        return gen_split_1951 (insn, operands);
    }
  if (!register_operand (operands[0], E_V16QImode)
      || !register_operand (operands[1], E_V16QImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2095 (insn, operands);
}

 rtx_insn *
split_46 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8BImode)
      && reg_or_mem_operand (operands[1], E_V8BImode)
      && ((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8BImode)
       || register_operand (operands[1], V8BImode))) && 
#line 4343 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V8BImode)
       || !register_operand (operands[1], V8BImode)))))
    return gen_split_1985 (insn, operands);
  if (!register_operand (operands[0], E_V8BImode)
      || !register_operand (operands[1], E_V8BImode)
      || !((
#line 1530 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1532 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2173 (insn, operands);
}

 rtx_insn *
split_52 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128DFmode)
      && reg_or_mem_operand (operands[1], E_V128DFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return gen_split_320 (insn, operands);
  if (!register_operand (operands[0], E_V128DFmode)
      || !register_operand (operands[1], E_V128DFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2167 (insn, operands);
}

 rtx_insn *
split_58 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128SFmode)
      && reg_or_mem_operand (operands[1], E_V128SFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return gen_split_309 (insn, operands);
  if (!register_operand (operands[0], E_V128SFmode)
      || !register_operand (operands[1], E_V128SFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2156 (insn, operands);
}

 rtx_insn *
split_64 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256HFmode)
      && reg_or_mem_operand (operands[1], E_V256HFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
    return gen_split_298 (insn, operands);
  if (!register_operand (operands[0], E_V256HFmode)
      || !register_operand (operands[1], E_V256HFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2145 (insn, operands);
}

 rtx_insn *
split_70 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128DImode)
      && reg_or_mem_operand (operands[1], E_V128DImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return gen_split_287 (insn, operands);
  if (!register_operand (operands[0], E_V128DImode)
      || !register_operand (operands[1], E_V128DImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2134 (insn, operands);
}

 rtx_insn *
split_76 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128SImode)
      && reg_or_mem_operand (operands[1], E_V128SImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
    return gen_split_276 (insn, operands);
  if (!register_operand (operands[0], E_V128SImode)
      || !register_operand (operands[1], E_V128SImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2123 (insn, operands);
}

 rtx_insn *
split_83 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V128HImode)
      && reg_or_mem_operand (operands[1], E_V128HImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
    return gen_split_264 (insn, operands);
  if (!register_operand (operands[0], E_V128HImode)
      || !register_operand (operands[1], E_V128HImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2111 (insn, operands);
}

 rtx_insn *
split_90 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V256QImode)
      && reg_or_mem_operand (operands[1], E_V256QImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return gen_split_252 (insn, operands);
  if (!register_operand (operands[0], E_V256QImode)
      || !register_operand (operands[1], E_V256QImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2099 (insn, operands);
}

 rtx_insn *
split_97 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF8BImode)
      && reg_or_mem_operand (operands[1], E_RVVMF8BImode)
      && 
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return gen_split_240 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF8BImode)
      || !register_operand (operands[1], E_RVVMF8BImode)
      || !(
#line 1294 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1296 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1577 (insn, operands);
}

 rtx_insn *
split_104 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF4BFmode)
      && reg_or_mem_operand (operands[1], E_RVVMF4BFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
    return gen_split_221 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF4BFmode)
      || !register_operand (operands[1], E_RVVMF4BFmode)
      || !((
#line 1257 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 936 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)) && 
#line 1259 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1569 (insn, operands);
}

 rtx_insn *
split_111 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern276 (x2))
    {
    case 0:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3539 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8QImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3743 (insn, operands);

    case 1:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3542 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4QImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3746 (insn, operands);

    case 2:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3545 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2QImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3749 (insn, operands);

    case 3:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3548 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1QImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3752 (insn, operands);

    case 4:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3551 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8HImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3755 (insn, operands);

    case 5:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3554 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4HImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3758 (insn, operands);

    case 6:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3557 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2HImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3761 (insn, operands);

    case 7:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3560 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1HImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3764 (insn, operands);

    case 8:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3563 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8SImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3767 (insn, operands);

    case 9:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3566 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4SImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3770 (insn, operands);

    case 10:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3569 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2SImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3773 (insn, operands);

    case 11:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3572 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1SImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3776 (insn, operands);

    case 12:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3575 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3779 (insn, operands);

    case 13:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3578 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3782 (insn, operands);

    case 14:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3581 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3785 (insn, operands);

    case 15:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3584 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3788 (insn, operands);

    case 16:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3587 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF2QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3791 (insn, operands);

    case 17:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3590 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF4QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3794 (insn, operands);

    case 18:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3593 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF8QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3797 (insn, operands);

    case 19:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3596 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF2HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3800 (insn, operands);

    case 20:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3599 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF4HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3803 (insn, operands);

    case 21:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3602 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF2SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3806 (insn, operands);

    case 22:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3605 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3809 (insn, operands);

    case 23:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3608 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3812 (insn, operands);

    case 24:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3611 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3815 (insn, operands);

    case 25:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3614 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3818 (insn, operands);

    case 26:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3617 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3821 (insn, operands);

    case 27:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3620 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3824 (insn, operands);

    case 28:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3623 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3827 (insn, operands);

    case 29:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3626 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3830 (insn, operands);

    case 30:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3629 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3833 (insn, operands);

    case 31:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3632 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3836 (insn, operands);

    case 32:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3635 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1024QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3839 (insn, operands);

    case 33:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3638 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2048QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3842 (insn, operands);

    case 34:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3641 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4096QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3845 (insn, operands);

    case 35:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3644 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3848 (insn, operands);

    case 36:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3647 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3851 (insn, operands);

    case 37:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3650 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3854 (insn, operands);

    case 38:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3653 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3857 (insn, operands);

    case 39:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3656 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3860 (insn, operands);

    case 40:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3659 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3863 (insn, operands);

    case 41:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3662 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3866 (insn, operands);

    case 42:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3665 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3869 (insn, operands);

    case 43:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3668 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3872 (insn, operands);

    case 44:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3671 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3875 (insn, operands);

    case 45:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3674 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1024HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3878 (insn, operands);

    case 46:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3677 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2048HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3881 (insn, operands);

    case 47:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3680 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3884 (insn, operands);

    case 48:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3683 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3887 (insn, operands);

    case 49:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3686 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3890 (insn, operands);

    case 50:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3689 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3893 (insn, operands);

    case 51:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3692 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3896 (insn, operands);

    case 52:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3695 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3899 (insn, operands);

    case 53:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3698 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3902 (insn, operands);

    case 54:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3701 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3905 (insn, operands);

    case 55:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3704 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3908 (insn, operands);

    case 56:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3707 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3911 (insn, operands);

    case 57:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3710 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1024SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3914 (insn, operands);

    case 58:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3713 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3917 (insn, operands);

    case 59:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3716 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3920 (insn, operands);

    case 60:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3719 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3923 (insn, operands);

    case 61:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3722 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3926 (insn, operands);

    case 62:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3725 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3929 (insn, operands);

    case 63:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3728 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3932 (insn, operands);

    case 64:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3731 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3935 (insn, operands);

    case 65:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3734 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3938 (insn, operands);

    case 66:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3737 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3941 (insn, operands);

    case 67:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3740 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3944 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_121 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 93:
      return split_118 (x1, insn);

    case 140:
      switch (pattern241 (x2))
        {
        case 0:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5841 (insn, operands);

        case 1:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5843 (insn, operands);

        case 2:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5845 (insn, operands);

        case 3:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1HFmode) && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5847 (insn, operands);

        case 4:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF2HFmode) && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5849 (insn, operands);

        case 5:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF4HFmode) && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5851 (insn, operands);

        case 6:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5853 (insn, operands);

        case 7:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5855 (insn, operands);

        case 8:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5857 (insn, operands);

        case 9:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1SFmode) && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5859 (insn, operands);

        case 10:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF2SFmode) && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5861 (insn, operands);

        case 11:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8DFmode) && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5863 (insn, operands);

        case 12:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4DFmode) && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5865 (insn, operands);

        case 13:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2DFmode) && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5867 (insn, operands);

        case 14:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1DFmode) && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5869 (insn, operands);

        case 15:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1HFmode) && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5871 (insn, operands);

        case 16:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2HFmode) && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5873 (insn, operands);

        case 17:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4HFmode) && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5875 (insn, operands);

        case 18:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8HFmode) && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5877 (insn, operands);

        case 19:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16HFmode) && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5879 (insn, operands);

        case 20:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32HFmode) && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5881 (insn, operands);

        case 21:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64HFmode) && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5883 (insn, operands);

        case 22:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128HFmode) && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5885 (insn, operands);

        case 23:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256HFmode) && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5887 (insn, operands);

        case 24:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512HFmode) && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5889 (insn, operands);

        case 25:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1024HFmode) && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5891 (insn, operands);

        case 26:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2048HFmode) && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5893 (insn, operands);

        case 27:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1SFmode) && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5895 (insn, operands);

        case 28:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2SFmode) && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5897 (insn, operands);

        case 29:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4SFmode) && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5899 (insn, operands);

        case 30:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8SFmode) && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5901 (insn, operands);

        case 31:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16SFmode) && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5903 (insn, operands);

        case 32:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32SFmode) && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5905 (insn, operands);

        case 33:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64SFmode) && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5907 (insn, operands);

        case 34:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128SFmode) && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5909 (insn, operands);

        case 35:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256SFmode) && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5911 (insn, operands);

        case 36:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512SFmode) && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5913 (insn, operands);

        case 37:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1024SFmode) && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5915 (insn, operands);

        case 38:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1DFmode) && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5917 (insn, operands);

        case 39:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2DFmode) && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5919 (insn, operands);

        case 40:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4DFmode) && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5921 (insn, operands);

        case 41:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8DFmode) && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5923 (insn, operands);

        case 42:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16DFmode) && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5925 (insn, operands);

        case 43:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32DFmode) && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5927 (insn, operands);

        case 44:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64DFmode) && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5929 (insn, operands);

        case 45:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128DFmode) && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5931 (insn, operands);

        case 46:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256DFmode) && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5933 (insn, operands);

        case 47:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512DFmode) && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5935 (insn, operands);

        default:
          return NULL;
        }

    case 141:
      switch (pattern241 (x2))
        {
        case 0:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5842 (insn, operands);

        case 1:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5844 (insn, operands);

        case 2:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2HFmode) && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5846 (insn, operands);

        case 3:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1HFmode) && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5848 (insn, operands);

        case 4:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF2HFmode) && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5850 (insn, operands);

        case 5:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF4HFmode) && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5852 (insn, operands);

        case 6:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5854 (insn, operands);

        case 7:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5856 (insn, operands);

        case 8:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2SFmode) && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5858 (insn, operands);

        case 9:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1SFmode) && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5860 (insn, operands);

        case 10:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVMF2SFmode) && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5862 (insn, operands);

        case 11:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM8DFmode) && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5864 (insn, operands);

        case 12:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM4DFmode) && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5866 (insn, operands);

        case 13:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM2DFmode) && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5868 (insn, operands);

        case 14:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (RVVM1DFmode) && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5870 (insn, operands);

        case 15:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1HFmode) && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5872 (insn, operands);

        case 16:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2HFmode) && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5874 (insn, operands);

        case 17:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4HFmode) && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5876 (insn, operands);

        case 18:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8HFmode) && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5878 (insn, operands);

        case 19:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16HFmode) && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5880 (insn, operands);

        case 20:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32HFmode) && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5882 (insn, operands);

        case 21:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64HFmode) && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5884 (insn, operands);

        case 22:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128HFmode) && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5886 (insn, operands);

        case 23:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256HFmode) && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5888 (insn, operands);

        case 24:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512HFmode) && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5890 (insn, operands);

        case 25:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1024HFmode) && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5892 (insn, operands);

        case 26:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2048HFmode) && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5894 (insn, operands);

        case 27:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1SFmode) && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5896 (insn, operands);

        case 28:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2SFmode) && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5898 (insn, operands);

        case 29:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4SFmode) && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5900 (insn, operands);

        case 30:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8SFmode) && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5902 (insn, operands);

        case 31:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16SFmode) && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5904 (insn, operands);

        case 32:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32SFmode) && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5906 (insn, operands);

        case 33:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64SFmode) && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5908 (insn, operands);

        case 34:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128SFmode) && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5910 (insn, operands);

        case 35:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256SFmode) && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5912 (insn, operands);

        case 36:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512SFmode) && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5914 (insn, operands);

        case 37:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1024SFmode) && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5916 (insn, operands);

        case 38:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V1DFmode) && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5918 (insn, operands);

        case 39:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V2DFmode) && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5920 (insn, operands);

        case 40:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V4DFmode) && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5922 (insn, operands);

        case 41:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V8DFmode) && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5924 (insn, operands);

        case 42:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V16DFmode) && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5926 (insn, operands);

        case 43:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V32DFmode) && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5928 (insn, operands);

        case 44:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V64DFmode) && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5930 (insn, operands);

        case 45:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V128DFmode) && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5932 (insn, operands);

        case 46:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V256DFmode) && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5934 (insn, operands);

        case 47:
          if (!((
#line 1597 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && !HONOR_SNANS (V512DFmode) && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1599 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5936 (insn, operands);

        default:
          return NULL;
        }

    case 123:
      switch (pattern241 (x2))
        {
        case 0:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5937 (insn, operands);

        case 1:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5938 (insn, operands);

        case 2:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5939 (insn, operands);

        case 3:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5940 (insn, operands);

        case 4:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5941 (insn, operands);

        case 5:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5942 (insn, operands);

        case 6:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5943 (insn, operands);

        case 7:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5944 (insn, operands);

        case 8:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5945 (insn, operands);

        case 9:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5946 (insn, operands);

        case 10:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5947 (insn, operands);

        case 11:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5948 (insn, operands);

        case 12:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5949 (insn, operands);

        case 13:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5950 (insn, operands);

        case 14:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5951 (insn, operands);

        case 15:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5952 (insn, operands);

        case 16:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5953 (insn, operands);

        case 17:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5954 (insn, operands);

        case 18:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5955 (insn, operands);

        case 19:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5956 (insn, operands);

        case 20:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5957 (insn, operands);

        case 21:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5958 (insn, operands);

        case 22:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5959 (insn, operands);

        case 23:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5960 (insn, operands);

        case 24:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5961 (insn, operands);

        case 25:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5962 (insn, operands);

        case 26:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5963 (insn, operands);

        case 27:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5964 (insn, operands);

        case 28:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5965 (insn, operands);

        case 29:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5966 (insn, operands);

        case 30:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5967 (insn, operands);

        case 31:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5968 (insn, operands);

        case 32:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5969 (insn, operands);

        case 33:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5970 (insn, operands);

        case 34:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5971 (insn, operands);

        case 35:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5972 (insn, operands);

        case 36:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5973 (insn, operands);

        case 37:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5974 (insn, operands);

        case 38:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5975 (insn, operands);

        case 39:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5976 (insn, operands);

        case 40:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5977 (insn, operands);

        case 41:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5978 (insn, operands);

        case 42:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5979 (insn, operands);

        case 43:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5980 (insn, operands);

        case 44:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5981 (insn, operands);

        case 45:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5982 (insn, operands);

        case 46:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5983 (insn, operands);

        case 47:
          if (!((
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1625 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5984 (insn, operands);

        default:
          return NULL;
        }

    case 145:
      return split_119 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
split_131 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8QImode)
        || register_operand (operands[3], RVVM8QImode)))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8QImode, 7))))
        return NULL;
      return gen_split_2309 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4QImode)
        || register_operand (operands[3], RVVM4QImode)))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4QImode, 7))))
        return NULL;
      return gen_split_2310 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2QImode)
        || register_operand (operands[3], RVVM2QImode)))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2QImode, 7))))
        return NULL;
      return gen_split_2311 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1QImode)
        || register_operand (operands[3], RVVM1QImode)))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1QImode, 7))))
        return NULL;
      return gen_split_2312 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8HImode)
        || register_operand (operands[3], RVVM8HImode)))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HImode, 7))))
        return NULL;
      return gen_split_2313 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4HImode)
        || register_operand (operands[3], RVVM4HImode)))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HImode, 7))))
        return NULL;
      return gen_split_2314 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2HImode)
        || register_operand (operands[3], RVVM2HImode)))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HImode, 7))))
        return NULL;
      return gen_split_2315 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1HImode)
        || register_operand (operands[3], RVVM1HImode)))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HImode, 7))))
        return NULL;
      return gen_split_2316 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8SImode)
        || register_operand (operands[3], RVVM8SImode)))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SImode, 7))))
        return NULL;
      return gen_split_2317 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4SImode)
        || register_operand (operands[3], RVVM4SImode)))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SImode, 7))))
        return NULL;
      return gen_split_2318 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2SImode)
        || register_operand (operands[3], RVVM2SImode)))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SImode, 7))))
        return NULL;
      return gen_split_2319 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1SImode)
        || register_operand (operands[3], RVVM1SImode)))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SImode, 7))))
        return NULL;
      return gen_split_2320 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8DImode)
        || register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DImode, 7))))
        return NULL;
      return gen_split_2321 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4DImode)
        || register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DImode, 7))))
        return NULL;
      return gen_split_2322 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2DImode)
        || register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DImode, 7))))
        return NULL;
      return gen_split_2323 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1DImode)
        || register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DImode, 7))))
        return NULL;
      return gen_split_2324 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2QImode)
        || register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2QImode, 7))))
        return NULL;
      return gen_split_2325 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF4QImode)
        || register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4QImode, 7))))
        return NULL;
      return gen_split_2326 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF8QImode)
        || register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF8QImode, 7))))
        return NULL;
      return gen_split_2327 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2HImode)
        || register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HImode, 7))))
        return NULL;
      return gen_split_2328 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF4HImode)
        || register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HImode, 7))))
        return NULL;
      return gen_split_2329 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2SImode)
        || register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SImode, 7))))
        return NULL;
      return gen_split_2330 (insn, operands);

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8BFmode)
        || register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8BFmode, 7))))
        return NULL;
      return gen_split_2331 (insn, operands);

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4BFmode)
        || register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4BFmode, 7))))
        return NULL;
      return gen_split_2332 (insn, operands);

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2BFmode)
        || register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2BFmode, 7))))
        return NULL;
      return gen_split_2333 (insn, operands);

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1BFmode)
        || register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1BFmode, 7))))
        return NULL;
      return gen_split_2334 (insn, operands);

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
        || register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2BFmode, 7))))
        return NULL;
      return gen_split_2335 (insn, operands);

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
        || register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4BFmode, 7))))
        return NULL;
      return gen_split_2336 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8HFmode)
        || register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HFmode, 7))))
        return NULL;
      return gen_split_2337 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4HFmode)
        || register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HFmode, 7))))
        return NULL;
      return gen_split_2338 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2HFmode)
        || register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HFmode, 7))))
        return NULL;
      return gen_split_2339 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1HFmode)
        || register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HFmode, 7))))
        return NULL;
      return gen_split_2340 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
        || register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HFmode, 7))))
        return NULL;
      return gen_split_2341 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
        || register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HFmode, 7))))
        return NULL;
      return gen_split_2342 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8SFmode)
        || register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SFmode, 7))))
        return NULL;
      return gen_split_2343 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4SFmode)
        || register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SFmode, 7))))
        return NULL;
      return gen_split_2344 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2SFmode)
        || register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SFmode, 7))))
        return NULL;
      return gen_split_2345 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1SFmode)
        || register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SFmode, 7))))
        return NULL;
      return gen_split_2346 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
        || register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SFmode, 7))))
        return NULL;
      return gen_split_2347 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8DFmode)
        || register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DFmode, 7))))
        return NULL;
      return gen_split_2348 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4DFmode)
        || register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DFmode, 7))))
        return NULL;
      return gen_split_2349 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2DFmode)
        || register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DFmode, 7))))
        return NULL;
      return gen_split_2350 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1DFmode)
        || register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DFmode, 7))))
        return NULL;
      return gen_split_2351 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1QImode)
        || register_operand (operands[3], V1QImode)))) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1QImode, 7))))
        return NULL;
      return gen_split_2352 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2QImode)
        || register_operand (operands[3], V2QImode)))) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2QImode, 7))))
        return NULL;
      return gen_split_2353 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4QImode)
        || register_operand (operands[3], V4QImode)))) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4QImode, 7))))
        return NULL;
      return gen_split_2354 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8QImode)
        || register_operand (operands[3], V8QImode)))) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8QImode, 7))))
        return NULL;
      return gen_split_2355 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16QImode)
        || register_operand (operands[3], V16QImode)))) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16QImode, 7))))
        return NULL;
      return gen_split_2356 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32QImode)
        || register_operand (operands[3], V32QImode)))) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32QImode, 7))))
        return NULL;
      return gen_split_2357 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64QImode)
        || register_operand (operands[3], V64QImode)))) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64QImode, 7))))
        return NULL;
      return gen_split_2358 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128QImode)
        || register_operand (operands[3], V128QImode)))) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128QImode, 7))))
        return NULL;
      return gen_split_2359 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256QImode)
        || register_operand (operands[3], V256QImode)))) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256QImode, 7))))
        return NULL;
      return gen_split_2360 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512QImode)
        || register_operand (operands[3], V512QImode)))) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512QImode, 7))))
        return NULL;
      return gen_split_2361 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024QImode)
        || register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024QImode, 7))))
        return NULL;
      return gen_split_2362 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2048QImode)
        || register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048QImode, 7))))
        return NULL;
      return gen_split_2363 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4096QImode)
        || register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4096QImode, 7))))
        return NULL;
      return gen_split_2364 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1HImode)
        || register_operand (operands[3], V1HImode)))) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HImode, 7))))
        return NULL;
      return gen_split_2365 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2HImode)
        || register_operand (operands[3], V2HImode)))) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HImode, 7))))
        return NULL;
      return gen_split_2366 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4HImode)
        || register_operand (operands[3], V4HImode)))) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HImode, 7))))
        return NULL;
      return gen_split_2367 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8HImode)
        || register_operand (operands[3], V8HImode)))) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HImode, 7))))
        return NULL;
      return gen_split_2368 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16HImode)
        || register_operand (operands[3], V16HImode)))) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HImode, 7))))
        return NULL;
      return gen_split_2369 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32HImode)
        || register_operand (operands[3], V32HImode)))) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HImode, 7))))
        return NULL;
      return gen_split_2370 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64HImode)
        || register_operand (operands[3], V64HImode)))) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HImode, 7))))
        return NULL;
      return gen_split_2371 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128HImode)
        || register_operand (operands[3], V128HImode)))) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HImode, 7))))
        return NULL;
      return gen_split_2372 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256HImode)
        || register_operand (operands[3], V256HImode)))) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HImode, 7))))
        return NULL;
      return gen_split_2373 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512HImode)
        || register_operand (operands[3], V512HImode)))) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HImode, 7))))
        return NULL;
      return gen_split_2374 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024HImode)
        || register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HImode, 7))))
        return NULL;
      return gen_split_2375 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2048HImode)
        || register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HImode, 7))))
        return NULL;
      return gen_split_2376 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1SImode)
        || register_operand (operands[3], V1SImode)))) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SImode, 7))))
        return NULL;
      return gen_split_2377 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2SImode)
        || register_operand (operands[3], V2SImode)))) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SImode, 7))))
        return NULL;
      return gen_split_2378 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4SImode)
        || register_operand (operands[3], V4SImode)))) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SImode, 7))))
        return NULL;
      return gen_split_2379 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8SImode)
        || register_operand (operands[3], V8SImode)))) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SImode, 7))))
        return NULL;
      return gen_split_2380 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16SImode)
        || register_operand (operands[3], V16SImode)))) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SImode, 7))))
        return NULL;
      return gen_split_2381 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32SImode)
        || register_operand (operands[3], V32SImode)))) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SImode, 7))))
        return NULL;
      return gen_split_2382 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64SImode)
        || register_operand (operands[3], V64SImode)))) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SImode, 7))))
        return NULL;
      return gen_split_2383 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128SImode)
        || register_operand (operands[3], V128SImode)))) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SImode, 7))))
        return NULL;
      return gen_split_2384 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256SImode)
        || register_operand (operands[3], V256SImode)))) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SImode, 7))))
        return NULL;
      return gen_split_2385 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512SImode)
        || register_operand (operands[3], V512SImode)))) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SImode, 7))))
        return NULL;
      return gen_split_2386 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024SImode)
        || register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SImode, 7))))
        return NULL;
      return gen_split_2387 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1DImode)
        || register_operand (operands[3], V1DImode)))) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DImode, 7))))
        return NULL;
      return gen_split_2388 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2DImode)
        || register_operand (operands[3], V2DImode)))) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DImode, 7))))
        return NULL;
      return gen_split_2389 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4DImode)
        || register_operand (operands[3], V4DImode)))) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DImode, 7))))
        return NULL;
      return gen_split_2390 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8DImode)
        || register_operand (operands[3], V8DImode)))) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DImode, 7))))
        return NULL;
      return gen_split_2391 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16DImode)
        || register_operand (operands[3], V16DImode)))) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DImode, 7))))
        return NULL;
      return gen_split_2392 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32DImode)
        || register_operand (operands[3], V32DImode)))) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DImode, 7))))
        return NULL;
      return gen_split_2393 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64DImode)
        || register_operand (operands[3], V64DImode)))) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DImode, 7))))
        return NULL;
      return gen_split_2394 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128DImode)
        || register_operand (operands[3], V128DImode)))) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DImode, 7))))
        return NULL;
      return gen_split_2395 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256DImode)
        || register_operand (operands[3], V256DImode)))) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DImode, 7))))
        return NULL;
      return gen_split_2396 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512DImode)
        || register_operand (operands[3], V512DImode)))) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DImode, 7))))
        return NULL;
      return gen_split_2397 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1HFmode)
        || register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HFmode, 7))))
        return NULL;
      return gen_split_2398 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2HFmode)
        || register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HFmode, 7))))
        return NULL;
      return gen_split_2399 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4HFmode)
        || register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HFmode, 7))))
        return NULL;
      return gen_split_2400 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8HFmode)
        || register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HFmode, 7))))
        return NULL;
      return gen_split_2401 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16HFmode)
        || register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HFmode, 7))))
        return NULL;
      return gen_split_2402 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32HFmode)
        || register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HFmode, 7))))
        return NULL;
      return gen_split_2403 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64HFmode)
        || register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HFmode, 7))))
        return NULL;
      return gen_split_2404 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128HFmode)
        || register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HFmode, 7))))
        return NULL;
      return gen_split_2405 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256HFmode)
        || register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HFmode, 7))))
        return NULL;
      return gen_split_2406 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512HFmode)
        || register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HFmode, 7))))
        return NULL;
      return gen_split_2407 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024HFmode)
        || register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HFmode, 7))))
        return NULL;
      return gen_split_2408 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2048HFmode)
        || register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HFmode, 7))))
        return NULL;
      return gen_split_2409 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1SFmode)
        || register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SFmode, 7))))
        return NULL;
      return gen_split_2410 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2SFmode)
        || register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SFmode, 7))))
        return NULL;
      return gen_split_2411 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4SFmode)
        || register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SFmode, 7))))
        return NULL;
      return gen_split_2412 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8SFmode)
        || register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SFmode, 7))))
        return NULL;
      return gen_split_2413 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16SFmode)
        || register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SFmode, 7))))
        return NULL;
      return gen_split_2414 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32SFmode)
        || register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SFmode, 7))))
        return NULL;
      return gen_split_2415 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64SFmode)
        || register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SFmode, 7))))
        return NULL;
      return gen_split_2416 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128SFmode)
        || register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SFmode, 7))))
        return NULL;
      return gen_split_2417 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256SFmode)
        || register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SFmode, 7))))
        return NULL;
      return gen_split_2418 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512SFmode)
        || register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SFmode, 7))))
        return NULL;
      return gen_split_2419 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024SFmode)
        || register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SFmode, 7))))
        return NULL;
      return gen_split_2420 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1DFmode)
        || register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DFmode, 7))))
        return NULL;
      return gen_split_2421 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2DFmode)
        || register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DFmode, 7))))
        return NULL;
      return gen_split_2422 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4DFmode)
        || register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DFmode, 7))))
        return NULL;
      return gen_split_2423 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8DFmode)
        || register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DFmode, 7))))
        return NULL;
      return gen_split_2424 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16DFmode)
        || register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DFmode, 7))))
        return NULL;
      return gen_split_2425 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32DFmode)
        || register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DFmode, 7))))
        return NULL;
      return gen_split_2426 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64DFmode)
        || register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DFmode, 7))))
        return NULL;
      return gen_split_2427 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128DFmode)
        || register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DFmode, 7))))
        return NULL;
      return gen_split_2428 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256DFmode)
        || register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DFmode, 7))))
        return NULL;
      return gen_split_2429 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !((
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512DFmode)
        || register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1922 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DFmode, 7))))
        return NULL;
      return gen_split_2430 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_141 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern155 (x2))
    {
    case 0:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8137 (insn, operands);

    case 1:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8143 (insn, operands);

    case 2:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8149 (insn, operands);

    case 3:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8155 (insn, operands);

    case 4:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8161 (insn, operands);

    case 5:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8167 (insn, operands);

    case 6:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8173 (insn, operands);

    case 7:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8179 (insn, operands);

    case 8:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8185 (insn, operands);

    case 9:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8191 (insn, operands);

    case 10:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8197 (insn, operands);

    case 11:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8203 (insn, operands);

    case 12:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8209 (insn, operands);

    case 13:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8215 (insn, operands);

    case 14:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8221 (insn, operands);

    case 15:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8227 (insn, operands);

    case 16:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8233 (insn, operands);

    case 17:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8239 (insn, operands);

    case 18:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8245 (insn, operands);

    case 19:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8251 (insn, operands);

    case 20:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8257 (insn, operands);

    case 21:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8263 (insn, operands);

    case 22:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8269 (insn, operands);

    case 23:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8275 (insn, operands);

    case 24:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8281 (insn, operands);

    case 25:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8287 (insn, operands);

    case 26:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8293 (insn, operands);

    case 27:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8299 (insn, operands);

    case 28:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8305 (insn, operands);

    case 29:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8311 (insn, operands);

    case 30:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8317 (insn, operands);

    case 31:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8323 (insn, operands);

    case 32:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8329 (insn, operands);

    case 33:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8335 (insn, operands);

    case 34:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8341 (insn, operands);

    case 35:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8347 (insn, operands);

    case 36:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8353 (insn, operands);

    case 37:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8359 (insn, operands);

    case 38:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8365 (insn, operands);

    case 39:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8371 (insn, operands);

    case 40:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8377 (insn, operands);

    case 41:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8383 (insn, operands);

    case 42:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8389 (insn, operands);

    case 43:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8395 (insn, operands);

    case 44:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8401 (insn, operands);

    case 45:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8407 (insn, operands);

    case 46:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8413 (insn, operands);

    case 47:
      if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8419 (insn, operands);

    case 48:
      if (!(
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8709 (insn, operands);

    case 49:
      if (!(
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8711 (insn, operands);

    case 50:
      if (!(
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8713 (insn, operands);

    case 51:
      if (!(
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8715 (insn, operands);

    case 52:
      if (!(
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8717 (insn, operands);

    case 53:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8719 (insn, operands);

    case 54:
      if (!(
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8721 (insn, operands);

    case 55:
      if (!(
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8723 (insn, operands);

    case 56:
      if (!(
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8725 (insn, operands);

    case 57:
      if (!(
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8727 (insn, operands);

    case 58:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8729 (insn, operands);

    case 59:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8731 (insn, operands);

    case 60:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8733 (insn, operands);

    case 61:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8735 (insn, operands);

    case 62:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8737 (insn, operands);

    case 63:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8739 (insn, operands);

    case 64:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8741 (insn, operands);

    case 65:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8743 (insn, operands);

    case 66:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8745 (insn, operands);

    case 67:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8747 (insn, operands);

    case 68:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8749 (insn, operands);

    case 69:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8751 (insn, operands);

    case 70:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8753 (insn, operands);

    case 71:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8755 (insn, operands);

    case 72:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8757 (insn, operands);

    case 73:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8759 (insn, operands);

    case 74:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8761 (insn, operands);

    case 75:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8763 (insn, operands);

    case 76:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8765 (insn, operands);

    case 77:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8767 (insn, operands);

    case 78:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8769 (insn, operands);

    case 79:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8771 (insn, operands);

    case 80:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8773 (insn, operands);

    case 81:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8775 (insn, operands);

    case 82:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8777 (insn, operands);

    case 83:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8779 (insn, operands);

    case 84:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8781 (insn, operands);

    case 85:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8783 (insn, operands);

    case 86:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8785 (insn, operands);

    case 87:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8787 (insn, operands);

    case 88:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8789 (insn, operands);

    case 89:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8791 (insn, operands);

    case 90:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8793 (insn, operands);

    case 91:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8795 (insn, operands);

    case 92:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8797 (insn, operands);

    case 93:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8799 (insn, operands);

    case 94:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8801 (insn, operands);

    case 95:
      if (!((
#line 697 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 699 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8803 (insn, operands);

    case 96:
      if (!(
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8852 (insn, operands);

    case 97:
      if (!(
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8853 (insn, operands);

    case 98:
      if (!(
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8854 (insn, operands);

    case 99:
      if (!(
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8855 (insn, operands);

    case 100:
      if (!(
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8856 (insn, operands);

    case 101:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8857 (insn, operands);

    case 102:
      if (!(
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8858 (insn, operands);

    case 103:
      if (!(
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8859 (insn, operands);

    case 104:
      if (!(
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8860 (insn, operands);

    case 105:
      if (!(
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8861 (insn, operands);

    case 106:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8862 (insn, operands);

    case 107:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8863 (insn, operands);

    case 108:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8864 (insn, operands);

    case 109:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8865 (insn, operands);

    case 110:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8866 (insn, operands);

    case 111:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8867 (insn, operands);

    case 112:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8868 (insn, operands);

    case 113:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8869 (insn, operands);

    case 114:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8870 (insn, operands);

    case 115:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8871 (insn, operands);

    case 116:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8872 (insn, operands);

    case 117:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8873 (insn, operands);

    case 118:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8874 (insn, operands);

    case 119:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8875 (insn, operands);

    case 120:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8876 (insn, operands);

    case 121:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8877 (insn, operands);

    case 122:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8878 (insn, operands);

    case 123:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8879 (insn, operands);

    case 124:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8880 (insn, operands);

    case 125:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8881 (insn, operands);

    case 126:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8882 (insn, operands);

    case 127:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8883 (insn, operands);

    case 128:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8884 (insn, operands);

    case 129:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8885 (insn, operands);

    case 130:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8886 (insn, operands);

    case 131:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8887 (insn, operands);

    case 132:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8888 (insn, operands);

    case 133:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8889 (insn, operands);

    case 134:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8890 (insn, operands);

    case 135:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8891 (insn, operands);

    case 136:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8892 (insn, operands);

    case 137:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8893 (insn, operands);

    case 138:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8894 (insn, operands);

    case 139:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8895 (insn, operands);

    case 140:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8896 (insn, operands);

    case 141:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8897 (insn, operands);

    case 142:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8898 (insn, operands);

    case 143:
      if (!((
#line 740 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 742 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_8899 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_148 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ASHIFT:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          switch (pattern231 (x2))
            {
            case 0:
              if (!((
#line 2992 "../../gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 2997 "../../gcc/config/riscv/riscv.md"
( 1)))
                return NULL;
              return gen_split_41 (insn, operands);

            case 1:
              if (!((
#line 2992 "../../gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 2997 "../../gcc/config/riscv/riscv.md"
( 1)))
                return NULL;
              return gen_split_44 (insn, operands);

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x4) != E_DImode)
            return NULL;
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return NULL;
          x6 = XEXP (x2, 1);
          if (GET_CODE (x6) != ZERO_EXTEND
              || GET_MODE (x6) != E_DImode
              || pattern283 (x2, 
E_HImode) != 0)
            return NULL;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_HImode)
              || !
#line 170 "../../gcc/config/riscv/crypto.md"
(TARGET_ZBKB && TARGET_64BIT))
            return NULL;
          return gen_split_187 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      switch (pattern234 (x2))
        {
        case 0:
          if (!((
#line 1022 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && !single_bit_mask_operand (operands[2], VOIDmode)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 1024 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_176 (insn, operands);

        case 1:
          if (!((
#line 1022 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && !single_bit_mask_operand (operands[2], VOIDmode)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 1024 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_178 (insn, operands);

        case 2:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2590 (insn, operands);

        case 3:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2604 (insn, operands);

        case 4:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2618 (insn, operands);

        case 5:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2632 (insn, operands);

        case 6:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2646 (insn, operands);

        case 7:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2660 (insn, operands);

        case 8:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2674 (insn, operands);

        case 9:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2688 (insn, operands);

        case 10:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2702 (insn, operands);

        case 11:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2716 (insn, operands);

        case 12:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2730 (insn, operands);

        case 13:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2744 (insn, operands);

        case 14:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2758 (insn, operands);

        case 15:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2772 (insn, operands);

        case 16:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2786 (insn, operands);

        case 17:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2800 (insn, operands);

        case 18:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2814 (insn, operands);

        case 19:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2828 (insn, operands);

        case 20:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2842 (insn, operands);

        case 21:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2856 (insn, operands);

        case 22:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2870 (insn, operands);

        case 23:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2884 (insn, operands);

        case 24:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2898 (insn, operands);

        case 25:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2912 (insn, operands);

        case 26:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2926 (insn, operands);

        case 27:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2940 (insn, operands);

        case 28:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2954 (insn, operands);

        case 29:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2968 (insn, operands);

        case 30:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2982 (insn, operands);

        case 31:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2996 (insn, operands);

        case 32:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3010 (insn, operands);

        case 33:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3024 (insn, operands);

        case 34:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3038 (insn, operands);

        case 35:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3052 (insn, operands);

        case 36:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3066 (insn, operands);

        case 37:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3080 (insn, operands);

        case 38:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3094 (insn, operands);

        case 39:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3108 (insn, operands);

        case 40:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3122 (insn, operands);

        case 41:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3136 (insn, operands);

        case 42:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3150 (insn, operands);

        case 43:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3164 (insn, operands);

        case 44:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3178 (insn, operands);

        case 45:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3192 (insn, operands);

        case 46:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3206 (insn, operands);

        case 47:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3220 (insn, operands);

        case 48:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3234 (insn, operands);

        case 49:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3248 (insn, operands);

        case 50:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3262 (insn, operands);

        case 51:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3276 (insn, operands);

        case 52:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3290 (insn, operands);

        case 53:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3304 (insn, operands);

        case 54:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3318 (insn, operands);

        case 55:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3332 (insn, operands);

        case 56:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3346 (insn, operands);

        case 57:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3360 (insn, operands);

        case 58:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3374 (insn, operands);

        case 59:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3388 (insn, operands);

        case 60:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3402 (insn, operands);

        case 61:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3416 (insn, operands);

        case 62:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3430 (insn, operands);

        case 63:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3444 (insn, operands);

        case 64:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3458 (insn, operands);

        case 65:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3472 (insn, operands);

        case 66:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3486 (insn, operands);

        case 67:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3500 (insn, operands);

        case 68:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3514 (insn, operands);

        case 69:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3528 (insn, operands);

        case 70:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3948 (insn, operands);

        case 71:
          if (!(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3951 (insn, operands);

        case 72:
          if (!(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3954 (insn, operands);

        case 73:
          if (!(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3957 (insn, operands);

        case 74:
          if (!(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3960 (insn, operands);

        case 75:
          if (!(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3963 (insn, operands);

        case 76:
          if (!(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3966 (insn, operands);

        case 77:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3969 (insn, operands);

        case 78:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3972 (insn, operands);

        case 79:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3975 (insn, operands);

        case 80:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3978 (insn, operands);

        case 81:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3981 (insn, operands);

        case 82:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3984 (insn, operands);

        case 83:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3987 (insn, operands);

        case 84:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3990 (insn, operands);

        case 85:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3993 (insn, operands);

        case 86:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3996 (insn, operands);

        case 87:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3999 (insn, operands);

        case 88:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4002 (insn, operands);

        case 89:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4005 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVMF64BImode:
          if (pattern343 (x2, 
E_RVVMF64BImode) != 0
              || !((
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1475 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10092 (insn, operands);

        case E_RVVMF32BImode:
          if (pattern343 (x2, 
E_RVVMF32BImode) != 0
              || !(
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1475 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10094 (insn, operands);

        case E_RVVMF16BImode:
          if (pattern343 (x2, 
E_RVVMF16BImode) != 0
              || !(
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1475 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10096 (insn, operands);

        case E_RVVMF8BImode:
          if (pattern343 (x2, 
E_RVVMF8BImode) != 0
              || !(
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1475 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10098 (insn, operands);

        case E_RVVMF4BImode:
          if (pattern343 (x2, 
E_RVVMF4BImode) != 0
              || !(
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1475 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10100 (insn, operands);

        case E_RVVMF2BImode:
          if (pattern343 (x2, 
E_RVVMF2BImode) != 0
              || !(
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1475 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10102 (insn, operands);

        case E_RVVM1BImode:
          if (pattern343 (x2, 
E_RVVM1BImode) != 0
              || !(
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1475 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10104 (insn, operands);

        case E_V1BImode:
          if (pattern343 (x2, 
E_V1BImode) != 0
              || !((
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1475 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10106 (insn, operands);

        case E_V2BImode:
          if (pattern343 (x2, 
E_V2BImode) != 0
              || !((
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1475 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10108 (insn, operands);

        case E_V4BImode:
          if (pattern343 (x2, 
E_V4BImode) != 0
              || !((
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1475 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10110 (insn, operands);

        case E_V8BImode:
          if (pattern343 (x2, 
E_V8BImode) != 0
              || !((
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1475 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10112 (insn, operands);

        case E_V16BImode:
          if (pattern343 (x2, 
E_V16BImode) != 0
              || !((
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1475 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10114 (insn, operands);

        case E_V32BImode:
          if (pattern343 (x2, 
E_V32BImode) != 0
              || !((
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1475 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10116 (insn, operands);

        case E_V64BImode:
          if (pattern343 (x2, 
E_V64BImode) != 0
              || !((
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1475 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10118 (insn, operands);

        case E_V128BImode:
          if (pattern343 (x2, 
E_V128BImode) != 0
              || !((
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1475 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10120 (insn, operands);

        case E_V256BImode:
          if (pattern343 (x2, 
E_V256BImode) != 0
              || !((
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1475 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10122 (insn, operands);

        case E_V512BImode:
          if (pattern343 (x2, 
E_V512BImode) != 0
              || !((
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1475 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10124 (insn, operands);

        case E_V1024BImode:
          if (pattern343 (x2, 
E_V1024BImode) != 0
              || !((
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1475 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10126 (insn, operands);

        case E_V2048BImode:
          if (pattern343 (x2, 
E_V2048BImode) != 0
              || !((
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1475 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10128 (insn, operands);

        case E_V4096BImode:
          if (pattern343 (x2, 
E_V4096BImode) != 0
              || !((
#line 1473 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1475 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_10130 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_155 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x2) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVM8SFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4411 (insn, operands);

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x2) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVM4SFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4412 (insn, operands);

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x2) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVM2SFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4413 (insn, operands);

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x2) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVM1SFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4414 (insn, operands);

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x2) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF2SFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4415 (insn, operands);

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x2) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM8DFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4416 (insn, operands);

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x2) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM4DFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4417 (insn, operands);

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x2) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVM2DFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4418 (insn, operands);

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x2) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVM1DFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4419 (insn, operands);

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x2) != E_V1HFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4420 (insn, operands);

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x2) != E_V2HFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4421 (insn, operands);

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x2) != E_V4HFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4422 (insn, operands);

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x2) != E_V8HFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4423 (insn, operands);

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x2) != E_V16HFmode
          || !register_operand (operands[1], E_V16SFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4424 (insn, operands);

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x2) != E_V32HFmode
          || !register_operand (operands[1], E_V32SFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4425 (insn, operands);

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x2) != E_V64HFmode
          || !register_operand (operands[1], E_V64SFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4426 (insn, operands);

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x2) != E_V128HFmode
          || !register_operand (operands[1], E_V128SFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1006 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4427 (insn, operands);

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x2) != E_V256HFmode
          || !register_operand (operands[1], E_V256SFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4428 (insn, operands);

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x2) != E_V512HFmode
          || !register_operand (operands[1], E_V512SFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1008 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4429 (insn, operands);

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x2) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024SFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4430 (insn, operands);

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x2) != E_V1SFmode
          || !register_operand (operands[1], E_V1DFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4431 (insn, operands);

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4432 (insn, operands);

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4DFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4433 (insn, operands);

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !register_operand (operands[1], E_V8DFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4434 (insn, operands);

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x2) != E_V16SFmode
          || !register_operand (operands[1], E_V16DFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1014 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4435 (insn, operands);

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x2) != E_V32SFmode
          || !register_operand (operands[1], E_V32DFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4436 (insn, operands);

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x2) != E_V64SFmode
          || !register_operand (operands[1], E_V64DFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4437 (insn, operands);

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x2) != E_V128SFmode
          || !register_operand (operands[1], E_V128DFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1017 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4438 (insn, operands);

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x2) != E_V256SFmode
          || !register_operand (operands[1], E_V256DFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4439 (insn, operands);

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x2) != E_V512SFmode
          || !register_operand (operands[1], E_V512DFmode)
          || !((
#line 883 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 885 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4440 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_161 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      return split_136 (x1, insn);

    case MULT:
      return split_137 (x1, insn);

    case NEG:
      switch (pattern144 (x2))
        {
        case 0:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5505 (insn, operands);

        case 1:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5506 (insn, operands);

        case 2:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5507 (insn, operands);

        case 3:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5508 (insn, operands);

        case 4:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5509 (insn, operands);

        case 5:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5510 (insn, operands);

        case 6:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5511 (insn, operands);

        case 7:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5512 (insn, operands);

        case 8:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5513 (insn, operands);

        case 9:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5514 (insn, operands);

        case 10:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5515 (insn, operands);

        case 11:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5516 (insn, operands);

        case 12:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5517 (insn, operands);

        case 13:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5518 (insn, operands);

        case 14:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5519 (insn, operands);

        case 15:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5520 (insn, operands);

        case 16:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5521 (insn, operands);

        case 17:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5522 (insn, operands);

        case 18:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5523 (insn, operands);

        case 19:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5524 (insn, operands);

        case 20:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5525 (insn, operands);

        case 21:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5526 (insn, operands);

        case 22:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5527 (insn, operands);

        case 23:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5528 (insn, operands);

        case 24:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5529 (insn, operands);

        case 25:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5530 (insn, operands);

        case 26:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5531 (insn, operands);

        case 27:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5532 (insn, operands);

        case 28:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5533 (insn, operands);

        case 29:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5534 (insn, operands);

        case 30:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5535 (insn, operands);

        case 31:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5536 (insn, operands);

        case 32:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5537 (insn, operands);

        case 33:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5538 (insn, operands);

        case 34:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5539 (insn, operands);

        case 35:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5540 (insn, operands);

        case 36:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5541 (insn, operands);

        case 37:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5542 (insn, operands);

        case 38:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5543 (insn, operands);

        case 39:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5544 (insn, operands);

        case 40:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5545 (insn, operands);

        case 41:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5546 (insn, operands);

        case 42:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5547 (insn, operands);

        case 43:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5548 (insn, operands);

        case 44:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5549 (insn, operands);

        case 45:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5550 (insn, operands);

        case 46:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5551 (insn, operands);

        case 47:
          if (!((
#line 1321 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1323 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_5552 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      return split_139 (x1, insn);

    case ZERO_EXTEND:
      return split_138 (x1, insn);

    case FLOAT_EXTEND:
      switch (pattern150 (x2))
        {
        case 0:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8901 (insn, operands);

        case 1:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8904 (insn, operands);

        case 2:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8907 (insn, operands);

        case 3:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8910 (insn, operands);

        case 4:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8913 (insn, operands);

        case 5:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8916 (insn, operands);

        case 6:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8919 (insn, operands);

        case 7:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8922 (insn, operands);

        case 8:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8925 (insn, operands);

        case 9:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8928 (insn, operands);

        case 10:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8931 (insn, operands);

        case 11:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8934 (insn, operands);

        case 12:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8937 (insn, operands);

        case 13:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8940 (insn, operands);

        case 14:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8943 (insn, operands);

        case 15:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8946 (insn, operands);

        case 16:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8949 (insn, operands);

        case 17:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8952 (insn, operands);

        case 18:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8955 (insn, operands);

        case 19:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8958 (insn, operands);

        case 20:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8961 (insn, operands);

        case 21:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8964 (insn, operands);

        case 22:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8967 (insn, operands);

        case 23:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8970 (insn, operands);

        case 24:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8973 (insn, operands);

        case 25:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8976 (insn, operands);

        case 26:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8979 (insn, operands);

        case 27:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8982 (insn, operands);

        case 28:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8985 (insn, operands);

        case 29:
          if (!((
#line 758 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 760 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8988 (insn, operands);

        case 30:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9050 (insn, operands);

        case 31:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9051 (insn, operands);

        case 32:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9052 (insn, operands);

        case 33:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9053 (insn, operands);

        case 34:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9054 (insn, operands);

        case 35:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9055 (insn, operands);

        case 36:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9056 (insn, operands);

        case 37:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9057 (insn, operands);

        case 38:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9058 (insn, operands);

        case 39:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9059 (insn, operands);

        case 40:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9060 (insn, operands);

        case 41:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9061 (insn, operands);

        case 42:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9062 (insn, operands);

        case 43:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9063 (insn, operands);

        case 44:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9064 (insn, operands);

        case 45:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9065 (insn, operands);

        case 46:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9066 (insn, operands);

        case 47:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9067 (insn, operands);

        case 48:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9068 (insn, operands);

        case 49:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9069 (insn, operands);

        case 50:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9070 (insn, operands);

        case 51:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9071 (insn, operands);

        case 52:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9072 (insn, operands);

        case 53:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9073 (insn, operands);

        case 54:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9074 (insn, operands);

        case 55:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9075 (insn, operands);

        case 56:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9076 (insn, operands);

        case 57:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9077 (insn, operands);

        case 58:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9078 (insn, operands);

        case 59:
          if (!((
#line 810 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 812 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9079 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_175 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return NULL;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return NULL;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return NULL;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 0);
  switch (GET_CODE (x9))
    {
    case NE:
    case EQ:
      res = split_174 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  if (!fp_native_comparison (x9, E_VOIDmode))
    return NULL;
  switch (pattern411 (x3))
    {
    case 0:
      if (!((
#line 3376 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3378 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_85 (insn, operands);

    case 1:
      if (!((
#line 3376 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))) && 
#line 3378 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_86 (insn, operands);

    case 2:
      if (!((
#line 3376 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3378 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_87 (insn, operands);

    case 3:
      if (!((
#line 3376 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))) && 
#line 3378 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_88 (insn, operands);

    case 4:
      if (!((
#line 3376 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3378 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_89 (insn, operands);

    case 5:
      if (!((
#line 3376 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))) && 
#line 3378 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_90 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_176 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return NULL;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NOT
      || GET_MODE (x4) != E_DImode)
    return NULL;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_DImode))
    return NULL;
  x6 = XEXP (x4, 0);
  if (GET_MODE (x6) != E_DImode)
    return NULL;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  if (!register_operand (operands[3], E_DImode))
    return NULL;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_SImode))
    return NULL;
  switch (GET_CODE (x6))
    {
    case SIGN_EXTEND:
      x10 = XEXP (x6, 0);
      switch (pattern467 (x10))
        {
        case 0:
          if (!((
#line 736 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 741 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_155 (insn, operands);

        case 1:
          if (!((
#line 764 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 768 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_159 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x10 = XEXP (x6, 0);
      switch (pattern467 (x10))
        {
        case 0:
          if (!((
#line 736 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 741 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_156 (insn, operands);

        case 1:
          if (!((
#line 764 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 768 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_160 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_177 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !p2m1_shift_operand (operands[2], E_SImode)
              || !register_operand (operands[3], E_SImode))
            return NULL;
          return gen_split_50 (insn, operands);

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !register_operand (operands[3], E_DImode))
            return NULL;
          if (p2m1_shift_operand (operands[2], E_DImode)
              && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return gen_split_51 (insn, operands);
          if (!high_mask_shift_operand (operands[2], E_DImode)
              || !
#line 3119 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return NULL;
          return gen_split_52 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      if (pattern340 (x1) != 0
          || !(
#line 3138 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && !TARGET_ZBA
   && ((INTVAL (operands[3]) >> INTVAL (operands[2])) == 0xffffffff)) && 
#line 3141 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_53 (insn, operands);

    case NOT:
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          switch (pattern373 (x1))
            {
            case 0:
              if (((
#line 242 "../../gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 245 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return gen_split_112 (insn, operands);
              break;

            case 1:
              if (((
#line 242 "../../gcc/config/riscv/bitmanip.md"
((TARGET_ZBB || TARGET_ZBKB) && !TARGET_ZCB
   && !optimize_function_for_size_p (cfun)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 245 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return gen_split_114 (insn, operands);
              break;

            default:
              break;
            }
          if (GET_CODE (x8) != SUBREG
              || maybe_ne (SUBREG_BYTE (x8), 0)
              || GET_MODE (x8) != E_DImode)
            return NULL;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != ASHIFT
              || GET_MODE (x9) != E_SImode)
            return NULL;
          x10 = XEXP (x9, 0);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return NULL;
          x11 = XEXP (x9, 1);
          operands[1] = x11;
          if (!register_operand (operands[1], E_QImode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (!arith_operand (operands[2], E_DImode))
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          if (!register_operand (operands[3], E_DImode)
              || !
#line 893 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBS
   && clz_hwi (INTVAL (operands[2])) >= 33))
            return NULL;
          return gen_split_168 (insn, operands);

        case SIGN_EXTEND:
          switch (pattern379 (x1))
            {
            case 0:
              if (!((
#line 736 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 741 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return NULL;
              return gen_split_157 (insn, operands);

            case 1:
              if (!((
#line 764 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 768 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return NULL;
              return gen_split_161 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          switch (pattern379 (x1))
            {
            case 0:
              if (!((
#line 736 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (TARGET_ZBB || TARGET_ZBKB)
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 741 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return NULL;
              return gen_split_158 (insn, operands);

            case 1:
              if (!((
#line 764 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBS
   && (INTVAL (operands[2]) & 0x1f) != 0x1f) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 768 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return NULL;
              return gen_split_162 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case NEG:
      if (GET_MODE (x4) != E_DImode)
        return NULL;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != GE
          || GET_MODE (x8) != E_DImode)
        return NULL;
      x12 = XEXP (x8, 1);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return NULL;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_DImode))
        return NULL;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_DImode))
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!register_operand (operands[3], E_DImode)
          || !
#line 260 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB || TARGET_ZBKB))
        return NULL;
      return gen_split_116 (insn, operands);

    case SIGN_EXTRACT:
      x13 = XEXP (x4, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      x14 = XEXP (x4, 2);
      operands[2] = x14;
      if (!immediate_operand (operands[2], E_VOIDmode))
        return NULL;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern448 (x3, 
E_SImode) != 0)
            return NULL;
          if ((
#line 106 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return gen_split_10533 (insn, operands);
          if ((
#line 119 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && !TARGET_ZBS && (UINTVAL (operands[2]) < 11)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return gen_split_10535 (insn, operands);
          if ((
#line 49 "../../gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return gen_split_10577 (insn, operands);
          if (!(
#line 62 "../../gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU && (UINTVAL (operands[2]) < 11)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10579 (insn, operands);

        case E_DImode:
          if (pattern448 (x3, 
E_DImode) != 0)
            return NULL;
          if ((
#line 106 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return gen_split_10534 (insn, operands);
          if ((
#line 119 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE && !TARGET_ZBS && (UINTVAL (operands[2]) < 11)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return gen_split_10536 (insn, operands);
          if ((
#line 49 "../../gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return gen_split_10578 (insn, operands);
          if (!(
#line 62 "../../gcc/config/riscv/sfb.md"
(TARGET_SFB_ALU && (UINTVAL (operands[2]) < 11)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10580 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      switch (pattern356 (x1))
        {
        case 0:
          if (!(
#line 137 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10537 (insn, operands);

        case 1:
          if (!(
#line 137 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10541 (insn, operands);

        case 2:
          if (!(
#line 137 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10538 (insn, operands);

        case 3:
          if (!(
#line 137 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10542 (insn, operands);

        case 4:
          if (!(
#line 137 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10539 (insn, operands);

        case 5:
          if (!(
#line 137 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10543 (insn, operands);

        case 6:
          if (!(
#line 137 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10540 (insn, operands);

        case 7:
          if (!(
#line 137 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10544 (insn, operands);

        case 8:
          if (!(
#line 150 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10545 (insn, operands);

        case 9:
          if (!(
#line 150 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10547 (insn, operands);

        case 10:
          if (!(
#line 150 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10546 (insn, operands);

        case 11:
          if (!(
#line 150 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10548 (insn, operands);

        case 12:
          if (!(
#line 163 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10549 (insn, operands);

        case 13:
          if (!(
#line 163 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10551 (insn, operands);

        case 14:
          if (!(
#line 163 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10550 (insn, operands);

        case 15:
          if (!(
#line 163 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10552 (insn, operands);

        case 16:
          if (!(
#line 176 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10553 (insn, operands);

        case 17:
          if (!(
#line 176 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10555 (insn, operands);

        case 18:
          if (!(
#line 176 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10554 (insn, operands);

        case 19:
          if (!(
#line 176 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10556 (insn, operands);

        default:
          return NULL;
        }

    case EQ:
      switch (pattern356 (x1))
        {
        case 0:
          if (!(
#line 192 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10557 (insn, operands);

        case 1:
          if (!(
#line 192 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10561 (insn, operands);

        case 2:
          if (!(
#line 192 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10558 (insn, operands);

        case 3:
          if (!(
#line 192 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10562 (insn, operands);

        case 4:
          if (!(
#line 192 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10559 (insn, operands);

        case 5:
          if (!(
#line 192 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10563 (insn, operands);

        case 6:
          if (!(
#line 192 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10560 (insn, operands);

        case 7:
          if (!(
#line 192 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10564 (insn, operands);

        case 8:
          if (!(
#line 205 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10565 (insn, operands);

        case 9:
          if (!(
#line 205 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10567 (insn, operands);

        case 10:
          if (!(
#line 205 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10566 (insn, operands);

        case 11:
          if (!(
#line 205 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10568 (insn, operands);

        case 12:
          if (!(
#line 218 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10569 (insn, operands);

        case 13:
          if (!(
#line 218 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10571 (insn, operands);

        case 14:
          if (!(
#line 218 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10570 (insn, operands);

        case 15:
          if (!(
#line 218 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10572 (insn, operands);

        case 16:
          if (!(
#line 231 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10573 (insn, operands);

        case 17:
          if (!(
#line 231 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10575 (insn, operands);

        case 18:
          if (!(
#line 231 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return NULL;
          return gen_split_10574 (insn, operands);

        case 19:
          if (!(
#line 231 "../../gcc/config/riscv/zicond.md"
(TARGET_ZICOND_LIKE || TARGET_XTHEADCONDMOV) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_10576 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
