/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode))
        return -1;
      return 2;

    case E_RVVM8HFmode:
      if (!register_operand (operands[0], E_RVVM8HFmode)
          || GET_MODE (x3) != E_RVVM8HFmode
          || !register_operand (operands[1], E_RVVM8HFmode))
        return -1;
      return 3;

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x3) != E_RVVM4HFmode
          || !register_operand (operands[1], E_RVVM4HFmode))
        return -1;
      return 4;

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x3) != E_RVVM2HFmode
          || !register_operand (operands[1], E_RVVM2HFmode))
        return -1;
      return 5;

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x3) != E_RVVM1HFmode
          || !register_operand (operands[1], E_RVVM1HFmode))
        return -1;
      return 6;

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x3) != E_RVVMF2HFmode
          || !register_operand (operands[1], E_RVVMF2HFmode))
        return -1;
      return 7;

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x3) != E_RVVMF4HFmode
          || !register_operand (operands[1], E_RVVMF4HFmode))
        return -1;
      return 8;

    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode)
          || GET_MODE (x3) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVM8SFmode))
        return -1;
      return 9;

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x3) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM4SFmode))
        return -1;
      return 10;

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x3) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM2SFmode))
        return -1;
      return 11;

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x3) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVM1SFmode))
        return -1;
      return 12;

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x3) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF2SFmode))
        return -1;
      return 13;

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode)
          || GET_MODE (x3) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVM8DFmode))
        return -1;
      return 14;

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode)
          || GET_MODE (x3) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVM4DFmode))
        return -1;
      return 15;

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode)
          || GET_MODE (x3) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVM2DFmode))
        return -1;
      return 16;

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode)
          || GET_MODE (x3) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVM1DFmode))
        return -1;
      return 17;

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x3) != E_V1HFmode
          || !register_operand (operands[1], E_V1HFmode))
        return -1;
      return 18;

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x3) != E_V2HFmode
          || !register_operand (operands[1], E_V2HFmode))
        return -1;
      return 19;

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 20;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 21;

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x3) != E_V16HFmode
          || !register_operand (operands[1], E_V16HFmode))
        return -1;
      return 22;

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x3) != E_V32HFmode
          || !register_operand (operands[1], E_V32HFmode))
        return -1;
      return 23;

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x3) != E_V64HFmode
          || !register_operand (operands[1], E_V64HFmode))
        return -1;
      return 24;

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x3) != E_V128HFmode
          || !register_operand (operands[1], E_V128HFmode))
        return -1;
      return 25;

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x3) != E_V256HFmode
          || !register_operand (operands[1], E_V256HFmode))
        return -1;
      return 26;

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x3) != E_V512HFmode
          || !register_operand (operands[1], E_V512HFmode))
        return -1;
      return 27;

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x3) != E_V1024HFmode
          || !register_operand (operands[1], E_V1024HFmode))
        return -1;
      return 28;

    case E_V2048HFmode:
      if (!register_operand (operands[0], E_V2048HFmode)
          || GET_MODE (x3) != E_V2048HFmode
          || !register_operand (operands[1], E_V2048HFmode))
        return -1;
      return 29;

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x3) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode))
        return -1;
      return 30;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 31;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 32;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode))
        return -1;
      return 33;

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x3) != E_V16SFmode
          || !register_operand (operands[1], E_V16SFmode))
        return -1;
      return 34;

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x3) != E_V32SFmode
          || !register_operand (operands[1], E_V32SFmode))
        return -1;
      return 35;

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x3) != E_V64SFmode
          || !register_operand (operands[1], E_V64SFmode))
        return -1;
      return 36;

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x3) != E_V128SFmode
          || !register_operand (operands[1], E_V128SFmode))
        return -1;
      return 37;

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x3) != E_V256SFmode
          || !register_operand (operands[1], E_V256SFmode))
        return -1;
      return 38;

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x3) != E_V512SFmode
          || !register_operand (operands[1], E_V512SFmode))
        return -1;
      return 39;

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode)
          || GET_MODE (x3) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024SFmode))
        return -1;
      return 40;

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x3) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode))
        return -1;
      return 41;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 42;

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode))
        return -1;
      return 43;

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x3) != E_V8DFmode
          || !register_operand (operands[1], E_V8DFmode))
        return -1;
      return 44;

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x3) != E_V16DFmode
          || !register_operand (operands[1], E_V16DFmode))
        return -1;
      return 45;

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x3) != E_V32DFmode
          || !register_operand (operands[1], E_V32DFmode))
        return -1;
      return 46;

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x3) != E_V64DFmode
          || !register_operand (operands[1], E_V64DFmode))
        return -1;
      return 47;

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode)
          || GET_MODE (x3) != E_V128DFmode
          || !register_operand (operands[1], E_V128DFmode))
        return -1;
      return 48;

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode)
          || GET_MODE (x3) != E_V256DFmode
          || !register_operand (operands[1], E_V256DFmode))
        return -1;
      return 49;

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode)
          || GET_MODE (x3) != E_V512DFmode
          || !register_operand (operands[1], E_V512DFmode))
        return -1;
      return 50;

    default:
      return -1;
    }
}

int
pattern119 (rtx x1, rtx_code i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 5
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 6
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 7
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x12) != i1)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 10
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 11
      || GET_MODE (x15) != E_SImode)
    return -1;
  x16 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x16) != i1)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 12
      || GET_MODE (x17) != E_SImode)
    return -1;
  x18 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 13
      || GET_MODE (x19) != E_SImode)
    return -1;
  x20 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x20) != i1)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 14
      || GET_MODE (x21) != E_SImode)
    return -1;
  x22 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x22) != i1)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != 15
      || GET_MODE (x23) != E_SImode)
    return -1;
  x24 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_CODE (x25) != REG
      || REGNO (x25) != 16
      || GET_MODE (x25) != E_SImode)
    return -1;
  x26 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x26) != i1)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 17
      || GET_MODE (x27) != E_SImode)
    return -1;
  x28 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != 28
      || GET_MODE (x29) != E_SImode)
    return -1;
  x30 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x30) != i1)
    return -1;
  x31 = XEXP (x30, 0);
  if (GET_CODE (x31) != REG
      || REGNO (x31) != 29
      || GET_MODE (x31) != E_SImode)
    return -1;
  x32 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x32) != i1)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 30
      || GET_MODE (x33) != E_SImode)
    return -1;
  x34 = XVECEXP (x1, 0, 16);
  if (GET_CODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_CODE (x35) != REG
      || REGNO (x35) != 31
      || GET_MODE (x35) != E_SImode)
    return -1;
  return 0;
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern0 (x1, 
E_RVVM8QImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern0 (x1, 
E_RVVM4QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern0 (x1, 
E_RVVM2QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern0 (x1, 
E_RVVM1QImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern0 (x1, 
E_RVVM8HImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern0 (x1, 
E_RVVM4HImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern0 (x1, 
E_RVVM2HImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern0 (x1, 
E_RVVM1HImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern0 (x1, 
E_RVVM8SImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern0 (x1, 
E_RVVM4SImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern0 (x1, 
E_RVVM2SImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern0 (x1, 
E_RVVM1SImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern0 (x1, 
E_RVVM8DImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern0 (x1, 
E_RVVM4DImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern0 (x1, 
E_RVVM2DImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern0 (x1, 
E_RVVM1DImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern0 (x1, 
E_RVVMF2QImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern0 (x1, 
E_RVVMF4QImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern0 (x1, 
E_RVVMF8QImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern0 (x1, 
E_RVVMF2HImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern0 (x1, 
E_RVVMF4HImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern0 (x1, 
E_RVVMF2SImode) != 0)
        return -1;
      return 21;

    case E_V1QImode:
      if (pattern0 (x1, 
E_V1QImode) != 0)
        return -1;
      return 22;

    case E_V2QImode:
      if (pattern0 (x1, 
E_V2QImode) != 0)
        return -1;
      return 23;

    case E_V4QImode:
      if (pattern0 (x1, 
E_V4QImode) != 0)
        return -1;
      return 24;

    case E_V8QImode:
      if (pattern0 (x1, 
E_V8QImode) != 0)
        return -1;
      return 25;

    case E_V16QImode:
      if (pattern0 (x1, 
E_V16QImode) != 0)
        return -1;
      return 26;

    case E_V32QImode:
      if (pattern0 (x1, 
E_V32QImode) != 0)
        return -1;
      return 27;

    case E_V64QImode:
      if (pattern0 (x1, 
E_V64QImode) != 0)
        return -1;
      return 28;

    case E_V128QImode:
      if (pattern0 (x1, 
E_V128QImode) != 0)
        return -1;
      return 29;

    case E_V256QImode:
      if (pattern0 (x1, 
E_V256QImode) != 0)
        return -1;
      return 30;

    case E_V512QImode:
      if (pattern0 (x1, 
E_V512QImode) != 0)
        return -1;
      return 31;

    case E_V1024QImode:
      if (pattern0 (x1, 
E_V1024QImode) != 0)
        return -1;
      return 32;

    case E_V2048QImode:
      if (pattern0 (x1, 
E_V2048QImode) != 0)
        return -1;
      return 33;

    case E_V4096QImode:
      if (pattern0 (x1, 
E_V4096QImode) != 0)
        return -1;
      return 34;

    case E_V1HImode:
      if (pattern0 (x1, 
E_V1HImode) != 0)
        return -1;
      return 35;

    case E_V2HImode:
      if (pattern0 (x1, 
E_V2HImode) != 0)
        return -1;
      return 36;

    case E_V4HImode:
      if (pattern0 (x1, 
E_V4HImode) != 0)
        return -1;
      return 37;

    case E_V8HImode:
      if (pattern0 (x1, 
E_V8HImode) != 0)
        return -1;
      return 38;

    case E_V16HImode:
      if (pattern0 (x1, 
E_V16HImode) != 0)
        return -1;
      return 39;

    case E_V32HImode:
      if (pattern0 (x1, 
E_V32HImode) != 0)
        return -1;
      return 40;

    case E_V64HImode:
      if (pattern0 (x1, 
E_V64HImode) != 0)
        return -1;
      return 41;

    case E_V128HImode:
      if (pattern0 (x1, 
E_V128HImode) != 0)
        return -1;
      return 42;

    case E_V256HImode:
      if (pattern0 (x1, 
E_V256HImode) != 0)
        return -1;
      return 43;

    case E_V512HImode:
      if (pattern0 (x1, 
E_V512HImode) != 0)
        return -1;
      return 44;

    case E_V1024HImode:
      if (pattern0 (x1, 
E_V1024HImode) != 0)
        return -1;
      return 45;

    case E_V2048HImode:
      if (pattern0 (x1, 
E_V2048HImode) != 0)
        return -1;
      return 46;

    case E_V1SImode:
      if (pattern0 (x1, 
E_V1SImode) != 0)
        return -1;
      return 47;

    case E_V2SImode:
      if (pattern0 (x1, 
E_V2SImode) != 0)
        return -1;
      return 48;

    case E_V4SImode:
      if (pattern0 (x1, 
E_V4SImode) != 0)
        return -1;
      return 49;

    case E_V8SImode:
      if (pattern0 (x1, 
E_V8SImode) != 0)
        return -1;
      return 50;

    case E_V16SImode:
      if (pattern0 (x1, 
E_V16SImode) != 0)
        return -1;
      return 51;

    case E_V32SImode:
      if (pattern0 (x1, 
E_V32SImode) != 0)
        return -1;
      return 52;

    case E_V64SImode:
      if (pattern0 (x1, 
E_V64SImode) != 0)
        return -1;
      return 53;

    case E_V128SImode:
      if (pattern0 (x1, 
E_V128SImode) != 0)
        return -1;
      return 54;

    case E_V256SImode:
      if (pattern0 (x1, 
E_V256SImode) != 0)
        return -1;
      return 55;

    case E_V512SImode:
      if (pattern0 (x1, 
E_V512SImode) != 0)
        return -1;
      return 56;

    case E_V1024SImode:
      if (pattern0 (x1, 
E_V1024SImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern0 (x1, 
E_V1DImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern0 (x1, 
E_V2DImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern0 (x1, 
E_V4DImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern0 (x1, 
E_V8DImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern0 (x1, 
E_V16DImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern0 (x1, 
E_V32DImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern0 (x1, 
E_V64DImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern0 (x1, 
E_V128DImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern0 (x1, 
E_V256DImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern0 (x1, 
E_V512DImode) != 0)
        return -1;
      return 67;

    case E_RVVM8HFmode:
      if (pattern0 (x1, 
E_RVVM8HFmode) != 0)
        return -1;
      return 68;

    case E_RVVM4HFmode:
      if (pattern0 (x1, 
E_RVVM4HFmode) != 0)
        return -1;
      return 69;

    case E_RVVM2HFmode:
      if (pattern0 (x1, 
E_RVVM2HFmode) != 0)
        return -1;
      return 70;

    case E_RVVM1HFmode:
      if (pattern0 (x1, 
E_RVVM1HFmode) != 0)
        return -1;
      return 71;

    case E_RVVMF2HFmode:
      if (pattern0 (x1, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 72;

    case E_RVVMF4HFmode:
      if (pattern0 (x1, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 73;

    case E_RVVM8SFmode:
      if (pattern0 (x1, 
E_RVVM8SFmode) != 0)
        return -1;
      return 74;

    case E_RVVM4SFmode:
      if (pattern0 (x1, 
E_RVVM4SFmode) != 0)
        return -1;
      return 75;

    case E_RVVM2SFmode:
      if (pattern0 (x1, 
E_RVVM2SFmode) != 0)
        return -1;
      return 76;

    case E_RVVM1SFmode:
      if (pattern0 (x1, 
E_RVVM1SFmode) != 0)
        return -1;
      return 77;

    case E_RVVMF2SFmode:
      if (pattern0 (x1, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 78;

    case E_RVVM8DFmode:
      if (pattern0 (x1, 
E_RVVM8DFmode) != 0)
        return -1;
      return 79;

    case E_RVVM4DFmode:
      if (pattern0 (x1, 
E_RVVM4DFmode) != 0)
        return -1;
      return 80;

    case E_RVVM2DFmode:
      if (pattern0 (x1, 
E_RVVM2DFmode) != 0)
        return -1;
      return 81;

    case E_RVVM1DFmode:
      if (pattern0 (x1, 
E_RVVM1DFmode) != 0)
        return -1;
      return 82;

    case E_V1HFmode:
      if (pattern0 (x1, 
E_V1HFmode) != 0)
        return -1;
      return 83;

    case E_V2HFmode:
      if (pattern0 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 84;

    case E_V4HFmode:
      if (pattern0 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 85;

    case E_V8HFmode:
      if (pattern0 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 86;

    case E_V16HFmode:
      if (pattern0 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 87;

    case E_V32HFmode:
      if (pattern0 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 88;

    case E_V64HFmode:
      if (pattern0 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 89;

    case E_V128HFmode:
      if (pattern0 (x1, 
E_V128HFmode) != 0)
        return -1;
      return 90;

    case E_V256HFmode:
      if (pattern0 (x1, 
E_V256HFmode) != 0)
        return -1;
      return 91;

    case E_V512HFmode:
      if (pattern0 (x1, 
E_V512HFmode) != 0)
        return -1;
      return 92;

    case E_V1024HFmode:
      if (pattern0 (x1, 
E_V1024HFmode) != 0)
        return -1;
      return 93;

    case E_V2048HFmode:
      if (pattern0 (x1, 
E_V2048HFmode) != 0)
        return -1;
      return 94;

    case E_V1SFmode:
      if (pattern0 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 95;

    case E_V2SFmode:
      if (pattern0 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 96;

    case E_V4SFmode:
      if (pattern0 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 97;

    case E_V8SFmode:
      if (pattern0 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 98;

    case E_V16SFmode:
      if (pattern0 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 99;

    case E_V32SFmode:
      if (pattern0 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 100;

    case E_V64SFmode:
      if (pattern0 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 101;

    case E_V128SFmode:
      if (pattern0 (x1, 
E_V128SFmode) != 0)
        return -1;
      return 102;

    case E_V256SFmode:
      if (pattern0 (x1, 
E_V256SFmode) != 0)
        return -1;
      return 103;

    case E_V512SFmode:
      if (pattern0 (x1, 
E_V512SFmode) != 0)
        return -1;
      return 104;

    case E_V1024SFmode:
      if (pattern0 (x1, 
E_V1024SFmode) != 0)
        return -1;
      return 105;

    case E_V1DFmode:
      if (pattern0 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 106;

    case E_V2DFmode:
      if (pattern0 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 107;

    case E_V4DFmode:
      if (pattern0 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 108;

    case E_V8DFmode:
      if (pattern0 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 109;

    case E_V16DFmode:
      if (pattern0 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 110;

    case E_V32DFmode:
      if (pattern0 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 111;

    case E_V64DFmode:
      if (pattern0 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 112;

    case E_V128DFmode:
      if (pattern0 (x1, 
E_V128DFmode) != 0)
        return -1;
      return 113;

    case E_V256DFmode:
      if (pattern0 (x1, 
E_V256DFmode) != 0)
        return -1;
      return 114;

    case E_V512DFmode:
      if (pattern0 (x1, 
E_V512DFmode) != 0)
        return -1;
      return 115;

    default:
      return -1;
    }
}

int
pattern154 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern156 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode)
          || GET_MODE (x1) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM8HImode))
        return -1;
      return 0;

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode)
          || GET_MODE (x1) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode)
          || GET_MODE (x1) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 2;

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode)
          || GET_MODE (x1) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVM1HImode))
        return -1;
      return 3;

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode)
          || GET_MODE (x1) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF2HImode))
        return -1;
      return 4;

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode)
          || GET_MODE (x1) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 5;

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode)
          || GET_MODE (x1) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM8SImode))
        return -1;
      return 6;

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode)
          || GET_MODE (x1) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 7;

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode)
          || GET_MODE (x1) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 8;

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode)
          || GET_MODE (x1) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 9;

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode)
          || GET_MODE (x1) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 10;

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 11;

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM4DImode))
        return -1;
      return 12;

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 13;

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVM1DImode))
        return -1;
      return 14;

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x1) != E_V1QImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      return 15;

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x1) != E_V2QImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 16;

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x1) != E_V4QImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 17;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 18;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16HImode))
        return -1;
      return 19;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !register_operand (operands[1], E_V32HImode))
        return -1;
      return 20;

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || GET_MODE (x1) != E_V64QImode
          || !register_operand (operands[1], E_V64HImode))
        return -1;
      return 21;

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode)
          || GET_MODE (x1) != E_V128QImode
          || !register_operand (operands[1], E_V128HImode))
        return -1;
      return 22;

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode)
          || GET_MODE (x1) != E_V256QImode
          || !register_operand (operands[1], E_V256HImode))
        return -1;
      return 23;

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode)
          || GET_MODE (x1) != E_V512QImode
          || !register_operand (operands[1], E_V512HImode))
        return -1;
      return 24;

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode)
          || GET_MODE (x1) != E_V1024QImode
          || !register_operand (operands[1], E_V1024HImode))
        return -1;
      return 25;

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode)
          || GET_MODE (x1) != E_V2048QImode
          || !register_operand (operands[1], E_V2048HImode))
        return -1;
      return 26;

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      return 27;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 28;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 29;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      return 30;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !register_operand (operands[1], E_V16SImode))
        return -1;
      return 31;

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode
          || !register_operand (operands[1], E_V32SImode))
        return -1;
      return 32;

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode)
          || GET_MODE (x1) != E_V64HImode
          || !register_operand (operands[1], E_V64SImode))
        return -1;
      return 33;

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode)
          || GET_MODE (x1) != E_V128HImode
          || !register_operand (operands[1], E_V128SImode))
        return -1;
      return 34;

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode)
          || GET_MODE (x1) != E_V256HImode
          || !register_operand (operands[1], E_V256SImode))
        return -1;
      return 35;

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode)
          || GET_MODE (x1) != E_V512HImode
          || !register_operand (operands[1], E_V512SImode))
        return -1;
      return 36;

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode)
          || GET_MODE (x1) != E_V1024HImode
          || !register_operand (operands[1], E_V1024SImode))
        return -1;
      return 37;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      return 38;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 39;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 40;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8DImode))
        return -1;
      return 41;

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || !register_operand (operands[1], E_V16DImode))
        return -1;
      return 42;

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || !register_operand (operands[1], E_V32DImode))
        return -1;
      return 43;

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || !register_operand (operands[1], E_V64DImode))
        return -1;
      return 44;

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode
          || !register_operand (operands[1], E_V128DImode))
        return -1;
      return 45;

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode
          || !register_operand (operands[1], E_V256DImode))
        return -1;
      return 46;

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode
          || !register_operand (operands[1], E_V512DImode))
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern193 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 7
      || XINT (x3, 1) != 93)
    return -1;
  x4 = XVECEXP (x3, 0, 5);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x3, 0, 6);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XVECEXP (x3, 0, 0);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 1);
  operands[5] = x8;
  if (!vector_length_operand (operands[5], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x3, 0, 2);
  operands[6] = x9;
  if (!const_int_operand (operands[6], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 3);
  operands[7] = x10;
  if (!const_int_operand (operands[7], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x3, 0, 4);
  operands[8] = x11;
  if (!const_int_operand (operands[8], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x2, 0, 1);
  operands[2] = x12;
  x13 = XVECEXP (x2, 0, 2);
  operands[3] = x13;
  x14 = XVECEXP (x2, 0, 3);
  operands[4] = x14;
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern192 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern192 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern192 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern192 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern192 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern192 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern192 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern192 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern192 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern192 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern192 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern192 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern192 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern192 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern192 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern192 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF2QImode:
      if (pattern192 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4QImode:
      if (pattern192 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF8QImode:
      if (pattern192 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVMF2HImode:
      if (pattern192 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 19;

    case E_RVVMF4HImode:
      if (pattern192 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2SImode:
      if (pattern192 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_RVVM8BFmode:
      if (pattern192 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 22;

    case E_RVVM4BFmode:
      if (pattern192 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 23;

    case E_RVVM2BFmode:
      if (pattern192 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 24;

    case E_RVVM1BFmode:
      if (pattern192 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 25;

    case E_RVVMF2BFmode:
      if (pattern192 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 26;

    case E_RVVMF4BFmode:
      if (pattern192 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 27;

    case E_RVVM8HFmode:
      if (pattern192 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 28;

    case E_RVVM4HFmode:
      if (pattern192 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 29;

    case E_RVVM2HFmode:
      if (pattern192 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 30;

    case E_RVVM1HFmode:
      if (pattern192 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 31;

    case E_RVVMF2HFmode:
      if (pattern192 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 32;

    case E_RVVMF4HFmode:
      if (pattern192 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 33;

    case E_RVVM8SFmode:
      if (pattern192 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 34;

    case E_RVVM4SFmode:
      if (pattern192 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 35;

    case E_RVVM2SFmode:
      if (pattern192 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 36;

    case E_RVVM1SFmode:
      if (pattern192 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 37;

    case E_RVVMF2SFmode:
      if (pattern192 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 38;

    case E_RVVM8DFmode:
      if (pattern192 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 39;

    case E_RVVM4DFmode:
      if (pattern192 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 40;

    case E_RVVM2DFmode:
      if (pattern192 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 41;

    case E_RVVM1DFmode:
      if (pattern192 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 42;

    case E_V1QImode:
      if (pattern192 (x2, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 43;

    case E_V2QImode:
      if (pattern192 (x2, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 44;

    case E_V4QImode:
      if (pattern192 (x2, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 45;

    case E_V8QImode:
      if (pattern192 (x2, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 46;

    case E_V16QImode:
      if (pattern192 (x2, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 47;

    case E_V32QImode:
      if (pattern192 (x2, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 48;

    case E_V64QImode:
      if (pattern192 (x2, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 49;

    case E_V128QImode:
      if (pattern192 (x2, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 50;

    case E_V256QImode:
      if (pattern192 (x2, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 51;

    case E_V512QImode:
      if (pattern192 (x2, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 52;

    case E_V1024QImode:
      if (pattern192 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 53;

    case E_V2048QImode:
      if (pattern192 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 54;

    case E_V4096QImode:
      if (pattern192 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 55;

    case E_V1HImode:
      if (pattern192 (x2, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 56;

    case E_V2HImode:
      if (pattern192 (x2, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 57;

    case E_V4HImode:
      if (pattern192 (x2, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 58;

    case E_V8HImode:
      if (pattern192 (x2, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 59;

    case E_V16HImode:
      if (pattern192 (x2, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 60;

    case E_V32HImode:
      if (pattern192 (x2, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 61;

    case E_V64HImode:
      if (pattern192 (x2, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 62;

    case E_V128HImode:
      if (pattern192 (x2, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 63;

    case E_V256HImode:
      if (pattern192 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 64;

    case E_V512HImode:
      if (pattern192 (x2, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 65;

    case E_V1024HImode:
      if (pattern192 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 66;

    case E_V2048HImode:
      if (pattern192 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 67;

    case E_V1SImode:
      if (pattern192 (x2, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 68;

    case E_V2SImode:
      if (pattern192 (x2, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 69;

    case E_V4SImode:
      if (pattern192 (x2, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 70;

    case E_V8SImode:
      if (pattern192 (x2, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 71;

    case E_V16SImode:
      if (pattern192 (x2, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 72;

    case E_V32SImode:
      if (pattern192 (x2, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 73;

    case E_V64SImode:
      if (pattern192 (x2, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 74;

    case E_V128SImode:
      if (pattern192 (x2, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 75;

    case E_V256SImode:
      if (pattern192 (x2, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 76;

    case E_V512SImode:
      if (pattern192 (x2, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 77;

    case E_V1024SImode:
      if (pattern192 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 78;

    case E_V1DImode:
      if (pattern192 (x2, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 79;

    case E_V2DImode:
      if (pattern192 (x2, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 80;

    case E_V4DImode:
      if (pattern192 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 81;

    case E_V8DImode:
      if (pattern192 (x2, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 82;

    case E_V16DImode:
      if (pattern192 (x2, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 83;

    case E_V32DImode:
      if (pattern192 (x2, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 84;

    case E_V64DImode:
      if (pattern192 (x2, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 85;

    case E_V128DImode:
      if (pattern192 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 86;

    case E_V256DImode:
      if (pattern192 (x2, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 87;

    case E_V512DImode:
      if (pattern192 (x2, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 88;

    case E_V1HFmode:
      if (pattern192 (x2, 
E_V1HFmode, 
E_V1BImode) != 0)
        return -1;
      return 89;

    case E_V2HFmode:
      if (pattern192 (x2, 
E_V2HFmode, 
E_V2BImode) != 0)
        return -1;
      return 90;

    case E_V4HFmode:
      if (pattern192 (x2, 
E_V4HFmode, 
E_V4BImode) != 0)
        return -1;
      return 91;

    case E_V8HFmode:
      if (pattern192 (x2, 
E_V8HFmode, 
E_V8BImode) != 0)
        return -1;
      return 92;

    case E_V16HFmode:
      if (pattern192 (x2, 
E_V16HFmode, 
E_V16BImode) != 0)
        return -1;
      return 93;

    case E_V32HFmode:
      if (pattern192 (x2, 
E_V32HFmode, 
E_V32BImode) != 0)
        return -1;
      return 94;

    case E_V64HFmode:
      if (pattern192 (x2, 
E_V64HFmode, 
E_V64BImode) != 0)
        return -1;
      return 95;

    case E_V128HFmode:
      if (pattern192 (x2, 
E_V128HFmode, 
E_V128BImode) != 0)
        return -1;
      return 96;

    case E_V256HFmode:
      if (pattern192 (x2, 
E_V256HFmode, 
E_V256BImode) != 0)
        return -1;
      return 97;

    case E_V512HFmode:
      if (pattern192 (x2, 
E_V512HFmode, 
E_V512BImode) != 0)
        return -1;
      return 98;

    case E_V1024HFmode:
      if (pattern192 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0)
        return -1;
      return 99;

    case E_V2048HFmode:
      if (pattern192 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0)
        return -1;
      return 100;

    case E_V1SFmode:
      if (pattern192 (x2, 
E_V1SFmode, 
E_V1BImode) != 0)
        return -1;
      return 101;

    case E_V2SFmode:
      if (pattern192 (x2, 
E_V2SFmode, 
E_V2BImode) != 0)
        return -1;
      return 102;

    case E_V4SFmode:
      if (pattern192 (x2, 
E_V4SFmode, 
E_V4BImode) != 0)
        return -1;
      return 103;

    case E_V8SFmode:
      if (pattern192 (x2, 
E_V8SFmode, 
E_V8BImode) != 0)
        return -1;
      return 104;

    case E_V16SFmode:
      if (pattern192 (x2, 
E_V16SFmode, 
E_V16BImode) != 0)
        return -1;
      return 105;

    case E_V32SFmode:
      if (pattern192 (x2, 
E_V32SFmode, 
E_V32BImode) != 0)
        return -1;
      return 106;

    case E_V64SFmode:
      if (pattern192 (x2, 
E_V64SFmode, 
E_V64BImode) != 0)
        return -1;
      return 107;

    case E_V128SFmode:
      if (pattern192 (x2, 
E_V128SFmode, 
E_V128BImode) != 0)
        return -1;
      return 108;

    case E_V256SFmode:
      if (pattern192 (x2, 
E_V256SFmode, 
E_V256BImode) != 0)
        return -1;
      return 109;

    case E_V512SFmode:
      if (pattern192 (x2, 
E_V512SFmode, 
E_V512BImode) != 0)
        return -1;
      return 110;

    case E_V1024SFmode:
      if (pattern192 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0)
        return -1;
      return 111;

    case E_V1DFmode:
      if (pattern192 (x2, 
E_V1DFmode, 
E_V1BImode) != 0)
        return -1;
      return 112;

    case E_V2DFmode:
      if (pattern192 (x2, 
E_V2DFmode, 
E_V2BImode) != 0)
        return -1;
      return 113;

    case E_V4DFmode:
      if (pattern192 (x2, 
E_V4DFmode, 
E_V4BImode) != 0)
        return -1;
      return 114;

    case E_V8DFmode:
      if (pattern192 (x2, 
E_V8DFmode, 
E_V8BImode) != 0)
        return -1;
      return 115;

    case E_V16DFmode:
      if (pattern192 (x2, 
E_V16DFmode, 
E_V16BImode) != 0)
        return -1;
      return 116;

    case E_V32DFmode:
      if (pattern192 (x2, 
E_V32DFmode, 
E_V32BImode) != 0)
        return -1;
      return 117;

    case E_V64DFmode:
      if (pattern192 (x2, 
E_V64DFmode, 
E_V64BImode) != 0)
        return -1;
      return 118;

    case E_V128DFmode:
      if (pattern192 (x2, 
E_V128DFmode, 
E_V128BImode) != 0)
        return -1;
      return 119;

    case E_V256DFmode:
      if (pattern192 (x2, 
E_V256DFmode, 
E_V256BImode) != 0)
        return -1;
      return 120;

    case E_V512DFmode:
      if (pattern192 (x2, 
E_V512DFmode, 
E_V512BImode) != 0)
        return -1;
      return 121;

    default:
      return -1;
    }
}

int
pattern241 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern168 (x1, 
E_RVVM8HFmode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern168 (x1, 
E_RVVM4HFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern168 (x1, 
E_RVVM2HFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern168 (x1, 
E_RVVM1HFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern168 (x1, 
E_RVVMF2HFmode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern168 (x1, 
E_RVVMF4HFmode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern168 (x1, 
E_RVVM8SFmode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern168 (x1, 
E_RVVM4SFmode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern168 (x1, 
E_RVVM2SFmode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern168 (x1, 
E_RVVM1SFmode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern168 (x1, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern168 (x1, 
E_RVVM8DFmode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern168 (x1, 
E_RVVM4DFmode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern168 (x1, 
E_RVVM2DFmode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern168 (x1, 
E_RVVM1DFmode) != 0)
        return -1;
      return 14;

    case E_V1HFmode:
      if (pattern168 (x1, 
E_V1HFmode) != 0)
        return -1;
      return 15;

    case E_V2HFmode:
      if (pattern168 (x1, 
E_V2HFmode) != 0)
        return -1;
      return 16;

    case E_V4HFmode:
      if (pattern168 (x1, 
E_V4HFmode) != 0)
        return -1;
      return 17;

    case E_V8HFmode:
      if (pattern168 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 18;

    case E_V16HFmode:
      if (pattern168 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 19;

    case E_V32HFmode:
      if (pattern168 (x1, 
E_V32HFmode) != 0)
        return -1;
      return 20;

    case E_V64HFmode:
      if (pattern168 (x1, 
E_V64HFmode) != 0)
        return -1;
      return 21;

    case E_V128HFmode:
      if (pattern168 (x1, 
E_V128HFmode) != 0)
        return -1;
      return 22;

    case E_V256HFmode:
      if (pattern168 (x1, 
E_V256HFmode) != 0)
        return -1;
      return 23;

    case E_V512HFmode:
      if (pattern168 (x1, 
E_V512HFmode) != 0)
        return -1;
      return 24;

    case E_V1024HFmode:
      if (pattern168 (x1, 
E_V1024HFmode) != 0)
        return -1;
      return 25;

    case E_V2048HFmode:
      if (pattern168 (x1, 
E_V2048HFmode) != 0)
        return -1;
      return 26;

    case E_V1SFmode:
      if (pattern168 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 27;

    case E_V2SFmode:
      if (pattern168 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 28;

    case E_V4SFmode:
      if (pattern168 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 29;

    case E_V8SFmode:
      if (pattern168 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 30;

    case E_V16SFmode:
      if (pattern168 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 31;

    case E_V32SFmode:
      if (pattern168 (x1, 
E_V32SFmode) != 0)
        return -1;
      return 32;

    case E_V64SFmode:
      if (pattern168 (x1, 
E_V64SFmode) != 0)
        return -1;
      return 33;

    case E_V128SFmode:
      if (pattern168 (x1, 
E_V128SFmode) != 0)
        return -1;
      return 34;

    case E_V256SFmode:
      if (pattern168 (x1, 
E_V256SFmode) != 0)
        return -1;
      return 35;

    case E_V512SFmode:
      if (pattern168 (x1, 
E_V512SFmode) != 0)
        return -1;
      return 36;

    case E_V1024SFmode:
      if (pattern168 (x1, 
E_V1024SFmode) != 0)
        return -1;
      return 37;

    case E_V1DFmode:
      if (pattern168 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 38;

    case E_V2DFmode:
      if (pattern168 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 39;

    case E_V4DFmode:
      if (pattern168 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 40;

    case E_V8DFmode:
      if (pattern168 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 41;

    case E_V16DFmode:
      if (pattern168 (x1, 
E_V16DFmode) != 0)
        return -1;
      return 42;

    case E_V32DFmode:
      if (pattern168 (x1, 
E_V32DFmode) != 0)
        return -1;
      return 43;

    case E_V64DFmode:
      if (pattern168 (x1, 
E_V64DFmode) != 0)
        return -1;
      return 44;

    case E_V128DFmode:
      if (pattern168 (x1, 
E_V128DFmode) != 0)
        return -1;
      return 45;

    case E_V256DFmode:
      if (pattern168 (x1, 
E_V256DFmode) != 0)
        return -1;
      return 46;

    case E_V512DFmode:
      if (pattern168 (x1, 
E_V512DFmode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern246 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i3))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !vector_all_trues_mask_operand (operands[3], i2)
      || !vector_const_0_operand (operands[5], i1)
      || !vector_merge_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern248 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[3], i3))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !vector_all_trues_mask_operand (operands[4], i1)
      || !vector_const_0_operand (operands[9], i2)
      || !vector_merge_operand (operands[10], i2)
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x1, 2);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern249 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8HImode:
          return pattern248 (x2, 
E_RVVMF2BImode, 
E_RVVM8HImode, 
E_RVVM4QImode); /* [-1, 0] */

        case E_RVVM4HImode:
          if (pattern248 (x2, 
E_RVVMF4BImode, 
E_RVVM4HImode, 
E_RVVM2QImode) != 0)
            return -1;
          return 1;

        case E_RVVM2HImode:
          if (pattern248 (x2, 
E_RVVMF8BImode, 
E_RVVM2HImode, 
E_RVVM1QImode) != 0)
            return -1;
          return 2;

        case E_RVVM1HImode:
          if (pattern248 (x2, 
E_RVVMF16BImode, 
E_RVVM1HImode, 
E_RVVMF2QImode) != 0)
            return -1;
          return 3;

        case E_RVVMF2HImode:
          if (pattern248 (x2, 
E_RVVMF32BImode, 
E_RVVMF2HImode, 
E_RVVMF4QImode) != 0)
            return -1;
          return 4;

        case E_RVVMF4HImode:
          if (pattern248 (x2, 
E_RVVMF64BImode, 
E_RVVMF4HImode, 
E_RVVMF8QImode) != 0)
            return -1;
          return 5;

        case E_V1HImode:
          if (pattern248 (x2, 
E_V1BImode, 
E_V1HImode, 
E_V1QImode) != 0)
            return -1;
          return 6;

        case E_V2HImode:
          if (pattern248 (x2, 
E_V2BImode, 
E_V2HImode, 
E_V2QImode) != 0)
            return -1;
          return 7;

        case E_V4HImode:
          if (pattern248 (x2, 
E_V4BImode, 
E_V4HImode, 
E_V4QImode) != 0)
            return -1;
          return 8;

        case E_V8HImode:
          if (pattern248 (x2, 
E_V8BImode, 
E_V8HImode, 
E_V8QImode) != 0)
            return -1;
          return 9;

        case E_V16HImode:
          if (pattern248 (x2, 
E_V16BImode, 
E_V16HImode, 
E_V16QImode) != 0)
            return -1;
          return 10;

        case E_V32HImode:
          if (pattern248 (x2, 
E_V32BImode, 
E_V32HImode, 
E_V32QImode) != 0)
            return -1;
          return 11;

        case E_V64HImode:
          if (pattern248 (x2, 
E_V64BImode, 
E_V64HImode, 
E_V64QImode) != 0)
            return -1;
          return 12;

        case E_V128HImode:
          if (pattern248 (x2, 
E_V128BImode, 
E_V128HImode, 
E_V128QImode) != 0)
            return -1;
          return 13;

        case E_V256HImode:
          if (pattern248 (x2, 
E_V256BImode, 
E_V256HImode, 
E_V256QImode) != 0)
            return -1;
          return 14;

        case E_V512HImode:
          if (pattern248 (x2, 
E_V512BImode, 
E_V512HImode, 
E_V512QImode) != 0)
            return -1;
          return 15;

        case E_V1024HImode:
          if (pattern248 (x2, 
E_V1024BImode, 
E_V1024HImode, 
E_V1024QImode) != 0)
            return -1;
          return 16;

        case E_V2048HImode:
          if (pattern248 (x2, 
E_V2048BImode, 
E_V2048HImode, 
E_V2048QImode) != 0)
            return -1;
          return 17;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8SImode:
          if (pattern248 (x2, 
E_RVVMF4BImode, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0)
            return -1;
          return 18;

        case E_RVVM4SImode:
          if (pattern248 (x2, 
E_RVVMF8BImode, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0)
            return -1;
          return 19;

        case E_RVVM2SImode:
          if (pattern248 (x2, 
E_RVVMF16BImode, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0)
            return -1;
          return 20;

        case E_RVVM1SImode:
          if (pattern248 (x2, 
E_RVVMF32BImode, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0)
            return -1;
          return 21;

        case E_RVVMF2SImode:
          if (pattern248 (x2, 
E_RVVMF64BImode, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0)
            return -1;
          return 22;

        case E_V1SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V1BImode
              || GET_MODE (x3) != E_V1SImode
              || GET_MODE (x4) != E_V1SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V1SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V1BImode
              || !vector_all_trues_mask_operand (operands[4], E_V1BImode)
              || !vector_const_0_operand (operands[9], E_V1SImode)
              || !vector_merge_operand (operands[10], E_V1SImode)
              || !register_operand (operands[1], E_V1BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V1SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V1BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V1HImode:
              if (!register_operand (operands[3], E_V1HImode))
                return -1;
              return 23;

            case E_V1SImode:
              if (!register_operand (operands[3], E_V1SImode))
                return -1;
              return 24;

            default:
              return -1;
            }

        case E_V2SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V2BImode
              || GET_MODE (x3) != E_V2SImode
              || GET_MODE (x4) != E_V2SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V2SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V2BImode
              || !vector_all_trues_mask_operand (operands[4], E_V2BImode)
              || !vector_const_0_operand (operands[9], E_V2SImode)
              || !vector_merge_operand (operands[10], E_V2SImode)
              || !register_operand (operands[1], E_V2BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V2SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V2BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V2HImode:
              if (!register_operand (operands[3], E_V2HImode))
                return -1;
              return 25;

            case E_V2SImode:
              if (!register_operand (operands[3], E_V2SImode))
                return -1;
              return 26;

            default:
              return -1;
            }

        case E_V4SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V4BImode
              || GET_MODE (x3) != E_V4SImode
              || GET_MODE (x4) != E_V4SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V4SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V4BImode
              || !vector_all_trues_mask_operand (operands[4], E_V4BImode)
              || !vector_const_0_operand (operands[9], E_V4SImode)
              || !vector_merge_operand (operands[10], E_V4SImode)
              || !register_operand (operands[1], E_V4BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V4SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V4BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V4HImode:
              if (!register_operand (operands[3], E_V4HImode))
                return -1;
              return 27;

            case E_V4SImode:
              if (!register_operand (operands[3], E_V4SImode))
                return -1;
              return 28;

            default:
              return -1;
            }

        case E_V8SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V8BImode
              || GET_MODE (x3) != E_V8SImode
              || GET_MODE (x4) != E_V8SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V8SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V8BImode
              || !vector_all_trues_mask_operand (operands[4], E_V8BImode)
              || !vector_const_0_operand (operands[9], E_V8SImode)
              || !vector_merge_operand (operands[10], E_V8SImode)
              || !register_operand (operands[1], E_V8BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V8SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V8BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V8HImode:
              if (!register_operand (operands[3], E_V8HImode))
                return -1;
              return 29;

            case E_V8SImode:
              if (!register_operand (operands[3], E_V8SImode))
                return -1;
              return 30;

            default:
              return -1;
            }

        case E_V16SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V16BImode
              || GET_MODE (x3) != E_V16SImode
              || GET_MODE (x4) != E_V16SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V16SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V16BImode
              || !vector_all_trues_mask_operand (operands[4], E_V16BImode)
              || !vector_const_0_operand (operands[9], E_V16SImode)
              || !vector_merge_operand (operands[10], E_V16SImode)
              || !register_operand (operands[1], E_V16BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V16SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V16BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V16HImode:
              if (!register_operand (operands[3], E_V16HImode))
                return -1;
              return 31;

            case E_V16SImode:
              if (!register_operand (operands[3], E_V16SImode))
                return -1;
              return 32;

            default:
              return -1;
            }

        case E_V32SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V32BImode
              || GET_MODE (x3) != E_V32SImode
              || GET_MODE (x4) != E_V32SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V32SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V32BImode
              || !vector_all_trues_mask_operand (operands[4], E_V32BImode)
              || !vector_const_0_operand (operands[9], E_V32SImode)
              || !vector_merge_operand (operands[10], E_V32SImode)
              || !register_operand (operands[1], E_V32BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V32SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V32BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V32HImode:
              if (!register_operand (operands[3], E_V32HImode))
                return -1;
              return 33;

            case E_V32SImode:
              if (!register_operand (operands[3], E_V32SImode))
                return -1;
              return 34;

            default:
              return -1;
            }

        case E_V64SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V64BImode
              || GET_MODE (x3) != E_V64SImode
              || GET_MODE (x4) != E_V64SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V64SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V64BImode
              || !vector_all_trues_mask_operand (operands[4], E_V64BImode)
              || !vector_const_0_operand (operands[9], E_V64SImode)
              || !vector_merge_operand (operands[10], E_V64SImode)
              || !register_operand (operands[1], E_V64BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V64SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V64BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V64HImode:
              if (!register_operand (operands[3], E_V64HImode))
                return -1;
              return 35;

            case E_V64SImode:
              if (!register_operand (operands[3], E_V64SImode))
                return -1;
              return 36;

            default:
              return -1;
            }

        case E_V128SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V128BImode
              || GET_MODE (x3) != E_V128SImode
              || GET_MODE (x4) != E_V128SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V128SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V128BImode
              || !vector_all_trues_mask_operand (operands[4], E_V128BImode)
              || !vector_const_0_operand (operands[9], E_V128SImode)
              || !vector_merge_operand (operands[10], E_V128SImode)
              || !register_operand (operands[1], E_V128BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V128SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V128BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V128HImode:
              if (!register_operand (operands[3], E_V128HImode))
                return -1;
              return 37;

            case E_V128SImode:
              if (!register_operand (operands[3], E_V128SImode))
                return -1;
              return 38;

            default:
              return -1;
            }

        case E_V256SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V256BImode
              || GET_MODE (x3) != E_V256SImode
              || GET_MODE (x4) != E_V256SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V256SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V256BImode
              || !vector_all_trues_mask_operand (operands[4], E_V256BImode)
              || !vector_const_0_operand (operands[9], E_V256SImode)
              || !vector_merge_operand (operands[10], E_V256SImode)
              || !register_operand (operands[1], E_V256BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V256SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V256BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V256HImode:
              if (!register_operand (operands[3], E_V256HImode))
                return -1;
              return 39;

            case E_V256SImode:
              if (!register_operand (operands[3], E_V256SImode))
                return -1;
              return 40;

            default:
              return -1;
            }

        case E_V512SImode:
          x6 = XEXP (x2, 0);
          if (GET_MODE (x6) != E_V512BImode
              || GET_MODE (x3) != E_V512SImode
              || GET_MODE (x4) != E_V512SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_V512SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_V512BImode
              || !vector_all_trues_mask_operand (operands[4], E_V512BImode)
              || !vector_const_0_operand (operands[9], E_V512SImode)
              || !vector_merge_operand (operands[10], E_V512SImode)
              || !register_operand (operands[1], E_V512BImode))
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_MODE (x9) != E_V512SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V512BImode)
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V512HImode:
              if (!register_operand (operands[3], E_V512HImode))
                return -1;
              return 41;

            case E_V512SImode:
              if (!register_operand (operands[3], E_V512SImode))
                return -1;
              return 42;

            default:
              return -1;
            }

        case E_V1024SImode:
          if (pattern248 (x2, 
E_V1024BImode, 
E_V1024SImode, 
E_V1024HImode) != 0)
            return -1;
          return 43;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8DImode:
          if (pattern248 (x2, 
E_RVVMF8BImode, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0)
            return -1;
          return 44;

        case E_RVVM4DImode:
          if (pattern248 (x2, 
E_RVVMF16BImode, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0)
            return -1;
          return 45;

        case E_RVVM2DImode:
          if (pattern248 (x2, 
E_RVVMF32BImode, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0)
            return -1;
          return 46;

        case E_RVVM1DImode:
          if (pattern248 (x2, 
E_RVVMF64BImode, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern299 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1SImode)
      || GET_MODE (x1) != E_RVVM1SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVMF2HImode:
      if (!register_operand (operands[1], E_RVVMF2HImode))
        return -1;
      return 0;

    case E_RVVMF4QImode:
      if (!register_operand (operands[1], E_RVVMF4QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern304 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1DImode)
      || GET_MODE (x1) != E_RVVM1DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVMF2SImode:
      if (!register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 0;

    case E_RVVMF4HImode:
      if (!register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 1;

    case E_RVVMF8QImode:
      if (!register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern309 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16SImode)
      || GET_MODE (x1) != E_V16SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern314 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512SImode)
      || GET_MODE (x1) != E_V512SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512HImode:
      if (!register_operand (operands[1], E_V512HImode))
        return -1;
      return 0;

    case E_V512QImode:
      if (!register_operand (operands[1], E_V512QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern319 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8DImode)
      || GET_MODE (x1) != E_V8DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern325 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512DImode)
      || GET_MODE (x1) != E_V512DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512SImode:
      if (!register_operand (operands[1], E_V512SImode))
        return -1;
      return 0;

    case E_V512HImode:
      if (!register_operand (operands[1], E_V512HImode))
        return -1;
      return 1;

    case E_V512QImode:
      if (!register_operand (operands[1], E_V512QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern332 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!register_operand (operands[3], i2))
    return -1;
  x7 = XEXP (x1, 1);
  operands[1] = x7;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern339 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !fp_native_comparison (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SFmode:
      if (!register_operand (operands[2], E_SFmode)
          || !register_operand (operands[3], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[2], E_DFmode)
          || !register_operand (operands[3], E_DFmode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[2], E_HFmode)
          || !register_operand (operands[3], E_HFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern342 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ASHIFT
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != SUBREG
      || maybe_ne (SUBREG_BYTE (x7), 0)
      || GET_MODE (x7) != E_QImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != AND
      || GET_MODE (x8) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode)
    return -1;
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x10 = XEXP (x3, 1);
  operands[3] = x10;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  x12 = XEXP (x11, 0);
  operands[4] = x12;
  x13 = XEXP (x8, 0);
  return pattern341 (x13); /* [-1, 3] */
}

int
pattern348 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern351 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern350 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern350 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern355 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern354 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern354 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern360 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern363 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  operands[4] = x2;
  if (!autovec_length_operand (operands[4], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  operands[5] = x3;
  if (!const_0_operand (operands[5], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF64BImode:
      return pattern362 (x1, 
E_RVVMF64BImode); /* [-1, 0] */

    case E_RVVMF32BImode:
      if (pattern362 (x1, 
E_RVVMF32BImode) != 0)
        return -1;
      return 1;

    case E_RVVMF16BImode:
      if (pattern362 (x1, 
E_RVVMF16BImode) != 0)
        return -1;
      return 2;

    case E_RVVMF8BImode:
      if (pattern362 (x1, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF4BImode:
      if (pattern362 (x1, 
E_RVVMF4BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF2BImode:
      if (pattern362 (x1, 
E_RVVMF2BImode) != 0)
        return -1;
      return 5;

    case E_RVVM1BImode:
      if (pattern362 (x1, 
E_RVVM1BImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern370 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != SUBREG
      || maybe_ne (SUBREG_BYTE (x6), 0)
      || GET_MODE (x6) != E_QImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != AND
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != NOT
      || GET_MODE (x8) != E_DImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x8, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x11 = XEXP (x7, 1);
  operands[2] = x11;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x12 = XEXP (x9, 0);
  operands[3] = x12;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      if (!scratch_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!scratch_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern375 (rtx x1, int i1, int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3
      || XVECLEN (x1, 0) != i2
      || XINT (x1, 1) != i1
      || GET_MODE (x1) != E_SImode)
    return -1;
  return 0;
}

int
pattern377 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_two_s12 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern379 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != ASHIFT
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_CODE (x8) != SUBREG
      || maybe_ne (SUBREG_BYTE (x8), 0)
      || GET_MODE (x8) != E_QImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != AND
      || GET_MODE (x9) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  x10 = XEXP (x9, 1);
  operands[2] = x10;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x11 = XEXP (x3, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x12 = XVECEXP (x1, 0, 1);
  x13 = XEXP (x12, 0);
  operands[4] = x13;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  x14 = XEXP (x9, 0);
  return pattern378 (x14); /* [-1, 1] */
}

int
pattern387 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern394 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != MEM)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  return 0;
}

int
pattern397 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != NOT
      || GET_MODE (x5) != E_DImode)
    return -1;
  return 0;
}

int
pattern401 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  operands[4] = x1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != AND)
    return -1;
  return pattern227 (x2); /* [-1, 1] */
}

int
pattern405 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern408 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern414 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !reg_or_0_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !reg_or_0_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern419 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      operands[1] = x2;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x7 = XEXP (x1, 1);
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      switch (GET_MODE (x4))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 1;

        case E_SImode:
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!register_operand (operands[2], E_DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      return 4;

    default:
      return -1;
    }
}

int
pattern436 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern441 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[4], i1)
      || !vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern447 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8DImode:
      if (!register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 0;

    case E_RVVM4DImode:
      if (!register_operand (operands[1], E_RVVM4DImode))
        return -1;
      return 1;

    case E_RVVM2DImode:
      if (!register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 2;

    case E_RVVM1DImode:
      if (!register_operand (operands[1], E_RVVM1DImode))
        return -1;
      return 3;

    case E_V1DImode:
      if (!register_operand (operands[1], E_V1DImode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 6;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode))
        return -1;
      return 7;

    case E_V16DImode:
      if (!register_operand (operands[1], E_V16DImode))
        return -1;
      return 8;

    case E_V32DImode:
      if (!register_operand (operands[1], E_V32DImode))
        return -1;
      return 9;

    case E_V64DImode:
      if (!register_operand (operands[1], E_V64DImode))
        return -1;
      return 10;

    case E_V128DImode:
      if (!register_operand (operands[1], E_V128DImode))
        return -1;
      return 11;

    case E_V256DImode:
      if (!register_operand (operands[1], E_V256DImode))
        return -1;
      return 12;

    case E_V512DImode:
      if (!register_operand (operands[1], E_V512DImode))
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern453 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern460 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern465 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 2);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
      operands[3] = x4;
      if (!branch_on_bit_operand (operands[3], E_VOIDmode))
        return -1;
      operands[0] = x2;
      return pattern464 (x1); /* [-1, 1] */

    case ZERO_EXTEND:
      operands[1] = x2;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      x6 = XEXP (x1, 1);
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !scratch_operand (operands[4], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || GET_MODE (x4) != E_DImode
              || !scratch_operand (operands[4], E_DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern476 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 2
      || XINT (x2, 1) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XVECEXP (x2, 0, 0);
  operands[3] = x8;
  x9 = XVECEXP (x2, 0, 1);
  operands[4] = x9;
  if (!pmode_reg_or_0_operand (operands[4], E_VOIDmode))
    return -1;
  x10 = XEXP (x1, 2);
  operands[2] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern475 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern475 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern475 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern475 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVM8HImode:
      if (pattern475 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 4;

    case E_RVVM4HImode:
      if (pattern475 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 5;

    case E_RVVM2HImode:
      if (pattern475 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 6;

    case E_RVVM1HImode:
      if (pattern475 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 7;

    case E_RVVM8SImode:
      if (pattern475 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM4SImode:
      if (pattern475 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM2SImode:
      if (pattern475 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVM1SImode:
      if (pattern475 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVM8DImode:
      if (pattern475 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 12;

    case E_RVVM4DImode:
      if (pattern475 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 13;

    case E_RVVM2DImode:
      if (pattern475 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 14;

    case E_RVVM1DImode:
      if (pattern475 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 15;

    case E_RVVMF8QImode:
      if (pattern475 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF4HImode:
      if (pattern475 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 17;

    case E_RVVMF2SImode:
      if (pattern475 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern489 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern488 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern488 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern488 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern488 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2QImode:
      if (pattern488 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4QImode:
      if (pattern488 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0)
        return -1;
      return 5;

    case E_RVVMF8QImode:
      if (pattern488 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0)
        return -1;
      return 6;

    case E_RVVM8HImode:
      if (pattern488 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0)
        return -1;
      return 7;

    case E_RVVM4HImode:
      if (pattern488 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
        return -1;
      return 8;

    case E_RVVM2HImode:
      if (pattern488 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
        return -1;
      return 9;

    case E_RVVM1HImode:
      if (pattern488 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
        return -1;
      return 10;

    case E_RVVMF2HImode:
      if (pattern488 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
        return -1;
      return 11;

    case E_RVVMF4HImode:
      if (pattern488 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
        return -1;
      return 12;

    case E_RVVM8SImode:
      if (pattern488 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0)
        return -1;
      return 13;

    case E_RVVM4SImode:
      if (pattern488 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
        return -1;
      return 14;

    case E_RVVM2SImode:
      if (pattern488 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
        return -1;
      return 15;

    case E_RVVM1SImode:
      if (pattern488 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
        return -1;
      return 16;

    case E_RVVMF2SImode:
      if (pattern488 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
        return -1;
      return 17;

    case E_V1QImode:
      if (pattern488 (x1, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0)
        return -1;
      return 18;

    case E_V2QImode:
      if (pattern488 (x1, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0)
        return -1;
      return 19;

    case E_V4QImode:
      if (pattern488 (x1, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0)
        return -1;
      return 20;

    case E_V8QImode:
      if (pattern488 (x1, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0)
        return -1;
      return 21;

    case E_V16QImode:
      if (pattern488 (x1, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0)
        return -1;
      return 22;

    case E_V32QImode:
      if (pattern488 (x1, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0)
        return -1;
      return 23;

    case E_V64QImode:
      if (pattern488 (x1, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0)
        return -1;
      return 24;

    case E_V128QImode:
      if (pattern488 (x1, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0)
        return -1;
      return 25;

    case E_V256QImode:
      if (pattern488 (x1, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0)
        return -1;
      return 26;

    case E_V512QImode:
      if (pattern488 (x1, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0)
        return -1;
      return 27;

    case E_V1024QImode:
      if (pattern488 (x1, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0)
        return -1;
      return 28;

    case E_V2048QImode:
      if (pattern488 (x1, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0)
        return -1;
      return 29;

    case E_V4096QImode:
      if (pattern488 (x1, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0)
        return -1;
      return 30;

    case E_V1HImode:
      if (pattern488 (x1, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0)
        return -1;
      return 31;

    case E_V2HImode:
      if (pattern488 (x1, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0)
        return -1;
      return 32;

    case E_V4HImode:
      if (pattern488 (x1, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0)
        return -1;
      return 33;

    case E_V8HImode:
      if (pattern488 (x1, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0)
        return -1;
      return 34;

    case E_V16HImode:
      if (pattern488 (x1, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
        return -1;
      return 35;

    case E_V32HImode:
      if (pattern488 (x1, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
        return -1;
      return 36;

    case E_V64HImode:
      if (pattern488 (x1, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
        return -1;
      return 37;

    case E_V128HImode:
      if (pattern488 (x1, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0)
        return -1;
      return 38;

    case E_V256HImode:
      if (pattern488 (x1, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
        return -1;
      return 39;

    case E_V512HImode:
      if (pattern488 (x1, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
        return -1;
      return 40;

    case E_V1024HImode:
      if (pattern488 (x1, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0)
        return -1;
      return 41;

    case E_V2048HImode:
      if (pattern488 (x1, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0)
        return -1;
      return 42;

    case E_V1SImode:
      if (pattern488 (x1, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0)
        return -1;
      return 43;

    case E_V2SImode:
      if (pattern488 (x1, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
        return -1;
      return 44;

    case E_V4SImode:
      if (pattern488 (x1, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
        return -1;
      return 45;

    case E_V8SImode:
      if (pattern488 (x1, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0)
        return -1;
      return 46;

    case E_V16SImode:
      if (pattern488 (x1, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
        return -1;
      return 47;

    case E_V32SImode:
      if (pattern488 (x1, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0)
        return -1;
      return 48;

    case E_V64SImode:
      if (pattern488 (x1, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
        return -1;
      return 49;

    case E_V128SImode:
      if (pattern488 (x1, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
        return -1;
      return 50;

    case E_V256SImode:
      if (pattern488 (x1, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
        return -1;
      return 51;

    case E_V512SImode:
      if (pattern488 (x1, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
        return -1;
      return 52;

    case E_V1024SImode:
      if (pattern488 (x1, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0)
        return -1;
      return 53;

    case E_RVVM8DImode:
      if (pattern488 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0)
        return -1;
      return 54;

    case E_RVVM4DImode:
      if (pattern488 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0)
        return -1;
      return 55;

    case E_RVVM2DImode:
      if (pattern488 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0)
        return -1;
      return 56;

    case E_RVVM1DImode:
      if (pattern488 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern488 (x1, 
E_V1DImode, 
E_V1BImode, 
E_DImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern488 (x1, 
E_V2DImode, 
E_V2BImode, 
E_DImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern488 (x1, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern488 (x1, 
E_V8DImode, 
E_V8BImode, 
E_DImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern488 (x1, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern488 (x1, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern488 (x1, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern488 (x1, 
E_V128DImode, 
E_V128BImode, 
E_DImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern488 (x1, 
E_V256DImode, 
E_V256BImode, 
E_DImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern488 (x1, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0)
        return -1;
      return 67;

    default:
      return -1;
    }
}

int
pattern504 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern505 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[5] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[6] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[7] = x6;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern504 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (pattern504 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (pattern504 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (pattern504 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (pattern504 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (pattern504 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode
          || GET_MODE (x2) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x7) != E_RVVM8SImode
          || !vector_merge_operand (operands[2], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HImode:
          if (!register_operand (operands[3], E_RVVM4HImode))
            return -1;
          return 6;

        case E_RVVM2QImode:
          if (!register_operand (operands[3], E_RVVM2QImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x7) != E_RVVM4SImode
          || !vector_merge_operand (operands[2], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode))
            return -1;
          return 8;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x7) != E_RVVM2SImode
          || !vector_merge_operand (operands[2], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode))
            return -1;
          return 10;

        case E_RVVMF2QImode:
          if (!register_operand (operands[3], E_RVVMF2QImode))
            return -1;
          return 11;

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x7) != E_RVVM1SImode
          || !vector_merge_operand (operands[2], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode))
            return -1;
          return 12;

        case E_RVVMF4QImode:
          if (!register_operand (operands[3], E_RVVMF4QImode))
            return -1;
          return 13;

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode)
          || GET_MODE (x1) != E_RVVMF2SImode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x7) != E_RVVMF2SImode
          || !vector_merge_operand (operands[2], E_RVVMF2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF4HImode:
          if (!register_operand (operands[3], E_RVVMF4HImode))
            return -1;
          return 14;

        case E_RVVMF8QImode:
          if (!register_operand (operands[3], E_RVVMF8QImode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode)
          || GET_MODE (x1) != E_RVVM8DImode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x7) != E_RVVM8DImode
          || !vector_merge_operand (operands[2], E_RVVM8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4SImode:
          if (!register_operand (operands[3], E_RVVM4SImode))
            return -1;
          return 16;

        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode))
            return -1;
          return 17;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode)
          || GET_MODE (x1) != E_RVVM4DImode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x7) != E_RVVM4DImode
          || !vector_merge_operand (operands[2], E_RVVM4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2SImode:
          if (!register_operand (operands[3], E_RVVM2SImode))
            return -1;
          return 19;

        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode))
            return -1;
          return 20;

        case E_RVVMF2QImode:
          if (!register_operand (operands[3], E_RVVMF2QImode))
            return -1;
          return 21;

        default:
          return -1;
        }

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode)
          || GET_MODE (x1) != E_RVVM2DImode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x7) != E_RVVM2DImode
          || !vector_merge_operand (operands[2], E_RVVM2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1SImode:
          if (!register_operand (operands[3], E_RVVM1SImode))
            return -1;
          return 22;

        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode))
            return -1;
          return 23;

        case E_RVVMF4QImode:
          if (!register_operand (operands[3], E_RVVMF4QImode))
            return -1;
          return 24;

        default:
          return -1;
        }

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode)
          || GET_MODE (x1) != E_RVVM1DImode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x7) != E_RVVM1DImode
          || !vector_merge_operand (operands[2], E_RVVM1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2SImode:
          if (!register_operand (operands[3], E_RVVMF2SImode))
            return -1;
          return 25;

        case E_RVVMF4HImode:
          if (!register_operand (operands[3], E_RVVMF4HImode))
            return -1;
          return 26;

        case E_RVVMF8QImode:
          if (!register_operand (operands[3], E_RVVMF8QImode))
            return -1;
          return 27;

        default:
          return -1;
        }

    case E_V1HImode:
      if (pattern504 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 28;

    case E_V2HImode:
      if (pattern504 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 29;

    case E_V4HImode:
      if (pattern504 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 30;

    case E_V8HImode:
      if (pattern504 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 31;

    case E_V16HImode:
      if (pattern504 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 32;

    case E_V32HImode:
      if (pattern504 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 33;

    case E_V64HImode:
      if (pattern504 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 34;

    case E_V128HImode:
      if (pattern504 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 35;

    case E_V256HImode:
      if (pattern504 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 36;

    case E_V512HImode:
      if (pattern504 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 37;

    case E_V1024HImode:
      if (pattern504 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 38;

    case E_V2048HImode:
      if (pattern504 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 39;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x7) != E_V1SImode
          || !vector_merge_operand (operands[2], E_V1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1HImode:
          if (!register_operand (operands[3], E_V1HImode))
            return -1;
          return 40;

        case E_V1QImode:
          if (!register_operand (operands[3], E_V1QImode))
            return -1;
          return 41;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x7) != E_V2SImode
          || !vector_merge_operand (operands[2], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2HImode:
          if (!register_operand (operands[3], E_V2HImode))
            return -1;
          return 42;

        case E_V2QImode:
          if (!register_operand (operands[3], E_V2QImode))
            return -1;
          return 43;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x7) != E_V4SImode
          || !vector_merge_operand (operands[2], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HImode:
          if (!register_operand (operands[3], E_V4HImode))
            return -1;
          return 44;

        case E_V4QImode:
          if (!register_operand (operands[3], E_V4QImode))
            return -1;
          return 45;

        default:
          return -1;
        }

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x7) != E_V8SImode
          || !vector_merge_operand (operands[2], E_V8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8HImode:
          if (!register_operand (operands[3], E_V8HImode))
            return -1;
          return 46;

        case E_V8QImode:
          if (!register_operand (operands[3], E_V8QImode))
            return -1;
          return 47;

        default:
          return -1;
        }

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x7) != E_V16SImode
          || !vector_merge_operand (operands[2], E_V16SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16HImode:
          if (!register_operand (operands[3], E_V16HImode))
            return -1;
          return 48;

        case E_V16QImode:
          if (!register_operand (operands[3], E_V16QImode))
            return -1;
          return 49;

        default:
          return -1;
        }

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode)
          || GET_MODE (x1) != E_V32SImode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x7) != E_V32SImode
          || !vector_merge_operand (operands[2], E_V32SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32HImode:
          if (!register_operand (operands[3], E_V32HImode))
            return -1;
          return 50;

        case E_V32QImode:
          if (!register_operand (operands[3], E_V32QImode))
            return -1;
          return 51;

        default:
          return -1;
        }

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode)
          || GET_MODE (x1) != E_V64SImode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x7) != E_V64SImode
          || !vector_merge_operand (operands[2], E_V64SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64HImode:
          if (!register_operand (operands[3], E_V64HImode))
            return -1;
          return 52;

        case E_V64QImode:
          if (!register_operand (operands[3], E_V64QImode))
            return -1;
          return 53;

        default:
          return -1;
        }

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode)
          || GET_MODE (x1) != E_V128SImode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x7) != E_V128SImode
          || !vector_merge_operand (operands[2], E_V128SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128HImode:
          if (!register_operand (operands[3], E_V128HImode))
            return -1;
          return 54;

        case E_V128QImode:
          if (!register_operand (operands[3], E_V128QImode))
            return -1;
          return 55;

        default:
          return -1;
        }

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode)
          || GET_MODE (x1) != E_V256SImode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x7) != E_V256SImode
          || !vector_merge_operand (operands[2], E_V256SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256HImode:
          if (!register_operand (operands[3], E_V256HImode))
            return -1;
          return 56;

        case E_V256QImode:
          if (!register_operand (operands[3], E_V256QImode))
            return -1;
          return 57;

        default:
          return -1;
        }

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode)
          || GET_MODE (x1) != E_V512SImode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x7) != E_V512SImode
          || !vector_merge_operand (operands[2], E_V512SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512HImode:
          if (!register_operand (operands[3], E_V512HImode))
            return -1;
          return 58;

        case E_V512QImode:
          if (!register_operand (operands[3], E_V512QImode))
            return -1;
          return 59;

        default:
          return -1;
        }

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode)
          || GET_MODE (x1) != E_V1024SImode
          || GET_MODE (x2) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode)
          || GET_MODE (x7) != E_V1024SImode
          || !vector_merge_operand (operands[2], E_V1024SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1024HImode:
          if (!register_operand (operands[3], E_V1024HImode))
            return -1;
          return 60;

        case E_V1024QImode:
          if (!register_operand (operands[3], E_V1024QImode))
            return -1;
          return 61;

        default:
          return -1;
        }

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x7) != E_V1DImode
          || !vector_merge_operand (operands[2], E_V1DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1SImode:
          if (!register_operand (operands[3], E_V1SImode))
            return -1;
          return 62;

        case E_V1HImode:
          if (!register_operand (operands[3], E_V1HImode))
            return -1;
          return 63;

        case E_V1QImode:
          if (!register_operand (operands[3], E_V1QImode))
            return -1;
          return 64;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x7) != E_V2DImode
          || !vector_merge_operand (operands[2], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2SImode:
          if (!register_operand (operands[3], E_V2SImode))
            return -1;
          return 65;

        case E_V2HImode:
          if (!register_operand (operands[3], E_V2HImode))
            return -1;
          return 66;

        case E_V2QImode:
          if (!register_operand (operands[3], E_V2QImode))
            return -1;
          return 67;

        default:
          return -1;
        }

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x7) != E_V4DImode
          || !vector_merge_operand (operands[2], E_V4DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4SImode:
          if (!register_operand (operands[3], E_V4SImode))
            return -1;
          return 68;

        case E_V4HImode:
          if (!register_operand (operands[3], E_V4HImode))
            return -1;
          return 69;

        case E_V4QImode:
          if (!register_operand (operands[3], E_V4QImode))
            return -1;
          return 70;

        default:
          return -1;
        }

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x7) != E_V8DImode
          || !vector_merge_operand (operands[2], E_V8DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8SImode:
          if (!register_operand (operands[3], E_V8SImode))
            return -1;
          return 71;

        case E_V8HImode:
          if (!register_operand (operands[3], E_V8HImode))
            return -1;
          return 72;

        case E_V8QImode:
          if (!register_operand (operands[3], E_V8QImode))
            return -1;
          return 73;

        default:
          return -1;
        }

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode)
          || GET_MODE (x1) != E_V16DImode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x7) != E_V16DImode
          || !vector_merge_operand (operands[2], E_V16DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16SImode:
          if (!register_operand (operands[3], E_V16SImode))
            return -1;
          return 74;

        case E_V16HImode:
          if (!register_operand (operands[3], E_V16HImode))
            return -1;
          return 75;

        case E_V16QImode:
          if (!register_operand (operands[3], E_V16QImode))
            return -1;
          return 76;

        default:
          return -1;
        }

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode)
          || GET_MODE (x1) != E_V32DImode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x7) != E_V32DImode
          || !vector_merge_operand (operands[2], E_V32DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32SImode:
          if (!register_operand (operands[3], E_V32SImode))
            return -1;
          return 77;

        case E_V32HImode:
          if (!register_operand (operands[3], E_V32HImode))
            return -1;
          return 78;

        case E_V32QImode:
          if (!register_operand (operands[3], E_V32QImode))
            return -1;
          return 79;

        default:
          return -1;
        }

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode)
          || GET_MODE (x1) != E_V64DImode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x7) != E_V64DImode
          || !vector_merge_operand (operands[2], E_V64DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64SImode:
          if (!register_operand (operands[3], E_V64SImode))
            return -1;
          return 80;

        case E_V64HImode:
          if (!register_operand (operands[3], E_V64HImode))
            return -1;
          return 81;

        case E_V64QImode:
          if (!register_operand (operands[3], E_V64QImode))
            return -1;
          return 82;

        default:
          return -1;
        }

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode)
          || GET_MODE (x1) != E_V128DImode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x7) != E_V128DImode
          || !vector_merge_operand (operands[2], E_V128DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128SImode:
          if (!register_operand (operands[3], E_V128SImode))
            return -1;
          return 83;

        case E_V128HImode:
          if (!register_operand (operands[3], E_V128HImode))
            return -1;
          return 84;

        case E_V128QImode:
          if (!register_operand (operands[3], E_V128QImode))
            return -1;
          return 85;

        default:
          return -1;
        }

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode)
          || GET_MODE (x1) != E_V256DImode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x7) != E_V256DImode
          || !vector_merge_operand (operands[2], E_V256DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256SImode:
          if (!register_operand (operands[3], E_V256SImode))
            return -1;
          return 86;

        case E_V256HImode:
          if (!register_operand (operands[3], E_V256HImode))
            return -1;
          return 87;

        case E_V256QImode:
          if (!register_operand (operands[3], E_V256QImode))
            return -1;
          return 88;

        default:
          return -1;
        }

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode)
          || GET_MODE (x1) != E_V512DImode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x7) != E_V512DImode
          || !vector_merge_operand (operands[2], E_V512DImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512SImode:
          if (!register_operand (operands[3], E_V512SImode))
            return -1;
          return 89;

        case E_V512HImode:
          if (!register_operand (operands[3], E_V512HImode))
            return -1;
          return 90;

        case E_V512QImode:
          if (!register_operand (operands[3], E_V512QImode))
            return -1;
          return 91;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern570 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (!register_operand (x5, i1))
    return -1;
  return 0;
}

int
pattern572 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF64BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[2], E_RVVMF64BImode))
        return -1;
      return 0;

    case E_RVVMF32BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[2], E_RVVMF32BImode))
        return -1;
      return 1;

    case E_RVVMF16BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[2], E_RVVMF16BImode))
        return -1;
      return 2;

    case E_RVVMF8BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[2], E_RVVMF8BImode))
        return -1;
      return 3;

    case E_RVVMF4BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || !register_operand (operands[2], E_RVVMF4BImode))
        return -1;
      return 4;

    case E_RVVMF2BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVMF2BImode
          || !vector_mask_operand (operands[1], E_RVVMF2BImode)
          || !register_operand (operands[2], E_RVVMF2BImode))
        return -1;
      return 5;

    case E_RVVM1BImode:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x4) != E_RVVM1BImode
          || !vector_mask_operand (operands[1], E_RVVM1BImode)
          || !register_operand (operands[2], E_RVVM1BImode))
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern578 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1)
      || !vector_move_operand (operands[3], i1)
      || !vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern579 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1BImode)
      || GET_MODE (x1) != E_RVVM1BImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_RVVM8QImode
      || !register_operand (operands[1], E_RVVM8QImode)
      || !vector_arith_operand (operands[2], E_RVVM8QImode))
    return -1;
  return 0;
}

int
pattern581 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XVECEXP (x2, 0, 5);
  operands[9] = x7;
  x8 = XEXP (x1, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x8, 1);
  operands[3] = x11;
  x12 = XEXP (x1, 2);
  operands[2] = x12;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern496 (x1, 
E_RVVM8HFmode, 
E_HFmode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (pattern496 (x1, 
E_RVVM4HFmode, 
E_HFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HFmode:
      if (pattern496 (x1, 
E_RVVM2HFmode, 
E_HFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HFmode:
      if (pattern496 (x1, 
E_RVVM1HFmode, 
E_HFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HFmode:
      if (pattern496 (x1, 
E_RVVMF2HFmode, 
E_HFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HFmode:
      if (pattern496 (x1, 
E_RVVMF4HFmode, 
E_HFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SFmode:
      if (pattern496 (x1, 
E_RVVM8SFmode, 
E_SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SFmode:
      if (pattern496 (x1, 
E_RVVM4SFmode, 
E_SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SFmode:
      if (pattern496 (x1, 
E_RVVM2SFmode, 
E_SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SFmode:
      if (pattern496 (x1, 
E_RVVM1SFmode, 
E_SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SFmode:
      if (pattern496 (x1, 
E_RVVMF2SFmode, 
E_SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DFmode:
      if (pattern496 (x1, 
E_RVVM8DFmode, 
E_DFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DFmode:
      if (pattern496 (x1, 
E_RVVM4DFmode, 
E_DFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DFmode:
      if (pattern496 (x1, 
E_RVVM2DFmode, 
E_DFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DFmode:
      if (pattern496 (x1, 
E_RVVM1DFmode, 
E_DFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern586 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[3], i2))
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[4], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern589 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern593 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], i1))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!vector_neg_arith_operand (operands[4], i1))
    return -1;
  x9 = XEXP (x1, 2);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  return 0;
}

int
pattern596 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], E_QImode)
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern600 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SImode:
      return pattern480 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode); /* [-1, 0] */

    case E_RVVM4SImode:
      if (pattern480 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2SImode:
      if (pattern480 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1SImode:
      if (pattern480 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2SImode:
      if (pattern480 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern607 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  if (!register_operand (operands[4], i2))
    return -1;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  if (!register_operand (operands[5], i2))
    return -1;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern609 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF4BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF4BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM4HFmode:
      if (!register_operand (operands[4], E_RVVM4HFmode)
          || !register_operand (operands[5], E_RVVM4HFmode))
        return -1;
      return 0;

    case E_RVVM8SFmode:
      if (!register_operand (operands[4], E_RVVM8SFmode)
          || !register_operand (operands[5], E_RVVM8SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern611 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_RVVMF16BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_RVVMF16BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM1HFmode:
      if (!register_operand (operands[4], E_RVVM1HFmode)
          || !register_operand (operands[5], E_RVVM1HFmode))
        return -1;
      return 0;

    case E_RVVM2SFmode:
      if (!register_operand (operands[4], E_RVVM2SFmode)
          || !register_operand (operands[5], E_RVVM2SFmode))
        return -1;
      return 1;

    case E_RVVM4DFmode:
      if (!register_operand (operands[4], E_RVVM4DFmode)
          || !register_operand (operands[5], E_RVVM4DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern614 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V1BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V1BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V1HFmode:
      if (!register_operand (operands[4], E_V1HFmode)
          || !register_operand (operands[5], E_V1HFmode))
        return -1;
      return 0;

    case E_V1SFmode:
      if (!register_operand (operands[4], E_V1SFmode)
          || !register_operand (operands[5], E_V1SFmode))
        return -1;
      return 1;

    case E_V1DFmode:
      if (!register_operand (operands[4], E_V1DFmode)
          || !register_operand (operands[5], E_V1DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern617 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V8BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[4], E_V8HFmode)
          || !register_operand (operands[5], E_V8HFmode))
        return -1;
      return 0;

    case E_V8SFmode:
      if (!register_operand (operands[4], E_V8SFmode)
          || !register_operand (operands[5], E_V8SFmode))
        return -1;
      return 1;

    case E_V8DFmode:
      if (!register_operand (operands[4], E_V8DFmode)
          || !register_operand (operands[5], E_V8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern620 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V64BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V64BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V64HFmode:
      if (!register_operand (operands[4], E_V64HFmode)
          || !register_operand (operands[5], E_V64HFmode))
        return -1;
      return 0;

    case E_V64SFmode:
      if (!register_operand (operands[4], E_V64SFmode)
          || !register_operand (operands[5], E_V64SFmode))
        return -1;
      return 1;

    case E_V64DFmode:
      if (!register_operand (operands[4], E_V64DFmode)
          || !register_operand (operands[5], E_V64DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern624 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!vector_mask_operand (operands[1], E_V1024BImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[7] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[8] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x6, 1);
  operands[5] = x8;
  x9 = XEXP (x1, 2);
  operands[2] = x9;
  if (!vector_merge_operand (operands[2], E_V1024BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V1024HFmode:
      if (!register_operand (operands[4], E_V1024HFmode)
          || !register_operand (operands[5], E_V1024HFmode))
        return -1;
      return 0;

    case E_V1024SFmode:
      if (!register_operand (operands[4], E_V1024SFmode)
          || !register_operand (operands[5], E_V1024SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern628 (rtx x1, machine_mode i1, int i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 18:
      if (REGNO (x12) != 9)
        return -1;
      x16 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x16) != SET)
        return -1;
      x17 = XEXP (x16, 1);
      if (GET_CODE (x17) != MEM
          || GET_MODE (x17) != i1)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != PLUS
          || GET_MODE (x18) != i1)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != REG
          || REGNO (x19) != 2
          || GET_MODE (x19) != i1)
        return -1;
      x20 = XEXP (x18, 1);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
        return -1;
      x21 = XEXP (x16, 0);
      if (GET_CODE (x21) != REG
          || REGNO (x21) != 8
          || GET_MODE (x21) != i1)
        return -1;
      x22 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x22) != SET)
        return -1;
      x23 = XEXP (x22, 1);
      if (GET_CODE (x23) != MEM
          || GET_MODE (x23) != i1)
        return -1;
      x24 = XEXP (x23, 0);
      if (GET_CODE (x24) != PLUS
          || GET_MODE (x24) != i1)
        return -1;
      x25 = XEXP (x24, 0);
      if (GET_CODE (x25) != REG
          || REGNO (x25) != 2
          || GET_MODE (x25) != i1)
        return -1;
      x26 = XEXP (x24, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
        return -1;
      x27 = XEXP (x22, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 1
          || GET_MODE (x27) != i1
          || !stack_pop_up_to_s2_operand (operands[0], E_VOIDmode))
        return -1;
      return 0;

    case 8:
      if (REGNO (x12) != 1)
        return -1;
      x16 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x16) != RETURN)
        return -1;
      x22 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x22) != USE)
        return -1;
      x27 = XEXP (x22, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 1
          || GET_MODE (x27) != E_SImode
          || !stack_pop_up_to_s0_operand (operands[0], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern648 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF4BImode
      || !vector_mask_operand (operands[1], E_RVVMF4BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM2QImode:
      if (!register_operand (operands[4], E_RVVM2QImode))
        return -1;
      return 0;

    case E_RVVM4HImode:
      if (!register_operand (operands[4], E_RVVM4HImode))
        return -1;
      return 1;

    case E_RVVM8SImode:
      if (!register_operand (operands[4], E_RVVM8SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern654 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF4BImode
      || !vector_mask_operand (operands[1], E_RVVMF4BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM4HImode:
      if (!register_operand (operands[4], E_RVVM4HImode))
        return -1;
      return 0;

    case E_RVVM2QImode:
      if (!register_operand (operands[4], E_RVVM2QImode))
        return -1;
      return 1;

    case E_RVVM8SImode:
      if (!register_operand (operands[4], E_RVVM8SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern660 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF8BImode
      || !vector_mask_operand (operands[1], E_RVVMF8BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM4SImode:
      if (!register_operand (operands[4], E_RVVM4SImode))
        return -1;
      return 0;

    case E_RVVM2HImode:
      if (!register_operand (operands[4], E_RVVM2HImode))
        return -1;
      return 1;

    case E_RVVM1QImode:
      if (!register_operand (operands[4], E_RVVM1QImode))
        return -1;
      return 2;

    case E_RVVM8DImode:
      if (!register_operand (operands[4], E_RVVM8DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern666 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_RVVMF32BImode
      || !vector_mask_operand (operands[1], E_RVVMF32BImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vector_merge_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_RVVM2DImode:
      if (!register_operand (operands[4], E_RVVM2DImode))
        return -1;
      return 0;

    case E_RVVM1SImode:
      if (!register_operand (operands[4], E_RVVM1SImode))
        return -1;
      return 1;

    case E_RVVMF2HImode:
      if (!register_operand (operands[4], E_RVVMF2HImode))
        return -1;
      return 2;

    case E_RVVMF4QImode:
      if (!register_operand (operands[4], E_RVVMF4QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern674 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x8) != SET)
    return -1;
  return 0;
}

int
pattern681 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF2BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF2BImode)
          || !register_operand (operands[3], E_RVVM8HFmode))
        return -1;
      return 0;

    case E_RVVMF4BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode)
          || !register_operand (operands[3], E_RVVM4HFmode))
        return -1;
      return 1;

    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[3], E_RVVM2HFmode))
        return -1;
      return 2;

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[3], E_RVVM1HFmode))
        return -1;
      return 3;

    case E_RVVMF32BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[3], E_RVVMF2HFmode))
        return -1;
      return 4;

    case E_RVVMF64BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[3], E_RVVMF4HFmode))
        return -1;
      return 5;

    case E_V1BImode:
      if (!vector_mask_operand (operands[1], E_V1BImode)
          || !register_operand (operands[3], E_V1HFmode))
        return -1;
      return 6;

    case E_V2BImode:
      if (!vector_mask_operand (operands[1], E_V2BImode)
          || !register_operand (operands[3], E_V2HFmode))
        return -1;
      return 7;

    case E_V4BImode:
      if (!vector_mask_operand (operands[1], E_V4BImode)
          || !register_operand (operands[3], E_V4HFmode))
        return -1;
      return 8;

    case E_V8BImode:
      if (!vector_mask_operand (operands[1], E_V8BImode)
          || !register_operand (operands[3], E_V8HFmode))
        return -1;
      return 9;

    case E_V16BImode:
      if (!vector_mask_operand (operands[1], E_V16BImode)
          || !register_operand (operands[3], E_V16HFmode))
        return -1;
      return 10;

    case E_V32BImode:
      if (!vector_mask_operand (operands[1], E_V32BImode)
          || !register_operand (operands[3], E_V32HFmode))
        return -1;
      return 11;

    case E_V64BImode:
      if (!vector_mask_operand (operands[1], E_V64BImode)
          || !register_operand (operands[3], E_V64HFmode))
        return -1;
      return 12;

    case E_V128BImode:
      if (!vector_mask_operand (operands[1], E_V128BImode)
          || !register_operand (operands[3], E_V128HFmode))
        return -1;
      return 13;

    case E_V256BImode:
      if (!vector_mask_operand (operands[1], E_V256BImode)
          || !register_operand (operands[3], E_V256HFmode))
        return -1;
      return 14;

    case E_V512BImode:
      if (!vector_mask_operand (operands[1], E_V512BImode)
          || !register_operand (operands[3], E_V512HFmode))
        return -1;
      return 15;

    case E_V1024BImode:
      if (!vector_mask_operand (operands[1], E_V1024BImode)
          || !register_operand (operands[3], E_V1024HFmode))
        return -1;
      return 16;

    case E_V2048BImode:
      if (!vector_mask_operand (operands[1], E_V2048BImode)
          || !register_operand (operands[3], E_V2048HFmode))
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern690 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i4
      || !reg_or_0_operand (operands[4], i3)
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern698 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !reg_or_0_operand (operands[3], E_DImode)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern703 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern702 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (pattern702 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (pattern702 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (pattern702 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (pattern702 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (pattern702 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode)
          || GET_MODE (x1) != E_RVVM8SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x2) != E_RVVM8SImode
          || GET_MODE (x3) != E_RVVM8SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM8SImode
          || GET_MODE (x4) != E_RVVM8SImode
          || !register_operand (operands[2], E_RVVM8SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HImode:
          if (!register_operand (operands[3], E_RVVM4HImode)
              || !register_operand (operands[4], E_RVVM4HImode))
            return -1;
          return 6;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVM4QImode:
              if (!register_operand (operands[4], E_RVVM4QImode))
                return -1;
              return 7;

            case E_RVVM8QImode:
              if (!register_operand (operands[4], E_RVVM8QImode))
                return -1;
              return 8;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode)
          || GET_MODE (x1) != E_RVVM4SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x2) != E_RVVM4SImode
          || GET_MODE (x3) != E_RVVM4SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM4SImode
          || GET_MODE (x4) != E_RVVM4SImode
          || !register_operand (operands[2], E_RVVM4SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode)
              || !register_operand (operands[4], E_RVVM2HImode))
            return -1;
          return 9;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVM2QImode:
              if (!register_operand (operands[4], E_RVVM2QImode))
                return -1;
              return 10;

            case E_RVVM4QImode:
              if (!register_operand (operands[4], E_RVVM4QImode))
                return -1;
              return 11;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode)
          || GET_MODE (x1) != E_RVVM2SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x2) != E_RVVM2SImode
          || GET_MODE (x3) != E_RVVM2SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM2SImode
          || GET_MODE (x4) != E_RVVM2SImode
          || !register_operand (operands[2], E_RVVM2SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode)
              || !register_operand (operands[4], E_RVVM1HImode))
            return -1;
          return 12;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVM1QImode:
              if (!register_operand (operands[4], E_RVVM1QImode))
                return -1;
              return 13;

            case E_RVVM2QImode:
              if (!register_operand (operands[4], E_RVVM2QImode))
                return -1;
              return 14;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode)
          || GET_MODE (x1) != E_RVVM1SImode)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_MODE (x6) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x2) != E_RVVM1SImode
          || GET_MODE (x3) != E_RVVM1SImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_MODE (x7) != E_RVVM1SImode
          || GET_MODE (x4) != E_RVVM1SImode
          || !register_operand (operands[2], E_RVVM1SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode)
              || !register_operand (operands[4], E_RVVMF2HImode))
            return -1;
          return 15;

        case E_RVVM1QImode:
          if (!register_operand (operands[3], E_RVVM1QImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_RVVMF2QImode:
              if (!register_operand (operands[4], E_RVVMF2QImode))
                return -1;
              return 16;

            case E_RVVM1QImode:
              if (!register_operand (operands[4], E_RVVM1QImode))
                return -1;
              return 17;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_RVVMF2SImode:
      if (pattern702 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 18;

    case E_RVVM8DImode:
      if (pattern702 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 19;

    case E_RVVM4DImode:
      if (pattern702 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 20;

    case E_RVVM2DImode:
      if (pattern702 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 21;

    case E_RVVM1DImode:
      if (pattern702 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 22;

    case E_V1HImode:
      if (pattern702 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 23;

    case E_V2HImode:
      if (pattern702 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 24;

    case E_V4HImode:
      if (pattern702 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 25;

    case E_V8HImode:
      if (pattern702 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 26;

    case E_V16HImode:
      if (pattern702 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 27;

    case E_V32HImode:
      if (pattern702 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 28;

    case E_V64HImode:
      if (pattern702 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 29;

    case E_V128HImode:
      if (pattern702 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 30;

    case E_V256HImode:
      if (pattern702 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 31;

    case E_V512HImode:
      if (pattern702 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 32;

    case E_V1024HImode:
      if (pattern702 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 33;

    case E_V2048HImode:
      if (pattern702 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 34;

    case E_V1SImode:
      if (pattern702 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 35;

    case E_V2SImode:
      if (pattern702 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 36;

    case E_V4SImode:
      if (pattern702 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 37;

    case E_V8SImode:
      if (pattern702 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 38;

    case E_V16SImode:
      if (pattern702 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 39;

    case E_V32SImode:
      if (pattern702 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 40;

    case E_V64SImode:
      if (pattern702 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 41;

    case E_V128SImode:
      if (pattern702 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 42;

    case E_V256SImode:
      if (pattern702 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 43;

    case E_V512SImode:
      if (pattern702 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 44;

    case E_V1024SImode:
      if (pattern702 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 45;

    case E_V1DImode:
      if (pattern702 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 46;

    case E_V2DImode:
      if (pattern702 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 47;

    case E_V4DImode:
      if (pattern702 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 48;

    case E_V8DImode:
      if (pattern702 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 49;

    case E_V16DImode:
      if (pattern702 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 50;

    case E_V32DImode:
      if (pattern702 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 51;

    case E_V64DImode:
      if (pattern702 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 52;

    case E_V128DImode:
      if (pattern702 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 53;

    case E_V256DImode:
      if (pattern702 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 54;

    case E_V512DImode:
      if (pattern702 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 55;

    default:
      return -1;
    }
}

int
pattern741 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 5);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != SET)
    return -1;
  return 0;
}

int
pattern744 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x22, 1);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  return 0;
}

int
pattern749 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XEXP (x22, 1);
  if (GET_MODE (x26) != i1)
    return -1;
  x27 = XVECEXP (x1, 0, 5);
  x28 = XEXP (x27, 0);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x27, 1);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  return 0;
}

int
pattern756 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[0] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  switch (XWINT (x8, 0))
    {
    case -4L:
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 1);
      if (XWINT (x12, 0) != -8L)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -12L)
        return -1;
      x17 = XVECEXP (x1, 0, 4);
      x18 = XEXP (x17, 1);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 1);
      if (XWINT (x20, 0) != -16L)
        return -1;
      x21 = XVECEXP (x1, 0, 5);
      x22 = XEXP (x21, 1);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 1);
      if (XWINT (x24, 0) != -20L)
        return -1;
      x25 = XVECEXP (x1, 0, 6);
      x26 = XEXP (x25, 1);
      x27 = XEXP (x26, 0);
      x28 = XEXP (x27, 1);
      if (XWINT (x28, 0) != -24L)
        return -1;
      x29 = XVECEXP (x1, 0, 7);
      x30 = XEXP (x29, 1);
      x31 = XEXP (x30, 0);
      x32 = XEXP (x31, 1);
      if (XWINT (x32, 0) != -28L)
        return -1;
      return 0;

    case -8L:
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 1);
      if (XWINT (x12, 0) != -16L)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -24L)
        return -1;
      x17 = XVECEXP (x1, 0, 4);
      x18 = XEXP (x17, 1);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 1);
      if (XWINT (x20, 0) != -32L)
        return -1;
      x21 = XVECEXP (x1, 0, 5);
      x22 = XEXP (x21, 1);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 1);
      if (XWINT (x24, 0) != -40L)
        return -1;
      x25 = XVECEXP (x1, 0, 6);
      x26 = XEXP (x25, 1);
      x27 = XEXP (x26, 0);
      x28 = XEXP (x27, 1);
      if (XWINT (x28, 0) != -48L)
        return -1;
      x29 = XVECEXP (x1, 0, 7);
      x30 = XEXP (x29, 1);
      x31 = XEXP (x30, 0);
      x32 = XEXP (x31, 1);
      if (XWINT (x32, 0) != -56L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern764 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i1)
    return -1;
  x33 = XEXP (x31, 1);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XVECEXP (x1, 0, 7);
  x37 = XEXP (x36, 0);
  if (GET_MODE (x37) != i1)
    return -1;
  x38 = XEXP (x36, 1);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XVECEXP (x1, 0, 8);
  x42 = XEXP (x41, 0);
  if (GET_MODE (x42) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 25:
      if (REGNO (x12) != 24
          || REGNO (x17) != 23)
        return -1;
      return 0;

    case 23:
      if (REGNO (x12) != 22
          || REGNO (x17) != 21)
        return -1;
      return 1;

    case 21:
      if (REGNO (x12) != 20
          || REGNO (x17) != 19
          || REGNO (x22) != 18
          || REGNO (x27) != 9
          || REGNO (x32) != 8
          || REGNO (x37) != 1)
        return -1;
      x43 = XEXP (x41, 1);
      if (x43 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x42) != 10)
        return -1;
      x44 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x44) != USE)
        return -1;
      x45 = XEXP (x44, 0);
      if (GET_CODE (x45) != REG
          || REGNO (x45) != 10
          || GET_MODE (x45) != i1)
        return -1;
      x46 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x46) != RETURN)
        return -1;
      x47 = XVECEXP (x1, 0, 11);
      if (GET_CODE (x47) != USE)
        return -1;
      x48 = XEXP (x47, 0);
      if (GET_CODE (x48) != REG
          || REGNO (x48) != 1
          || GET_MODE (x48) != E_SImode
          || !stack_pop_up_to_s5_operand (operands[0], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern777 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XEXP (x17, 1);
  if (GET_MODE (x21) != i1)
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  x23 = XEXP (x22, 0);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XEXP (x22, 1);
  if (GET_MODE (x26) != i1)
    return -1;
  x27 = XVECEXP (x1, 0, 5);
  x28 = XEXP (x27, 0);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XEXP (x27, 1);
  if (GET_MODE (x31) != i1)
    return -1;
  x32 = XVECEXP (x1, 0, 6);
  x33 = XEXP (x32, 0);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XEXP (x32, 1);
  if (GET_MODE (x36) != i1)
    return -1;
  x37 = XVECEXP (x1, 0, 7);
  x38 = XEXP (x37, 0);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XEXP (x37, 1);
  if (GET_MODE (x41) != i1)
    return -1;
  x42 = XVECEXP (x1, 0, 8);
  x43 = XEXP (x42, 0);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XEXP (x42, 1);
  if (GET_MODE (x46) != i1)
    return -1;
  x47 = XVECEXP (x1, 0, 9);
  x48 = XEXP (x47, 0);
  if (GET_MODE (x48) != i1)
    return -1;
  x49 = XEXP (x48, 0);
  if (GET_MODE (x49) != i1)
    return -1;
  x50 = XEXP (x49, 0);
  if (GET_MODE (x50) != i1)
    return -1;
  x51 = XEXP (x47, 1);
  if (GET_MODE (x51) != i1)
    return -1;
  x52 = XVECEXP (x1, 0, 10);
  x53 = XEXP (x52, 0);
  if (GET_MODE (x53) != i1)
    return -1;
  x54 = XEXP (x52, 1);
  if (GET_MODE (x54) != i1)
    return -1;
  x55 = XEXP (x54, 0);
  if (GET_MODE (x55) != i1)
    return -1;
  return 0;
}

int
pattern790 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != REG
      || REGNO (x1) != 1
      || GET_MODE (x1) != i1
      || !stack_pop_up_to_s8_operand (operands[0], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern794 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -44])
    return -1;
  return 0;
}

int
pattern798 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67, x68, x69, x70, x71, x72, x73;
  rtx x74;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i1)
    return -1;
  x33 = XEXP (x31, 1);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XVECEXP (x1, 0, 7);
  x37 = XEXP (x36, 0);
  if (GET_MODE (x37) != i1)
    return -1;
  x38 = XEXP (x36, 1);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XVECEXP (x1, 0, 8);
  x42 = XEXP (x41, 0);
  if (GET_MODE (x42) != i1)
    return -1;
  x43 = XEXP (x41, 1);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XVECEXP (x1, 0, 9);
  x47 = XEXP (x46, 0);
  if (GET_MODE (x47) != i1)
    return -1;
  x48 = XEXP (x46, 1);
  if (GET_MODE (x48) != i1)
    return -1;
  x49 = XEXP (x48, 0);
  if (GET_MODE (x49) != i1)
    return -1;
  x50 = XEXP (x49, 0);
  if (GET_MODE (x50) != i1)
    return -1;
  x51 = XVECEXP (x1, 0, 10);
  x52 = XEXP (x51, 0);
  if (GET_MODE (x52) != i1)
    return -1;
  x53 = XEXP (x51, 1);
  if (GET_MODE (x53) != i1)
    return -1;
  x54 = XEXP (x53, 0);
  if (GET_MODE (x54) != i1)
    return -1;
  x55 = XEXP (x54, 0);
  if (GET_MODE (x55) != i1)
    return -1;
  x56 = XVECEXP (x1, 0, 11);
  x57 = XEXP (x56, 0);
  if (GET_MODE (x57) != i1)
    return -1;
  x58 = XEXP (x56, 1);
  if (GET_MODE (x58) != i1)
    return -1;
  x59 = XEXP (x58, 0);
  if (GET_MODE (x59) != i1)
    return -1;
  x60 = XEXP (x59, 0);
  if (GET_MODE (x60) != i1)
    return -1;
  x61 = XVECEXP (x1, 0, 12);
  x62 = XEXP (x61, 0);
  if (GET_MODE (x62) != i1)
    return -1;
  x63 = XEXP (x61, 1);
  if (GET_MODE (x63) != i1)
    return -1;
  x64 = XEXP (x63, 0);
  if (GET_MODE (x64) != i1)
    return -1;
  x65 = XEXP (x64, 0);
  if (GET_MODE (x65) != i1)
    return -1;
  x66 = XVECEXP (x1, 0, 13);
  x67 = XEXP (x66, 0);
  if (GET_MODE (x67) != i1)
    return -1;
  x68 = XEXP (x66, 1);
  if (GET_MODE (x68) != i1)
    return -1;
  x69 = XEXP (x68, 0);
  if (GET_MODE (x69) != i1)
    return -1;
  x70 = XEXP (x69, 0);
  if (GET_MODE (x70) != i1)
    return -1;
  x71 = XVECEXP (x1, 0, 14);
  x72 = XEXP (x71, 0);
  if (GET_MODE (x72) != i1)
    return -1;
  x73 = XVECEXP (x1, 0, 15);
  x74 = XEXP (x73, 0);
  if (GET_MODE (x74) != i1)
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  switch (GET_CODE (x4))
    {
    case PLUS:
      operands[3] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!arith_operand (operands[2], E_DImode)
          || !
#line 869 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 9; /* *addsi3_extended2 */

    case MINUS:
      operands[3] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!reg_or_0_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 1050 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 18; /* *subsi3_extended2 */

    case NEG:
      operands[2] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 1102 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
        return -1;
      return 22; /* *negsi2_extended2 */

    case MULT:
      operands[3] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 1267 "../../gcc/config/riscv/riscv.md"
((TARGET_ZMMUL || TARGET_MUL) && TARGET_64BIT))
        return -1;
      return 29; /* *mulsi3_extended2 */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 1967 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && !TARGET_XTHEADMEMIDX))
            return -1;
          return 127; /* *extendsidi2_internal */

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 1984 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 130; /* *extendqidi2 */
          if (!(
#line 323 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 544; /* *extendqidi2_bitmanip */

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 1984 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 133; /* *extendhidi2 */
          if (!(
#line 323 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 547; /* *extendhidi2_bitmanip */

        default:
          return -1;
        }

    case E_HImode:
      x2 = XEXP (x1, 1);
      switch (pattern285 (x2, 
E_HImode))
        {
        case 0:
          if (
#line 1984 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 128; /* *extendqihi2 */
          if (!
#line 323 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 542; /* *extendqihi2_bitmanip */

        case 1:
          if (
#line 1984 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 131; /* *extendhihi2 */
          if (!
#line 323 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 545; /* *extendhihi2_bitmanip */

        default:
          return -1;
        }

    case E_SImode:
      x2 = XEXP (x1, 1);
      switch (pattern285 (x2, 
E_SImode))
        {
        case 0:
          if (
#line 1984 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 129; /* *extendqisi2 */
          if (!
#line 323 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 543; /* *extendqisi2_bitmanip */

        case 1:
          if (
#line 1984 "../../gcc/config/riscv/riscv.md"
(!TARGET_ZBB && !TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 132; /* *extendhisi2 */
          if (!
#line 323 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB && !TARGET_XTHEADMEMIDX))
            return -1;
          return 546; /* *extendhisi2_bitmanip */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      x2 = XEXP (x1, 1);
      switch (pattern286 (x2, 
E_HImode))
        {
        case 0:
          if (
#line 65 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 874; /* *extendhihi2_th_ext */
          if (!
#line 551 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return -1;
          return 929; /* *th_memidx_extendhihi2 */

        case 1:
          if (
#line 76 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 877; /* *extendqihi2_th_ext */
          if (
#line 551 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return 926; /* *th_memidx_extendqihi2 */
          if (!
#line 628 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB))
            return -1;
          return 937; /* *th_memidx_bb_extendqihi2 */

        default:
          return -1;
        }

    case E_SImode:
      x2 = XEXP (x1, 1);
      switch (pattern286 (x2, 
E_SImode))
        {
        case 0:
          if (
#line 65 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 875; /* *extendhisi2_th_ext */
          if (
#line 551 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return 930; /* *th_memidx_extendhisi2 */
          if (!
#line 612 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB))
            return -1;
          return 935; /* *th_memidx_bb_extendhisi2 */

        case 1:
          if (
#line 76 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX))
            return 878; /* *extendqisi2_th_ext */
          if (
#line 551 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB))
            return 927; /* *th_memidx_extendqisi2 */
          if (!
#line 628 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB))
            return -1;
          return 938; /* *th_memidx_bb_extendqisi2 */

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 65 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 876; /* *extendhidi2_th_ext */
          if ((
#line 551 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 931; /* *th_memidx_extendhidi2 */
          if (!(
#line 612 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 936; /* *th_memidx_bb_extendhidi2 */

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 76 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB && !TARGET_XTHEADMEMIDX) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 879; /* *extendqidi2_th_ext */
          if ((
#line 551 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && !TARGET_XTHEADBB) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 928; /* *th_memidx_extendqidi2 */
          if (!(
#line 628 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADMEMIDX && TARGET_XTHEADBB) && 
#line 60 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 939; /* *th_memidx_bb_extendqidi2 */

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 482 "../../gcc/config/riscv/thead.md"
(TARGET_64BIT && TARGET_XTHEADMEMIDX))
            return -1;
          return 922; /* *th_memidx_extendsidi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (XINT (x3, 1) != 93)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != VEC_SELECT
      || pattern333 (x3) != 0)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (GET_MODE (x4) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8QImode:
              if (!register_operand (operands[1], E_RVVM8QImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28261; /* *pred_extract_first_sextdirvvm8qi */

            case E_RVVM4QImode:
              if (!register_operand (operands[1], E_RVVM4QImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28262; /* *pred_extract_first_sextdirvvm4qi */

            case E_RVVM2QImode:
              if (!register_operand (operands[1], E_RVVM2QImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28263; /* *pred_extract_first_sextdirvvm2qi */

            case E_RVVM1QImode:
              if (!register_operand (operands[1], E_RVVM1QImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28264; /* *pred_extract_first_sextdirvvm1qi */

            case E_RVVMF2QImode:
              if (!register_operand (operands[1], E_RVVMF2QImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28265; /* *pred_extract_first_sextdirvvmf2qi */

            case E_RVVMF4QImode:
              if (!register_operand (operands[1], E_RVVMF4QImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28266; /* *pred_extract_first_sextdirvvmf4qi */

            case E_RVVMF8QImode:
              if (!register_operand (operands[1], E_RVVMF8QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 565 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 28267; /* *pred_extract_first_sextdirvvmf8qi */

            case E_V1QImode:
              if (!register_operand (operands[1], E_V1QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 571 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 28279; /* *pred_extract_first_sextdiv1qi */

            case E_V2QImode:
              if (!register_operand (operands[1], E_V2QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 572 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 28280; /* *pred_extract_first_sextdiv2qi */

            case E_V4QImode:
              if (!register_operand (operands[1], E_V4QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 573 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 28281; /* *pred_extract_first_sextdiv4qi */

            case E_V8QImode:
              if (!register_operand (operands[1], E_V8QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 574 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 28282; /* *pred_extract_first_sextdiv8qi */

            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 575 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 28283; /* *pred_extract_first_sextdiv16qi */

            case E_V32QImode:
              if (!register_operand (operands[1], E_V32QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 576 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 28284; /* *pred_extract_first_sextdiv32qi */

            case E_V64QImode:
              if (!register_operand (operands[1], E_V64QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 577 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 28285; /* *pred_extract_first_sextdiv64qi */

            case E_V128QImode:
              if (!register_operand (operands[1], E_V128QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 578 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 28286; /* *pred_extract_first_sextdiv128qi */

            case E_V256QImode:
              if (!register_operand (operands[1], E_V256QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 579 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 28287; /* *pred_extract_first_sextdiv256qi */

            case E_V512QImode:
              if (!register_operand (operands[1], E_V512QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 580 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 28288; /* *pred_extract_first_sextdiv512qi */

            case E_V1024QImode:
              if (!register_operand (operands[1], E_V1024QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 581 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 28289; /* *pred_extract_first_sextdiv1024qi */

            case E_V2048QImode:
              if (!register_operand (operands[1], E_V2048QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 582 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 28290; /* *pred_extract_first_sextdiv2048qi */

            case E_V4096QImode:
              if (!register_operand (operands[1], E_V4096QImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 583 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 28291; /* *pred_extract_first_sextdiv4096qi */

            default:
              return -1;
            }

        case E_HImode:
          if (GET_MODE (x4) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8HImode:
              if (!register_operand (operands[1], E_RVVM8HImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28268; /* *pred_extract_first_sextdirvvm8hi */

            case E_RVVM4HImode:
              if (!register_operand (operands[1], E_RVVM4HImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28269; /* *pred_extract_first_sextdirvvm4hi */

            case E_RVVM2HImode:
              if (!register_operand (operands[1], E_RVVM2HImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28270; /* *pred_extract_first_sextdirvvm2hi */

            case E_RVVM1HImode:
              if (!register_operand (operands[1], E_RVVM1HImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28271; /* *pred_extract_first_sextdirvvm1hi */

            case E_RVVMF2HImode:
              if (!register_operand (operands[1], E_RVVMF2HImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28272; /* *pred_extract_first_sextdirvvmf2hi */

            case E_RVVMF4HImode:
              if (!register_operand (operands[1], E_RVVMF4HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 567 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 28273; /* *pred_extract_first_sextdirvvmf4hi */

            case E_V1HImode:
              if (!register_operand (operands[1], E_V1HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 584 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 28292; /* *pred_extract_first_sextdiv1hi */

            case E_V2HImode:
              if (!register_operand (operands[1], E_V2HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 585 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 28293; /* *pred_extract_first_sextdiv2hi */

            case E_V4HImode:
              if (!register_operand (operands[1], E_V4HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 586 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 28294; /* *pred_extract_first_sextdiv4hi */

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 587 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 28295; /* *pred_extract_first_sextdiv8hi */

            case E_V16HImode:
              if (!register_operand (operands[1], E_V16HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 588 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 28296; /* *pred_extract_first_sextdiv16hi */

            case E_V32HImode:
              if (!register_operand (operands[1], E_V32HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 589 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 28297; /* *pred_extract_first_sextdiv32hi */

            case E_V64HImode:
              if (!register_operand (operands[1], E_V64HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 590 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 28298; /* *pred_extract_first_sextdiv64hi */

            case E_V128HImode:
              if (!register_operand (operands[1], E_V128HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 591 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 28299; /* *pred_extract_first_sextdiv128hi */

            case E_V256HImode:
              if (!register_operand (operands[1], E_V256HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 592 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 28300; /* *pred_extract_first_sextdiv256hi */

            case E_V512HImode:
              if (!register_operand (operands[1], E_V512HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 593 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 28301; /* *pred_extract_first_sextdiv512hi */

            case E_V1024HImode:
              if (!register_operand (operands[1], E_V1024HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 594 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 28302; /* *pred_extract_first_sextdiv1024hi */

            case E_V2048HImode:
              if (!register_operand (operands[1], E_V2048HImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 595 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 28303; /* *pred_extract_first_sextdiv2048hi */

            default:
              return -1;
            }

        case E_SImode:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8SImode:
              if (!register_operand (operands[1], E_RVVM8SImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28274; /* *pred_extract_first_sextdirvvm8si */

            case E_RVVM4SImode:
              if (!register_operand (operands[1], E_RVVM4SImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28275; /* *pred_extract_first_sextdirvvm4si */

            case E_RVVM2SImode:
              if (!register_operand (operands[1], E_RVVM2SImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28276; /* *pred_extract_first_sextdirvvm2si */

            case E_RVVM1SImode:
              if (!register_operand (operands[1], E_RVVM1SImode)
                  || !
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode))
                return -1;
              return 28277; /* *pred_extract_first_sextdirvvm1si */

            case E_RVVMF2SImode:
              if (!register_operand (operands[1], E_RVVMF2SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 569 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 28278; /* *pred_extract_first_sextdirvvmf2si */

            case E_V1SImode:
              if (!register_operand (operands[1], E_V1SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 596 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 28304; /* *pred_extract_first_sextdiv1si */

            case E_V2SImode:
              if (!register_operand (operands[1], E_V2SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 597 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 28305; /* *pred_extract_first_sextdiv2si */

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 598 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 28306; /* *pred_extract_first_sextdiv4si */

            case E_V8SImode:
              if (!register_operand (operands[1], E_V8SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 599 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 28307; /* *pred_extract_first_sextdiv8si */

            case E_V16SImode:
              if (!register_operand (operands[1], E_V16SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 600 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 28308; /* *pred_extract_first_sextdiv16si */

            case E_V32SImode:
              if (!register_operand (operands[1], E_V32SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 601 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 28309; /* *pred_extract_first_sextdiv32si */

            case E_V64SImode:
              if (!register_operand (operands[1], E_V64SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 602 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 28310; /* *pred_extract_first_sextdiv64si */

            case E_V128SImode:
              if (!register_operand (operands[1], E_V128SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 603 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 28311; /* *pred_extract_first_sextdiv128si */

            case E_V256SImode:
              if (!register_operand (operands[1], E_V256SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 604 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 28312; /* *pred_extract_first_sextdiv256si */

            case E_V512SImode:
              if (!register_operand (operands[1], E_V512SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 605 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 28313; /* *pred_extract_first_sextdiv512si */

            case E_V1024SImode:
              if (!register_operand (operands[1], E_V1024SImode)
                  || !(
#line 72 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == DImode) && 
#line 606 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 28314; /* *pred_extract_first_sextdiv1024si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (GET_MODE (x4) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8QImode:
              if (!register_operand (operands[1], E_RVVM8QImode)
                  || !
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28315; /* *pred_extract_first_sextsirvvm8qi */

            case E_RVVM4QImode:
              if (!register_operand (operands[1], E_RVVM4QImode)
                  || !
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28316; /* *pred_extract_first_sextsirvvm4qi */

            case E_RVVM2QImode:
              if (!register_operand (operands[1], E_RVVM2QImode)
                  || !
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28317; /* *pred_extract_first_sextsirvvm2qi */

            case E_RVVM1QImode:
              if (!register_operand (operands[1], E_RVVM1QImode)
                  || !
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28318; /* *pred_extract_first_sextsirvvm1qi */

            case E_RVVMF2QImode:
              if (!register_operand (operands[1], E_RVVMF2QImode)
                  || !
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28319; /* *pred_extract_first_sextsirvvmf2qi */

            case E_RVVMF4QImode:
              if (!register_operand (operands[1], E_RVVMF4QImode)
                  || !
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28320; /* *pred_extract_first_sextsirvvmf4qi */

            case E_RVVMF8QImode:
              if (!register_operand (operands[1], E_RVVMF8QImode)
                  || !(
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode) && 
#line 559 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 28321; /* *pred_extract_first_sextsirvvmf8qi */

            default:
              return -1;
            }

        case E_HImode:
          if (GET_MODE (x4) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_RVVM8HImode:
              if (!register_operand (operands[1], E_RVVM8HImode)
                  || !
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28322; /* *pred_extract_first_sextsirvvm8hi */

            case E_RVVM4HImode:
              if (!register_operand (operands[1], E_RVVM4HImode)
                  || !
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28323; /* *pred_extract_first_sextsirvvm4hi */

            case E_RVVM2HImode:
              if (!register_operand (operands[1], E_RVVM2HImode)
                  || !
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28324; /* *pred_extract_first_sextsirvvm2hi */

            case E_RVVM1HImode:
              if (!register_operand (operands[1], E_RVVM1HImode)
                  || !
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28325; /* *pred_extract_first_sextsirvvm1hi */

            case E_RVVMF2HImode:
              if (!register_operand (operands[1], E_RVVMF2HImode)
                  || !
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode))
                return -1;
              return 28326; /* *pred_extract_first_sextsirvvmf2hi */

            case E_RVVMF4HImode:
              if (!register_operand (operands[1], E_RVVMF4HImode)
                  || !(
#line 85 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && Pmode == SImode) && 
#line 561 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 28327; /* *pred_extract_first_sextsirvvmf4hi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern149 (x2))
    {
    case 0:
      if (!
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30149; /* *dual_widen_suburvvm8hi */

    case 1:
      if (!
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30155; /* *dual_widen_suburvvm4hi */

    case 2:
      if (!
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30161; /* *dual_widen_suburvvm2hi */

    case 3:
      if (!
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30167; /* *dual_widen_suburvvm1hi */

    case 4:
      if (!
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30173; /* *dual_widen_suburvvmf2hi */

    case 5:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30179; /* *dual_widen_suburvvmf4hi */

    case 6:
      if (!
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30185; /* *dual_widen_suburvvm8si */

    case 7:
      if (!
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30191; /* *dual_widen_suburvvm4si */

    case 8:
      if (!
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30197; /* *dual_widen_suburvvm2si */

    case 9:
      if (!
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30203; /* *dual_widen_suburvvm1si */

    case 10:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30209; /* *dual_widen_suburvvmf2si */

    case 11:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30215; /* *dual_widen_suburvvm8di */

    case 12:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30221; /* *dual_widen_suburvvm4di */

    case 13:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30227; /* *dual_widen_suburvvm2di */

    case 14:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30233; /* *dual_widen_suburvvm1di */

    case 15:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 30239; /* *dual_widen_subuv1hi */

    case 16:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 30245; /* *dual_widen_subuv2hi */

    case 17:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 30251; /* *dual_widen_subuv4hi */

    case 18:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 30257; /* *dual_widen_subuv8hi */

    case 19:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 30263; /* *dual_widen_subuv16hi */

    case 20:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30269; /* *dual_widen_subuv32hi */

    case 21:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30275; /* *dual_widen_subuv64hi */

    case 22:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30281; /* *dual_widen_subuv128hi */

    case 23:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30287; /* *dual_widen_subuv256hi */

    case 24:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30293; /* *dual_widen_subuv512hi */

    case 25:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30299; /* *dual_widen_subuv1024hi */

    case 26:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30305; /* *dual_widen_subuv2048hi */

    case 27:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 30311; /* *dual_widen_subuv1si */

    case 28:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 30317; /* *dual_widen_subuv2si */

    case 29:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 30323; /* *dual_widen_subuv4si */

    case 30:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 30329; /* *dual_widen_subuv8si */

    case 31:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30335; /* *dual_widen_subuv16si */

    case 32:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30341; /* *dual_widen_subuv32si */

    case 33:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30347; /* *dual_widen_subuv64si */

    case 34:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30353; /* *dual_widen_subuv128si */

    case 35:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30359; /* *dual_widen_subuv256si */

    case 36:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30365; /* *dual_widen_subuv512si */

    case 37:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30371; /* *dual_widen_subuv1024si */

    case 38:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30377; /* *dual_widen_subuv1di */

    case 39:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30383; /* *dual_widen_subuv2di */

    case 40:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30389; /* *dual_widen_subuv4di */

    case 41:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30395; /* *dual_widen_subuv8di */

    case 42:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30401; /* *dual_widen_subuv16di */

    case 43:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30407; /* *dual_widen_subuv32di */

    case 44:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30413; /* *dual_widen_subuv64di */

    case 45:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30419; /* *dual_widen_subuv128di */

    case 46:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30425; /* *dual_widen_subuv256di */

    case 47:
      if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30431; /* *dual_widen_subuv512di */

    case 48:
      if (!
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30531; /* *single_widen_first_suburvvm8hi */

    case 49:
      if (!
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30533; /* *single_widen_first_suburvvm4hi */

    case 50:
      if (!
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30535; /* *single_widen_first_suburvvm2hi */

    case 51:
      if (!
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30537; /* *single_widen_first_suburvvm1hi */

    case 52:
      if (!
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30539; /* *single_widen_first_suburvvmf2hi */

    case 53:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30541; /* *single_widen_first_suburvvmf4hi */

    case 54:
      if (!
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30543; /* *single_widen_first_suburvvm8si */

    case 55:
      if (!
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30545; /* *single_widen_first_suburvvm4si */

    case 56:
      if (!
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30547; /* *single_widen_first_suburvvm2si */

    case 57:
      if (!
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 30549; /* *single_widen_first_suburvvm1si */

    case 58:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30551; /* *single_widen_first_suburvvmf2si */

    case 59:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30553; /* *single_widen_first_suburvvm8di */

    case 60:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30555; /* *single_widen_first_suburvvm4di */

    case 61:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30557; /* *single_widen_first_suburvvm2di */

    case 62:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30559; /* *single_widen_first_suburvvm1di */

    case 63:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 30561; /* *single_widen_first_subuv1hi */

    case 64:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 30563; /* *single_widen_first_subuv2hi */

    case 65:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 30565; /* *single_widen_first_subuv4hi */

    case 66:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 30567; /* *single_widen_first_subuv8hi */

    case 67:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 30569; /* *single_widen_first_subuv16hi */

    case 68:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30571; /* *single_widen_first_subuv32hi */

    case 69:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30573; /* *single_widen_first_subuv64hi */

    case 70:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30575; /* *single_widen_first_subuv128hi */

    case 71:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30577; /* *single_widen_first_subuv256hi */

    case 72:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30579; /* *single_widen_first_subuv512hi */

    case 73:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30581; /* *single_widen_first_subuv1024hi */

    case 74:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30583; /* *single_widen_first_subuv2048hi */

    case 75:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 30585; /* *single_widen_first_subuv1si */

    case 76:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 30587; /* *single_widen_first_subuv2si */

    case 77:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 30589; /* *single_widen_first_subuv4si */

    case 78:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 30591; /* *single_widen_first_subuv8si */

    case 79:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30593; /* *single_widen_first_subuv16si */

    case 80:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30595; /* *single_widen_first_subuv32si */

    case 81:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30597; /* *single_widen_first_subuv64si */

    case 82:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30599; /* *single_widen_first_subuv128si */

    case 83:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30601; /* *single_widen_first_subuv256si */

    case 84:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30603; /* *single_widen_first_subuv512si */

    case 85:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30605; /* *single_widen_first_subuv1024si */

    case 86:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30607; /* *single_widen_first_subuv1di */

    case 87:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30609; /* *single_widen_first_subuv2di */

    case 88:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 30611; /* *single_widen_first_subuv4di */

    case 89:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 30613; /* *single_widen_first_subuv8di */

    case 90:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 30615; /* *single_widen_first_subuv16di */

    case 91:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 30617; /* *single_widen_first_subuv32di */

    case 92:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 30619; /* *single_widen_first_subuv64di */

    case 93:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 30621; /* *single_widen_first_subuv128di */

    case 94:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 30623; /* *single_widen_first_subuv256di */

    case 95:
      if (!(
#line 652 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 30625; /* *single_widen_first_subuv512di */

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern163 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[2], E_RVVM8SImode)
          && 
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32389; /* *vwsll_zext1_trunc_rvvm8si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32449; /* *vwsll_zext1_trunc_scalar_rvvm8si */

    case 1:
      if (vector_shift_operand (operands[2], E_RVVM4SImode)
          && 
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32390; /* *vwsll_zext1_trunc_rvvm4si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32450; /* *vwsll_zext1_trunc_scalar_rvvm4si */

    case 2:
      if (vector_shift_operand (operands[2], E_RVVM2SImode)
          && 
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32391; /* *vwsll_zext1_trunc_rvvm2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32451; /* *vwsll_zext1_trunc_scalar_rvvm2si */

    case 3:
      if (vector_shift_operand (operands[2], E_RVVM1SImode)
          && 
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32392; /* *vwsll_zext1_trunc_rvvm1si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32452; /* *vwsll_zext1_trunc_scalar_rvvm1si */

    case 4:
      if (vector_shift_operand (operands[2], E_RVVMF2SImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32393; /* *vwsll_zext1_trunc_rvvmf2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32453; /* *vwsll_zext1_trunc_scalar_rvvmf2si */

    case 5:
      if (vector_shift_operand (operands[2], E_RVVM8DImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32394; /* *vwsll_zext1_trunc_rvvm8di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32454; /* *vwsll_zext1_trunc_scalar_rvvm8di */

    case 6:
      if (vector_shift_operand (operands[2], E_RVVM4DImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32395; /* *vwsll_zext1_trunc_rvvm4di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32455; /* *vwsll_zext1_trunc_scalar_rvvm4di */

    case 7:
      if (vector_shift_operand (operands[2], E_RVVM2DImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32396; /* *vwsll_zext1_trunc_rvvm2di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32456; /* *vwsll_zext1_trunc_scalar_rvvm2di */

    case 8:
      if (vector_shift_operand (operands[2], E_RVVM1DImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32397; /* *vwsll_zext1_trunc_rvvm1di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32457; /* *vwsll_zext1_trunc_scalar_rvvm1di */

    case 9:
      if (vector_shift_operand (operands[2], E_V1SImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 32398; /* *vwsll_zext1_trunc_v1si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32458; /* *vwsll_zext1_trunc_scalar_v1si */

    case 10:
      if (vector_shift_operand (operands[2], E_V2SImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 32399; /* *vwsll_zext1_trunc_v2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32459; /* *vwsll_zext1_trunc_scalar_v2si */

    case 11:
      if (vector_shift_operand (operands[2], E_V4SImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 32400; /* *vwsll_zext1_trunc_v4si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32460; /* *vwsll_zext1_trunc_scalar_v4si */

    case 12:
      if (vector_shift_operand (operands[2], E_V8SImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 32401; /* *vwsll_zext1_trunc_v8si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32461; /* *vwsll_zext1_trunc_scalar_v8si */

    case 13:
      if (vector_shift_operand (operands[2], E_V16SImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 32402; /* *vwsll_zext1_trunc_v16si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32462; /* *vwsll_zext1_trunc_scalar_v16si */

    case 14:
      if (vector_shift_operand (operands[2], E_V32SImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 32403; /* *vwsll_zext1_trunc_v32si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32463; /* *vwsll_zext1_trunc_scalar_v32si */

    case 15:
      if (vector_shift_operand (operands[2], E_V64SImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 32404; /* *vwsll_zext1_trunc_v64si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32464; /* *vwsll_zext1_trunc_scalar_v64si */

    case 16:
      if (vector_shift_operand (operands[2], E_V128SImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 32405; /* *vwsll_zext1_trunc_v128si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32465; /* *vwsll_zext1_trunc_scalar_v128si */

    case 17:
      if (vector_shift_operand (operands[2], E_V256SImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 32406; /* *vwsll_zext1_trunc_v256si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32466; /* *vwsll_zext1_trunc_scalar_v256si */

    case 18:
      if (vector_shift_operand (operands[2], E_V512SImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 32407; /* *vwsll_zext1_trunc_v512si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32467; /* *vwsll_zext1_trunc_scalar_v512si */

    case 19:
      if (vector_shift_operand (operands[2], E_V1024SImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 32408; /* *vwsll_zext1_trunc_v1024si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32468; /* *vwsll_zext1_trunc_scalar_v1024si */

    case 20:
      if (vector_shift_operand (operands[2], E_V1DImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 32409; /* *vwsll_zext1_trunc_v1di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32469; /* *vwsll_zext1_trunc_scalar_v1di */

    case 21:
      if (vector_shift_operand (operands[2], E_V2DImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 32410; /* *vwsll_zext1_trunc_v2di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32470; /* *vwsll_zext1_trunc_scalar_v2di */

    case 22:
      if (vector_shift_operand (operands[2], E_V4DImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 32411; /* *vwsll_zext1_trunc_v4di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32471; /* *vwsll_zext1_trunc_scalar_v4di */

    case 23:
      if (vector_shift_operand (operands[2], E_V8DImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 32412; /* *vwsll_zext1_trunc_v8di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32472; /* *vwsll_zext1_trunc_scalar_v8di */

    case 24:
      if (vector_shift_operand (operands[2], E_V16DImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 32413; /* *vwsll_zext1_trunc_v16di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32473; /* *vwsll_zext1_trunc_scalar_v16di */

    case 25:
      if (vector_shift_operand (operands[2], E_V32DImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 32414; /* *vwsll_zext1_trunc_v32di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32474; /* *vwsll_zext1_trunc_scalar_v32di */

    case 26:
      if (vector_shift_operand (operands[2], E_V64DImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 32415; /* *vwsll_zext1_trunc_v64di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32475; /* *vwsll_zext1_trunc_scalar_v64di */

    case 27:
      if (vector_shift_operand (operands[2], E_V128DImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 32416; /* *vwsll_zext1_trunc_v128di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32476; /* *vwsll_zext1_trunc_scalar_v128di */

    case 28:
      if (vector_shift_operand (operands[2], E_V256DImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 32417; /* *vwsll_zext1_trunc_v256di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32477; /* *vwsll_zext1_trunc_scalar_v256di */

    case 29:
      if (vector_shift_operand (operands[2], E_V512DImode)
          && (
#line 1606 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 32418; /* *vwsll_zext1_trunc_v512di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1647 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32478; /* *vwsll_zext1_trunc_scalar_v512di */

    case 30:
      if (!
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32419; /* *vwsll_zext2_trunc_rvvm8si */

    case 31:
      if (!
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32420; /* *vwsll_zext2_trunc_rvvm4si */

    case 32:
      if (!
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32421; /* *vwsll_zext2_trunc_rvvm2si */

    case 33:
      if (!
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32422; /* *vwsll_zext2_trunc_rvvm1si */

    case 34:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32423; /* *vwsll_zext2_trunc_rvvmf2si */

    case 35:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32424; /* *vwsll_zext2_trunc_rvvm8di */

    case 36:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32425; /* *vwsll_zext2_trunc_rvvm4di */

    case 37:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32426; /* *vwsll_zext2_trunc_rvvm2di */

    case 38:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32427; /* *vwsll_zext2_trunc_rvvm1di */

    case 39:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32428; /* *vwsll_zext2_trunc_v1si */

    case 40:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32429; /* *vwsll_zext2_trunc_v2si */

    case 41:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32430; /* *vwsll_zext2_trunc_v4si */

    case 42:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32431; /* *vwsll_zext2_trunc_v8si */

    case 43:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32432; /* *vwsll_zext2_trunc_v16si */

    case 44:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32433; /* *vwsll_zext2_trunc_v32si */

    case 45:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32434; /* *vwsll_zext2_trunc_v64si */

    case 46:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1118 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32435; /* *vwsll_zext2_trunc_v128si */

    case 47:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1119 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32436; /* *vwsll_zext2_trunc_v256si */

    case 48:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1120 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32437; /* *vwsll_zext2_trunc_v512si */

    case 49:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1121 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32438; /* *vwsll_zext2_trunc_v1024si */

    case 50:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1122 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32439; /* *vwsll_zext2_trunc_v1di */

    case 51:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1123 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32440; /* *vwsll_zext2_trunc_v2di */

    case 52:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1124 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32441; /* *vwsll_zext2_trunc_v4di */

    case 53:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1125 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32442; /* *vwsll_zext2_trunc_v8di */

    case 54:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1126 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32443; /* *vwsll_zext2_trunc_v16di */

    case 55:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1127 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32444; /* *vwsll_zext2_trunc_v32di */

    case 56:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1128 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32445; /* *vwsll_zext2_trunc_v64di */

    case 57:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1129 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32446; /* *vwsll_zext2_trunc_v128di */

    case 58:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1130 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32447; /* *vwsll_zext2_trunc_v256di */

    case 59:
      if (!(
#line 1629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 1131 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32448; /* *vwsll_zext2_trunc_v512di */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern241 (x3))
    {
    case 0:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27891; /* copysignrvvm8hf3 */

    case 1:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27892; /* copysignrvvm4hf3 */

    case 2:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27893; /* copysignrvvm2hf3 */

    case 3:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27894; /* copysignrvvm1hf3 */

    case 4:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27895; /* copysignrvvmf2hf3 */

    case 5:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27896; /* copysignrvvmf4hf3 */

    case 6:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27897; /* copysignrvvm8sf3 */

    case 7:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27898; /* copysignrvvm4sf3 */

    case 8:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27899; /* copysignrvvm2sf3 */

    case 9:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27900; /* copysignrvvm1sf3 */

    case 10:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27901; /* copysignrvvmf2sf3 */

    case 11:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27902; /* copysignrvvm8df3 */

    case 12:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27903; /* copysignrvvm4df3 */

    case 13:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27904; /* copysignrvvm2df3 */

    case 14:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27905; /* copysignrvvm1df3 */

    case 15:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27906; /* copysignv1hf3 */

    case 16:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27907; /* copysignv2hf3 */

    case 17:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27908; /* copysignv4hf3 */

    case 18:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27909; /* copysignv8hf3 */

    case 19:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27910; /* copysignv16hf3 */

    case 20:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27911; /* copysignv32hf3 */

    case 21:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27912; /* copysignv64hf3 */

    case 22:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27913; /* copysignv128hf3 */

    case 23:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27914; /* copysignv256hf3 */

    case 24:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27915; /* copysignv512hf3 */

    case 25:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27916; /* copysignv1024hf3 */

    case 26:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27917; /* copysignv2048hf3 */

    case 27:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27918; /* copysignv1sf3 */

    case 28:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27919; /* copysignv2sf3 */

    case 29:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27920; /* copysignv4sf3 */

    case 30:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27921; /* copysignv8sf3 */

    case 31:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27922; /* copysignv16sf3 */

    case 32:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27923; /* copysignv32sf3 */

    case 33:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27924; /* copysignv64sf3 */

    case 34:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27925; /* copysignv128sf3 */

    case 35:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27926; /* copysignv256sf3 */

    case 36:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27927; /* copysignv512sf3 */

    case 37:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27928; /* copysignv1024sf3 */

    case 38:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27929; /* copysignv1df3 */

    case 39:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27930; /* copysignv2df3 */

    case 40:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27931; /* copysignv4df3 */

    case 41:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27932; /* copysignv8df3 */

    case 42:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27933; /* copysignv16df3 */

    case 43:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27934; /* copysignv32df3 */

    case 44:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27935; /* copysignv64df3 */

    case 45:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27936; /* copysignv128df3 */

    case 46:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27937; /* copysignv256df3 */

    case 47:
      if (!(
#line 1623 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27938; /* copysignv512df3 */

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern167 (x1))
    {
    case 0:
      if (!(
#line 3573 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
        return -1;
      return 393; /* flt_quietsfsi4_zfa */

    case 1:
      if (!(
#line 3573 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
        return -1;
      return 397; /* flt_quietdfsi4_zfa */

    case 2:
      if (!(
#line 3573 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
        return -1;
      return 401; /* flt_quiethfsi4_zfa */

    case 3:
      if (!(
#line 3573 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
        return -1;
      return 395; /* flt_quietsfdi4_zfa */

    case 4:
      if (!(
#line 3573 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
        return -1;
      return 399; /* flt_quietdfdi4_zfa */

    case 5:
      if (!(
#line 3573 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT && TARGET_ZFA) && ((
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
        return -1;
      return 403; /* flt_quiethfdi4_zfa */

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      switch (pattern176 ())
        {
        case 0:
          if (!(
#line 3595 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
            return -1;
          return 405; /* fclasssfsi */

        case 1:
          if (!(
#line 3595 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
            return -1;
          return 407; /* fclassdfsi */

        case 2:
          if (!(
#line 3595 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
            return -1;
          return 409; /* fclasshfsi */

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      switch (pattern176 ())
        {
        case 0:
          if (!(
#line 3595 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))))
            return -1;
          return 406; /* fclasssfdi */

        case 1:
          if (!(
#line 3595 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX))))
            return -1;
          return 408; /* fclassdfdi */

        case 2:
          if (!(
#line 3595 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT) && (
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX))))
            return -1;
          return 410; /* fclasshfdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_59 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern589 (x2, 
E_RVVMF16BImode) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF2QImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF2QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !
#line 3496 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8693; /* pred_madcrvvmf2qi_scalar */

    case E_RVVM1HImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM1HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVM1HImode)
          || !
#line 3496 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8699; /* pred_madcrvvm1hi_scalar */

    case E_RVVM2SImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM2SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM2SImode)
          || !
#line 3496 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8704; /* pred_madcrvvm2si_scalar */

    case E_RVVM4DImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM4DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM4DImode)
          || !(
#line 3567 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8798; /* *pred_madcrvvm4di_scalar */

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18671; /* pred_redmax_vl0srvvm8qi */

        case 1:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18679; /* pred_redmax_vl0srvvm4qi */

        case 2:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18687; /* pred_redmax_vl0srvvm2qi */

        case 3:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18695; /* pred_redmax_vl0srvvm1qi */

        case 4:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18799; /* pred_redmax_vl0srvvmf2qi */

        case 5:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18807; /* pred_redmax_vl0srvvmf4qi */

        case 6:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18815; /* pred_redmax_vl0srvvmf8qi */

        case 7:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18847; /* pred_redmax_vl0sv1qi */

        case 8:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18855; /* pred_redmax_vl0sv2qi */

        case 9:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18863; /* pred_redmax_vl0sv4qi */

        case 10:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18871; /* pred_redmax_vl0sv8qi */

        case 11:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18879; /* pred_redmax_vl0sv16qi */

        case 12:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18887; /* pred_redmax_vl0sv32qi */

        case 13:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18895; /* pred_redmax_vl0sv64qi */

        case 14:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18903; /* pred_redmax_vl0sv128qi */

        case 15:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18911; /* pred_redmax_vl0sv256qi */

        case 16:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18919; /* pred_redmax_vl0sv512qi */

        case 17:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18927; /* pred_redmax_vl0sv1024qi */

        case 18:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18935; /* pred_redmax_vl0sv2048qi */

        case 19:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18943; /* pred_redmax_vl0sv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18703; /* pred_redmax_vl0srvvm8hi */

        case 1:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18711; /* pred_redmax_vl0srvvm4hi */

        case 2:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18719; /* pred_redmax_vl0srvvm2hi */

        case 3:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18727; /* pred_redmax_vl0srvvm1hi */

        case 4:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18823; /* pred_redmax_vl0srvvmf2hi */

        case 5:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18831; /* pred_redmax_vl0srvvmf4hi */

        case 6:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18951; /* pred_redmax_vl0sv1hi */

        case 7:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18959; /* pred_redmax_vl0sv2hi */

        case 8:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18967; /* pred_redmax_vl0sv4hi */

        case 9:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18975; /* pred_redmax_vl0sv8hi */

        case 10:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18983; /* pred_redmax_vl0sv16hi */

        case 11:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18991; /* pred_redmax_vl0sv32hi */

        case 12:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18999; /* pred_redmax_vl0sv64hi */

        case 13:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19007; /* pred_redmax_vl0sv128hi */

        case 14:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19015; /* pred_redmax_vl0sv256hi */

        case 15:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19023; /* pred_redmax_vl0sv512hi */

        case 16:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19031; /* pred_redmax_vl0sv1024hi */

        case 17:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19039; /* pred_redmax_vl0sv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18735; /* pred_redmax_vl0srvvm8si */

        case 1:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18743; /* pred_redmax_vl0srvvm4si */

        case 2:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18751; /* pred_redmax_vl0srvvm2si */

        case 3:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18759; /* pred_redmax_vl0srvvm1si */

        case 4:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18839; /* pred_redmax_vl0srvvmf2si */

        case 5:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 19047; /* pred_redmax_vl0sv1si */

        case 6:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 19055; /* pred_redmax_vl0sv2si */

        case 7:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 19063; /* pred_redmax_vl0sv4si */

        case 8:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 19071; /* pred_redmax_vl0sv8si */

        case 9:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19079; /* pred_redmax_vl0sv16si */

        case 10:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19087; /* pred_redmax_vl0sv32si */

        case 11:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19095; /* pred_redmax_vl0sv64si */

        case 12:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19103; /* pred_redmax_vl0sv128si */

        case 13:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19111; /* pred_redmax_vl0sv256si */

        case 14:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19119; /* pred_redmax_vl0sv512si */

        case 15:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19127; /* pred_redmax_vl0sv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18767; /* pred_redmax_vl0srvvm8di */

        case 1:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18775; /* pred_redmax_vl0srvvm4di */

        case 2:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18783; /* pred_redmax_vl0srvvm2di */

        case 3:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18791; /* pred_redmax_vl0srvvm1di */

        case 4:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19135; /* pred_redmax_vl0sv1di */

        case 5:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19143; /* pred_redmax_vl0sv2di */

        case 6:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19151; /* pred_redmax_vl0sv4di */

        case 7:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19159; /* pred_redmax_vl0sv8di */

        case 8:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19167; /* pred_redmax_vl0sv16di */

        case 9:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19175; /* pred_redmax_vl0sv32di */

        case 10:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19183; /* pred_redmax_vl0sv64di */

        case 11:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19191; /* pred_redmax_vl0sv128di */

        case 12:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19199; /* pred_redmax_vl0sv256di */

        case 13:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19207; /* pred_redmax_vl0sv512di */

        default:
          return -1;
        }

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern681 (x2, 
E_RVVM1HFmode))
        {
        case 0:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19525; /* pred_redmax_vl0srvvm8hf */

        case 1:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19527; /* pred_redmax_vl0srvvm4hf */

        case 2:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19529; /* pred_redmax_vl0srvvm2hf */

        case 3:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19531; /* pred_redmax_vl0srvvm1hf */

        case 4:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19533; /* pred_redmax_vl0srvvmf2hf */

        case 5:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19535; /* pred_redmax_vl0srvvmf4hf */

        case 6:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 19555; /* pred_redmax_vl0sv1hf */

        case 7:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 19557; /* pred_redmax_vl0sv2hf */

        case 8:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 19559; /* pred_redmax_vl0sv4hf */

        case 9:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 19561; /* pred_redmax_vl0sv8hf */

        case 10:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 19563; /* pred_redmax_vl0sv16hf */

        case 11:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19565; /* pred_redmax_vl0sv32hf */

        case 12:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19567; /* pred_redmax_vl0sv64hf */

        case 13:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19569; /* pred_redmax_vl0sv128hf */

        case 14:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19571; /* pred_redmax_vl0sv256hf */

        case 15:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19573; /* pred_redmax_vl0sv512hf */

        case 16:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19575; /* pred_redmax_vl0sv1024hf */

        case 17:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19577; /* pred_redmax_vl0sv2048hf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern682 (x2, 
E_RVVM1SFmode))
        {
        case 0:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19537; /* pred_redmax_vl0srvvm8sf */

        case 1:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19539; /* pred_redmax_vl0srvvm4sf */

        case 2:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19541; /* pred_redmax_vl0srvvm2sf */

        case 3:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19543; /* pred_redmax_vl0srvvm1sf */

        case 4:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19545; /* pred_redmax_vl0srvvmf2sf */

        case 5:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19579; /* pred_redmax_vl0sv1sf */

        case 6:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19581; /* pred_redmax_vl0sv2sf */

        case 7:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19583; /* pred_redmax_vl0sv4sf */

        case 8:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19585; /* pred_redmax_vl0sv8sf */

        case 9:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19587; /* pred_redmax_vl0sv16sf */

        case 10:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19589; /* pred_redmax_vl0sv32sf */

        case 11:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19591; /* pred_redmax_vl0sv64sf */

        case 12:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19593; /* pred_redmax_vl0sv128sf */

        case 13:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19595; /* pred_redmax_vl0sv256sf */

        case 14:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19597; /* pred_redmax_vl0sv512sf */

        case 15:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19599; /* pred_redmax_vl0sv1024sf */

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      switch (pattern683 (x2))
        {
        case 0:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19547; /* pred_redmax_vl0srvvm8df */

        case 1:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19549; /* pred_redmax_vl0srvvm4df */

        case 2:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19551; /* pred_redmax_vl0srvvm2df */

        case 3:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19553; /* pred_redmax_vl0srvvm1df */

        case 4:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19601; /* pred_redmax_vl0sv1df */

        case 5:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19603; /* pred_redmax_vl0sv2df */

        case 6:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19605; /* pred_redmax_vl0sv4df */

        case 7:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19607; /* pred_redmax_vl0sv8df */

        case 8:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19609; /* pred_redmax_vl0sv16df */

        case 9:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19611; /* pred_redmax_vl0sv32df */

        case 10:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19613; /* pred_redmax_vl0sv64df */

        case 11:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19615; /* pred_redmax_vl0sv128df */

        case 12:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19617; /* pred_redmax_vl0sv256df */

        case 13:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19619; /* pred_redmax_vl0sv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18128; /* pred_redminurvvm8qi */

        case 1:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18136; /* pred_redminurvvm4qi */

        case 2:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18144; /* pred_redminurvvm2qi */

        case 3:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18152; /* pred_redminurvvm1qi */

        case 4:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18256; /* pred_redminurvvmf2qi */

        case 5:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18264; /* pred_redminurvvmf4qi */

        case 6:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18272; /* pred_redminurvvmf8qi */

        case 7:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18304; /* pred_redminuv1qi */

        case 8:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18312; /* pred_redminuv2qi */

        case 9:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18320; /* pred_redminuv4qi */

        case 10:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18328; /* pred_redminuv8qi */

        case 11:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18336; /* pred_redminuv16qi */

        case 12:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18344; /* pred_redminuv32qi */

        case 13:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18352; /* pred_redminuv64qi */

        case 14:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18360; /* pred_redminuv128qi */

        case 15:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18368; /* pred_redminuv256qi */

        case 16:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18376; /* pred_redminuv512qi */

        case 17:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18384; /* pred_redminuv1024qi */

        case 18:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18392; /* pred_redminuv2048qi */

        case 19:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18400; /* pred_redminuv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18160; /* pred_redminurvvm8hi */

        case 1:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18168; /* pred_redminurvvm4hi */

        case 2:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18176; /* pred_redminurvvm2hi */

        case 3:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18184; /* pred_redminurvvm1hi */

        case 4:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18280; /* pred_redminurvvmf2hi */

        case 5:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18288; /* pred_redminurvvmf4hi */

        case 6:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18408; /* pred_redminuv1hi */

        case 7:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18416; /* pred_redminuv2hi */

        case 8:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18424; /* pred_redminuv4hi */

        case 9:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18432; /* pred_redminuv8hi */

        case 10:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18440; /* pred_redminuv16hi */

        case 11:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18448; /* pred_redminuv32hi */

        case 12:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18456; /* pred_redminuv64hi */

        case 13:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18464; /* pred_redminuv128hi */

        case 14:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18472; /* pred_redminuv256hi */

        case 15:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18480; /* pred_redminuv512hi */

        case 16:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18488; /* pred_redminuv1024hi */

        case 17:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18496; /* pred_redminuv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18192; /* pred_redminurvvm8si */

        case 1:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18200; /* pred_redminurvvm4si */

        case 2:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18208; /* pred_redminurvvm2si */

        case 3:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18216; /* pred_redminurvvm1si */

        case 4:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18296; /* pred_redminurvvmf2si */

        case 5:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18504; /* pred_redminuv1si */

        case 6:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18512; /* pred_redminuv2si */

        case 7:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18520; /* pred_redminuv4si */

        case 8:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18528; /* pred_redminuv8si */

        case 9:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18536; /* pred_redminuv16si */

        case 10:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18544; /* pred_redminuv32si */

        case 11:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18552; /* pred_redminuv64si */

        case 12:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18560; /* pred_redminuv128si */

        case 13:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18568; /* pred_redminuv256si */

        case 14:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18576; /* pred_redminuv512si */

        case 15:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18584; /* pred_redminuv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18224; /* pred_redminurvvm8di */

        case 1:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18232; /* pred_redminurvvm4di */

        case 2:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18240; /* pred_redminurvvm2di */

        case 3:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18248; /* pred_redminurvvm1di */

        case 4:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18592; /* pred_redminuv1di */

        case 5:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18600; /* pred_redminuv2di */

        case 6:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18608; /* pred_redminuv4di */

        case 7:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18616; /* pred_redminuv8di */

        case 8:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18624; /* pred_redminuv16di */

        case 9:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18632; /* pred_redminuv32di */

        case 10:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18640; /* pred_redminuv64di */

        case 11:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18648; /* pred_redminuv128di */

        case 12:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18656; /* pred_redminuv256di */

        case 13:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18664; /* pred_redminuv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (pattern361 (x3) != 0)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[5] = x5;
  if (!vector_length_operand (operands[5], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[6] = x6;
  if (!const_int_operand (operands[6], E_VOIDmode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[7] = x7;
  if (!const_int_operand (operands[7], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x2, 0, 1);
  switch (XINT (x8, 1))
    {
    case 143:
      return recog_78 (x1, insn, pnum_clobbers);

    case 149:
      return recog_77 (x1, insn, pnum_clobbers);

    case 150:
      return recog_66 (x1, insn, pnum_clobbers);

    case 151:
      return recog_76 (x1, insn, pnum_clobbers);

    case 152:
      return recog_65 (x1, insn, pnum_clobbers);

    case 153:
      return recog_75 (x1, insn, pnum_clobbers);

    case 154:
      return recog_74 (x1, insn, pnum_clobbers);

    case 155:
      return recog_73 (x1, insn, pnum_clobbers);

    case 144:
      return recog_72 (x1, insn, pnum_clobbers);

    case 156:
      return recog_71 (x1, insn, pnum_clobbers);

    case 157:
      return recog_64 (x1, insn, pnum_clobbers);

    case 158:
      return recog_70 (x1, insn, pnum_clobbers);

    case 159:
      return recog_63 (x1, insn, pnum_clobbers);

    case 160:
      return recog_69 (x1, insn, pnum_clobbers);

    case 161:
      return recog_68 (x1, insn, pnum_clobbers);

    case 162:
      return recog_67 (x1, insn, pnum_clobbers);

    case 163:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM1HImode:
          switch (pattern677 (x2, 
E_RVVM1HImode))
            {
            case 0:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19213; /* pred_wredsumrvvm8qi */

            case 1:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19215; /* pred_wredsumrvvm4qi */

            case 2:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19217; /* pred_wredsumrvvm2qi */

            case 3:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19219; /* pred_wredsumrvvm1qi */

            case 4:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19221; /* pred_wredsumrvvmf2qi */

            case 5:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19223; /* pred_wredsumrvvmf4qi */

            case 6:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 19225; /* pred_wredsumrvvmf8qi */

            case 7:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 19249; /* pred_wredsumv1qi */

            case 8:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 19251; /* pred_wredsumv2qi */

            case 9:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 19253; /* pred_wredsumv4qi */

            case 10:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 19255; /* pred_wredsumv8qi */

            case 11:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 19257; /* pred_wredsumv16qi */

            case 12:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 19259; /* pred_wredsumv32qi */

            case 13:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19261; /* pred_wredsumv64qi */

            case 14:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19263; /* pred_wredsumv128qi */

            case 15:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19265; /* pred_wredsumv256qi */

            case 16:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19267; /* pred_wredsumv512qi */

            case 17:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19269; /* pred_wredsumv1024qi */

            case 18:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19271; /* pred_wredsumv2048qi */

            case 19:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19273; /* pred_wredsumv4096qi */

            default:
              return -1;
            }

        case E_RVVM1SImode:
          switch (pattern678 (x2, 
E_RVVM1SImode))
            {
            case 0:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19227; /* pred_wredsumrvvm8hi */

            case 1:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19229; /* pred_wredsumrvvm4hi */

            case 2:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19231; /* pred_wredsumrvvm2hi */

            case 3:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19233; /* pred_wredsumrvvm1hi */

            case 4:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19235; /* pred_wredsumrvvmf2hi */

            case 5:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 19237; /* pred_wredsumrvvmf4hi */

            case 6:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 19275; /* pred_wredsumv1hi */

            case 7:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 19277; /* pred_wredsumv2hi */

            case 8:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 19279; /* pred_wredsumv4hi */

            case 9:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 19281; /* pred_wredsumv8hi */

            case 10:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 19283; /* pred_wredsumv16hi */

            case 11:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19285; /* pred_wredsumv32hi */

            case 12:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19287; /* pred_wredsumv64hi */

            case 13:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19289; /* pred_wredsumv128hi */

            case 14:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19291; /* pred_wredsumv256hi */

            case 15:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19293; /* pred_wredsumv512hi */

            case 16:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19295; /* pred_wredsumv1024hi */

            case 17:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19297; /* pred_wredsumv2048hi */

            default:
              return -1;
            }

        case E_RVVM1DImode:
          switch (pattern679 (x2, 
E_RVVM1DImode))
            {
            case 0:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19239; /* pred_wredsumrvvm8si */

            case 1:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19241; /* pred_wredsumrvvm4si */

            case 2:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19243; /* pred_wredsumrvvm2si */

            case 3:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19245; /* pred_wredsumrvvm1si */

            case 4:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 19247; /* pred_wredsumrvvmf2si */

            case 5:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 19299; /* pred_wredsumv1si */

            case 6:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 19301; /* pred_wredsumv2si */

            case 7:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 19303; /* pred_wredsumv4si */

            case 8:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 19305; /* pred_wredsumv8si */

            case 9:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19307; /* pred_wredsumv16si */

            case 10:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19309; /* pred_wredsumv32si */

            case 11:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19311; /* pred_wredsumv64si */

            case 12:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19313; /* pred_wredsumv128si */

            case 13:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19315; /* pred_wredsumv256si */

            case 14:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19317; /* pred_wredsumv512si */

            case 15:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19319; /* pred_wredsumv1024si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 164:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM1HImode:
          switch (pattern677 (x2, 
E_RVVM1HImode))
            {
            case 0:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19214; /* pred_wredsumurvvm8qi */

            case 1:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19216; /* pred_wredsumurvvm4qi */

            case 2:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19218; /* pred_wredsumurvvm2qi */

            case 3:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19220; /* pred_wredsumurvvm1qi */

            case 4:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19222; /* pred_wredsumurvvmf2qi */

            case 5:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19224; /* pred_wredsumurvvmf4qi */

            case 6:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 19226; /* pred_wredsumurvvmf8qi */

            case 7:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 19250; /* pred_wredsumuv1qi */

            case 8:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 19252; /* pred_wredsumuv2qi */

            case 9:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 19254; /* pred_wredsumuv4qi */

            case 10:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 19256; /* pred_wredsumuv8qi */

            case 11:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 19258; /* pred_wredsumuv16qi */

            case 12:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 19260; /* pred_wredsumuv32qi */

            case 13:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19262; /* pred_wredsumuv64qi */

            case 14:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19264; /* pred_wredsumuv128qi */

            case 15:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19266; /* pred_wredsumuv256qi */

            case 16:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19268; /* pred_wredsumuv512qi */

            case 17:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19270; /* pred_wredsumuv1024qi */

            case 18:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19272; /* pred_wredsumuv2048qi */

            case 19:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19274; /* pred_wredsumuv4096qi */

            default:
              return -1;
            }

        case E_RVVM1SImode:
          switch (pattern678 (x2, 
E_RVVM1SImode))
            {
            case 0:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19228; /* pred_wredsumurvvm8hi */

            case 1:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19230; /* pred_wredsumurvvm4hi */

            case 2:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19232; /* pred_wredsumurvvm2hi */

            case 3:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19234; /* pred_wredsumurvvm1hi */

            case 4:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19236; /* pred_wredsumurvvmf2hi */

            case 5:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 19238; /* pred_wredsumurvvmf4hi */

            case 6:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 19276; /* pred_wredsumuv1hi */

            case 7:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 19278; /* pred_wredsumuv2hi */

            case 8:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 19280; /* pred_wredsumuv4hi */

            case 9:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 19282; /* pred_wredsumuv8hi */

            case 10:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 19284; /* pred_wredsumuv16hi */

            case 11:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19286; /* pred_wredsumuv32hi */

            case 12:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19288; /* pred_wredsumuv64hi */

            case 13:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19290; /* pred_wredsumuv128hi */

            case 14:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19292; /* pred_wredsumuv256hi */

            case 15:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19294; /* pred_wredsumuv512hi */

            case 16:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19296; /* pred_wredsumuv1024hi */

            case 17:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19298; /* pred_wredsumuv2048hi */

            default:
              return -1;
            }

        case E_RVVM1DImode:
          switch (pattern679 (x2, 
E_RVVM1DImode))
            {
            case 0:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19240; /* pred_wredsumurvvm8si */

            case 1:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19242; /* pred_wredsumurvvm4si */

            case 2:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19244; /* pred_wredsumurvvm2si */

            case 3:
              if (!
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19246; /* pred_wredsumurvvm1si */

            case 4:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 19248; /* pred_wredsumurvvmf2si */

            case 5:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 19300; /* pred_wredsumuv1si */

            case 6:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 19302; /* pred_wredsumuv2si */

            case 7:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 19304; /* pred_wredsumuv4si */

            case 8:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 19306; /* pred_wredsumuv8si */

            case 9:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19308; /* pred_wredsumuv16si */

            case 10:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19310; /* pred_wredsumuv32si */

            case 11:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19312; /* pred_wredsumuv64si */

            case 12:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19314; /* pred_wredsumuv128si */

            case 13:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19316; /* pred_wredsumuv256si */

            case 14:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19318; /* pred_wredsumuv512si */

            case 15:
              if (!(
#line 7824 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19320; /* pred_wredsumuv1024si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 165:
      return recog_79 (x1, insn, pnum_clobbers);

    case 166:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM1HImode:
          switch (pattern677 (x2, 
E_RVVM1HImode))
            {
            case 0:
              if (!
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19322; /* pred_wredsumu_vl0srvvm8qi */

            case 1:
              if (!
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19324; /* pred_wredsumu_vl0srvvm4qi */

            case 2:
              if (!
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19326; /* pred_wredsumu_vl0srvvm2qi */

            case 3:
              if (!
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19328; /* pred_wredsumu_vl0srvvm1qi */

            case 4:
              if (!
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19330; /* pred_wredsumu_vl0srvvmf2qi */

            case 5:
              if (!
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19332; /* pred_wredsumu_vl0srvvmf4qi */

            case 6:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 19334; /* pred_wredsumu_vl0srvvmf8qi */

            case 7:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 19358; /* pred_wredsumu_vl0sv1qi */

            case 8:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 19360; /* pred_wredsumu_vl0sv2qi */

            case 9:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 19362; /* pred_wredsumu_vl0sv4qi */

            case 10:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 19364; /* pred_wredsumu_vl0sv8qi */

            case 11:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 19366; /* pred_wredsumu_vl0sv16qi */

            case 12:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 19368; /* pred_wredsumu_vl0sv32qi */

            case 13:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19370; /* pred_wredsumu_vl0sv64qi */

            case 14:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19372; /* pred_wredsumu_vl0sv128qi */

            case 15:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19374; /* pred_wredsumu_vl0sv256qi */

            case 16:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19376; /* pred_wredsumu_vl0sv512qi */

            case 17:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19378; /* pred_wredsumu_vl0sv1024qi */

            case 18:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19380; /* pred_wredsumu_vl0sv2048qi */

            case 19:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19382; /* pred_wredsumu_vl0sv4096qi */

            default:
              return -1;
            }

        case E_RVVM1SImode:
          switch (pattern678 (x2, 
E_RVVM1SImode))
            {
            case 0:
              if (!
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19336; /* pred_wredsumu_vl0srvvm8hi */

            case 1:
              if (!
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19338; /* pred_wredsumu_vl0srvvm4hi */

            case 2:
              if (!
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19340; /* pred_wredsumu_vl0srvvm2hi */

            case 3:
              if (!
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19342; /* pred_wredsumu_vl0srvvm1hi */

            case 4:
              if (!
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19344; /* pred_wredsumu_vl0srvvmf2hi */

            case 5:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 19346; /* pred_wredsumu_vl0srvvmf4hi */

            case 6:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 19384; /* pred_wredsumu_vl0sv1hi */

            case 7:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 19386; /* pred_wredsumu_vl0sv2hi */

            case 8:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 19388; /* pred_wredsumu_vl0sv4hi */

            case 9:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 19390; /* pred_wredsumu_vl0sv8hi */

            case 10:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 19392; /* pred_wredsumu_vl0sv16hi */

            case 11:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19394; /* pred_wredsumu_vl0sv32hi */

            case 12:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19396; /* pred_wredsumu_vl0sv64hi */

            case 13:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19398; /* pred_wredsumu_vl0sv128hi */

            case 14:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19400; /* pred_wredsumu_vl0sv256hi */

            case 15:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19402; /* pred_wredsumu_vl0sv512hi */

            case 16:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19404; /* pred_wredsumu_vl0sv1024hi */

            case 17:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19406; /* pred_wredsumu_vl0sv2048hi */

            default:
              return -1;
            }

        case E_RVVM1DImode:
          switch (pattern679 (x2, 
E_RVVM1DImode))
            {
            case 0:
              if (!
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19348; /* pred_wredsumu_vl0srvvm8si */

            case 1:
              if (!
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19350; /* pred_wredsumu_vl0srvvm4si */

            case 2:
              if (!
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19352; /* pred_wredsumu_vl0srvvm2si */

            case 3:
              if (!
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 19354; /* pred_wredsumu_vl0srvvm1si */

            case 4:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 19356; /* pred_wredsumu_vl0srvvmf2si */

            case 5:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 19408; /* pred_wredsumu_vl0sv1si */

            case 6:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 19410; /* pred_wredsumu_vl0sv2si */

            case 7:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 19412; /* pred_wredsumu_vl0sv4si */

            case 8:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 19414; /* pred_wredsumu_vl0sv8si */

            case 9:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 19416; /* pred_wredsumu_vl0sv16si */

            case 10:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 19418; /* pred_wredsumu_vl0sv32si */

            case 11:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 19420; /* pred_wredsumu_vl0sv64si */

            case 12:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 19422; /* pred_wredsumu_vl0sv128si */

            case 13:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 19424; /* pred_wredsumu_vl0sv256si */

            case 14:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 19426; /* pred_wredsumu_vl0sv512si */

            case 15:
              if (!(
#line 7846 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 19428; /* pred_wredsumu_vl0sv1024si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern193 (x1))
    {
    case 0:
      if (!
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20079; /* pred_slideuprvvm8qi */

    case 1:
      if (!
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20081; /* pred_slideuprvvm4qi */

    case 2:
      if (!
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20083; /* pred_slideuprvvm2qi */

    case 3:
      if (!
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20085; /* pred_slideuprvvm1qi */

    case 4:
      if (!
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20087; /* pred_slideuprvvm8hi */

    case 5:
      if (!
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20089; /* pred_slideuprvvm4hi */

    case 6:
      if (!
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20091; /* pred_slideuprvvm2hi */

    case 7:
      if (!
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20093; /* pred_slideuprvvm1hi */

    case 8:
      if (!
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20095; /* pred_slideuprvvm8si */

    case 9:
      if (!
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20097; /* pred_slideuprvvm4si */

    case 10:
      if (!
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20099; /* pred_slideuprvvm2si */

    case 11:
      if (!
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 20101; /* pred_slideuprvvm1si */

    case 12:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20103; /* pred_slideuprvvm8di */

    case 13:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20105; /* pred_slideuprvvm4di */

    case 14:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20107; /* pred_slideuprvvm2di */

    case 15:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20109; /* pred_slideuprvvm1di */

    case 16:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 20111; /* pred_slideuprvvmf2qi */

    case 17:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 20113; /* pred_slideuprvvmf4qi */

    case 18:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 20115; /* pred_slideuprvvmf8qi */

    case 19:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 20117; /* pred_slideuprvvmf2hi */

    case 20:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 20119; /* pred_slideuprvvmf4hi */

    case 21:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 20121; /* pred_slideuprvvmf2si */

    case 22:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20123; /* pred_slideuprvvm8bf */

    case 23:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20125; /* pred_slideuprvvm4bf */

    case 24:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20127; /* pred_slideuprvvm2bf */

    case 25:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20129; /* pred_slideuprvvm1bf */

    case 26:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 20131; /* pred_slideuprvvmf2bf */

    case 27:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20133; /* pred_slideuprvvmf4bf */

    case 28:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20135; /* pred_slideuprvvm8hf */

    case 29:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20137; /* pred_slideuprvvm4hf */

    case 30:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20139; /* pred_slideuprvvm2hf */

    case 31:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20141; /* pred_slideuprvvm1hf */

    case 32:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20143; /* pred_slideuprvvmf2hf */

    case 33:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20145; /* pred_slideuprvvmf4hf */

    case 34:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20147; /* pred_slideuprvvm8sf */

    case 35:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20149; /* pred_slideuprvvm4sf */

    case 36:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20151; /* pred_slideuprvvm2sf */

    case 37:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20153; /* pred_slideuprvvm1sf */

    case 38:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20155; /* pred_slideuprvvmf2sf */

    case 39:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20157; /* pred_slideuprvvm8df */

    case 40:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20159; /* pred_slideuprvvm4df */

    case 41:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20161; /* pred_slideuprvvm2df */

    case 42:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20163; /* pred_slideuprvvm1df */

    case 43:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 20165; /* pred_slideupv1qi */

    case 44:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 20167; /* pred_slideupv2qi */

    case 45:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 20169; /* pred_slideupv4qi */

    case 46:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 20171; /* pred_slideupv8qi */

    case 47:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 20173; /* pred_slideupv16qi */

    case 48:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 20175; /* pred_slideupv32qi */

    case 49:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20177; /* pred_slideupv64qi */

    case 50:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20179; /* pred_slideupv128qi */

    case 51:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20181; /* pred_slideupv256qi */

    case 52:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20183; /* pred_slideupv512qi */

    case 53:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20185; /* pred_slideupv1024qi */

    case 54:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20187; /* pred_slideupv2048qi */

    case 55:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20189; /* pred_slideupv4096qi */

    case 56:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 20191; /* pred_slideupv1hi */

    case 57:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 20193; /* pred_slideupv2hi */

    case 58:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 20195; /* pred_slideupv4hi */

    case 59:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 20197; /* pred_slideupv8hi */

    case 60:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 20199; /* pred_slideupv16hi */

    case 61:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20201; /* pred_slideupv32hi */

    case 62:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20203; /* pred_slideupv64hi */

    case 63:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20205; /* pred_slideupv128hi */

    case 64:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20207; /* pred_slideupv256hi */

    case 65:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20209; /* pred_slideupv512hi */

    case 66:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20211; /* pred_slideupv1024hi */

    case 67:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20213; /* pred_slideupv2048hi */

    case 68:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 20215; /* pred_slideupv1si */

    case 69:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 20217; /* pred_slideupv2si */

    case 70:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 20219; /* pred_slideupv4si */

    case 71:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 20221; /* pred_slideupv8si */

    case 72:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20223; /* pred_slideupv16si */

    case 73:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20225; /* pred_slideupv32si */

    case 74:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20227; /* pred_slideupv64si */

    case 75:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20229; /* pred_slideupv128si */

    case 76:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20231; /* pred_slideupv256si */

    case 77:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20233; /* pred_slideupv512si */

    case 78:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20235; /* pred_slideupv1024si */

    case 79:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20237; /* pred_slideupv1di */

    case 80:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20239; /* pred_slideupv2di */

    case 81:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 20241; /* pred_slideupv4di */

    case 82:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20243; /* pred_slideupv8di */

    case 83:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20245; /* pred_slideupv16di */

    case 84:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20247; /* pred_slideupv32di */

    case 85:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20249; /* pred_slideupv64di */

    case 86:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20251; /* pred_slideupv128di */

    case 87:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20253; /* pred_slideupv256di */

    case 88:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20255; /* pred_slideupv512di */

    case 89:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20257; /* pred_slideupv1hf */

    case 90:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20259; /* pred_slideupv2hf */

    case 91:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20261; /* pred_slideupv4hf */

    case 92:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20263; /* pred_slideupv8hf */

    case 93:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 20265; /* pred_slideupv16hf */

    case 94:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20267; /* pred_slideupv32hf */

    case 95:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20269; /* pred_slideupv64hf */

    case 96:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20271; /* pred_slideupv128hf */

    case 97:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20273; /* pred_slideupv256hf */

    case 98:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20275; /* pred_slideupv512hf */

    case 99:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20277; /* pred_slideupv1024hf */

    case 100:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20279; /* pred_slideupv2048hf */

    case 101:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20281; /* pred_slideupv1sf */

    case 102:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20283; /* pred_slideupv2sf */

    case 103:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20285; /* pred_slideupv4sf */

    case 104:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 20287; /* pred_slideupv8sf */

    case 105:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20289; /* pred_slideupv16sf */

    case 106:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20291; /* pred_slideupv32sf */

    case 107:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20293; /* pred_slideupv64sf */

    case 108:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20295; /* pred_slideupv128sf */

    case 109:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20297; /* pred_slideupv256sf */

    case 110:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 293 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20299; /* pred_slideupv512sf */

    case 111:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20301; /* pred_slideupv1024sf */

    case 112:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20303; /* pred_slideupv1df */

    case 113:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20305; /* pred_slideupv2df */

    case 114:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 20307; /* pred_slideupv4df */

    case 115:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 20309; /* pred_slideupv8df */

    case 116:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 20311; /* pred_slideupv16df */

    case 117:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 20313; /* pred_slideupv32df */

    case 118:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 20315; /* pred_slideupv64df */

    case 119:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 20317; /* pred_slideupv128df */

    case 120:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 20319; /* pred_slideupv256df */

    case 121:
      if (!(
#line 8114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 20321; /* pred_slideupv512df */

    default:
      return -1;
    }
}

 int
recog_110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      if (arith_operand (operands[2], E_SImode))
        {
          if (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
            return 108; /* *xorsi3 */
          if (
#line 1771 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return 113; /* *xorsi3_internal */
        }
      if (single_bit_mask_operand (operands[2], E_SImode)
          && (
#line 791 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return 622; /* *binvisi */
      if (!uimm_extra_bit_or_twobits (operands[2], E_SImode)
          || !(
#line 1022 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && !single_bit_mask_operand (operands[2], VOIDmode)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return -1;
      return 645; /* *xorisi_extrabit */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      if (arith_operand (operands[2], E_DImode)
          && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
        return 110; /* *xordi3 */
      if (single_bit_mask_operand (operands[2], E_DImode)
          && (
#line 791 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return 624; /* *binvidi */
      if (!uimm_extra_bit_or_twobits (operands[2], E_DImode)
          || !(
#line 1022 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && !single_bit_mask_operand (operands[2], VOIDmode)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 647; /* *xoridi_extrabit */

    case E_HImode:
      switch (pattern337 (x2))
        {
        case 0:
          return 282; /* *xorhihi3 */

        case 1:
          return 283; /* *xorsihi3 */

        default:
          return -1;
        }

    case E_RVVM8QImode:
      if (pattern233 (x2, 
E_RVVM8QImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24545; /* xorrvvm8qi3 */

    case E_RVVM4QImode:
      if (pattern233 (x2, 
E_RVVM4QImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24559; /* xorrvvm4qi3 */

    case E_RVVM2QImode:
      if (pattern233 (x2, 
E_RVVM2QImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24573; /* xorrvvm2qi3 */

    case E_RVVM1QImode:
      if (pattern233 (x2, 
E_RVVM1QImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24587; /* xorrvvm1qi3 */

    case E_RVVM8HImode:
      if (pattern233 (x2, 
E_RVVM8HImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24601; /* xorrvvm8hi3 */

    case E_RVVM4HImode:
      if (pattern233 (x2, 
E_RVVM4HImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24615; /* xorrvvm4hi3 */

    case E_RVVM2HImode:
      if (pattern233 (x2, 
E_RVVM2HImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24629; /* xorrvvm2hi3 */

    case E_RVVM1HImode:
      if (pattern233 (x2, 
E_RVVM1HImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24643; /* xorrvvm1hi3 */

    case E_RVVM8SImode:
      if (pattern233 (x2, 
E_RVVM8SImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24657; /* xorrvvm8si3 */

    case E_RVVM4SImode:
      if (pattern233 (x2, 
E_RVVM4SImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24671; /* xorrvvm4si3 */

    case E_RVVM2SImode:
      if (pattern233 (x2, 
E_RVVM2SImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24685; /* xorrvvm2si3 */

    case E_RVVM1SImode:
      if (pattern233 (x2, 
E_RVVM1SImode) != 0
          || !
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24699; /* xorrvvm1si3 */

    case E_RVVM8DImode:
      if (pattern233 (x2, 
E_RVVM8DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24713; /* xorrvvm8di3 */

    case E_RVVM4DImode:
      if (pattern233 (x2, 
E_RVVM4DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24727; /* xorrvvm4di3 */

    case E_RVVM2DImode:
      if (pattern233 (x2, 
E_RVVM2DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24741; /* xorrvvm2di3 */

    case E_RVVM1DImode:
      if (pattern233 (x2, 
E_RVVM1DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24755; /* xorrvvm1di3 */

    case E_RVVMF2QImode:
      if (pattern233 (x2, 
E_RVVMF2QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24769; /* xorrvvmf2qi3 */

    case E_RVVMF4QImode:
      if (pattern233 (x2, 
E_RVVMF4QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24783; /* xorrvvmf4qi3 */

    case E_RVVMF8QImode:
      if (pattern233 (x2, 
E_RVVMF8QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24797; /* xorrvvmf8qi3 */

    case E_RVVMF2HImode:
      if (pattern233 (x2, 
E_RVVMF2HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24811; /* xorrvvmf2hi3 */

    case E_RVVMF4HImode:
      if (pattern233 (x2, 
E_RVVMF4HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24825; /* xorrvvmf4hi3 */

    case E_RVVMF2SImode:
      if (pattern233 (x2, 
E_RVVMF2SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24839; /* xorrvvmf2si3 */

    case E_V1QImode:
      if (pattern233 (x2, 
E_V1QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24853; /* xorv1qi3 */

    case E_V2QImode:
      if (pattern233 (x2, 
E_V2QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24867; /* xorv2qi3 */

    case E_V4QImode:
      if (pattern233 (x2, 
E_V4QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24881; /* xorv4qi3 */

    case E_V8QImode:
      if (pattern233 (x2, 
E_V8QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24895; /* xorv8qi3 */

    case E_V16QImode:
      if (pattern233 (x2, 
E_V16QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24909; /* xorv16qi3 */

    case E_V32QImode:
      if (pattern233 (x2, 
E_V32QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24923; /* xorv32qi3 */

    case E_V64QImode:
      if (pattern233 (x2, 
E_V64QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24937; /* xorv64qi3 */

    case E_V128QImode:
      if (pattern233 (x2, 
E_V128QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24951; /* xorv128qi3 */

    case E_V256QImode:
      if (pattern233 (x2, 
E_V256QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24965; /* xorv256qi3 */

    case E_V512QImode:
      if (pattern233 (x2, 
E_V512QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24979; /* xorv512qi3 */

    case E_V1024QImode:
      if (pattern233 (x2, 
E_V1024QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 24993; /* xorv1024qi3 */

    case E_V2048QImode:
      if (pattern233 (x2, 
E_V2048QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25007; /* xorv2048qi3 */

    case E_V4096QImode:
      if (pattern233 (x2, 
E_V4096QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25021; /* xorv4096qi3 */

    case E_V1HImode:
      if (pattern233 (x2, 
E_V1HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25035; /* xorv1hi3 */

    case E_V2HImode:
      if (pattern233 (x2, 
E_V2HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25049; /* xorv2hi3 */

    case E_V4HImode:
      if (pattern233 (x2, 
E_V4HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25063; /* xorv4hi3 */

    case E_V8HImode:
      if (pattern233 (x2, 
E_V8HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25077; /* xorv8hi3 */

    case E_V16HImode:
      if (pattern233 (x2, 
E_V16HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25091; /* xorv16hi3 */

    case E_V32HImode:
      if (pattern233 (x2, 
E_V32HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25105; /* xorv32hi3 */

    case E_V64HImode:
      if (pattern233 (x2, 
E_V64HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25119; /* xorv64hi3 */

    case E_V128HImode:
      if (pattern233 (x2, 
E_V128HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25133; /* xorv128hi3 */

    case E_V256HImode:
      if (pattern233 (x2, 
E_V256HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25147; /* xorv256hi3 */

    case E_V512HImode:
      if (pattern233 (x2, 
E_V512HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25161; /* xorv512hi3 */

    case E_V1024HImode:
      if (pattern233 (x2, 
E_V1024HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25175; /* xorv1024hi3 */

    case E_V2048HImode:
      if (pattern233 (x2, 
E_V2048HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25189; /* xorv2048hi3 */

    case E_V1SImode:
      if (pattern233 (x2, 
E_V1SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25203; /* xorv1si3 */

    case E_V2SImode:
      if (pattern233 (x2, 
E_V2SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25217; /* xorv2si3 */

    case E_V4SImode:
      if (pattern233 (x2, 
E_V4SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25231; /* xorv4si3 */

    case E_V8SImode:
      if (pattern233 (x2, 
E_V8SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25245; /* xorv8si3 */

    case E_V16SImode:
      if (pattern233 (x2, 
E_V16SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25259; /* xorv16si3 */

    case E_V32SImode:
      if (pattern233 (x2, 
E_V32SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25273; /* xorv32si3 */

    case E_V64SImode:
      if (pattern233 (x2, 
E_V64SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25287; /* xorv64si3 */

    case E_V128SImode:
      if (pattern233 (x2, 
E_V128SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25301; /* xorv128si3 */

    case E_V256SImode:
      if (pattern233 (x2, 
E_V256SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25315; /* xorv256si3 */

    case E_V512SImode:
      if (pattern233 (x2, 
E_V512SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25329; /* xorv512si3 */

    case E_V1024SImode:
      if (pattern233 (x2, 
E_V1024SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25343; /* xorv1024si3 */

    case E_V1DImode:
      if (pattern233 (x2, 
E_V1DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25357; /* xorv1di3 */

    case E_V2DImode:
      if (pattern233 (x2, 
E_V2DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25371; /* xorv2di3 */

    case E_V4DImode:
      if (pattern233 (x2, 
E_V4DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25385; /* xorv4di3 */

    case E_V8DImode:
      if (pattern233 (x2, 
E_V8DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25399; /* xorv8di3 */

    case E_V16DImode:
      if (pattern233 (x2, 
E_V16DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25413; /* xorv16di3 */

    case E_V32DImode:
      if (pattern233 (x2, 
E_V32DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25427; /* xorv32di3 */

    case E_V64DImode:
      if (pattern233 (x2, 
E_V64DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25441; /* xorv64di3 */

    case E_V128DImode:
      if (pattern233 (x2, 
E_V128DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25455; /* xorv128di3 */

    case E_V256DImode:
      if (pattern233 (x2, 
E_V256DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25469; /* xorv256di3 */

    case E_V512DImode:
      if (pattern233 (x2, 
E_V512DImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25483; /* xorv512di3 */

    case E_RVVMF64BImode:
      if (pattern0 (x2, 
E_RVVMF64BImode) != 0
          || !(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25903; /* xorrvvmf64bi3 */

    case E_RVVMF32BImode:
      if (pattern0 (x2, 
E_RVVMF32BImode) != 0
          || !
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25906; /* xorrvvmf32bi3 */

    case E_RVVMF16BImode:
      if (pattern0 (x2, 
E_RVVMF16BImode) != 0
          || !
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25909; /* xorrvvmf16bi3 */

    case E_RVVMF8BImode:
      if (pattern0 (x2, 
E_RVVMF8BImode) != 0
          || !
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25912; /* xorrvvmf8bi3 */

    case E_RVVMF4BImode:
      if (pattern0 (x2, 
E_RVVMF4BImode) != 0
          || !
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25915; /* xorrvvmf4bi3 */

    case E_RVVMF2BImode:
      if (pattern0 (x2, 
E_RVVMF2BImode) != 0
          || !
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25918; /* xorrvvmf2bi3 */

    case E_RVVM1BImode:
      if (pattern0 (x2, 
E_RVVM1BImode) != 0
          || !
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25921; /* xorrvvm1bi3 */

    case E_V1BImode:
      if (pattern0 (x2, 
E_V1BImode) != 0
          || !(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
        return -1;
      return 25924; /* xorv1bi3 */

    case E_V2BImode:
      if (pattern0 (x2, 
E_V2BImode) != 0
          || !(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
        return -1;
      return 25927; /* xorv2bi3 */

    case E_V4BImode:
      if (pattern0 (x2, 
E_V4BImode) != 0
          || !(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
        return -1;
      return 25930; /* xorv4bi3 */

    case E_V8BImode:
      if (pattern0 (x2, 
E_V8BImode) != 0
          || !(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
        return -1;
      return 25933; /* xorv8bi3 */

    case E_V16BImode:
      if (pattern0 (x2, 
E_V16BImode) != 0
          || !(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
        return -1;
      return 25936; /* xorv16bi3 */

    case E_V32BImode:
      if (pattern0 (x2, 
E_V32BImode) != 0
          || !(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
        return -1;
      return 25939; /* xorv32bi3 */

    case E_V64BImode:
      if (pattern0 (x2, 
E_V64BImode) != 0
          || !(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25942; /* xorv64bi3 */

    case E_V128BImode:
      if (pattern0 (x2, 
E_V128BImode) != 0
          || !(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25945; /* xorv128bi3 */

    case E_V256BImode:
      if (pattern0 (x2, 
E_V256BImode) != 0
          || !(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25948; /* xorv256bi3 */

    case E_V512BImode:
      if (pattern0 (x2, 
E_V512BImode) != 0
          || !(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25951; /* xorv512bi3 */

    case E_V1024BImode:
      if (pattern0 (x2, 
E_V1024BImode) != 0
          || !(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25954; /* xorv1024bi3 */

    case E_V2048BImode:
      if (pattern0 (x2, 
E_V2048BImode) != 0
          || !(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25957; /* xorv2048bi3 */

    case E_V4096BImode:
      if (pattern0 (x2, 
E_V4096BImode) != 0
          || !(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25960; /* xorv4096bi3 */

    default:
      return -1;
    }
}

 int
recog_127 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V32DFmode)
      && reg_or_mem_operand (operands[1], E_V32DFmode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DFmode)
       || register_operand (operands[1], V32DFmode))) && (
#line 4387 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3310; /* *movv32dfsi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DFmode)
       || register_operand (operands[1], V32DFmode))) && (
#line 4387 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3311; /* *movv32dfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V32DFmode)
      || !register_operand (operands[1], E_V32DFmode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 3410; /* *movv32df_vls */
}

 int
recog_133 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V32SFmode)
      && reg_or_mem_operand (operands[1], E_V32SFmode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SFmode)
       || register_operand (operands[1], V32SFmode))) && (
#line 4381 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3298; /* *movv32sfsi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SFmode)
       || register_operand (operands[1], V32SFmode))) && (
#line 4381 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3299; /* *movv32sfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V32SFmode)
      || !register_operand (operands[1], E_V32SFmode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 3399; /* *movv32sf_vls */
}

 int
recog_139 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V64HFmode)
      && reg_or_mem_operand (operands[1], E_V64HFmode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HFmode)
       || register_operand (operands[1], V64HFmode))) && (
#line 4375 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3286; /* *movv64hfsi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HFmode)
       || register_operand (operands[1], V64HFmode))) && (
#line 4375 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3287; /* *movv64hfdi_lra */
        }
    }
  if (!register_operand (operands[0], E_V64HFmode)
      || !register_operand (operands[1], E_V64HFmode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 3388; /* *movv64hf_vls */
}

 int
recog_145 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V32DImode)
      && reg_or_mem_operand (operands[1], E_V32DImode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DImode)
       || register_operand (operands[1], V32DImode))) && (
#line 4369 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3274; /* *movv32disi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32DImode)
       || register_operand (operands[1], V32DImode))) && (
#line 4369 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3275; /* *movv32didi_lra */
        }
    }
  if (!register_operand (operands[0], E_V32DImode)
      || !register_operand (operands[1], E_V32DImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 3377; /* *movv32di_vls */
}

 int
recog_151 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V32SImode)
      && reg_or_mem_operand (operands[1], E_V32SImode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SImode)
       || register_operand (operands[1], V32SImode))) && (
#line 4363 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3262; /* *movv32sisi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V32SImode)
       || register_operand (operands[1], V32SImode))) && (
#line 4363 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3263; /* *movv32sidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V32SImode)
      || !register_operand (operands[1], E_V32SImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 3366; /* *movv32si_vls */
}

 int
recog_157 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V64HImode)
      && reg_or_mem_operand (operands[1], E_V64HImode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HImode)
       || register_operand (operands[1], V64HImode))) && (
#line 4357 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3250; /* *movv64hisi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V64HImode)
       || register_operand (operands[1], V64HImode))) && (
#line 4357 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3251; /* *movv64hidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V64HImode)
      || !register_operand (operands[1], E_V64HImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 3355; /* *movv64hi_vls */
}

 int
recog_163 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL
      && reg_or_mem_operand (operands[0], E_V256QImode)
      && reg_or_mem_operand (operands[1], E_V256QImode))
    {
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256QImode)
       || register_operand (operands[1], V256QImode))) && (
#line 4351 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
        {
          *pnum_clobbers = 1;
          return 3238; /* *movv256qisi_lra */
        }
      if ((
#line 1478 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)
   && (register_operand (operands[0], V256QImode)
       || register_operand (operands[1], V256QImode))) && (
#line 4351 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
        {
          *pnum_clobbers = 1;
          return 3239; /* *movv256qidi_lra */
        }
    }
  if (!register_operand (operands[0], E_V256QImode)
      || !register_operand (operands[1], E_V256QImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 3344; /* *movv256qi_vls */
}

 int
recog_169 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF4BImode)
      && register_operand (operands[1], E_RVVMF4BImode)
      && 
#line 1294 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
    return 2816; /* *movrvvmf4bi */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4BImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4BImode))
    return -1;
  if ((
#line 1354 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 1;
      return 2856; /* *movrvvmf4bisi_lra */
    }
  if (!(
#line 1354 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 1;
  return 2857; /* *movrvvmf4bidi_lra */
}

 int
recog_175 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF2SImode)
      && register_operand (operands[1], E_RVVMF2SImode)
      && (
#line 1257 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
    return 2799; /* *movrvvmf2si_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2SImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2SImode))
    return -1;
  if ((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 1;
      return 2835; /* *movrvvmf2sisi_lra */
    }
  if (!(
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 940 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 1;
  return 2846; /* *movrvvmf2sidi_lra */
}

 int
recog_180 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_RVVMF4HImode)
      && register_operand (operands[1], E_RVVMF4HImode)
      && (
#line 1257 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
    return 2794; /* *movrvvmf4hi_fract */
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4HImode))
    return -1;
  if ((
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 1;
      return 2830; /* *movrvvmf4hisi_lra */
    }
  if (!(
#line 1332 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && (lra_in_progress || reload_completed)) && (
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 1;
  return 2841; /* *movrvvmf4hidi_lra */
}

 int
recog_187 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8BImode)
      && reg_or_mem_operand (operands[1], E_V8BImode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8BImode)
       || register_operand (operands[1], V8BImode))) && 
#line 4343 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
    return 3230; /* *movv8bi */
  if (!register_operand (operands[0], E_V8BImode)
      || !register_operand (operands[1], E_V8BImode)
      || !(
#line 1530 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
    return -1;
  return 3497; /* *movv8bi_vls */
}

 int
recog_193 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4DFmode)
      && reg_or_mem_operand (operands[1], E_V4DFmode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4DFmode)
       || register_operand (operands[1], V4DFmode))) && 
#line 4336 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 3224; /* *movv4df */
  if (!register_operand (operands[0], E_V4DFmode)
      || !register_operand (operands[1], E_V4DFmode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 3407; /* *movv4df_vls */
}

 int
recog_197 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8SFmode)
      && reg_or_mem_operand (operands[1], E_V8SFmode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8SFmode)
       || register_operand (operands[1], V8SFmode))) && 
#line 4332 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 3220; /* *movv8sf */
  if (!register_operand (operands[0], E_V8SFmode)
      || !register_operand (operands[1], E_V8SFmode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 3397; /* *movv8sf_vls */
}

 int
recog_203 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4HFmode)
      && reg_or_mem_operand (operands[1], E_V4HFmode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4HFmode)
       || register_operand (operands[1], V4HFmode))) && 
#line 4326 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 3214; /* *movv4hf */
  if (!register_operand (operands[0], E_V4HFmode)
      || !register_operand (operands[1], E_V4HFmode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 3384; /* *movv4hf_vls */
}

 int
recog_209 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2DImode)
      && reg_or_mem_operand (operands[1], E_V2DImode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2DImode)
       || register_operand (operands[1], V2DImode))) && 
#line 4320 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return 3208; /* *movv2di */
  if (!register_operand (operands[0], E_V2DImode)
      || !register_operand (operands[1], E_V2DImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 3373; /* *movv2di_vls */
}

 int
recog_216 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16HImode)
      && reg_or_mem_operand (operands[1], E_V16HImode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16HImode)
       || register_operand (operands[1], V16HImode))) && 
#line 4313 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return 3201; /* *movv16hi */
  if (!register_operand (operands[0], E_V16HImode)
      || !register_operand (operands[1], E_V16HImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
    return -1;
  return 3353; /* *movv16hi_vls */
}

 int
recog_223 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4QImode)
      && reg_or_mem_operand (operands[1], E_V4QImode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4QImode)
       || register_operand (operands[1], V4QImode))) && 
#line 4306 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
    return 3194; /* *movv4qi */
  if (!register_operand (operands[0], E_V4QImode)
      || !register_operand (operands[1], E_V4QImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
    return -1;
  return 3338; /* *movv4qi_vls */
}

 int
recog_230 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2HImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3184; /* *movrvvm4x2hi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3185; /* *movrvvm4x2hi_di */
}

 int
recog_237 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2HFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1330 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3170; /* *movrvvm2x2hf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1330 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3171; /* *movrvvm2x2hf_di */
}

 int
recog_244 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2HImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3156; /* *movrvvm2x2hi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3157; /* *movrvvm2x2hi_di */
}

 int
recog_251 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2QImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3142; /* *movrvvm1x2qi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3143; /* *movrvvm1x2qi_di */
}

 int
recog_258 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6HFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1306 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3128; /* *movrvvm1x6hf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1306 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3129; /* *movrvvm1x6hf_di */
}

 int
recog_265 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6BFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1299 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3114; /* *movrvvm1x6bf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1299 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3115; /* *movrvvm1x6bf_di */
}

 int
recog_273 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2SImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3098; /* *movrvvm2x2si_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3099; /* *movrvvm2x2si_di */
}

 int
recog_281 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x8QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x8QImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3082; /* *movrvvmf2x8qi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3083; /* *movrvvmf2x8qi_di */
}

 int
recog_289 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3DFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1272 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3066; /* *movrvvm2x3df_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1272 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3067; /* *movrvvm2x3df_di */
}

 int
recog_297 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2SFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1264 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3050; /* *movrvvm1x2sf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1264 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3051; /* *movrvvm1x2sf_di */
}

 int
recog_305 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x8BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x8BFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3034; /* *movrvvmf2x8bf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3035; /* *movrvvmf2x8bf_di */
}

 int
recog_313 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x3DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x3DImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3018; /* *movrvvm2x3di_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3019; /* *movrvvm2x3di_di */
}

 int
recog_321 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2SImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3002; /* *movrvvm1x2si_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3003; /* *movrvvm1x2si_di */
}

 int
recog_329 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x8QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x8QImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2986; /* *movrvvmf4x8qi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2987; /* *movrvvmf4x8qi_di */
}

 int
recog_337 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x7DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x7DFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2970; /* *movrvvm1x7df_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2971; /* *movrvvm1x7df_di */
}

 int
recog_345 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x6SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x6SFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2954; /* *movrvvmf2x6sf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2955; /* *movrvvmf2x6sf_di */
}

 int
recog_353 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x5HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x5HFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2938; /* *movrvvmf4x5hf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2939; /* *movrvvmf4x5hf_di */
}

 int
recog_361 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x4BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x4BFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2922; /* *movrvvmf4x4bf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2923; /* *movrvvmf4x4bf_di */
}

 int
recog_369 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x3DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x3DImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2906; /* *movrvvm1x3di_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2907; /* *movrvvm1x3di_di */
}

 int
recog_377 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  res = recog_376 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  switch (GET_CODE (x2))
    {
    case MEM:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      if (!absolute_symbolic_operand (operands[0], E_VOIDmode))
        return -1;
      x4 = XEXP (x1, 1);
      operands[1] = x4;
      switch (GET_MODE (x2))
        {
        case E_QImode:
          if (!reg_or_0_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 93 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
            {
              *pnum_clobbers = 1;
              return 842; /* *local_pic_storeqi */
            }
          if (!(
#line 93 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
            return -1;
          *pnum_clobbers = 1;
          return 846; /* *local_pic_storeqi */

        case E_HImode:
          if (!reg_or_0_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 93 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
            {
              *pnum_clobbers = 1;
              return 843; /* *local_pic_storehi */
            }
          if (!(
#line 93 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
            return -1;
          *pnum_clobbers = 1;
          return 847; /* *local_pic_storehi */

        case E_SImode:
          if (!reg_or_0_operand (operands[1], E_SImode))
            return -1;
          if ((
#line 93 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
            {
              *pnum_clobbers = 1;
              return 844; /* *local_pic_storesi */
            }
          if (!(
#line 93 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
            return -1;
          *pnum_clobbers = 1;
          return 848; /* *local_pic_storesi */

        case E_DImode:
          if (!reg_or_0_operand (operands[1], E_DImode))
            return -1;
          if ((
#line 93 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            {
              *pnum_clobbers = 1;
              return 845; /* *local_pic_storedi */
            }
          if (!(
#line 93 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            return -1;
          *pnum_clobbers = 1;
          return 849; /* *local_pic_storedi */

        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          if ((
#line 102 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 110 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            {
              *pnum_clobbers = 1;
              return 850; /* *local_pic_storesf */
            }
          if ((
#line 102 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 110 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            {
              *pnum_clobbers = 1;
              return 853; /* *local_pic_storesf */
            }
          if ((
#line 128 "../../gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
            {
              *pnum_clobbers = 1;
              return 862; /* *local_pic_store_sfsf */
            }
          if (!(
#line 128 "../../gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
            return -1;
          *pnum_clobbers = 1;
          return 865; /* *local_pic_store_sfsf */

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode))
            return -1;
          if ((
#line 102 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 111 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            {
              *pnum_clobbers = 1;
              return 851; /* *local_pic_storedf */
            }
          if ((
#line 102 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 111 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            {
              *pnum_clobbers = 1;
              return 854; /* *local_pic_storedf */
            }
          if ((
#line 128 "../../gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 115 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            {
              *pnum_clobbers = 1;
              return 863; /* *local_pic_store_sfdf */
            }
          if (!(
#line 128 "../../gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 115 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            return -1;
          *pnum_clobbers = 1;
          return 866; /* *local_pic_store_sfdf */

        case E_HFmode:
          if (!register_operand (operands[1], E_HFmode))
            return -1;
          if ((
#line 102 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 112 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            {
              *pnum_clobbers = 1;
              return 852; /* *local_pic_storehf */
            }
          if ((
#line 102 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 112 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            {
              *pnum_clobbers = 1;
              return 855; /* *local_pic_storehf */
            }
          if ((
#line 128 "../../gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 115 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            {
              *pnum_clobbers = 1;
              return 864; /* *local_pic_store_sfhf */
            }
          if (!(
#line 128 "../../gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[0])) && (
#line 115 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            return -1;
          *pnum_clobbers = 1;
          return 867; /* *local_pic_store_sfhf */

        default:
          return -1;
        }

    case REG:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x1, 1);
      operands[0] = x4;
      switch (REGNO (x2))
        {
        case 68:
          if (!const_int_operand (operands[0], E_SImode)
              || !
#line 1089 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 2721; /* vxrmsi */

        case 69:
          if (!reg_or_int_operand (operands[0], E_SImode)
              || !
#line 1111 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 2723; /* fsrmsi_restore */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_388 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != LABEL_REF)
    return -1;
  x6 = XEXP (x2, 2);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  res = recog_387 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (!equality_operator (x3, E_VOIDmode))
    return -1;
  operands[1] = x3;
  x9 = XEXP (x3, 1);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  operands[2] = x8;
  x10 = XEXP (x4, 1);
  operands[3] = x10;
  if (consecutive_bits_operand (operands[3], E_VOIDmode)
      && XWINT (x9, 0) == 0L)
    {
      switch (pattern452 (x2))
        {
        case 0:
          if ((
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 361; /* *branchqi_shiftedmask_equals_zero */
            }
          if ((
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 365; /* *branchqi_shiftedmask_equals_zero */
            }
          break;

        case 1:
          if ((
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 362; /* *branchhi_shiftedmask_equals_zero */
            }
          if ((
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 366; /* *branchhi_shiftedmask_equals_zero */
            }
          break;

        case 2:
          if ((
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 363; /* *branchsi_shiftedmask_equals_zero */
            }
          if ((
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 367; /* *branchsi_shiftedmask_equals_zero */
            }
          break;

        case 3:
          if ((
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && ((((
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
            {
              *pnum_clobbers = 1;
              return 364; /* *branchdi_shiftedmask_equals_zero */
            }
          if ((
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 368; /* *branchdi_shiftedmask_equals_zero */
            }
          break;

        default:
          break;
        }
    }
  operands[4] = x9;
  x11 = XEXP (x5, 0);
  operands[0] = x11;
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !const_twobits_not_arith_operand (operands[3], E_SImode)
          || !single_bit_mask_operand (operands[4], E_SImode)
          || !(
#line 1101 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && TARGET_ZBB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 2;
      return 651; /* *branchsi_mask_twobits_equals_singlebit */

    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !const_twobits_not_arith_operand (operands[3], E_DImode)
          || !single_bit_mask_operand (operands[4], E_DImode)
          || !(
#line 1101 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && TARGET_ZBB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 2;
      return 652; /* *branchdi_mask_twobits_equals_singlebit */

    default:
      return -1;
    }
}

 int
recog_392 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!vector_move_operand (operands[3], E_RVVMF16BImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[2] = x7;
  if (!vector_undef_operand (operands[2], E_RVVMF16BImode))
    return -1;
  if (
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return 1233; /* *pred_th_movrvvmf16bi */
  if (!
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 3818; /* pred_movrvvmf16bi */
}

 int
recog_394 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!vector_move_operand (operands[3], E_RVVMF4BImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[2] = x7;
  if (!vector_undef_operand (operands[2], E_RVVMF4BImode))
    return -1;
  if (
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return 1235; /* *pred_th_movrvvmf4bi */
  if (!
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 3820; /* pred_movrvvmf4bi */
}

 int
recog_396 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!vector_move_operand (operands[3], E_RVVM1BImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[2] = x7;
  if (!vector_undef_operand (operands[2], E_RVVM1BImode))
    return -1;
  if (
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return 1237; /* *pred_th_movrvvm1bi */
  if (!
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
    return -1;
  return 3822; /* pred_movrvvm1bi */
}

 int
recog_399 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern472 (x2))
    {
    case 0:
      if (!
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28609; /* *cond_len_zero_extendrvvm4qirvvm8hi */

    case 1:
      if (!
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28611; /* *cond_len_zero_extendrvvm2qirvvm4hi */

    case 2:
      if (!
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28613; /* *cond_len_zero_extendrvvm1qirvvm2hi */

    case 3:
      if (!
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28615; /* *cond_len_zero_extendrvvmf2qirvvm1hi */

    case 4:
      if (!
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28617; /* *cond_len_zero_extendrvvmf4qirvvmf2hi */

    case 5:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28619; /* *cond_len_zero_extendrvvmf8qirvvmf4hi */

    case 6:
      if (!
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28621; /* *cond_len_zero_extendrvvm4hirvvm8si */

    case 7:
      if (!
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28705; /* *cond_len_zero_extendrvvm2qirvvm8si */

    case 8:
      if (!
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28623; /* *cond_len_zero_extendrvvm2hirvvm4si */

    case 9:
      if (!
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28707; /* *cond_len_zero_extendrvvm1qirvvm4si */

    case 10:
      if (!
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28625; /* *cond_len_zero_extendrvvm1hirvvm2si */

    case 11:
      if (!
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28709; /* *cond_len_zero_extendrvvmf2qirvvm2si */

    case 12:
      if (!
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28627; /* *cond_len_zero_extendrvvmf2hirvvm1si */

    case 13:
      if (!
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
        return -1;
      return 28711; /* *cond_len_zero_extendrvvmf4qirvvm1si */

    case 14:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28629; /* *cond_len_zero_extendrvvmf4hirvvmf2si */

    case 15:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28713; /* *cond_len_zero_extendrvvmf8qirvvmf2si */

    case 16:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28631; /* *cond_len_zero_extendrvvm4sirvvm8di */

    case 17:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28715; /* *cond_len_zero_extendrvvm2hirvvm8di */

    case 18:
      if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1151 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28765; /* *cond_len_zero_extendrvvm1qirvvm8di */

    case 19:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28633; /* *cond_len_zero_extendrvvm2sirvvm4di */

    case 20:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28717; /* *cond_len_zero_extendrvvm1hirvvm4di */

    case 21:
      if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1151 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28767; /* *cond_len_zero_extendrvvmf2qirvvm4di */

    case 22:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28635; /* *cond_len_zero_extendrvvm1sirvvm2di */

    case 23:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28719; /* *cond_len_zero_extendrvvmf2hirvvm2di */

    case 24:
      if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1152 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28769; /* *cond_len_zero_extendrvvmf4qirvvm2di */

    case 25:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28637; /* *cond_len_zero_extendrvvmf2sirvvm1di */

    case 26:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28721; /* *cond_len_zero_extendrvvmf4hirvvm1di */

    case 27:
      if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1152 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28771; /* *cond_len_zero_extendrvvmf8qirvvm1di */

    case 28:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 28639; /* *cond_len_zero_extendv1qiv1hi */

    case 29:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 28641; /* *cond_len_zero_extendv2qiv2hi */

    case 30:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 28643; /* *cond_len_zero_extendv4qiv4hi */

    case 31:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 28645; /* *cond_len_zero_extendv8qiv8hi */

    case 32:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 28647; /* *cond_len_zero_extendv16qiv16hi */

    case 33:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28649; /* *cond_len_zero_extendv32qiv32hi */

    case 34:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28651; /* *cond_len_zero_extendv64qiv64hi */

    case 35:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28653; /* *cond_len_zero_extendv128qiv128hi */

    case 36:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28655; /* *cond_len_zero_extendv256qiv256hi */

    case 37:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28657; /* *cond_len_zero_extendv512qiv512hi */

    case 38:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28659; /* *cond_len_zero_extendv1024qiv1024hi */

    case 39:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28661; /* *cond_len_zero_extendv2048qiv2048hi */

    case 40:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28663; /* *cond_len_zero_extendv1hiv1si */

    case 41:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 28723; /* *cond_len_zero_extendv1qiv1si */

    case 42:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28665; /* *cond_len_zero_extendv2hiv2si */

    case 43:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 28725; /* *cond_len_zero_extendv2qiv2si */

    case 44:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28667; /* *cond_len_zero_extendv4hiv4si */

    case 45:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 28727; /* *cond_len_zero_extendv4qiv4si */

    case 46:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28669; /* *cond_len_zero_extendv8hiv8si */

    case 47:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 28729; /* *cond_len_zero_extendv8qiv8si */

    case 48:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28671; /* *cond_len_zero_extendv16hiv16si */

    case 49:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28731; /* *cond_len_zero_extendv16qiv16si */

    case 50:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28673; /* *cond_len_zero_extendv32hiv32si */

    case 51:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28733; /* *cond_len_zero_extendv32qiv32si */

    case 52:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28675; /* *cond_len_zero_extendv64hiv64si */

    case 53:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28735; /* *cond_len_zero_extendv64qiv64si */

    case 54:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28677; /* *cond_len_zero_extendv128hiv128si */

    case 55:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1118 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28737; /* *cond_len_zero_extendv128qiv128si */

    case 56:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28679; /* *cond_len_zero_extendv256hiv256si */

    case 57:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1119 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28739; /* *cond_len_zero_extendv256qiv256si */

    case 58:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28681; /* *cond_len_zero_extendv512hiv512si */

    case 59:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1120 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28741; /* *cond_len_zero_extendv512qiv512si */

    case 60:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28683; /* *cond_len_zero_extendv1024hiv1024si */

    case 61:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1121 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28743; /* *cond_len_zero_extendv1024qiv1024si */

    case 62:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28685; /* *cond_len_zero_extendv1siv1di */

    case 63:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1122 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28745; /* *cond_len_zero_extendv1hiv1di */

    case 64:
      if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1154 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28773; /* *cond_len_zero_extendv1qiv1di */

    case 65:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28687; /* *cond_len_zero_extendv2siv2di */

    case 66:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1123 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28747; /* *cond_len_zero_extendv2hiv2di */

    case 67:
      if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1155 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28775; /* *cond_len_zero_extendv2qiv2di */

    case 68:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28689; /* *cond_len_zero_extendv4siv4di */

    case 69:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1124 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28749; /* *cond_len_zero_extendv4hiv4di */

    case 70:
      if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1156 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 28777; /* *cond_len_zero_extendv4qiv4di */

    case 71:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28691; /* *cond_len_zero_extendv8siv8di */

    case 72:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1125 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28751; /* *cond_len_zero_extendv8hiv8di */

    case 73:
      if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1157 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 28779; /* *cond_len_zero_extendv8qiv8di */

    case 74:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28693; /* *cond_len_zero_extendv16siv16di */

    case 75:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1126 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28753; /* *cond_len_zero_extendv16hiv16di */

    case 76:
      if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1158 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 28781; /* *cond_len_zero_extendv16qiv16di */

    case 77:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28695; /* *cond_len_zero_extendv32siv32di */

    case 78:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1127 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28755; /* *cond_len_zero_extendv32hiv32di */

    case 79:
      if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1159 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 28783; /* *cond_len_zero_extendv32qiv32di */

    case 80:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28697; /* *cond_len_zero_extendv64siv64di */

    case 81:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1128 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28757; /* *cond_len_zero_extendv64hiv64di */

    case 82:
      if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1160 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 28785; /* *cond_len_zero_extendv64qiv64di */

    case 83:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28699; /* *cond_len_zero_extendv128siv128di */

    case 84:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1129 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28759; /* *cond_len_zero_extendv128hiv128di */

    case 85:
      if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1161 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 28787; /* *cond_len_zero_extendv128qiv128di */

    case 86:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28701; /* *cond_len_zero_extendv256siv256di */

    case 87:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1130 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28761; /* *cond_len_zero_extendv256hiv256di */

    case 88:
      if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1162 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 28789; /* *cond_len_zero_extendv256qiv256di */

    case 89:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28703; /* *cond_len_zero_extendv512siv512di */

    case 90:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1131 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28763; /* *cond_len_zero_extendv512hiv512di */

    case 91:
      if (!(
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1163 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 28791; /* *cond_len_zero_extendv512qiv512di */

    default:
      return -1;
    }
}

 int
recog_400 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != MINUS)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 0);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 1);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 2);
  operands[7] = x8;
  x9 = XEXP (x4, 0);
  operands[2] = x9;
  x10 = XVECEXP (x3, 0, 1);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  operands[1] = x11;
  x12 = XEXP (x4, 1);
  switch (GET_CODE (x12))
    {
    case REG:
    case SUBREG:
      operands[3] = x12;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          if (pattern686 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
              || !
#line 3216 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8499; /* pred_sbcrvvm8qi */

        case E_RVVM4QImode:
          if (pattern686 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
              || !
#line 3216 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8500; /* pred_sbcrvvm4qi */

        case E_RVVM2QImode:
          if (pattern686 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
              || !
#line 3216 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8501; /* pred_sbcrvvm2qi */

        case E_RVVM1QImode:
          if (pattern686 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
              || !
#line 3216 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8502; /* pred_sbcrvvm1qi */

        case E_RVVM8HImode:
          if (pattern686 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
              || !
#line 3216 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8503; /* pred_sbcrvvm8hi */

        case E_RVVM4HImode:
          if (pattern686 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
              || !
#line 3216 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8504; /* pred_sbcrvvm4hi */

        case E_RVVM2HImode:
          if (pattern686 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
              || !
#line 3216 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8505; /* pred_sbcrvvm2hi */

        case E_RVVM1HImode:
          if (pattern686 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
              || !
#line 3216 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8506; /* pred_sbcrvvm1hi */

        case E_RVVM8SImode:
          if (pattern686 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
              || !
#line 3216 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8507; /* pred_sbcrvvm8si */

        case E_RVVM4SImode:
          if (pattern686 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
              || !
#line 3216 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8508; /* pred_sbcrvvm4si */

        case E_RVVM2SImode:
          if (pattern686 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
              || !
#line 3216 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8509; /* pred_sbcrvvm2si */

        case E_RVVM1SImode:
          if (pattern686 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
              || !
#line 3216 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 8510; /* pred_sbcrvvm1si */

        case E_RVVM8DImode:
          if (pattern686 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 3216 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8511; /* pred_sbcrvvm8di */

        case E_RVVM4DImode:
          if (pattern686 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 3216 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8512; /* pred_sbcrvvm4di */

        case E_RVVM2DImode:
          if (pattern686 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 3216 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8513; /* pred_sbcrvvm2di */

        case E_RVVM1DImode:
          if (pattern686 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 3216 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 8514; /* pred_sbcrvvm1di */

        case E_RVVMF2QImode:
          if (pattern686 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
              || !(
#line 3216 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 8515; /* pred_sbcrvvmf2qi */

        case E_RVVMF4QImode:
          if (pattern686 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
              || !(
#line 3216 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 8516; /* pred_sbcrvvmf4qi */

        case E_RVVMF8QImode:
          if (pattern686 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
              || !(
#line 3216 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 8517; /* pred_sbcrvvmf8qi */

        case E_RVVMF2HImode:
          if (pattern686 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
              || !(
#line 3216 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 8518; /* pred_sbcrvvmf2hi */

        case E_RVVMF4HImode:
          if (pattern686 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
              || !(
#line 3216 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 8519; /* pred_sbcrvvmf4hi */

        case E_RVVMF2SImode:
          if (pattern686 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
              || !(
#line 3216 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 8520; /* pred_sbcrvvmf2si */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x13 = XEXP (x12, 0);
      switch (GET_CODE (x13))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[3] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8QImode:
              if (pattern699 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode) != 0
                  || !
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8575; /* pred_sbcrvvm8qi_scalar */

            case E_RVVM4QImode:
              if (pattern699 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0
                  || !
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8576; /* pred_sbcrvvm4qi_scalar */

            case E_RVVM2QImode:
              if (pattern699 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0
                  || !
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8577; /* pred_sbcrvvm2qi_scalar */

            case E_RVVM1QImode:
              if (pattern699 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0
                  || !
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8578; /* pred_sbcrvvm1qi_scalar */

            case E_RVVMF2QImode:
              if (pattern699 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0
                  || !
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8579; /* pred_sbcrvvmf2qi_scalar */

            case E_RVVMF4QImode:
              if (pattern699 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0
                  || !
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8580; /* pred_sbcrvvmf4qi_scalar */

            case E_RVVMF8QImode:
              if (pattern699 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8581; /* pred_sbcrvvmf8qi_scalar */

            case E_RVVM8HImode:
              if (pattern699 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0
                  || !
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8582; /* pred_sbcrvvm8hi_scalar */

            case E_RVVM4HImode:
              if (pattern699 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0
                  || !
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8583; /* pred_sbcrvvm4hi_scalar */

            case E_RVVM2HImode:
              if (pattern699 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0
                  || !
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8584; /* pred_sbcrvvm2hi_scalar */

            case E_RVVM1HImode:
              if (pattern699 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0
                  || !
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8585; /* pred_sbcrvvm1hi_scalar */

            case E_RVVMF2HImode:
              if (pattern699 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0
                  || !
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8586; /* pred_sbcrvvmf2hi_scalar */

            case E_RVVMF4HImode:
              if (pattern699 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8587; /* pred_sbcrvvmf4hi_scalar */

            case E_RVVM8SImode:
              if (pattern699 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0
                  || !
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8588; /* pred_sbcrvvm8si_scalar */

            case E_RVVM4SImode:
              if (pattern699 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0
                  || !
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8589; /* pred_sbcrvvm4si_scalar */

            case E_RVVM2SImode:
              if (pattern699 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0
                  || !
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8590; /* pred_sbcrvvm2si_scalar */

            case E_RVVM1SImode:
              if (pattern699 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0
                  || !
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 8591; /* pred_sbcrvvm1si_scalar */

            case E_RVVMF2SImode:
              if (pattern699 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8592; /* pred_sbcrvvmf2si_scalar */

            case E_V1QImode:
              if (pattern699 (x2, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 8593; /* pred_sbcv1qi_scalar */

            case E_V2QImode:
              if (pattern699 (x2, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 8594; /* pred_sbcv2qi_scalar */

            case E_V4QImode:
              if (pattern699 (x2, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 8595; /* pred_sbcv4qi_scalar */

            case E_V8QImode:
              if (pattern699 (x2, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 8596; /* pred_sbcv8qi_scalar */

            case E_V16QImode:
              if (pattern699 (x2, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 8597; /* pred_sbcv16qi_scalar */

            case E_V32QImode:
              if (pattern699 (x2, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 8598; /* pred_sbcv32qi_scalar */

            case E_V64QImode:
              if (pattern699 (x2, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 8599; /* pred_sbcv64qi_scalar */

            case E_V128QImode:
              if (pattern699 (x2, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 8600; /* pred_sbcv128qi_scalar */

            case E_V256QImode:
              if (pattern699 (x2, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 8601; /* pred_sbcv256qi_scalar */

            case E_V512QImode:
              if (pattern699 (x2, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 8602; /* pred_sbcv512qi_scalar */

            case E_V1024QImode:
              if (pattern699 (x2, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 8603; /* pred_sbcv1024qi_scalar */

            case E_V2048QImode:
              if (pattern699 (x2, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 8604; /* pred_sbcv2048qi_scalar */

            case E_V4096QImode:
              if (pattern699 (x2, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 8605; /* pred_sbcv4096qi_scalar */

            case E_V1HImode:
              if (pattern699 (x2, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 8606; /* pred_sbcv1hi_scalar */

            case E_V2HImode:
              if (pattern699 (x2, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 8607; /* pred_sbcv2hi_scalar */

            case E_V4HImode:
              if (pattern699 (x2, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 8608; /* pred_sbcv4hi_scalar */

            case E_V8HImode:
              if (pattern699 (x2, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 8609; /* pred_sbcv8hi_scalar */

            case E_V16HImode:
              if (pattern699 (x2, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 8610; /* pred_sbcv16hi_scalar */

            case E_V32HImode:
              if (pattern699 (x2, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 8611; /* pred_sbcv32hi_scalar */

            case E_V64HImode:
              if (pattern699 (x2, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 8612; /* pred_sbcv64hi_scalar */

            case E_V128HImode:
              if (pattern699 (x2, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 8613; /* pred_sbcv128hi_scalar */

            case E_V256HImode:
              if (pattern699 (x2, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 8614; /* pred_sbcv256hi_scalar */

            case E_V512HImode:
              if (pattern699 (x2, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 8615; /* pred_sbcv512hi_scalar */

            case E_V1024HImode:
              if (pattern699 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 8616; /* pred_sbcv1024hi_scalar */

            case E_V2048HImode:
              if (pattern699 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 8617; /* pred_sbcv2048hi_scalar */

            case E_V1SImode:
              if (pattern699 (x2, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 8618; /* pred_sbcv1si_scalar */

            case E_V2SImode:
              if (pattern699 (x2, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 8619; /* pred_sbcv2si_scalar */

            case E_V4SImode:
              if (pattern699 (x2, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 8620; /* pred_sbcv4si_scalar */

            case E_V8SImode:
              if (pattern699 (x2, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 8621; /* pred_sbcv8si_scalar */

            case E_V16SImode:
              if (pattern699 (x2, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 8622; /* pred_sbcv16si_scalar */

            case E_V32SImode:
              if (pattern699 (x2, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 8623; /* pred_sbcv32si_scalar */

            case E_V64SImode:
              if (pattern699 (x2, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 8624; /* pred_sbcv64si_scalar */

            case E_V128SImode:
              if (pattern699 (x2, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 8625; /* pred_sbcv128si_scalar */

            case E_V256SImode:
              if (pattern699 (x2, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 8626; /* pred_sbcv256si_scalar */

            case E_V512SImode:
              if (pattern699 (x2, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 8627; /* pred_sbcv512si_scalar */

            case E_V1024SImode:
              if (pattern699 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0
                  || !(
#line 3266 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 8628; /* pred_sbcv1024si_scalar */

            case E_RVVM8DImode:
              if (pattern699 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0
                  || !(
#line 3408 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8637; /* *pred_sbcrvvm8di_scalar */

            case E_RVVM4DImode:
              if (pattern699 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0
                  || !(
#line 3408 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8638; /* *pred_sbcrvvm4di_scalar */

            case E_RVVM2DImode:
              if (pattern699 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0
                  || !(
#line 3408 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8639; /* *pred_sbcrvvm2di_scalar */

            case E_RVVM1DImode:
              if (pattern699 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0
                  || !(
#line 3408 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8640; /* *pred_sbcrvvm1di_scalar */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x13) != E_DImode)
            return -1;
          x14 = XEXP (x13, 0);
          operands[3] = x14;
          if (!reg_or_0_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8DImode:
              if (pattern715 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
                  || !(
#line 3434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8641; /* *pred_sbcrvvm8di_extended_scalar */

            case E_RVVM4DImode:
              if (pattern715 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
                  || !(
#line 3434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8642; /* *pred_sbcrvvm4di_extended_scalar */

            case E_RVVM2DImode:
              if (pattern715 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
                  || !(
#line 3434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8643; /* *pred_sbcrvvm2di_extended_scalar */

            case E_RVVM1DImode:
              if (pattern715 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
                  || !(
#line 3434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 8644; /* *pred_sbcrvvm1di_extended_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_413 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8QImode)
        || register_operand (operands[3], RVVM8QImode)))))
        return -1;
      return 3651; /* *pred_movrvvm8qi */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4QImode)
        || register_operand (operands[3], RVVM4QImode)))))
        return -1;
      return 3652; /* *pred_movrvvm4qi */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2QImode)
        || register_operand (operands[3], RVVM2QImode)))))
        return -1;
      return 3653; /* *pred_movrvvm2qi */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1QImode)
        || register_operand (operands[3], RVVM1QImode)))))
        return -1;
      return 3654; /* *pred_movrvvm1qi */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8HImode)
        || register_operand (operands[3], RVVM8HImode)))))
        return -1;
      return 3655; /* *pred_movrvvm8hi */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4HImode)
        || register_operand (operands[3], RVVM4HImode)))))
        return -1;
      return 3656; /* *pred_movrvvm4hi */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2HImode)
        || register_operand (operands[3], RVVM2HImode)))))
        return -1;
      return 3657; /* *pred_movrvvm2hi */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1HImode)
        || register_operand (operands[3], RVVM1HImode)))))
        return -1;
      return 3658; /* *pred_movrvvm1hi */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8SImode)
        || register_operand (operands[3], RVVM8SImode)))))
        return -1;
      return 3659; /* *pred_movrvvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4SImode)
        || register_operand (operands[3], RVVM4SImode)))))
        return -1;
      return 3660; /* *pred_movrvvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2SImode)
        || register_operand (operands[3], RVVM2SImode)))))
        return -1;
      return 3661; /* *pred_movrvvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1SImode)
        || register_operand (operands[3], RVVM1SImode)))))
        return -1;
      return 3662; /* *pred_movrvvm1si */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8DImode)
        || register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3663; /* *pred_movrvvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4DImode)
        || register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3664; /* *pred_movrvvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2DImode)
        || register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3665; /* *pred_movrvvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1DImode)
        || register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3666; /* *pred_movrvvm1di */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2QImode)
        || register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3667; /* *pred_movrvvmf2qi */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF4QImode)
        || register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3668; /* *pred_movrvvmf4qi */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF8QImode)
        || register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3669; /* *pred_movrvvmf8qi */

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2HImode)
        || register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3670; /* *pred_movrvvmf2hi */

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF4HImode)
        || register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3671; /* *pred_movrvvmf4hi */

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2SImode)
        || register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3672; /* *pred_movrvvmf2si */

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8BFmode)
        || register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3673; /* *pred_movrvvm8bf */

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4BFmode)
        || register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3674; /* *pred_movrvvm4bf */

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2BFmode)
        || register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3675; /* *pred_movrvvm2bf */

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1BFmode)
        || register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3676; /* *pred_movrvvm1bf */

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
        || register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3677; /* *pred_movrvvmf2bf */

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
        || register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3678; /* *pred_movrvvmf4bf */

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8HFmode)
        || register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3679; /* *pred_movrvvm8hf */

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4HFmode)
        || register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3680; /* *pred_movrvvm4hf */

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2HFmode)
        || register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3681; /* *pred_movrvvm2hf */

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1HFmode)
        || register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3682; /* *pred_movrvvm1hf */

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
        || register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3683; /* *pred_movrvvmf2hf */

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
        || register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3684; /* *pred_movrvvmf4hf */

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8SFmode)
        || register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3685; /* *pred_movrvvm8sf */

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4SFmode)
        || register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3686; /* *pred_movrvvm4sf */

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2SFmode)
        || register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3687; /* *pred_movrvvm2sf */

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1SFmode)
        || register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3688; /* *pred_movrvvm1sf */

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
        || register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3689; /* *pred_movrvvmf2sf */

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM8DFmode)
        || register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3690; /* *pred_movrvvm8df */

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM4DFmode)
        || register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3691; /* *pred_movrvvm4df */

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM2DFmode)
        || register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3692; /* *pred_movrvvm2df */

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], RVVM1DFmode)
        || register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3693; /* *pred_movrvvm1df */

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1QImode)
        || register_operand (operands[3], V1QImode)))) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 3694; /* *pred_movv1qi */

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2QImode)
        || register_operand (operands[3], V2QImode)))) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 3695; /* *pred_movv2qi */

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4QImode)
        || register_operand (operands[3], V4QImode)))) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 3696; /* *pred_movv4qi */

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8QImode)
        || register_operand (operands[3], V8QImode)))) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 3697; /* *pred_movv8qi */

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16QImode)
        || register_operand (operands[3], V16QImode)))) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 3698; /* *pred_movv16qi */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32QImode)
        || register_operand (operands[3], V32QImode)))) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 3699; /* *pred_movv32qi */

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64QImode)
        || register_operand (operands[3], V64QImode)))) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3700; /* *pred_movv64qi */

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128QImode)
        || register_operand (operands[3], V128QImode)))) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3701; /* *pred_movv128qi */

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256QImode)
        || register_operand (operands[3], V256QImode)))) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3702; /* *pred_movv256qi */

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512QImode)
        || register_operand (operands[3], V512QImode)))) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3703; /* *pred_movv512qi */

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024QImode)
        || register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3704; /* *pred_movv1024qi */

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2048QImode)
        || register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3705; /* *pred_movv2048qi */

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4096QImode)
        || register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3706; /* *pred_movv4096qi */

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1HImode)
        || register_operand (operands[3], V1HImode)))) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 3707; /* *pred_movv1hi */

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2HImode)
        || register_operand (operands[3], V2HImode)))) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 3708; /* *pred_movv2hi */

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4HImode)
        || register_operand (operands[3], V4HImode)))) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 3709; /* *pred_movv4hi */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8HImode)
        || register_operand (operands[3], V8HImode)))) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 3710; /* *pred_movv8hi */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16HImode)
        || register_operand (operands[3], V16HImode)))) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 3711; /* *pred_movv16hi */

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32HImode)
        || register_operand (operands[3], V32HImode)))) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3712; /* *pred_movv32hi */

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64HImode)
        || register_operand (operands[3], V64HImode)))) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3713; /* *pred_movv64hi */

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128HImode)
        || register_operand (operands[3], V128HImode)))) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3714; /* *pred_movv128hi */

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256HImode)
        || register_operand (operands[3], V256HImode)))) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3715; /* *pred_movv256hi */

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512HImode)
        || register_operand (operands[3], V512HImode)))) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3716; /* *pred_movv512hi */

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024HImode)
        || register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3717; /* *pred_movv1024hi */

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2048HImode)
        || register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3718; /* *pred_movv2048hi */

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1SImode)
        || register_operand (operands[3], V1SImode)))) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 3719; /* *pred_movv1si */

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2SImode)
        || register_operand (operands[3], V2SImode)))) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 3720; /* *pred_movv2si */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4SImode)
        || register_operand (operands[3], V4SImode)))) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 3721; /* *pred_movv4si */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8SImode)
        || register_operand (operands[3], V8SImode)))) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 3722; /* *pred_movv8si */

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16SImode)
        || register_operand (operands[3], V16SImode)))) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3723; /* *pred_movv16si */

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32SImode)
        || register_operand (operands[3], V32SImode)))) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3724; /* *pred_movv32si */

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64SImode)
        || register_operand (operands[3], V64SImode)))) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3725; /* *pred_movv64si */

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128SImode)
        || register_operand (operands[3], V128SImode)))) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3726; /* *pred_movv128si */

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256SImode)
        || register_operand (operands[3], V256SImode)))) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3727; /* *pred_movv256si */

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512SImode)
        || register_operand (operands[3], V512SImode)))) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3728; /* *pred_movv512si */

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024SImode)
        || register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3729; /* *pred_movv1024si */

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1DImode)
        || register_operand (operands[3], V1DImode)))) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3730; /* *pred_movv1di */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2DImode)
        || register_operand (operands[3], V2DImode)))) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3731; /* *pred_movv2di */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4DImode)
        || register_operand (operands[3], V4DImode)))) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3732; /* *pred_movv4di */

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8DImode)
        || register_operand (operands[3], V8DImode)))) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3733; /* *pred_movv8di */

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16DImode)
        || register_operand (operands[3], V16DImode)))) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3734; /* *pred_movv16di */

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32DImode)
        || register_operand (operands[3], V32DImode)))) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3735; /* *pred_movv32di */

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64DImode)
        || register_operand (operands[3], V64DImode)))) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3736; /* *pred_movv64di */

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128DImode)
        || register_operand (operands[3], V128DImode)))) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3737; /* *pred_movv128di */

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256DImode)
        || register_operand (operands[3], V256DImode)))) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3738; /* *pred_movv256di */

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512DImode)
        || register_operand (operands[3], V512DImode)))) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3739; /* *pred_movv512di */

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1HFmode)
        || register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3740; /* *pred_movv1hf */

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2HFmode)
        || register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3741; /* *pred_movv2hf */

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4HFmode)
        || register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3742; /* *pred_movv4hf */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8HFmode)
        || register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3743; /* *pred_movv8hf */

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16HFmode)
        || register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3744; /* *pred_movv16hf */

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32HFmode)
        || register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3745; /* *pred_movv32hf */

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64HFmode)
        || register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3746; /* *pred_movv64hf */

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128HFmode)
        || register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3747; /* *pred_movv128hf */

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256HFmode)
        || register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3748; /* *pred_movv256hf */

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512HFmode)
        || register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3749; /* *pred_movv512hf */

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024HFmode)
        || register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3750; /* *pred_movv1024hf */

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2048HFmode)
        || register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3751; /* *pred_movv2048hf */

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1SFmode)
        || register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3752; /* *pred_movv1sf */

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2SFmode)
        || register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3753; /* *pred_movv2sf */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4SFmode)
        || register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3754; /* *pred_movv4sf */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8SFmode)
        || register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3755; /* *pred_movv8sf */

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16SFmode)
        || register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3756; /* *pred_movv16sf */

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32SFmode)
        || register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3757; /* *pred_movv32sf */

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64SFmode)
        || register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3758; /* *pred_movv64sf */

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128SFmode)
        || register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3759; /* *pred_movv128sf */

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256SFmode)
        || register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3760; /* *pred_movv256sf */

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512SFmode)
        || register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3761; /* *pred_movv512sf */

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1024SFmode)
        || register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3762; /* *pred_movv1024sf */

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V1DFmode)
        || register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3763; /* *pred_movv1df */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V2DFmode)
        || register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3764; /* *pred_movv2df */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V4DFmode)
        || register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3765; /* *pred_movv4df */

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V8DFmode)
        || register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3766; /* *pred_movv8df */

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V16DFmode)
        || register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3767; /* *pred_movv16df */

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V32DFmode)
        || register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3768; /* *pred_movv32df */

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V64DFmode)
        || register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3769; /* *pred_movv64df */

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V128DFmode)
        || register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3770; /* *pred_movv128df */

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V256DFmode)
        || register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3771; /* *pred_movv256df */

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !(
#line 1912 "../../gcc/config/riscv/vector.md"
((TARGET_VECTOR
    && (register_operand (operands[0], V512DFmode)
        || register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3772; /* *pred_movv512df */

    default:
      return -1;
    }
}

 int
recog_601 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern562 (x2))
    {
    case 0:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15033; /* pred_xorsignrvvm8hf */

    case 1:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15035; /* pred_xorsignrvvm4hf */

    case 2:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15037; /* pred_xorsignrvvm2hf */

    case 3:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15039; /* pred_xorsignrvvm1hf */

    case 4:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15041; /* pred_xorsignrvvmf2hf */

    case 5:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 15043; /* pred_xorsignrvvmf4hf */

    case 6:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15045; /* pred_xorsignrvvm8sf */

    case 7:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15047; /* pred_xorsignrvvm4sf */

    case 8:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15049; /* pred_xorsignrvvm2sf */

    case 9:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15051; /* pred_xorsignrvvm1sf */

    case 10:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 15053; /* pred_xorsignrvvmf2sf */

    case 11:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15055; /* pred_xorsignrvvm8df */

    case 12:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15057; /* pred_xorsignrvvm4df */

    case 13:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15059; /* pred_xorsignrvvm2df */

    case 14:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15061; /* pred_xorsignrvvm1df */

    case 15:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 15063; /* pred_xorsignv1hf */

    case 16:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 15065; /* pred_xorsignv2hf */

    case 17:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 15067; /* pred_xorsignv4hf */

    case 18:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 15069; /* pred_xorsignv8hf */

    case 19:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 15071; /* pred_xorsignv16hf */

    case 20:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15073; /* pred_xorsignv32hf */

    case 21:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15075; /* pred_xorsignv64hf */

    case 22:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15077; /* pred_xorsignv128hf */

    case 23:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15079; /* pred_xorsignv256hf */

    case 24:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15081; /* pred_xorsignv512hf */

    case 25:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15083; /* pred_xorsignv1024hf */

    case 26:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15085; /* pred_xorsignv2048hf */

    case 27:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15087; /* pred_xorsignv1sf */

    case 28:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15089; /* pred_xorsignv2sf */

    case 29:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15091; /* pred_xorsignv4sf */

    case 30:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15093; /* pred_xorsignv8sf */

    case 31:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15095; /* pred_xorsignv16sf */

    case 32:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15097; /* pred_xorsignv32sf */

    case 33:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15099; /* pred_xorsignv64sf */

    case 34:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15101; /* pred_xorsignv128sf */

    case 35:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15103; /* pred_xorsignv256sf */

    case 36:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15105; /* pred_xorsignv512sf */

    case 37:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15107; /* pred_xorsignv1024sf */

    case 38:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15109; /* pred_xorsignv1df */

    case 39:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15111; /* pred_xorsignv2df */

    case 40:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15113; /* pred_xorsignv4df */

    case 41:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15115; /* pred_xorsignv8df */

    case 42:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15117; /* pred_xorsignv16df */

    case 43:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15119; /* pred_xorsignv32df */

    case 44:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15121; /* pred_xorsignv64df */

    case 45:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15123; /* pred_xorsignv128df */

    case 46:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15125; /* pred_xorsignv256df */

    case 47:
      if (!(
#line 6383 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15127; /* pred_xorsignv512df */

    case 48:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15144; /* pred_xorsignrvvm8hf_scalar */

    case 49:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15146; /* pred_xorsignrvvm4hf_scalar */

    case 50:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15148; /* pred_xorsignrvvm2hf_scalar */

    case 51:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15150; /* pred_xorsignrvvm1hf_scalar */

    case 52:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15152; /* pred_xorsignrvvmf2hf_scalar */

    case 53:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 15154; /* pred_xorsignrvvmf4hf_scalar */

    case 54:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15156; /* pred_xorsignrvvm8sf_scalar */

    case 55:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15158; /* pred_xorsignrvvm4sf_scalar */

    case 56:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15160; /* pred_xorsignrvvm2sf_scalar */

    case 57:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15162; /* pred_xorsignrvvm1sf_scalar */

    case 58:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 15164; /* pred_xorsignrvvmf2sf_scalar */

    case 59:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15166; /* pred_xorsignrvvm8df_scalar */

    case 60:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15168; /* pred_xorsignrvvm4df_scalar */

    case 61:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15170; /* pred_xorsignrvvm2df_scalar */

    case 62:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15172; /* pred_xorsignrvvm1df_scalar */

    case 63:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 15174; /* pred_xorsignv1hf_scalar */

    case 64:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 15176; /* pred_xorsignv2hf_scalar */

    case 65:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 15178; /* pred_xorsignv4hf_scalar */

    case 66:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 15180; /* pred_xorsignv8hf_scalar */

    case 67:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 15182; /* pred_xorsignv16hf_scalar */

    case 68:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15184; /* pred_xorsignv32hf_scalar */

    case 69:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15186; /* pred_xorsignv64hf_scalar */

    case 70:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15188; /* pred_xorsignv128hf_scalar */

    case 71:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15190; /* pred_xorsignv256hf_scalar */

    case 72:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15192; /* pred_xorsignv512hf_scalar */

    case 73:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15194; /* pred_xorsignv1024hf_scalar */

    case 74:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15196; /* pred_xorsignv2048hf_scalar */

    case 75:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15198; /* pred_xorsignv1sf_scalar */

    case 76:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15200; /* pred_xorsignv2sf_scalar */

    case 77:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15202; /* pred_xorsignv4sf_scalar */

    case 78:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15204; /* pred_xorsignv8sf_scalar */

    case 79:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15206; /* pred_xorsignv16sf_scalar */

    case 80:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15208; /* pred_xorsignv32sf_scalar */

    case 81:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15210; /* pred_xorsignv64sf_scalar */

    case 82:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15212; /* pred_xorsignv128sf_scalar */

    case 83:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15214; /* pred_xorsignv256sf_scalar */

    case 84:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15216; /* pred_xorsignv512sf_scalar */

    case 85:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15218; /* pred_xorsignv1024sf_scalar */

    case 86:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15220; /* pred_xorsignv1df_scalar */

    case 87:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15222; /* pred_xorsignv2df_scalar */

    case 88:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15224; /* pred_xorsignv4df_scalar */

    case 89:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15226; /* pred_xorsignv8df_scalar */

    case 90:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15228; /* pred_xorsignv16df_scalar */

    case 91:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15230; /* pred_xorsignv32df_scalar */

    case 92:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15232; /* pred_xorsignv64df_scalar */

    case 93:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15234; /* pred_xorsignv128df_scalar */

    case 94:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15236; /* pred_xorsignv256df_scalar */

    case 95:
      if (!(
#line 6425 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15238; /* pred_xorsignv512df_scalar */

    default:
      return -1;
    }
}

 int
recog_607 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[6] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[7] = x7;
  x8 = XEXP (x2, 1);
  switch (XINT (x8, 1))
    {
    case 119:
      x9 = XVECEXP (x8, 0, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          if (pattern670 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
              || !
#line 6152 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14408; /* pred_iotarvvm8qi */

        case E_RVVM4QImode:
          if (pattern670 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
              || !
#line 6152 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14409; /* pred_iotarvvm4qi */

        case E_RVVM2QImode:
          if (pattern670 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
              || !
#line 6152 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14410; /* pred_iotarvvm2qi */

        case E_RVVM1QImode:
          if (pattern670 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
              || !
#line 6152 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14411; /* pred_iotarvvm1qi */

        case E_RVVM8HImode:
          if (pattern670 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
              || !
#line 6152 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14412; /* pred_iotarvvm8hi */

        case E_RVVM4HImode:
          if (pattern670 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
              || !
#line 6152 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14413; /* pred_iotarvvm4hi */

        case E_RVVM2HImode:
          if (pattern670 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
              || !
#line 6152 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14414; /* pred_iotarvvm2hi */

        case E_RVVM1HImode:
          if (pattern670 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
              || !
#line 6152 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14415; /* pred_iotarvvm1hi */

        case E_RVVM8SImode:
          if (pattern670 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
              || !
#line 6152 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14416; /* pred_iotarvvm8si */

        case E_RVVM4SImode:
          if (pattern670 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
              || !
#line 6152 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14417; /* pred_iotarvvm4si */

        case E_RVVM2SImode:
          if (pattern670 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
              || !
#line 6152 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14418; /* pred_iotarvvm2si */

        case E_RVVM1SImode:
          if (pattern670 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
              || !
#line 6152 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 14419; /* pred_iotarvvm1si */

        case E_RVVM8DImode:
          if (pattern670 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 6152 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14420; /* pred_iotarvvm8di */

        case E_RVVM4DImode:
          if (pattern670 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 6152 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14421; /* pred_iotarvvm4di */

        case E_RVVM2DImode:
          if (pattern670 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 6152 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14422; /* pred_iotarvvm2di */

        case E_RVVM1DImode:
          if (pattern670 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 6152 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 14423; /* pred_iotarvvm1di */

        case E_RVVMF2QImode:
          if (pattern670 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
              || !(
#line 6152 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 14424; /* pred_iotarvvmf2qi */

        case E_RVVMF4QImode:
          if (pattern670 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
              || !(
#line 6152 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 14425; /* pred_iotarvvmf4qi */

        case E_RVVMF8QImode:
          if (pattern670 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
              || !(
#line 6152 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 14426; /* pred_iotarvvmf8qi */

        case E_RVVMF2HImode:
          if (pattern670 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
              || !(
#line 6152 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 14427; /* pred_iotarvvmf2hi */

        case E_RVVMF4HImode:
          if (pattern670 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
              || !(
#line 6152 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 14428; /* pred_iotarvvmf4hi */

        case E_RVVMF2SImode:
          if (pattern670 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
              || !(
#line 6152 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 14429; /* pred_iotarvvmf2si */

        default:
          return -1;
        }

    case 120:
      x9 = XVECEXP (x8, 0, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          if (pattern603 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
              || !(
#line 6963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16358; /* pred_rsqrt7rvvm8hf */

        case E_RVVM4HFmode:
          if (pattern603 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
              || !(
#line 6963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16359; /* pred_rsqrt7rvvm4hf */

        case E_RVVM2HFmode:
          if (pattern603 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 6963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16360; /* pred_rsqrt7rvvm2hf */

        case E_RVVM1HFmode:
          if (pattern603 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 6963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16361; /* pred_rsqrt7rvvm1hf */

        case E_RVVMF2HFmode:
          if (pattern603 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 6963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16362; /* pred_rsqrt7rvvmf2hf */

        case E_RVVMF4HFmode:
          if (pattern603 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 6963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 16363; /* pred_rsqrt7rvvmf4hf */

        case E_RVVM8SFmode:
          if (pattern603 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
              || !(
#line 6963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16364; /* pred_rsqrt7rvvm8sf */

        case E_RVVM4SFmode:
          if (pattern603 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 6963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16365; /* pred_rsqrt7rvvm4sf */

        case E_RVVM2SFmode:
          if (pattern603 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 6963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16366; /* pred_rsqrt7rvvm2sf */

        case E_RVVM1SFmode:
          if (pattern603 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 6963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16367; /* pred_rsqrt7rvvm1sf */

        case E_RVVMF2SFmode:
          if (pattern603 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 6963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 16368; /* pred_rsqrt7rvvmf2sf */

        case E_RVVM8DFmode:
          if (pattern603 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 6963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16369; /* pred_rsqrt7rvvm8df */

        case E_RVVM4DFmode:
          if (pattern603 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 6963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16370; /* pred_rsqrt7rvvm4df */

        case E_RVVM2DFmode:
          if (pattern603 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 6963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16371; /* pred_rsqrt7rvvm2df */

        case E_RVVM1DFmode:
          if (pattern603 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 6963 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16372; /* pred_rsqrt7rvvm1df */

        default:
          return -1;
        }

    case 122:
      x9 = XVECEXP (x8, 0, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern671 (x2, 
E_RVVM8HImode, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
              || !(
#line 7005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16388; /* pred_classrvvm8hf */

        case E_RVVM4HImode:
          if (pattern671 (x2, 
E_RVVM4HImode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
              || !(
#line 7005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16389; /* pred_classrvvm4hf */

        case E_RVVM2HImode:
          if (pattern671 (x2, 
E_RVVM2HImode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 7005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16390; /* pred_classrvvm2hf */

        case E_RVVM1HImode:
          if (pattern671 (x2, 
E_RVVM1HImode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 7005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16391; /* pred_classrvvm1hf */

        case E_RVVMF2HImode:
          if (pattern671 (x2, 
E_RVVMF2HImode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 7005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 16392; /* pred_classrvvmf2hf */

        case E_RVVMF4HImode:
          if (pattern671 (x2, 
E_RVVMF4HImode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 7005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 16393; /* pred_classrvvmf4hf */

        case E_RVVM8SImode:
          if (pattern671 (x2, 
E_RVVM8SImode, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
              || !(
#line 7005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16394; /* pred_classrvvm8sf */

        case E_RVVM4SImode:
          if (pattern671 (x2, 
E_RVVM4SImode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 7005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16395; /* pred_classrvvm4sf */

        case E_RVVM2SImode:
          if (pattern671 (x2, 
E_RVVM2SImode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 7005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16396; /* pred_classrvvm2sf */

        case E_RVVM1SImode:
          if (pattern671 (x2, 
E_RVVM1SImode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 7005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 16397; /* pred_classrvvm1sf */

        case E_RVVMF2SImode:
          if (pattern671 (x2, 
E_RVVMF2SImode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 7005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 16398; /* pred_classrvvmf2sf */

        case E_RVVM8DImode:
          if (pattern671 (x2, 
E_RVVM8DImode, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 7005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16399; /* pred_classrvvm8df */

        case E_RVVM4DImode:
          if (pattern671 (x2, 
E_RVVM4DImode, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 7005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16400; /* pred_classrvvm4df */

        case E_RVVM2DImode:
          if (pattern671 (x2, 
E_RVVM2DImode, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 7005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16401; /* pred_classrvvm2df */

        case E_RVVM1DImode:
          if (pattern671 (x2, 
E_RVVM1DImode, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 7005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 16402; /* pred_classrvvm1df */

        default:
          return -1;
        }

    case 127:
      x9 = XVECEXP (x8, 0, 0);
      if (GET_CODE (x9) != FLOAT_TRUNCATE)
        return -1;
      x10 = XEXP (x9, 0);
      operands[3] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM4HFmode:
          if (pattern689 (x2, 
E_RVVM4HFmode, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 990 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18095; /* pred_rod_truncrvvm8sf */

        case E_RVVM2HFmode:
          if (pattern689 (x2, 
E_RVVM2HFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 991 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18096; /* pred_rod_truncrvvm4sf */

        case E_RVVM1HFmode:
          if (pattern689 (x2, 
E_RVVM1HFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 992 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18097; /* pred_rod_truncrvvm2sf */

        case E_RVVMF2HFmode:
          if (pattern689 (x2, 
E_RVVMF2HFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 993 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18098; /* pred_rod_truncrvvm1sf */

        case E_RVVMF4HFmode:
          if (pattern689 (x2, 
E_RVVMF4HFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 994 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18099; /* pred_rod_truncrvvmf2sf */

        case E_RVVM4SFmode:
          if (pattern689 (x2, 
E_RVVM4SFmode, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18100; /* pred_rod_truncrvvm8df */

        case E_RVVM2SFmode:
          if (pattern689 (x2, 
E_RVVM2SFmode, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18101; /* pred_rod_truncrvvm4df */

        case E_RVVM1SFmode:
          if (pattern689 (x2, 
E_RVVM1SFmode, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18102; /* pred_rod_truncrvvm2df */

        case E_RVVMF2SFmode:
          if (pattern689 (x2, 
E_RVVMF2SFmode, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18103; /* pred_rod_truncrvvm1df */

        case E_V1HFmode:
          if (pattern689 (x2, 
E_V1HFmode, 
E_V1SFmode, 
E_V1BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 999 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18104; /* pred_rod_truncv1sf */

        case E_V2HFmode:
          if (pattern689 (x2, 
E_V2HFmode, 
E_V2SFmode, 
E_V2BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1000 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18105; /* pred_rod_truncv2sf */

        case E_V4HFmode:
          if (pattern689 (x2, 
E_V4HFmode, 
E_V4SFmode, 
E_V4BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1001 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18106; /* pred_rod_truncv4sf */

        case E_V8HFmode:
          if (pattern689 (x2, 
E_V8HFmode, 
E_V8SFmode, 
E_V8BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1002 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 18107; /* pred_rod_truncv8sf */

        case E_V16HFmode:
          if (pattern689 (x2, 
E_V16HFmode, 
E_V16SFmode, 
E_V16BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1003 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18108; /* pred_rod_truncv16sf */

        case E_V32HFmode:
          if (pattern689 (x2, 
E_V32HFmode, 
E_V32SFmode, 
E_V32BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1004 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18109; /* pred_rod_truncv32sf */

        case E_V64HFmode:
          if (pattern689 (x2, 
E_V64HFmode, 
E_V64SFmode, 
E_V64BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1005 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18110; /* pred_rod_truncv64sf */

        case E_V128HFmode:
          if (pattern689 (x2, 
E_V128HFmode, 
E_V128SFmode, 
E_V128BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1006 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18111; /* pred_rod_truncv128sf */

        case E_V256HFmode:
          if (pattern689 (x2, 
E_V256HFmode, 
E_V256SFmode, 
E_V256BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1007 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18112; /* pred_rod_truncv256sf */

        case E_V512HFmode:
          if (pattern689 (x2, 
E_V512HFmode, 
E_V512SFmode, 
E_V512BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1008 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18113; /* pred_rod_truncv512sf */

        case E_V1024HFmode:
          if (pattern689 (x2, 
E_V1024HFmode, 
E_V1024SFmode, 
E_V1024BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1009 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18114; /* pred_rod_truncv1024sf */

        case E_V1SFmode:
          if (pattern689 (x2, 
E_V1SFmode, 
E_V1DFmode, 
E_V1BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1010 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18115; /* pred_rod_truncv1df */

        case E_V2SFmode:
          if (pattern689 (x2, 
E_V2SFmode, 
E_V2DFmode, 
E_V2BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1011 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18116; /* pred_rod_truncv2df */

        case E_V4SFmode:
          if (pattern689 (x2, 
E_V4SFmode, 
E_V4DFmode, 
E_V4BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1012 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 18117; /* pred_rod_truncv4df */

        case E_V8SFmode:
          if (pattern689 (x2, 
E_V8SFmode, 
E_V8DFmode, 
E_V8BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1013 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18118; /* pred_rod_truncv8df */

        case E_V16SFmode:
          if (pattern689 (x2, 
E_V16SFmode, 
E_V16DFmode, 
E_V16BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1014 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18119; /* pred_rod_truncv16df */

        case E_V32SFmode:
          if (pattern689 (x2, 
E_V32SFmode, 
E_V32DFmode, 
E_V32BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1015 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18120; /* pred_rod_truncv32df */

        case E_V64SFmode:
          if (pattern689 (x2, 
E_V64SFmode, 
E_V64DFmode, 
E_V64BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1016 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18121; /* pred_rod_truncv64df */

        case E_V128SFmode:
          if (pattern689 (x2, 
E_V128SFmode, 
E_V128DFmode, 
E_V128BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1017 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18122; /* pred_rod_truncv128df */

        case E_V256SFmode:
          if (pattern689 (x2, 
E_V256SFmode, 
E_V256DFmode, 
E_V256BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1018 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18123; /* pred_rod_truncv256df */

        case E_V512SFmode:
          if (pattern689 (x2, 
E_V512SFmode, 
E_V512DFmode, 
E_V512BImode) != 0
              || !(
#line 7745 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1019 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18124; /* pred_rod_truncv512df */

        default:
          return -1;
        }

    case 196:
      return recog_605 (x1, insn, pnum_clobbers);

    case 197:
      return recog_604 (x1, insn, pnum_clobbers);

    case 198:
      return recog_603 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_694 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V8SImode, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_659 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V8SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8SImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return 13199; /* *pred_maddv8si */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return -1;
  return 13267; /* *pred_maccv8si */
}

 int
recog_701 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_652 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V256HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 13192; /* *pred_maddv256hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 13260; /* *pred_maccv256hi */
}

 int
recog_708 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V2HImode, 
E_V2BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_645 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V2HImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2HImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return 13185; /* *pred_maddv2hi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return -1;
  return 13253; /* *pred_maccv2hi */
}

 int
recog_715 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern570 (x2, 
E_V128QImode, 
E_V128BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_638 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!register_operand (operands[3], E_V128QImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5357 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return 13178; /* *pred_maddv128qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5386 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13246; /* *pred_maccv128qi */
}

 int
recog_722 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 13347; /* *pred_maddv16di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13415; /* *pred_maccv16di_scalar */
}

 int
recog_729 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return 13340; /* *pred_maddv256si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 13408; /* *pred_maccv256si_scalar */
}

 int
recog_736 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 13333; /* *pred_maddv2si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 13401; /* *pred_maccv2si_scalar */
}

 int
recog_743 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern701 (x2, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5435 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return 13326; /* *pred_maddv64hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 13394; /* *pred_maccv64hi_scalar */
}

 int
recog_750 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      switch (pattern566 (x2))
        {
        case 0:
          if (!
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9302; /* pred_dual_widen_addurvvm8hi */

        case 1:
          if (!
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9308; /* pred_dual_widen_addurvvm4hi */

        case 2:
          if (!
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9314; /* pred_dual_widen_addurvvm2hi */

        case 3:
          if (!
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9320; /* pred_dual_widen_addurvvm1hi */

        case 4:
          if (!
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9326; /* pred_dual_widen_addurvvmf2hi */

        case 5:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9332; /* pred_dual_widen_addurvvmf4hi */

        case 6:
          if (!
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9338; /* pred_dual_widen_addurvvm8si */

        case 7:
          if (!
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9344; /* pred_dual_widen_addurvvm4si */

        case 8:
          if (!
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9350; /* pred_dual_widen_addurvvm2si */

        case 9:
          if (!
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9356; /* pred_dual_widen_addurvvm1si */

        case 10:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9362; /* pred_dual_widen_addurvvmf2si */

        case 11:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9368; /* pred_dual_widen_addurvvm8di */

        case 12:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9374; /* pred_dual_widen_addurvvm4di */

        case 13:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9380; /* pred_dual_widen_addurvvm2di */

        case 14:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9386; /* pred_dual_widen_addurvvm1di */

        case 15:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9392; /* pred_dual_widen_adduv1hi */

        case 16:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9398; /* pred_dual_widen_adduv2hi */

        case 17:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9404; /* pred_dual_widen_adduv4hi */

        case 18:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9410; /* pred_dual_widen_adduv8hi */

        case 19:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9416; /* pred_dual_widen_adduv16hi */

        case 20:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9422; /* pred_dual_widen_adduv32hi */

        case 21:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9428; /* pred_dual_widen_adduv64hi */

        case 22:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9434; /* pred_dual_widen_adduv128hi */

        case 23:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9440; /* pred_dual_widen_adduv256hi */

        case 24:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9446; /* pred_dual_widen_adduv512hi */

        case 25:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9452; /* pred_dual_widen_adduv1024hi */

        case 26:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9458; /* pred_dual_widen_adduv2048hi */

        case 27:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9464; /* pred_dual_widen_adduv1si */

        case 28:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9470; /* pred_dual_widen_adduv2si */

        case 29:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9476; /* pred_dual_widen_adduv4si */

        case 30:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9482; /* pred_dual_widen_adduv8si */

        case 31:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9488; /* pred_dual_widen_adduv16si */

        case 32:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9494; /* pred_dual_widen_adduv32si */

        case 33:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9500; /* pred_dual_widen_adduv64si */

        case 34:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9506; /* pred_dual_widen_adduv128si */

        case 35:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9512; /* pred_dual_widen_adduv256si */

        case 36:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9518; /* pred_dual_widen_adduv512si */

        case 37:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9524; /* pred_dual_widen_adduv1024si */

        case 38:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9530; /* pred_dual_widen_adduv1di */

        case 39:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9536; /* pred_dual_widen_adduv2di */

        case 40:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9542; /* pred_dual_widen_adduv4di */

        case 41:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9548; /* pred_dual_widen_adduv8di */

        case 42:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9554; /* pred_dual_widen_adduv16di */

        case 43:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9560; /* pred_dual_widen_adduv32di */

        case 44:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9566; /* pred_dual_widen_adduv64di */

        case 45:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9572; /* pred_dual_widen_adduv128di */

        case 46:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9578; /* pred_dual_widen_adduv256di */

        case 47:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9584; /* pred_dual_widen_adduv512di */

        case 48:
          if (!
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9590; /* pred_dual_widen_addurvvm8hi_scalar */

        case 49:
          if (!
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9596; /* pred_dual_widen_addurvvm4hi_scalar */

        case 50:
          if (!
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9602; /* pred_dual_widen_addurvvm2hi_scalar */

        case 51:
          if (!
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9608; /* pred_dual_widen_addurvvm1hi_scalar */

        case 52:
          if (!
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9614; /* pred_dual_widen_addurvvmf2hi_scalar */

        case 53:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9620; /* pred_dual_widen_addurvvmf4hi_scalar */

        case 54:
          if (!
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9626; /* pred_dual_widen_addurvvm8si_scalar */

        case 55:
          if (!
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9632; /* pred_dual_widen_addurvvm4si_scalar */

        case 56:
          if (!
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9638; /* pred_dual_widen_addurvvm2si_scalar */

        case 57:
          if (!
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9644; /* pred_dual_widen_addurvvm1si_scalar */

        case 58:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9650; /* pred_dual_widen_addurvvmf2si_scalar */

        case 59:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9656; /* pred_dual_widen_addurvvm8di_scalar */

        case 60:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9662; /* pred_dual_widen_addurvvm4di_scalar */

        case 61:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9668; /* pred_dual_widen_addurvvm2di_scalar */

        case 62:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9674; /* pred_dual_widen_addurvvm1di_scalar */

        case 63:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9680; /* pred_dual_widen_adduv1hi_scalar */

        case 64:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9686; /* pred_dual_widen_adduv2hi_scalar */

        case 65:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9692; /* pred_dual_widen_adduv4hi_scalar */

        case 66:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9698; /* pred_dual_widen_adduv8hi_scalar */

        case 67:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9704; /* pred_dual_widen_adduv16hi_scalar */

        case 68:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9710; /* pred_dual_widen_adduv32hi_scalar */

        case 69:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9716; /* pred_dual_widen_adduv64hi_scalar */

        case 70:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9722; /* pred_dual_widen_adduv128hi_scalar */

        case 71:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9728; /* pred_dual_widen_adduv256hi_scalar */

        case 72:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9734; /* pred_dual_widen_adduv512hi_scalar */

        case 73:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9740; /* pred_dual_widen_adduv1024hi_scalar */

        case 74:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9746; /* pred_dual_widen_adduv2048hi_scalar */

        case 75:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9752; /* pred_dual_widen_adduv1si_scalar */

        case 76:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9758; /* pred_dual_widen_adduv2si_scalar */

        case 77:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9764; /* pred_dual_widen_adduv4si_scalar */

        case 78:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9770; /* pred_dual_widen_adduv8si_scalar */

        case 79:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9776; /* pred_dual_widen_adduv16si_scalar */

        case 80:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9782; /* pred_dual_widen_adduv32si_scalar */

        case 81:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9788; /* pred_dual_widen_adduv64si_scalar */

        case 82:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9794; /* pred_dual_widen_adduv128si_scalar */

        case 83:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9800; /* pred_dual_widen_adduv256si_scalar */

        case 84:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9806; /* pred_dual_widen_adduv512si_scalar */

        case 85:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9812; /* pred_dual_widen_adduv1024si_scalar */

        case 86:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9818; /* pred_dual_widen_adduv1di_scalar */

        case 87:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9824; /* pred_dual_widen_adduv2di_scalar */

        case 88:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9830; /* pred_dual_widen_adduv4di_scalar */

        case 89:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9836; /* pred_dual_widen_adduv8di_scalar */

        case 90:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9842; /* pred_dual_widen_adduv16di_scalar */

        case 91:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9848; /* pred_dual_widen_adduv32di_scalar */

        case 92:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9854; /* pred_dual_widen_adduv64di_scalar */

        case 93:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9860; /* pred_dual_widen_adduv128di_scalar */

        case 94:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9866; /* pred_dual_widen_adduv256di_scalar */

        case 95:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9872; /* pred_dual_widen_adduv512di_scalar */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern567 (x2))
        {
        case 0:
          if (!
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9974; /* pred_single_widen_addurvvm8hi */

        case 1:
          if (!
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9976; /* pred_single_widen_addurvvm4hi */

        case 2:
          if (!
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9978; /* pred_single_widen_addurvvm2hi */

        case 3:
          if (!
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9980; /* pred_single_widen_addurvvm1hi */

        case 4:
          if (!
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9982; /* pred_single_widen_addurvvmf2hi */

        case 5:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9984; /* pred_single_widen_addurvvmf4hi */

        case 6:
          if (!
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9986; /* pred_single_widen_addurvvm8si */

        case 7:
          if (!
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9988; /* pred_single_widen_addurvvm4si */

        case 8:
          if (!
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9990; /* pred_single_widen_addurvvm2si */

        case 9:
          if (!
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9992; /* pred_single_widen_addurvvm1si */

        case 10:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9994; /* pred_single_widen_addurvvmf2si */

        case 11:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9996; /* pred_single_widen_addurvvm8di */

        case 12:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9998; /* pred_single_widen_addurvvm4di */

        case 13:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10000; /* pred_single_widen_addurvvm2di */

        case 14:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10002; /* pred_single_widen_addurvvm1di */

        case 15:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10004; /* pred_single_widen_adduv1hi */

        case 16:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10006; /* pred_single_widen_adduv2hi */

        case 17:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10008; /* pred_single_widen_adduv4hi */

        case 18:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10010; /* pred_single_widen_adduv8hi */

        case 19:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10012; /* pred_single_widen_adduv16hi */

        case 20:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10014; /* pred_single_widen_adduv32hi */

        case 21:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10016; /* pred_single_widen_adduv64hi */

        case 22:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10018; /* pred_single_widen_adduv128hi */

        case 23:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10020; /* pred_single_widen_adduv256hi */

        case 24:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10022; /* pred_single_widen_adduv512hi */

        case 25:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10024; /* pred_single_widen_adduv1024hi */

        case 26:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10026; /* pred_single_widen_adduv2048hi */

        case 27:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10028; /* pred_single_widen_adduv1si */

        case 28:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10030; /* pred_single_widen_adduv2si */

        case 29:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10032; /* pred_single_widen_adduv4si */

        case 30:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10034; /* pred_single_widen_adduv8si */

        case 31:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10036; /* pred_single_widen_adduv16si */

        case 32:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10038; /* pred_single_widen_adduv32si */

        case 33:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10040; /* pred_single_widen_adduv64si */

        case 34:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10042; /* pred_single_widen_adduv128si */

        case 35:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10044; /* pred_single_widen_adduv256si */

        case 36:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10046; /* pred_single_widen_adduv512si */

        case 37:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10048; /* pred_single_widen_adduv1024si */

        case 38:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10050; /* pred_single_widen_adduv1di */

        case 39:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10052; /* pred_single_widen_adduv2di */

        case 40:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10054; /* pred_single_widen_adduv4di */

        case 41:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10056; /* pred_single_widen_adduv8di */

        case 42:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10058; /* pred_single_widen_adduv16di */

        case 43:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10060; /* pred_single_widen_adduv32di */

        case 44:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10062; /* pred_single_widen_adduv64di */

        case 45:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10064; /* pred_single_widen_adduv128di */

        case 46:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10066; /* pred_single_widen_adduv256di */

        case 47:
          if (!(
#line 4070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10068; /* pred_single_widen_adduv512di */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern569 (x2))
        {
        case 0:
          if (!
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10550; /* pred_zero_extendrvvm8hi */

        case 1:
          if (!
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10552; /* pred_zero_extendrvvm4hi */

        case 2:
          if (!
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10554; /* pred_zero_extendrvvm2hi */

        case 3:
          if (!
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10556; /* pred_zero_extendrvvm1hi */

        case 4:
          if (!
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10558; /* pred_zero_extendrvvmf2hi */

        case 5:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10560; /* pred_zero_extendrvvmf4hi */

        case 6:
          if (!
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10562; /* pred_zero_extendrvvm8si */

        case 7:
          if (!
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10564; /* pred_zero_extendrvvm4si */

        case 8:
          if (!
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10566; /* pred_zero_extendrvvm2si */

        case 9:
          if (!
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10568; /* pred_zero_extendrvvm1si */

        case 10:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10570; /* pred_zero_extendrvvmf2si */

        case 11:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10572; /* pred_zero_extendrvvm8di */

        case 12:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10574; /* pred_zero_extendrvvm4di */

        case 13:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10576; /* pred_zero_extendrvvm2di */

        case 14:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10578; /* pred_zero_extendrvvm1di */

        case 15:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10580; /* pred_zero_extendv1hi */

        case 16:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10582; /* pred_zero_extendv2hi */

        case 17:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10584; /* pred_zero_extendv4hi */

        case 18:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10586; /* pred_zero_extendv8hi */

        case 19:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10588; /* pred_zero_extendv16hi */

        case 20:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10590; /* pred_zero_extendv32hi */

        case 21:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10592; /* pred_zero_extendv64hi */

        case 22:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10594; /* pred_zero_extendv128hi */

        case 23:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10596; /* pred_zero_extendv256hi */

        case 24:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10598; /* pred_zero_extendv512hi */

        case 25:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10600; /* pred_zero_extendv1024hi */

        case 26:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10602; /* pred_zero_extendv2048hi */

        case 27:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10604; /* pred_zero_extendv1si */

        case 28:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10606; /* pred_zero_extendv2si */

        case 29:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10608; /* pred_zero_extendv4si */

        case 30:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10610; /* pred_zero_extendv8si */

        case 31:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10612; /* pred_zero_extendv16si */

        case 32:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10614; /* pred_zero_extendv32si */

        case 33:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10616; /* pred_zero_extendv64si */

        case 34:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10618; /* pred_zero_extendv128si */

        case 35:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10620; /* pred_zero_extendv256si */

        case 36:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10622; /* pred_zero_extendv512si */

        case 37:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10624; /* pred_zero_extendv1024si */

        case 38:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10626; /* pred_zero_extendv1di */

        case 39:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10628; /* pred_zero_extendv2di */

        case 40:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10630; /* pred_zero_extendv4di */

        case 41:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10632; /* pred_zero_extendv8di */

        case 42:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10634; /* pred_zero_extendv16di */

        case 43:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10636; /* pred_zero_extendv32di */

        case 44:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10638; /* pred_zero_extendv64di */

        case 45:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10640; /* pred_zero_extendv128di */

        case 46:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10642; /* pred_zero_extendv256di */

        case 47:
          if (!(
#line 4206 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10644; /* pred_zero_extendv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_789 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V2048QImode) == 0
      && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return 13482; /* *pred_minus_mulv2048qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V2048QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V2048QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2048QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return 13550; /* *pred_nmsubv2048qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13618; /* *pred_nmsacv2048qi */
}

 int
recog_797 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern574 (x2, 
E_V8QImode, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[5] = x4;
  if (pattern706 (x2, 
E_V8QImode) == 0
      && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return 13474; /* *pred_minus_mulv8qi_undef */
  operands[4] = x4;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  operands[5] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[6] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[7] = x8;
  x9 = XVECEXP (x5, 0, 4);
  operands[8] = x9;
  x10 = XEXP (x3, 1);
  if (GET_MODE (x10) != E_V8QImode)
    return -1;
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_V8QImode))
    return -1;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8QImode))
    return -1;
  x13 = XEXP (x2, 2);
  if (rtx_equal_p (x13, operands[2])
      && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return 13542; /* *pred_nmsubv8qi */
  if (!rtx_equal_p (x13, operands[4])
      || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
    return -1;
  return 13610; /* *pred_nmsacv8qi */
}

 int
recog_805 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V256DImode, 
E_V256BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return 13719; /* *pred_nmsubv256di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13787; /* *pred_nmsacv256di_scalar */
}

 int
recog_811 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 13713; /* *pred_nmsubv4di_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 13781; /* *pred_nmsacv4di_scalar */
}

 int
recog_818 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return 13706; /* *pred_nmsubv64si_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 13774; /* *pred_nmsacv64si_scalar */
}

 int
recog_826 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern710 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0)
    return -1;
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, operands[3])
      && (
#line 5719 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return 13698; /* *pred_nmsubv1024hi_scalar */
  if (!rtx_equal_p (x3, operands[4])
      || !(
#line 5749 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 13766; /* *pred_nmsacv1024hi_scalar */
}

 int
recog_834 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern574 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern706 (x2, 
E_RVVM8QImode) == 0
          && 
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13449; /* *pred_minus_mulrvvm8qi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM8QImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM8QImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM8QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13517; /* *pred_nmsubrvvm8qi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13585; /* *pred_nmsacrvvm8qi */

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern574 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern706 (x2, 
E_RVVM4QImode) == 0
          && 
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13450; /* *pred_minus_mulrvvm4qi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM4QImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM4QImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM4QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13518; /* *pred_nmsubrvvm4qi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13586; /* *pred_nmsacrvvm4qi */

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern574 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern706 (x2, 
E_RVVM2QImode) == 0
          && 
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13451; /* *pred_minus_mulrvvm2qi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM2QImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM2QImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM2QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13519; /* *pred_nmsubrvvm2qi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13587; /* *pred_nmsacrvvm2qi */

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern574 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern706 (x2, 
E_RVVM1QImode) == 0
          && 
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13452; /* *pred_minus_mulrvvm1qi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM1QImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM1QImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM1QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13520; /* *pred_nmsubrvvm1qi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13588; /* *pred_nmsacrvvm1qi */

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern574 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern706 (x2, 
E_RVVM8HImode) == 0
          && 
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13453; /* *pred_minus_mulrvvm8hi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM8HImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM8HImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM8HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13521; /* *pred_nmsubrvvm8hi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13589; /* *pred_nmsacrvvm8hi */

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern574 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern706 (x2, 
E_RVVM4HImode) == 0
          && 
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13454; /* *pred_minus_mulrvvm4hi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM4HImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM4HImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM4HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13522; /* *pred_nmsubrvvm4hi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13590; /* *pred_nmsacrvvm4hi */

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern574 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern706 (x2, 
E_RVVM2HImode) == 0
          && 
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13455; /* *pred_minus_mulrvvm2hi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM2HImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM2HImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM2HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13523; /* *pred_nmsubrvvm2hi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13591; /* *pred_nmsacrvvm2hi */

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern574 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern706 (x2, 
E_RVVM1HImode) == 0
          && 
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13456; /* *pred_minus_mulrvvm1hi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM1HImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM1HImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM1HImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13524; /* *pred_nmsubrvvm1hi */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13592; /* *pred_nmsacrvvm1hi */

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern574 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern706 (x2, 
E_RVVM8SImode) == 0
          && 
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13457; /* *pred_minus_mulrvvm8si_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM8SImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM8SImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM8SImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13525; /* *pred_nmsubrvvm8si */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13593; /* *pred_nmsacrvvm8si */

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern574 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern706 (x2, 
E_RVVM4SImode) == 0
          && 
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13458; /* *pred_minus_mulrvvm4si_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM4SImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM4SImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM4SImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13526; /* *pred_nmsubrvvm4si */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13594; /* *pred_nmsacrvvm4si */

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern574 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern706 (x2, 
E_RVVM2SImode) == 0
          && 
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13459; /* *pred_minus_mulrvvm2si_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM2SImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM2SImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM2SImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13527; /* *pred_nmsubrvvm2si */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13595; /* *pred_nmsacrvvm2si */

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern574 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern706 (x2, 
E_RVVM1SImode) == 0
          && 
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13460; /* *pred_minus_mulrvvm1si_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM1SImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM1SImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM1SImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && 
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 13528; /* *pred_nmsubrvvm1si */
      if (!rtx_equal_p (x13, operands[4])
          || !
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 13596; /* *pred_nmsacrvvm1si */

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern574 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern706 (x2, 
E_RVVM8DImode) == 0
          && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13461; /* *pred_minus_mulrvvm8di_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM8DImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM8DImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM8DImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13529; /* *pred_nmsubrvvm8di */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13597; /* *pred_nmsacrvvm8di */

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern574 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern706 (x2, 
E_RVVM4DImode) == 0
          && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13462; /* *pred_minus_mulrvvm4di_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM4DImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM4DImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM4DImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13530; /* *pred_nmsubrvvm4di */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13598; /* *pred_nmsacrvvm4di */

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern574 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern706 (x2, 
E_RVVM2DImode) == 0
          && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13463; /* *pred_minus_mulrvvm2di_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM2DImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM2DImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM2DImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13531; /* *pred_nmsubrvvm2di */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13599; /* *pred_nmsacrvvm2di */

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern574 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern706 (x2, 
E_RVVM1DImode) == 0
          && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13464; /* *pred_minus_mulrvvm1di_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVM1DImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVM1DImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVM1DImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 13532; /* *pred_nmsubrvvm1di */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13600; /* *pred_nmsacrvvm1di */

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern574 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern706 (x2, 
E_RVVMF2QImode) == 0
          && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13465; /* *pred_minus_mulrvvmf2qi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVMF2QImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVMF2QImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVMF2QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13533; /* *pred_nmsubrvvmf2qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 13601; /* *pred_nmsacrvvmf2qi */

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern574 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern706 (x2, 
E_RVVMF4QImode) == 0
          && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13466; /* *pred_minus_mulrvvmf4qi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVMF4QImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVMF4QImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVMF4QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 13534; /* *pred_nmsubrvvmf4qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 13602; /* *pred_nmsacrvvmf4qi */

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern574 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      x4 = XEXP (x3, 0);
      operands[5] = x4;
      if (pattern706 (x2, 
E_RVVMF8QImode) == 0
          && (
#line 5613 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 13467; /* *pred_minus_mulrvvmf8qi_undef */
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_RVVMF8QImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      if (!register_operand (operands[2], E_RVVMF8QImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      if (!register_operand (operands[3], E_RVVMF8QImode))
        return -1;
      x13 = XEXP (x2, 2);
      if (rtx_equal_p (x13, operands[2])
          && (
#line 5639 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 13535; /* *pred_nmsubrvvmf8qi */
      if (!rtx_equal_p (x13, operands[4])
          || !(
#line 5668 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 13603; /* *pred_nmsacrvvmf8qi */

    case E_RVVMF2HImode:
      return recog_803 (x1, insn, pnum_clobbers);

    case E_RVVMF4HImode:
      return recog_802 (x1, insn, pnum_clobbers);

    case E_RVVMF2SImode:
      return recog_801 (x1, insn, pnum_clobbers);

    case E_V1QImode:
      return recog_800 (x1, insn, pnum_clobbers);

    case E_V2QImode:
      return recog_799 (x1, insn, pnum_clobbers);

    case E_V4QImode:
      return recog_798 (x1, insn, pnum_clobbers);

    case E_V8QImode:
      return recog_797 (x1, insn, pnum_clobbers);

    case E_V16QImode:
      return recog_796 (x1, insn, pnum_clobbers);

    case E_V32QImode:
      return recog_795 (x1, insn, pnum_clobbers);

    case E_V64QImode:
      return recog_794 (x1, insn, pnum_clobbers);

    case E_V128QImode:
      return recog_793 (x1, insn, pnum_clobbers);

    case E_V256QImode:
      return recog_792 (x1, insn, pnum_clobbers);

    case E_V512QImode:
      return recog_791 (x1, insn, pnum_clobbers);

    case E_V1024QImode:
      return recog_790 (x1, insn, pnum_clobbers);

    case E_V2048QImode:
      return recog_789 (x1, insn, pnum_clobbers);

    case E_V4096QImode:
      return recog_788 (x1, insn, pnum_clobbers);

    case E_V1HImode:
      return recog_787 (x1, insn, pnum_clobbers);

    case E_V2HImode:
      return recog_786 (x1, insn, pnum_clobbers);

    case E_V4HImode:
      return recog_785 (x1, insn, pnum_clobbers);

    case E_V8HImode:
      return recog_784 (x1, insn, pnum_clobbers);

    case E_V16HImode:
      return recog_783 (x1, insn, pnum_clobbers);

    case E_V32HImode:
      return recog_782 (x1, insn, pnum_clobbers);

    case E_V64HImode:
      return recog_781 (x1, insn, pnum_clobbers);

    case E_V128HImode:
      return recog_780 (x1, insn, pnum_clobbers);

    case E_V256HImode:
      return recog_779 (x1, insn, pnum_clobbers);

    case E_V512HImode:
      return recog_778 (x1, insn, pnum_clobbers);

    case E_V1024HImode:
      return recog_777 (x1, insn, pnum_clobbers);

    case E_V2048HImode:
      return recog_776 (x1, insn, pnum_clobbers);

    case E_V1SImode:
      return recog_775 (x1, insn, pnum_clobbers);

    case E_V2SImode:
      return recog_774 (x1, insn, pnum_clobbers);

    case E_V4SImode:
      return recog_773 (x1, insn, pnum_clobbers);

    case E_V8SImode:
      return recog_772 (x1, insn, pnum_clobbers);

    case E_V16SImode:
      return recog_771 (x1, insn, pnum_clobbers);

    case E_V32SImode:
      return recog_770 (x1, insn, pnum_clobbers);

    case E_V64SImode:
      return recog_769 (x1, insn, pnum_clobbers);

    case E_V128SImode:
      return recog_768 (x1, insn, pnum_clobbers);

    case E_V256SImode:
      return recog_767 (x1, insn, pnum_clobbers);

    case E_V512SImode:
      return recog_766 (x1, insn, pnum_clobbers);

    case E_V1024SImode:
      return recog_765 (x1, insn, pnum_clobbers);

    case E_V1DImode:
      return recog_764 (x1, insn, pnum_clobbers);

    case E_V2DImode:
      return recog_763 (x1, insn, pnum_clobbers);

    case E_V4DImode:
      return recog_762 (x1, insn, pnum_clobbers);

    case E_V8DImode:
      return recog_761 (x1, insn, pnum_clobbers);

    case E_V16DImode:
      return recog_760 (x1, insn, pnum_clobbers);

    case E_V32DImode:
      return recog_759 (x1, insn, pnum_clobbers);

    case E_V64DImode:
      return recog_758 (x1, insn, pnum_clobbers);

    case E_V128DImode:
      return recog_757 (x1, insn, pnum_clobbers);

    case E_V256DImode:
      return recog_756 (x1, insn, pnum_clobbers);

    case E_V512DImode:
      return recog_755 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_861 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern493 (x2, 
E_V2SImode, 
E_V2BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V2SImode)
      && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return 6318; /* pred_ashlv2si */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
    return -1;
  return 6797; /* pred_ashlv2si_scalar */
}

 int
recog_866 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern493 (x2, 
E_V256HImode, 
E_V256BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V256HImode)
      && (
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return 6233; /* pred_ashlv256hi */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 2759 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 6782; /* pred_ashlv256hi_scalar */
}

 int
recog_871 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern672 (x2, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V512SImode)
      && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return 32896; /* pred_vwsllv512di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 32944; /* pred_vwsllv512di_scalar */
}

 int
recog_876 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern672 (x2, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode) != 0)
    return -1;
  if (vector_shift_operand (operands[4], E_V16SImode)
      && (
#line 301 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return 32891; /* pred_vwsllv16di */
  if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
      || !(
#line 322 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 32939; /* pred_vwsllv16di_scalar */
}

 int
recog_881 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  x6 = XEXP (x3, 1);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTEND:
      switch (pattern534 (x2))
        {
        case 0:
          if (!
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9305; /* pred_dual_widen_mulsrvvm8hi */

        case 1:
          if (!
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9311; /* pred_dual_widen_mulsrvvm4hi */

        case 2:
          if (!
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9317; /* pred_dual_widen_mulsrvvm2hi */

        case 3:
          if (!
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9323; /* pred_dual_widen_mulsrvvm1hi */

        case 4:
          if (!
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9329; /* pred_dual_widen_mulsrvvmf2hi */

        case 5:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9335; /* pred_dual_widen_mulsrvvmf4hi */

        case 6:
          if (!
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9341; /* pred_dual_widen_mulsrvvm8si */

        case 7:
          if (!
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9347; /* pred_dual_widen_mulsrvvm4si */

        case 8:
          if (!
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9353; /* pred_dual_widen_mulsrvvm2si */

        case 9:
          if (!
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9359; /* pred_dual_widen_mulsrvvm1si */

        case 10:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9365; /* pred_dual_widen_mulsrvvmf2si */

        case 11:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9371; /* pred_dual_widen_mulsrvvm8di */

        case 12:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9377; /* pred_dual_widen_mulsrvvm4di */

        case 13:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9383; /* pred_dual_widen_mulsrvvm2di */

        case 14:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9389; /* pred_dual_widen_mulsrvvm1di */

        case 15:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9395; /* pred_dual_widen_mulsv1hi */

        case 16:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9401; /* pred_dual_widen_mulsv2hi */

        case 17:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9407; /* pred_dual_widen_mulsv4hi */

        case 18:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9413; /* pred_dual_widen_mulsv8hi */

        case 19:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9419; /* pred_dual_widen_mulsv16hi */

        case 20:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9425; /* pred_dual_widen_mulsv32hi */

        case 21:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9431; /* pred_dual_widen_mulsv64hi */

        case 22:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9437; /* pred_dual_widen_mulsv128hi */

        case 23:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9443; /* pred_dual_widen_mulsv256hi */

        case 24:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9449; /* pred_dual_widen_mulsv512hi */

        case 25:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9455; /* pred_dual_widen_mulsv1024hi */

        case 26:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9461; /* pred_dual_widen_mulsv2048hi */

        case 27:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9467; /* pred_dual_widen_mulsv1si */

        case 28:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9473; /* pred_dual_widen_mulsv2si */

        case 29:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9479; /* pred_dual_widen_mulsv4si */

        case 30:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9485; /* pred_dual_widen_mulsv8si */

        case 31:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9491; /* pred_dual_widen_mulsv16si */

        case 32:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9497; /* pred_dual_widen_mulsv32si */

        case 33:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9503; /* pred_dual_widen_mulsv64si */

        case 34:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9509; /* pred_dual_widen_mulsv128si */

        case 35:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9515; /* pred_dual_widen_mulsv256si */

        case 36:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9521; /* pred_dual_widen_mulsv512si */

        case 37:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9527; /* pred_dual_widen_mulsv1024si */

        case 38:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9533; /* pred_dual_widen_mulsv1di */

        case 39:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9539; /* pred_dual_widen_mulsv2di */

        case 40:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9545; /* pred_dual_widen_mulsv4di */

        case 41:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9551; /* pred_dual_widen_mulsv8di */

        case 42:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9557; /* pred_dual_widen_mulsv16di */

        case 43:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9563; /* pred_dual_widen_mulsv32di */

        case 44:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9569; /* pred_dual_widen_mulsv64di */

        case 45:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9575; /* pred_dual_widen_mulsv128di */

        case 46:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9581; /* pred_dual_widen_mulsv256di */

        case 47:
          if (!(
#line 4005 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9587; /* pred_dual_widen_mulsv512di */

        case 48:
          if (!
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9593; /* pred_dual_widen_mulsrvvm8hi_scalar */

        case 49:
          if (!
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9599; /* pred_dual_widen_mulsrvvm4hi_scalar */

        case 50:
          if (!
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9605; /* pred_dual_widen_mulsrvvm2hi_scalar */

        case 51:
          if (!
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9611; /* pred_dual_widen_mulsrvvm1hi_scalar */

        case 52:
          if (!
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9617; /* pred_dual_widen_mulsrvvmf2hi_scalar */

        case 53:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9623; /* pred_dual_widen_mulsrvvmf4hi_scalar */

        case 54:
          if (!
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9629; /* pred_dual_widen_mulsrvvm8si_scalar */

        case 55:
          if (!
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9635; /* pred_dual_widen_mulsrvvm4si_scalar */

        case 56:
          if (!
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9641; /* pred_dual_widen_mulsrvvm2si_scalar */

        case 57:
          if (!
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 9647; /* pred_dual_widen_mulsrvvm1si_scalar */

        case 58:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9653; /* pred_dual_widen_mulsrvvmf2si_scalar */

        case 59:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9659; /* pred_dual_widen_mulsrvvm8di_scalar */

        case 60:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9665; /* pred_dual_widen_mulsrvvm4di_scalar */

        case 61:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9671; /* pred_dual_widen_mulsrvvm2di_scalar */

        case 62:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9677; /* pred_dual_widen_mulsrvvm1di_scalar */

        case 63:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 9683; /* pred_dual_widen_mulsv1hi_scalar */

        case 64:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 9689; /* pred_dual_widen_mulsv2hi_scalar */

        case 65:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 9695; /* pred_dual_widen_mulsv4hi_scalar */

        case 66:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 9701; /* pred_dual_widen_mulsv8hi_scalar */

        case 67:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 9707; /* pred_dual_widen_mulsv16hi_scalar */

        case 68:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9713; /* pred_dual_widen_mulsv32hi_scalar */

        case 69:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9719; /* pred_dual_widen_mulsv64hi_scalar */

        case 70:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9725; /* pred_dual_widen_mulsv128hi_scalar */

        case 71:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9731; /* pred_dual_widen_mulsv256hi_scalar */

        case 72:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9737; /* pred_dual_widen_mulsv512hi_scalar */

        case 73:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9743; /* pred_dual_widen_mulsv1024hi_scalar */

        case 74:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9749; /* pred_dual_widen_mulsv2048hi_scalar */

        case 75:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 9755; /* pred_dual_widen_mulsv1si_scalar */

        case 76:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 9761; /* pred_dual_widen_mulsv2si_scalar */

        case 77:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 9767; /* pred_dual_widen_mulsv4si_scalar */

        case 78:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 9773; /* pred_dual_widen_mulsv8si_scalar */

        case 79:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9779; /* pred_dual_widen_mulsv16si_scalar */

        case 80:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9785; /* pred_dual_widen_mulsv32si_scalar */

        case 81:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9791; /* pred_dual_widen_mulsv64si_scalar */

        case 82:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9797; /* pred_dual_widen_mulsv128si_scalar */

        case 83:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9803; /* pred_dual_widen_mulsv256si_scalar */

        case 84:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9809; /* pred_dual_widen_mulsv512si_scalar */

        case 85:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9815; /* pred_dual_widen_mulsv1024si_scalar */

        case 86:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9821; /* pred_dual_widen_mulsv1di_scalar */

        case 87:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9827; /* pred_dual_widen_mulsv2di_scalar */

        case 88:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 9833; /* pred_dual_widen_mulsv4di_scalar */

        case 89:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 9839; /* pred_dual_widen_mulsv8di_scalar */

        case 90:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 9845; /* pred_dual_widen_mulsv16di_scalar */

        case 91:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 9851; /* pred_dual_widen_mulsv32di_scalar */

        case 92:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 9857; /* pred_dual_widen_mulsv64di_scalar */

        case 93:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 9863; /* pred_dual_widen_mulsv128di_scalar */

        case 94:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 9869; /* pred_dual_widen_mulsv256di_scalar */

        case 95:
          if (!(
#line 4028 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 9875; /* pred_dual_widen_mulsv512di_scalar */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern534 (x2))
        {
        case 0:
          if (!
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10453; /* pred_widen_mulsurvvm8hi */

        case 1:
          if (!
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10454; /* pred_widen_mulsurvvm4hi */

        case 2:
          if (!
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10455; /* pred_widen_mulsurvvm2hi */

        case 3:
          if (!
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10456; /* pred_widen_mulsurvvm1hi */

        case 4:
          if (!
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10457; /* pred_widen_mulsurvvmf2hi */

        case 5:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10458; /* pred_widen_mulsurvvmf4hi */

        case 6:
          if (!
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10459; /* pred_widen_mulsurvvm8si */

        case 7:
          if (!
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10460; /* pred_widen_mulsurvvm4si */

        case 8:
          if (!
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10461; /* pred_widen_mulsurvvm2si */

        case 9:
          if (!
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10462; /* pred_widen_mulsurvvm1si */

        case 10:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10463; /* pred_widen_mulsurvvmf2si */

        case 11:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10464; /* pred_widen_mulsurvvm8di */

        case 12:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10465; /* pred_widen_mulsurvvm4di */

        case 13:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10466; /* pred_widen_mulsurvvm2di */

        case 14:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10467; /* pred_widen_mulsurvvm1di */

        case 15:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10468; /* pred_widen_mulsuv1hi */

        case 16:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10469; /* pred_widen_mulsuv2hi */

        case 17:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10470; /* pred_widen_mulsuv4hi */

        case 18:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10471; /* pred_widen_mulsuv8hi */

        case 19:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10472; /* pred_widen_mulsuv16hi */

        case 20:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10473; /* pred_widen_mulsuv32hi */

        case 21:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10474; /* pred_widen_mulsuv64hi */

        case 22:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10475; /* pred_widen_mulsuv128hi */

        case 23:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10476; /* pred_widen_mulsuv256hi */

        case 24:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10477; /* pred_widen_mulsuv512hi */

        case 25:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10478; /* pred_widen_mulsuv1024hi */

        case 26:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10479; /* pred_widen_mulsuv2048hi */

        case 27:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10480; /* pred_widen_mulsuv1si */

        case 28:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10481; /* pred_widen_mulsuv2si */

        case 29:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10482; /* pred_widen_mulsuv4si */

        case 30:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10483; /* pred_widen_mulsuv8si */

        case 31:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10484; /* pred_widen_mulsuv16si */

        case 32:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10485; /* pred_widen_mulsuv32si */

        case 33:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10486; /* pred_widen_mulsuv64si */

        case 34:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10487; /* pred_widen_mulsuv128si */

        case 35:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10488; /* pred_widen_mulsuv256si */

        case 36:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10489; /* pred_widen_mulsuv512si */

        case 37:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10490; /* pred_widen_mulsuv1024si */

        case 38:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10491; /* pred_widen_mulsuv1di */

        case 39:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10492; /* pred_widen_mulsuv2di */

        case 40:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10493; /* pred_widen_mulsuv4di */

        case 41:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10494; /* pred_widen_mulsuv8di */

        case 42:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10495; /* pred_widen_mulsuv16di */

        case 43:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10496; /* pred_widen_mulsuv32di */

        case 44:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10497; /* pred_widen_mulsuv64di */

        case 45:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10498; /* pred_widen_mulsuv128di */

        case 46:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10499; /* pred_widen_mulsuv256di */

        case 47:
          if (!(
#line 4160 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10500; /* pred_widen_mulsuv512di */

        case 48:
          if (!
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10501; /* pred_widen_mulsurvvm8hi_scalar */

        case 49:
          if (!
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10502; /* pred_widen_mulsurvvm4hi_scalar */

        case 50:
          if (!
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10503; /* pred_widen_mulsurvvm2hi_scalar */

        case 51:
          if (!
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10504; /* pred_widen_mulsurvvm1hi_scalar */

        case 52:
          if (!
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10505; /* pred_widen_mulsurvvmf2hi_scalar */

        case 53:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10506; /* pred_widen_mulsurvvmf4hi_scalar */

        case 54:
          if (!
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10507; /* pred_widen_mulsurvvm8si_scalar */

        case 55:
          if (!
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10508; /* pred_widen_mulsurvvm4si_scalar */

        case 56:
          if (!
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10509; /* pred_widen_mulsurvvm2si_scalar */

        case 57:
          if (!
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 10510; /* pred_widen_mulsurvvm1si_scalar */

        case 58:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10511; /* pred_widen_mulsurvvmf2si_scalar */

        case 59:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10512; /* pred_widen_mulsurvvm8di_scalar */

        case 60:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10513; /* pred_widen_mulsurvvm4di_scalar */

        case 61:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10514; /* pred_widen_mulsurvvm2di_scalar */

        case 62:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10515; /* pred_widen_mulsurvvm1di_scalar */

        case 63:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 10516; /* pred_widen_mulsuv1hi_scalar */

        case 64:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 10517; /* pred_widen_mulsuv2hi_scalar */

        case 65:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 10518; /* pred_widen_mulsuv4hi_scalar */

        case 66:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 10519; /* pred_widen_mulsuv8hi_scalar */

        case 67:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 10520; /* pred_widen_mulsuv16hi_scalar */

        case 68:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10521; /* pred_widen_mulsuv32hi_scalar */

        case 69:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10522; /* pred_widen_mulsuv64hi_scalar */

        case 70:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10523; /* pred_widen_mulsuv128hi_scalar */

        case 71:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10524; /* pred_widen_mulsuv256hi_scalar */

        case 72:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10525; /* pred_widen_mulsuv512hi_scalar */

        case 73:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10526; /* pred_widen_mulsuv1024hi_scalar */

        case 74:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10527; /* pred_widen_mulsuv2048hi_scalar */

        case 75:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 10528; /* pred_widen_mulsuv1si_scalar */

        case 76:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 10529; /* pred_widen_mulsuv2si_scalar */

        case 77:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 10530; /* pred_widen_mulsuv4si_scalar */

        case 78:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 10531; /* pred_widen_mulsuv8si_scalar */

        case 79:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10532; /* pred_widen_mulsuv16si_scalar */

        case 80:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10533; /* pred_widen_mulsuv32si_scalar */

        case 81:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10534; /* pred_widen_mulsuv64si_scalar */

        case 82:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10535; /* pred_widen_mulsuv128si_scalar */

        case 83:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10536; /* pred_widen_mulsuv256si_scalar */

        case 84:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10537; /* pred_widen_mulsuv512si_scalar */

        case 85:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10538; /* pred_widen_mulsuv1024si_scalar */

        case 86:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10539; /* pred_widen_mulsuv1di_scalar */

        case 87:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10540; /* pred_widen_mulsuv2di_scalar */

        case 88:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 10541; /* pred_widen_mulsuv4di_scalar */

        case 89:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 10542; /* pred_widen_mulsuv8di_scalar */

        case 90:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 10543; /* pred_widen_mulsuv16di_scalar */

        case 91:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 10544; /* pred_widen_mulsuv32di_scalar */

        case 92:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 10545; /* pred_widen_mulsuv64di_scalar */

        case 93:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 10546; /* pred_widen_mulsuv128di_scalar */

        case 94:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 10547; /* pred_widen_mulsuv256di_scalar */

        case 95:
          if (!(
#line 4183 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 10548; /* pred_widen_mulsuv512di_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_895 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return recog_753 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      x5 = XEXP (x2, 0);
      x6 = XVECEXP (x5, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x5, 0, 2);
      operands[6] = x7;
      x8 = XVECEXP (x5, 0, 3);
      operands[7] = x8;
      x9 = XVECEXP (x5, 0, 4);
      operands[8] = x9;
      x10 = XEXP (x3, 1);
      operands[3] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      x12 = XEXP (x4, 0);
      switch (GET_CODE (x12))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          switch (pattern489 (x2))
            {
            case 0:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6857; /* pred_addrvvm8qi_scalar */

            case 1:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6866; /* pred_addrvvm4qi_scalar */

            case 2:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6875; /* pred_addrvvm2qi_scalar */

            case 3:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6884; /* pred_addrvvm1qi_scalar */

            case 4:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6893; /* pred_addrvvmf2qi_scalar */

            case 5:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6902; /* pred_addrvvmf4qi_scalar */

            case 6:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 6911; /* pred_addrvvmf8qi_scalar */

            case 7:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6920; /* pred_addrvvm8hi_scalar */

            case 8:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6929; /* pred_addrvvm4hi_scalar */

            case 9:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6938; /* pred_addrvvm2hi_scalar */

            case 10:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6947; /* pred_addrvvm1hi_scalar */

            case 11:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6956; /* pred_addrvvmf2hi_scalar */

            case 12:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 6965; /* pred_addrvvmf4hi_scalar */

            case 13:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6974; /* pred_addrvvm8si_scalar */

            case 14:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6983; /* pred_addrvvm4si_scalar */

            case 15:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6992; /* pred_addrvvm2si_scalar */

            case 16:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7001; /* pred_addrvvm1si_scalar */

            case 17:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7010; /* pred_addrvvmf2si_scalar */

            case 18:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 7019; /* pred_addv1qi_scalar */

            case 19:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 7028; /* pred_addv2qi_scalar */

            case 20:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 7037; /* pred_addv4qi_scalar */

            case 21:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 7046; /* pred_addv8qi_scalar */

            case 22:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 7055; /* pred_addv16qi_scalar */

            case 23:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 7064; /* pred_addv32qi_scalar */

            case 24:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7073; /* pred_addv64qi_scalar */

            case 25:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7082; /* pred_addv128qi_scalar */

            case 26:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7091; /* pred_addv256qi_scalar */

            case 27:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7100; /* pred_addv512qi_scalar */

            case 28:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7109; /* pred_addv1024qi_scalar */

            case 29:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7118; /* pred_addv2048qi_scalar */

            case 30:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7127; /* pred_addv4096qi_scalar */

            case 31:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 7136; /* pred_addv1hi_scalar */

            case 32:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 7145; /* pred_addv2hi_scalar */

            case 33:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 7154; /* pred_addv4hi_scalar */

            case 34:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 7163; /* pred_addv8hi_scalar */

            case 35:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 7172; /* pred_addv16hi_scalar */

            case 36:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7181; /* pred_addv32hi_scalar */

            case 37:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7190; /* pred_addv64hi_scalar */

            case 38:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7199; /* pred_addv128hi_scalar */

            case 39:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7208; /* pred_addv256hi_scalar */

            case 40:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7217; /* pred_addv512hi_scalar */

            case 41:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7226; /* pred_addv1024hi_scalar */

            case 42:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7235; /* pred_addv2048hi_scalar */

            case 43:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 7244; /* pred_addv1si_scalar */

            case 44:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 7253; /* pred_addv2si_scalar */

            case 45:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 7262; /* pred_addv4si_scalar */

            case 46:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 7271; /* pred_addv8si_scalar */

            case 47:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7280; /* pred_addv16si_scalar */

            case 48:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7289; /* pred_addv32si_scalar */

            case 49:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7298; /* pred_addv64si_scalar */

            case 50:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7307; /* pred_addv128si_scalar */

            case 51:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7316; /* pred_addv256si_scalar */

            case 52:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7325; /* pred_addv512si_scalar */

            case 53:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7334; /* pred_addv1024si_scalar */

            case 54:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7667; /* *pred_addrvvm8di_scalar */

            case 55:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7676; /* *pred_addrvvm4di_scalar */

            case 56:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7685; /* *pred_addrvvm2di_scalar */

            case 57:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7694; /* *pred_addrvvm1di_scalar */

            case 58:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7703; /* *pred_addv1di_scalar */

            case 59:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7712; /* *pred_addv2di_scalar */

            case 60:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7721; /* *pred_addv4di_scalar */

            case 61:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7730; /* *pred_addv8di_scalar */

            case 62:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7739; /* *pred_addv16di_scalar */

            case 63:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7748; /* *pred_addv32di_scalar */

            case 64:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7757; /* *pred_addv64di_scalar */

            case 65:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7766; /* *pred_addv128di_scalar */

            case 66:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7775; /* *pred_addv256di_scalar */

            case 67:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7784; /* *pred_addv512di_scalar */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          return recog_608 (x1, insn, pnum_clobbers);

        case ZERO_EXTEND:
          x13 = XEXP (x12, 0);
          operands[4] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8HImode:
              if (pattern690 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10262; /* pred_single_widen_addurvvm8hi_extended_scalar */

            case E_RVVM4HImode:
              if (pattern690 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10264; /* pred_single_widen_addurvvm4hi_extended_scalar */

            case E_RVVM2HImode:
              if (pattern690 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10266; /* pred_single_widen_addurvvm2hi_extended_scalar */

            case E_RVVM1HImode:
              if (pattern690 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10268; /* pred_single_widen_addurvvm1hi_extended_scalar */

            case E_RVVMF2HImode:
              if (pattern690 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_QImode, 
E_HImode) != 0
                  || !
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10270; /* pred_single_widen_addurvvmf2hi_extended_scalar */

            case E_RVVMF4HImode:
              if (pattern690 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10272; /* pred_single_widen_addurvvmf4hi_extended_scalar */

            case E_RVVM8SImode:
              if (pattern690 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10274; /* pred_single_widen_addurvvm8si_extended_scalar */

            case E_RVVM4SImode:
              if (pattern690 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10276; /* pred_single_widen_addurvvm4si_extended_scalar */

            case E_RVVM2SImode:
              if (pattern690 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10278; /* pred_single_widen_addurvvm2si_extended_scalar */

            case E_RVVM1SImode:
              if (pattern690 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_HImode, 
E_SImode) != 0
                  || !
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 10280; /* pred_single_widen_addurvvm1si_extended_scalar */

            case E_RVVMF2SImode:
              if (pattern690 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10282; /* pred_single_widen_addurvvmf2si_extended_scalar */

            case E_RVVM8DImode:
              if (pattern690 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10284; /* pred_single_widen_addurvvm8di_extended_scalar */

            case E_RVVM4DImode:
              if (pattern690 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10286; /* pred_single_widen_addurvvm4di_extended_scalar */

            case E_RVVM2DImode:
              if (pattern690 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10288; /* pred_single_widen_addurvvm2di_extended_scalar */

            case E_RVVM1DImode:
              if (pattern690 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10290; /* pred_single_widen_addurvvm1di_extended_scalar */

            case E_V1HImode:
              if (pattern690 (x2, 
E_V1HImode, 
E_V1BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 10292; /* pred_single_widen_adduv1hi_extended_scalar */

            case E_V2HImode:
              if (pattern690 (x2, 
E_V2HImode, 
E_V2BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 10294; /* pred_single_widen_adduv2hi_extended_scalar */

            case E_V4HImode:
              if (pattern690 (x2, 
E_V4HImode, 
E_V4BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 10296; /* pred_single_widen_adduv4hi_extended_scalar */

            case E_V8HImode:
              if (pattern690 (x2, 
E_V8HImode, 
E_V8BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 10298; /* pred_single_widen_adduv8hi_extended_scalar */

            case E_V16HImode:
              if (pattern690 (x2, 
E_V16HImode, 
E_V16BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 10300; /* pred_single_widen_adduv16hi_extended_scalar */

            case E_V32HImode:
              if (pattern690 (x2, 
E_V32HImode, 
E_V32BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 10302; /* pred_single_widen_adduv32hi_extended_scalar */

            case E_V64HImode:
              if (pattern690 (x2, 
E_V64HImode, 
E_V64BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 10304; /* pred_single_widen_adduv64hi_extended_scalar */

            case E_V128HImode:
              if (pattern690 (x2, 
E_V128HImode, 
E_V128BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 10306; /* pred_single_widen_adduv128hi_extended_scalar */

            case E_V256HImode:
              if (pattern690 (x2, 
E_V256HImode, 
E_V256BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 10308; /* pred_single_widen_adduv256hi_extended_scalar */

            case E_V512HImode:
              if (pattern690 (x2, 
E_V512HImode, 
E_V512BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 10310; /* pred_single_widen_adduv512hi_extended_scalar */

            case E_V1024HImode:
              if (pattern690 (x2, 
E_V1024HImode, 
E_V1024BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 10312; /* pred_single_widen_adduv1024hi_extended_scalar */

            case E_V2048HImode:
              if (pattern690 (x2, 
E_V2048HImode, 
E_V2048BImode, 
E_QImode, 
E_HImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 10314; /* pred_single_widen_adduv2048hi_extended_scalar */

            case E_V1SImode:
              if (pattern690 (x2, 
E_V1SImode, 
E_V1BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 10316; /* pred_single_widen_adduv1si_extended_scalar */

            case E_V2SImode:
              if (pattern690 (x2, 
E_V2SImode, 
E_V2BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 10318; /* pred_single_widen_adduv2si_extended_scalar */

            case E_V4SImode:
              if (pattern690 (x2, 
E_V4SImode, 
E_V4BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 10320; /* pred_single_widen_adduv4si_extended_scalar */

            case E_V8SImode:
              if (pattern690 (x2, 
E_V8SImode, 
E_V8BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 10322; /* pred_single_widen_adduv8si_extended_scalar */

            case E_V16SImode:
              if (pattern690 (x2, 
E_V16SImode, 
E_V16BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 10324; /* pred_single_widen_adduv16si_extended_scalar */

            case E_V32SImode:
              if (pattern690 (x2, 
E_V32SImode, 
E_V32BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 10326; /* pred_single_widen_adduv32si_extended_scalar */

            case E_V64SImode:
              if (pattern690 (x2, 
E_V64SImode, 
E_V64BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 10328; /* pred_single_widen_adduv64si_extended_scalar */

            case E_V128SImode:
              if (pattern690 (x2, 
E_V128SImode, 
E_V128BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 10330; /* pred_single_widen_adduv128si_extended_scalar */

            case E_V256SImode:
              if (pattern690 (x2, 
E_V256SImode, 
E_V256BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 10332; /* pred_single_widen_adduv256si_extended_scalar */

            case E_V512SImode:
              if (pattern690 (x2, 
E_V512SImode, 
E_V512BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 10334; /* pred_single_widen_adduv512si_extended_scalar */

            case E_V1024SImode:
              if (pattern690 (x2, 
E_V1024SImode, 
E_V1024BImode, 
E_HImode, 
E_SImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 10336; /* pred_single_widen_adduv1024si_extended_scalar */

            case E_V1DImode:
              if (pattern690 (x2, 
E_V1DImode, 
E_V1BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10338; /* pred_single_widen_adduv1di_extended_scalar */

            case E_V2DImode:
              if (pattern690 (x2, 
E_V2DImode, 
E_V2BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10340; /* pred_single_widen_adduv2di_extended_scalar */

            case E_V4DImode:
              if (pattern690 (x2, 
E_V4DImode, 
E_V4BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 10342; /* pred_single_widen_adduv4di_extended_scalar */

            case E_V8DImode:
              if (pattern690 (x2, 
E_V8DImode, 
E_V8BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 10344; /* pred_single_widen_adduv8di_extended_scalar */

            case E_V16DImode:
              if (pattern690 (x2, 
E_V16DImode, 
E_V16BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 10346; /* pred_single_widen_adduv16di_extended_scalar */

            case E_V32DImode:
              if (pattern690 (x2, 
E_V32DImode, 
E_V32BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 10348; /* pred_single_widen_adduv32di_extended_scalar */

            case E_V64DImode:
              if (pattern690 (x2, 
E_V64DImode, 
E_V64BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 10350; /* pred_single_widen_adduv64di_extended_scalar */

            case E_V128DImode:
              if (pattern690 (x2, 
E_V128DImode, 
E_V128BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 10352; /* pred_single_widen_adduv128di_extended_scalar */

            case E_V256DImode:
              if (pattern690 (x2, 
E_V256DImode, 
E_V256BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 10354; /* pred_single_widen_adduv256di_extended_scalar */

            case E_V512DImode:
              if (pattern690 (x2, 
E_V512DImode, 
E_V512BImode, 
E_SImode, 
E_DImode) != 0
                  || !(
#line 4114 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 10356; /* pred_single_widen_adduv512di_extended_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_751 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_750 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_752 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_904 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern499 (x2))
    {
    case 0:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5506; /* pred_umaxrvvm8qi */

    case 1:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5523; /* pred_umaxrvvm4qi */

    case 2:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5540; /* pred_umaxrvvm2qi */

    case 3:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5557; /* pred_umaxrvvm1qi */

    case 4:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5574; /* pred_umaxrvvm8hi */

    case 5:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5591; /* pred_umaxrvvm4hi */

    case 6:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5608; /* pred_umaxrvvm2hi */

    case 7:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5625; /* pred_umaxrvvm1hi */

    case 8:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5642; /* pred_umaxrvvm8si */

    case 9:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5659; /* pred_umaxrvvm4si */

    case 10:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5676; /* pred_umaxrvvm2si */

    case 11:
      if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5693; /* pred_umaxrvvm1si */

    case 12:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5710; /* pred_umaxrvvm8di */

    case 13:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5727; /* pred_umaxrvvm4di */

    case 14:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5744; /* pred_umaxrvvm2di */

    case 15:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5761; /* pred_umaxrvvm1di */

    case 16:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5778; /* pred_umaxrvvmf2qi */

    case 17:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5795; /* pred_umaxrvvmf4qi */

    case 18:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5812; /* pred_umaxrvvmf8qi */

    case 19:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 5829; /* pred_umaxrvvmf2hi */

    case 20:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5846; /* pred_umaxrvvmf4hi */

    case 21:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 5863; /* pred_umaxrvvmf2si */

    case 22:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 5880; /* pred_umaxv1qi */

    case 23:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 5897; /* pred_umaxv2qi */

    case 24:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 5914; /* pred_umaxv4qi */

    case 25:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 5931; /* pred_umaxv8qi */

    case 26:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 5948; /* pred_umaxv16qi */

    case 27:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 5965; /* pred_umaxv32qi */

    case 28:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 5982; /* pred_umaxv64qi */

    case 29:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 5999; /* pred_umaxv128qi */

    case 30:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6016; /* pred_umaxv256qi */

    case 31:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6033; /* pred_umaxv512qi */

    case 32:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6050; /* pred_umaxv1024qi */

    case 33:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6067; /* pred_umaxv2048qi */

    case 34:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6084; /* pred_umaxv4096qi */

    case 35:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 6101; /* pred_umaxv1hi */

    case 36:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 6118; /* pred_umaxv2hi */

    case 37:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 6135; /* pred_umaxv4hi */

    case 38:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 6152; /* pred_umaxv8hi */

    case 39:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 6169; /* pred_umaxv16hi */

    case 40:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6186; /* pred_umaxv32hi */

    case 41:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6203; /* pred_umaxv64hi */

    case 42:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6220; /* pred_umaxv128hi */

    case 43:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6237; /* pred_umaxv256hi */

    case 44:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6254; /* pred_umaxv512hi */

    case 45:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6271; /* pred_umaxv1024hi */

    case 46:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6288; /* pred_umaxv2048hi */

    case 47:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 6305; /* pred_umaxv1si */

    case 48:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 6322; /* pred_umaxv2si */

    case 49:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 6339; /* pred_umaxv4si */

    case 50:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 6356; /* pred_umaxv8si */

    case 51:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6373; /* pred_umaxv16si */

    case 52:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6390; /* pred_umaxv32si */

    case 53:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6407; /* pred_umaxv64si */

    case 54:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6424; /* pred_umaxv128si */

    case 55:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6441; /* pred_umaxv256si */

    case 56:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6458; /* pred_umaxv512si */

    case 57:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6475; /* pred_umaxv1024si */

    case 58:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6492; /* pred_umaxv1di */

    case 59:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6509; /* pred_umaxv2di */

    case 60:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6526; /* pred_umaxv4di */

    case 61:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 6543; /* pred_umaxv8di */

    case 62:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 6560; /* pred_umaxv16di */

    case 63:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 6577; /* pred_umaxv32di */

    case 64:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 6594; /* pred_umaxv64di */

    case 65:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 6611; /* pred_umaxv128di */

    case 66:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 6628; /* pred_umaxv256di */

    case 67:
      if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 6645; /* pred_umaxv512di */

    case 68:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6862; /* pred_umaxrvvm8qi_scalar */

    case 69:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6871; /* pred_umaxrvvm4qi_scalar */

    case 70:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6880; /* pred_umaxrvvm2qi_scalar */

    case 71:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6889; /* pred_umaxrvvm1qi_scalar */

    case 72:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6898; /* pred_umaxrvvmf2qi_scalar */

    case 73:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6907; /* pred_umaxrvvmf4qi_scalar */

    case 74:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6916; /* pred_umaxrvvmf8qi_scalar */

    case 75:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6925; /* pred_umaxrvvm8hi_scalar */

    case 76:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6934; /* pred_umaxrvvm4hi_scalar */

    case 77:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6943; /* pred_umaxrvvm2hi_scalar */

    case 78:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6952; /* pred_umaxrvvm1hi_scalar */

    case 79:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6961; /* pred_umaxrvvmf2hi_scalar */

    case 80:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 6970; /* pred_umaxrvvmf4hi_scalar */

    case 81:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6979; /* pred_umaxrvvm8si_scalar */

    case 82:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6988; /* pred_umaxrvvm4si_scalar */

    case 83:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 6997; /* pred_umaxrvvm2si_scalar */

    case 84:
      if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 7006; /* pred_umaxrvvm1si_scalar */

    case 85:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7015; /* pred_umaxrvvmf2si_scalar */

    case 86:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 7024; /* pred_umaxv1qi_scalar */

    case 87:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 7033; /* pred_umaxv2qi_scalar */

    case 88:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 7042; /* pred_umaxv4qi_scalar */

    case 89:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 7051; /* pred_umaxv8qi_scalar */

    case 90:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 7060; /* pred_umaxv16qi_scalar */

    case 91:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 7069; /* pred_umaxv32qi_scalar */

    case 92:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7078; /* pred_umaxv64qi_scalar */

    case 93:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7087; /* pred_umaxv128qi_scalar */

    case 94:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7096; /* pred_umaxv256qi_scalar */

    case 95:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7105; /* pred_umaxv512qi_scalar */

    case 96:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7114; /* pred_umaxv1024qi_scalar */

    case 97:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7123; /* pred_umaxv2048qi_scalar */

    case 98:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7132; /* pred_umaxv4096qi_scalar */

    case 99:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 7141; /* pred_umaxv1hi_scalar */

    case 100:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 7150; /* pred_umaxv2hi_scalar */

    case 101:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 7159; /* pred_umaxv4hi_scalar */

    case 102:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 7168; /* pred_umaxv8hi_scalar */

    case 103:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 7177; /* pred_umaxv16hi_scalar */

    case 104:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7186; /* pred_umaxv32hi_scalar */

    case 105:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7195; /* pred_umaxv64hi_scalar */

    case 106:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7204; /* pred_umaxv128hi_scalar */

    case 107:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7213; /* pred_umaxv256hi_scalar */

    case 108:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7222; /* pred_umaxv512hi_scalar */

    case 109:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7231; /* pred_umaxv1024hi_scalar */

    case 110:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7240; /* pred_umaxv2048hi_scalar */

    case 111:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 7249; /* pred_umaxv1si_scalar */

    case 112:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 7258; /* pred_umaxv2si_scalar */

    case 113:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 7267; /* pred_umaxv4si_scalar */

    case 114:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 7276; /* pred_umaxv8si_scalar */

    case 115:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7285; /* pred_umaxv16si_scalar */

    case 116:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7294; /* pred_umaxv32si_scalar */

    case 117:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7303; /* pred_umaxv64si_scalar */

    case 118:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7312; /* pred_umaxv128si_scalar */

    case 119:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7321; /* pred_umaxv256si_scalar */

    case 120:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7330; /* pred_umaxv512si_scalar */

    case 121:
      if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7339; /* pred_umaxv1024si_scalar */

    case 122:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7672; /* *pred_umaxrvvm8di_scalar */

    case 123:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7681; /* *pred_umaxrvvm4di_scalar */

    case 124:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7690; /* *pred_umaxrvvm2di_scalar */

    case 125:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7699; /* *pred_umaxrvvm1di_scalar */

    case 126:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7708; /* *pred_umaxv1di_scalar */

    case 127:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7717; /* *pred_umaxv2di_scalar */

    case 128:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7726; /* *pred_umaxv4di_scalar */

    case 129:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7735; /* *pred_umaxv8di_scalar */

    case 130:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7744; /* *pred_umaxv16di_scalar */

    case 131:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7753; /* *pred_umaxv32di_scalar */

    case 132:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7762; /* *pred_umaxv64di_scalar */

    case 133:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7771; /* *pred_umaxv128di_scalar */

    case 134:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7780; /* *pred_umaxv256di_scalar */

    case 135:
      if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7789; /* *pred_umaxv512di_scalar */

    case 136:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7798; /* *pred_umaxrvvm8di_extended_scalar */

    case 137:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7807; /* *pred_umaxrvvm4di_extended_scalar */

    case 138:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7816; /* *pred_umaxrvvm2di_extended_scalar */

    case 139:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7825; /* *pred_umaxrvvm1di_extended_scalar */

    case 140:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7834; /* *pred_umaxv1di_extended_scalar */

    case 141:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7843; /* *pred_umaxv2di_extended_scalar */

    case 142:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 7852; /* *pred_umaxv4di_extended_scalar */

    case 143:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 7861; /* *pred_umaxv8di_extended_scalar */

    case 144:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 7870; /* *pred_umaxv16di_extended_scalar */

    case 145:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 7879; /* *pred_umaxv32di_extended_scalar */

    case 146:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 7888; /* *pred_umaxv64di_extended_scalar */

    case 147:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 7897; /* *pred_umaxv128di_extended_scalar */

    case 148:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 7906; /* *pred_umaxv256di_extended_scalar */

    case 149:
      if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 7915; /* *pred_umaxv512di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_916 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern505 (x2))
    {
    case 0:
      if (!
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9118; /* pred_zero_extendrvvm8hi_vf2 */

    case 1:
      if (!
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9120; /* pred_zero_extendrvvm4hi_vf2 */

    case 2:
      if (!
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9122; /* pred_zero_extendrvvm2hi_vf2 */

    case 3:
      if (!
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9124; /* pred_zero_extendrvvm1hi_vf2 */

    case 4:
      if (!
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9126; /* pred_zero_extendrvvmf2hi_vf2 */

    case 5:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9128; /* pred_zero_extendrvvmf4hi_vf2 */

    case 6:
      if (!
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9130; /* pred_zero_extendrvvm8si_vf2 */

    case 7:
      if (!
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9214; /* pred_zero_extendrvvm8si_vf4 */

    case 8:
      if (!
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9132; /* pred_zero_extendrvvm4si_vf2 */

    case 9:
      if (!
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9216; /* pred_zero_extendrvvm4si_vf4 */

    case 10:
      if (!
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9134; /* pred_zero_extendrvvm2si_vf2 */

    case 11:
      if (!
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9218; /* pred_zero_extendrvvm2si_vf4 */

    case 12:
      if (!
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9136; /* pred_zero_extendrvvm1si_vf2 */

    case 13:
      if (!
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR))
        return -1;
      return 9220; /* pred_zero_extendrvvm1si_vf4 */

    case 14:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9138; /* pred_zero_extendrvvmf2si_vf2 */

    case 15:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9222; /* pred_zero_extendrvvmf2si_vf4 */

    case 16:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9140; /* pred_zero_extendrvvm8di_vf2 */

    case 17:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9224; /* pred_zero_extendrvvm8di_vf4 */

    case 18:
      if (!(
#line 3982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1151 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9274; /* pred_zero_extendrvvm8di_vf8 */

    case 19:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9142; /* pred_zero_extendrvvm4di_vf2 */

    case 20:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9226; /* pred_zero_extendrvvm4di_vf4 */

    case 21:
      if (!(
#line 3982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1151 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9276; /* pred_zero_extendrvvm4di_vf8 */

    case 22:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9144; /* pred_zero_extendrvvm2di_vf2 */

    case 23:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9228; /* pred_zero_extendrvvm2di_vf4 */

    case 24:
      if (!(
#line 3982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1152 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9278; /* pred_zero_extendrvvm2di_vf8 */

    case 25:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9146; /* pred_zero_extendrvvm1di_vf2 */

    case 26:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9230; /* pred_zero_extendrvvm1di_vf4 */

    case 27:
      if (!(
#line 3982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1152 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9280; /* pred_zero_extendrvvm1di_vf8 */

    case 28:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 9148; /* pred_zero_extendv1hi_vf2 */

    case 29:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 9150; /* pred_zero_extendv2hi_vf2 */

    case 30:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 9152; /* pred_zero_extendv4hi_vf2 */

    case 31:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 9154; /* pred_zero_extendv8hi_vf2 */

    case 32:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 9156; /* pred_zero_extendv16hi_vf2 */

    case 33:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9158; /* pred_zero_extendv32hi_vf2 */

    case 34:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9160; /* pred_zero_extendv64hi_vf2 */

    case 35:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9162; /* pred_zero_extendv128hi_vf2 */

    case 36:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9164; /* pred_zero_extendv256hi_vf2 */

    case 37:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9166; /* pred_zero_extendv512hi_vf2 */

    case 38:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9168; /* pred_zero_extendv1024hi_vf2 */

    case 39:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9170; /* pred_zero_extendv2048hi_vf2 */

    case 40:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 9172; /* pred_zero_extendv1si_vf2 */

    case 41:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 9232; /* pred_zero_extendv1si_vf4 */

    case 42:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 9174; /* pred_zero_extendv2si_vf2 */

    case 43:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 9234; /* pred_zero_extendv2si_vf4 */

    case 44:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 9176; /* pred_zero_extendv4si_vf2 */

    case 45:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 9236; /* pred_zero_extendv4si_vf4 */

    case 46:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 9178; /* pred_zero_extendv8si_vf2 */

    case 47:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 9238; /* pred_zero_extendv8si_vf4 */

    case 48:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9180; /* pred_zero_extendv16si_vf2 */

    case 49:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9240; /* pred_zero_extendv16si_vf4 */

    case 50:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9182; /* pred_zero_extendv32si_vf2 */

    case 51:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9242; /* pred_zero_extendv32si_vf4 */

    case 52:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9184; /* pred_zero_extendv64si_vf2 */

    case 53:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9244; /* pred_zero_extendv64si_vf4 */

    case 54:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9186; /* pred_zero_extendv128si_vf2 */

    case 55:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1118 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9246; /* pred_zero_extendv128si_vf4 */

    case 56:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9188; /* pred_zero_extendv256si_vf2 */

    case 57:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1119 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9248; /* pred_zero_extendv256si_vf4 */

    case 58:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9190; /* pred_zero_extendv512si_vf2 */

    case 59:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1120 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9250; /* pred_zero_extendv512si_vf4 */

    case 60:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9192; /* pred_zero_extendv1024si_vf2 */

    case 61:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1121 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9252; /* pred_zero_extendv1024si_vf4 */

    case 62:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9194; /* pred_zero_extendv1di_vf2 */

    case 63:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1122 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9254; /* pred_zero_extendv1di_vf4 */

    case 64:
      if (!(
#line 3982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1154 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9282; /* pred_zero_extendv1di_vf8 */

    case 65:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9196; /* pred_zero_extendv2di_vf2 */

    case 66:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1123 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9256; /* pred_zero_extendv2di_vf4 */

    case 67:
      if (!(
#line 3982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1155 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9284; /* pred_zero_extendv2di_vf8 */

    case 68:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9198; /* pred_zero_extendv4di_vf2 */

    case 69:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1124 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9258; /* pred_zero_extendv4di_vf4 */

    case 70:
      if (!(
#line 3982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1156 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 9286; /* pred_zero_extendv4di_vf8 */

    case 71:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9200; /* pred_zero_extendv8di_vf2 */

    case 72:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1125 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9260; /* pred_zero_extendv8di_vf4 */

    case 73:
      if (!(
#line 3982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1157 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 9288; /* pred_zero_extendv8di_vf8 */

    case 74:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9202; /* pred_zero_extendv16di_vf2 */

    case 75:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1126 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9262; /* pred_zero_extendv16di_vf4 */

    case 76:
      if (!(
#line 3982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1158 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 9290; /* pred_zero_extendv16di_vf8 */

    case 77:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9204; /* pred_zero_extendv32di_vf2 */

    case 78:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1127 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9264; /* pred_zero_extendv32di_vf4 */

    case 79:
      if (!(
#line 3982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1159 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 9292; /* pred_zero_extendv32di_vf8 */

    case 80:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9206; /* pred_zero_extendv64di_vf2 */

    case 81:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1128 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9266; /* pred_zero_extendv64di_vf4 */

    case 82:
      if (!(
#line 3982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1160 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 9294; /* pred_zero_extendv64di_vf8 */

    case 83:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9208; /* pred_zero_extendv128di_vf2 */

    case 84:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1129 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9268; /* pred_zero_extendv128di_vf4 */

    case 85:
      if (!(
#line 3982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1161 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 9296; /* pred_zero_extendv128di_vf8 */

    case 86:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9210; /* pred_zero_extendv256di_vf2 */

    case 87:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1130 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9270; /* pred_zero_extendv256di_vf4 */

    case 88:
      if (!(
#line 3982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1162 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 9298; /* pred_zero_extendv256di_vf8 */

    case 89:
      if (!(
#line 3942 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9212; /* pred_zero_extendv512di_vf2 */

    case 90:
      if (!(
#line 3962 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1131 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9272; /* pred_zero_extendv512di_vf4 */

    case 91:
      if (!(
#line 3982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1163 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 9300; /* pred_zero_extendv512di_vf8 */

    default:
      return -1;
    }
}

 int
recog_928 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern478 (x2, 
191))
    {
    case 0:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2216; /* pred_indexed_load_widthwurvvm8qi */

    case 1:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2222; /* pred_indexed_load_widthwurvvm4qi */

    case 2:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2228; /* pred_indexed_load_widthwurvvm2qi */

    case 3:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2234; /* pred_indexed_load_widthwurvvm1qi */

    case 4:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2240; /* pred_indexed_load_widthwurvvm8hi */

    case 5:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2246; /* pred_indexed_load_widthwurvvm4hi */

    case 6:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2252; /* pred_indexed_load_widthwurvvm2hi */

    case 7:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2258; /* pred_indexed_load_widthwurvvm1hi */

    case 8:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2264; /* pred_indexed_load_widthwurvvm8si */

    case 9:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2270; /* pred_indexed_load_widthwurvvm4si */

    case 10:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2276; /* pred_indexed_load_widthwurvvm2si */

    case 11:
      if (!
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 2282; /* pred_indexed_load_widthwurvvm1si */

    case 12:
      if (!(
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2288; /* pred_indexed_load_widthwurvvm8di */

    case 13:
      if (!(
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2294; /* pred_indexed_load_widthwurvvm4di */

    case 14:
      if (!(
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2300; /* pred_indexed_load_widthwurvvm2di */

    case 15:
      if (!(
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 2306; /* pred_indexed_load_widthwurvvm1di */

    case 16:
      if (!(
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2312; /* pred_indexed_load_widthwurvvmf8qi */

    case 17:
      if (!(
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2318; /* pred_indexed_load_widthwurvvmf4hi */

    case 18:
      if (!(
#line 310 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 2324; /* pred_indexed_load_widthwurvvmf2si */

    default:
      return -1;
    }
}

 int
recog_931 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern722 (x2))
    {
    case 0:
      if (register_operand (operands[4], E_RVVM8QImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11409; /* pred_smulrvvm8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11885; /* pred_smulrvvm8qi_scalar */

    case 1:
      if (register_operand (operands[4], E_RVVM4QImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11416; /* pred_smulrvvm4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11890; /* pred_smulrvvm4qi_scalar */

    case 2:
      if (register_operand (operands[4], E_RVVM2QImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11423; /* pred_smulrvvm2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11895; /* pred_smulrvvm2qi_scalar */

    case 3:
      if (register_operand (operands[4], E_RVVM1QImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11430; /* pred_smulrvvm1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11900; /* pred_smulrvvm1qi_scalar */

    case 4:
      if (register_operand (operands[4], E_RVVM8HImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11437; /* pred_smulrvvm8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11920; /* pred_smulrvvm8hi_scalar */

    case 5:
      if (register_operand (operands[4], E_RVVM4HImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11444; /* pred_smulrvvm4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11925; /* pred_smulrvvm4hi_scalar */

    case 6:
      if (register_operand (operands[4], E_RVVM2HImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11451; /* pred_smulrvvm2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11930; /* pred_smulrvvm2hi_scalar */

    case 7:
      if (register_operand (operands[4], E_RVVM1HImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11458; /* pred_smulrvvm1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11935; /* pred_smulrvvm1hi_scalar */

    case 8:
      if (register_operand (operands[4], E_RVVM8SImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11465; /* pred_smulrvvm8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11950; /* pred_smulrvvm8si_scalar */

    case 9:
      if (register_operand (operands[4], E_RVVM4SImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11472; /* pred_smulrvvm4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11955; /* pred_smulrvvm4si_scalar */

    case 10:
      if (register_operand (operands[4], E_RVVM2SImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11479; /* pred_smulrvvm2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11960; /* pred_smulrvvm2si_scalar */

    case 11:
      if (register_operand (operands[4], E_RVVM1SImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11486; /* pred_smulrvvm1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11965; /* pred_smulrvvm1si_scalar */

    case 12:
      if (register_operand (operands[4], E_RVVM8DImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11493; /* pred_smulrvvm8di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12199; /* *pred_smulrvvm8di_scalar */

    case 13:
      if (register_operand (operands[4], E_RVVM4DImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11500; /* pred_smulrvvm4di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12204; /* *pred_smulrvvm4di_scalar */

    case 14:
      if (register_operand (operands[4], E_RVVM2DImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11507; /* pred_smulrvvm2di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12209; /* *pred_smulrvvm2di_scalar */

    case 15:
      if (register_operand (operands[4], E_RVVM1DImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11514; /* pred_smulrvvm1di */
      if (!reg_or_0_operand (operands[4], E_DImode)
          || !(
#line 4656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12214; /* *pred_smulrvvm1di_scalar */

    case 16:
      if (register_operand (operands[4], E_RVVMF2QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11521; /* pred_smulrvvmf2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11905; /* pred_smulrvvmf2qi_scalar */

    case 17:
      if (register_operand (operands[4], E_RVVMF4QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11528; /* pred_smulrvvmf4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11910; /* pred_smulrvvmf4qi_scalar */

    case 18:
      if (register_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11535; /* pred_smulrvvmf8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11915; /* pred_smulrvvmf8qi_scalar */

    case 19:
      if (register_operand (operands[4], E_RVVMF2HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11542; /* pred_smulrvvmf2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11940; /* pred_smulrvvmf2hi_scalar */

    case 20:
      if (register_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11549; /* pred_smulrvvmf4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11945; /* pred_smulrvvmf4hi_scalar */

    case 21:
      if (register_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11556; /* pred_smulrvvmf2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11970; /* pred_smulrvvmf2si_scalar */

    case 22:
      if (register_operand (operands[4], E_V1QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return 11563; /* pred_smulv1qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 11975; /* pred_smulv1qi_scalar */

    case 23:
      if (register_operand (operands[4], E_V2QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return 11570; /* pred_smulv2qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 11980; /* pred_smulv2qi_scalar */

    case 24:
      if (register_operand (operands[4], E_V4QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 11577; /* pred_smulv4qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 11985; /* pred_smulv4qi_scalar */

    case 25:
      if (register_operand (operands[4], E_V8QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 11584; /* pred_smulv8qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 11990; /* pred_smulv8qi_scalar */

    case 26:
      if (register_operand (operands[4], E_V16QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return 11591; /* pred_smulv16qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 11995; /* pred_smulv16qi_scalar */

    case 27:
      if (register_operand (operands[4], E_V32QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return 11598; /* pred_smulv32qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 12000; /* pred_smulv32qi_scalar */

    case 28:
      if (register_operand (operands[4], E_V64QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 11605; /* pred_smulv64qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12005; /* pred_smulv64qi_scalar */

    case 29:
      if (register_operand (operands[4], E_V128QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return 11612; /* pred_smulv128qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12010; /* pred_smulv128qi_scalar */

    case 30:
      if (register_operand (operands[4], E_V256QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return 11619; /* pred_smulv256qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12015; /* pred_smulv256qi_scalar */

    case 31:
      if (register_operand (operands[4], E_V512QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return 11626; /* pred_smulv512qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12020; /* pred_smulv512qi_scalar */

    case 32:
      if (register_operand (operands[4], E_V1024QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return 11633; /* pred_smulv1024qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12025; /* pred_smulv1024qi_scalar */

    case 33:
      if (register_operand (operands[4], E_V2048QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return 11640; /* pred_smulv2048qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12030; /* pred_smulv2048qi_scalar */

    case 34:
      if (register_operand (operands[4], E_V4096QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 11647; /* pred_smulv4096qi */
      if (!reg_or_0_operand (operands[4], E_QImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12035; /* pred_smulv4096qi_scalar */

    case 35:
      if (register_operand (operands[4], E_V1HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 11654; /* pred_smulv1hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 12040; /* pred_smulv1hi_scalar */

    case 36:
      if (register_operand (operands[4], E_V2HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 11661; /* pred_smulv2hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 12045; /* pred_smulv2hi_scalar */

    case 37:
      if (register_operand (operands[4], E_V4HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 11668; /* pred_smulv4hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12050; /* pred_smulv4hi_scalar */

    case 38:
      if (register_operand (operands[4], E_V8HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 11675; /* pred_smulv8hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12055; /* pred_smulv8hi_scalar */

    case 39:
      if (register_operand (operands[4], E_V16HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 11682; /* pred_smulv16hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12060; /* pred_smulv16hi_scalar */

    case 40:
      if (register_operand (operands[4], E_V32HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 11689; /* pred_smulv32hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12065; /* pred_smulv32hi_scalar */

    case 41:
      if (register_operand (operands[4], E_V64HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 11696; /* pred_smulv64hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12070; /* pred_smulv64hi_scalar */

    case 42:
      if (register_operand (operands[4], E_V128HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 11703; /* pred_smulv128hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12075; /* pred_smulv128hi_scalar */

    case 43:
      if (register_operand (operands[4], E_V256HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 11710; /* pred_smulv256hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12080; /* pred_smulv256hi_scalar */

    case 44:
      if (register_operand (operands[4], E_V512HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 11717; /* pred_smulv512hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12085; /* pred_smulv512hi_scalar */

    case 45:
      if (register_operand (operands[4], E_V1024HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 11724; /* pred_smulv1024hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12090; /* pred_smulv1024hi_scalar */

    case 46:
      if (register_operand (operands[4], E_V2048HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 11731; /* pred_smulv2048hi */
      if (!reg_or_0_operand (operands[4], E_HImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12095; /* pred_smulv2048hi_scalar */

    case 47:
      if (register_operand (operands[4], E_V1SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 11738; /* pred_smulv1si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 12100; /* pred_smulv1si_scalar */

    case 48:
      if (register_operand (operands[4], E_V2SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 11745; /* pred_smulv2si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 12105; /* pred_smulv2si_scalar */

    case 49:
      if (register_operand (operands[4], E_V4SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 11752; /* pred_smulv4si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12110; /* pred_smulv4si_scalar */

    case 50:
      if (register_operand (operands[4], E_V8SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 11759; /* pred_smulv8si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12115; /* pred_smulv8si_scalar */

    case 51:
      if (register_operand (operands[4], E_V16SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 11766; /* pred_smulv16si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12120; /* pred_smulv16si_scalar */

    case 52:
      if (register_operand (operands[4], E_V32SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 11773; /* pred_smulv32si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12125; /* pred_smulv32si_scalar */

    case 53:
      if (register_operand (operands[4], E_V64SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 11780; /* pred_smulv64si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12130; /* pred_smulv64si_scalar */

    case 54:
      if (register_operand (operands[4], E_V128SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 11787; /* pred_smulv128si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12135; /* pred_smulv128si_scalar */

    case 55:
      if (register_operand (operands[4], E_V256SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 11794; /* pred_smulv256si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12140; /* pred_smulv256si_scalar */

    case 56:
      if (register_operand (operands[4], E_V512SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 11801; /* pred_smulv512si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12145; /* pred_smulv512si_scalar */

    case 57:
      if (register_operand (operands[4], E_V1024SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 11808; /* pred_smulv1024si */
      if (!reg_or_0_operand (operands[4], E_SImode)
          || !(
#line 4576 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12150; /* pred_smulv1024si_scalar */

    case 58:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11815; /* pred_smulv1di */

    case 59:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11822; /* pred_smulv2di */

    case 60:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11829; /* pred_smulv4di */

    case 61:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11836; /* pred_smulv8di */

    case 62:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11843; /* pred_smulv16di */

    case 63:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11850; /* pred_smulv32di */

    case 64:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11857; /* pred_smulv64di */

    case 65:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11864; /* pred_smulv128di */

    case 66:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11871; /* pred_smulv256di */

    case 67:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11878; /* pred_smulv512di */

    case 68:
      if (!(
#line 4679 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12219; /* *pred_smulrvvm8di_extended_scalar */

    case 69:
      if (!(
#line 4679 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12224; /* *pred_smulrvvm4di_extended_scalar */

    case 70:
      if (!(
#line 4679 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12229; /* *pred_smulrvvm2di_extended_scalar */

    case 71:
      if (!(
#line 4679 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12234; /* *pred_smulrvvm1di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_938 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern723 (x2))
    {
    case 0:
      if (register_operand (operands[4], E_RVVM8QImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11411; /* pred_ssrarvvm8qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12152; /* pred_ssrarvvm8qi_scalar */

    case 1:
      if (register_operand (operands[4], E_RVVM4QImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11418; /* pred_ssrarvvm4qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12154; /* pred_ssrarvvm4qi_scalar */

    case 2:
      if (register_operand (operands[4], E_RVVM2QImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11425; /* pred_ssrarvvm2qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12156; /* pred_ssrarvvm2qi_scalar */

    case 3:
      if (register_operand (operands[4], E_RVVM1QImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11432; /* pred_ssrarvvm1qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12158; /* pred_ssrarvvm1qi_scalar */

    case 4:
      if (register_operand (operands[4], E_RVVM8HImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11439; /* pred_ssrarvvm8hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12160; /* pred_ssrarvvm8hi_scalar */

    case 5:
      if (register_operand (operands[4], E_RVVM4HImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11446; /* pred_ssrarvvm4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12162; /* pred_ssrarvvm4hi_scalar */

    case 6:
      if (register_operand (operands[4], E_RVVM2HImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11453; /* pred_ssrarvvm2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12164; /* pred_ssrarvvm2hi_scalar */

    case 7:
      if (register_operand (operands[4], E_RVVM1HImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11460; /* pred_ssrarvvm1hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12166; /* pred_ssrarvvm1hi_scalar */

    case 8:
      if (register_operand (operands[4], E_RVVM8SImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11467; /* pred_ssrarvvm8si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12168; /* pred_ssrarvvm8si_scalar */

    case 9:
      if (register_operand (operands[4], E_RVVM4SImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11474; /* pred_ssrarvvm4si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12170; /* pred_ssrarvvm4si_scalar */

    case 10:
      if (register_operand (operands[4], E_RVVM2SImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11481; /* pred_ssrarvvm2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12172; /* pred_ssrarvvm2si_scalar */

    case 11:
      if (register_operand (operands[4], E_RVVM1SImode)
          && 
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 11488; /* pred_ssrarvvm1si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !
#line 4598 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12174; /* pred_ssrarvvm1si_scalar */

    case 12:
      if (register_operand (operands[4], E_RVVM8DImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11495; /* pred_ssrarvvm8di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4598 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12176; /* pred_ssrarvvm8di_scalar */

    case 13:
      if (register_operand (operands[4], E_RVVM4DImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11502; /* pred_ssrarvvm4di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4598 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12178; /* pred_ssrarvvm4di_scalar */

    case 14:
      if (register_operand (operands[4], E_RVVM2DImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11509; /* pred_ssrarvvm2di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4598 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12180; /* pred_ssrarvvm2di_scalar */

    case 15:
      if (register_operand (operands[4], E_RVVM1DImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 11516; /* pred_ssrarvvm1di */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4598 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12182; /* pred_ssrarvvm1di_scalar */

    case 16:
      if (register_operand (operands[4], E_RVVMF2QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11523; /* pred_ssrarvvmf2qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4598 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 12184; /* pred_ssrarvvmf2qi_scalar */

    case 17:
      if (register_operand (operands[4], E_RVVMF4QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11530; /* pred_ssrarvvmf4qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4598 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 12186; /* pred_ssrarvvmf4qi_scalar */

    case 18:
      if (register_operand (operands[4], E_RVVMF8QImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11537; /* pred_ssrarvvmf8qi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4598 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12188; /* pred_ssrarvvmf8qi_scalar */

    case 19:
      if (register_operand (operands[4], E_RVVMF2HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return 11544; /* pred_ssrarvvmf2hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4598 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 12190; /* pred_ssrarvvmf2hi_scalar */

    case 20:
      if (register_operand (operands[4], E_RVVMF4HImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11551; /* pred_ssrarvvmf4hi */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4598 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12192; /* pred_ssrarvvmf4hi_scalar */

    case 21:
      if (register_operand (operands[4], E_RVVMF2SImode)
          && (
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return 11558; /* pred_ssrarvvmf2si */
      if (!pmode_reg_or_uimm5_operand (operands[4], E_VOIDmode)
          || !(
#line 4598 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 12194; /* pred_ssrarvvmf2si_scalar */

    case 22:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 11565; /* pred_ssrav1qi */

    case 23:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 11572; /* pred_ssrav2qi */

    case 24:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 11579; /* pred_ssrav4qi */

    case 25:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 11586; /* pred_ssrav8qi */

    case 26:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 11593; /* pred_ssrav16qi */

    case 27:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 11600; /* pred_ssrav32qi */

    case 28:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11607; /* pred_ssrav64qi */

    case 29:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11614; /* pred_ssrav128qi */

    case 30:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11621; /* pred_ssrav256qi */

    case 31:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11628; /* pred_ssrav512qi */

    case 32:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11635; /* pred_ssrav1024qi */

    case 33:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11642; /* pred_ssrav2048qi */

    case 34:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11649; /* pred_ssrav4096qi */

    case 35:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 11656; /* pred_ssrav1hi */

    case 36:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 11663; /* pred_ssrav2hi */

    case 37:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 11670; /* pred_ssrav4hi */

    case 38:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 11677; /* pred_ssrav8hi */

    case 39:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 11684; /* pred_ssrav16hi */

    case 40:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11691; /* pred_ssrav32hi */

    case 41:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11698; /* pred_ssrav64hi */

    case 42:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11705; /* pred_ssrav128hi */

    case 43:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11712; /* pred_ssrav256hi */

    case 44:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11719; /* pred_ssrav512hi */

    case 45:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11726; /* pred_ssrav1024hi */

    case 46:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11733; /* pred_ssrav2048hi */

    case 47:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 11740; /* pred_ssrav1si */

    case 48:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 11747; /* pred_ssrav2si */

    case 49:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 11754; /* pred_ssrav4si */

    case 50:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 11761; /* pred_ssrav8si */

    case 51:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11768; /* pred_ssrav16si */

    case 52:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11775; /* pred_ssrav32si */

    case 53:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11782; /* pred_ssrav64si */

    case 54:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11789; /* pred_ssrav128si */

    case 55:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11796; /* pred_ssrav256si */

    case 56:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11803; /* pred_ssrav512si */

    case 57:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11810; /* pred_ssrav1024si */

    case 58:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11817; /* pred_ssrav1di */

    case 59:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11824; /* pred_ssrav2di */

    case 60:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11831; /* pred_ssrav4di */

    case 61:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11838; /* pred_ssrav8di */

    case 62:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11845; /* pred_ssrav16di */

    case 63:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11852; /* pred_ssrav32di */

    case 64:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11859; /* pred_ssrav64di */

    case 65:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11866; /* pred_ssrav128di */

    case 66:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11873; /* pred_ssrav256di */

    case 67:
      if (!(
#line 4553 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11880; /* pred_ssrav512di */

    default:
      return -1;
    }
}

 int
recog_1027 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_956 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return 15384; /* *pred_maddv4hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return -1;
  return 15480; /* *pred_maccv4hf */
}

 int
recog_1033 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_950 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM8DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15372; /* *pred_maddrvvm8df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15468; /* *pred_maccrvvm8df */
}

 int
recog_1039 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_944 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF4HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVMF4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
    return 15360; /* *pred_maddrvvmf4hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 15456; /* *pred_maccrvvmf4hf */
}

 int
recog_1046 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM4HFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15736; /* *pred_mul_neg_addrvvm4hf_undef */
}

 int
recog_1055 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVMF2SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVMF2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVMF2SFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 15754; /* *pred_mul_neg_addrvvmf2sf_undef */
}

 int
recog_1065 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V32HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V32HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V32HFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15774; /* *pred_mul_neg_addv32hf_undef */
}

 int
recog_1075 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V8SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V8SFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15794; /* *pred_mul_neg_addv8sf_undef */
}

 int
recog_1085 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V4DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V4DFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15814; /* *pred_mul_neg_addv4df_undef */
}

 int
recog_1095 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1090 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V128DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V128DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return 15920; /* *pred_nmsubv128df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 16016; /* *pred_nmsacv128df */
}

 int
recog_1105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1080 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V256SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V256SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return 15900; /* *pred_nmsubv256sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15996; /* *pred_nmsacv256sf */
}

 int
recog_1115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1070 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1024HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1024HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
    return 15880; /* *pred_nmsubv1024hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15976; /* *pred_nmsacv1024hf */
}

 int
recog_1125 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1060 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return 15860; /* *pred_nmsubv1hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return -1;
  return 15956; /* *pred_nmsacv1hf */
}

 int
recog_1135 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1050 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVMF4HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVMF4HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
    return 15840; /* *pred_nmsubrvvmf4hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 15936; /* *pred_nmsacrvvmf4hf */
}

 int
recog_1145 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM4HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM4HFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15257; /* *pred_mul_subrvvm4hf_undef */
}

 int
recog_1152 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM2SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM2SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM2SFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15271; /* *pred_mul_subrvvm2sf_undef */
}

 int
recog_1159 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V1HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V1HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V1HFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return -1;
  return 15285; /* *pred_mul_subv1hf_undef */
}

 int
recog_1166 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V128HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V128HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V128HFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15299; /* *pred_mul_subv128hf_undef */
}

 int
recog_1173 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V4SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V4SFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15313; /* *pred_mul_subv4sf_undef */
}

 int
recog_1180 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V512SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V512SFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15327; /* *pred_mul_subv512sf_undef */
}

 int
recog_1187 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V32DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V32DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V32DFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15341; /* *pred_mul_subv32df_undef */
}

 int
recog_1194 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1189 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V128DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V128DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return 15441; /* *pred_msubv128df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15537; /* *pred_msacv128df */
}

 int
recog_1201 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1182 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15427; /* *pred_msubv1df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15523; /* *pred_msacv1df */
}

 int
recog_1208 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1175 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V16SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return 15413; /* *pred_msubv16sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15509; /* *pred_msacv16sf */
}

 int
recog_1215 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1168 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V512HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return 15399; /* *pred_msubv512hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15495; /* *pred_msacv512hf */
}

 int
recog_1222 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1161 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V4HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return 15385; /* *pred_msubv4hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return -1;
  return 15481; /* *pred_msacv4hf */
}

 int
recog_1229 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1154 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF2SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVMF2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
    return 15371; /* *pred_msubrvvmf2sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 15467; /* *pred_msacrvvmf2sf */
}

 int
recog_1236 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1147 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM1HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM1HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15357; /* *pred_msubrvvm1hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15453; /* *pred_msacrvvm1hf */
}

 int
recog_1243 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM1HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM1HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM1HFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15741; /* *pred_mul_neg_subrvvm1hf_undef */
}

 int
recog_1250 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVMF2SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVMF2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVMF2SFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 15755; /* *pred_mul_neg_subrvvmf2sf_undef */
}

 int
recog_1257 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V4HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V4HFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return -1;
  return 15769; /* *pred_mul_neg_subv4hf_undef */
}

 int
recog_1264 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V512HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V512HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V512HFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15783; /* *pred_mul_neg_subv512hf_undef */
}

 int
recog_1271 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V16SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V16SFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
    return -1;
  return 15797; /* *pred_mul_neg_subv16sf_undef */
}

 int
recog_1278 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1DFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15811; /* *pred_mul_neg_subv1df_undef */
}

 int
recog_1285 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V128DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V128DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V128DFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15825; /* *pred_mul_neg_subv128df_undef */
}

 int
recog_1292 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1283 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V32DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V32DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return 15917; /* *pred_nmaddv32df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 16013; /* *pred_nmaccv32df */
}

 int
recog_1299 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1276 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V512SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return 15903; /* *pred_nmaddv512sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15999; /* *pred_nmaccv512sf */
}

 int
recog_1306 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1269 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V4SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15889; /* *pred_nmaddv4sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15985; /* *pred_nmaccv4sf */
}

 int
recog_1313 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1262 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V128HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V128HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return 15875; /* *pred_nmaddv128hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15971; /* *pred_nmaccv128hf */
}

 int
recog_1321 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1254 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM1DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM1DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15859; /* *pred_nmaddrvvm1df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15955; /* *pred_nmaccrvvm1df */
}

 int
recog_1329 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1246 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM8SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15843; /* *pred_nmaddrvvm8sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15939; /* *pred_nmaccrvvm8sf */
}

 int
recog_1337 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern588 (x2))
    {
    case 0:
      return recog_1335 (x1, insn, pnum_clobbers);

    case 1:
      return recog_1334 (x1, insn, pnum_clobbers);

    case 2:
      return recog_1333 (x1, insn, pnum_clobbers);

    case 3:
      return recog_1332 (x1, insn, pnum_clobbers);

    case 4:
      return recog_1331 (x1, insn, pnum_clobbers);

    case 5:
      return recog_1330 (x1, insn, pnum_clobbers);

    case 6:
      return recog_1329 (x1, insn, pnum_clobbers);

    case 7:
      return recog_1328 (x1, insn, pnum_clobbers);

    case 8:
      return recog_1327 (x1, insn, pnum_clobbers);

    case 9:
      return recog_1326 (x1, insn, pnum_clobbers);

    case 10:
      return recog_1325 (x1, insn, pnum_clobbers);

    case 11:
      return recog_1324 (x1, insn, pnum_clobbers);

    case 12:
      return recog_1323 (x1, insn, pnum_clobbers);

    case 13:
      return recog_1322 (x1, insn, pnum_clobbers);

    case 14:
      return recog_1321 (x1, insn, pnum_clobbers);

    case 15:
      return recog_1320 (x1, insn, pnum_clobbers);

    case 16:
      return recog_1319 (x1, insn, pnum_clobbers);

    case 17:
      return recog_1318 (x1, insn, pnum_clobbers);

    case 18:
      return recog_1317 (x1, insn, pnum_clobbers);

    case 19:
      return recog_1316 (x1, insn, pnum_clobbers);

    case 20:
      return recog_1315 (x1, insn, pnum_clobbers);

    case 21:
      return recog_1314 (x1, insn, pnum_clobbers);

    case 22:
      return recog_1313 (x1, insn, pnum_clobbers);

    case 23:
      return recog_1312 (x1, insn, pnum_clobbers);

    case 24:
      return recog_1311 (x1, insn, pnum_clobbers);

    case 25:
      return recog_1310 (x1, insn, pnum_clobbers);

    case 26:
      return recog_1309 (x1, insn, pnum_clobbers);

    case 27:
      return recog_1308 (x1, insn, pnum_clobbers);

    case 28:
      return recog_1307 (x1, insn, pnum_clobbers);

    case 29:
      return recog_1306 (x1, insn, pnum_clobbers);

    case 30:
      return recog_1305 (x1, insn, pnum_clobbers);

    case 31:
      return recog_1304 (x1, insn, pnum_clobbers);

    case 32:
      return recog_1303 (x1, insn, pnum_clobbers);

    case 33:
      return recog_1302 (x1, insn, pnum_clobbers);

    case 34:
      return recog_1301 (x1, insn, pnum_clobbers);

    case 35:
      return recog_1300 (x1, insn, pnum_clobbers);

    case 36:
      return recog_1299 (x1, insn, pnum_clobbers);

    case 37:
      return recog_1298 (x1, insn, pnum_clobbers);

    case 38:
      return recog_1297 (x1, insn, pnum_clobbers);

    case 39:
      return recog_1296 (x1, insn, pnum_clobbers);

    case 40:
      return recog_1295 (x1, insn, pnum_clobbers);

    case 41:
      return recog_1294 (x1, insn, pnum_clobbers);

    case 42:
      return recog_1293 (x1, insn, pnum_clobbers);

    case 43:
      return recog_1292 (x1, insn, pnum_clobbers);

    case 44:
      return recog_1291 (x1, insn, pnum_clobbers);

    case 45:
      return recog_1290 (x1, insn, pnum_clobbers);

    case 46:
      return recog_1289 (x1, insn, pnum_clobbers);

    case 47:
      return recog_1288 (x1, insn, pnum_clobbers);

    case 48:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16023; /* *pred_nmaddrvvm8hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16119; /* *pred_nmaccrvvm8hf_scalar */

    case 49:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16025; /* *pred_nmaddrvvm4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16121; /* *pred_nmaccrvvm4hf_scalar */

    case 50:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16027; /* *pred_nmaddrvvm2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16123; /* *pred_nmaccrvvm2hf_scalar */

    case 51:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16029; /* *pred_nmaddrvvm1hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16125; /* *pred_nmaccrvvm1hf_scalar */

    case 52:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 16031; /* *pred_nmaddrvvmf2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16127; /* *pred_nmaccrvvmf2hf_scalar */

    case 53:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return 16033; /* *pred_nmaddrvvmf4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 16129; /* *pred_nmaccrvvmf4hf_scalar */

    case 54:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16035; /* *pred_nmaddrvvm8sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16131; /* *pred_nmaccrvvm8sf_scalar */

    case 55:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16037; /* *pred_nmaddrvvm4sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16133; /* *pred_nmaccrvvm4sf_scalar */

    case 56:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16039; /* *pred_nmaddrvvm2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16135; /* *pred_nmaccrvvm2sf_scalar */

    case 57:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 16041; /* *pred_nmaddrvvm1sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16137; /* *pred_nmaccrvvm1sf_scalar */

    case 58:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return 16043; /* *pred_nmaddrvvmf2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 16139; /* *pred_nmaccrvvmf2sf_scalar */

    case 59:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16045; /* *pred_nmaddrvvm8df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16141; /* *pred_nmaccrvvm8df_scalar */

    case 60:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16047; /* *pred_nmaddrvvm4df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16143; /* *pred_nmaccrvvm4df_scalar */

    case 61:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16049; /* *pred_nmaddrvvm2df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16145; /* *pred_nmaccrvvm2df_scalar */

    case 62:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 16051; /* *pred_nmaddrvvm1df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16147; /* *pred_nmaccrvvm1df_scalar */

    case 63:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return 16053; /* *pred_nmaddv1hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 16149; /* *pred_nmaccv1hf_scalar */

    case 64:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return 16055; /* *pred_nmaddv2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 16151; /* *pred_nmaccv2hf_scalar */

    case 65:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return 16057; /* *pred_nmaddv4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 16153; /* *pred_nmaccv4hf_scalar */

    case 66:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return 16059; /* *pred_nmaddv8hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 16155; /* *pred_nmaccv8hf_scalar */

    case 67:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return 16061; /* *pred_nmaddv16hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 16157; /* *pred_nmaccv16hf_scalar */

    case 68:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return 16063; /* *pred_nmaddv32hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16159; /* *pred_nmaccv32hf_scalar */

    case 69:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return 16065; /* *pred_nmaddv64hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16161; /* *pred_nmaccv64hf_scalar */

    case 70:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return 16067; /* *pred_nmaddv128hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16163; /* *pred_nmaccv128hf_scalar */

    case 71:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return 16069; /* *pred_nmaddv256hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16165; /* *pred_nmaccv256hf_scalar */

    case 72:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return 16071; /* *pred_nmaddv512hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16167; /* *pred_nmaccv512hf_scalar */

    case 73:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return 16073; /* *pred_nmaddv1024hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16169; /* *pred_nmaccv1024hf_scalar */

    case 74:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return 16075; /* *pred_nmaddv2048hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16171; /* *pred_nmaccv2048hf_scalar */

    case 75:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16077; /* *pred_nmaddv1sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16173; /* *pred_nmaccv1sf_scalar */

    case 76:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16079; /* *pred_nmaddv2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16175; /* *pred_nmaccv2sf_scalar */

    case 77:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16081; /* *pred_nmaddv4sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16177; /* *pred_nmaccv4sf_scalar */

    case 78:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 16083; /* *pred_nmaddv8sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16179; /* *pred_nmaccv8sf_scalar */

    case 79:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return 16085; /* *pred_nmaddv16sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16181; /* *pred_nmaccv16sf_scalar */

    case 80:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return 16087; /* *pred_nmaddv32sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16183; /* *pred_nmaccv32sf_scalar */

    case 81:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return 16089; /* *pred_nmaddv64sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16185; /* *pred_nmaccv64sf_scalar */

    case 82:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return 16091; /* *pred_nmaddv128sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16187; /* *pred_nmaccv128sf_scalar */

    case 83:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return 16093; /* *pred_nmaddv256sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16189; /* *pred_nmaccv256sf_scalar */

    case 84:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return 16095; /* *pred_nmaddv512sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16191; /* *pred_nmaccv512sf_scalar */

    case 85:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return 16097; /* *pred_nmaddv1024sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16193; /* *pred_nmaccv1024sf_scalar */

    case 86:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 16099; /* *pred_nmaddv1df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16195; /* *pred_nmaccv1df_scalar */

    case 87:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 16101; /* *pred_nmaddv2df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16197; /* *pred_nmaccv2df_scalar */

    case 88:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 16103; /* *pred_nmaddv4df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16199; /* *pred_nmaccv4df_scalar */

    case 89:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return 16105; /* *pred_nmaddv8df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16201; /* *pred_nmaccv8df_scalar */

    case 90:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return 16107; /* *pred_nmaddv16df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16203; /* *pred_nmaccv16df_scalar */

    case 91:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return 16109; /* *pred_nmaddv32df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16205; /* *pred_nmaccv32df_scalar */

    case 92:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return 16111; /* *pred_nmaddv64df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16207; /* *pred_nmaccv64df_scalar */

    case 93:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return 16113; /* *pred_nmaddv128df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16209; /* *pred_nmaccv128df_scalar */

    case 94:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return 16115; /* *pred_nmaddv256df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16211; /* *pred_nmaccv256df_scalar */

    case 95:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6839 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return 16117; /* *pred_nmaddv512df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6874 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16213; /* *pred_nmaccv512df_scalar */

    case 96:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16824; /* pred_widen_mul_neg_subrvvm8sf */

    case 97:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16826; /* pred_widen_mul_neg_subrvvm4sf */

    case 98:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16828; /* pred_widen_mul_neg_subrvvm2sf */

    case 99:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16830; /* pred_widen_mul_neg_subrvvm1sf */

    case 100:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 16832; /* pred_widen_mul_neg_subrvvmf2sf */

    case 101:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16834; /* pred_widen_mul_neg_subrvvm8df */

    case 102:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16836; /* pred_widen_mul_neg_subrvvm4df */

    case 103:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16838; /* pred_widen_mul_neg_subrvvm2df */

    case 104:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16840; /* pred_widen_mul_neg_subrvvm1df */

    case 105:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16842; /* pred_widen_mul_neg_subv1sf */

    case 106:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16844; /* pred_widen_mul_neg_subv2sf */

    case 107:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16846; /* pred_widen_mul_neg_subv4sf */

    case 108:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16848; /* pred_widen_mul_neg_subv8sf */

    case 109:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16850; /* pred_widen_mul_neg_subv16sf */

    case 110:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16852; /* pred_widen_mul_neg_subv32sf */

    case 111:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16854; /* pred_widen_mul_neg_subv64sf */

    case 112:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16856; /* pred_widen_mul_neg_subv128sf */

    case 113:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16858; /* pred_widen_mul_neg_subv256sf */

    case 114:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16860; /* pred_widen_mul_neg_subv512sf */

    case 115:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16862; /* pred_widen_mul_neg_subv1024sf */

    case 116:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16864; /* pred_widen_mul_neg_subv1df */

    case 117:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16866; /* pred_widen_mul_neg_subv2df */

    case 118:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16868; /* pred_widen_mul_neg_subv4df */

    case 119:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16870; /* pred_widen_mul_neg_subv8df */

    case 120:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16872; /* pred_widen_mul_neg_subv16df */

    case 121:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16874; /* pred_widen_mul_neg_subv32df */

    case 122:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16876; /* pred_widen_mul_neg_subv64df */

    case 123:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16878; /* pred_widen_mul_neg_subv128df */

    case 124:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16880; /* pred_widen_mul_neg_subv256df */

    case 125:
      if (!(
#line 7234 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16882; /* pred_widen_mul_neg_subv512df */

    case 126:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16884; /* pred_widen_mul_neg_subrvvm8sf_scalar */

    case 127:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16886; /* pred_widen_mul_neg_subrvvm4sf_scalar */

    case 128:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16888; /* pred_widen_mul_neg_subrvvm2sf_scalar */

    case 129:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16890; /* pred_widen_mul_neg_subrvvm1sf_scalar */

    case 130:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 16892; /* pred_widen_mul_neg_subrvvmf2sf_scalar */

    case 131:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16894; /* pred_widen_mul_neg_subrvvm8df_scalar */

    case 132:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16896; /* pred_widen_mul_neg_subrvvm4df_scalar */

    case 133:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16898; /* pred_widen_mul_neg_subrvvm2df_scalar */

    case 134:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16900; /* pred_widen_mul_neg_subrvvm1df_scalar */

    case 135:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16902; /* pred_widen_mul_neg_subv1sf_scalar */

    case 136:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16904; /* pred_widen_mul_neg_subv2sf_scalar */

    case 137:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16906; /* pred_widen_mul_neg_subv4sf_scalar */

    case 138:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16908; /* pred_widen_mul_neg_subv8sf_scalar */

    case 139:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16910; /* pred_widen_mul_neg_subv16sf_scalar */

    case 140:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16912; /* pred_widen_mul_neg_subv32sf_scalar */

    case 141:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16914; /* pred_widen_mul_neg_subv64sf_scalar */

    case 142:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16916; /* pred_widen_mul_neg_subv128sf_scalar */

    case 143:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16918; /* pred_widen_mul_neg_subv256sf_scalar */

    case 144:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16920; /* pred_widen_mul_neg_subv512sf_scalar */

    case 145:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16922; /* pred_widen_mul_neg_subv1024sf_scalar */

    case 146:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16924; /* pred_widen_mul_neg_subv1df_scalar */

    case 147:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16926; /* pred_widen_mul_neg_subv2df_scalar */

    case 148:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16928; /* pred_widen_mul_neg_subv4df_scalar */

    case 149:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16930; /* pred_widen_mul_neg_subv8df_scalar */

    case 150:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16932; /* pred_widen_mul_neg_subv16df_scalar */

    case 151:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16934; /* pred_widen_mul_neg_subv32df_scalar */

    case 152:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16936; /* pred_widen_mul_neg_subv64df_scalar */

    case 153:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16938; /* pred_widen_mul_neg_subv128df_scalar */

    case 154:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16940; /* pred_widen_mul_neg_subv256df_scalar */

    case 155:
      if (!(
#line 7264 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16942; /* pred_widen_mul_neg_subv512df_scalar */

    default:
      return -1;
    }
}

 int
recog_1389 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V512QImode:
      if (!register_operand (operands[3], E_V512QImode)
          || !vector_neg_arith_operand (operands[4], E_V512QImode)
          || !(
#line 4851 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12662; /* *pred_ltgev512qi_merge_tie_mask */

    case E_V512HImode:
      if (!register_operand (operands[3], E_V512HImode)
          || !vector_neg_arith_operand (operands[4], E_V512HImode)
          || !(
#line 4851 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12675; /* *pred_ltgev512hi_merge_tie_mask */

    case E_V512SImode:
      if (!register_operand (operands[3], E_V512SImode)
          || !vector_neg_arith_operand (operands[4], E_V512SImode)
          || !(
#line 4851 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12687; /* *pred_ltgev512si_merge_tie_mask */

    case E_V512DImode:
      if (!register_operand (operands[3], E_V512DImode)
          || !vector_neg_arith_operand (operands[4], E_V512DImode)
          || !(
#line 4851 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12698; /* *pred_ltgev512di_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1398 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern537 (x2, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V8BImode))
    {
      res = recog_1383 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V8BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V8QImode:
      if (!register_operand (operands[4], E_V8QImode)
          || !vector_neg_arith_operand (operands[5], E_V8QImode))
        return -1;
      if ((
#line 4875 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8QImode)) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 12724; /* *pred_ltgev8qi */
      if (!(
#line 4896 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8QImode)) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 12792; /* *pred_ltgev8qi_narrow */

    case E_V8HImode:
      if (!register_operand (operands[4], E_V8HImode)
          || !vector_neg_arith_operand (operands[5], E_V8HImode))
        return -1;
      if ((
#line 4875 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8HImode)) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 12737; /* *pred_ltgev8hi */
      if (!(
#line 4896 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8HImode)) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12805; /* *pred_ltgev8hi_narrow */

    case E_V8SImode:
      if (!register_operand (operands[4], E_V8SImode)
          || !vector_neg_arith_operand (operands[5], E_V8SImode))
        return -1;
      if ((
#line 4875 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8SImode)) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 12749; /* *pred_ltgev8si */
      if (!(
#line 4896 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8SImode)) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12817; /* *pred_ltgev8si_narrow */

    case E_V8DImode:
      if (!register_operand (operands[4], E_V8DImode)
          || !vector_neg_arith_operand (operands[5], E_V8DImode))
        return -1;
      if ((
#line 4875 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8DImode)) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 12760; /* *pred_ltgev8di */
      if (!(
#line 4896 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8DImode)) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12828; /* *pred_ltgev8di_narrow */

    default:
      return -1;
    }
}

 int
recog_1404 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF2QImode:
      if (!register_operand (operands[3], E_RVVMF2QImode)
          || GET_MODE (x9) != E_RVVMF2QImode
          || !register_operand (operands[4], E_QImode)
          || !
#line 4935 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12839; /* *pred_cmprvvmf2qi_scalar_merge_tie_mask */

    case E_RVVM1HImode:
      if (!register_operand (operands[3], E_RVVM1HImode)
          || GET_MODE (x9) != E_RVVM1HImode
          || !register_operand (operands[4], E_HImode)
          || !
#line 4935 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12845; /* *pred_cmprvvm1hi_scalar_merge_tie_mask */

    case E_RVVM2SImode:
      if (!register_operand (operands[3], E_RVVM2SImode)
          || GET_MODE (x9) != E_RVVM2SImode
          || !register_operand (operands[4], E_SImode)
          || !
#line 4935 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 12850; /* *pred_cmprvvm2si_scalar_merge_tie_mask */

    case E_RVVM4DImode:
      if (!register_operand (operands[3], E_RVVM4DImode)
          || GET_MODE (x9) != E_RVVM4DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5045 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12998; /* *pred_cmprvvm4di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1411 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V16QImode:
      if (!register_operand (operands[3], E_V16QImode)
          || GET_MODE (x9) != E_V16QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4935 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 12857; /* *pred_cmpv16qi_scalar_merge_tie_mask */

    case E_V16HImode:
      if (!register_operand (operands[3], E_V16HImode)
          || GET_MODE (x9) != E_V16HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4935 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 12870; /* *pred_cmpv16hi_scalar_merge_tie_mask */

    case E_V16SImode:
      if (!register_operand (operands[3], E_V16SImode)
          || GET_MODE (x9) != E_V16SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4935 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12882; /* *pred_cmpv16si_scalar_merge_tie_mask */

    case E_V16DImode:
      if (!register_operand (operands[3], E_V16DImode)
          || GET_MODE (x9) != E_V16DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5045 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 13005; /* *pred_cmpv16di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1418 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V2048QImode:
      if (!register_operand (operands[3], E_V2048QImode)
          || GET_MODE (x9) != E_V2048QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4935 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12864; /* *pred_cmpv2048qi_scalar_merge_tie_mask */

    case E_V2048HImode:
      if (!register_operand (operands[3], E_V2048HImode)
          || GET_MODE (x9) != E_V2048HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4935 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12877; /* *pred_cmpv2048hi_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1422 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern571 (x2, 
E_V64BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V64BImode))
    {
      res = recog_1413 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V64BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V64BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V64QImode:
      if (!register_operand (operands[4], E_V64QImode)
          || GET_MODE (x9) != E_V64QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64QImode)) && 
#line 736 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return 12913; /* *pred_cmpv64qi_scalar */
      if (!(
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64QImode)) && 
#line 736 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 12967; /* *pred_cmpv64qi_scalar_narrow */

    case E_V64HImode:
      if (!register_operand (operands[4], E_V64HImode)
          || GET_MODE (x9) != E_V64HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64HImode)) && 
#line 749 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 12926; /* *pred_cmpv64hi_scalar */
      if (!(
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64HImode)) && 
#line 749 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 12980; /* *pred_cmpv64hi_scalar_narrow */

    case E_V64SImode:
      if (!register_operand (operands[4], E_V64SImode)
          || GET_MODE (x9) != E_V64SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64SImode)) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 12938; /* *pred_cmpv64si_scalar */
      if (!(
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64SImode)) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 12992; /* *pred_cmpv64si_scalar_narrow */

    case E_V64DImode:
      if (!register_operand (operands[4], E_V64DImode)
          || GET_MODE (x9) != E_V64DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V64DImode)) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 13021; /* *pred_cmpv64di_scalar */
      if (!(
#line 5092 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V64DImode)) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 13035; /* *pred_cmpv64di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1429 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1BImode:
      x2 = XEXP (x1, 1);
      if (pattern571 (x2, 
E_RVVM1BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern625 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode) == 0
          && 
#line 4935 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return 12835; /* *pred_cmprvvm8qi_scalar_merge_tie_mask */
      operands[3] = x3;
      if (pattern626 (x2, 
E_RVVM1BImode, 
E_RVVM8QImode, 
E_QImode) != 0)
        return -1;
      if (
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8QImode)))
        return 12889; /* *pred_cmprvvm8qi_scalar */
      if (!
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8QImode)))
        return -1;
      return 12943; /* *pred_cmprvvm8qi_scalar_narrow */

    case E_RVVMF2BImode:
      x2 = XEXP (x1, 1);
      if (pattern571 (x2, 
E_RVVMF2BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF2BImode))
        {
          res = recog_1401 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF2BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF2BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM4QImode:
          if (!register_operand (operands[4], E_RVVM4QImode)
              || GET_MODE (x9) != E_RVVM4QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if (
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4QImode)))
            return 12890; /* *pred_cmprvvm4qi_scalar */
          if (!
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4QImode)))
            return -1;
          return 12944; /* *pred_cmprvvm4qi_scalar_narrow */

        case E_RVVM8HImode:
          if (!register_operand (operands[4], E_RVVM8HImode)
              || GET_MODE (x9) != E_RVVM8HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if (
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8HImode)))
            return 12896; /* *pred_cmprvvm8hi_scalar */
          if (!
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8HImode)))
            return -1;
          return 12950; /* *pred_cmprvvm8hi_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF4BImode:
      x2 = XEXP (x1, 1);
      if (pattern571 (x2, 
E_RVVMF4BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF4BImode))
        {
          res = recog_1402 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF4BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM2QImode:
          if (!register_operand (operands[4], E_RVVM2QImode)
              || GET_MODE (x9) != E_RVVM2QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if (
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2QImode)))
            return 12891; /* *pred_cmprvvm2qi_scalar */
          if (!
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2QImode)))
            return -1;
          return 12945; /* *pred_cmprvvm2qi_scalar_narrow */

        case E_RVVM4HImode:
          if (!register_operand (operands[4], E_RVVM4HImode)
              || GET_MODE (x9) != E_RVVM4HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if (
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4HImode)))
            return 12897; /* *pred_cmprvvm4hi_scalar */
          if (!
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4HImode)))
            return -1;
          return 12951; /* *pred_cmprvvm4hi_scalar_narrow */

        case E_RVVM8SImode:
          if (!register_operand (operands[4], E_RVVM8SImode)
              || GET_MODE (x9) != E_RVVM8SImode
              || !register_operand (operands[5], E_SImode))
            return -1;
          if (
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8SImode)))
            return 12902; /* *pred_cmprvvm8si_scalar */
          if (!
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8SImode)))
            return -1;
          return 12956; /* *pred_cmprvvm8si_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF8BImode:
      x2 = XEXP (x1, 1);
      if (pattern571 (x2, 
E_RVVMF8BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF8BImode))
        {
          res = recog_1403 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF8BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVM1QImode:
          if (!register_operand (operands[4], E_RVVM1QImode)
              || GET_MODE (x9) != E_RVVM1QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if (
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1QImode)))
            return 12892; /* *pred_cmprvvm1qi_scalar */
          if (!
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1QImode)))
            return -1;
          return 12946; /* *pred_cmprvvm1qi_scalar_narrow */

        case E_RVVM2HImode:
          if (!register_operand (operands[4], E_RVVM2HImode)
              || GET_MODE (x9) != E_RVVM2HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if (
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2HImode)))
            return 12898; /* *pred_cmprvvm2hi_scalar */
          if (!
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2HImode)))
            return -1;
          return 12952; /* *pred_cmprvvm2hi_scalar_narrow */

        case E_RVVM4SImode:
          if (!register_operand (operands[4], E_RVVM4SImode)
              || GET_MODE (x9) != E_RVVM4SImode
              || !register_operand (operands[5], E_SImode))
            return -1;
          if (
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4SImode)))
            return 12903; /* *pred_cmprvvm4si_scalar */
          if (!
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4SImode)))
            return -1;
          return 12957; /* *pred_cmprvvm4si_scalar_narrow */

        case E_RVVM8DImode:
          if (!register_operand (operands[4], E_RVVM8DImode)
              || GET_MODE (x9) != E_RVVM8DImode
              || !register_operand (operands[5], E_DImode))
            return -1;
          if ((
#line 5070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM8DImode)) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13011; /* *pred_cmprvvm8di_scalar */
          if (!(
#line 5092 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM8DImode)) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13025; /* *pred_cmprvvm8di_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF16BImode:
      x2 = XEXP (x1, 1);
      if (pattern571 (x2, 
E_RVVMF16BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF16BImode))
        {
          res = recog_1404 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF16BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVMF2QImode:
          if (!register_operand (operands[4], E_RVVMF2QImode)
              || GET_MODE (x9) != E_RVVMF2QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if (
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2QImode)))
            return 12893; /* *pred_cmprvvmf2qi_scalar */
          if (!
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2QImode)))
            return -1;
          return 12947; /* *pred_cmprvvmf2qi_scalar_narrow */

        case E_RVVM1HImode:
          if (!register_operand (operands[4], E_RVVM1HImode)
              || GET_MODE (x9) != E_RVVM1HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if (
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1HImode)))
            return 12899; /* *pred_cmprvvm1hi_scalar */
          if (!
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1HImode)))
            return -1;
          return 12953; /* *pred_cmprvvm1hi_scalar_narrow */

        case E_RVVM2SImode:
          if (!register_operand (operands[4], E_RVVM2SImode)
              || GET_MODE (x9) != E_RVVM2SImode
              || !register_operand (operands[5], E_SImode))
            return -1;
          if (
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2SImode)))
            return 12904; /* *pred_cmprvvm2si_scalar */
          if (!
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2SImode)))
            return -1;
          return 12958; /* *pred_cmprvvm2si_scalar_narrow */

        case E_RVVM4DImode:
          if (!register_operand (operands[4], E_RVVM4DImode)
              || GET_MODE (x9) != E_RVVM4DImode
              || !register_operand (operands[5], E_DImode))
            return -1;
          if ((
#line 5070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM4DImode)) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13012; /* *pred_cmprvvm4di_scalar */
          if (!(
#line 5092 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM4DImode)) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13026; /* *pred_cmprvvm4di_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF32BImode:
      x2 = XEXP (x1, 1);
      if (pattern571 (x2, 
E_RVVMF32BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF32BImode))
        {
          res = recog_1405 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF32BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVMF4QImode:
          if (!register_operand (operands[4], E_RVVMF4QImode)
              || GET_MODE (x9) != E_RVVMF4QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if (
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4QImode)))
            return 12894; /* *pred_cmprvvmf4qi_scalar */
          if (!
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4QImode)))
            return -1;
          return 12948; /* *pred_cmprvvmf4qi_scalar_narrow */

        case E_RVVMF2HImode:
          if (!register_operand (operands[4], E_RVVMF2HImode)
              || GET_MODE (x9) != E_RVVMF2HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if (
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2HImode)))
            return 12900; /* *pred_cmprvvmf2hi_scalar */
          if (!
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2HImode)))
            return -1;
          return 12954; /* *pred_cmprvvmf2hi_scalar_narrow */

        case E_RVVM1SImode:
          if (!register_operand (operands[4], E_RVVM1SImode)
              || GET_MODE (x9) != E_RVVM1SImode
              || !register_operand (operands[5], E_SImode))
            return -1;
          if (
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1SImode)))
            return 12905; /* *pred_cmprvvm1si_scalar */
          if (!
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1SImode)))
            return -1;
          return 12959; /* *pred_cmprvvm1si_scalar_narrow */

        case E_RVVM2DImode:
          if (!register_operand (operands[4], E_RVVM2DImode)
              || GET_MODE (x9) != E_RVVM2DImode
              || !register_operand (operands[5], E_DImode))
            return -1;
          if ((
#line 5070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM2DImode)) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13013; /* *pred_cmprvvm2di_scalar */
          if (!(
#line 5092 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM2DImode)) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13027; /* *pred_cmprvvm2di_scalar_narrow */

        default:
          return -1;
        }

    case E_RVVMF64BImode:
      x2 = XEXP (x1, 1);
      if (pattern571 (x2, 
E_RVVMF64BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_RVVMF64BImode))
        {
          res = recog_1406 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_RVVMF64BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_RVVMF8QImode:
          if (!register_operand (operands[4], E_RVVMF8QImode)
              || GET_MODE (x9) != E_RVVMF8QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if ((
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF8QImode)) && 
#line 724 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12895; /* *pred_cmprvvmf8qi_scalar */
          if (!(
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF8QImode)) && 
#line 724 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12949; /* *pred_cmprvvmf8qi_scalar_narrow */

        case E_RVVMF4HImode:
          if (!register_operand (operands[4], E_RVVMF4HImode)
              || GET_MODE (x9) != E_RVVMF4HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if ((
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF4HImode)) && 
#line 726 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12901; /* *pred_cmprvvmf4hi_scalar */
          if (!(
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF4HImode)) && 
#line 726 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12955; /* *pred_cmprvvmf4hi_scalar_narrow */

        case E_RVVMF2SImode:
          if (!register_operand (operands[4], E_RVVMF2SImode)
              || GET_MODE (x9) != E_RVVMF2SImode
              || !register_operand (operands[5], E_SImode))
            return -1;
          if ((
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVMF2SImode)) && 
#line 728 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 12906; /* *pred_cmprvvmf2si_scalar */
          if (!(
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVMF2SImode)) && 
#line 728 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 12960; /* *pred_cmprvvmf2si_scalar_narrow */

        case E_RVVM1DImode:
          if (!register_operand (operands[4], E_RVVM1DImode)
              || GET_MODE (x9) != E_RVVM1DImode
              || !register_operand (operands[5], E_DImode))
            return -1;
          if ((
#line 5070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (RVVM1DImode)) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return 13014; /* *pred_cmprvvm1di_scalar */
          if (!(
#line 5092 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (RVVM1DImode)) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 13028; /* *pred_cmprvvm1di_scalar_narrow */

        default:
          return -1;
        }

    case E_V1BImode:
      return recog_1428 (x1, insn, pnum_clobbers);

    case E_V2BImode:
      return recog_1427 (x1, insn, pnum_clobbers);

    case E_V4BImode:
      return recog_1426 (x1, insn, pnum_clobbers);

    case E_V8BImode:
      return recog_1425 (x1, insn, pnum_clobbers);

    case E_V16BImode:
      return recog_1424 (x1, insn, pnum_clobbers);

    case E_V32BImode:
      return recog_1423 (x1, insn, pnum_clobbers);

    case E_V64BImode:
      return recog_1422 (x1, insn, pnum_clobbers);

    case E_V128BImode:
      return recog_1421 (x1, insn, pnum_clobbers);

    case E_V256BImode:
      return recog_1420 (x1, insn, pnum_clobbers);

    case E_V512BImode:
      return recog_1419 (x1, insn, pnum_clobbers);

    case E_V1024BImode:
      x2 = XEXP (x1, 1);
      if (pattern571 (x2, 
E_V1024BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V1024BImode))
        {
          res = recog_1417 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V1024BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_V1024BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V1024QImode:
          if (!register_operand (operands[4], E_V1024QImode)
              || GET_MODE (x9) != E_V1024QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if ((
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024QImode)) && 
#line 740 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return 12917; /* *pred_cmpv1024qi_scalar */
          if (!(
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024QImode)) && 
#line 740 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 12971; /* *pred_cmpv1024qi_scalar_narrow */

        case E_V1024HImode:
          if (!register_operand (operands[4], E_V1024HImode)
              || GET_MODE (x9) != E_V1024HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if ((
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024HImode)) && 
#line 753 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return 12930; /* *pred_cmpv1024hi_scalar */
          if (!(
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024HImode)) && 
#line 753 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 12984; /* *pred_cmpv1024hi_scalar_narrow */

        case E_V1024SImode:
          if (!register_operand (operands[4], E_V1024SImode)
              || GET_MODE (x9) != E_V1024SImode
              || !register_operand (operands[5], E_SImode))
            return -1;
          if ((
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V1024SImode)) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return 12942; /* *pred_cmpv1024si_scalar */
          if (!(
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V1024SImode)) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 12996; /* *pred_cmpv1024si_scalar_narrow */

        default:
          return -1;
        }

    case E_V2048BImode:
      x2 = XEXP (x1, 1);
      if (pattern571 (x2, 
E_V2048BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (register_operand (operands[1], E_V2048BImode))
        {
          res = recog_1418 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!vector_mask_operand (operands[1], E_V2048BImode))
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XVECEXP (x4, 0, 1);
      operands[6] = x5;
      x6 = XVECEXP (x4, 0, 2);
      operands[7] = x6;
      x7 = XVECEXP (x4, 0, 3);
      operands[8] = x7;
      x8 = XEXP (x3, 0);
      operands[4] = x8;
      x9 = XEXP (x3, 1);
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!vector_merge_operand (operands[2], E_V2048BImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_V2048QImode:
          if (!register_operand (operands[4], E_V2048QImode)
              || GET_MODE (x9) != E_V2048QImode
              || !register_operand (operands[5], E_QImode))
            return -1;
          if ((
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048QImode)) && 
#line 741 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return 12918; /* *pred_cmpv2048qi_scalar */
          if (!(
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048QImode)) && 
#line 741 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 12972; /* *pred_cmpv2048qi_scalar_narrow */

        case E_V2048HImode:
          if (!register_operand (operands[4], E_V2048HImode)
              || GET_MODE (x9) != E_V2048HImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          if ((
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V2048HImode)) && 
#line 754 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return 12931; /* *pred_cmpv2048hi_scalar */
          if (!(
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V2048HImode)) && 
#line 754 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 12985; /* *pred_cmpv2048hi_scalar_narrow */

        default:
          return -1;
        }

    case E_V4096BImode:
      x2 = XEXP (x1, 1);
      if (pattern571 (x2, 
E_V4096BImode) != 0)
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (pattern625 (x2, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) == 0
          && (
#line 4935 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 12865; /* *pred_cmpv4096qi_scalar_merge_tie_mask */
      operands[3] = x3;
      if (pattern626 (x2, 
E_V4096BImode, 
E_V4096QImode, 
E_QImode) != 0)
        return -1;
      if ((
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4096QImode)) && 
#line 742 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return 12919; /* *pred_cmpv4096qi_scalar */
      if (!(
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4096QImode)) && 
#line 742 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 12973; /* *pred_cmpv4096qi_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1479 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern101 (x1))
    {
    case 0:
      if (reg_or_0_operand (operands[1], E_SImode)
          && 
#line 2147 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
        return 170; /* floatunssisf2 */
      if (!reg_or_0_operand (operands[1], E_DImode)
          || !(
#line 2147 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
        return -1;
      return 171; /* floatunsdisf2 */

    case 1:
      if (reg_or_0_operand (operands[1], E_SImode)
          && (
#line 2147 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return 172; /* floatunssidf2 */
      if (!reg_or_0_operand (operands[1], E_DImode)
          || !(
#line 2147 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
        return -1;
      return 173; /* floatunsdidf2 */

    case 2:
      if (reg_or_0_operand (operands[1], E_SImode)
          && (
#line 2147 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return 174; /* floatunssihf2 */
      if (!reg_or_0_operand (operands[1], E_DImode)
          || !(
#line 2147 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
        return -1;
      return 175; /* floatunsdihf2 */

    case 3:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26492; /* floatunsrvvm8hirvvm8hf2 */

    case 4:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26648; /* floatunsrvvm4qirvvm8hf2 */

    case 5:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26494; /* floatunsrvvm4hirvvm4hf2 */

    case 6:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26650; /* floatunsrvvm2qirvvm4hf2 */

    case 7:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26840; /* floatunsrvvm8sirvvm4hf2 */

    case 8:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26496; /* floatunsrvvm2hirvvm2hf2 */

    case 9:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26652; /* floatunsrvvm1qirvvm2hf2 */

    case 10:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26842; /* floatunsrvvm4sirvvm2hf2 */

    case 11:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26498; /* floatunsrvvm1hirvvm1hf2 */

    case 12:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26654; /* floatunsrvvmf2qirvvm1hf2 */

    case 13:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26844; /* floatunsrvvm2sirvvm1hf2 */

    case 14:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26500; /* floatunsrvvmf2hirvvmf2hf2 */

    case 15:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26656; /* floatunsrvvmf4qirvvmf2hf2 */

    case 16:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26846; /* floatunsrvvm1sirvvmf2hf2 */

    case 17:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26502; /* floatunsrvvmf4hirvvmf4hf2 */

    case 18:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26658; /* floatunsrvvmf8qirvvmf4hf2 */

    case 19:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26848; /* floatunsrvvmf2sirvvmf4hf2 */

    case 20:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26504; /* floatunsrvvm8sirvvm8sf2 */

    case 21:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26660; /* floatunsrvvm4hirvvm8sf2 */

    case 22:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26506; /* floatunsrvvm4sirvvm4sf2 */

    case 23:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26662; /* floatunsrvvm2hirvvm4sf2 */

    case 24:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26850; /* floatunsrvvm8dirvvm4sf2 */

    case 25:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26508; /* floatunsrvvm2sirvvm2sf2 */

    case 26:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26664; /* floatunsrvvm1hirvvm2sf2 */

    case 27:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26852; /* floatunsrvvm4dirvvm2sf2 */

    case 28:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26510; /* floatunsrvvm1sirvvm1sf2 */

    case 29:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26666; /* floatunsrvvmf2hirvvm1sf2 */

    case 30:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26854; /* floatunsrvvm2dirvvm1sf2 */

    case 31:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26512; /* floatunsrvvmf2sirvvmf2sf2 */

    case 32:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26668; /* floatunsrvvmf4hirvvmf2sf2 */

    case 33:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26856; /* floatunsrvvm1dirvvmf2sf2 */

    case 34:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26514; /* floatunsrvvm8dirvvm8df2 */

    case 35:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26670; /* floatunsrvvm4sirvvm8df2 */

    case 36:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26516; /* floatunsrvvm4dirvvm4df2 */

    case 37:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26672; /* floatunsrvvm2sirvvm4df2 */

    case 38:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26518; /* floatunsrvvm2dirvvm2df2 */

    case 39:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26674; /* floatunsrvvm1sirvvm2df2 */

    case 40:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26520; /* floatunsrvvm1dirvvm1df2 */

    case 41:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26676; /* floatunsrvvmf2sirvvm1df2 */

    case 42:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 26522; /* floatunsv1hiv1hf2 */

    case 43:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 26678; /* floatunsv1qiv1hf2 */

    case 44:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 26858; /* floatunsv1siv1hf2 */

    case 45:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 26524; /* floatunsv2hiv2hf2 */

    case 46:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 26680; /* floatunsv2qiv2hf2 */

    case 47:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 26860; /* floatunsv2siv2hf2 */

    case 48:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 26526; /* floatunsv4hiv4hf2 */

    case 49:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 26682; /* floatunsv4qiv4hf2 */

    case 50:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 26862; /* floatunsv4siv4hf2 */

    case 51:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 26528; /* floatunsv8hiv8hf2 */

    case 52:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 26684; /* floatunsv8qiv8hf2 */

    case 53:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 26864; /* floatunsv8siv8hf2 */

    case 54:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 26530; /* floatunsv16hiv16hf2 */

    case 55:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 26686; /* floatunsv16qiv16hf2 */

    case 56:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26866; /* floatunsv16siv16hf2 */

    case 57:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26532; /* floatunsv32hiv32hf2 */

    case 58:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26688; /* floatunsv32qiv32hf2 */

    case 59:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26868; /* floatunsv32siv32hf2 */

    case 60:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26534; /* floatunsv64hiv64hf2 */

    case 61:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26690; /* floatunsv64qiv64hf2 */

    case 62:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26870; /* floatunsv64siv64hf2 */

    case 63:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26536; /* floatunsv128hiv128hf2 */

    case 64:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26692; /* floatunsv128qiv128hf2 */

    case 65:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26872; /* floatunsv128siv128hf2 */

    case 66:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26538; /* floatunsv256hiv256hf2 */

    case 67:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26694; /* floatunsv256qiv256hf2 */

    case 68:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26874; /* floatunsv256siv256hf2 */

    case 69:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26540; /* floatunsv512hiv512hf2 */

    case 70:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26696; /* floatunsv512qiv512hf2 */

    case 71:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26876; /* floatunsv512siv512hf2 */

    case 72:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26542; /* floatunsv1024hiv1024hf2 */

    case 73:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26698; /* floatunsv1024qiv1024hf2 */

    case 74:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26878; /* floatunsv1024siv1024hf2 */

    case 75:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26544; /* floatunsv2048hiv2048hf2 */

    case 76:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26700; /* floatunsv2048qiv2048hf2 */

    case 77:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26546; /* floatunsv1siv1sf2 */

    case 78:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26702; /* floatunsv1hiv1sf2 */

    case 79:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26880; /* floatunsv1div1sf2 */

    case 80:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26548; /* floatunsv2siv2sf2 */

    case 81:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26704; /* floatunsv2hiv2sf2 */

    case 82:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26882; /* floatunsv2div2sf2 */

    case 83:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26550; /* floatunsv4siv4sf2 */

    case 84:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26706; /* floatunsv4hiv4sf2 */

    case 85:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26884; /* floatunsv4div4sf2 */

    case 86:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26552; /* floatunsv8siv8sf2 */

    case 87:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26708; /* floatunsv8hiv8sf2 */

    case 88:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26886; /* floatunsv8div8sf2 */

    case 89:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26554; /* floatunsv16siv16sf2 */

    case 90:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26710; /* floatunsv16hiv16sf2 */

    case 91:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26888; /* floatunsv16div16sf2 */

    case 92:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26556; /* floatunsv32siv32sf2 */

    case 93:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26712; /* floatunsv32hiv32sf2 */

    case 94:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26890; /* floatunsv32div32sf2 */

    case 95:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26558; /* floatunsv64siv64sf2 */

    case 96:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26714; /* floatunsv64hiv64sf2 */

    case 97:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26892; /* floatunsv64div64sf2 */

    case 98:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26560; /* floatunsv128siv128sf2 */

    case 99:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26716; /* floatunsv128hiv128sf2 */

    case 100:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26894; /* floatunsv128div128sf2 */

    case 101:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26562; /* floatunsv256siv256sf2 */

    case 102:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26718; /* floatunsv256hiv256sf2 */

    case 103:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26896; /* floatunsv256div256sf2 */

    case 104:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26564; /* floatunsv512siv512sf2 */

    case 105:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26720; /* floatunsv512hiv512sf2 */

    case 106:
      if (!(
#line 1049 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26898; /* floatunsv512div512sf2 */

    case 107:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26566; /* floatunsv1024siv1024sf2 */

    case 108:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26722; /* floatunsv1024hiv1024sf2 */

    case 109:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26568; /* floatunsv1div1df2 */

    case 110:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26724; /* floatunsv1siv1df2 */

    case 111:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26570; /* floatunsv2div2df2 */

    case 112:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26726; /* floatunsv2siv2df2 */

    case 113:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26572; /* floatunsv4div4df2 */

    case 114:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26728; /* floatunsv4siv4df2 */

    case 115:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26574; /* floatunsv8div8df2 */

    case 116:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26730; /* floatunsv8siv8df2 */

    case 117:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26576; /* floatunsv16div16df2 */

    case 118:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26732; /* floatunsv16siv16df2 */

    case 119:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26578; /* floatunsv32div32df2 */

    case 120:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26734; /* floatunsv32siv32df2 */

    case 121:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26580; /* floatunsv64div64df2 */

    case 122:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26736; /* floatunsv64siv64df2 */

    case 123:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26582; /* floatunsv128div128df2 */

    case 124:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26738; /* floatunsv128siv128df2 */

    case 125:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26584; /* floatunsv256div256df2 */

    case 126:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26740; /* floatunsv256siv256df2 */

    case 127:
      if (!(
#line 957 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26586; /* floatunsv512div512df2 */

    case 128:
      if (!(
#line 1005 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26742; /* floatunsv512siv512df2 */

    default:
      return -1;
    }
}

 int
recog_1488 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern117 (x3))
    {
    case 0:
      if (!
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 3520; /* *vec_duplicatervvm8qi */

    case 1:
      if (!
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 3521; /* *vec_duplicatervvm4qi */

    case 2:
      if (!
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 3522; /* *vec_duplicatervvm2qi */

    case 3:
      if (!
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 3523; /* *vec_duplicatervvm1qi */

    case 4:
      if (!
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 3524; /* *vec_duplicatervvm8hi */

    case 5:
      if (!
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 3525; /* *vec_duplicatervvm4hi */

    case 6:
      if (!
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 3526; /* *vec_duplicatervvm2hi */

    case 7:
      if (!
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 3527; /* *vec_duplicatervvm1hi */

    case 8:
      if (!
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 3528; /* *vec_duplicatervvm8si */

    case 9:
      if (!
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 3529; /* *vec_duplicatervvm4si */

    case 10:
      if (!
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 3530; /* *vec_duplicatervvm2si */

    case 11:
      if (!
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 3531; /* *vec_duplicatervvm1si */

    case 12:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3532; /* *vec_duplicatervvm8di */

    case 13:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3533; /* *vec_duplicatervvm4di */

    case 14:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3534; /* *vec_duplicatervvm2di */

    case 15:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3535; /* *vec_duplicatervvm1di */

    case 16:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3536; /* *vec_duplicatervvmf2qi */

    case 17:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3537; /* *vec_duplicatervvmf4qi */

    case 18:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3538; /* *vec_duplicatervvmf8qi */

    case 19:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 3539; /* *vec_duplicatervvmf2hi */

    case 20:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3540; /* *vec_duplicatervvmf4hi */

    case 21:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 3541; /* *vec_duplicatervvmf2si */

    case 22:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3542; /* *vec_duplicatervvm8bf */

    case 23:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3543; /* *vec_duplicatervvm4bf */

    case 24:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3544; /* *vec_duplicatervvm2bf */

    case 25:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3545; /* *vec_duplicatervvm1bf */

    case 26:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 3546; /* *vec_duplicatervvmf2bf */

    case 27:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3547; /* *vec_duplicatervvmf4bf */

    case 28:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3548; /* *vec_duplicatervvm8hf */

    case 29:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3549; /* *vec_duplicatervvm4hf */

    case 30:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3550; /* *vec_duplicatervvm2hf */

    case 31:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3551; /* *vec_duplicatervvm1hf */

    case 32:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3552; /* *vec_duplicatervvmf2hf */

    case 33:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3553; /* *vec_duplicatervvmf4hf */

    case 34:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3554; /* *vec_duplicatervvm8sf */

    case 35:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3555; /* *vec_duplicatervvm4sf */

    case 36:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3556; /* *vec_duplicatervvm2sf */

    case 37:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3557; /* *vec_duplicatervvm1sf */

    case 38:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3558; /* *vec_duplicatervvmf2sf */

    case 39:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3559; /* *vec_duplicatervvm8df */

    case 40:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3560; /* *vec_duplicatervvm4df */

    case 41:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3561; /* *vec_duplicatervvm2df */

    case 42:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3562; /* *vec_duplicatervvm1df */

    case 43:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 3563; /* *vec_duplicatev1qi */

    case 44:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 3564; /* *vec_duplicatev2qi */

    case 45:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 3565; /* *vec_duplicatev4qi */

    case 46:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 3566; /* *vec_duplicatev8qi */

    case 47:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 3567; /* *vec_duplicatev16qi */

    case 48:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 3568; /* *vec_duplicatev32qi */

    case 49:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3569; /* *vec_duplicatev64qi */

    case 50:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3570; /* *vec_duplicatev128qi */

    case 51:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3571; /* *vec_duplicatev256qi */

    case 52:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3572; /* *vec_duplicatev512qi */

    case 53:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3573; /* *vec_duplicatev1024qi */

    case 54:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3574; /* *vec_duplicatev2048qi */

    case 55:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3575; /* *vec_duplicatev4096qi */

    case 56:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 3576; /* *vec_duplicatev1hi */

    case 57:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 3577; /* *vec_duplicatev2hi */

    case 58:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 3578; /* *vec_duplicatev4hi */

    case 59:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 3579; /* *vec_duplicatev8hi */

    case 60:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 3580; /* *vec_duplicatev16hi */

    case 61:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3581; /* *vec_duplicatev32hi */

    case 62:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3582; /* *vec_duplicatev64hi */

    case 63:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3583; /* *vec_duplicatev128hi */

    case 64:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3584; /* *vec_duplicatev256hi */

    case 65:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3585; /* *vec_duplicatev512hi */

    case 66:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3586; /* *vec_duplicatev1024hi */

    case 67:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3587; /* *vec_duplicatev2048hi */

    case 68:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 3588; /* *vec_duplicatev1si */

    case 69:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 3589; /* *vec_duplicatev2si */

    case 70:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 3590; /* *vec_duplicatev4si */

    case 71:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 3591; /* *vec_duplicatev8si */

    case 72:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3592; /* *vec_duplicatev16si */

    case 73:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3593; /* *vec_duplicatev32si */

    case 74:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3594; /* *vec_duplicatev64si */

    case 75:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3595; /* *vec_duplicatev128si */

    case 76:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3596; /* *vec_duplicatev256si */

    case 77:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3597; /* *vec_duplicatev512si */

    case 78:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3598; /* *vec_duplicatev1024si */

    case 79:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3599; /* *vec_duplicatev1di */

    case 80:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3600; /* *vec_duplicatev2di */

    case 81:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 3601; /* *vec_duplicatev4di */

    case 82:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3602; /* *vec_duplicatev8di */

    case 83:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3603; /* *vec_duplicatev16di */

    case 84:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3604; /* *vec_duplicatev32di */

    case 85:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3605; /* *vec_duplicatev64di */

    case 86:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3606; /* *vec_duplicatev128di */

    case 87:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3607; /* *vec_duplicatev256di */

    case 88:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3608; /* *vec_duplicatev512di */

    case 89:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3609; /* *vec_duplicatev1hf */

    case 90:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3610; /* *vec_duplicatev2hf */

    case 91:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3611; /* *vec_duplicatev4hf */

    case 92:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3612; /* *vec_duplicatev8hf */

    case 93:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 3613; /* *vec_duplicatev16hf */

    case 94:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3614; /* *vec_duplicatev32hf */

    case 95:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3615; /* *vec_duplicatev64hf */

    case 96:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3616; /* *vec_duplicatev128hf */

    case 97:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3617; /* *vec_duplicatev256hf */

    case 98:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3618; /* *vec_duplicatev512hf */

    case 99:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3619; /* *vec_duplicatev1024hf */

    case 100:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3620; /* *vec_duplicatev2048hf */

    case 101:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3621; /* *vec_duplicatev1sf */

    case 102:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3622; /* *vec_duplicatev2sf */

    case 103:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3623; /* *vec_duplicatev4sf */

    case 104:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 3624; /* *vec_duplicatev8sf */

    case 105:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3625; /* *vec_duplicatev16sf */

    case 106:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3626; /* *vec_duplicatev32sf */

    case 107:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3627; /* *vec_duplicatev64sf */

    case 108:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3628; /* *vec_duplicatev128sf */

    case 109:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3629; /* *vec_duplicatev256sf */

    case 110:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 293 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3630; /* *vec_duplicatev512sf */

    case 111:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3631; /* *vec_duplicatev1024sf */

    case 112:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3632; /* *vec_duplicatev1df */

    case 113:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3633; /* *vec_duplicatev2df */

    case 114:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 3634; /* *vec_duplicatev4df */

    case 115:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 3635; /* *vec_duplicatev8df */

    case 116:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 3636; /* *vec_duplicatev16df */

    case 117:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 3637; /* *vec_duplicatev32df */

    case 118:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 3638; /* *vec_duplicatev64df */

    case 119:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 3639; /* *vec_duplicatev128df */

    case 120:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 3640; /* *vec_duplicatev256df */

    case 121:
      if (!(
#line 1592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 3641; /* *vec_duplicatev512df */

    default:
      return -1;
    }
}

 int
recog_1498 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern1 (x1))
    {
    case 0:
      if (!
#line 1416 "../../gcc/config/riscv/riscv.md"
(TARGET_DIV))
        return -1;
      return 39; /* *umodsi3 */

    case 1:
      if (!
#line 1443 "../../gcc/config/riscv/riscv.md"
(TARGET_DIV && TARGET_64BIT))
        return -1;
      return 43; /* umoddi3 */

    case 2:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24554; /* umodrvvm8qi3 */

    case 3:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24568; /* umodrvvm4qi3 */

    case 4:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24582; /* umodrvvm2qi3 */

    case 5:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24596; /* umodrvvm1qi3 */

    case 6:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24610; /* umodrvvm8hi3 */

    case 7:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24624; /* umodrvvm4hi3 */

    case 8:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24638; /* umodrvvm2hi3 */

    case 9:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24652; /* umodrvvm1hi3 */

    case 10:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24666; /* umodrvvm8si3 */

    case 11:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24680; /* umodrvvm4si3 */

    case 12:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24694; /* umodrvvm2si3 */

    case 13:
      if (!
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 24708; /* umodrvvm1si3 */

    case 14:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24722; /* umodrvvm8di3 */

    case 15:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24736; /* umodrvvm4di3 */

    case 16:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24750; /* umodrvvm2di3 */

    case 17:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 24764; /* umodrvvm1di3 */

    case 18:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24778; /* umodrvvmf2qi3 */

    case 19:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24792; /* umodrvvmf4qi3 */

    case 20:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24806; /* umodrvvmf8qi3 */

    case 21:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 24820; /* umodrvvmf2hi3 */

    case 22:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24834; /* umodrvvmf4hi3 */

    case 23:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 24848; /* umodrvvmf2si3 */

    case 24:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 24862; /* umodv1qi3 */

    case 25:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 24876; /* umodv2qi3 */

    case 26:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 24890; /* umodv4qi3 */

    case 27:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 24904; /* umodv8qi3 */

    case 28:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 24918; /* umodv16qi3 */

    case 29:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 24932; /* umodv32qi3 */

    case 30:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 24946; /* umodv64qi3 */

    case 31:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 24960; /* umodv128qi3 */

    case 32:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 24974; /* umodv256qi3 */

    case 33:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 24988; /* umodv512qi3 */

    case 34:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25002; /* umodv1024qi3 */

    case 35:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25016; /* umodv2048qi3 */

    case 36:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25030; /* umodv4096qi3 */

    case 37:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 25044; /* umodv1hi3 */

    case 38:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 25058; /* umodv2hi3 */

    case 39:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 25072; /* umodv4hi3 */

    case 40:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 25086; /* umodv8hi3 */

    case 41:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 25100; /* umodv16hi3 */

    case 42:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25114; /* umodv32hi3 */

    case 43:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25128; /* umodv64hi3 */

    case 44:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25142; /* umodv128hi3 */

    case 45:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25156; /* umodv256hi3 */

    case 46:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25170; /* umodv512hi3 */

    case 47:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25184; /* umodv1024hi3 */

    case 48:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25198; /* umodv2048hi3 */

    case 49:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 25212; /* umodv1si3 */

    case 50:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 25226; /* umodv2si3 */

    case 51:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 25240; /* umodv4si3 */

    case 52:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 25254; /* umodv8si3 */

    case 53:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25268; /* umodv16si3 */

    case 54:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25282; /* umodv32si3 */

    case 55:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25296; /* umodv64si3 */

    case 56:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25310; /* umodv128si3 */

    case 57:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25324; /* umodv256si3 */

    case 58:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25338; /* umodv512si3 */

    case 59:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25352; /* umodv1024si3 */

    case 60:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25366; /* umodv1di3 */

    case 61:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25380; /* umodv2di3 */

    case 62:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25394; /* umodv4di3 */

    case 63:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25408; /* umodv8di3 */

    case 64:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25422; /* umodv16di3 */

    case 65:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25436; /* umodv32di3 */

    case 66:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25450; /* umodv64di3 */

    case 67:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25464; /* umodv128di3 */

    case 68:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25478; /* umodv256di3 */

    case 69:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25492; /* umodv512di3 */

    default:
      return -1;
    }
}

 int
recog_1507 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern2 (x1))
    {
    case 0:
      if (!(
#line 1493 "../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && TARGET_FDIV) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
        return -1;
      return 51; /* sqrtsf2 */

    case 1:
      if (!(
#line 1493 "../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && TARGET_FDIV) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 52; /* sqrtdf2 */

    case 2:
      if (!(
#line 1493 "../../gcc/config/riscv/riscv.md"
((TARGET_HARD_FLOAT || TARGET_ZFINX) && TARGET_FDIV) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 53; /* sqrthf2 */

    case 3:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27131; /* sqrtrvvm8hf2 */

    case 4:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27132; /* sqrtrvvm4hf2 */

    case 5:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27133; /* sqrtrvvm2hf2 */

    case 6:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27134; /* sqrtrvvm1hf2 */

    case 7:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 27135; /* sqrtrvvmf2hf2 */

    case 8:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27136; /* sqrtrvvmf4hf2 */

    case 9:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27137; /* sqrtrvvm8sf2 */

    case 10:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27138; /* sqrtrvvm4sf2 */

    case 11:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27139; /* sqrtrvvm2sf2 */

    case 12:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27140; /* sqrtrvvm1sf2 */

    case 13:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27141; /* sqrtrvvmf2sf2 */

    case 14:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27142; /* sqrtrvvm8df2 */

    case 15:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27143; /* sqrtrvvm4df2 */

    case 16:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27144; /* sqrtrvvm2df2 */

    case 17:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27145; /* sqrtrvvm1df2 */

    case 18:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 27146; /* sqrtv1hf2 */

    case 19:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 27147; /* sqrtv2hf2 */

    case 20:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 27148; /* sqrtv4hf2 */

    case 21:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 27149; /* sqrtv8hf2 */

    case 22:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 27150; /* sqrtv16hf2 */

    case 23:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27151; /* sqrtv32hf2 */

    case 24:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27152; /* sqrtv64hf2 */

    case 25:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27153; /* sqrtv128hf2 */

    case 26:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27154; /* sqrtv256hf2 */

    case 27:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27155; /* sqrtv512hf2 */

    case 28:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27156; /* sqrtv1024hf2 */

    case 29:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27157; /* sqrtv2048hf2 */

    case 30:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27158; /* sqrtv1sf2 */

    case 31:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27159; /* sqrtv2sf2 */

    case 32:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27160; /* sqrtv4sf2 */

    case 33:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 27161; /* sqrtv8sf2 */

    case 34:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27162; /* sqrtv16sf2 */

    case 35:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27163; /* sqrtv32sf2 */

    case 36:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27164; /* sqrtv64sf2 */

    case 37:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27165; /* sqrtv128sf2 */

    case 38:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27166; /* sqrtv256sf2 */

    case 39:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27167; /* sqrtv512sf2 */

    case 40:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27168; /* sqrtv1024sf2 */

    case 41:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27169; /* sqrtv1df2 */

    case 42:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27170; /* sqrtv2df2 */

    case 43:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 27171; /* sqrtv4df2 */

    case 44:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27172; /* sqrtv8df2 */

    case 45:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27173; /* sqrtv16df2 */

    case 46:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27174; /* sqrtv32df2 */

    case 47:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27175; /* sqrtv64df2 */

    case 48:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27176; /* sqrtv128df2 */

    case 49:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27177; /* sqrtv256df2 */

    case 50:
      if (!(
#line 1150 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27178; /* sqrtv512df2 */

    default:
      return -1;
    }
}

 int
recog_1521 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != LABEL_REF)
    return -1;
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x2, 1);
  switch (GET_MODE (x7))
    {
    case E_SImode:
      if (!
#line 3788 "../../gcc/config/riscv/riscv.md"
(is_zicfilp_p ()))
        return -1;
      return 446; /* tablejump_cfisi */

    case E_DImode:
      if (!(
#line 3788 "../../gcc/config/riscv/riscv.md"
(is_zicfilp_p ()) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 447; /* tablejump_cfidi */

    default:
      return -1;
    }
}

 int
recog_1522 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (pattern330 (x3) != 0)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 2)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 2)
    return -1;
  x8 = XEXP (x5, 1);
  operands[0] = x8;
  if (!stack_push_up_to_ra_operand (operands[0], E_VOIDmode))
    return -1;
  x9 = XEXP (x3, 0);
  x10 = XEXP (x9, 1);
  switch (XWINT (x10, 0))
    {
    case -4L:
      if (pattern551 (x1, 
E_SImode) != 0
          || !(
#line 1111 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return -1;
      return 33877; /* gpr_multi_push_up_to_ra_si */

    case -8L:
      if (pattern551 (x1, 
E_DImode) != 0
          || !(
#line 1111 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 33878; /* gpr_multi_push_up_to_ra_di */

    default:
      return -1;
    }
}

 int
recog_1524 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      switch (XINT (x3, 1))
        {
        case 9:
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 10)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 5)
            return -1;
          x7 = XVECEXP (x3, 0, 0);
          operands[0] = x7;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (GET_MODE (x3) != E_SImode
                  || !symbolic_operand (operands[0], E_SImode)
                  || GET_MODE (x6) != E_SImode
                  || !(
#line 2400 "../../gcc/config/riscv/riscv.md"
(TARGET_TLSDESC) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 268; /* tlsdescsi */

            case E_DImode:
              if (GET_MODE (x3) != E_DImode
                  || !symbolic_operand (operands[0], E_DImode)
                  || GET_MODE (x6) != E_DImode
                  || !(
#line 2400 "../../gcc/config/riscv/riscv.md"
(TARGET_TLSDESC) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 269; /* tlsdescdi */

            default:
              return -1;
            }

        case 41:
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x8 = XEXP (x5, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          x7 = XVECEXP (x3, 0, 0);
          operands[1] = x7;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern422 (x3, 
E_SImode) != 0)
                return -1;
              return 475; /* stack_protect_set_si */

            case E_DImode:
              if (pattern422 (x3, 
E_DImode) != 0
                  || !
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                return -1;
              return 476; /* stack_protect_set_di */

            default:
              return -1;
            }

        case 90:
          if (GET_MODE (x3) != E_BLKmode)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          x5 = XVECEXP (x1, 0, 1);
          operands[1] = x5;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          x7 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x7, operands[0]))
            return -1;
          if (
#line 28 "../../gcc/config/riscv/sync-rvwmo.md"
(!TARGET_ZTSO))
            return 787; /* mem_thread_fence_rvwmo */
          if (!
#line 28 "../../gcc/config/riscv/sync-ztso.md"
(TARGET_ZTSO))
            return -1;
          return 796; /* mem_thread_fence_ztso */

        default:
          return -1;
        }

    case 2:
      if (XINT (x3, 1) != 42)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      x9 = XVECEXP (x3, 0, 1);
      operands[2] = x9;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern423 (x3, 
E_SImode) != 0)
            return -1;
          return 477; /* stack_protect_test_si */

        case E_DImode:
          if (pattern423 (x3, 
E_DImode) != 0
              || !
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
            return -1;
          return 478; /* stack_protect_test_di */

        default:
          return -1;
        }

    case 3:
      if (XINT (x3, 1) != 91
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 66
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SET)
        return -1;
      x8 = XEXP (x5, 1);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 4
          || XINT (x8, 1) != 91
          || GET_MODE (x8) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 67
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[0] = x7;
      x9 = XVECEXP (x3, 0, 1);
      operands[1] = x9;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x10 = XVECEXP (x3, 0, 2);
      operands[2] = x10;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x11 = XVECEXP (x8, 0, 2);
      operands[3] = x11;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x12 = XVECEXP (x8, 0, 3);
      operands[4] = x12;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return -1;
      x13 = XVECEXP (x8, 0, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      x14 = XVECEXP (x8, 0, 1);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      if (vector_length_operand (operands[0], E_SImode)
          && (
#line 1765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return 3645; /* vsetvl_discard_resultsi */
      if (!vector_length_operand (operands[0], E_DImode)
          || !(
#line 1765 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      return 3646; /* vsetvl_discard_resultdi */

    default:
      return -1;
    }
}

 int
recog_1527 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case IF_THEN_ELSE:
          if (pattern225 (x2) != 0)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x3, 0);
          x7 = XEXP (x6, 0);
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          switch (pattern429 (x1))
            {
            case 0:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 345; /* *branchqi_shiftedarith_eq_shifted */
              break;

            case 1:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 353; /* *branchqi_shiftedarith_eq_shifted */
              break;

            case 2:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 347; /* *branchhi_shiftedarith_eq_shifted */
              break;

            case 3:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 355; /* *branchhi_shiftedarith_eq_shifted */
              break;

            case 4:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 349; /* *branchsi_shiftedarith_eq_shifted */
              break;

            case 5:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 357; /* *branchsi_shiftedarith_eq_shifted */
              break;

            case 6:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && (((
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
                return 351; /* *branchdi_shiftedarith_eq_shifted */
              break;

            case 7:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 359; /* *branchdi_shiftedarith_eq_shifted */
              break;

            case 8:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 346; /* *branchqi_shiftedarith_ne_shifted */
              break;

            case 9:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 354; /* *branchqi_shiftedarith_ne_shifted */
              break;

            case 10:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 348; /* *branchhi_shiftedarith_ne_shifted */
              break;

            case 11:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 356; /* *branchhi_shiftedarith_ne_shifted */
              break;

            case 12:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 350; /* *branchsi_shiftedarith_ne_shifted */
              break;

            case 13:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 358; /* *branchsi_shiftedarith_ne_shifted */
              break;

            case 14:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && (((
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
                return 352; /* *branchdi_shiftedarith_ne_shifted */
              break;

            case 15:
              if ((
#line 3194 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[2]))
    && !SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_AFTER_COMMON_TRAILING_SHIFT (INTVAL (operands[2]),
					     INTVAL (operands[3]))) && 
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 360; /* *branchdi_shiftedarith_ne_shifted */
              break;

            default:
              break;
            }
          operands[1] = x6;
          switch (pattern431 (x1))
            {
            case 0:
              if (!(
#line 1101 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && TARGET_ZBB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 651; /* *branchsi_mask_twobits_equals_singlebit */

            case 1:
              if (!(
#line 1101 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && TARGET_ZBB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 652; /* *branchdi_mask_twobits_equals_singlebit */

            default:
              return -1;
            }

        case CALL:
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_SImode
              || pattern273 (x1) != 0)
            return -1;
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (!call_insn_operand (operands[1], E_VOIDmode))
            return -1;
          x10 = XEXP (x3, 1);
          operands[2] = x10;
          x4 = XVECEXP (x1, 0, 1);
          x11 = XEXP (x4, 0);
          x12 = XVECEXP (x11, 0, 0);
          operands[3] = x12;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          return 457; /* call_value_internal */

        case SUBREG:
        case MEM:
          operands[1] = x3;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x13 = XEXP (x4, 1);
          if (GET_CODE (x13) != UNSPEC_VOLATILE)
            return -1;
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          switch (pattern374 (x4))
            {
            case 0:
              switch (XINT (x13, 1))
                {
                case 82:
                  x5 = XVECEXP (x1, 0, 2);
                  if (GET_CODE (x5) != CLOBBER)
                    return -1;
                  x14 = XEXP (x5, 0);
                  operands[4] = x14;
                  x15 = XVECEXP (x13, 0, 0);
                  switch (GET_CODE (x15))
                    {
                    case PLUS:
                      switch (pattern461 (x13))
                        {
                        case 0:
                          if (!
#line 193 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                            return -1;
                          return 752; /* lrsc_atomic_fetch_addsi */

                        case 1:
                          if (!(
#line 193 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                            return -1;
                          return 756; /* lrsc_atomic_fetch_adddi */

                        default:
                          return -1;
                        }

                    case IOR:
                      switch (pattern461 (x13))
                        {
                        case 0:
                          if (!
#line 193 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                            return -1;
                          return 753; /* lrsc_atomic_fetch_orsi */

                        case 1:
                          if (!(
#line 193 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                            return -1;
                          return 757; /* lrsc_atomic_fetch_ordi */

                        default:
                          return -1;
                        }

                    case XOR:
                      switch (pattern461 (x13))
                        {
                        case 0:
                          if (!
#line 193 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                            return -1;
                          return 754; /* lrsc_atomic_fetch_xorsi */

                        case 1:
                          if (!(
#line 193 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                            return -1;
                          return 758; /* lrsc_atomic_fetch_xordi */

                        default:
                          return -1;
                        }

                    case AND:
                      switch (pattern461 (x13))
                        {
                        case 0:
                          if (!
#line 193 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                            return -1;
                          return 755; /* lrsc_atomic_fetch_andsi */

                        case 1:
                          if (!(
#line 193 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                            return -1;
                          return 759; /* lrsc_atomic_fetch_anddi */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case 86:
                  if (pnum_clobbers == NULL
                      || GET_MODE (x13) != E_SImode
                      || !register_operand (operands[0], E_SImode)
                      || !memory_operand (operands[1], E_SImode))
                    return -1;
                  x15 = XVECEXP (x13, 0, 0);
                  operands[2] = x15;
                  if (!reg_or_0_operand (operands[2], E_SImode))
                    return -1;
                  x5 = XVECEXP (x1, 0, 2);
                  operands[4] = x5;
                  if (!reg_or_0_operand (operands[4], E_SImode)
                      || !
#line 493 "../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                    return -1;
                  *pnum_clobbers = 1;
                  return 779; /* subword_atomic_exchange_strong */

                default:
                  return -1;
                }

            case 1:
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != CLOBBER)
                return -1;
              x15 = XVECEXP (x13, 0, 0);
              operands[2] = x15;
              x16 = XVECEXP (x13, 0, 1);
              operands[3] = x16;
              x17 = XVECEXP (x13, 0, 2);
              operands[4] = x17;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              x18 = XVECEXP (x13, 0, 3);
              operands[5] = x18;
              if (!const_int_operand (operands[5], E_SImode))
                return -1;
              x14 = XEXP (x5, 0);
              operands[6] = x14;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern552 (x13, 
E_SImode) != 0
                      || !
#line 517 "../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC))
                    return -1;
                  return 780; /* zalrsc_atomic_cas_value_strongsi */

                case E_DImode:
                  if (pattern552 (x13, 
E_DImode) != 0
                      || !(
#line 517 "../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 781; /* zalrsc_atomic_cas_value_strongdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          if (XVECLEN (x3, 0) != 2
              || XINT (x3, 1) != 85)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          x19 = XVECEXP (x3, 0, 0);
          operands[1] = x19;
          x20 = XVECEXP (x3, 0, 1);
          operands[3] = x20;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x13 = XEXP (x4, 1);
          operands[2] = x13;
          x14 = XEXP (x5, 0);
          operands[4] = x14;
          x11 = XEXP (x4, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern462 (x3, 
E_SImode) != 0
                  || !
#line 410 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC))
                return -1;
              return 775; /* lrsc_atomic_exchangesi */

            case E_DImode:
              if (pattern462 (x3, 
E_DImode) != 0
                  || !(
#line 410 "../../gcc/config/riscv/sync.md"
(!TARGET_ZAAMO && TARGET_ZALRSC) && 
#line 27 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 776; /* lrsc_atomic_exchangedi */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 5
              || XINT (x3, 1) != 91)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x13 = XEXP (x4, 1);
          if (GET_CODE (x13) != UNSPEC
              || XVECLEN (x13, 0) != 3
              || XINT (x13, 1) != 91
              || GET_MODE (x13) != E_SImode)
            return -1;
          x11 = XEXP (x4, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 66
              || GET_MODE (x11) != E_SImode)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != SET)
            return -1;
          x21 = XEXP (x5, 1);
          if (GET_CODE (x21) != UNSPEC
              || XVECLEN (x21, 0) != 4
              || XINT (x21, 1) != 91
              || GET_MODE (x21) != E_SImode)
            return -1;
          x14 = XEXP (x5, 0);
          if (GET_CODE (x14) != REG
              || REGNO (x14) != 67
              || GET_MODE (x14) != E_SImode)
            return -1;
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          x19 = XVECEXP (x3, 0, 0);
          operands[1] = x19;
          x20 = XVECEXP (x3, 0, 1);
          operands[2] = x20;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x22 = XVECEXP (x3, 0, 2);
          operands[3] = x22;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x23 = XVECEXP (x3, 0, 3);
          operands[4] = x23;
          if (!const_int_operand (operands[4], E_VOIDmode))
            return -1;
          x24 = XVECEXP (x3, 0, 4);
          operands[5] = x24;
          if (!const_int_operand (operands[5], E_VOIDmode))
            return -1;
          x15 = XVECEXP (x13, 0, 0);
          if (!rtx_equal_p (x15, operands[1]))
            return -1;
          x16 = XVECEXP (x13, 0, 1);
          if (!rtx_equal_p (x16, operands[2]))
            return -1;
          x17 = XVECEXP (x13, 0, 2);
          if (!rtx_equal_p (x17, operands[3]))
            return -1;
          x25 = XVECEXP (x21, 0, 0);
          if (!rtx_equal_p (x25, operands[2]))
            return -1;
          x26 = XVECEXP (x21, 0, 1);
          if (!rtx_equal_p (x26, operands[3]))
            return -1;
          x27 = XVECEXP (x21, 0, 2);
          if (!rtx_equal_p (x27, operands[4]))
            return -1;
          x28 = XVECEXP (x21, 0, 3);
          if (!rtx_equal_p (x28, operands[5]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !vector_length_operand (operands[1], E_SImode)
                  || !(
#line 1725 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                return -1;
              return 3642; /* vsetvlsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !vector_length_operand (operands[1], E_DImode)
                  || !(
#line 1725 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                return -1;
              return 3643; /* vsetvldi */

            default:
              return -1;
            }

        case PLUS:
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != REG
              || pattern271 (x1, 
8) != 0)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != SET)
            return -1;
          x21 = XEXP (x5, 1);
          if (GET_CODE (x21) != MEM)
            return -1;
          x29 = XEXP (x21, 0);
          if (GET_CODE (x29) != PLUS)
            return -1;
          x30 = XEXP (x29, 0);
          if (GET_CODE (x30) != REG
              || REGNO (x30) != 2)
            return -1;
          x31 = XEXP (x29, 1);
          if (GET_CODE (x31) != CONST_INT)
            return -1;
          x14 = XEXP (x5, 0);
          if (GET_CODE (x14) != REG
              || REGNO (x14) != 1)
            return -1;
          x10 = XEXP (x3, 1);
          operands[0] = x10;
          if (!stack_pop_up_to_s0_operand (operands[0], E_VOIDmode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          x13 = XEXP (x4, 1);
          x32 = XEXP (x13, 0);
          x33 = XEXP (x32, 1);
          switch (XWINT (x33, 0))
            {
            case -4L:
              if (XWINT (x31, 0) != -8L
                  || pattern695 (x1, 
E_SImode) != 0
                  || !(
#line 42 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33807; /* gpr_multi_pop_up_to_s0_si */

            case -8L:
              if (XWINT (x31, 0) != -16L
                  || pattern695 (x1, 
E_DImode) != 0
                  || !(
#line 42 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33808; /* gpr_multi_pop_up_to_s0_di */

            default:
              return -1;
            }

        case REG:
          if (pattern226 (x1, 
8) != 0)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (pattern418 (x4, 
1) != 0)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != SET)
            return -1;
          x21 = XEXP (x5, 1);
          if (GET_CODE (x21) != PLUS)
            return -1;
          x29 = XEXP (x21, 0);
          if (GET_CODE (x29) != REG
              || REGNO (x29) != 2)
            return -1;
          x14 = XEXP (x5, 0);
          if (GET_CODE (x14) != REG
              || REGNO (x14) != 2)
            return -1;
          x34 = XEXP (x21, 1);
          operands[0] = x34;
          if (!stack_push_up_to_s0_operand (operands[0], E_VOIDmode))
            return -1;
          x9 = XEXP (x2, 0);
          x35 = XEXP (x9, 0);
          x36 = XEXP (x35, 1);
          switch (XWINT (x36, 0))
            {
            case -4L:
              x11 = XEXP (x4, 0);
              x37 = XEXP (x11, 0);
              x38 = XEXP (x37, 1);
              if (XWINT (x38, 0) != -8L
                  || pattern696 (x1, 
E_SImode) != 0
                  || !(
#line 1125 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33879; /* gpr_multi_push_up_to_s0_si */

            case -8L:
              x11 = XEXP (x4, 0);
              x37 = XEXP (x11, 0);
              x38 = XEXP (x37, 1);
              if (XWINT (x38, 0) != -16L
                  || pattern696 (x1, 
E_DImode) != 0
                  || !(
#line 1125 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33880; /* gpr_multi_push_up_to_s0_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x9 = XEXP (x2, 0);
      if (GET_CODE (x9) != MEM
          || GET_MODE (x9) != E_SImode
          || pattern273 (x1) != 0)
        return -1;
      x35 = XEXP (x9, 0);
      operands[0] = x35;
      if (!call_insn_operand (operands[0], E_VOIDmode))
        return -1;
      x3 = XEXP (x2, 1);
      operands[1] = x3;
      x4 = XVECEXP (x1, 0, 1);
      x11 = XEXP (x4, 0);
      x12 = XVECEXP (x11, 0, 0);
      operands[2] = x12;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      return 456; /* call_internal */

    case RETURN:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x11 = XEXP (x4, 0);
      operands[0] = x11;
      if (!pmode_register_operand (operands[0], E_VOIDmode))
        return -1;
      return 462; /* gpr_restore_return */

    default:
      return -1;
    }
}

 int
recog_1540 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67, x68, x69, x70, x71, x72, x73;
  rtx x74, x75, x76;
  int res ATTRIBUTE_UNUSED;
  if (pattern115 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case PLUS:
      if (pattern432 (x1) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 8);
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != MEM)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != PLUS)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 2)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XEXP (x6, 0);
      if (GET_CODE (x11) != REG
          || pattern759 (x2) != 0)
        return -1;
      x12 = XEXP (x3, 0);
      if (GET_CODE (x12) != REG)
        return -1;
      x13 = XEXP (x5, 1);
      operands[0] = x13;
      switch (pattern766 (x1))
        {
        case 0:
          switch (pattern773 (x1, 
E_SImode))
            {
            case 0:
              if (pattern795 (x1, 
18, 
19, 
20, 
21, 
22) != 0
                  || pattern800 (x1, 
E_SImode, 
SET, 
9) != 0)
                return -1;
              x14 = XVECEXP (x1, 0, 12);
              x15 = XEXP (x14, 1);
              if (pattern802 (x15) != 0)
                return -1;
              x16 = XEXP (x14, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 8
                  || GET_MODE (x16) != E_SImode)
                return -1;
              x17 = XVECEXP (x1, 0, 13);
              if (pattern805 (x17) != 0
                  || !(
#line 350 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33827; /* gpr_multi_pop_up_to_s11_si */

            case 1:
              if (pattern795 (x1, 
8, 
9, 
18, 
19, 
20) != 0
                  || pattern801 (x1, 
E_SImode) != 0
                  || !(
#line 658 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33849; /* gpr_multi_popret_up_to_s9_si */

            case 2:
              if (!(
#line 959 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33869; /* gpr_multi_popretz_up_to_s7_si */

            default:
              return -1;
            }

        case 1:
          switch (pattern773 (x1, 
E_DImode))
            {
            case 0:
              if (pattern797 (x1, 
18, 
19, 
20, 
21, 
22) != 0
                  || pattern800 (x1, 
E_DImode, 
SET, 
9) != 0)
                return -1;
              x14 = XVECEXP (x1, 0, 12);
              x15 = XEXP (x14, 1);
              if (pattern803 (x15) != 0)
                return -1;
              x16 = XEXP (x14, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 8
                  || GET_MODE (x16) != E_DImode)
                return -1;
              x17 = XVECEXP (x1, 0, 13);
              if (pattern806 (x17) != 0
                  || !(
#line 350 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33828; /* gpr_multi_pop_up_to_s11_di */

            case 1:
              if (pattern797 (x1, 
8, 
9, 
18, 
19, 
20) != 0
                  || pattern801 (x1, 
E_DImode) != 0
                  || !(
#line 658 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33850; /* gpr_multi_popret_up_to_s9_di */

            case 2:
              if (!(
#line 959 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33870; /* gpr_multi_popretz_up_to_s7_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      if (REGNO (x5) != 27)
        return -1;
      x18 = XEXP (x4, 0);
      if (GET_CODE (x18) != MEM)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != PLUS)
        return -1;
      x20 = XEXP (x19, 0);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 2)
        return -1;
      x21 = XEXP (x19, 1);
      if (GET_CODE (x21) != CONST_INT)
        return -1;
      x22 = XVECEXP (x1, 0, 1);
      x23 = XEXP (x22, 1);
      if (GET_CODE (x23) != REG
          || REGNO (x23) != 26)
        return -1;
      x24 = XEXP (x22, 0);
      if (GET_CODE (x24) != MEM)
        return -1;
      x25 = XEXP (x24, 0);
      if (GET_CODE (x25) != PLUS)
        return -1;
      x26 = XEXP (x25, 0);
      if (GET_CODE (x26) != REG
          || REGNO (x26) != 2)
        return -1;
      x27 = XEXP (x25, 1);
      if (GET_CODE (x27) != CONST_INT)
        return -1;
      x28 = XVECEXP (x1, 0, 2);
      x29 = XEXP (x28, 1);
      if (GET_CODE (x29) != REG
          || REGNO (x29) != 25)
        return -1;
      x30 = XEXP (x28, 0);
      if (GET_CODE (x30) != MEM)
        return -1;
      x31 = XEXP (x30, 0);
      if (GET_CODE (x31) != PLUS)
        return -1;
      x32 = XEXP (x31, 0);
      if (GET_CODE (x32) != REG
          || REGNO (x32) != 2)
        return -1;
      x33 = XEXP (x31, 1);
      if (GET_CODE (x33) != CONST_INT)
        return -1;
      x34 = XVECEXP (x1, 0, 3);
      x35 = XEXP (x34, 1);
      if (GET_CODE (x35) != REG
          || REGNO (x35) != 24)
        return -1;
      x36 = XEXP (x34, 0);
      if (GET_CODE (x36) != MEM)
        return -1;
      x37 = XEXP (x36, 0);
      if (GET_CODE (x37) != PLUS)
        return -1;
      x38 = XEXP (x37, 0);
      if (GET_CODE (x38) != REG
          || REGNO (x38) != 2)
        return -1;
      x39 = XEXP (x37, 1);
      if (GET_CODE (x39) != CONST_INT)
        return -1;
      x40 = XVECEXP (x1, 0, 4);
      x41 = XEXP (x40, 1);
      if (GET_CODE (x41) != REG
          || REGNO (x41) != 23)
        return -1;
      x42 = XEXP (x40, 0);
      if (GET_CODE (x42) != MEM)
        return -1;
      x43 = XEXP (x42, 0);
      if (GET_CODE (x43) != PLUS)
        return -1;
      x44 = XEXP (x43, 0);
      if (GET_CODE (x44) != REG
          || REGNO (x44) != 2)
        return -1;
      x45 = XEXP (x43, 1);
      if (GET_CODE (x45) != CONST_INT)
        return -1;
      x46 = XVECEXP (x1, 0, 5);
      x47 = XEXP (x46, 1);
      if (GET_CODE (x47) != REG
          || REGNO (x47) != 22)
        return -1;
      x48 = XEXP (x46, 0);
      if (GET_CODE (x48) != MEM)
        return -1;
      x49 = XEXP (x48, 0);
      if (GET_CODE (x49) != PLUS)
        return -1;
      x50 = XEXP (x49, 0);
      if (GET_CODE (x50) != REG
          || REGNO (x50) != 2)
        return -1;
      x51 = XEXP (x49, 1);
      if (GET_CODE (x51) != CONST_INT)
        return -1;
      x52 = XVECEXP (x1, 0, 6);
      x53 = XEXP (x52, 1);
      if (GET_CODE (x53) != REG
          || REGNO (x53) != 21)
        return -1;
      x54 = XEXP (x52, 0);
      if (GET_CODE (x54) != MEM)
        return -1;
      x55 = XEXP (x54, 0);
      if (GET_CODE (x55) != PLUS)
        return -1;
      x56 = XEXP (x55, 0);
      if (GET_CODE (x56) != REG
          || REGNO (x56) != 2)
        return -1;
      x57 = XEXP (x55, 1);
      if (GET_CODE (x57) != CONST_INT)
        return -1;
      x58 = XVECEXP (x1, 0, 7);
      x59 = XEXP (x58, 1);
      if (GET_CODE (x59) != REG
          || REGNO (x59) != 20)
        return -1;
      x60 = XEXP (x58, 0);
      if (GET_CODE (x60) != MEM)
        return -1;
      x61 = XEXP (x60, 0);
      if (GET_CODE (x61) != PLUS)
        return -1;
      x62 = XEXP (x61, 0);
      if (GET_CODE (x62) != REG
          || REGNO (x62) != 2)
        return -1;
      x63 = XEXP (x61, 1);
      if (GET_CODE (x63) != CONST_INT)
        return -1;
      x6 = XVECEXP (x1, 0, 8);
      if (pattern761 (x6, 
19) != 0
          || pattern762 (x2, 
18) != 0
          || pattern771 (x3, 
9) != 0)
        return -1;
      x64 = XVECEXP (x1, 0, 11);
      if (GET_CODE (x64) != SET)
        return -1;
      x65 = XEXP (x64, 1);
      if (GET_CODE (x65) != REG
          || REGNO (x65) != 8)
        return -1;
      x66 = XEXP (x64, 0);
      if (GET_CODE (x66) != MEM)
        return -1;
      x67 = XEXP (x66, 0);
      if (GET_CODE (x67) != PLUS)
        return -1;
      x68 = XEXP (x67, 0);
      if (GET_CODE (x68) != REG
          || REGNO (x68) != 2)
        return -1;
      x69 = XEXP (x67, 1);
      if (GET_CODE (x69) != CONST_INT)
        return -1;
      x14 = XVECEXP (x1, 0, 12);
      if (GET_CODE (x14) != SET)
        return -1;
      x15 = XEXP (x14, 1);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 1)
        return -1;
      x16 = XEXP (x14, 0);
      if (GET_CODE (x16) != MEM)
        return -1;
      x70 = XEXP (x16, 0);
      if (GET_CODE (x70) != PLUS)
        return -1;
      x71 = XEXP (x70, 0);
      if (GET_CODE (x71) != REG
          || REGNO (x71) != 2)
        return -1;
      x72 = XEXP (x70, 1);
      if (GET_CODE (x72) != CONST_INT)
        return -1;
      x17 = XVECEXP (x1, 0, 13);
      if (GET_CODE (x17) != SET)
        return -1;
      x73 = XEXP (x17, 1);
      if (GET_CODE (x73) != PLUS)
        return -1;
      x74 = XEXP (x73, 0);
      if (GET_CODE (x74) != REG
          || REGNO (x74) != 2)
        return -1;
      x75 = XEXP (x17, 0);
      if (GET_CODE (x75) != REG
          || REGNO (x75) != 2)
        return -1;
      x76 = XEXP (x73, 1);
      operands[0] = x76;
      if (!stack_push_up_to_s11_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern776 (x1))
        {
        case 0:
          if (XWINT (x69, 0) != -48L
              || XWINT (x72, 0) != -52L
              || pattern793 (x1, 
E_SImode) != 0
              || !(
#line 1433 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33899; /* gpr_multi_push_up_to_s11_si */

        case 1:
          if (XWINT (x69, 0) != -96L
              || XWINT (x72, 0) != -104L
              || pattern793 (x1, 
E_DImode) != 0
              || !(
#line 1433 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33900; /* gpr_multi_push_up_to_s11_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 1);
  switch (GET_CODE (x7))
    {
    case SIGN_EXTEND:
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern137 (x2, 
E_RVVM8HImode, 
E_RVVM4QImode) != 0
              || !(
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9296 (insn, operands);

        case E_RVVM4HImode:
          if (pattern137 (x2, 
E_RVVM4HImode, 
E_RVVM2QImode) != 0
              || !(
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9298 (insn, operands);

        case E_RVVM2HImode:
          if (pattern137 (x2, 
E_RVVM2HImode, 
E_RVVM1QImode) != 0
              || !(
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9300 (insn, operands);

        case E_RVVM1HImode:
          if (pattern137 (x2, 
E_RVVM1HImode, 
E_RVVMF2QImode) != 0
              || !(
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9302 (insn, operands);

        case E_RVVMF2HImode:
          if (pattern137 (x2, 
E_RVVMF2HImode, 
E_RVVMF4QImode) != 0
              || !(
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9304 (insn, operands);

        case E_RVVMF4HImode:
          if (pattern137 (x2, 
E_RVVMF4HImode, 
E_RVVMF8QImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9306 (insn, operands);

        case E_RVVM8SImode:
          if (pattern137 (x2, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0
              || !(
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9308 (insn, operands);

        case E_RVVM4SImode:
          if (pattern137 (x2, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0
              || !(
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9310 (insn, operands);

        case E_RVVM2SImode:
          if (pattern137 (x2, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0
              || !(
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9312 (insn, operands);

        case E_RVVM1SImode:
          if (pattern137 (x2, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0
              || !(
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9314 (insn, operands);

        case E_RVVMF2SImode:
          if (pattern137 (x2, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9316 (insn, operands);

        case E_RVVM8DImode:
          if (pattern137 (x2, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9318 (insn, operands);

        case E_RVVM4DImode:
          if (pattern137 (x2, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9320 (insn, operands);

        case E_RVVM2DImode:
          if (pattern137 (x2, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9322 (insn, operands);

        case E_RVVM1DImode:
          if (pattern137 (x2, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9324 (insn, operands);

        case E_V1HImode:
          if (pattern137 (x2, 
E_V1HImode, 
E_V1QImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9326 (insn, operands);

        case E_V2HImode:
          if (pattern137 (x2, 
E_V2HImode, 
E_V2QImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9328 (insn, operands);

        case E_V4HImode:
          if (pattern137 (x2, 
E_V4HImode, 
E_V4QImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9330 (insn, operands);

        case E_V8HImode:
          if (pattern137 (x2, 
E_V8HImode, 
E_V8QImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9332 (insn, operands);

        case E_V16HImode:
          if (pattern137 (x2, 
E_V16HImode, 
E_V16QImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9334 (insn, operands);

        case E_V32HImode:
          if (pattern137 (x2, 
E_V32HImode, 
E_V32QImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9336 (insn, operands);

        case E_V64HImode:
          if (pattern137 (x2, 
E_V64HImode, 
E_V64QImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9338 (insn, operands);

        case E_V128HImode:
          if (pattern137 (x2, 
E_V128HImode, 
E_V128QImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9340 (insn, operands);

        case E_V256HImode:
          if (pattern137 (x2, 
E_V256HImode, 
E_V256QImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9342 (insn, operands);

        case E_V512HImode:
          if (pattern137 (x2, 
E_V512HImode, 
E_V512QImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9344 (insn, operands);

        case E_V1024HImode:
          if (pattern137 (x2, 
E_V1024HImode, 
E_V1024QImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9346 (insn, operands);

        case E_V2048HImode:
          if (pattern137 (x2, 
E_V2048HImode, 
E_V2048QImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9348 (insn, operands);

        case E_V1SImode:
          if (pattern137 (x2, 
E_V1SImode, 
E_V1HImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9350 (insn, operands);

        case E_V2SImode:
          if (pattern137 (x2, 
E_V2SImode, 
E_V2HImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9352 (insn, operands);

        case E_V4SImode:
          if (pattern137 (x2, 
E_V4SImode, 
E_V4HImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9354 (insn, operands);

        case E_V8SImode:
          if (pattern137 (x2, 
E_V8SImode, 
E_V8HImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9356 (insn, operands);

        case E_V16SImode:
          if (pattern137 (x2, 
E_V16SImode, 
E_V16HImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9358 (insn, operands);

        case E_V32SImode:
          if (pattern137 (x2, 
E_V32SImode, 
E_V32HImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9360 (insn, operands);

        case E_V64SImode:
          if (pattern137 (x2, 
E_V64SImode, 
E_V64HImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9362 (insn, operands);

        case E_V128SImode:
          if (pattern137 (x2, 
E_V128SImode, 
E_V128HImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9364 (insn, operands);

        case E_V256SImode:
          if (pattern137 (x2, 
E_V256SImode, 
E_V256HImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9366 (insn, operands);

        case E_V512SImode:
          if (pattern137 (x2, 
E_V512SImode, 
E_V512HImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9368 (insn, operands);

        case E_V1024SImode:
          if (pattern137 (x2, 
E_V1024SImode, 
E_V1024HImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9370 (insn, operands);

        case E_V1DImode:
          if (pattern137 (x2, 
E_V1DImode, 
E_V1SImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9372 (insn, operands);

        case E_V2DImode:
          if (pattern137 (x2, 
E_V2DImode, 
E_V2SImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9374 (insn, operands);

        case E_V4DImode:
          if (pattern137 (x2, 
E_V4DImode, 
E_V4SImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9376 (insn, operands);

        case E_V8DImode:
          if (pattern137 (x2, 
E_V8DImode, 
E_V8SImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9378 (insn, operands);

        case E_V16DImode:
          if (pattern137 (x2, 
E_V16DImode, 
E_V16SImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9380 (insn, operands);

        case E_V32DImode:
          if (pattern137 (x2, 
E_V32DImode, 
E_V32SImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9382 (insn, operands);

        case E_V64DImode:
          if (pattern137 (x2, 
E_V64DImode, 
E_V64SImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9384 (insn, operands);

        case E_V128DImode:
          if (pattern137 (x2, 
E_V128DImode, 
E_V128SImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9386 (insn, operands);

        case E_V256DImode:
          if (pattern137 (x2, 
E_V256DImode, 
E_V256SImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9388 (insn, operands);

        case E_V512DImode:
          if (pattern137 (x2, 
E_V512DImode, 
E_V512SImode) != 0
              || !((
#line 961 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 963 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9390 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern137 (x2, 
E_RVVM8HImode, 
E_RVVM4QImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9392 (insn, operands);

        case E_RVVM4HImode:
          if (pattern137 (x2, 
E_RVVM4HImode, 
E_RVVM2QImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9393 (insn, operands);

        case E_RVVM2HImode:
          if (pattern137 (x2, 
E_RVVM2HImode, 
E_RVVM1QImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9394 (insn, operands);

        case E_RVVM1HImode:
          if (pattern137 (x2, 
E_RVVM1HImode, 
E_RVVMF2QImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9395 (insn, operands);

        case E_RVVMF2HImode:
          if (pattern137 (x2, 
E_RVVMF2HImode, 
E_RVVMF4QImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9396 (insn, operands);

        case E_RVVMF4HImode:
          if (pattern137 (x2, 
E_RVVMF4HImode, 
E_RVVMF8QImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9397 (insn, operands);

        case E_RVVM8SImode:
          if (pattern137 (x2, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9398 (insn, operands);

        case E_RVVM4SImode:
          if (pattern137 (x2, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9399 (insn, operands);

        case E_RVVM2SImode:
          if (pattern137 (x2, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9400 (insn, operands);

        case E_RVVM1SImode:
          if (pattern137 (x2, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9401 (insn, operands);

        case E_RVVMF2SImode:
          if (pattern137 (x2, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9402 (insn, operands);

        case E_RVVM8DImode:
          if (pattern137 (x2, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9403 (insn, operands);

        case E_RVVM4DImode:
          if (pattern137 (x2, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9404 (insn, operands);

        case E_RVVM2DImode:
          if (pattern137 (x2, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9405 (insn, operands);

        case E_RVVM1DImode:
          if (pattern137 (x2, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9406 (insn, operands);

        case E_V1HImode:
          if (pattern137 (x2, 
E_V1HImode, 
E_V1QImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9407 (insn, operands);

        case E_V2HImode:
          if (pattern137 (x2, 
E_V2HImode, 
E_V2QImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9408 (insn, operands);

        case E_V4HImode:
          if (pattern137 (x2, 
E_V4HImode, 
E_V4QImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9409 (insn, operands);

        case E_V8HImode:
          if (pattern137 (x2, 
E_V8HImode, 
E_V8QImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9410 (insn, operands);

        case E_V16HImode:
          if (pattern137 (x2, 
E_V16HImode, 
E_V16QImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9411 (insn, operands);

        case E_V32HImode:
          if (pattern137 (x2, 
E_V32HImode, 
E_V32QImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9412 (insn, operands);

        case E_V64HImode:
          if (pattern137 (x2, 
E_V64HImode, 
E_V64QImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9413 (insn, operands);

        case E_V128HImode:
          if (pattern137 (x2, 
E_V128HImode, 
E_V128QImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9414 (insn, operands);

        case E_V256HImode:
          if (pattern137 (x2, 
E_V256HImode, 
E_V256QImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9415 (insn, operands);

        case E_V512HImode:
          if (pattern137 (x2, 
E_V512HImode, 
E_V512QImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9416 (insn, operands);

        case E_V1024HImode:
          if (pattern137 (x2, 
E_V1024HImode, 
E_V1024QImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9417 (insn, operands);

        case E_V2048HImode:
          if (pattern137 (x2, 
E_V2048HImode, 
E_V2048QImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9418 (insn, operands);

        case E_V1SImode:
          if (pattern137 (x2, 
E_V1SImode, 
E_V1HImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9419 (insn, operands);

        case E_V2SImode:
          if (pattern137 (x2, 
E_V2SImode, 
E_V2HImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9420 (insn, operands);

        case E_V4SImode:
          if (pattern137 (x2, 
E_V4SImode, 
E_V4HImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9421 (insn, operands);

        case E_V8SImode:
          if (pattern137 (x2, 
E_V8SImode, 
E_V8HImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9422 (insn, operands);

        case E_V16SImode:
          if (pattern137 (x2, 
E_V16SImode, 
E_V16HImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9423 (insn, operands);

        case E_V32SImode:
          if (pattern137 (x2, 
E_V32SImode, 
E_V32HImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9424 (insn, operands);

        case E_V64SImode:
          if (pattern137 (x2, 
E_V64SImode, 
E_V64HImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9425 (insn, operands);

        case E_V128SImode:
          if (pattern137 (x2, 
E_V128SImode, 
E_V128HImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9426 (insn, operands);

        case E_V256SImode:
          if (pattern137 (x2, 
E_V256SImode, 
E_V256HImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9427 (insn, operands);

        case E_V512SImode:
          if (pattern137 (x2, 
E_V512SImode, 
E_V512HImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9428 (insn, operands);

        case E_V1024SImode:
          if (pattern137 (x2, 
E_V1024SImode, 
E_V1024HImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9429 (insn, operands);

        case E_V1DImode:
          if (pattern137 (x2, 
E_V1DImode, 
E_V1SImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9430 (insn, operands);

        case E_V2DImode:
          if (pattern137 (x2, 
E_V2DImode, 
E_V2SImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9431 (insn, operands);

        case E_V4DImode:
          if (pattern137 (x2, 
E_V4DImode, 
E_V4SImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9432 (insn, operands);

        case E_V8DImode:
          if (pattern137 (x2, 
E_V8DImode, 
E_V8SImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9433 (insn, operands);

        case E_V16DImode:
          if (pattern137 (x2, 
E_V16DImode, 
E_V16SImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9434 (insn, operands);

        case E_V32DImode:
          if (pattern137 (x2, 
E_V32DImode, 
E_V32SImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9435 (insn, operands);

        case E_V64DImode:
          if (pattern137 (x2, 
E_V64DImode, 
E_V64SImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9436 (insn, operands);

        case E_V128DImode:
          if (pattern137 (x2, 
E_V128DImode, 
E_V128SImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9437 (insn, operands);

        case E_V256DImode:
          if (pattern137 (x2, 
E_V256DImode, 
E_V256SImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9438 (insn, operands);

        case E_V512DImode:
          if (pattern137 (x2, 
E_V512DImode, 
E_V512SImode) != 0
              || !((
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 985 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_9439 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      return split_3 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
split_10 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16DFmode)
      && reg_or_mem_operand (operands[1], E_V16DFmode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return gen_split_317 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16DFmode)
       || register_operand (operands[1], V16DFmode))) && 
#line 4338 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16DFmode)
       || !register_operand (operands[1], V16DFmode)))))
        return gen_split_1981 (insn, operands);
    }
  if (!register_operand (operands[0], E_V16DFmode)
      || !register_operand (operands[1], E_V16DFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2164 (insn, operands);
}

 rtx_insn *
split_11 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8DFmode)
      && reg_or_mem_operand (operands[1], E_V8DFmode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return gen_split_316 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8DFmode)
       || register_operand (operands[1], V8DFmode))) && 
#line 4337 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V8DFmode)
       || !register_operand (operands[1], V8DFmode)))))
        return gen_split_1980 (insn, operands);
    }
  if (!register_operand (operands[0], E_V8DFmode)
      || !register_operand (operands[1], E_V8DFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2163 (insn, operands);
}

 rtx_insn *
split_13 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2DFmode)
      && reg_or_mem_operand (operands[1], E_V2DFmode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return gen_split_314 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2DFmode)
       || register_operand (operands[1], V2DFmode))) && 
#line 4335 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V2DFmode)
       || !register_operand (operands[1], V2DFmode)))))
        return gen_split_1978 (insn, operands);
    }
  if (!register_operand (operands[0], E_V2DFmode)
      || !register_operand (operands[1], E_V2DFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2161 (insn, operands);
}

 rtx_insn *
split_17 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4SFmode)
      && reg_or_mem_operand (operands[1], E_V4SFmode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return gen_split_304 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4SFmode)
       || register_operand (operands[1], V4SFmode))) && 
#line 4331 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4SFmode)
       || !register_operand (operands[1], V4SFmode)))))
        return gen_split_1974 (insn, operands);
    }
  if (!register_operand (operands[0], E_V4SFmode)
      || !register_operand (operands[1], E_V4SFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2151 (insn, operands);
}

 rtx_insn *
split_21 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8HFmode)
      && reg_or_mem_operand (operands[1], E_V8HFmode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return gen_split_293 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8HFmode)
       || register_operand (operands[1], V8HFmode))) && 
#line 4327 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V8HFmode)
       || !register_operand (operands[1], V8HFmode)))))
        return gen_split_1970 (insn, operands);
    }
  if (!register_operand (operands[0], E_V8HFmode)
      || !register_operand (operands[1], E_V8HFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2140 (insn, operands);
}

 rtx_insn *
split_25 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16DImode)
      && reg_or_mem_operand (operands[1], E_V16DImode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return gen_split_284 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16DImode)
       || register_operand (operands[1], V16DImode))) && 
#line 4323 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16DImode)
       || !register_operand (operands[1], V16DImode)))))
        return gen_split_1966 (insn, operands);
    }
  if (!register_operand (operands[0], E_V16DImode)
      || !register_operand (operands[1], E_V16DImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2131 (insn, operands);
}

 rtx_insn *
split_30 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V16SImode)
      && reg_or_mem_operand (operands[1], E_V16SImode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return gen_split_273 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V16SImode)
       || register_operand (operands[1], V16SImode))) && 
#line 4318 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V16SImode)
       || !register_operand (operands[1], V16SImode)))))
        return gen_split_1961 (insn, operands);
    }
  if (!register_operand (operands[0], E_V16SImode)
      || !register_operand (operands[1], E_V16SImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2120 (insn, operands);
}

 rtx_insn *
split_36 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8HImode)
      && reg_or_mem_operand (operands[1], E_V8HImode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return gen_split_260 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8HImode)
       || register_operand (operands[1], V8HImode))) && 
#line 4312 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V8HImode)
       || !register_operand (operands[1], V8HImode)))))
        return gen_split_1955 (insn, operands);
    }
  if (!register_operand (operands[0], E_V8HImode)
      || !register_operand (operands[1], E_V8HImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2107 (insn, operands);
}

 rtx_insn *
split_42 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4QImode)
      && reg_or_mem_operand (operands[1], E_V4QImode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return gen_split_246 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4QImode)
       || register_operand (operands[1], V4QImode))) && 
#line 4306 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4QImode)
       || !register_operand (operands[1], V4QImode)))))
        return gen_split_1949 (insn, operands);
    }
  if (!register_operand (operands[0], E_V4QImode)
      || !register_operand (operands[1], E_V4QImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2093 (insn, operands);
}

 rtx_insn *
split_48 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2BImode)
      && reg_or_mem_operand (operands[1], E_V2BImode)
      && ((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2BImode)
       || register_operand (operands[1], V2BImode))) && 
#line 4341 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V2BImode)
       || !register_operand (operands[1], V2BImode)))))
    return gen_split_1983 (insn, operands);
  if (!register_operand (operands[0], E_V2BImode)
      || !register_operand (operands[1], E_V2BImode)
      || !((
#line 1530 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1532 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2171 (insn, operands);
}

 rtx_insn *
split_54 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V32DFmode)
      && reg_or_mem_operand (operands[1], E_V32DFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return gen_split_318 (insn, operands);
  if (!register_operand (operands[0], E_V32DFmode)
      || !register_operand (operands[1], E_V32DFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2165 (insn, operands);
}

 rtx_insn *
split_60 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V32SFmode)
      && reg_or_mem_operand (operands[1], E_V32SFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return gen_split_307 (insn, operands);
  if (!register_operand (operands[0], E_V32SFmode)
      || !register_operand (operands[1], E_V32SFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2154 (insn, operands);
}

 rtx_insn *
split_66 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V64HFmode)
      && reg_or_mem_operand (operands[1], E_V64HFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
    return gen_split_296 (insn, operands);
  if (!register_operand (operands[0], E_V64HFmode)
      || !register_operand (operands[1], E_V64HFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2143 (insn, operands);
}

 rtx_insn *
split_72 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V32DImode)
      && reg_or_mem_operand (operands[1], E_V32DImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
    return gen_split_285 (insn, operands);
  if (!register_operand (operands[0], E_V32DImode)
      || !register_operand (operands[1], E_V32DImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2132 (insn, operands);
}

 rtx_insn *
split_78 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V32SImode)
      && reg_or_mem_operand (operands[1], E_V32SImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
    return gen_split_274 (insn, operands);
  if (!register_operand (operands[0], E_V32SImode)
      || !register_operand (operands[1], E_V32SImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2121 (insn, operands);
}

 rtx_insn *
split_85 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V32HImode)
      && reg_or_mem_operand (operands[1], E_V32HImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
    return gen_split_262 (insn, operands);
  if (!register_operand (operands[0], E_V32HImode)
      || !register_operand (operands[1], E_V32HImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2109 (insn, operands);
}

 rtx_insn *
split_92 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V64QImode)
      && reg_or_mem_operand (operands[1], E_V64QImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
    return gen_split_250 (insn, operands);
  if (!register_operand (operands[0], E_V64QImode)
      || !register_operand (operands[1], E_V64QImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2097 (insn, operands);
}

 rtx_insn *
split_100 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF64BImode)
      && reg_or_mem_operand (operands[1], E_RVVMF64BImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
    return gen_split_237 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF64BImode)
      || !register_operand (operands[1], E_RVVMF64BImode)
      || !((
#line 1294 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1296 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1574 (insn, operands);
}

 rtx_insn *
split_107 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF4HImode)
      && reg_or_mem_operand (operands[1], E_RVVMF4HImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return gen_split_214 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF4HImode)
      || !register_operand (operands[1], E_RVVMF4HImode)
      || !((
#line 1257 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 934 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1259 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1567 (insn, operands);
}

 rtx_insn *
split_114 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern276 (x2))
    {
    case 0:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3541 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8QImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3745 (insn, operands);

    case 1:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3544 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4QImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3748 (insn, operands);

    case 2:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3547 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2QImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3751 (insn, operands);

    case 3:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3550 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1QImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3754 (insn, operands);

    case 4:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3553 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8HImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3757 (insn, operands);

    case 5:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3556 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4HImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3760 (insn, operands);

    case 6:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3559 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2HImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3763 (insn, operands);

    case 7:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3562 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1HImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3766 (insn, operands);

    case 8:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3565 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8SImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3769 (insn, operands);

    case 9:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3568 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4SImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3772 (insn, operands);

    case 10:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3571 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2SImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3775 (insn, operands);

    case 11:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && (
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3574 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1SImode)
          || !(
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3778 (insn, operands);

    case 12:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3577 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM8DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3781 (insn, operands);

    case 13:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3580 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM4DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3784 (insn, operands);

    case 14:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3583 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM2DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3787 (insn, operands);

    case 15:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3586 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVM1DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3790 (insn, operands);

    case 16:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3589 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF2QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3793 (insn, operands);

    case 17:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3592 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF4QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3796 (insn, operands);

    case 18:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3595 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF8QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3799 (insn, operands);

    case 19:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3598 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF2HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3802 (insn, operands);

    case 20:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3601 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF4HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3805 (insn, operands);

    case 21:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3604 (insn, operands);
      if (!vector_shift_operand (operands[2], E_RVVMF2SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3808 (insn, operands);

    case 22:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3607 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3811 (insn, operands);

    case 23:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3610 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3814 (insn, operands);

    case 24:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3613 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3817 (insn, operands);

    case 25:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3616 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3820 (insn, operands);

    case 26:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3619 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3823 (insn, operands);

    case 27:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3622 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3826 (insn, operands);

    case 28:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3625 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3829 (insn, operands);

    case 29:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3628 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3832 (insn, operands);

    case 30:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3631 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3835 (insn, operands);

    case 31:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3634 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3838 (insn, operands);

    case 32:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3637 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1024QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3841 (insn, operands);

    case 33:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3640 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2048QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3844 (insn, operands);

    case 34:
      if (vector_scalar_shift_operand (operands[2], E_QImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3643 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4096QImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3847 (insn, operands);

    case 35:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3646 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3850 (insn, operands);

    case 36:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3649 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3853 (insn, operands);

    case 37:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3652 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3856 (insn, operands);

    case 38:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3655 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3859 (insn, operands);

    case 39:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3658 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3862 (insn, operands);

    case 40:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3661 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3865 (insn, operands);

    case 41:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3664 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3868 (insn, operands);

    case 42:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3667 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3871 (insn, operands);

    case 43:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3670 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3874 (insn, operands);

    case 44:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3673 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3877 (insn, operands);

    case 45:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3676 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1024HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3880 (insn, operands);

    case 46:
      if (vector_scalar_shift_operand (operands[2], E_HImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3679 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2048HImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3883 (insn, operands);

    case 47:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3682 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3886 (insn, operands);

    case 48:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3685 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3889 (insn, operands);

    case 49:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3688 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3892 (insn, operands);

    case 50:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3691 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3895 (insn, operands);

    case 51:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3694 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3898 (insn, operands);

    case 52:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3697 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3901 (insn, operands);

    case 53:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3700 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3904 (insn, operands);

    case 54:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3703 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3907 (insn, operands);

    case 55:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3706 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3910 (insn, operands);

    case 56:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3709 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3913 (insn, operands);

    case 57:
      if (vector_scalar_shift_operand (operands[2], E_SImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3712 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1024SImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3916 (insn, operands);

    case 58:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3715 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V1DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3919 (insn, operands);

    case 59:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3718 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V2DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3922 (insn, operands);

    case 60:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3721 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V4DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3925 (insn, operands);

    case 61:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3724 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V8DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3928 (insn, operands);

    case 62:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3727 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V16DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3931 (insn, operands);

    case 63:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3730 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V32DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3934 (insn, operands);

    case 64:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3733 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V64DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3937 (insn, operands);

    case 65:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3736 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V128DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3940 (insn, operands);

    case 66:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3739 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V256DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3943 (insn, operands);

    case 67:
      if (vector_scalar_shift_operand (operands[2], E_DImode)
          && ((
#line 508 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 510 "../../gcc/config/riscv/autovec.md"
( 1)))
        return gen_split_3742 (insn, operands);
      if (!vector_shift_operand (operands[2], E_V512DImode)
          || !((
#line 533 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 535 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3946 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_123 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern595 (x2))
    {
    case 0:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6595 (insn, operands);

    case 1:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6597 (insn, operands);

    case 2:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6599 (insn, operands);

    case 3:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6601 (insn, operands);

    case 4:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6603 (insn, operands);

    case 5:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6605 (insn, operands);

    case 6:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6607 (insn, operands);

    case 7:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6691 (insn, operands);

    case 8:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6609 (insn, operands);

    case 9:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6693 (insn, operands);

    case 10:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6611 (insn, operands);

    case 11:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6695 (insn, operands);

    case 12:
      if (!(
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6613 (insn, operands);

    case 13:
      if (!(
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6697 (insn, operands);

    case 14:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6615 (insn, operands);

    case 15:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6699 (insn, operands);

    case 16:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6617 (insn, operands);

    case 17:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6701 (insn, operands);

    case 18:
      if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1151 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6751 (insn, operands);

    case 19:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6619 (insn, operands);

    case 20:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6703 (insn, operands);

    case 21:
      if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1151 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6753 (insn, operands);

    case 22:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6621 (insn, operands);

    case 23:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6705 (insn, operands);

    case 24:
      if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1152 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6755 (insn, operands);

    case 25:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6623 (insn, operands);

    case 26:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6707 (insn, operands);

    case 27:
      if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1152 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6757 (insn, operands);

    case 28:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6625 (insn, operands);

    case 29:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6627 (insn, operands);

    case 30:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6629 (insn, operands);

    case 31:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6631 (insn, operands);

    case 32:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6633 (insn, operands);

    case 33:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6635 (insn, operands);

    case 34:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6637 (insn, operands);

    case 35:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6639 (insn, operands);

    case 36:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6641 (insn, operands);

    case 37:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6643 (insn, operands);

    case 38:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6645 (insn, operands);

    case 39:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6647 (insn, operands);

    case 40:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6649 (insn, operands);

    case 41:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6709 (insn, operands);

    case 42:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6651 (insn, operands);

    case 43:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6711 (insn, operands);

    case 44:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6653 (insn, operands);

    case 45:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6713 (insn, operands);

    case 46:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6655 (insn, operands);

    case 47:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6715 (insn, operands);

    case 48:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6657 (insn, operands);

    case 49:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6717 (insn, operands);

    case 50:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6659 (insn, operands);

    case 51:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6719 (insn, operands);

    case 52:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6661 (insn, operands);

    case 53:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6721 (insn, operands);

    case 54:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6663 (insn, operands);

    case 55:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1118 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6723 (insn, operands);

    case 56:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6665 (insn, operands);

    case 57:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1119 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6725 (insn, operands);

    case 58:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6667 (insn, operands);

    case 59:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1120 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6727 (insn, operands);

    case 60:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6669 (insn, operands);

    case 61:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1121 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6729 (insn, operands);

    case 62:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6671 (insn, operands);

    case 63:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1122 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6731 (insn, operands);

    case 64:
      if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1154 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6759 (insn, operands);

    case 65:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6673 (insn, operands);

    case 66:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1123 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6733 (insn, operands);

    case 67:
      if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1155 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6761 (insn, operands);

    case 68:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6675 (insn, operands);

    case 69:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1124 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6735 (insn, operands);

    case 70:
      if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1156 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6763 (insn, operands);

    case 71:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6677 (insn, operands);

    case 72:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1125 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6737 (insn, operands);

    case 73:
      if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1157 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6765 (insn, operands);

    case 74:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6679 (insn, operands);

    case 75:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1126 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6739 (insn, operands);

    case 76:
      if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1158 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6767 (insn, operands);

    case 77:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6681 (insn, operands);

    case 78:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1127 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6741 (insn, operands);

    case 79:
      if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1159 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6769 (insn, operands);

    case 80:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6683 (insn, operands);

    case 81:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1128 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6743 (insn, operands);

    case 82:
      if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1160 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6771 (insn, operands);

    case 83:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6685 (insn, operands);

    case 84:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1129 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6745 (insn, operands);

    case 85:
      if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1161 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6773 (insn, operands);

    case 86:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6687 (insn, operands);

    case 87:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1130 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6747 (insn, operands);

    case 88:
      if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1162 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6775 (insn, operands);

    case 89:
      if (!((
#line 212 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 214 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6689 (insn, operands);

    case 90:
      if (!((
#line 238 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1131 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 240 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6749 (insn, operands);

    case 91:
      if (!((
#line 264 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1163 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 266 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_6777 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_127 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8QImode, 7))))
        return NULL;
      return gen_split_801 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4QImode, 7))))
        return NULL;
      return gen_split_807 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2QImode, 7))))
        return NULL;
      return gen_split_813 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1QImode, 7))))
        return NULL;
      return gen_split_819 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HImode, 7))))
        return NULL;
      return gen_split_825 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HImode, 7))))
        return NULL;
      return gen_split_831 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HImode, 7))))
        return NULL;
      return gen_split_837 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HImode, 7))))
        return NULL;
      return gen_split_843 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SImode, 7))))
        return NULL;
      return gen_split_849 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SImode, 7))))
        return NULL;
      return gen_split_855 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SImode, 7))))
        return NULL;
      return gen_split_861 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SImode, 7))))
        return NULL;
      return gen_split_867 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DImode, 7))))
        return NULL;
      return gen_split_873 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DImode, 7))))
        return NULL;
      return gen_split_879 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DImode, 7))))
        return NULL;
      return gen_split_885 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DImode, 7))))
        return NULL;
      return gen_split_891 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2QImode, 7))))
        return NULL;
      return gen_split_897 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4QImode, 7))))
        return NULL;
      return gen_split_903 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF8QImode, 7))))
        return NULL;
      return gen_split_909 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HImode, 7))))
        return NULL;
      return gen_split_915 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HImode, 7))))
        return NULL;
      return gen_split_921 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SImode, 7))))
        return NULL;
      return gen_split_927 (insn, operands);

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8BFmode, 7))))
        return NULL;
      return gen_split_933 (insn, operands);

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4BFmode, 7))))
        return NULL;
      return gen_split_939 (insn, operands);

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2BFmode, 7))))
        return NULL;
      return gen_split_945 (insn, operands);

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1BFmode, 7))))
        return NULL;
      return gen_split_951 (insn, operands);

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2BFmode, 7))))
        return NULL;
      return gen_split_957 (insn, operands);

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4BFmode, 7))))
        return NULL;
      return gen_split_963 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HFmode, 7))))
        return NULL;
      return gen_split_969 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HFmode, 7))))
        return NULL;
      return gen_split_975 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HFmode, 7))))
        return NULL;
      return gen_split_981 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HFmode, 7))))
        return NULL;
      return gen_split_987 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HFmode, 7))))
        return NULL;
      return gen_split_993 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HFmode, 7))))
        return NULL;
      return gen_split_999 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SFmode, 7))))
        return NULL;
      return gen_split_1005 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SFmode, 7))))
        return NULL;
      return gen_split_1011 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SFmode, 7))))
        return NULL;
      return gen_split_1017 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SFmode, 7))))
        return NULL;
      return gen_split_1023 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SFmode, 7))))
        return NULL;
      return gen_split_1029 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DFmode, 7))))
        return NULL;
      return gen_split_1035 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DFmode, 7))))
        return NULL;
      return gen_split_1041 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DFmode, 7))))
        return NULL;
      return gen_split_1047 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DFmode, 7))))
        return NULL;
      return gen_split_1053 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1QImode, 7))))
        return NULL;
      return gen_split_1059 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2QImode, 7))))
        return NULL;
      return gen_split_1065 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4QImode, 7))))
        return NULL;
      return gen_split_1071 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8QImode, 7))))
        return NULL;
      return gen_split_1077 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16QImode, 7))))
        return NULL;
      return gen_split_1083 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32QImode, 7))))
        return NULL;
      return gen_split_1089 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64QImode, 7))))
        return NULL;
      return gen_split_1095 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128QImode, 7))))
        return NULL;
      return gen_split_1101 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256QImode, 7))))
        return NULL;
      return gen_split_1107 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512QImode, 7))))
        return NULL;
      return gen_split_1113 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024QImode, 7))))
        return NULL;
      return gen_split_1119 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048QImode, 7))))
        return NULL;
      return gen_split_1125 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4096QImode, 7))))
        return NULL;
      return gen_split_1131 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HImode, 7))))
        return NULL;
      return gen_split_1137 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HImode, 7))))
        return NULL;
      return gen_split_1143 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HImode, 7))))
        return NULL;
      return gen_split_1149 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HImode, 7))))
        return NULL;
      return gen_split_1155 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HImode, 7))))
        return NULL;
      return gen_split_1161 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HImode, 7))))
        return NULL;
      return gen_split_1167 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HImode, 7))))
        return NULL;
      return gen_split_1173 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HImode, 7))))
        return NULL;
      return gen_split_1179 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HImode, 7))))
        return NULL;
      return gen_split_1185 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HImode, 7))))
        return NULL;
      return gen_split_1191 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HImode, 7))))
        return NULL;
      return gen_split_1197 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HImode, 7))))
        return NULL;
      return gen_split_1203 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SImode, 7))))
        return NULL;
      return gen_split_1209 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SImode, 7))))
        return NULL;
      return gen_split_1215 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SImode, 7))))
        return NULL;
      return gen_split_1221 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SImode, 7))))
        return NULL;
      return gen_split_1227 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SImode, 7))))
        return NULL;
      return gen_split_1233 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SImode, 7))))
        return NULL;
      return gen_split_1239 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SImode, 7))))
        return NULL;
      return gen_split_1245 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SImode, 7))))
        return NULL;
      return gen_split_1251 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SImode, 7))))
        return NULL;
      return gen_split_1257 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SImode, 7))))
        return NULL;
      return gen_split_1263 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SImode, 7))))
        return NULL;
      return gen_split_1269 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DImode, 7))))
        return NULL;
      return gen_split_1275 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DImode, 7))))
        return NULL;
      return gen_split_1281 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DImode, 7))))
        return NULL;
      return gen_split_1287 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DImode, 7))))
        return NULL;
      return gen_split_1293 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DImode, 7))))
        return NULL;
      return gen_split_1299 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DImode, 7))))
        return NULL;
      return gen_split_1305 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DImode, 7))))
        return NULL;
      return gen_split_1311 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DImode, 7))))
        return NULL;
      return gen_split_1317 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DImode, 7))))
        return NULL;
      return gen_split_1323 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DImode, 7))))
        return NULL;
      return gen_split_1329 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HFmode, 7))))
        return NULL;
      return gen_split_1335 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HFmode, 7))))
        return NULL;
      return gen_split_1341 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HFmode, 7))))
        return NULL;
      return gen_split_1347 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HFmode, 7))))
        return NULL;
      return gen_split_1353 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HFmode, 7))))
        return NULL;
      return gen_split_1359 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HFmode, 7))))
        return NULL;
      return gen_split_1365 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HFmode, 7))))
        return NULL;
      return gen_split_1371 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HFmode, 7))))
        return NULL;
      return gen_split_1377 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HFmode, 7))))
        return NULL;
      return gen_split_1383 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HFmode, 7))))
        return NULL;
      return gen_split_1389 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HFmode, 7))))
        return NULL;
      return gen_split_1395 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HFmode, 7))))
        return NULL;
      return gen_split_1401 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SFmode, 7))))
        return NULL;
      return gen_split_1407 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SFmode, 7))))
        return NULL;
      return gen_split_1413 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SFmode, 7))))
        return NULL;
      return gen_split_1419 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SFmode, 7))))
        return NULL;
      return gen_split_1425 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SFmode, 7))))
        return NULL;
      return gen_split_1431 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SFmode, 7))))
        return NULL;
      return gen_split_1437 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SFmode, 7))))
        return NULL;
      return gen_split_1443 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SFmode, 7))))
        return NULL;
      return gen_split_1449 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SFmode, 7))))
        return NULL;
      return gen_split_1455 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SFmode, 7))))
        return NULL;
      return gen_split_1461 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SFmode, 7))))
        return NULL;
      return gen_split_1467 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DFmode, 7))))
        return NULL;
      return gen_split_1473 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DFmode, 7))))
        return NULL;
      return gen_split_1479 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DFmode, 7))))
        return NULL;
      return gen_split_1485 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DFmode, 7))))
        return NULL;
      return gen_split_1491 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DFmode, 7))))
        return NULL;
      return gen_split_1497 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DFmode, 7))))
        return NULL;
      return gen_split_1503 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DFmode, 7))))
        return NULL;
      return gen_split_1509 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DFmode, 7))))
        return NULL;
      return gen_split_1515 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DFmode, 7))))
        return NULL;
      return gen_split_1521 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DFmode, 7))))
        return NULL;
      return gen_split_1527 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_135 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8QImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5293 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4QImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5294 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2QImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5295 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1QImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5296 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8HImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5297 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4HImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5298 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2HImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5299 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1HImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5300 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8SImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5301 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4SImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5302 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2SImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5303 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1SImode) != 0
          || !(
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5304 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8DImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5305 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4DImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5306 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2DImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5307 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1DImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5308 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2QImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5309 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF4QImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5310 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF8QImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5311 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2HImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5312 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF4HImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5313 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2SImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5314 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1QImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5315 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2QImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5316 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4QImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5317 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8QImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5318 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16QImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5319 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32QImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5320 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64QImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5321 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128QImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5322 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256QImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5323 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512QImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5324 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024QImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5325 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2048QImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5326 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4096QImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5327 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1HImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5328 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2HImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5329 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4HImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5330 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8HImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5331 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16HImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5332 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32HImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5333 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64HImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5334 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128HImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5335 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256HImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5336 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512HImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5337 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024HImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5338 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2048HImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5339 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1SImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5340 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2SImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5341 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4SImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5342 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8SImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5343 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16SImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5344 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32SImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5345 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64SImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5346 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128SImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5347 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256SImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5348 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512SImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5349 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024SImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5350 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1DImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5351 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2DImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5352 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4DImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5353 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8DImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5354 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16DImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5355 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32DImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5356 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64DImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5357 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128DImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5358 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256DImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5359 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512DImode) != 0
          || !((
#line 1208 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1210 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5360 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8HFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5409 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4HFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5410 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2HFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5411 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1HFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5412 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2HFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5413 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF4HFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5414 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8SFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5415 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4SFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5416 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2SFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5417 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1SFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5418 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVMF2SFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5419 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM8DFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5420 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM4DFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5421 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM2DFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5422 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_RVVM1DFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5423 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1HFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5424 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2HFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5425 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4HFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5426 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8HFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5427 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16HFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5428 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32HFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5429 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64HFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5430 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128HFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5431 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256HFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5432 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512HFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5433 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024HFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5434 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2048HFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5435 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1SFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5436 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2SFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5437 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4SFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5438 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8SFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5439 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16SFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5440 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32SFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5441 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64SFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5442 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128SFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5443 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256SFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5444 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512SFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5445 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1024SFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5446 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V1DFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5447 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V2DFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5448 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V4DFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5449 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V8DFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5450 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V16DFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5451 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V32DFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5452 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V64DFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5453 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V128DFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5454 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V256DFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5455 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern402 (x2, 
E_V512DFmode) != 0
          || !((
#line 1264 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1266 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5456 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_145 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      switch (pattern156 (x2))
        {
        case 0:
          if (!(
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4333 (insn, operands);

        case 1:
          if (!(
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4334 (insn, operands);

        case 2:
          if (!(
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4335 (insn, operands);

        case 3:
          if (!(
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4336 (insn, operands);

        case 4:
          if (!(
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4337 (insn, operands);

        case 5:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4338 (insn, operands);

        case 6:
          if (!(
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4339 (insn, operands);

        case 7:
          if (!(
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4340 (insn, operands);

        case 8:
          if (!(
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4341 (insn, operands);

        case 9:
          if (!(
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4342 (insn, operands);

        case 10:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4343 (insn, operands);

        case 11:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4344 (insn, operands);

        case 12:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4345 (insn, operands);

        case 13:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4346 (insn, operands);

        case 14:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4347 (insn, operands);

        case 15:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4348 (insn, operands);

        case 16:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4349 (insn, operands);

        case 17:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4350 (insn, operands);

        case 18:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4351 (insn, operands);

        case 19:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4352 (insn, operands);

        case 20:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4353 (insn, operands);

        case 21:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4354 (insn, operands);

        case 22:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4355 (insn, operands);

        case 23:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4356 (insn, operands);

        case 24:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4357 (insn, operands);

        case 25:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4358 (insn, operands);

        case 26:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4359 (insn, operands);

        case 27:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4360 (insn, operands);

        case 28:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4361 (insn, operands);

        case 29:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4362 (insn, operands);

        case 30:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4363 (insn, operands);

        case 31:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4364 (insn, operands);

        case 32:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4365 (insn, operands);

        case 33:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4366 (insn, operands);

        case 34:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4367 (insn, operands);

        case 35:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4368 (insn, operands);

        case 36:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4369 (insn, operands);

        case 37:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4370 (insn, operands);

        case 38:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4371 (insn, operands);

        case 39:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4372 (insn, operands);

        case 40:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4373 (insn, operands);

        case 41:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4374 (insn, operands);

        case 42:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4375 (insn, operands);

        case 43:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4376 (insn, operands);

        case 44:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4377 (insn, operands);

        case 45:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4378 (insn, operands);

        case 46:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4379 (insn, operands);

        case 47:
          if (!((
#line 797 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 799 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4380 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      switch (pattern160 (x2))
        {
        case 0:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7844 (insn, operands);

        case 1:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7848 (insn, operands);

        case 2:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7852 (insn, operands);

        case 3:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7856 (insn, operands);

        case 4:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7860 (insn, operands);

        case 5:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7864 (insn, operands);

        case 6:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7868 (insn, operands);

        case 7:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7872 (insn, operands);

        case 8:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7876 (insn, operands);

        case 9:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7880 (insn, operands);

        case 10:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7884 (insn, operands);

        case 11:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7888 (insn, operands);

        case 12:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7892 (insn, operands);

        case 13:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7896 (insn, operands);

        case 14:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7900 (insn, operands);

        case 15:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7904 (insn, operands);

        case 16:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7908 (insn, operands);

        case 17:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7912 (insn, operands);

        case 18:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7916 (insn, operands);

        case 19:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7920 (insn, operands);

        case 20:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7924 (insn, operands);

        case 21:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7928 (insn, operands);

        case 22:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7932 (insn, operands);

        case 23:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7936 (insn, operands);

        case 24:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7940 (insn, operands);

        case 25:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7944 (insn, operands);

        case 26:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7948 (insn, operands);

        case 27:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7952 (insn, operands);

        case 28:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7956 (insn, operands);

        case 29:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7960 (insn, operands);

        case 30:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7964 (insn, operands);

        case 31:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7968 (insn, operands);

        case 32:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7972 (insn, operands);

        case 33:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7976 (insn, operands);

        case 34:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7980 (insn, operands);

        case 35:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7984 (insn, operands);

        case 36:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7988 (insn, operands);

        case 37:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7992 (insn, operands);

        case 38:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7996 (insn, operands);

        case 39:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8000 (insn, operands);

        case 40:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8004 (insn, operands);

        case 41:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8008 (insn, operands);

        case 42:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8012 (insn, operands);

        case 43:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8016 (insn, operands);

        case 44:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8020 (insn, operands);

        case 45:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8024 (insn, operands);

        case 46:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8028 (insn, operands);

        case 47:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8032 (insn, operands);

        case 48:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7846 (insn, operands);

        case 49:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7850 (insn, operands);

        case 50:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7854 (insn, operands);

        case 51:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7858 (insn, operands);

        case 52:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7862 (insn, operands);

        case 53:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7866 (insn, operands);

        case 54:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7870 (insn, operands);

        case 55:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7874 (insn, operands);

        case 56:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7878 (insn, operands);

        case 57:
          if (!(
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7882 (insn, operands);

        case 58:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7886 (insn, operands);

        case 59:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7890 (insn, operands);

        case 60:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7894 (insn, operands);

        case 61:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7898 (insn, operands);

        case 62:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7902 (insn, operands);

        case 63:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7906 (insn, operands);

        case 64:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7910 (insn, operands);

        case 65:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7914 (insn, operands);

        case 66:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7918 (insn, operands);

        case 67:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7922 (insn, operands);

        case 68:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7926 (insn, operands);

        case 69:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7930 (insn, operands);

        case 70:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7934 (insn, operands);

        case 71:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7938 (insn, operands);

        case 72:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7942 (insn, operands);

        case 73:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7946 (insn, operands);

        case 74:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7950 (insn, operands);

        case 75:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7954 (insn, operands);

        case 76:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7958 (insn, operands);

        case 77:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7962 (insn, operands);

        case 78:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7966 (insn, operands);

        case 79:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7970 (insn, operands);

        case 80:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7974 (insn, operands);

        case 81:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7978 (insn, operands);

        case 82:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7982 (insn, operands);

        case 83:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7986 (insn, operands);

        case 84:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7990 (insn, operands);

        case 85:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7994 (insn, operands);

        case 86:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_7998 (insn, operands);

        case 87:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8002 (insn, operands);

        case 88:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8006 (insn, operands);

        case 89:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8010 (insn, operands);

        case 90:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8014 (insn, operands);

        case 91:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8018 (insn, operands);

        case 92:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8022 (insn, operands);

        case 93:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8026 (insn, operands);

        case 94:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8030 (insn, operands);

        case 95:
          if (!((
#line 569 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 571 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8034 (insn, operands);

        case 96:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8036 (insn, operands);

        case 97:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8038 (insn, operands);

        case 98:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8040 (insn, operands);

        case 99:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8042 (insn, operands);

        case 100:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8044 (insn, operands);

        case 101:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8046 (insn, operands);

        case 102:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8048 (insn, operands);

        case 103:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8050 (insn, operands);

        case 104:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8052 (insn, operands);

        case 105:
          if (!(
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8054 (insn, operands);

        case 106:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8056 (insn, operands);

        case 107:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8058 (insn, operands);

        case 108:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8060 (insn, operands);

        case 109:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8062 (insn, operands);

        case 110:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8064 (insn, operands);

        case 111:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8066 (insn, operands);

        case 112:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8068 (insn, operands);

        case 113:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8070 (insn, operands);

        case 114:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8072 (insn, operands);

        case 115:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8074 (insn, operands);

        case 116:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8076 (insn, operands);

        case 117:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8078 (insn, operands);

        case 118:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8080 (insn, operands);

        case 119:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8082 (insn, operands);

        case 120:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8084 (insn, operands);

        case 121:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8086 (insn, operands);

        case 122:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8088 (insn, operands);

        case 123:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8090 (insn, operands);

        case 124:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8092 (insn, operands);

        case 125:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8094 (insn, operands);

        case 126:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8096 (insn, operands);

        case 127:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8098 (insn, operands);

        case 128:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8100 (insn, operands);

        case 129:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8102 (insn, operands);

        case 130:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8104 (insn, operands);

        case 131:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8106 (insn, operands);

        case 132:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8108 (insn, operands);

        case 133:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8110 (insn, operands);

        case 134:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8112 (insn, operands);

        case 135:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8114 (insn, operands);

        case 136:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8116 (insn, operands);

        case 137:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8118 (insn, operands);

        case 138:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8120 (insn, operands);

        case 139:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8122 (insn, operands);

        case 140:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8124 (insn, operands);

        case 141:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8126 (insn, operands);

        case 142:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8128 (insn, operands);

        case 143:
          if (!((
#line 587 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 589 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8130 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      return split_144 (x1, insn);

    case ASHIFT:
      return split_143 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
split_156 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SFmode:
      if (!register_operand (operands[0], E_RVVM8SFmode)
          || GET_MODE (x2) != E_RVVM8SFmode
          || !register_operand (operands[1], E_RVVM4HFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 990 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4381 (insn, operands);

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x2) != E_RVVM4SFmode
          || !register_operand (operands[1], E_RVVM2HFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 991 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4382 (insn, operands);

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x2) != E_RVVM2SFmode
          || !register_operand (operands[1], E_RVVM1HFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 992 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4383 (insn, operands);

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x2) != E_RVVM1SFmode
          || !register_operand (operands[1], E_RVVMF2HFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 993 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4384 (insn, operands);

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x2) != E_RVVMF2SFmode
          || !register_operand (operands[1], E_RVVMF4HFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 994 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4385 (insn, operands);

    case E_RVVM8DFmode:
      if (!register_operand (operands[0], E_RVVM8DFmode)
          || GET_MODE (x2) != E_RVVM8DFmode
          || !register_operand (operands[1], E_RVVM4SFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4386 (insn, operands);

    case E_RVVM4DFmode:
      if (!register_operand (operands[0], E_RVVM4DFmode)
          || GET_MODE (x2) != E_RVVM4DFmode
          || !register_operand (operands[1], E_RVVM2SFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4387 (insn, operands);

    case E_RVVM2DFmode:
      if (!register_operand (operands[0], E_RVVM2DFmode)
          || GET_MODE (x2) != E_RVVM2DFmode
          || !register_operand (operands[1], E_RVVM1SFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4388 (insn, operands);

    case E_RVVM1DFmode:
      if (!register_operand (operands[0], E_RVVM1DFmode)
          || GET_MODE (x2) != E_RVVM1DFmode
          || !register_operand (operands[1], E_RVVMF2SFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4389 (insn, operands);

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x2) != E_V1SFmode
          || !register_operand (operands[1], E_V1HFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 999 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4390 (insn, operands);

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V2HFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1000 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4391 (insn, operands);

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4HFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1001 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4392 (insn, operands);

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !register_operand (operands[1], E_V8HFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1002 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4393 (insn, operands);

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x2) != E_V16SFmode
          || !register_operand (operands[1], E_V16HFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1003 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4394 (insn, operands);

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x2) != E_V32SFmode
          || !register_operand (operands[1], E_V32HFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1004 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4395 (insn, operands);

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x2) != E_V64SFmode
          || !register_operand (operands[1], E_V64HFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1005 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4396 (insn, operands);

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x2) != E_V128SFmode
          || !register_operand (operands[1], E_V128HFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1006 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4397 (insn, operands);

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x2) != E_V256SFmode
          || !register_operand (operands[1], E_V256HFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1007 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4398 (insn, operands);

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x2) != E_V512SFmode
          || !register_operand (operands[1], E_V512HFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1008 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4399 (insn, operands);

    case E_V1024SFmode:
      if (!register_operand (operands[0], E_V1024SFmode)
          || GET_MODE (x2) != E_V1024SFmode
          || !register_operand (operands[1], E_V1024HFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1009 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4400 (insn, operands);

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x2) != E_V1DFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1010 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4401 (insn, operands);

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1011 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4402 (insn, operands);

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x2) != E_V4DFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1012 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4403 (insn, operands);

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x2) != E_V8DFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1013 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4404 (insn, operands);

    case E_V16DFmode:
      if (!register_operand (operands[0], E_V16DFmode)
          || GET_MODE (x2) != E_V16DFmode
          || !register_operand (operands[1], E_V16SFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1014 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4405 (insn, operands);

    case E_V32DFmode:
      if (!register_operand (operands[0], E_V32DFmode)
          || GET_MODE (x2) != E_V32DFmode
          || !register_operand (operands[1], E_V32SFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1015 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4406 (insn, operands);

    case E_V64DFmode:
      if (!register_operand (operands[0], E_V64DFmode)
          || GET_MODE (x2) != E_V64DFmode
          || !register_operand (operands[1], E_V64SFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1016 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4407 (insn, operands);

    case E_V128DFmode:
      if (!register_operand (operands[0], E_V128DFmode)
          || GET_MODE (x2) != E_V128DFmode
          || !register_operand (operands[1], E_V128SFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1017 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4408 (insn, operands);

    case E_V256DFmode:
      if (!register_operand (operands[0], E_V256DFmode)
          || GET_MODE (x2) != E_V256DFmode
          || !register_operand (operands[1], E_V256SFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1018 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4409 (insn, operands);

    case E_V512DFmode:
      if (!register_operand (operands[0], E_V512DFmode)
          || GET_MODE (x2) != E_V512DFmode
          || !register_operand (operands[1], E_V512SFmode)
          || !((
#line 850 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1019 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 852 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4410 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_162 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ASHIFT:
      switch (pattern231 (x2))
        {
        case 0:
          if (!((
#line 2992 "../../gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 2997 "../../gcc/config/riscv/riscv.md"
( 1)))
            return NULL;
          return gen_split_42 (insn, operands);

        case 1:
          if (!((
#line 2992 "../../gcc/config/riscv/riscv.md"
((!SMALL_OPERAND (INTVAL (operands[3]))
    && SMALL_OPERAND (INTVAL (operands[3]) >> INTVAL (operands[2]))
    && (!TARGET_ZBS || popcount_hwi (INTVAL (operands[3])) > 1)
    && (INTVAL (operands[3]) & ((1ULL << INTVAL (operands[2])) - 1)) == 0)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 2997 "../../gcc/config/riscv/riscv.md"
( 1)))
            return NULL;
          return gen_split_45 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      switch (pattern234 (x2))
        {
        case 0:
          if (!((
#line 1022 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && !single_bit_mask_operand (operands[2], VOIDmode)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 1024 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_177 (insn, operands);

        case 1:
          if (!((
#line 1022 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && !single_bit_mask_operand (operands[2], VOIDmode)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 1024 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_179 (insn, operands);

        case 2:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2591 (insn, operands);

        case 3:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2605 (insn, operands);

        case 4:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2619 (insn, operands);

        case 5:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2633 (insn, operands);

        case 6:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2647 (insn, operands);

        case 7:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2661 (insn, operands);

        case 8:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2675 (insn, operands);

        case 9:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2689 (insn, operands);

        case 10:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2703 (insn, operands);

        case 11:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2717 (insn, operands);

        case 12:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2731 (insn, operands);

        case 13:
          if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2745 (insn, operands);

        case 14:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2759 (insn, operands);

        case 15:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2773 (insn, operands);

        case 16:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2787 (insn, operands);

        case 17:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2801 (insn, operands);

        case 18:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2815 (insn, operands);

        case 19:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2829 (insn, operands);

        case 20:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2843 (insn, operands);

        case 21:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2857 (insn, operands);

        case 22:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2871 (insn, operands);

        case 23:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2885 (insn, operands);

        case 24:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2899 (insn, operands);

        case 25:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2913 (insn, operands);

        case 26:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2927 (insn, operands);

        case 27:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2941 (insn, operands);

        case 28:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2955 (insn, operands);

        case 29:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2969 (insn, operands);

        case 30:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2983 (insn, operands);

        case 31:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2997 (insn, operands);

        case 32:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3011 (insn, operands);

        case 33:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3025 (insn, operands);

        case 34:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3039 (insn, operands);

        case 35:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3053 (insn, operands);

        case 36:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3067 (insn, operands);

        case 37:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3081 (insn, operands);

        case 38:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3095 (insn, operands);

        case 39:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3109 (insn, operands);

        case 40:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3123 (insn, operands);

        case 41:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3137 (insn, operands);

        case 42:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3151 (insn, operands);

        case 43:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3165 (insn, operands);

        case 44:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3179 (insn, operands);

        case 45:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3193 (insn, operands);

        case 46:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3207 (insn, operands);

        case 47:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3221 (insn, operands);

        case 48:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3235 (insn, operands);

        case 49:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3249 (insn, operands);

        case 50:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3263 (insn, operands);

        case 51:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3277 (insn, operands);

        case 52:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3291 (insn, operands);

        case 53:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3305 (insn, operands);

        case 54:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3319 (insn, operands);

        case 55:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3333 (insn, operands);

        case 56:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3347 (insn, operands);

        case 57:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3361 (insn, operands);

        case 58:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3375 (insn, operands);

        case 59:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3389 (insn, operands);

        case 60:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3403 (insn, operands);

        case 61:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3417 (insn, operands);

        case 62:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3431 (insn, operands);

        case 63:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3445 (insn, operands);

        case 64:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3459 (insn, operands);

        case 65:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3473 (insn, operands);

        case 66:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3487 (insn, operands);

        case 67:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3501 (insn, operands);

        case 68:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3515 (insn, operands);

        case 69:
          if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3529 (insn, operands);

        case 70:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3949 (insn, operands);

        case 71:
          if (!(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3952 (insn, operands);

        case 72:
          if (!(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3955 (insn, operands);

        case 73:
          if (!(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3958 (insn, operands);

        case 74:
          if (!(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3961 (insn, operands);

        case 75:
          if (!(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3964 (insn, operands);

        case 76:
          if (!(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3967 (insn, operands);

        case 77:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3970 (insn, operands);

        case 78:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3973 (insn, operands);

        case 79:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3976 (insn, operands);

        case 80:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3979 (insn, operands);

        case 81:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3982 (insn, operands);

        case 82:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3985 (insn, operands);

        case 83:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3988 (insn, operands);

        case 84:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3991 (insn, operands);

        case 85:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3994 (insn, operands);

        case 86:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3997 (insn, operands);

        case 87:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4000 (insn, operands);

        case 88:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4003 (insn, operands);

        case 89:
          if (!((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4006 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_172 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 5
      || XINT (x3, 1) != 93)
    return NULL;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 5
      || XINT (x4, 1) != 171)
    return NULL;
  x5 = XVECEXP (x3, 0, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || pattern329 (x3) != 0)
    return NULL;
  switch (pattern456 (x2))
    {
    case 0:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF64BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10191 (insn, operands);

    case 1:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF32BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10193 (insn, operands);

    case 2:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF16BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10195 (insn, operands);

    case 3:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF8BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10197 (insn, operands);

    case 4:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF4BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10199 (insn, operands);

    case 5:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF2BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10201 (insn, operands);

    case 6:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVM1BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10203 (insn, operands);

    case 7:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode)))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10205 (insn, operands);

    case 8:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode)))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10207 (insn, operands);

    case 9:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode)))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10209 (insn, operands);

    case 10:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V8BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode)))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10211 (insn, operands);

    case 11:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V16BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode)))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10213 (insn, operands);

    case 12:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V32BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10215 (insn, operands);

    case 13:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V64BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10217 (insn, operands);

    case 14:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V128BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10219 (insn, operands);

    case 15:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V256BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10221 (insn, operands);

    case 16:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V512BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10223 (insn, operands);

    case 17:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1024BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10225 (insn, operands);

    case 18:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2048BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10227 (insn, operands);

    case 19:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4096BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10229 (insn, operands);

    case 20:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF64BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10192 (insn, operands);

    case 21:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF32BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10194 (insn, operands);

    case 22:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF16BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10196 (insn, operands);

    case 23:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF8BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10198 (insn, operands);

    case 24:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF4BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10200 (insn, operands);

    case 25:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVMF2BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10202 (insn, operands);

    case 26:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (RVVM1BImode)).exists ()) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10204 (insn, operands);

    case 27:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode)))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10206 (insn, operands);

    case 28:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode)))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10208 (insn, operands);

    case 29:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode)))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10210 (insn, operands);

    case 30:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V8BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode)))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10212 (insn, operands);

    case 31:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V16BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode)))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10214 (insn, operands);

    case 32:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V32BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode)))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10216 (insn, operands);

    case 33:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V64BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10218 (insn, operands);

    case 34:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V128BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10220 (insn, operands);

    case 35:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V256BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10222 (insn, operands);

    case 36:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V512BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10224 (insn, operands);

    case 37:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V1024BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10226 (insn, operands);

    case 38:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V2048BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10228 (insn, operands);

    case 39:
      if (!((
#line 1519 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR
   && can_create_pseudo_p ()
   && riscv_vector::get_vector_mode (Pmode, GET_MODE_NUNITS (V4096BImode)).exists ()) && (((((
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096))) && 
#line 1523 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_10230 (insn, operands);

    default:
      return NULL;
    }
}
