/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[1], E_HFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM8DImode)
      || GET_MODE (x1) != E_RVVM8DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8DFmode:
      if (!register_operand (operands[1], E_RVVM8DFmode))
        return -1;
      return 0;

    case E_RVVM4SFmode:
      if (!register_operand (operands[1], E_RVVM4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM1DImode)
      || GET_MODE (x1) != E_RVVM1DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM1DFmode:
      if (!register_operand (operands[1], E_RVVM1DFmode))
        return -1;
      return 0;

    case E_RVVMF2SFmode:
      if (!register_operand (operands[1], E_RVVMF2SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V64HImode)
      || GET_MODE (x1) != E_V64HImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V64HFmode:
      if (!register_operand (operands[1], E_V64HFmode))
        return -1;
      return 0;

    case E_V64SFmode:
      if (!register_operand (operands[1], E_V64SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 0;

    case E_V4HFmode:
      if (!register_operand (operands[1], E_V4HFmode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512SImode)
      || GET_MODE (x1) != E_V512SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512SFmode:
      if (!register_operand (operands[1], E_V512SFmode))
        return -1;
      return 0;

    case E_V512HFmode:
      if (!register_operand (operands[1], E_V512HFmode))
        return -1;
      return 1;

    case E_V512DFmode:
      if (!register_operand (operands[1], E_V512DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern51 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V512DImode)
      || GET_MODE (x1) != E_V512DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V512DFmode:
      if (!register_operand (operands[1], E_V512DFmode))
        return -1;
      return 0;

    case E_V512SFmode:
      if (!register_operand (operands[1], E_V512SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVMF4HFmode)
      || GET_MODE (x1) != E_RVVMF4HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVMF4HImode:
      if (!register_operand (operands[1], E_RVVMF4HImode))
        return -1;
      return 0;

    case E_RVVMF8QImode:
      if (!register_operand (operands[1], E_RVVMF8QImode))
        return -1;
      return 1;

    case E_RVVMF2SImode:
      if (!register_operand (operands[1], E_RVVMF2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern64 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM8DFmode)
      || GET_MODE (x1) != E_RVVM8DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM8DImode:
      if (!register_operand (operands[1], E_RVVM8DImode))
        return -1;
      return 0;

    case E_RVVM4SImode:
      if (!register_operand (operands[1], E_RVVM4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM2DFmode)
      || GET_MODE (x1) != E_RVVM2DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM2DImode:
      if (!register_operand (operands[1], E_RVVM2DImode))
        return -1;
      return 0;

    case E_RVVM1SImode:
      if (!register_operand (operands[1], E_RVVM1SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16HFmode)
      || GET_MODE (x1) != E_V16HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V1024HFmode)
      || GET_MODE (x1) != E_V1024HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V1024HImode:
      if (!register_operand (operands[1], E_V1024HImode))
        return -1;
      return 0;

    case E_V1024QImode:
      if (!register_operand (operands[1], E_V1024QImode))
        return -1;
      return 1;

    case E_V1024SImode:
      if (!register_operand (operands[1], E_V1024SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V32SFmode)
      || GET_MODE (x1) != E_V32SFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V32SImode:
      if (!register_operand (operands[1], E_V32SImode))
        return -1;
      return 0;

    case E_V32HImode:
      if (!register_operand (operands[1], E_V32HImode))
        return -1;
      return 1;

    case E_V32DImode:
      if (!register_operand (operands[1], E_V32DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DFmode)
      || GET_MODE (x1) != E_V2DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      return 0;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V256DFmode)
      || GET_MODE (x1) != E_V256DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V256DImode:
      if (!register_operand (operands[1], E_V256DImode))
        return -1;
      return 0;

    case E_V256SImode:
      if (!register_operand (operands[1], E_V256SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern106 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  return pattern105 (x2); /* [-1, 2] */
}

int
pattern108 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[2], i2))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !vector_mask_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (pattern3 (x3) != 0)
        return -1;
      return 1;

    case E_RVVM8QImode:
      if (pattern0 (x3, 
E_RVVM8QImode) != 0)
        return -1;
      return 2;

    case E_RVVM4QImode:
      if (pattern0 (x3, 
E_RVVM4QImode) != 0)
        return -1;
      return 3;

    case E_RVVM2QImode:
      if (pattern0 (x3, 
E_RVVM2QImode) != 0)
        return -1;
      return 4;

    case E_RVVM1QImode:
      if (pattern0 (x3, 
E_RVVM1QImode) != 0)
        return -1;
      return 5;

    case E_RVVM8HImode:
      if (pattern0 (x3, 
E_RVVM8HImode) != 0)
        return -1;
      return 6;

    case E_RVVM4HImode:
      if (pattern0 (x3, 
E_RVVM4HImode) != 0)
        return -1;
      return 7;

    case E_RVVM2HImode:
      if (pattern0 (x3, 
E_RVVM2HImode) != 0)
        return -1;
      return 8;

    case E_RVVM1HImode:
      if (pattern0 (x3, 
E_RVVM1HImode) != 0)
        return -1;
      return 9;

    case E_RVVM8SImode:
      if (pattern0 (x3, 
E_RVVM8SImode) != 0)
        return -1;
      return 10;

    case E_RVVM4SImode:
      if (pattern0 (x3, 
E_RVVM4SImode) != 0)
        return -1;
      return 11;

    case E_RVVM2SImode:
      if (pattern0 (x3, 
E_RVVM2SImode) != 0)
        return -1;
      return 12;

    case E_RVVM1SImode:
      if (pattern0 (x3, 
E_RVVM1SImode) != 0)
        return -1;
      return 13;

    case E_RVVM8DImode:
      if (pattern0 (x3, 
E_RVVM8DImode) != 0)
        return -1;
      return 14;

    case E_RVVM4DImode:
      if (pattern0 (x3, 
E_RVVM4DImode) != 0)
        return -1;
      return 15;

    case E_RVVM2DImode:
      if (pattern0 (x3, 
E_RVVM2DImode) != 0)
        return -1;
      return 16;

    case E_RVVM1DImode:
      if (pattern0 (x3, 
E_RVVM1DImode) != 0)
        return -1;
      return 17;

    case E_RVVMF2QImode:
      if (pattern0 (x3, 
E_RVVMF2QImode) != 0)
        return -1;
      return 18;

    case E_RVVMF4QImode:
      if (pattern0 (x3, 
E_RVVMF4QImode) != 0)
        return -1;
      return 19;

    case E_RVVMF8QImode:
      if (pattern0 (x3, 
E_RVVMF8QImode) != 0)
        return -1;
      return 20;

    case E_RVVMF2HImode:
      if (pattern0 (x3, 
E_RVVMF2HImode) != 0)
        return -1;
      return 21;

    case E_RVVMF4HImode:
      if (pattern0 (x3, 
E_RVVMF4HImode) != 0)
        return -1;
      return 22;

    case E_RVVMF2SImode:
      if (pattern0 (x3, 
E_RVVMF2SImode) != 0)
        return -1;
      return 23;

    case E_V1QImode:
      if (pattern0 (x3, 
E_V1QImode) != 0)
        return -1;
      return 24;

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 25;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 26;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 27;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 28;

    case E_V32QImode:
      if (pattern0 (x3, 
E_V32QImode) != 0)
        return -1;
      return 29;

    case E_V64QImode:
      if (pattern0 (x3, 
E_V64QImode) != 0)
        return -1;
      return 30;

    case E_V128QImode:
      if (pattern0 (x3, 
E_V128QImode) != 0)
        return -1;
      return 31;

    case E_V256QImode:
      if (pattern0 (x3, 
E_V256QImode) != 0)
        return -1;
      return 32;

    case E_V512QImode:
      if (pattern0 (x3, 
E_V512QImode) != 0)
        return -1;
      return 33;

    case E_V1024QImode:
      if (pattern0 (x3, 
E_V1024QImode) != 0)
        return -1;
      return 34;

    case E_V2048QImode:
      if (pattern0 (x3, 
E_V2048QImode) != 0)
        return -1;
      return 35;

    case E_V4096QImode:
      if (pattern0 (x3, 
E_V4096QImode) != 0)
        return -1;
      return 36;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 37;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 38;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 39;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 40;

    case E_V16HImode:
      if (pattern0 (x3, 
E_V16HImode) != 0)
        return -1;
      return 41;

    case E_V32HImode:
      if (pattern0 (x3, 
E_V32HImode) != 0)
        return -1;
      return 42;

    case E_V64HImode:
      if (pattern0 (x3, 
E_V64HImode) != 0)
        return -1;
      return 43;

    case E_V128HImode:
      if (pattern0 (x3, 
E_V128HImode) != 0)
        return -1;
      return 44;

    case E_V256HImode:
      if (pattern0 (x3, 
E_V256HImode) != 0)
        return -1;
      return 45;

    case E_V512HImode:
      if (pattern0 (x3, 
E_V512HImode) != 0)
        return -1;
      return 46;

    case E_V1024HImode:
      if (pattern0 (x3, 
E_V1024HImode) != 0)
        return -1;
      return 47;

    case E_V2048HImode:
      if (pattern0 (x3, 
E_V2048HImode) != 0)
        return -1;
      return 48;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 49;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 50;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 51;

    case E_V8SImode:
      if (pattern0 (x3, 
E_V8SImode) != 0)
        return -1;
      return 52;

    case E_V16SImode:
      if (pattern0 (x3, 
E_V16SImode) != 0)
        return -1;
      return 53;

    case E_V32SImode:
      if (pattern0 (x3, 
E_V32SImode) != 0)
        return -1;
      return 54;

    case E_V64SImode:
      if (pattern0 (x3, 
E_V64SImode) != 0)
        return -1;
      return 55;

    case E_V128SImode:
      if (pattern0 (x3, 
E_V128SImode) != 0)
        return -1;
      return 56;

    case E_V256SImode:
      if (pattern0 (x3, 
E_V256SImode) != 0)
        return -1;
      return 57;

    case E_V512SImode:
      if (pattern0 (x3, 
E_V512SImode) != 0)
        return -1;
      return 58;

    case E_V1024SImode:
      if (pattern0 (x3, 
E_V1024SImode) != 0)
        return -1;
      return 59;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 60;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 61;

    case E_V4DImode:
      if (pattern0 (x3, 
E_V4DImode) != 0)
        return -1;
      return 62;

    case E_V8DImode:
      if (pattern0 (x3, 
E_V8DImode) != 0)
        return -1;
      return 63;

    case E_V16DImode:
      if (pattern0 (x3, 
E_V16DImode) != 0)
        return -1;
      return 64;

    case E_V32DImode:
      if (pattern0 (x3, 
E_V32DImode) != 0)
        return -1;
      return 65;

    case E_V64DImode:
      if (pattern0 (x3, 
E_V64DImode) != 0)
        return -1;
      return 66;

    case E_V128DImode:
      if (pattern0 (x3, 
E_V128DImode) != 0)
        return -1;
      return 67;

    case E_V256DImode:
      if (pattern0 (x3, 
E_V256DImode) != 0)
        return -1;
      return 68;

    case E_V512DImode:
      if (pattern0 (x3, 
E_V512DImode) != 0)
        return -1;
      return 69;

    default:
      return -1;
    }
}

int
pattern128 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SFmode:
      return pattern128 (x1, 
E_RVVM4HFmode, 
E_RVVM8SFmode); /* [-1, 0] */

    case E_RVVM4SFmode:
      if (pattern128 (x1, 
E_RVVM2HFmode, 
E_RVVM4SFmode) != 0)
        return -1;
      return 1;

    case E_RVVM2SFmode:
      if (pattern128 (x1, 
E_RVVM1HFmode, 
E_RVVM2SFmode) != 0)
        return -1;
      return 2;

    case E_RVVM1SFmode:
      if (pattern128 (x1, 
E_RVVMF2HFmode, 
E_RVVM1SFmode) != 0)
        return -1;
      return 3;

    case E_RVVMF2SFmode:
      if (pattern128 (x1, 
E_RVVMF4HFmode, 
E_RVVMF2SFmode) != 0)
        return -1;
      return 4;

    case E_RVVM8DFmode:
      if (pattern128 (x1, 
E_RVVM4SFmode, 
E_RVVM8DFmode) != 0)
        return -1;
      return 5;

    case E_RVVM4DFmode:
      if (pattern128 (x1, 
E_RVVM2SFmode, 
E_RVVM4DFmode) != 0)
        return -1;
      return 6;

    case E_RVVM2DFmode:
      if (pattern128 (x1, 
E_RVVM1SFmode, 
E_RVVM2DFmode) != 0)
        return -1;
      return 7;

    case E_RVVM1DFmode:
      if (pattern128 (x1, 
E_RVVMF2SFmode, 
E_RVVM1DFmode) != 0)
        return -1;
      return 8;

    case E_V1SFmode:
      if (pattern128 (x1, 
E_V1HFmode, 
E_V1SFmode) != 0)
        return -1;
      return 9;

    case E_V2SFmode:
      if (pattern128 (x1, 
E_V2HFmode, 
E_V2SFmode) != 0)
        return -1;
      return 10;

    case E_V4SFmode:
      if (pattern128 (x1, 
E_V4HFmode, 
E_V4SFmode) != 0)
        return -1;
      return 11;

    case E_V8SFmode:
      if (pattern128 (x1, 
E_V8HFmode, 
E_V8SFmode) != 0)
        return -1;
      return 12;

    case E_V16SFmode:
      if (pattern128 (x1, 
E_V16HFmode, 
E_V16SFmode) != 0)
        return -1;
      return 13;

    case E_V32SFmode:
      if (pattern128 (x1, 
E_V32HFmode, 
E_V32SFmode) != 0)
        return -1;
      return 14;

    case E_V64SFmode:
      if (pattern128 (x1, 
E_V64HFmode, 
E_V64SFmode) != 0)
        return -1;
      return 15;

    case E_V128SFmode:
      if (pattern128 (x1, 
E_V128HFmode, 
E_V128SFmode) != 0)
        return -1;
      return 16;

    case E_V256SFmode:
      if (pattern128 (x1, 
E_V256HFmode, 
E_V256SFmode) != 0)
        return -1;
      return 17;

    case E_V512SFmode:
      if (pattern128 (x1, 
E_V512HFmode, 
E_V512SFmode) != 0)
        return -1;
      return 18;

    case E_V1024SFmode:
      if (pattern128 (x1, 
E_V1024HFmode, 
E_V1024SFmode) != 0)
        return -1;
      return 19;

    case E_V1DFmode:
      if (pattern128 (x1, 
E_V1SFmode, 
E_V1DFmode) != 0)
        return -1;
      return 20;

    case E_V2DFmode:
      if (pattern128 (x1, 
E_V2SFmode, 
E_V2DFmode) != 0)
        return -1;
      return 21;

    case E_V4DFmode:
      if (pattern128 (x1, 
E_V4SFmode, 
E_V4DFmode) != 0)
        return -1;
      return 22;

    case E_V8DFmode:
      if (pattern128 (x1, 
E_V8SFmode, 
E_V8DFmode) != 0)
        return -1;
      return 23;

    case E_V16DFmode:
      if (pattern128 (x1, 
E_V16SFmode, 
E_V16DFmode) != 0)
        return -1;
      return 24;

    case E_V32DFmode:
      if (pattern128 (x1, 
E_V32SFmode, 
E_V32DFmode) != 0)
        return -1;
      return 25;

    case E_V64DFmode:
      if (pattern128 (x1, 
E_V64SFmode, 
E_V64DFmode) != 0)
        return -1;
      return 26;

    case E_V128DFmode:
      if (pattern128 (x1, 
E_V128SFmode, 
E_V128DFmode) != 0)
        return -1;
      return 27;

    case E_V256DFmode:
      if (pattern128 (x1, 
E_V256SFmode, 
E_V256DFmode) != 0)
        return -1;
      return 28;

    case E_V512DFmode:
      if (pattern128 (x1, 
E_V512SFmode, 
E_V512DFmode) != 0)
        return -1;
      return 29;

    default:
      return -1;
    }
}

int
pattern142 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      x5 = XEXP (x1, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HFmode:
          return pattern136 (x1, 
E_RVVM8HFmode); /* [-1, 0] */

        case E_RVVM4HFmode:
          if (pattern136 (x1, 
E_RVVM4HFmode) != 0)
            return -1;
          return 1;

        case E_RVVM2HFmode:
          if (pattern136 (x1, 
E_RVVM2HFmode) != 0)
            return -1;
          return 2;

        case E_RVVM1HFmode:
          if (pattern136 (x1, 
E_RVVM1HFmode) != 0)
            return -1;
          return 3;

        case E_RVVMF2HFmode:
          if (pattern136 (x1, 
E_RVVMF2HFmode) != 0)
            return -1;
          return 4;

        case E_RVVMF4HFmode:
          if (pattern136 (x1, 
E_RVVMF4HFmode) != 0)
            return -1;
          return 5;

        case E_RVVM8SFmode:
          if (pattern136 (x1, 
E_RVVM8SFmode) != 0)
            return -1;
          return 6;

        case E_RVVM4SFmode:
          if (pattern136 (x1, 
E_RVVM4SFmode) != 0)
            return -1;
          return 7;

        case E_RVVM2SFmode:
          if (pattern136 (x1, 
E_RVVM2SFmode) != 0)
            return -1;
          return 8;

        case E_RVVM1SFmode:
          if (pattern136 (x1, 
E_RVVM1SFmode) != 0)
            return -1;
          return 9;

        case E_RVVMF2SFmode:
          if (pattern136 (x1, 
E_RVVMF2SFmode) != 0)
            return -1;
          return 10;

        case E_RVVM8DFmode:
          if (pattern136 (x1, 
E_RVVM8DFmode) != 0)
            return -1;
          return 11;

        case E_RVVM4DFmode:
          if (pattern136 (x1, 
E_RVVM4DFmode) != 0)
            return -1;
          return 12;

        case E_RVVM2DFmode:
          if (pattern136 (x1, 
E_RVVM2DFmode) != 0)
            return -1;
          return 13;

        case E_RVVM1DFmode:
          if (pattern136 (x1, 
E_RVVM1DFmode) != 0)
            return -1;
          return 14;

        case E_V1HFmode:
          if (pattern136 (x1, 
E_V1HFmode) != 0)
            return -1;
          return 15;

        case E_V2HFmode:
          if (pattern136 (x1, 
E_V2HFmode) != 0)
            return -1;
          return 16;

        case E_V4HFmode:
          if (pattern136 (x1, 
E_V4HFmode) != 0)
            return -1;
          return 17;

        case E_V8HFmode:
          if (pattern136 (x1, 
E_V8HFmode) != 0)
            return -1;
          return 18;

        case E_V16HFmode:
          if (pattern136 (x1, 
E_V16HFmode) != 0)
            return -1;
          return 19;

        case E_V32HFmode:
          if (pattern136 (x1, 
E_V32HFmode) != 0)
            return -1;
          return 20;

        case E_V64HFmode:
          if (pattern136 (x1, 
E_V64HFmode) != 0)
            return -1;
          return 21;

        case E_V128HFmode:
          if (pattern136 (x1, 
E_V128HFmode) != 0)
            return -1;
          return 22;

        case E_V256HFmode:
          if (pattern136 (x1, 
E_V256HFmode) != 0)
            return -1;
          return 23;

        case E_V512HFmode:
          if (pattern136 (x1, 
E_V512HFmode) != 0)
            return -1;
          return 24;

        case E_V1024HFmode:
          if (pattern136 (x1, 
E_V1024HFmode) != 0)
            return -1;
          return 25;

        case E_V2048HFmode:
          if (pattern136 (x1, 
E_V2048HFmode) != 0)
            return -1;
          return 26;

        case E_V1SFmode:
          if (pattern136 (x1, 
E_V1SFmode) != 0)
            return -1;
          return 27;

        case E_V2SFmode:
          if (pattern136 (x1, 
E_V2SFmode) != 0)
            return -1;
          return 28;

        case E_V4SFmode:
          if (pattern136 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 29;

        case E_V8SFmode:
          if (pattern136 (x1, 
E_V8SFmode) != 0)
            return -1;
          return 30;

        case E_V16SFmode:
          if (pattern136 (x1, 
E_V16SFmode) != 0)
            return -1;
          return 31;

        case E_V32SFmode:
          if (pattern136 (x1, 
E_V32SFmode) != 0)
            return -1;
          return 32;

        case E_V64SFmode:
          if (pattern136 (x1, 
E_V64SFmode) != 0)
            return -1;
          return 33;

        case E_V128SFmode:
          if (pattern136 (x1, 
E_V128SFmode) != 0)
            return -1;
          return 34;

        case E_V256SFmode:
          if (pattern136 (x1, 
E_V256SFmode) != 0)
            return -1;
          return 35;

        case E_V512SFmode:
          if (pattern136 (x1, 
E_V512SFmode) != 0)
            return -1;
          return 36;

        case E_V1024SFmode:
          if (pattern136 (x1, 
E_V1024SFmode) != 0)
            return -1;
          return 37;

        case E_V1DFmode:
          if (pattern136 (x1, 
E_V1DFmode) != 0)
            return -1;
          return 38;

        case E_V2DFmode:
          if (pattern136 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 39;

        case E_V4DFmode:
          if (pattern136 (x1, 
E_V4DFmode) != 0)
            return -1;
          return 40;

        case E_V8DFmode:
          if (pattern136 (x1, 
E_V8DFmode) != 0)
            return -1;
          return 41;

        case E_V16DFmode:
          if (pattern136 (x1, 
E_V16DFmode) != 0)
            return -1;
          return 42;

        case E_V32DFmode:
          if (pattern136 (x1, 
E_V32DFmode) != 0)
            return -1;
          return 43;

        case E_V64DFmode:
          if (pattern136 (x1, 
E_V64DFmode) != 0)
            return -1;
          return 44;

        case E_V128DFmode:
          if (pattern136 (x1, 
E_V128DFmode) != 0)
            return -1;
          return 45;

        case E_V256DFmode:
          if (pattern136 (x1, 
E_V256DFmode) != 0)
            return -1;
          return 46;

        case E_V512DFmode:
          if (pattern136 (x1, 
E_V512DFmode) != 0)
            return -1;
          return 47;

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      res = pattern139 (x1);
      if (res >= 0)
        return res + 48; /* [48, 107] */
      return -1;

    case NEG:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != FLOAT_EXTEND)
        return -1;
      x5 = XEXP (x1, 1);
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case FLOAT_EXTEND:
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          x8 = XEXP (x4, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern140 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode) != 0)
                return -1;
              return 108;

            case E_RVVM4SFmode:
              if (pattern140 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode) != 0)
                return -1;
              return 109;

            case E_RVVM2SFmode:
              if (pattern140 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode) != 0)
                return -1;
              return 110;

            case E_RVVM1SFmode:
              if (pattern140 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode) != 0)
                return -1;
              return 111;

            case E_RVVMF2SFmode:
              if (pattern140 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode) != 0)
                return -1;
              return 112;

            case E_RVVM8DFmode:
              if (pattern140 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode) != 0)
                return -1;
              return 113;

            case E_RVVM4DFmode:
              if (pattern140 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode) != 0)
                return -1;
              return 114;

            case E_RVVM2DFmode:
              if (pattern140 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode) != 0)
                return -1;
              return 115;

            case E_RVVM1DFmode:
              if (pattern140 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode) != 0)
                return -1;
              return 116;

            case E_V1SFmode:
              if (pattern140 (x1, 
E_V1SFmode, 
E_V1HFmode) != 0)
                return -1;
              return 117;

            case E_V2SFmode:
              if (pattern140 (x1, 
E_V2SFmode, 
E_V2HFmode) != 0)
                return -1;
              return 118;

            case E_V4SFmode:
              if (pattern140 (x1, 
E_V4SFmode, 
E_V4HFmode) != 0)
                return -1;
              return 119;

            case E_V8SFmode:
              if (pattern140 (x1, 
E_V8SFmode, 
E_V8HFmode) != 0)
                return -1;
              return 120;

            case E_V16SFmode:
              if (pattern140 (x1, 
E_V16SFmode, 
E_V16HFmode) != 0)
                return -1;
              return 121;

            case E_V32SFmode:
              if (pattern140 (x1, 
E_V32SFmode, 
E_V32HFmode) != 0)
                return -1;
              return 122;

            case E_V64SFmode:
              if (pattern140 (x1, 
E_V64SFmode, 
E_V64HFmode) != 0)
                return -1;
              return 123;

            case E_V128SFmode:
              if (pattern140 (x1, 
E_V128SFmode, 
E_V128HFmode) != 0)
                return -1;
              return 124;

            case E_V256SFmode:
              if (pattern140 (x1, 
E_V256SFmode, 
E_V256HFmode) != 0)
                return -1;
              return 125;

            case E_V512SFmode:
              if (pattern140 (x1, 
E_V512SFmode, 
E_V512HFmode) != 0)
                return -1;
              return 126;

            case E_V1024SFmode:
              if (pattern140 (x1, 
E_V1024SFmode, 
E_V1024HFmode) != 0)
                return -1;
              return 127;

            case E_V1DFmode:
              if (pattern140 (x1, 
E_V1DFmode, 
E_V1SFmode) != 0)
                return -1;
              return 128;

            case E_V2DFmode:
              if (pattern140 (x1, 
E_V2DFmode, 
E_V2SFmode) != 0)
                return -1;
              return 129;

            case E_V4DFmode:
              if (pattern140 (x1, 
E_V4DFmode, 
E_V4SFmode) != 0)
                return -1;
              return 130;

            case E_V8DFmode:
              if (pattern140 (x1, 
E_V8DFmode, 
E_V8SFmode) != 0)
                return -1;
              return 131;

            case E_V16DFmode:
              if (pattern140 (x1, 
E_V16DFmode, 
E_V16SFmode) != 0)
                return -1;
              return 132;

            case E_V32DFmode:
              if (pattern140 (x1, 
E_V32DFmode, 
E_V32SFmode) != 0)
                return -1;
              return 133;

            case E_V64DFmode:
              if (pattern140 (x1, 
E_V64DFmode, 
E_V64SFmode) != 0)
                return -1;
              return 134;

            case E_V128DFmode:
              if (pattern140 (x1, 
E_V128DFmode, 
E_V128SFmode) != 0)
                return -1;
              return 135;

            case E_V256DFmode:
              if (pattern140 (x1, 
E_V256DFmode, 
E_V256SFmode) != 0)
                return -1;
              return 136;

            case E_V512DFmode:
              if (pattern140 (x1, 
E_V512DFmode, 
E_V512SFmode) != 0)
                return -1;
              return 137;

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[3] = x6;
          x8 = XEXP (x4, 0);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8SFmode:
              if (pattern141 (x1, 
E_RVVM8SFmode, 
E_RVVM4HFmode) != 0)
                return -1;
              return 138;

            case E_RVVM4SFmode:
              if (pattern141 (x1, 
E_RVVM4SFmode, 
E_RVVM2HFmode) != 0)
                return -1;
              return 139;

            case E_RVVM2SFmode:
              if (pattern141 (x1, 
E_RVVM2SFmode, 
E_RVVM1HFmode) != 0)
                return -1;
              return 140;

            case E_RVVM1SFmode:
              if (pattern141 (x1, 
E_RVVM1SFmode, 
E_RVVMF2HFmode) != 0)
                return -1;
              return 141;

            case E_RVVMF2SFmode:
              if (pattern141 (x1, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode) != 0)
                return -1;
              return 142;

            case E_RVVM8DFmode:
              if (pattern141 (x1, 
E_RVVM8DFmode, 
E_RVVM4SFmode) != 0)
                return -1;
              return 143;

            case E_RVVM4DFmode:
              if (pattern141 (x1, 
E_RVVM4DFmode, 
E_RVVM2SFmode) != 0)
                return -1;
              return 144;

            case E_RVVM2DFmode:
              if (pattern141 (x1, 
E_RVVM2DFmode, 
E_RVVM1SFmode) != 0)
                return -1;
              return 145;

            case E_RVVM1DFmode:
              if (pattern141 (x1, 
E_RVVM1DFmode, 
E_RVVMF2SFmode) != 0)
                return -1;
              return 146;

            case E_V1SFmode:
              if (pattern141 (x1, 
E_V1SFmode, 
E_V1HFmode) != 0)
                return -1;
              return 147;

            case E_V2SFmode:
              if (pattern141 (x1, 
E_V2SFmode, 
E_V2HFmode) != 0)
                return -1;
              return 148;

            case E_V4SFmode:
              if (pattern141 (x1, 
E_V4SFmode, 
E_V4HFmode) != 0)
                return -1;
              return 149;

            case E_V8SFmode:
              if (pattern141 (x1, 
E_V8SFmode, 
E_V8HFmode) != 0)
                return -1;
              return 150;

            case E_V16SFmode:
              if (pattern141 (x1, 
E_V16SFmode, 
E_V16HFmode) != 0)
                return -1;
              return 151;

            case E_V32SFmode:
              if (pattern141 (x1, 
E_V32SFmode, 
E_V32HFmode) != 0)
                return -1;
              return 152;

            case E_V64SFmode:
              if (pattern141 (x1, 
E_V64SFmode, 
E_V64HFmode) != 0)
                return -1;
              return 153;

            case E_V128SFmode:
              if (pattern141 (x1, 
E_V128SFmode, 
E_V128HFmode) != 0)
                return -1;
              return 154;

            case E_V256SFmode:
              if (pattern141 (x1, 
E_V256SFmode, 
E_V256HFmode) != 0)
                return -1;
              return 155;

            case E_V512SFmode:
              if (pattern141 (x1, 
E_V512SFmode, 
E_V512HFmode) != 0)
                return -1;
              return 156;

            case E_V1024SFmode:
              if (pattern141 (x1, 
E_V1024SFmode, 
E_V1024HFmode) != 0)
                return -1;
              return 157;

            case E_V1DFmode:
              if (pattern141 (x1, 
E_V1DFmode, 
E_V1SFmode) != 0)
                return -1;
              return 158;

            case E_V2DFmode:
              if (pattern141 (x1, 
E_V2DFmode, 
E_V2SFmode) != 0)
                return -1;
              return 159;

            case E_V4DFmode:
              if (pattern141 (x1, 
E_V4DFmode, 
E_V4SFmode) != 0)
                return -1;
              return 160;

            case E_V8DFmode:
              if (pattern141 (x1, 
E_V8DFmode, 
E_V8SFmode) != 0)
                return -1;
              return 161;

            case E_V16DFmode:
              if (pattern141 (x1, 
E_V16DFmode, 
E_V16SFmode) != 0)
                return -1;
              return 162;

            case E_V32DFmode:
              if (pattern141 (x1, 
E_V32DFmode, 
E_V32SFmode) != 0)
                return -1;
              return 163;

            case E_V64DFmode:
              if (pattern141 (x1, 
E_V64DFmode, 
E_V64SFmode) != 0)
                return -1;
              return 164;

            case E_V128DFmode:
              if (pattern141 (x1, 
E_V128DFmode, 
E_V128SFmode) != 0)
                return -1;
              return 165;

            case E_V256DFmode:
              if (pattern141 (x1, 
E_V256DFmode, 
E_V256SFmode) != 0)
                return -1;
              return 166;

            case E_V512DFmode:
              if (pattern141 (x1, 
E_V512DFmode, 
E_V512SFmode) != 0)
                return -1;
              return 167;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern191 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 5
      || XINT (x3, 1) != 93)
    return -1;
  x4 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x3, 0, 4);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != MEM
      || GET_MODE (x6) != E_BLKmode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != SCRATCH)
    return -1;
  x8 = XVECEXP (x3, 0, 0);
  operands[0] = x8;
  x9 = XVECEXP (x3, 0, 1);
  operands[4] = x9;
  if (!vector_length_operand (operands[4], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 2);
  operands[5] = x10;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x2, 0, 1);
  operands[1] = x11;
  if (!pmode_reg_or_0_operand (operands[1], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x2, 0, 2);
  operands[2] = x12;
  x13 = XVECEXP (x2, 0, 3);
  operands[3] = x13;
  switch (GET_MODE (x3))
    {
    case E_RVVMF64BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF64BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF8QImode:
          return pattern185 (
E_RVVMF8QImode); /* [-1, 63] */

        case E_RVVMF4HImode:
          res = pattern185 (
E_RVVMF4HImode);
          if (res >= 0)
            return res + 64; /* [64, 127] */
          return -1;

        case E_RVVMF2SImode:
          res = pattern185 (
E_RVVMF2SImode);
          if (res >= 0)
            return res + 128; /* [128, 191] */
          return -1;

        case E_RVVM1DImode:
          res = pattern185 (
E_RVVM1DImode);
          if (res >= 0)
            return res + 192; /* [192, 255] */
          return -1;

        default:
          return -1;
        }

    case E_RVVMF32BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF32BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF4QImode:
          res = pattern186 (
E_RVVMF4QImode);
          if (res >= 0)
            return res + 256; /* [256, 311] */
          return -1;

        case E_RVVMF2HImode:
          res = pattern186 (
E_RVVMF2HImode);
          if (res >= 0)
            return res + 312; /* [312, 367] */
          return -1;

        case E_RVVM1SImode:
          res = pattern186 (
E_RVVM1SImode);
          if (res >= 0)
            return res + 368; /* [368, 423] */
          return -1;

        case E_RVVM2DImode:
          res = pattern186 (
E_RVVM2DImode);
          if (res >= 0)
            return res + 424; /* [424, 479] */
          return -1;

        default:
          return -1;
        }

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF16BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVMF2QImode:
          res = pattern187 (
E_RVVMF2QImode);
          if (res >= 0)
            return res + 480; /* [480, 523] */
          return -1;

        case E_RVVM1HImode:
          res = pattern187 (
E_RVVM1HImode);
          if (res >= 0)
            return res + 524; /* [524, 567] */
          return -1;

        case E_RVVM2SImode:
          res = pattern187 (
E_RVVM2SImode);
          if (res >= 0)
            return res + 568; /* [568, 611] */
          return -1;

        case E_RVVM4DImode:
          res = pattern187 (
E_RVVM4DImode);
          if (res >= 0)
            return res + 612; /* [612, 655] */
          return -1;

        default:
          return -1;
        }

    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM1QImode:
          res = pattern188 (
E_RVVM1QImode);
          if (res >= 0)
            return res + 656; /* [656, 681] */
          return -1;

        case E_RVVM2HImode:
          res = pattern188 (
E_RVVM2HImode);
          if (res >= 0)
            return res + 682; /* [682, 707] */
          return -1;

        case E_RVVM4SImode:
          res = pattern188 (
E_RVVM4SImode);
          if (res >= 0)
            return res + 708; /* [708, 733] */
          return -1;

        case E_RVVM8DImode:
          res = pattern188 (
E_RVVM8DImode);
          if (res >= 0)
            return res + 734; /* [734, 759] */
          return -1;

        default:
          return -1;
        }

    case E_RVVMF4BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM2QImode:
          res = pattern189 (
E_RVVM2QImode);
          if (res >= 0)
            return res + 760; /* [760, 771] */
          return -1;

        case E_RVVM4HImode:
          res = pattern189 (
E_RVVM4HImode);
          if (res >= 0)
            return res + 772; /* [772, 783] */
          return -1;

        case E_RVVM8SImode:
          res = pattern189 (
E_RVVM8SImode);
          if (res >= 0)
            return res + 784; /* [784, 795] */
          return -1;

        default:
          return -1;
        }

    case E_RVVMF2BImode:
      if (!vector_mask_operand (operands[0], E_RVVMF2BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_RVVM4QImode:
          res = pattern190 (
E_RVVM4QImode);
          if (res >= 0)
            return res + 796; /* [796, 800] */
          return -1;

        case E_RVVM8HImode:
          res = pattern190 (
E_RVVM8HImode);
          if (res >= 0)
            return res + 801; /* [801, 805] */
          return -1;

        default:
          return -1;
        }

    case E_RVVM1BImode:
      if (!vector_mask_operand (operands[0], E_RVVM1BImode)
          || !register_operand (operands[2], E_RVVM8QImode)
          || !register_operand (operands[3], E_RVVM8QImode))
        return -1;
      return 806;

    default:
      return -1;
    }
}

int
pattern217 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern218 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      return pattern217 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

    case E_RVVM4QImode:
      if (pattern217 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 1;

    case E_RVVM2QImode:
      if (pattern217 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 2;

    case E_RVVM1QImode:
      if (pattern217 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2QImode:
      if (pattern217 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4QImode:
      if (pattern217 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 5;

    case E_RVVMF8QImode:
      if (pattern217 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 6;

    case E_RVVM8HImode:
      if (pattern217 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
        return -1;
      return 7;

    case E_RVVM4HImode:
      if (pattern217 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 8;

    case E_RVVM2HImode:
      if (pattern217 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 9;

    case E_RVVM1HImode:
      if (pattern217 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 10;

    case E_RVVMF2HImode:
      if (pattern217 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 11;

    case E_RVVMF4HImode:
      if (pattern217 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 12;

    case E_RVVM8SImode:
      if (pattern217 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 13;

    case E_RVVM4SImode:
      if (pattern217 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 14;

    case E_RVVM2SImode:
      if (pattern217 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 15;

    case E_RVVM1SImode:
      if (pattern217 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 16;

    case E_RVVMF2SImode:
      if (pattern217 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 17;

    case E_RVVM8DImode:
      if (pattern217 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 18;

    case E_RVVM4DImode:
      if (pattern217 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 19;

    case E_RVVM2DImode:
      if (pattern217 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 20;

    case E_RVVM1DImode:
      if (pattern217 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 21;

    case E_V1QImode:
      if (pattern217 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
        return -1;
      return 22;

    case E_V2QImode:
      if (pattern217 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
        return -1;
      return 23;

    case E_V4QImode:
      if (pattern217 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
        return -1;
      return 24;

    case E_V8QImode:
      if (pattern217 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
        return -1;
      return 25;

    case E_V16QImode:
      if (pattern217 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
        return -1;
      return 26;

    case E_V32QImode:
      if (pattern217 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
        return -1;
      return 27;

    case E_V64QImode:
      if (pattern217 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
        return -1;
      return 28;

    case E_V128QImode:
      if (pattern217 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
        return -1;
      return 29;

    case E_V256QImode:
      if (pattern217 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
        return -1;
      return 30;

    case E_V512QImode:
      if (pattern217 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
        return -1;
      return 31;

    case E_V1024QImode:
      if (pattern217 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
        return -1;
      return 32;

    case E_V2048QImode:
      if (pattern217 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
        return -1;
      return 33;

    case E_V4096QImode:
      if (pattern217 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
        return -1;
      return 34;

    case E_V1HImode:
      if (pattern217 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
        return -1;
      return 35;

    case E_V2HImode:
      if (pattern217 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
        return -1;
      return 36;

    case E_V4HImode:
      if (pattern217 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
        return -1;
      return 37;

    case E_V8HImode:
      if (pattern217 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
        return -1;
      return 38;

    case E_V16HImode:
      if (pattern217 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
        return -1;
      return 39;

    case E_V32HImode:
      if (pattern217 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
        return -1;
      return 40;

    case E_V64HImode:
      if (pattern217 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
        return -1;
      return 41;

    case E_V128HImode:
      if (pattern217 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
        return -1;
      return 42;

    case E_V256HImode:
      if (pattern217 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
        return -1;
      return 43;

    case E_V512HImode:
      if (pattern217 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
        return -1;
      return 44;

    case E_V1024HImode:
      if (pattern217 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
        return -1;
      return 45;

    case E_V2048HImode:
      if (pattern217 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 46;

    case E_V1SImode:
      if (pattern217 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
        return -1;
      return 47;

    case E_V2SImode:
      if (pattern217 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
        return -1;
      return 48;

    case E_V4SImode:
      if (pattern217 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
        return -1;
      return 49;

    case E_V8SImode:
      if (pattern217 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
        return -1;
      return 50;

    case E_V16SImode:
      if (pattern217 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
        return -1;
      return 51;

    case E_V32SImode:
      if (pattern217 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
        return -1;
      return 52;

    case E_V64SImode:
      if (pattern217 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
        return -1;
      return 53;

    case E_V128SImode:
      if (pattern217 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
        return -1;
      return 54;

    case E_V256SImode:
      if (pattern217 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
        return -1;
      return 55;

    case E_V512SImode:
      if (pattern217 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
        return -1;
      return 56;

    case E_V1024SImode:
      if (pattern217 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 57;

    case E_V1DImode:
      if (pattern217 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 58;

    case E_V2DImode:
      if (pattern217 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 59;

    case E_V4DImode:
      if (pattern217 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 60;

    case E_V8DImode:
      if (pattern217 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 61;

    case E_V16DImode:
      if (pattern217 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 62;

    case E_V32DImode:
      if (pattern217 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 63;

    case E_V64DImode:
      if (pattern217 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 64;

    case E_V128DImode:
      if (pattern217 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 65;

    case E_V256DImode:
      if (pattern217 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 66;

    case E_V512DImode:
      if (pattern217 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 67;

    default:
      return -1;
    }
}

int
pattern233 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_arith_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern237 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 5
      || XINT (x3, 1) != 91
      || GET_MODE (x3) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!const_int_operand (operands[4], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x3, 0, 4);
  operands[5] = x8;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern242 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM8SFmode:
      if (!register_operand (operands[1], E_RVVM4HFmode))
        return -1;
      return 0;

    case E_RVVM4SFmode:
      if (!register_operand (operands[1], E_RVVM2HFmode))
        return -1;
      return 1;

    case E_RVVM2SFmode:
      if (!register_operand (operands[1], E_RVVM1HFmode))
        return -1;
      return 2;

    case E_RVVM1SFmode:
      if (!register_operand (operands[1], E_RVVMF2HFmode))
        return -1;
      return 3;

    case E_RVVMF2SFmode:
      if (!register_operand (operands[1], E_RVVMF4HFmode))
        return -1;
      return 4;

    case E_V1SFmode:
      if (!register_operand (operands[1], E_V1HFmode))
        return -1;
      return 5;

    case E_V2SFmode:
      if (!register_operand (operands[1], E_V2HFmode))
        return -1;
      return 6;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4HFmode))
        return -1;
      return 7;

    case E_V8SFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 8;

    case E_V16SFmode:
      if (!register_operand (operands[1], E_V16HFmode))
        return -1;
      return 9;

    case E_V32SFmode:
      if (!register_operand (operands[1], E_V32HFmode))
        return -1;
      return 10;

    case E_V64SFmode:
      if (!register_operand (operands[1], E_V64HFmode))
        return -1;
      return 11;

    case E_V128SFmode:
      if (!register_operand (operands[1], E_V128HFmode))
        return -1;
      return 12;

    case E_V256SFmode:
      if (!register_operand (operands[1], E_V256HFmode))
        return -1;
      return 13;

    case E_V512SFmode:
      if (!register_operand (operands[1], E_V512HFmode))
        return -1;
      return 14;

    case E_V1024SFmode:
      if (!register_operand (operands[1], E_V1024HFmode))
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern243 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_RVVM8DFmode:
      if (!register_operand (operands[1], E_RVVM4SFmode))
        return -1;
      return 0;

    case E_RVVM4DFmode:
      if (!register_operand (operands[1], E_RVVM2SFmode))
        return -1;
      return 1;

    case E_RVVM2DFmode:
      if (!register_operand (operands[1], E_RVVM1SFmode))
        return -1;
      return 2;

    case E_RVVM1DFmode:
      if (!register_operand (operands[1], E_RVVMF2SFmode))
        return -1;
      return 3;

    case E_V1DFmode:
      if (!register_operand (operands[1], E_V1SFmode))
        return -1;
      return 4;

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      return 5;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 6;

    case E_V8DFmode:
      if (!register_operand (operands[1], E_V8SFmode))
        return -1;
      return 7;

    case E_V16DFmode:
      if (!register_operand (operands[1], E_V16SFmode))
        return -1;
      return 8;

    case E_V32DFmode:
      if (!register_operand (operands[1], E_V32SFmode))
        return -1;
      return 9;

    case E_V64DFmode:
      if (!register_operand (operands[1], E_V64SFmode))
        return -1;
      return 10;

    case E_V128DFmode:
      if (!register_operand (operands[1], E_V128SFmode))
        return -1;
      return 11;

    case E_V256DFmode:
      if (!register_operand (operands[1], E_V256SFmode))
        return -1;
      return 12;

    case E_V512DFmode:
      if (!register_operand (operands[1], E_V512SFmode))
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern245 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8HImode:
          if (!register_operand (operands[1], E_RVVM4QImode))
            return -1;
          return 0;

        case E_RVVM4HImode:
          if (!register_operand (operands[1], E_RVVM2QImode))
            return -1;
          return 1;

        case E_RVVM2HImode:
          if (!register_operand (operands[1], E_RVVM1QImode))
            return -1;
          return 2;

        case E_RVVM1HImode:
          if (!register_operand (operands[1], E_RVVMF2QImode))
            return -1;
          return 3;

        case E_RVVMF2HImode:
          if (!register_operand (operands[1], E_RVVMF4QImode))
            return -1;
          return 4;

        case E_RVVMF4HImode:
          if (!register_operand (operands[1], E_RVVMF8QImode))
            return -1;
          return 5;

        case E_V1HImode:
          if (!register_operand (operands[1], E_V1QImode))
            return -1;
          return 6;

        case E_V2HImode:
          if (!register_operand (operands[1], E_V2QImode))
            return -1;
          return 7;

        case E_V4HImode:
          if (!register_operand (operands[1], E_V4QImode))
            return -1;
          return 8;

        case E_V8HImode:
          if (!register_operand (operands[1], E_V8QImode))
            return -1;
          return 9;

        case E_V16HImode:
          if (!register_operand (operands[1], E_V16QImode))
            return -1;
          return 10;

        case E_V32HImode:
          if (!register_operand (operands[1], E_V32QImode))
            return -1;
          return 11;

        case E_V64HImode:
          if (!register_operand (operands[1], E_V64QImode))
            return -1;
          return 12;

        case E_V128HImode:
          if (!register_operand (operands[1], E_V128QImode))
            return -1;
          return 13;

        case E_V256HImode:
          if (!register_operand (operands[1], E_V256QImode))
            return -1;
          return 14;

        case E_V512HImode:
          if (!register_operand (operands[1], E_V512QImode))
            return -1;
          return 15;

        case E_V1024HImode:
          if (!register_operand (operands[1], E_V1024QImode))
            return -1;
          return 16;

        case E_V2048HImode:
          if (!register_operand (operands[1], E_V2048QImode))
            return -1;
          return 17;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8SImode:
          if (!register_operand (operands[1], E_RVVM4HImode))
            return -1;
          return 18;

        case E_RVVM4SImode:
          if (!register_operand (operands[1], E_RVVM2HImode))
            return -1;
          return 19;

        case E_RVVM2SImode:
          if (!register_operand (operands[1], E_RVVM1HImode))
            return -1;
          return 20;

        case E_RVVM1SImode:
          if (!register_operand (operands[1], E_RVVMF2HImode))
            return -1;
          return 21;

        case E_RVVMF2SImode:
          if (!register_operand (operands[1], E_RVVMF4HImode))
            return -1;
          return 22;

        case E_V1SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V1HImode:
              if (!register_operand (operands[1], E_V1HImode))
                return -1;
              return 23;

            case E_V1SImode:
              if (!register_operand (operands[1], E_V1SImode))
                return -1;
              return 24;

            default:
              return -1;
            }

        case E_V2SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V2HImode:
              if (!register_operand (operands[1], E_V2HImode))
                return -1;
              return 25;

            case E_V2SImode:
              if (!register_operand (operands[1], E_V2SImode))
                return -1;
              return 26;

            default:
              return -1;
            }

        case E_V4SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V4HImode:
              if (!register_operand (operands[1], E_V4HImode))
                return -1;
              return 27;

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode))
                return -1;
              return 28;

            default:
              return -1;
            }

        case E_V8SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode))
                return -1;
              return 29;

            case E_V8SImode:
              if (!register_operand (operands[1], E_V8SImode))
                return -1;
              return 30;

            default:
              return -1;
            }

        case E_V16SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V16HImode:
              if (!register_operand (operands[1], E_V16HImode))
                return -1;
              return 31;

            case E_V16SImode:
              if (!register_operand (operands[1], E_V16SImode))
                return -1;
              return 32;

            default:
              return -1;
            }

        case E_V32SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V32HImode:
              if (!register_operand (operands[1], E_V32HImode))
                return -1;
              return 33;

            case E_V32SImode:
              if (!register_operand (operands[1], E_V32SImode))
                return -1;
              return 34;

            default:
              return -1;
            }

        case E_V64SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V64HImode:
              if (!register_operand (operands[1], E_V64HImode))
                return -1;
              return 35;

            case E_V64SImode:
              if (!register_operand (operands[1], E_V64SImode))
                return -1;
              return 36;

            default:
              return -1;
            }

        case E_V128SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V128HImode:
              if (!register_operand (operands[1], E_V128HImode))
                return -1;
              return 37;

            case E_V128SImode:
              if (!register_operand (operands[1], E_V128SImode))
                return -1;
              return 38;

            default:
              return -1;
            }

        case E_V256SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V256HImode:
              if (!register_operand (operands[1], E_V256HImode))
                return -1;
              return 39;

            case E_V256SImode:
              if (!register_operand (operands[1], E_V256SImode))
                return -1;
              return 40;

            default:
              return -1;
            }

        case E_V512SImode:
          switch (GET_MODE (operands[1]))
            {
            case E_V512HImode:
              if (!register_operand (operands[1], E_V512HImode))
                return -1;
              return 41;

            case E_V512SImode:
              if (!register_operand (operands[1], E_V512SImode))
                return -1;
              return 42;

            default:
              return -1;
            }

        case E_V1024SImode:
          if (!register_operand (operands[1], E_V1024HImode))
            return -1;
          return 43;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_RVVM8DImode:
          if (!register_operand (operands[1], E_RVVM4SImode))
            return -1;
          return 44;

        case E_RVVM4DImode:
          if (!register_operand (operands[1], E_RVVM2SImode))
            return -1;
          return 45;

        case E_RVVM2DImode:
          if (!register_operand (operands[1], E_RVVM1SImode))
            return -1;
          return 46;

        case E_RVVM1DImode:
          if (!register_operand (operands[1], E_RVVMF2SImode))
            return -1;
          return 47;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern252 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_0_3_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern254 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 4
      || XINT (x3, 1) != 93)
    return -1;
  x4 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 67
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 0);
  operands[4] = x7;
  if (!vector_length_operand (operands[4], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x3, 0, 1);
  operands[5] = x8;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return -1;
  x9 = XEXP (x2, 0);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[1] = x9;
      x10 = XEXP (x2, 1);
      operands[2] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM1BImode:
          return 0;

        case E_RVVMF2BImode:
          return 1;

        case E_RVVMF4BImode:
          return 2;

        case E_RVVMF8BImode:
          return 3;

        case E_RVVMF16BImode:
          return 4;

        case E_RVVMF32BImode:
          return 5;

        case E_RVVMF64BImode:
          return 6;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x10 = XEXP (x2, 1);
      operands[1] = x10;
      x11 = XEXP (x9, 0);
      switch (GET_CODE (x11))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[2] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM1BImode:
              return 7;

            case E_RVVMF2BImode:
              return 8;

            case E_RVVMF4BImode:
              return 9;

            case E_RVVMF8BImode:
              return 10;

            case E_RVVMF16BImode:
              return 11;

            case E_RVVMF32BImode:
              return 12;

            case E_RVVMF64BImode:
              return 13;

            case E_V1BImode:
              return 14;

            case E_V2BImode:
              return 15;

            case E_V4BImode:
              return 16;

            case E_V8BImode:
              return 17;

            case E_V16BImode:
              return 18;

            case E_V32BImode:
              return 19;

            case E_V64BImode:
              return 20;

            case E_V128BImode:
              return 21;

            case E_V256BImode:
              return 22;

            case E_V512BImode:
              return 23;

            case E_V1024BImode:
              return 24;

            case E_V2048BImode:
              return 25;

            case E_V4096BImode:
              return 26;

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x11) != E_DImode)
            return -1;
          x12 = XEXP (x11, 0);
          operands[2] = x12;
          if (!reg_or_0_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVMF8BImode:
              if (pattern253 (x1, 
E_RVVMF8BImode, 
E_RVVM8DImode) != 0)
                return -1;
              return 27;

            case E_RVVMF16BImode:
              if (pattern253 (x1, 
E_RVVMF16BImode, 
E_RVVM4DImode) != 0)
                return -1;
              return 28;

            case E_RVVMF32BImode:
              if (pattern253 (x1, 
E_RVVMF32BImode, 
E_RVVM2DImode) != 0)
                return -1;
              return 29;

            case E_RVVMF64BImode:
              if (pattern253 (x1, 
E_RVVMF64BImode, 
E_RVVM1DImode) != 0)
                return -1;
              return 30;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern261 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern262 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern261 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern261 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern265 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 66
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 67
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (!const_int_operand (x4, E_VOIDmode))
    return -1;
  return 0;
}

int
pattern267 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (XINT (x1, 1) != 93)
    return -1;
  x2 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 66
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 67
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern270 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[4] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND)
    return -1;
  return pattern121 (x1); /* [-1, 3] */
}

int
pattern272 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != USE)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 34
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern273 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 34
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 1
      || GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern277 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x9 = XEXP (x6, 1);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 0);
  operands[3] = x11;
  if (!scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern279 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case NOT:
      if (GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[1] = x1;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern280 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != ASHIFT
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x4, 0);
  return pattern279 (x6); /* [-1, 1] */
}

int
pattern283 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern287 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern291 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern293 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern297 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM4SImode)
      || GET_MODE (x1) != E_RVVM4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM2HImode:
      if (!register_operand (operands[1], E_RVVM2HImode))
        return -1;
      return 0;

    case E_RVVM1QImode:
      if (!register_operand (operands[1], E_RVVM1QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern302 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_RVVM4DImode)
      || GET_MODE (x1) != E_RVVM4DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_RVVM2SImode:
      if (!register_operand (operands[1], E_RVVM2SImode))
        return -1;
      return 0;

    case E_RVVM1HImode:
      if (!register_operand (operands[1], E_RVVM1HImode))
        return -1;
      return 1;

    case E_RVVMF2QImode:
      if (!register_operand (operands[1], E_RVVMF2QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern307 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      return 0;

    case E_V4QImode:
      if (!register_operand (operands[1], E_V4QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern312 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V128SImode)
      || GET_MODE (x1) != E_V128SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V128HImode:
      if (!register_operand (operands[1], E_V128HImode))
        return -1;
      return 0;

    case E_V128QImode:
      if (!register_operand (operands[1], E_V128QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern317 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!register_operand (operands[1], E_V2HImode))
        return -1;
      return 1;

    case E_V2QImode:
      if (!register_operand (operands[1], E_V2QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern322 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V64DImode)
      || GET_MODE (x1) != E_V64DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V64SImode:
      if (!register_operand (operands[1], E_V64SImode))
        return -1;
      return 0;

    case E_V64HImode:
      if (!register_operand (operands[1], E_V64HImode))
        return -1;
      return 1;

    case E_V64QImode:
      if (!register_operand (operands[1], E_V64QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern329 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 66
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 67
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern334 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern338 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern341 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case NOT:
      if (GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_SImode:
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!scratch_operand (operands[4], E_DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x1;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_SImode:
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!scratch_operand (operands[4], E_DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern347 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF2QImode:
      return pattern346 (
E_RVVMF2QImode); /* [-1, 1] */

    case E_RVVMF4QImode:
      res = pattern346 (
E_RVVMF4QImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case E_RVVMF8QImode:
      res = pattern346 (
E_RVVMF8QImode);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    case E_RVVMF2HImode:
      res = pattern346 (
E_RVVMF2HImode);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    case E_RVVMF4HImode:
      res = pattern346 (
E_RVVMF4HImode);
      if (res >= 0)
        return res + 8; /* [8, 9] */
      return -1;

    case E_RVVMF2BFmode:
      res = pattern346 (
E_RVVMF2BFmode);
      if (res >= 0)
        return res + 10; /* [10, 11] */
      return -1;

    case E_RVVMF4BFmode:
      res = pattern346 (
E_RVVMF4BFmode);
      if (res >= 0)
        return res + 12; /* [12, 13] */
      return -1;

    case E_RVVMF2HFmode:
      res = pattern346 (
E_RVVMF2HFmode);
      if (res >= 0)
        return res + 14; /* [14, 15] */
      return -1;

    case E_RVVMF4HFmode:
      res = pattern346 (
E_RVVMF4HFmode);
      if (res >= 0)
        return res + 16; /* [16, 17] */
      return -1;

    case E_RVVMF2SImode:
      res = pattern346 (
E_RVVMF2SImode);
      if (res >= 0)
        return res + 18; /* [18, 19] */
      return -1;

    case E_RVVMF2SFmode:
      res = pattern346 (
E_RVVMF2SFmode);
      if (res >= 0)
        return res + 20; /* [20, 21] */
      return -1;

    case E_RVVMF64BImode:
      res = pattern346 (
E_RVVMF64BImode);
      if (res >= 0)
        return res + 22; /* [22, 23] */
      return -1;

    case E_RVVMF32BImode:
      res = pattern346 (
E_RVVMF32BImode);
      if (res >= 0)
        return res + 24; /* [24, 25] */
      return -1;

    case E_RVVMF16BImode:
      res = pattern346 (
E_RVVMF16BImode);
      if (res >= 0)
        return res + 26; /* [26, 27] */
      return -1;

    case E_RVVMF8BImode:
      res = pattern346 (
E_RVVMF8BImode);
      if (res >= 0)
        return res + 28; /* [28, 29] */
      return -1;

    case E_RVVMF4BImode:
      res = pattern346 (
E_RVVMF4BImode);
      if (res >= 0)
        return res + 30; /* [30, 31] */
      return -1;

    case E_RVVMF2BImode:
      res = pattern346 (
E_RVVMF2BImode);
      if (res >= 0)
        return res + 32; /* [32, 33] */
      return -1;

    case E_RVVM1BImode:
      res = pattern346 (
E_RVVM1BImode);
      if (res >= 0)
        return res + 34; /* [34, 35] */
      return -1;

    case E_V32QImode:
      res = pattern346 (
E_V32QImode);
      if (res >= 0)
        return res + 36; /* [36, 37] */
      return -1;

    case E_V64QImode:
      res = pattern346 (
E_V64QImode);
      if (res >= 0)
        return res + 38; /* [38, 39] */
      return -1;

    case E_V128QImode:
      res = pattern346 (
E_V128QImode);
      if (res >= 0)
        return res + 40; /* [40, 41] */
      return -1;

    case E_V256QImode:
      res = pattern346 (
E_V256QImode);
      if (res >= 0)
        return res + 42; /* [42, 43] */
      return -1;

    case E_V512QImode:
      res = pattern346 (
E_V512QImode);
      if (res >= 0)
        return res + 44; /* [44, 45] */
      return -1;

    case E_V1024QImode:
      res = pattern346 (
E_V1024QImode);
      if (res >= 0)
        return res + 46; /* [46, 47] */
      return -1;

    case E_V2048QImode:
      res = pattern346 (
E_V2048QImode);
      if (res >= 0)
        return res + 48; /* [48, 49] */
      return -1;

    case E_V4096QImode:
      res = pattern346 (
E_V4096QImode);
      if (res >= 0)
        return res + 50; /* [50, 51] */
      return -1;

    case E_V32HImode:
      res = pattern346 (
E_V32HImode);
      if (res >= 0)
        return res + 52; /* [52, 53] */
      return -1;

    case E_V64HImode:
      res = pattern346 (
E_V64HImode);
      if (res >= 0)
        return res + 54; /* [54, 55] */
      return -1;

    case E_V128HImode:
      res = pattern346 (
E_V128HImode);
      if (res >= 0)
        return res + 56; /* [56, 57] */
      return -1;

    case E_V256HImode:
      res = pattern346 (
E_V256HImode);
      if (res >= 0)
        return res + 58; /* [58, 59] */
      return -1;

    case E_V512HImode:
      res = pattern346 (
E_V512HImode);
      if (res >= 0)
        return res + 60; /* [60, 61] */
      return -1;

    case E_V1024HImode:
      res = pattern346 (
E_V1024HImode);
      if (res >= 0)
        return res + 62; /* [62, 63] */
      return -1;

    case E_V2048HImode:
      res = pattern346 (
E_V2048HImode);
      if (res >= 0)
        return res + 64; /* [64, 65] */
      return -1;

    case E_V32SImode:
      res = pattern346 (
E_V32SImode);
      if (res >= 0)
        return res + 66; /* [66, 67] */
      return -1;

    case E_V64SImode:
      res = pattern346 (
E_V64SImode);
      if (res >= 0)
        return res + 68; /* [68, 69] */
      return -1;

    case E_V128SImode:
      res = pattern346 (
E_V128SImode);
      if (res >= 0)
        return res + 70; /* [70, 71] */
      return -1;

    case E_V256SImode:
      res = pattern346 (
E_V256SImode);
      if (res >= 0)
        return res + 72; /* [72, 73] */
      return -1;

    case E_V512SImode:
      res = pattern346 (
E_V512SImode);
      if (res >= 0)
        return res + 74; /* [74, 75] */
      return -1;

    case E_V1024SImode:
      res = pattern346 (
E_V1024SImode);
      if (res >= 0)
        return res + 76; /* [76, 77] */
      return -1;

    case E_V32DImode:
      res = pattern346 (
E_V32DImode);
      if (res >= 0)
        return res + 78; /* [78, 79] */
      return -1;

    case E_V64DImode:
      res = pattern346 (
E_V64DImode);
      if (res >= 0)
        return res + 80; /* [80, 81] */
      return -1;

    case E_V128DImode:
      res = pattern346 (
E_V128DImode);
      if (res >= 0)
        return res + 82; /* [82, 83] */
      return -1;

    case E_V256DImode:
      res = pattern346 (
E_V256DImode);
      if (res >= 0)
        return res + 84; /* [84, 85] */
      return -1;

    case E_V512DImode:
      res = pattern346 (
E_V512DImode);
      if (res >= 0)
        return res + 86; /* [86, 87] */
      return -1;

    case E_V32HFmode:
      res = pattern346 (
E_V32HFmode);
      if (res >= 0)
        return res + 88; /* [88, 89] */
      return -1;

    case E_V64HFmode:
      res = pattern346 (
E_V64HFmode);
      if (res >= 0)
        return res + 90; /* [90, 91] */
      return -1;

    case E_V128HFmode:
      res = pattern346 (
E_V128HFmode);
      if (res >= 0)
        return res + 92; /* [92, 93] */
      return -1;

    case E_V256HFmode:
      res = pattern346 (
E_V256HFmode);
      if (res >= 0)
        return res + 94; /* [94, 95] */
      return -1;

    case E_V512HFmode:
      res = pattern346 (
E_V512HFmode);
      if (res >= 0)
        return res + 96; /* [96, 97] */
      return -1;

    case E_V1024HFmode:
      res = pattern346 (
E_V1024HFmode);
      if (res >= 0)
        return res + 98; /* [98, 99] */
      return -1;

    case E_V2048HFmode:
      res = pattern346 (
E_V2048HFmode);
      if (res >= 0)
        return res + 100; /* [100, 101] */
      return -1;

    case E_V32SFmode:
      res = pattern346 (
E_V32SFmode);
      if (res >= 0)
        return res + 102; /* [102, 103] */
      return -1;

    case E_V64SFmode:
      res = pattern346 (
E_V64SFmode);
      if (res >= 0)
        return res + 104; /* [104, 105] */
      return -1;

    case E_V128SFmode:
      res = pattern346 (
E_V128SFmode);
      if (res >= 0)
        return res + 106; /* [106, 107] */
      return -1;

    case E_V256SFmode:
      res = pattern346 (
E_V256SFmode);
      if (res >= 0)
        return res + 108; /* [108, 109] */
      return -1;

    case E_V512SFmode:
      res = pattern346 (
E_V512SFmode);
      if (res >= 0)
        return res + 110; /* [110, 111] */
      return -1;

    case E_V1024SFmode:
      res = pattern346 (
E_V1024SFmode);
      if (res >= 0)
        return res + 112; /* [112, 113] */
      return -1;

    case E_V32DFmode:
      res = pattern346 (
E_V32DFmode);
      if (res >= 0)
        return res + 114; /* [114, 115] */
      return -1;

    case E_V64DFmode:
      res = pattern346 (
E_V64DFmode);
      if (res >= 0)
        return res + 116; /* [116, 117] */
      return -1;

    case E_V128DFmode:
      res = pattern346 (
E_V128DFmode);
      if (res >= 0)
        return res + 118; /* [118, 119] */
      return -1;

    case E_V256DFmode:
      res = pattern346 (
E_V256DFmode);
      if (res >= 0)
        return res + 120; /* [120, 121] */
      return -1;

    case E_V512DFmode:
      res = pattern346 (
E_V512DFmode);
      if (res >= 0)
        return res + 122; /* [122, 123] */
      return -1;

    case E_V32BImode:
      res = pattern346 (
E_V32BImode);
      if (res >= 0)
        return res + 124; /* [124, 125] */
      return -1;

    case E_V64BImode:
      res = pattern346 (
E_V64BImode);
      if (res >= 0)
        return res + 126; /* [126, 127] */
      return -1;

    case E_V128BImode:
      res = pattern346 (
E_V128BImode);
      if (res >= 0)
        return res + 128; /* [128, 129] */
      return -1;

    case E_V256BImode:
      res = pattern346 (
E_V256BImode);
      if (res >= 0)
        return res + 130; /* [130, 131] */
      return -1;

    case E_V512BImode:
      res = pattern346 (
E_V512BImode);
      if (res >= 0)
        return res + 132; /* [132, 133] */
      return -1;

    case E_V1024BImode:
      res = pattern346 (
E_V1024BImode);
      if (res >= 0)
        return res + 134; /* [134, 135] */
      return -1;

    case E_V2048BImode:
      res = pattern346 (
E_V2048BImode);
      if (res >= 0)
        return res + 136; /* [136, 137] */
      return -1;

    case E_V4096BImode:
      res = pattern346 (
E_V4096BImode);
      if (res >= 0)
        return res + 138; /* [138, 139] */
      return -1;

    default:
      return -1;
    }
}

int
pattern412 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !memory_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern416 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !memory_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern420 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != AND
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ASHIFT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return 0;
}

int
pattern426 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern431 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  if (!equality_operator (operands[1], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x5, 1);
  operands[3] = x7;
  x8 = XEXP (x4, 1);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[0] = x10;
  x11 = XVECEXP (x1, 0, 1);
  x12 = XEXP (x11, 0);
  operands[5] = x12;
  x13 = XVECEXP (x1, 0, 2);
  x14 = XEXP (x13, 0);
  operands[6] = x14;
  switch (GET_MODE (x5))
    {
    case E_SImode:
      return pattern430 (
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern430 (
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern442 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[5] = x4;
  if (!vector_length_operand (operands[5], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[6] = x5;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XEXP (x1, 2);
  operands[2] = x8;
  x9 = XEXP (x6, 1);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[4] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVMF64BImode:
          return pattern440 (x1, 
E_RVVMF64BImode); /* [-1, 0] */

        case E_RVVMF32BImode:
          if (pattern440 (x1, 
E_RVVMF32BImode) != 0)
            return -1;
          return 1;

        case E_RVVMF16BImode:
          if (pattern440 (x1, 
E_RVVMF16BImode) != 0)
            return -1;
          return 2;

        case E_RVVMF8BImode:
          if (pattern440 (x1, 
E_RVVMF8BImode) != 0)
            return -1;
          return 3;

        case E_RVVMF4BImode:
          if (pattern440 (x1, 
E_RVVMF4BImode) != 0)
            return -1;
          return 4;

        case E_RVVMF2BImode:
          if (pattern440 (x1, 
E_RVVMF2BImode) != 0)
            return -1;
          return 5;

        case E_RVVM1BImode:
          if (pattern440 (x1, 
E_RVVM1BImode) != 0)
            return -1;
          return 6;

        case E_V1BImode:
          if (pattern440 (x1, 
E_V1BImode) != 0)
            return -1;
          return 7;

        case E_V2BImode:
          if (pattern440 (x1, 
E_V2BImode) != 0)
            return -1;
          return 8;

        case E_V4BImode:
          if (pattern440 (x1, 
E_V4BImode) != 0)
            return -1;
          return 9;

        case E_V8BImode:
          if (pattern440 (x1, 
E_V8BImode) != 0)
            return -1;
          return 10;

        case E_V16BImode:
          if (pattern440 (x1, 
E_V16BImode) != 0)
            return -1;
          return 11;

        case E_V32BImode:
          if (pattern440 (x1, 
E_V32BImode) != 0)
            return -1;
          return 12;

        case E_V64BImode:
          if (pattern440 (x1, 
E_V64BImode) != 0)
            return -1;
          return 13;

        case E_V128BImode:
          if (pattern440 (x1, 
E_V128BImode) != 0)
            return -1;
          return 14;

        case E_V256BImode:
          if (pattern440 (x1, 
E_V256BImode) != 0)
            return -1;
          return 15;

        case E_V512BImode:
          if (pattern440 (x1, 
E_V512BImode) != 0)
            return -1;
          return 16;

        case E_V1024BImode:
          if (pattern440 (x1, 
E_V1024BImode) != 0)
            return -1;
          return 17;

        case E_V2048BImode:
          if (pattern440 (x1, 
E_V2048BImode) != 0)
            return -1;
          return 18;

        case E_V4096BImode:
          if (pattern440 (x1, 
E_V4096BImode) != 0)
            return -1;
          return 19;

        default:
          return -1;
        }

    case NOT:
      x10 = XEXP (x9, 0);
      operands[4] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVMF64BImode:
          if (pattern441 (x1, 
E_RVVMF64BImode) != 0)
            return -1;
          return 20;

        case E_RVVMF32BImode:
          if (pattern441 (x1, 
E_RVVMF32BImode) != 0)
            return -1;
          return 21;

        case E_RVVMF16BImode:
          if (pattern441 (x1, 
E_RVVMF16BImode) != 0)
            return -1;
          return 22;

        case E_RVVMF8BImode:
          if (pattern441 (x1, 
E_RVVMF8BImode) != 0)
            return -1;
          return 23;

        case E_RVVMF4BImode:
          if (pattern441 (x1, 
E_RVVMF4BImode) != 0)
            return -1;
          return 24;

        case E_RVVMF2BImode:
          if (pattern441 (x1, 
E_RVVMF2BImode) != 0)
            return -1;
          return 25;

        case E_RVVM1BImode:
          if (pattern441 (x1, 
E_RVVM1BImode) != 0)
            return -1;
          return 26;

        case E_V1BImode:
          if (pattern441 (x1, 
E_V1BImode) != 0)
            return -1;
          return 27;

        case E_V2BImode:
          if (pattern441 (x1, 
E_V2BImode) != 0)
            return -1;
          return 28;

        case E_V4BImode:
          if (pattern441 (x1, 
E_V4BImode) != 0)
            return -1;
          return 29;

        case E_V8BImode:
          if (pattern441 (x1, 
E_V8BImode) != 0)
            return -1;
          return 30;

        case E_V16BImode:
          if (pattern441 (x1, 
E_V16BImode) != 0)
            return -1;
          return 31;

        case E_V32BImode:
          if (pattern441 (x1, 
E_V32BImode) != 0)
            return -1;
          return 32;

        case E_V64BImode:
          if (pattern441 (x1, 
E_V64BImode) != 0)
            return -1;
          return 33;

        case E_V128BImode:
          if (pattern441 (x1, 
E_V128BImode) != 0)
            return -1;
          return 34;

        case E_V256BImode:
          if (pattern441 (x1, 
E_V256BImode) != 0)
            return -1;
          return 35;

        case E_V512BImode:
          if (pattern441 (x1, 
E_V512BImode) != 0)
            return -1;
          return 36;

        case E_V1024BImode:
          if (pattern441 (x1, 
E_V1024BImode) != 0)
            return -1;
          return 37;

        case E_V2048BImode:
          if (pattern441 (x1, 
E_V2048BImode) != 0)
            return -1;
          return 38;

        case E_V4096BImode:
          if (pattern441 (x1, 
E_V4096BImode) != 0)
            return -1;
          return 39;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern482 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern484 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_all_trues_mask_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1)
      || !vector_undef_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern485 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF64BImode:
      return pattern484 (x1, 
E_RVVMF64BImode); /* [-1, 0] */

    case E_RVVMF32BImode:
      if (pattern484 (x1, 
E_RVVMF32BImode) != 0)
        return -1;
      return 1;

    case E_RVVMF16BImode:
      if (pattern484 (x1, 
E_RVVMF16BImode) != 0)
        return -1;
      return 2;

    case E_RVVMF8BImode:
      if (pattern484 (x1, 
E_RVVMF8BImode) != 0)
        return -1;
      return 3;

    case E_RVVMF4BImode:
      if (pattern484 (x1, 
E_RVVMF4BImode) != 0)
        return -1;
      return 4;

    case E_RVVMF2BImode:
      if (pattern484 (x1, 
E_RVVMF2BImode) != 0)
        return -1;
      return 5;

    case E_RVVM1BImode:
      if (pattern484 (x1, 
E_RVVM1BImode) != 0)
        return -1;
      return 6;

    case E_V1BImode:
      if (pattern484 (x1, 
E_V1BImode) != 0)
        return -1;
      return 7;

    case E_V2BImode:
      if (pattern484 (x1, 
E_V2BImode) != 0)
        return -1;
      return 8;

    case E_V4BImode:
      if (pattern484 (x1, 
E_V4BImode) != 0)
        return -1;
      return 9;

    case E_V8BImode:
      if (pattern484 (x1, 
E_V8BImode) != 0)
        return -1;
      return 10;

    case E_V16BImode:
      if (pattern484 (x1, 
E_V16BImode) != 0)
        return -1;
      return 11;

    case E_V32BImode:
      if (pattern484 (x1, 
E_V32BImode) != 0)
        return -1;
      return 12;

    case E_V64BImode:
      if (pattern484 (x1, 
E_V64BImode) != 0)
        return -1;
      return 13;

    case E_V128BImode:
      if (pattern484 (x1, 
E_V128BImode) != 0)
        return -1;
      return 14;

    case E_V256BImode:
      if (pattern484 (x1, 
E_V256BImode) != 0)
        return -1;
      return 15;

    case E_V512BImode:
      if (pattern484 (x1, 
E_V512BImode) != 0)
        return -1;
      return 16;

    case E_V1024BImode:
      if (pattern484 (x1, 
E_V1024BImode) != 0)
        return -1;
      return 17;

    case E_V2048BImode:
      if (pattern484 (x1, 
E_V2048BImode) != 0)
        return -1;
      return 18;

    case E_V4096BImode:
      if (pattern484 (x1, 
E_V4096BImode) != 0)
        return -1;
      return 19;

    default:
      return -1;
    }
}

int
pattern493 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern495 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern497 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 2);
  operands[2] = x7;
  x8 = XEXP (x1, 1);
  x9 = XEXP (x8, 0);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[3] = x9;
      x10 = XEXP (x8, 1);
      operands[4] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          return pattern495 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode); /* [-1, 0] */

        case E_RVVM4QImode:
          if (pattern495 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2QImode:
          if (pattern495 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1QImode:
          if (pattern495 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 3;

        case E_RVVM8HImode:
          if (pattern495 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 4;

        case E_RVVM4HImode:
          if (pattern495 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 5;

        case E_RVVM2HImode:
          if (pattern495 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 6;

        case E_RVVM1HImode:
          if (pattern495 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 7;

        case E_RVVM8SImode:
          if (pattern495 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 8;

        case E_RVVM4SImode:
          if (pattern495 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 9;

        case E_RVVM2SImode:
          if (pattern495 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 10;

        case E_RVVM1SImode:
          if (pattern495 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 11;

        case E_RVVM8DImode:
          if (pattern495 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 12;

        case E_RVVM4DImode:
          if (pattern495 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 13;

        case E_RVVM2DImode:
          if (pattern495 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 14;

        case E_RVVM1DImode:
          if (pattern495 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 15;

        case E_RVVMF2QImode:
          if (pattern495 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 16;

        case E_RVVMF4QImode:
          if (pattern495 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 17;

        case E_RVVMF8QImode:
          if (pattern495 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 18;

        case E_RVVMF2HImode:
          if (pattern495 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 19;

        case E_RVVMF4HImode:
          if (pattern495 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 20;

        case E_RVVMF2SImode:
          if (pattern495 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 21;

        case E_V1QImode:
          if (pattern495 (x1, 
E_V1QImode, 
E_V1BImode) != 0)
            return -1;
          return 22;

        case E_V2QImode:
          if (pattern495 (x1, 
E_V2QImode, 
E_V2BImode) != 0)
            return -1;
          return 23;

        case E_V4QImode:
          if (pattern495 (x1, 
E_V4QImode, 
E_V4BImode) != 0)
            return -1;
          return 24;

        case E_V8QImode:
          if (pattern495 (x1, 
E_V8QImode, 
E_V8BImode) != 0)
            return -1;
          return 25;

        case E_V16QImode:
          if (pattern495 (x1, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 26;

        case E_V32QImode:
          if (pattern495 (x1, 
E_V32QImode, 
E_V32BImode) != 0)
            return -1;
          return 27;

        case E_V64QImode:
          if (pattern495 (x1, 
E_V64QImode, 
E_V64BImode) != 0)
            return -1;
          return 28;

        case E_V128QImode:
          if (pattern495 (x1, 
E_V128QImode, 
E_V128BImode) != 0)
            return -1;
          return 29;

        case E_V256QImode:
          if (pattern495 (x1, 
E_V256QImode, 
E_V256BImode) != 0)
            return -1;
          return 30;

        case E_V512QImode:
          if (pattern495 (x1, 
E_V512QImode, 
E_V512BImode) != 0)
            return -1;
          return 31;

        case E_V1024QImode:
          if (pattern495 (x1, 
E_V1024QImode, 
E_V1024BImode) != 0)
            return -1;
          return 32;

        case E_V2048QImode:
          if (pattern495 (x1, 
E_V2048QImode, 
E_V2048BImode) != 0)
            return -1;
          return 33;

        case E_V4096QImode:
          if (pattern495 (x1, 
E_V4096QImode, 
E_V4096BImode) != 0)
            return -1;
          return 34;

        case E_V1HImode:
          if (pattern495 (x1, 
E_V1HImode, 
E_V1BImode) != 0)
            return -1;
          return 35;

        case E_V2HImode:
          if (pattern495 (x1, 
E_V2HImode, 
E_V2BImode) != 0)
            return -1;
          return 36;

        case E_V4HImode:
          if (pattern495 (x1, 
E_V4HImode, 
E_V4BImode) != 0)
            return -1;
          return 37;

        case E_V8HImode:
          if (pattern495 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 38;

        case E_V16HImode:
          if (pattern495 (x1, 
E_V16HImode, 
E_V16BImode) != 0)
            return -1;
          return 39;

        case E_V32HImode:
          if (pattern495 (x1, 
E_V32HImode, 
E_V32BImode) != 0)
            return -1;
          return 40;

        case E_V64HImode:
          if (pattern495 (x1, 
E_V64HImode, 
E_V64BImode) != 0)
            return -1;
          return 41;

        case E_V128HImode:
          if (pattern495 (x1, 
E_V128HImode, 
E_V128BImode) != 0)
            return -1;
          return 42;

        case E_V256HImode:
          if (pattern495 (x1, 
E_V256HImode, 
E_V256BImode) != 0)
            return -1;
          return 43;

        case E_V512HImode:
          if (pattern495 (x1, 
E_V512HImode, 
E_V512BImode) != 0)
            return -1;
          return 44;

        case E_V1024HImode:
          if (pattern495 (x1, 
E_V1024HImode, 
E_V1024BImode) != 0)
            return -1;
          return 45;

        case E_V2048HImode:
          if (pattern495 (x1, 
E_V2048HImode, 
E_V2048BImode) != 0)
            return -1;
          return 46;

        case E_V1SImode:
          if (pattern495 (x1, 
E_V1SImode, 
E_V1BImode) != 0)
            return -1;
          return 47;

        case E_V2SImode:
          if (pattern495 (x1, 
E_V2SImode, 
E_V2BImode) != 0)
            return -1;
          return 48;

        case E_V4SImode:
          if (pattern495 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 49;

        case E_V8SImode:
          if (pattern495 (x1, 
E_V8SImode, 
E_V8BImode) != 0)
            return -1;
          return 50;

        case E_V16SImode:
          if (pattern495 (x1, 
E_V16SImode, 
E_V16BImode) != 0)
            return -1;
          return 51;

        case E_V32SImode:
          if (pattern495 (x1, 
E_V32SImode, 
E_V32BImode) != 0)
            return -1;
          return 52;

        case E_V64SImode:
          if (pattern495 (x1, 
E_V64SImode, 
E_V64BImode) != 0)
            return -1;
          return 53;

        case E_V128SImode:
          if (pattern495 (x1, 
E_V128SImode, 
E_V128BImode) != 0)
            return -1;
          return 54;

        case E_V256SImode:
          if (pattern495 (x1, 
E_V256SImode, 
E_V256BImode) != 0)
            return -1;
          return 55;

        case E_V512SImode:
          if (pattern495 (x1, 
E_V512SImode, 
E_V512BImode) != 0)
            return -1;
          return 56;

        case E_V1024SImode:
          if (pattern495 (x1, 
E_V1024SImode, 
E_V1024BImode) != 0)
            return -1;
          return 57;

        case E_V1DImode:
          if (pattern495 (x1, 
E_V1DImode, 
E_V1BImode) != 0)
            return -1;
          return 58;

        case E_V2DImode:
          if (pattern495 (x1, 
E_V2DImode, 
E_V2BImode) != 0)
            return -1;
          return 59;

        case E_V4DImode:
          if (pattern495 (x1, 
E_V4DImode, 
E_V4BImode) != 0)
            return -1;
          return 60;

        case E_V8DImode:
          if (pattern495 (x1, 
E_V8DImode, 
E_V8BImode) != 0)
            return -1;
          return 61;

        case E_V16DImode:
          if (pattern495 (x1, 
E_V16DImode, 
E_V16BImode) != 0)
            return -1;
          return 62;

        case E_V32DImode:
          if (pattern495 (x1, 
E_V32DImode, 
E_V32BImode) != 0)
            return -1;
          return 63;

        case E_V64DImode:
          if (pattern495 (x1, 
E_V64DImode, 
E_V64BImode) != 0)
            return -1;
          return 64;

        case E_V128DImode:
          if (pattern495 (x1, 
E_V128DImode, 
E_V128BImode) != 0)
            return -1;
          return 65;

        case E_V256DImode:
          if (pattern495 (x1, 
E_V256DImode, 
E_V256BImode) != 0)
            return -1;
          return 66;

        case E_V512DImode:
          if (pattern495 (x1, 
E_V512DImode, 
E_V512BImode) != 0)
            return -1;
          return 67;

        case E_RVVM8HFmode:
          if (pattern495 (x1, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0)
            return -1;
          return 68;

        case E_RVVM4HFmode:
          if (pattern495 (x1, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 69;

        case E_RVVM2HFmode:
          if (pattern495 (x1, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 70;

        case E_RVVM1HFmode:
          if (pattern495 (x1, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 71;

        case E_RVVMF2HFmode:
          if (pattern495 (x1, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 72;

        case E_RVVMF4HFmode:
          if (pattern495 (x1, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 73;

        case E_RVVM8SFmode:
          if (pattern495 (x1, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
            return -1;
          return 74;

        case E_RVVM4SFmode:
          if (pattern495 (x1, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 75;

        case E_RVVM2SFmode:
          if (pattern495 (x1, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 76;

        case E_RVVM1SFmode:
          if (pattern495 (x1, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 77;

        case E_RVVMF2SFmode:
          if (pattern495 (x1, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 78;

        case E_RVVM8DFmode:
          if (pattern495 (x1, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0)
            return -1;
          return 79;

        case E_RVVM4DFmode:
          if (pattern495 (x1, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 80;

        case E_RVVM2DFmode:
          if (pattern495 (x1, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 81;

        case E_RVVM1DFmode:
          if (pattern495 (x1, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 82;

        case E_V1HFmode:
          if (pattern495 (x1, 
E_V1HFmode, 
E_V1BImode) != 0)
            return -1;
          return 83;

        case E_V2HFmode:
          if (pattern495 (x1, 
E_V2HFmode, 
E_V2BImode) != 0)
            return -1;
          return 84;

        case E_V4HFmode:
          if (pattern495 (x1, 
E_V4HFmode, 
E_V4BImode) != 0)
            return -1;
          return 85;

        case E_V8HFmode:
          if (pattern495 (x1, 
E_V8HFmode, 
E_V8BImode) != 0)
            return -1;
          return 86;

        case E_V16HFmode:
          if (pattern495 (x1, 
E_V16HFmode, 
E_V16BImode) != 0)
            return -1;
          return 87;

        case E_V32HFmode:
          if (pattern495 (x1, 
E_V32HFmode, 
E_V32BImode) != 0)
            return -1;
          return 88;

        case E_V64HFmode:
          if (pattern495 (x1, 
E_V64HFmode, 
E_V64BImode) != 0)
            return -1;
          return 89;

        case E_V128HFmode:
          if (pattern495 (x1, 
E_V128HFmode, 
E_V128BImode) != 0)
            return -1;
          return 90;

        case E_V256HFmode:
          if (pattern495 (x1, 
E_V256HFmode, 
E_V256BImode) != 0)
            return -1;
          return 91;

        case E_V512HFmode:
          if (pattern495 (x1, 
E_V512HFmode, 
E_V512BImode) != 0)
            return -1;
          return 92;

        case E_V1024HFmode:
          if (pattern495 (x1, 
E_V1024HFmode, 
E_V1024BImode) != 0)
            return -1;
          return 93;

        case E_V2048HFmode:
          if (pattern495 (x1, 
E_V2048HFmode, 
E_V2048BImode) != 0)
            return -1;
          return 94;

        case E_V1SFmode:
          if (pattern495 (x1, 
E_V1SFmode, 
E_V1BImode) != 0)
            return -1;
          return 95;

        case E_V2SFmode:
          if (pattern495 (x1, 
E_V2SFmode, 
E_V2BImode) != 0)
            return -1;
          return 96;

        case E_V4SFmode:
          if (pattern495 (x1, 
E_V4SFmode, 
E_V4BImode) != 0)
            return -1;
          return 97;

        case E_V8SFmode:
          if (pattern495 (x1, 
E_V8SFmode, 
E_V8BImode) != 0)
            return -1;
          return 98;

        case E_V16SFmode:
          if (pattern495 (x1, 
E_V16SFmode, 
E_V16BImode) != 0)
            return -1;
          return 99;

        case E_V32SFmode:
          if (pattern495 (x1, 
E_V32SFmode, 
E_V32BImode) != 0)
            return -1;
          return 100;

        case E_V64SFmode:
          if (pattern495 (x1, 
E_V64SFmode, 
E_V64BImode) != 0)
            return -1;
          return 101;

        case E_V128SFmode:
          if (pattern495 (x1, 
E_V128SFmode, 
E_V128BImode) != 0)
            return -1;
          return 102;

        case E_V256SFmode:
          if (pattern495 (x1, 
E_V256SFmode, 
E_V256BImode) != 0)
            return -1;
          return 103;

        case E_V512SFmode:
          if (pattern495 (x1, 
E_V512SFmode, 
E_V512BImode) != 0)
            return -1;
          return 104;

        case E_V1024SFmode:
          if (pattern495 (x1, 
E_V1024SFmode, 
E_V1024BImode) != 0)
            return -1;
          return 105;

        case E_V1DFmode:
          if (pattern495 (x1, 
E_V1DFmode, 
E_V1BImode) != 0)
            return -1;
          return 106;

        case E_V2DFmode:
          if (pattern495 (x1, 
E_V2DFmode, 
E_V2BImode) != 0)
            return -1;
          return 107;

        case E_V4DFmode:
          if (pattern495 (x1, 
E_V4DFmode, 
E_V4BImode) != 0)
            return -1;
          return 108;

        case E_V8DFmode:
          if (pattern495 (x1, 
E_V8DFmode, 
E_V8BImode) != 0)
            return -1;
          return 109;

        case E_V16DFmode:
          if (pattern495 (x1, 
E_V16DFmode, 
E_V16BImode) != 0)
            return -1;
          return 110;

        case E_V32DFmode:
          if (pattern495 (x1, 
E_V32DFmode, 
E_V32BImode) != 0)
            return -1;
          return 111;

        case E_V64DFmode:
          if (pattern495 (x1, 
E_V64DFmode, 
E_V64BImode) != 0)
            return -1;
          return 112;

        case E_V128DFmode:
          if (pattern495 (x1, 
E_V128DFmode, 
E_V128BImode) != 0)
            return -1;
          return 113;

        case E_V256DFmode:
          if (pattern495 (x1, 
E_V256DFmode, 
E_V256BImode) != 0)
            return -1;
          return 114;

        case E_V512DFmode:
          if (pattern495 (x1, 
E_V512DFmode, 
E_V512BImode) != 0)
            return -1;
          return 115;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x10 = XEXP (x8, 1);
      operands[3] = x10;
      x11 = XEXP (x9, 0);
      switch (GET_CODE (x11))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[4] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8QImode:
              if (pattern488 (x1, 
E_RVVM8QImode, 
E_RVVM1BImode, 
E_QImode) != 0)
                return -1;
              return 116;

            case E_RVVM4QImode:
              if (pattern488 (x1, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode) != 0)
                return -1;
              return 117;

            case E_RVVM2QImode:
              if (pattern488 (x1, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0)
                return -1;
              return 118;

            case E_RVVM1QImode:
              if (pattern488 (x1, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0)
                return -1;
              return 119;

            case E_RVVMF2QImode:
              if (pattern488 (x1, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0)
                return -1;
              return 120;

            case E_RVVMF4QImode:
              if (pattern488 (x1, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0)
                return -1;
              return 121;

            case E_RVVMF8QImode:
              if (pattern488 (x1, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0)
                return -1;
              return 122;

            case E_RVVM8HImode:
              if (pattern488 (x1, 
E_RVVM8HImode, 
E_RVVMF2BImode, 
E_HImode) != 0)
                return -1;
              return 123;

            case E_RVVM4HImode:
              if (pattern488 (x1, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
                return -1;
              return 124;

            case E_RVVM2HImode:
              if (pattern488 (x1, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
                return -1;
              return 125;

            case E_RVVM1HImode:
              if (pattern488 (x1, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
                return -1;
              return 126;

            case E_RVVMF2HImode:
              if (pattern488 (x1, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
                return -1;
              return 127;

            case E_RVVMF4HImode:
              if (pattern488 (x1, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
                return -1;
              return 128;

            case E_RVVM8SImode:
              if (pattern488 (x1, 
E_RVVM8SImode, 
E_RVVMF4BImode, 
E_SImode) != 0)
                return -1;
              return 129;

            case E_RVVM4SImode:
              if (pattern488 (x1, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
                return -1;
              return 130;

            case E_RVVM2SImode:
              if (pattern488 (x1, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
                return -1;
              return 131;

            case E_RVVM1SImode:
              if (pattern488 (x1, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
                return -1;
              return 132;

            case E_RVVMF2SImode:
              if (pattern488 (x1, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
                return -1;
              return 133;

            case E_V1QImode:
              if (pattern488 (x1, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0)
                return -1;
              return 134;

            case E_V2QImode:
              if (pattern488 (x1, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0)
                return -1;
              return 135;

            case E_V4QImode:
              if (pattern488 (x1, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0)
                return -1;
              return 136;

            case E_V8QImode:
              if (pattern488 (x1, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0)
                return -1;
              return 137;

            case E_V16QImode:
              if (pattern488 (x1, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0)
                return -1;
              return 138;

            case E_V32QImode:
              if (pattern488 (x1, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0)
                return -1;
              return 139;

            case E_V64QImode:
              if (pattern488 (x1, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0)
                return -1;
              return 140;

            case E_V128QImode:
              if (pattern488 (x1, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0)
                return -1;
              return 141;

            case E_V256QImode:
              if (pattern488 (x1, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0)
                return -1;
              return 142;

            case E_V512QImode:
              if (pattern488 (x1, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0)
                return -1;
              return 143;

            case E_V1024QImode:
              if (pattern488 (x1, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0)
                return -1;
              return 144;

            case E_V2048QImode:
              if (pattern488 (x1, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0)
                return -1;
              return 145;

            case E_V4096QImode:
              if (pattern488 (x1, 
E_V4096QImode, 
E_V4096BImode, 
E_QImode) != 0)
                return -1;
              return 146;

            case E_V1HImode:
              if (pattern488 (x1, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0)
                return -1;
              return 147;

            case E_V2HImode:
              if (pattern488 (x1, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0)
                return -1;
              return 148;

            case E_V4HImode:
              if (pattern488 (x1, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0)
                return -1;
              return 149;

            case E_V8HImode:
              if (pattern488 (x1, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0)
                return -1;
              return 150;

            case E_V16HImode:
              if (pattern488 (x1, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
                return -1;
              return 151;

            case E_V32HImode:
              if (pattern488 (x1, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
                return -1;
              return 152;

            case E_V64HImode:
              if (pattern488 (x1, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
                return -1;
              return 153;

            case E_V128HImode:
              if (pattern488 (x1, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0)
                return -1;
              return 154;

            case E_V256HImode:
              if (pattern488 (x1, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
                return -1;
              return 155;

            case E_V512HImode:
              if (pattern488 (x1, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
                return -1;
              return 156;

            case E_V1024HImode:
              if (pattern488 (x1, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0)
                return -1;
              return 157;

            case E_V2048HImode:
              if (pattern488 (x1, 
E_V2048HImode, 
E_V2048BImode, 
E_HImode) != 0)
                return -1;
              return 158;

            case E_V1SImode:
              if (pattern488 (x1, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0)
                return -1;
              return 159;

            case E_V2SImode:
              if (pattern488 (x1, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
                return -1;
              return 160;

            case E_V4SImode:
              if (pattern488 (x1, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
                return -1;
              return 161;

            case E_V8SImode:
              if (pattern488 (x1, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0)
                return -1;
              return 162;

            case E_V16SImode:
              if (pattern488 (x1, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
                return -1;
              return 163;

            case E_V32SImode:
              if (pattern488 (x1, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0)
                return -1;
              return 164;

            case E_V64SImode:
              if (pattern488 (x1, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
                return -1;
              return 165;

            case E_V128SImode:
              if (pattern488 (x1, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
                return -1;
              return 166;

            case E_V256SImode:
              if (pattern488 (x1, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
                return -1;
              return 167;

            case E_V512SImode:
              if (pattern488 (x1, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
                return -1;
              return 168;

            case E_V1024SImode:
              if (pattern488 (x1, 
E_V1024SImode, 
E_V1024BImode, 
E_SImode) != 0)
                return -1;
              return 169;

            case E_RVVM8DImode:
              if (pattern488 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode, 
E_DImode) != 0)
                return -1;
              return 170;

            case E_RVVM4DImode:
              if (pattern488 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode, 
E_DImode) != 0)
                return -1;
              return 171;

            case E_RVVM2DImode:
              if (pattern488 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode, 
E_DImode) != 0)
                return -1;
              return 172;

            case E_RVVM1DImode:
              if (pattern488 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode, 
E_DImode) != 0)
                return -1;
              return 173;

            case E_V1DImode:
              if (pattern488 (x1, 
E_V1DImode, 
E_V1BImode, 
E_DImode) != 0)
                return -1;
              return 174;

            case E_V2DImode:
              if (pattern488 (x1, 
E_V2DImode, 
E_V2BImode, 
E_DImode) != 0)
                return -1;
              return 175;

            case E_V4DImode:
              if (pattern488 (x1, 
E_V4DImode, 
E_V4BImode, 
E_DImode) != 0)
                return -1;
              return 176;

            case E_V8DImode:
              if (pattern488 (x1, 
E_V8DImode, 
E_V8BImode, 
E_DImode) != 0)
                return -1;
              return 177;

            case E_V16DImode:
              if (pattern488 (x1, 
E_V16DImode, 
E_V16BImode, 
E_DImode) != 0)
                return -1;
              return 178;

            case E_V32DImode:
              if (pattern488 (x1, 
E_V32DImode, 
E_V32BImode, 
E_DImode) != 0)
                return -1;
              return 179;

            case E_V64DImode:
              if (pattern488 (x1, 
E_V64DImode, 
E_V64BImode, 
E_DImode) != 0)
                return -1;
              return 180;

            case E_V128DImode:
              if (pattern488 (x1, 
E_V128DImode, 
E_V128BImode, 
E_DImode) != 0)
                return -1;
              return 181;

            case E_V256DImode:
              if (pattern488 (x1, 
E_V256DImode, 
E_V256BImode, 
E_DImode) != 0)
                return -1;
              return 182;

            case E_V512DImode:
              if (pattern488 (x1, 
E_V512DImode, 
E_V512BImode, 
E_DImode) != 0)
                return -1;
              return 183;

            case E_RVVM8HFmode:
              if (pattern496 (x1, 
E_RVVM8HFmode, 
E_HFmode, 
E_RVVMF2BImode) != 0)
                return -1;
              return 184;

            case E_RVVM4HFmode:
              if (pattern496 (x1, 
E_RVVM4HFmode, 
E_HFmode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 185;

            case E_RVVM2HFmode:
              if (pattern496 (x1, 
E_RVVM2HFmode, 
E_HFmode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 186;

            case E_RVVM1HFmode:
              if (pattern496 (x1, 
E_RVVM1HFmode, 
E_HFmode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 187;

            case E_RVVMF2HFmode:
              if (pattern496 (x1, 
E_RVVMF2HFmode, 
E_HFmode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 188;

            case E_RVVMF4HFmode:
              if (pattern496 (x1, 
E_RVVMF4HFmode, 
E_HFmode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 189;

            case E_RVVM8SFmode:
              if (pattern496 (x1, 
E_RVVM8SFmode, 
E_SFmode, 
E_RVVMF4BImode) != 0)
                return -1;
              return 190;

            case E_RVVM4SFmode:
              if (pattern496 (x1, 
E_RVVM4SFmode, 
E_SFmode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 191;

            case E_RVVM2SFmode:
              if (pattern496 (x1, 
E_RVVM2SFmode, 
E_SFmode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 192;

            case E_RVVM1SFmode:
              if (pattern496 (x1, 
E_RVVM1SFmode, 
E_SFmode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 193;

            case E_RVVMF2SFmode:
              if (pattern496 (x1, 
E_RVVMF2SFmode, 
E_SFmode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 194;

            case E_RVVM8DFmode:
              if (pattern496 (x1, 
E_RVVM8DFmode, 
E_DFmode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 195;

            case E_RVVM4DFmode:
              if (pattern496 (x1, 
E_RVVM4DFmode, 
E_DFmode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 196;

            case E_RVVM2DFmode:
              if (pattern496 (x1, 
E_RVVM2DFmode, 
E_DFmode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 197;

            case E_RVVM1DFmode:
              if (pattern496 (x1, 
E_RVVM1DFmode, 
E_DFmode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 198;

            default:
              return -1;
            }

        case SIGN_EXTEND:
          res = pattern491 (x1);
          if (res >= 0)
            return res + 199; /* [199, 212] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern563 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern565 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[6] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[7] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[8] = x6;
  x7 = XEXP (x1, 1);
  x8 = XVECEXP (x7, 0, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[3] = x8;
      x9 = XVECEXP (x7, 0, 1);
      operands[4] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8DImode:
          return pattern554 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode); /* [-1, 0] */

        case E_RVVM4DImode:
          if (pattern554 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
            return -1;
          return 1;

        case E_RVVM2DImode:
          if (pattern554 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
            return -1;
          return 2;

        case E_RVVM1DImode:
          if (pattern554 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x9 = XVECEXP (x7, 0, 1);
      operands[3] = x9;
      x10 = XEXP (x8, 0);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[4] = x10;
          if (!reg_or_0_operand (operands[4], E_DImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVM8DImode:
              if (pattern556 (x1, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
                return -1;
              return 4;

            case E_RVVM4DImode:
              if (pattern556 (x1, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
                return -1;
              return 5;

            case E_RVVM2DImode:
              if (pattern556 (x1, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
                return -1;
              return 6;

            case E_RVVM1DImode:
              if (pattern556 (x1, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
                return -1;
              return 7;

            default:
              return -1;
            }

        case SIGN_EXTEND:
          res = pattern557 (x1);
          if (res >= 0)
            return res + 8; /* [8, 11] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern574 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (!register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern576 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[5] = x4;
  x5 = XVECEXP (x2, 0, 3);
  operands[6] = x5;
  x6 = XVECEXP (x2, 0, 4);
  operands[7] = x6;
  x7 = XVECEXP (x2, 0, 5);
  operands[8] = x7;
  x8 = XEXP (x1, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XEXP (x1, 2);
  operands[2] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HFmode:
      return pattern504 (x1, 
E_RVVM8HFmode, 
E_RVVM8HImode, 
E_RVVMF2BImode); /* [-1, 0] */

    case E_RVVM4HFmode:
      if (!register_operand (operands[0], E_RVVM4HFmode)
          || GET_MODE (x1) != E_RVVM4HFmode
          || GET_MODE (x2) != E_RVVMF4BImode
          || !vector_mask_operand (operands[1], E_RVVMF4BImode)
          || GET_MODE (x8) != E_RVVM4HFmode
          || !vector_merge_operand (operands[2], E_RVVM4HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HImode:
          if (!register_operand (operands[3], E_RVVM4HImode))
            return -1;
          return 1;

        case E_RVVM8SImode:
          if (!register_operand (operands[3], E_RVVM8SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_RVVM2HFmode:
      if (!register_operand (operands[0], E_RVVM2HFmode)
          || GET_MODE (x1) != E_RVVM2HFmode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x8) != E_RVVM2HFmode
          || !vector_merge_operand (operands[2], E_RVVM2HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HImode:
          if (!register_operand (operands[3], E_RVVM2HImode))
            return -1;
          return 3;

        case E_RVVM4SImode:
          if (!register_operand (operands[3], E_RVVM4SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_RVVM1HFmode:
      if (!register_operand (operands[0], E_RVVM1HFmode)
          || GET_MODE (x1) != E_RVVM1HFmode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x8) != E_RVVM1HFmode
          || !vector_merge_operand (operands[2], E_RVVM1HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HImode:
          if (!register_operand (operands[3], E_RVVM1HImode))
            return -1;
          return 5;

        case E_RVVM2SImode:
          if (!register_operand (operands[3], E_RVVM2SImode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_RVVMF2HFmode:
      if (!register_operand (operands[0], E_RVVMF2HFmode)
          || GET_MODE (x1) != E_RVVMF2HFmode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x8) != E_RVVMF2HFmode
          || !vector_merge_operand (operands[2], E_RVVMF2HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HImode:
          if (!register_operand (operands[3], E_RVVMF2HImode))
            return -1;
          return 7;

        case E_RVVM1SImode:
          if (!register_operand (operands[3], E_RVVM1SImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case E_RVVMF4HFmode:
      if (!register_operand (operands[0], E_RVVMF4HFmode)
          || GET_MODE (x1) != E_RVVMF4HFmode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x8) != E_RVVMF4HFmode
          || !vector_merge_operand (operands[2], E_RVVMF4HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF4HImode:
          if (!register_operand (operands[3], E_RVVMF4HImode))
            return -1;
          return 9;

        case E_RVVMF2SImode:
          if (!register_operand (operands[3], E_RVVMF2SImode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_RVVM8SFmode:
      if (pattern504 (x1, 
E_RVVM8SFmode, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0)
        return -1;
      return 11;

    case E_RVVM4SFmode:
      if (!register_operand (operands[0], E_RVVM4SFmode)
          || GET_MODE (x1) != E_RVVM4SFmode
          || GET_MODE (x2) != E_RVVMF8BImode
          || !vector_mask_operand (operands[1], E_RVVMF8BImode)
          || GET_MODE (x8) != E_RVVM4SFmode
          || !vector_merge_operand (operands[2], E_RVVM4SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4SImode:
          if (!register_operand (operands[3], E_RVVM4SImode))
            return -1;
          return 12;

        case E_RVVM8DImode:
          if (!register_operand (operands[3], E_RVVM8DImode))
            return -1;
          return 13;

        default:
          return -1;
        }

    case E_RVVM2SFmode:
      if (!register_operand (operands[0], E_RVVM2SFmode)
          || GET_MODE (x1) != E_RVVM2SFmode
          || GET_MODE (x2) != E_RVVMF16BImode
          || !vector_mask_operand (operands[1], E_RVVMF16BImode)
          || GET_MODE (x8) != E_RVVM2SFmode
          || !vector_merge_operand (operands[2], E_RVVM2SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2SImode:
          if (!register_operand (operands[3], E_RVVM2SImode))
            return -1;
          return 14;

        case E_RVVM4DImode:
          if (!register_operand (operands[3], E_RVVM4DImode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      if (!register_operand (operands[0], E_RVVM1SFmode)
          || GET_MODE (x1) != E_RVVM1SFmode
          || GET_MODE (x2) != E_RVVMF32BImode
          || !vector_mask_operand (operands[1], E_RVVMF32BImode)
          || GET_MODE (x8) != E_RVVM1SFmode
          || !vector_merge_operand (operands[2], E_RVVM1SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1SImode:
          if (!register_operand (operands[3], E_RVVM1SImode))
            return -1;
          return 16;

        case E_RVVM2DImode:
          if (!register_operand (operands[3], E_RVVM2DImode))
            return -1;
          return 17;

        default:
          return -1;
        }

    case E_RVVMF2SFmode:
      if (!register_operand (operands[0], E_RVVMF2SFmode)
          || GET_MODE (x1) != E_RVVMF2SFmode
          || GET_MODE (x2) != E_RVVMF64BImode
          || !vector_mask_operand (operands[1], E_RVVMF64BImode)
          || GET_MODE (x8) != E_RVVMF2SFmode
          || !vector_merge_operand (operands[2], E_RVVMF2SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2SImode:
          if (!register_operand (operands[3], E_RVVMF2SImode))
            return -1;
          return 18;

        case E_RVVM1DImode:
          if (!register_operand (operands[3], E_RVVM1DImode))
            return -1;
          return 19;

        default:
          return -1;
        }

    case E_RVVM8DFmode:
      if (pattern504 (x1, 
E_RVVM8DFmode, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0)
        return -1;
      return 20;

    case E_RVVM4DFmode:
      if (pattern504 (x1, 
E_RVVM4DFmode, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0)
        return -1;
      return 21;

    case E_RVVM2DFmode:
      if (pattern504 (x1, 
E_RVVM2DFmode, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0)
        return -1;
      return 22;

    case E_RVVM1DFmode:
      if (pattern504 (x1, 
E_RVVM1DFmode, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0)
        return -1;
      return 23;

    case E_V1HFmode:
      if (!register_operand (operands[0], E_V1HFmode)
          || GET_MODE (x1) != E_V1HFmode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x8) != E_V1HFmode
          || !vector_merge_operand (operands[2], E_V1HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1HImode:
          if (!register_operand (operands[3], E_V1HImode))
            return -1;
          return 24;

        case E_V1SImode:
          if (!register_operand (operands[3], E_V1SImode))
            return -1;
          return 25;

        default:
          return -1;
        }

    case E_V2HFmode:
      if (!register_operand (operands[0], E_V2HFmode)
          || GET_MODE (x1) != E_V2HFmode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x8) != E_V2HFmode
          || !vector_merge_operand (operands[2], E_V2HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2HImode:
          if (!register_operand (operands[3], E_V2HImode))
            return -1;
          return 26;

        case E_V2SImode:
          if (!register_operand (operands[3], E_V2SImode))
            return -1;
          return 27;

        default:
          return -1;
        }

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x1) != E_V4HFmode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x8) != E_V4HFmode
          || !vector_merge_operand (operands[2], E_V4HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HImode:
          if (!register_operand (operands[3], E_V4HImode))
            return -1;
          return 28;

        case E_V4SImode:
          if (!register_operand (operands[3], E_V4SImode))
            return -1;
          return 29;

        default:
          return -1;
        }

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x8) != E_V8HFmode
          || !vector_merge_operand (operands[2], E_V8HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8HImode:
          if (!register_operand (operands[3], E_V8HImode))
            return -1;
          return 30;

        case E_V8SImode:
          if (!register_operand (operands[3], E_V8SImode))
            return -1;
          return 31;

        default:
          return -1;
        }

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x1) != E_V16HFmode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x8) != E_V16HFmode
          || !vector_merge_operand (operands[2], E_V16HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16HImode:
          if (!register_operand (operands[3], E_V16HImode))
            return -1;
          return 32;

        case E_V16SImode:
          if (!register_operand (operands[3], E_V16SImode))
            return -1;
          return 33;

        default:
          return -1;
        }

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x1) != E_V32HFmode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x8) != E_V32HFmode
          || !vector_merge_operand (operands[2], E_V32HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32HImode:
          if (!register_operand (operands[3], E_V32HImode))
            return -1;
          return 34;

        case E_V32SImode:
          if (!register_operand (operands[3], E_V32SImode))
            return -1;
          return 35;

        default:
          return -1;
        }

    case E_V64HFmode:
      if (!register_operand (operands[0], E_V64HFmode)
          || GET_MODE (x1) != E_V64HFmode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x8) != E_V64HFmode
          || !vector_merge_operand (operands[2], E_V64HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64HImode:
          if (!register_operand (operands[3], E_V64HImode))
            return -1;
          return 36;

        case E_V64SImode:
          if (!register_operand (operands[3], E_V64SImode))
            return -1;
          return 37;

        default:
          return -1;
        }

    case E_V128HFmode:
      if (!register_operand (operands[0], E_V128HFmode)
          || GET_MODE (x1) != E_V128HFmode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x8) != E_V128HFmode
          || !vector_merge_operand (operands[2], E_V128HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128HImode:
          if (!register_operand (operands[3], E_V128HImode))
            return -1;
          return 38;

        case E_V128SImode:
          if (!register_operand (operands[3], E_V128SImode))
            return -1;
          return 39;

        default:
          return -1;
        }

    case E_V256HFmode:
      if (!register_operand (operands[0], E_V256HFmode)
          || GET_MODE (x1) != E_V256HFmode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x8) != E_V256HFmode
          || !vector_merge_operand (operands[2], E_V256HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256HImode:
          if (!register_operand (operands[3], E_V256HImode))
            return -1;
          return 40;

        case E_V256SImode:
          if (!register_operand (operands[3], E_V256SImode))
            return -1;
          return 41;

        default:
          return -1;
        }

    case E_V512HFmode:
      if (!register_operand (operands[0], E_V512HFmode)
          || GET_MODE (x1) != E_V512HFmode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x8) != E_V512HFmode
          || !vector_merge_operand (operands[2], E_V512HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512HImode:
          if (!register_operand (operands[3], E_V512HImode))
            return -1;
          return 42;

        case E_V512SImode:
          if (!register_operand (operands[3], E_V512SImode))
            return -1;
          return 43;

        default:
          return -1;
        }

    case E_V1024HFmode:
      if (!register_operand (operands[0], E_V1024HFmode)
          || GET_MODE (x1) != E_V1024HFmode
          || GET_MODE (x2) != E_V1024BImode
          || !vector_mask_operand (operands[1], E_V1024BImode)
          || GET_MODE (x8) != E_V1024HFmode
          || !vector_merge_operand (operands[2], E_V1024HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1024HImode:
          if (!register_operand (operands[3], E_V1024HImode))
            return -1;
          return 44;

        case E_V1024SImode:
          if (!register_operand (operands[3], E_V1024SImode))
            return -1;
          return 45;

        default:
          return -1;
        }

    case E_V2048HFmode:
      if (pattern504 (x1, 
E_V2048HFmode, 
E_V2048HImode, 
E_V2048BImode) != 0)
        return -1;
      return 46;

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x1) != E_V1SFmode
          || GET_MODE (x2) != E_V1BImode
          || !vector_mask_operand (operands[1], E_V1BImode)
          || GET_MODE (x8) != E_V1SFmode
          || !vector_merge_operand (operands[2], E_V1SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V1SImode:
          if (!register_operand (operands[3], E_V1SImode))
            return -1;
          return 47;

        case E_V1DImode:
          if (!register_operand (operands[3], E_V1DImode))
            return -1;
          return 48;

        default:
          return -1;
        }

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x1) != E_V2SFmode
          || GET_MODE (x2) != E_V2BImode
          || !vector_mask_operand (operands[1], E_V2BImode)
          || GET_MODE (x8) != E_V2SFmode
          || !vector_merge_operand (operands[2], E_V2SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2SImode:
          if (!register_operand (operands[3], E_V2SImode))
            return -1;
          return 49;

        case E_V2DImode:
          if (!register_operand (operands[3], E_V2DImode))
            return -1;
          return 50;

        default:
          return -1;
        }

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || GET_MODE (x2) != E_V4BImode
          || !vector_mask_operand (operands[1], E_V4BImode)
          || GET_MODE (x8) != E_V4SFmode
          || !vector_merge_operand (operands[2], E_V4SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4SImode:
          if (!register_operand (operands[3], E_V4SImode))
            return -1;
          return 51;

        case E_V4DImode:
          if (!register_operand (operands[3], E_V4DImode))
            return -1;
          return 52;

        default:
          return -1;
        }

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x1) != E_V8SFmode
          || GET_MODE (x2) != E_V8BImode
          || !vector_mask_operand (operands[1], E_V8BImode)
          || GET_MODE (x8) != E_V8SFmode
          || !vector_merge_operand (operands[2], E_V8SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8SImode:
          if (!register_operand (operands[3], E_V8SImode))
            return -1;
          return 53;

        case E_V8DImode:
          if (!register_operand (operands[3], E_V8DImode))
            return -1;
          return 54;

        default:
          return -1;
        }

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x1) != E_V16SFmode
          || GET_MODE (x2) != E_V16BImode
          || !vector_mask_operand (operands[1], E_V16BImode)
          || GET_MODE (x8) != E_V16SFmode
          || !vector_merge_operand (operands[2], E_V16SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V16SImode:
          if (!register_operand (operands[3], E_V16SImode))
            return -1;
          return 55;

        case E_V16DImode:
          if (!register_operand (operands[3], E_V16DImode))
            return -1;
          return 56;

        default:
          return -1;
        }

    case E_V32SFmode:
      if (!register_operand (operands[0], E_V32SFmode)
          || GET_MODE (x1) != E_V32SFmode
          || GET_MODE (x2) != E_V32BImode
          || !vector_mask_operand (operands[1], E_V32BImode)
          || GET_MODE (x8) != E_V32SFmode
          || !vector_merge_operand (operands[2], E_V32SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V32SImode:
          if (!register_operand (operands[3], E_V32SImode))
            return -1;
          return 57;

        case E_V32DImode:
          if (!register_operand (operands[3], E_V32DImode))
            return -1;
          return 58;

        default:
          return -1;
        }

    case E_V64SFmode:
      if (!register_operand (operands[0], E_V64SFmode)
          || GET_MODE (x1) != E_V64SFmode
          || GET_MODE (x2) != E_V64BImode
          || !vector_mask_operand (operands[1], E_V64BImode)
          || GET_MODE (x8) != E_V64SFmode
          || !vector_merge_operand (operands[2], E_V64SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V64SImode:
          if (!register_operand (operands[3], E_V64SImode))
            return -1;
          return 59;

        case E_V64DImode:
          if (!register_operand (operands[3], E_V64DImode))
            return -1;
          return 60;

        default:
          return -1;
        }

    case E_V128SFmode:
      if (!register_operand (operands[0], E_V128SFmode)
          || GET_MODE (x1) != E_V128SFmode
          || GET_MODE (x2) != E_V128BImode
          || !vector_mask_operand (operands[1], E_V128BImode)
          || GET_MODE (x8) != E_V128SFmode
          || !vector_merge_operand (operands[2], E_V128SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V128SImode:
          if (!register_operand (operands[3], E_V128SImode))
            return -1;
          return 61;

        case E_V128DImode:
          if (!register_operand (operands[3], E_V128DImode))
            return -1;
          return 62;

        default:
          return -1;
        }

    case E_V256SFmode:
      if (!register_operand (operands[0], E_V256SFmode)
          || GET_MODE (x1) != E_V256SFmode
          || GET_MODE (x2) != E_V256BImode
          || !vector_mask_operand (operands[1], E_V256BImode)
          || GET_MODE (x8) != E_V256SFmode
          || !vector_merge_operand (operands[2], E_V256SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V256SImode:
          if (!register_operand (operands[3], E_V256SImode))
            return -1;
          return 63;

        case E_V256DImode:
          if (!register_operand (operands[3], E_V256DImode))
            return -1;
          return 64;

        default:
          return -1;
        }

    case E_V512SFmode:
      if (!register_operand (operands[0], E_V512SFmode)
          || GET_MODE (x1) != E_V512SFmode
          || GET_MODE (x2) != E_V512BImode
          || !vector_mask_operand (operands[1], E_V512BImode)
          || GET_MODE (x8) != E_V512SFmode
          || !vector_merge_operand (operands[2], E_V512SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V512SImode:
          if (!register_operand (operands[3], E_V512SImode))
            return -1;
          return 65;

        case E_V512DImode:
          if (!register_operand (operands[3], E_V512DImode))
            return -1;
          return 66;

        default:
          return -1;
        }

    case E_V1024SFmode:
      if (pattern504 (x1, 
E_V1024SFmode, 
E_V1024SImode, 
E_V1024BImode) != 0)
        return -1;
      return 67;

    case E_V1DFmode:
      if (pattern504 (x1, 
E_V1DFmode, 
E_V1DImode, 
E_V1BImode) != 0)
        return -1;
      return 68;

    case E_V2DFmode:
      if (pattern504 (x1, 
E_V2DFmode, 
E_V2DImode, 
E_V2BImode) != 0)
        return -1;
      return 69;

    case E_V4DFmode:
      if (pattern504 (x1, 
E_V4DFmode, 
E_V4DImode, 
E_V4BImode) != 0)
        return -1;
      return 70;

    case E_V8DFmode:
      if (pattern504 (x1, 
E_V8DFmode, 
E_V8DImode, 
E_V8BImode) != 0)
        return -1;
      return 71;

    case E_V16DFmode:
      if (pattern504 (x1, 
E_V16DFmode, 
E_V16DImode, 
E_V16BImode) != 0)
        return -1;
      return 72;

    case E_V32DFmode:
      if (pattern504 (x1, 
E_V32DFmode, 
E_V32DImode, 
E_V32BImode) != 0)
        return -1;
      return 73;

    case E_V64DFmode:
      if (pattern504 (x1, 
E_V64DFmode, 
E_V64DImode, 
E_V64BImode) != 0)
        return -1;
      return 74;

    case E_V128DFmode:
      if (pattern504 (x1, 
E_V128DFmode, 
E_V128DImode, 
E_V128BImode) != 0)
        return -1;
      return 75;

    case E_V256DFmode:
      if (pattern504 (x1, 
E_V256DFmode, 
E_V256DImode, 
E_V256BImode) != 0)
        return -1;
      return 76;

    case E_V512DFmode:
      if (pattern504 (x1, 
E_V512DFmode, 
E_V512DImode, 
E_V512BImode) != 0)
        return -1;
      return 77;

    default:
      return -1;
    }
}

int
pattern682 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF4BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF4BImode)
          || !register_operand (operands[3], E_RVVM8SFmode))
        return -1;
      return 0;

    case E_RVVMF8BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF8BImode)
          || !register_operand (operands[3], E_RVVM4SFmode))
        return -1;
      return 1;

    case E_RVVMF16BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF16BImode)
          || !register_operand (operands[3], E_RVVM2SFmode))
        return -1;
      return 2;

    case E_RVVMF32BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF32BImode)
          || !register_operand (operands[3], E_RVVM1SFmode))
        return -1;
      return 3;

    case E_RVVMF64BImode:
      if (!vector_mask_operand (operands[1], E_RVVMF64BImode)
          || !register_operand (operands[3], E_RVVMF2SFmode))
        return -1;
      return 4;

    case E_V1BImode:
      if (!vector_mask_operand (operands[1], E_V1BImode)
          || !register_operand (operands[3], E_V1SFmode))
        return -1;
      return 5;

    case E_V2BImode:
      if (!vector_mask_operand (operands[1], E_V2BImode)
          || !register_operand (operands[3], E_V2SFmode))
        return -1;
      return 6;

    case E_V4BImode:
      if (!vector_mask_operand (operands[1], E_V4BImode)
          || !register_operand (operands[3], E_V4SFmode))
        return -1;
      return 7;

    case E_V8BImode:
      if (!vector_mask_operand (operands[1], E_V8BImode)
          || !register_operand (operands[3], E_V8SFmode))
        return -1;
      return 8;

    case E_V16BImode:
      if (!vector_mask_operand (operands[1], E_V16BImode)
          || !register_operand (operands[3], E_V16SFmode))
        return -1;
      return 9;

    case E_V32BImode:
      if (!vector_mask_operand (operands[1], E_V32BImode)
          || !register_operand (operands[3], E_V32SFmode))
        return -1;
      return 10;

    case E_V64BImode:
      if (!vector_mask_operand (operands[1], E_V64BImode)
          || !register_operand (operands[3], E_V64SFmode))
        return -1;
      return 11;

    case E_V128BImode:
      if (!vector_mask_operand (operands[1], E_V128BImode)
          || !register_operand (operands[3], E_V128SFmode))
        return -1;
      return 12;

    case E_V256BImode:
      if (!vector_mask_operand (operands[1], E_V256BImode)
          || !register_operand (operands[3], E_V256SFmode))
        return -1;
      return 13;

    case E_V512BImode:
      if (!vector_mask_operand (operands[1], E_V512BImode)
          || !register_operand (operands[3], E_V512SFmode))
        return -1;
      return 14;

    case E_V1024BImode:
      if (!vector_mask_operand (operands[1], E_V1024BImode)
          || !register_operand (operands[3], E_V1024SFmode))
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern692 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !vector_mask_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[4], i1)
      || !register_operand (operands[3], i1)
      || !vector_merge_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern699 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !reg_or_0_operand (operands[3], i3)
      || !register_operand (operands[4], i2)
      || !vector_merge_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern705 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8HImode:
      return pattern704 (x1, 
E_RVVM8HImode, 
E_RVVM4QImode, 
E_RVVMF2BImode, 
E_QImode); /* [-1, 0] */

    case E_RVVM4HImode:
      if (pattern704 (x1, 
E_RVVM4HImode, 
E_RVVM2QImode, 
E_RVVMF4BImode, 
E_QImode) != 0)
        return -1;
      return 1;

    case E_RVVM2HImode:
      if (pattern704 (x1, 
E_RVVM2HImode, 
E_RVVM1QImode, 
E_RVVMF8BImode, 
E_QImode) != 0)
        return -1;
      return 2;

    case E_RVVM1HImode:
      if (pattern704 (x1, 
E_RVVM1HImode, 
E_RVVMF2QImode, 
E_RVVMF16BImode, 
E_QImode) != 0)
        return -1;
      return 3;

    case E_RVVMF2HImode:
      if (pattern704 (x1, 
E_RVVMF2HImode, 
E_RVVMF4QImode, 
E_RVVMF32BImode, 
E_QImode) != 0)
        return -1;
      return 4;

    case E_RVVMF4HImode:
      if (pattern704 (x1, 
E_RVVMF4HImode, 
E_RVVMF8QImode, 
E_RVVMF64BImode, 
E_QImode) != 0)
        return -1;
      return 5;

    case E_RVVM8SImode:
      if (pattern704 (x1, 
E_RVVM8SImode, 
E_RVVM4HImode, 
E_RVVMF4BImode, 
E_HImode) != 0)
        return -1;
      return 6;

    case E_RVVM4SImode:
      if (pattern704 (x1, 
E_RVVM4SImode, 
E_RVVM2HImode, 
E_RVVMF8BImode, 
E_HImode) != 0)
        return -1;
      return 7;

    case E_RVVM2SImode:
      if (pattern704 (x1, 
E_RVVM2SImode, 
E_RVVM1HImode, 
E_RVVMF16BImode, 
E_HImode) != 0)
        return -1;
      return 8;

    case E_RVVM1SImode:
      if (pattern704 (x1, 
E_RVVM1SImode, 
E_RVVMF2HImode, 
E_RVVMF32BImode, 
E_HImode) != 0)
        return -1;
      return 9;

    case E_RVVMF2SImode:
      if (pattern704 (x1, 
E_RVVMF2SImode, 
E_RVVMF4HImode, 
E_RVVMF64BImode, 
E_HImode) != 0)
        return -1;
      return 10;

    case E_RVVM8DImode:
      if (pattern704 (x1, 
E_RVVM8DImode, 
E_RVVM4SImode, 
E_RVVMF8BImode, 
E_SImode) != 0)
        return -1;
      return 11;

    case E_RVVM4DImode:
      if (pattern704 (x1, 
E_RVVM4DImode, 
E_RVVM2SImode, 
E_RVVMF16BImode, 
E_SImode) != 0)
        return -1;
      return 12;

    case E_RVVM2DImode:
      if (pattern704 (x1, 
E_RVVM2DImode, 
E_RVVM1SImode, 
E_RVVMF32BImode, 
E_SImode) != 0)
        return -1;
      return 13;

    case E_RVVM1DImode:
      if (pattern704 (x1, 
E_RVVM1DImode, 
E_RVVMF2SImode, 
E_RVVMF64BImode, 
E_SImode) != 0)
        return -1;
      return 14;

    case E_V1HImode:
      if (pattern704 (x1, 
E_V1HImode, 
E_V1QImode, 
E_V1BImode, 
E_QImode) != 0)
        return -1;
      return 15;

    case E_V2HImode:
      if (pattern704 (x1, 
E_V2HImode, 
E_V2QImode, 
E_V2BImode, 
E_QImode) != 0)
        return -1;
      return 16;

    case E_V4HImode:
      if (pattern704 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V4BImode, 
E_QImode) != 0)
        return -1;
      return 17;

    case E_V8HImode:
      if (pattern704 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V8BImode, 
E_QImode) != 0)
        return -1;
      return 18;

    case E_V16HImode:
      if (pattern704 (x1, 
E_V16HImode, 
E_V16QImode, 
E_V16BImode, 
E_QImode) != 0)
        return -1;
      return 19;

    case E_V32HImode:
      if (pattern704 (x1, 
E_V32HImode, 
E_V32QImode, 
E_V32BImode, 
E_QImode) != 0)
        return -1;
      return 20;

    case E_V64HImode:
      if (pattern704 (x1, 
E_V64HImode, 
E_V64QImode, 
E_V64BImode, 
E_QImode) != 0)
        return -1;
      return 21;

    case E_V128HImode:
      if (pattern704 (x1, 
E_V128HImode, 
E_V128QImode, 
E_V128BImode, 
E_QImode) != 0)
        return -1;
      return 22;

    case E_V256HImode:
      if (pattern704 (x1, 
E_V256HImode, 
E_V256QImode, 
E_V256BImode, 
E_QImode) != 0)
        return -1;
      return 23;

    case E_V512HImode:
      if (pattern704 (x1, 
E_V512HImode, 
E_V512QImode, 
E_V512BImode, 
E_QImode) != 0)
        return -1;
      return 24;

    case E_V1024HImode:
      if (pattern704 (x1, 
E_V1024HImode, 
E_V1024QImode, 
E_V1024BImode, 
E_QImode) != 0)
        return -1;
      return 25;

    case E_V2048HImode:
      if (pattern704 (x1, 
E_V2048HImode, 
E_V2048QImode, 
E_V2048BImode, 
E_QImode) != 0)
        return -1;
      return 26;

    case E_V1SImode:
      if (pattern704 (x1, 
E_V1SImode, 
E_V1HImode, 
E_V1BImode, 
E_HImode) != 0)
        return -1;
      return 27;

    case E_V2SImode:
      if (pattern704 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V2BImode, 
E_HImode) != 0)
        return -1;
      return 28;

    case E_V4SImode:
      if (pattern704 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V4BImode, 
E_HImode) != 0)
        return -1;
      return 29;

    case E_V8SImode:
      if (pattern704 (x1, 
E_V8SImode, 
E_V8HImode, 
E_V8BImode, 
E_HImode) != 0)
        return -1;
      return 30;

    case E_V16SImode:
      if (pattern704 (x1, 
E_V16SImode, 
E_V16HImode, 
E_V16BImode, 
E_HImode) != 0)
        return -1;
      return 31;

    case E_V32SImode:
      if (pattern704 (x1, 
E_V32SImode, 
E_V32HImode, 
E_V32BImode, 
E_HImode) != 0)
        return -1;
      return 32;

    case E_V64SImode:
      if (pattern704 (x1, 
E_V64SImode, 
E_V64HImode, 
E_V64BImode, 
E_HImode) != 0)
        return -1;
      return 33;

    case E_V128SImode:
      if (pattern704 (x1, 
E_V128SImode, 
E_V128HImode, 
E_V128BImode, 
E_HImode) != 0)
        return -1;
      return 34;

    case E_V256SImode:
      if (pattern704 (x1, 
E_V256SImode, 
E_V256HImode, 
E_V256BImode, 
E_HImode) != 0)
        return -1;
      return 35;

    case E_V512SImode:
      if (pattern704 (x1, 
E_V512SImode, 
E_V512HImode, 
E_V512BImode, 
E_HImode) != 0)
        return -1;
      return 36;

    case E_V1024SImode:
      if (pattern704 (x1, 
E_V1024SImode, 
E_V1024HImode, 
E_V1024BImode, 
E_HImode) != 0)
        return -1;
      return 37;

    case E_V1DImode:
      if (pattern704 (x1, 
E_V1DImode, 
E_V1SImode, 
E_V1BImode, 
E_SImode) != 0)
        return -1;
      return 38;

    case E_V2DImode:
      if (pattern704 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V2BImode, 
E_SImode) != 0)
        return -1;
      return 39;

    case E_V4DImode:
      if (pattern704 (x1, 
E_V4DImode, 
E_V4SImode, 
E_V4BImode, 
E_SImode) != 0)
        return -1;
      return 40;

    case E_V8DImode:
      if (pattern704 (x1, 
E_V8DImode, 
E_V8SImode, 
E_V8BImode, 
E_SImode) != 0)
        return -1;
      return 41;

    case E_V16DImode:
      if (pattern704 (x1, 
E_V16DImode, 
E_V16SImode, 
E_V16BImode, 
E_SImode) != 0)
        return -1;
      return 42;

    case E_V32DImode:
      if (pattern704 (x1, 
E_V32DImode, 
E_V32SImode, 
E_V32BImode, 
E_SImode) != 0)
        return -1;
      return 43;

    case E_V64DImode:
      if (pattern704 (x1, 
E_V64DImode, 
E_V64SImode, 
E_V64BImode, 
E_SImode) != 0)
        return -1;
      return 44;

    case E_V128DImode:
      if (pattern704 (x1, 
E_V128DImode, 
E_V128SImode, 
E_V128BImode, 
E_SImode) != 0)
        return -1;
      return 45;

    case E_V256DImode:
      if (pattern704 (x1, 
E_V256DImode, 
E_V256SImode, 
E_V256BImode, 
E_SImode) != 0)
        return -1;
      return 46;

    case E_V512DImode:
      if (pattern704 (x1, 
E_V512DImode, 
E_V512SImode, 
E_V512BImode, 
E_SImode) != 0)
        return -1;
      return 47;

    default:
      return -1;
    }
}

int
pattern730 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[0] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  switch (XWINT (x8, 0))
    {
    case -4L:
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 1);
      if (XWINT (x12, 0) != -8L)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -12L)
        return -1;
      return 0;

    case -8L:
      x9 = XVECEXP (x1, 0, 2);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 1);
      if (XWINT (x12, 0) != -16L)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -24L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern733 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !vector_mask_operand (operands[1], i3))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x3, 1);
  return pattern725 (x4, 
i1, 
i2, 
i4); /* [-1, 0] */
}

int
pattern735 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  return 0;
}

int
pattern736 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  switch (XWINT (x5, 0))
    {
    case -4L:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -8L)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -12L)
        return -1;
      return 0;

    case -8L:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -16L)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -24L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern739 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XEXP (x12, 1);
  if (GET_MODE (x16) != i1)
    return -1;
  x17 = XVECEXP (x1, 0, 3);
  x18 = XEXP (x17, 0);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x17, 1);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  return 0;
}

int
pattern742 (rtx x1, machine_mode i1, int i2, int i3, int i4, int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 22:
      if (REGNO (x12) != 21
          || REGNO (x17) != 20
          || REGNO (x22) != 19)
        return -1;
      x28 = XEXP (x26, 1);
      if (GET_CODE (x28) != MEM
          || GET_MODE (x28) != i1)
        return -1;
      x29 = XEXP (x28, 0);
      if (GET_CODE (x29) != PLUS
          || GET_MODE (x29) != i1)
        return -1;
      x30 = XEXP (x29, 0);
      if (GET_CODE (x30) != REG
          || REGNO (x30) != 2
          || GET_MODE (x30) != i1)
        return -1;
      x31 = XEXP (x29, 1);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + i5]
          || REGNO (x27) != 18)
        return -1;
      x32 = XVECEXP (x1, 0, 6);
      if (GET_CODE (x32) != SET)
        return -1;
      x33 = XEXP (x32, 1);
      if (GET_CODE (x33) != MEM
          || GET_MODE (x33) != i1)
        return -1;
      x34 = XEXP (x33, 0);
      if (GET_CODE (x34) != PLUS
          || GET_MODE (x34) != i1)
        return -1;
      x35 = XEXP (x34, 0);
      if (GET_CODE (x35) != REG
          || REGNO (x35) != 2
          || GET_MODE (x35) != i1)
        return -1;
      x36 = XEXP (x34, 1);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
        return -1;
      x37 = XEXP (x32, 0);
      if (GET_CODE (x37) != REG
          || REGNO (x37) != 9
          || GET_MODE (x37) != i1)
        return -1;
      x38 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x38) != SET)
        return -1;
      x39 = XEXP (x38, 1);
      if (GET_CODE (x39) != MEM
          || GET_MODE (x39) != i1)
        return -1;
      x40 = XEXP (x39, 0);
      if (GET_CODE (x40) != PLUS
          || GET_MODE (x40) != i1)
        return -1;
      x41 = XEXP (x40, 0);
      if (GET_CODE (x41) != REG
          || REGNO (x41) != 2
          || GET_MODE (x41) != i1)
        return -1;
      x42 = XEXP (x40, 1);
      if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
        return -1;
      x43 = XEXP (x38, 0);
      if (GET_CODE (x43) != REG
          || REGNO (x43) != 8
          || GET_MODE (x43) != i1)
        return -1;
      x44 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x44) != SET)
        return -1;
      x45 = XEXP (x44, 1);
      if (GET_CODE (x45) != MEM
          || GET_MODE (x45) != i1)
        return -1;
      x46 = XEXP (x45, 0);
      if (GET_CODE (x46) != PLUS
          || GET_MODE (x46) != i1)
        return -1;
      x47 = XEXP (x46, 0);
      if (GET_CODE (x47) != REG
          || REGNO (x47) != 2
          || GET_MODE (x47) != i1)
        return -1;
      x48 = XEXP (x46, 1);
      if (x48 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
        return -1;
      x49 = XEXP (x44, 0);
      if (GET_CODE (x49) != REG
          || REGNO (x49) != 1
          || GET_MODE (x49) != i1
          || !stack_pop_up_to_s6_operand (operands[0], E_VOIDmode))
        return -1;
      return 0;

    case 20:
      if (REGNO (x12) != 19
          || REGNO (x17) != 18
          || REGNO (x22) != 9)
        return -1;
      x28 = XEXP (x26, 1);
      if (GET_CODE (x28) != MEM
          || GET_MODE (x28) != i1)
        return -1;
      x29 = XEXP (x28, 0);
      if (GET_CODE (x29) != PLUS
          || GET_MODE (x29) != i1)
        return -1;
      x30 = XEXP (x29, 0);
      if (GET_CODE (x30) != REG
          || REGNO (x30) != 2
          || GET_MODE (x30) != i1)
        return -1;
      x31 = XEXP (x29, 1);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + i5]
          || REGNO (x27) != 8)
        return -1;
      x32 = XVECEXP (x1, 0, 6);
      if (GET_CODE (x32) != SET)
        return -1;
      x33 = XEXP (x32, 1);
      if (GET_CODE (x33) != MEM
          || GET_MODE (x33) != i1)
        return -1;
      x34 = XEXP (x33, 0);
      if (GET_CODE (x34) != PLUS
          || GET_MODE (x34) != i1)
        return -1;
      x35 = XEXP (x34, 0);
      if (GET_CODE (x35) != REG
          || REGNO (x35) != 2
          || GET_MODE (x35) != i1)
        return -1;
      x36 = XEXP (x34, 1);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
        return -1;
      x37 = XEXP (x32, 0);
      if (GET_CODE (x37) != REG
          || REGNO (x37) != 1
          || GET_MODE (x37) != i1)
        return -1;
      x38 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x38) != RETURN)
        return -1;
      x44 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x44) != USE)
        return -1;
      x49 = XEXP (x44, 0);
      if (GET_CODE (x49) != REG
          || REGNO (x49) != 1
          || GET_MODE (x49) != E_SImode
          || !stack_pop_up_to_s4_operand (operands[0], E_VOIDmode))
        return -1;
      return 1;

    case 18:
      if (REGNO (x12) != 9
          || REGNO (x17) != 8
          || REGNO (x22) != 1)
        return -1;
      x28 = XEXP (x26, 1);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x27) != 10)
        return -1;
      x32 = XVECEXP (x1, 0, 6);
      if (GET_CODE (x32) != USE)
        return -1;
      x37 = XEXP (x32, 0);
      if (GET_CODE (x37) != REG
          || REGNO (x37) != 10
          || GET_MODE (x37) != i1)
        return -1;
      x38 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x38) != RETURN)
        return -1;
      x44 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x44) != USE)
        return -1;
      x49 = XEXP (x44, 0);
      if (GET_CODE (x49) != REG
          || REGNO (x49) != 1
          || GET_MODE (x49) != E_SImode
          || !stack_pop_up_to_s2_operand (operands[0], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern767 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != MEM)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 2)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  return 0;
}

int
pattern770 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  switch (XWINT (x5, 0))
    {
    case -4L:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -8L)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -12L)
        return -1;
      x14 = XVECEXP (x1, 0, 3);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (XWINT (x17, 0) != -16L)
        return -1;
      x18 = XVECEXP (x1, 0, 4);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 1);
      if (XWINT (x21, 0) != -20L)
        return -1;
      x22 = XVECEXP (x1, 0, 5);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 0);
      x25 = XEXP (x24, 1);
      if (XWINT (x25, 0) != -24L)
        return -1;
      x26 = XVECEXP (x1, 0, 6);
      x27 = XEXP (x26, 0);
      x28 = XEXP (x27, 0);
      x29 = XEXP (x28, 1);
      if (XWINT (x29, 0) != -28L)
        return -1;
      x30 = XVECEXP (x1, 0, 7);
      x31 = XEXP (x30, 0);
      x32 = XEXP (x31, 0);
      x33 = XEXP (x32, 1);
      if (XWINT (x33, 0) != -32L)
        return -1;
      x34 = XVECEXP (x1, 0, 8);
      x35 = XEXP (x34, 0);
      x36 = XEXP (x35, 0);
      x37 = XEXP (x36, 1);
      if (XWINT (x37, 0) != -36L)
        return -1;
      return 0;

    case -8L:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != -16L)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != -24L)
        return -1;
      x14 = XVECEXP (x1, 0, 3);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (XWINT (x17, 0) != -32L)
        return -1;
      x18 = XVECEXP (x1, 0, 4);
      x19 = XEXP (x18, 0);
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 1);
      if (XWINT (x21, 0) != -40L)
        return -1;
      x22 = XVECEXP (x1, 0, 5);
      x23 = XEXP (x22, 0);
      x24 = XEXP (x23, 0);
      x25 = XEXP (x24, 1);
      if (XWINT (x25, 0) != -48L)
        return -1;
      x26 = XVECEXP (x1, 0, 6);
      x27 = XEXP (x26, 0);
      x28 = XEXP (x27, 0);
      x29 = XEXP (x28, 1);
      if (XWINT (x29, 0) != -56L)
        return -1;
      x30 = XVECEXP (x1, 0, 7);
      x31 = XEXP (x30, 0);
      x32 = XEXP (x31, 0);
      x33 = XEXP (x32, 1);
      if (XWINT (x33, 0) != -64L)
        return -1;
      x34 = XVECEXP (x1, 0, 8);
      x35 = XEXP (x34, 0);
      x36 = XEXP (x35, 0);
      x37 = XEXP (x36, 1);
      if (XWINT (x37, 0) != -72L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern779 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + -32])
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i1
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  return pattern778 (x9); /* [-1, 0] */
}

int
pattern783 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != USE)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1
      || !stack_pop_up_to_s9_operand (operands[0], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern784 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != i1)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_MODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != i1)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (GET_MODE (x17) != i1)
    return -1;
  x18 = XEXP (x16, 1);
  if (GET_MODE (x18) != i1)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_MODE (x19) != i1)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_MODE (x20) != i1)
    return -1;
  x21 = XVECEXP (x1, 0, 4);
  x22 = XEXP (x21, 0);
  if (GET_MODE (x22) != i1)
    return -1;
  x23 = XEXP (x21, 1);
  if (GET_MODE (x23) != i1)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_MODE (x24) != i1)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_MODE (x25) != i1)
    return -1;
  x26 = XVECEXP (x1, 0, 5);
  x27 = XEXP (x26, 0);
  if (GET_MODE (x27) != i1)
    return -1;
  x28 = XEXP (x26, 1);
  if (GET_MODE (x28) != i1)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_MODE (x29) != i1)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_MODE (x30) != i1)
    return -1;
  x31 = XVECEXP (x1, 0, 6);
  x32 = XEXP (x31, 0);
  if (GET_MODE (x32) != i1)
    return -1;
  x33 = XEXP (x31, 1);
  if (GET_MODE (x33) != i1)
    return -1;
  x34 = XEXP (x33, 0);
  if (GET_MODE (x34) != i1)
    return -1;
  x35 = XEXP (x34, 0);
  if (GET_MODE (x35) != i1)
    return -1;
  x36 = XVECEXP (x1, 0, 7);
  x37 = XEXP (x36, 0);
  if (GET_MODE (x37) != i1)
    return -1;
  x38 = XEXP (x36, 1);
  if (GET_MODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_MODE (x39) != i1)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != i1)
    return -1;
  x41 = XVECEXP (x1, 0, 8);
  x42 = XEXP (x41, 0);
  if (GET_MODE (x42) != i1)
    return -1;
  x43 = XEXP (x41, 1);
  if (GET_MODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_MODE (x44) != i1)
    return -1;
  x45 = XEXP (x44, 0);
  if (GET_MODE (x45) != i1)
    return -1;
  x46 = XVECEXP (x1, 0, 9);
  x47 = XEXP (x46, 0);
  if (GET_MODE (x47) != i1)
    return -1;
  x48 = XEXP (x46, 1);
  if (GET_MODE (x48) != i1)
    return -1;
  x49 = XEXP (x48, 0);
  if (GET_MODE (x49) != i1)
    return -1;
  x50 = XEXP (x49, 0);
  if (GET_MODE (x50) != i1)
    return -1;
  x51 = XVECEXP (x1, 0, 10);
  x52 = XEXP (x51, 0);
  if (GET_MODE (x52) != i1)
    return -1;
  x53 = XEXP (x51, 1);
  if (GET_MODE (x53) != i1)
    return -1;
  x54 = XEXP (x53, 0);
  if (GET_MODE (x54) != i1)
    return -1;
  x55 = XEXP (x54, 0);
  if (GET_MODE (x55) != i1)
    return -1;
  x56 = XVECEXP (x1, 0, 11);
  x57 = XEXP (x56, 0);
  if (GET_MODE (x57) != i1)
    return -1;
  x58 = XEXP (x56, 1);
  if (GET_MODE (x58) != i1)
    return -1;
  x59 = XEXP (x58, 0);
  if (GET_MODE (x59) != i1)
    return -1;
  x60 = XEXP (x59, 0);
  if (GET_MODE (x60) != i1)
    return -1;
  x61 = XVECEXP (x1, 0, 12);
  x62 = XEXP (x61, 0);
  if (GET_MODE (x62) != i1)
    return -1;
  switch (REGNO (x7))
    {
    case 27:
      if (REGNO (x12) != 26
          || REGNO (x17) != 25
          || REGNO (x22) != 24
          || REGNO (x27) != 23
          || REGNO (x32) != 22
          || REGNO (x37) != 21
          || REGNO (x42) != 20
          || REGNO (x47) != 19
          || REGNO (x52) != 18
          || REGNO (x57) != 9)
        return -1;
      return 0;

    case 25:
      if (REGNO (x12) != 24
          || REGNO (x17) != 23
          || REGNO (x22) != 22
          || REGNO (x27) != 21
          || REGNO (x32) != 20
          || REGNO (x37) != 19
          || REGNO (x42) != 18
          || REGNO (x47) != 9
          || REGNO (x52) != 8
          || REGNO (x57) != 1)
        return -1;
      x63 = XEXP (x61, 1);
      if (x63 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x62) != 10)
        return -1;
      x64 = XVECEXP (x1, 0, 13);
      if (pattern783 (x64, 
i1, 
10) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      return recog_5 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      x5 = XEXP (x3, 0);
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x7 = XEXP (x4, 0);
      operands[3] = x7;
      x8 = XEXP (x2, 1);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern137 (x2, 
E_RVVM8HImode, 
E_RVVM4QImode) != 0
              || !
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31406; /* *dual_widen_fmasurvvm8hi */

        case E_RVVM4HImode:
          if (pattern137 (x2, 
E_RVVM4HImode, 
E_RVVM2QImode) != 0
              || !
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31407; /* *dual_widen_fmasurvvm4hi */

        case E_RVVM2HImode:
          if (pattern137 (x2, 
E_RVVM2HImode, 
E_RVVM1QImode) != 0
              || !
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31408; /* *dual_widen_fmasurvvm2hi */

        case E_RVVM1HImode:
          if (pattern137 (x2, 
E_RVVM1HImode, 
E_RVVMF2QImode) != 0
              || !
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31409; /* *dual_widen_fmasurvvm1hi */

        case E_RVVMF2HImode:
          if (pattern137 (x2, 
E_RVVMF2HImode, 
E_RVVMF4QImode) != 0
              || !
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31410; /* *dual_widen_fmasurvvmf2hi */

        case E_RVVMF4HImode:
          if (pattern137 (x2, 
E_RVVMF4HImode, 
E_RVVMF8QImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31411; /* *dual_widen_fmasurvvmf4hi */

        case E_RVVM8SImode:
          if (pattern137 (x2, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0
              || !
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31412; /* *dual_widen_fmasurvvm8si */

        case E_RVVM4SImode:
          if (pattern137 (x2, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0
              || !
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31413; /* *dual_widen_fmasurvvm4si */

        case E_RVVM2SImode:
          if (pattern137 (x2, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0
              || !
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31414; /* *dual_widen_fmasurvvm2si */

        case E_RVVM1SImode:
          if (pattern137 (x2, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0
              || !
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31415; /* *dual_widen_fmasurvvm1si */

        case E_RVVMF2SImode:
          if (pattern137 (x2, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31416; /* *dual_widen_fmasurvvmf2si */

        case E_RVVM8DImode:
          if (pattern137 (x2, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31417; /* *dual_widen_fmasurvvm8di */

        case E_RVVM4DImode:
          if (pattern137 (x2, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31418; /* *dual_widen_fmasurvvm4di */

        case E_RVVM2DImode:
          if (pattern137 (x2, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31419; /* *dual_widen_fmasurvvm2di */

        case E_RVVM1DImode:
          if (pattern137 (x2, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31420; /* *dual_widen_fmasurvvm1di */

        case E_V1HImode:
          if (pattern137 (x2, 
E_V1HImode, 
E_V1QImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 31421; /* *dual_widen_fmasuv1hi */

        case E_V2HImode:
          if (pattern137 (x2, 
E_V2HImode, 
E_V2QImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 31422; /* *dual_widen_fmasuv2hi */

        case E_V4HImode:
          if (pattern137 (x2, 
E_V4HImode, 
E_V4QImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 31423; /* *dual_widen_fmasuv4hi */

        case E_V8HImode:
          if (pattern137 (x2, 
E_V8HImode, 
E_V8QImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 31424; /* *dual_widen_fmasuv8hi */

        case E_V16HImode:
          if (pattern137 (x2, 
E_V16HImode, 
E_V16QImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 31425; /* *dual_widen_fmasuv16hi */

        case E_V32HImode:
          if (pattern137 (x2, 
E_V32HImode, 
E_V32QImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31426; /* *dual_widen_fmasuv32hi */

        case E_V64HImode:
          if (pattern137 (x2, 
E_V64HImode, 
E_V64QImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31427; /* *dual_widen_fmasuv64hi */

        case E_V128HImode:
          if (pattern137 (x2, 
E_V128HImode, 
E_V128QImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31428; /* *dual_widen_fmasuv128hi */

        case E_V256HImode:
          if (pattern137 (x2, 
E_V256HImode, 
E_V256QImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31429; /* *dual_widen_fmasuv256hi */

        case E_V512HImode:
          if (pattern137 (x2, 
E_V512HImode, 
E_V512QImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31430; /* *dual_widen_fmasuv512hi */

        case E_V1024HImode:
          if (pattern137 (x2, 
E_V1024HImode, 
E_V1024QImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31431; /* *dual_widen_fmasuv1024hi */

        case E_V2048HImode:
          if (pattern137 (x2, 
E_V2048HImode, 
E_V2048QImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31432; /* *dual_widen_fmasuv2048hi */

        case E_V1SImode:
          if (pattern137 (x2, 
E_V1SImode, 
E_V1HImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 31433; /* *dual_widen_fmasuv1si */

        case E_V2SImode:
          if (pattern137 (x2, 
E_V2SImode, 
E_V2HImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 31434; /* *dual_widen_fmasuv2si */

        case E_V4SImode:
          if (pattern137 (x2, 
E_V4SImode, 
E_V4HImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 31435; /* *dual_widen_fmasuv4si */

        case E_V8SImode:
          if (pattern137 (x2, 
E_V8SImode, 
E_V8HImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 31436; /* *dual_widen_fmasuv8si */

        case E_V16SImode:
          if (pattern137 (x2, 
E_V16SImode, 
E_V16HImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31437; /* *dual_widen_fmasuv16si */

        case E_V32SImode:
          if (pattern137 (x2, 
E_V32SImode, 
E_V32HImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31438; /* *dual_widen_fmasuv32si */

        case E_V64SImode:
          if (pattern137 (x2, 
E_V64SImode, 
E_V64HImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31439; /* *dual_widen_fmasuv64si */

        case E_V128SImode:
          if (pattern137 (x2, 
E_V128SImode, 
E_V128HImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31440; /* *dual_widen_fmasuv128si */

        case E_V256SImode:
          if (pattern137 (x2, 
E_V256SImode, 
E_V256HImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31441; /* *dual_widen_fmasuv256si */

        case E_V512SImode:
          if (pattern137 (x2, 
E_V512SImode, 
E_V512HImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31442; /* *dual_widen_fmasuv512si */

        case E_V1024SImode:
          if (pattern137 (x2, 
E_V1024SImode, 
E_V1024HImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31443; /* *dual_widen_fmasuv1024si */

        case E_V1DImode:
          if (pattern137 (x2, 
E_V1DImode, 
E_V1SImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31444; /* *dual_widen_fmasuv1di */

        case E_V2DImode:
          if (pattern137 (x2, 
E_V2DImode, 
E_V2SImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31445; /* *dual_widen_fmasuv2di */

        case E_V4DImode:
          if (pattern137 (x2, 
E_V4DImode, 
E_V4SImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31446; /* *dual_widen_fmasuv4di */

        case E_V8DImode:
          if (pattern137 (x2, 
E_V8DImode, 
E_V8SImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31447; /* *dual_widen_fmasuv8di */

        case E_V16DImode:
          if (pattern137 (x2, 
E_V16DImode, 
E_V16SImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31448; /* *dual_widen_fmasuv16di */

        case E_V32DImode:
          if (pattern137 (x2, 
E_V32DImode, 
E_V32SImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31449; /* *dual_widen_fmasuv32di */

        case E_V64DImode:
          if (pattern137 (x2, 
E_V64DImode, 
E_V64SImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31450; /* *dual_widen_fmasuv64di */

        case E_V128DImode:
          if (pattern137 (x2, 
E_V128DImode, 
E_V128SImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31451; /* *dual_widen_fmasuv128di */

        case E_V256DImode:
          if (pattern137 (x2, 
E_V256DImode, 
E_V256SImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31452; /* *dual_widen_fmasuv256di */

        case E_V512DImode:
          if (pattern137 (x2, 
E_V512DImode, 
E_V512SImode) != 0
              || !(
#line 983 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31453; /* *dual_widen_fmasuv512di */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x8 = XEXP (x2, 1);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8HImode:
          if (pattern138 (x2, 
E_RVVM8HImode, 
E_RVVM4QImode) != 0
              || !
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31502; /* *single_widen_fmasrvvm8hi */

        case E_RVVM4HImode:
          if (pattern138 (x2, 
E_RVVM4HImode, 
E_RVVM2QImode) != 0
              || !
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31504; /* *single_widen_fmasrvvm4hi */

        case E_RVVM2HImode:
          if (pattern138 (x2, 
E_RVVM2HImode, 
E_RVVM1QImode) != 0
              || !
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31506; /* *single_widen_fmasrvvm2hi */

        case E_RVVM1HImode:
          if (pattern138 (x2, 
E_RVVM1HImode, 
E_RVVMF2QImode) != 0
              || !
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31508; /* *single_widen_fmasrvvm1hi */

        case E_RVVMF2HImode:
          if (pattern138 (x2, 
E_RVVMF2HImode, 
E_RVVMF4QImode) != 0
              || !
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31510; /* *single_widen_fmasrvvmf2hi */

        case E_RVVMF4HImode:
          if (pattern138 (x2, 
E_RVVMF4HImode, 
E_RVVMF8QImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31512; /* *single_widen_fmasrvvmf4hi */

        case E_RVVM8SImode:
          if (pattern138 (x2, 
E_RVVM8SImode, 
E_RVVM4HImode) != 0
              || !
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31514; /* *single_widen_fmasrvvm8si */

        case E_RVVM4SImode:
          if (pattern138 (x2, 
E_RVVM4SImode, 
E_RVVM2HImode) != 0
              || !
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31516; /* *single_widen_fmasrvvm4si */

        case E_RVVM2SImode:
          if (pattern138 (x2, 
E_RVVM2SImode, 
E_RVVM1HImode) != 0
              || !
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31518; /* *single_widen_fmasrvvm2si */

        case E_RVVM1SImode:
          if (pattern138 (x2, 
E_RVVM1SImode, 
E_RVVMF2HImode) != 0
              || !
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 31520; /* *single_widen_fmasrvvm1si */

        case E_RVVMF2SImode:
          if (pattern138 (x2, 
E_RVVMF2SImode, 
E_RVVMF4HImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31522; /* *single_widen_fmasrvvmf2si */

        case E_RVVM8DImode:
          if (pattern138 (x2, 
E_RVVM8DImode, 
E_RVVM4SImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31524; /* *single_widen_fmasrvvm8di */

        case E_RVVM4DImode:
          if (pattern138 (x2, 
E_RVVM4DImode, 
E_RVVM2SImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31526; /* *single_widen_fmasrvvm4di */

        case E_RVVM2DImode:
          if (pattern138 (x2, 
E_RVVM2DImode, 
E_RVVM1SImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31528; /* *single_widen_fmasrvvm2di */

        case E_RVVM1DImode:
          if (pattern138 (x2, 
E_RVVM1DImode, 
E_RVVMF2SImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31530; /* *single_widen_fmasrvvm1di */

        case E_V1HImode:
          if (pattern138 (x2, 
E_V1HImode, 
E_V1QImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 31532; /* *single_widen_fmasv1hi */

        case E_V2HImode:
          if (pattern138 (x2, 
E_V2HImode, 
E_V2QImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 31534; /* *single_widen_fmasv2hi */

        case E_V4HImode:
          if (pattern138 (x2, 
E_V4HImode, 
E_V4QImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 31536; /* *single_widen_fmasv4hi */

        case E_V8HImode:
          if (pattern138 (x2, 
E_V8HImode, 
E_V8QImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 31538; /* *single_widen_fmasv8hi */

        case E_V16HImode:
          if (pattern138 (x2, 
E_V16HImode, 
E_V16QImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 31540; /* *single_widen_fmasv16hi */

        case E_V32HImode:
          if (pattern138 (x2, 
E_V32HImode, 
E_V32QImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31542; /* *single_widen_fmasv32hi */

        case E_V64HImode:
          if (pattern138 (x2, 
E_V64HImode, 
E_V64QImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31544; /* *single_widen_fmasv64hi */

        case E_V128HImode:
          if (pattern138 (x2, 
E_V128HImode, 
E_V128QImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31546; /* *single_widen_fmasv128hi */

        case E_V256HImode:
          if (pattern138 (x2, 
E_V256HImode, 
E_V256QImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31548; /* *single_widen_fmasv256hi */

        case E_V512HImode:
          if (pattern138 (x2, 
E_V512HImode, 
E_V512QImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31550; /* *single_widen_fmasv512hi */

        case E_V1024HImode:
          if (pattern138 (x2, 
E_V1024HImode, 
E_V1024QImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31552; /* *single_widen_fmasv1024hi */

        case E_V2048HImode:
          if (pattern138 (x2, 
E_V2048HImode, 
E_V2048QImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31554; /* *single_widen_fmasv2048hi */

        case E_V1SImode:
          if (pattern138 (x2, 
E_V1SImode, 
E_V1HImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 31556; /* *single_widen_fmasv1si */

        case E_V2SImode:
          if (pattern138 (x2, 
E_V2SImode, 
E_V2HImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 31558; /* *single_widen_fmasv2si */

        case E_V4SImode:
          if (pattern138 (x2, 
E_V4SImode, 
E_V4HImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 31560; /* *single_widen_fmasv4si */

        case E_V8SImode:
          if (pattern138 (x2, 
E_V8SImode, 
E_V8HImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 31562; /* *single_widen_fmasv8si */

        case E_V16SImode:
          if (pattern138 (x2, 
E_V16SImode, 
E_V16HImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31564; /* *single_widen_fmasv16si */

        case E_V32SImode:
          if (pattern138 (x2, 
E_V32SImode, 
E_V32HImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31566; /* *single_widen_fmasv32si */

        case E_V64SImode:
          if (pattern138 (x2, 
E_V64SImode, 
E_V64HImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31568; /* *single_widen_fmasv64si */

        case E_V128SImode:
          if (pattern138 (x2, 
E_V128SImode, 
E_V128HImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31570; /* *single_widen_fmasv128si */

        case E_V256SImode:
          if (pattern138 (x2, 
E_V256SImode, 
E_V256HImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31572; /* *single_widen_fmasv256si */

        case E_V512SImode:
          if (pattern138 (x2, 
E_V512SImode, 
E_V512HImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31574; /* *single_widen_fmasv512si */

        case E_V1024SImode:
          if (pattern138 (x2, 
E_V1024SImode, 
E_V1024HImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31576; /* *single_widen_fmasv1024si */

        case E_V1DImode:
          if (pattern138 (x2, 
E_V1DImode, 
E_V1SImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31578; /* *single_widen_fmasv1di */

        case E_V2DImode:
          if (pattern138 (x2, 
E_V2DImode, 
E_V2SImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31580; /* *single_widen_fmasv2di */

        case E_V4DImode:
          if (pattern138 (x2, 
E_V4DImode, 
E_V4SImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31582; /* *single_widen_fmasv4di */

        case E_V8DImode:
          if (pattern138 (x2, 
E_V8DImode, 
E_V8SImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31584; /* *single_widen_fmasv8di */

        case E_V16DImode:
          if (pattern138 (x2, 
E_V16DImode, 
E_V16SImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31586; /* *single_widen_fmasv16di */

        case E_V32DImode:
          if (pattern138 (x2, 
E_V32DImode, 
E_V32SImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31588; /* *single_widen_fmasv32di */

        case E_V64DImode:
          if (pattern138 (x2, 
E_V64DImode, 
E_V64SImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31590; /* *single_widen_fmasv64di */

        case E_V128DImode:
          if (pattern138 (x2, 
E_V128DImode, 
E_V128SImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31592; /* *single_widen_fmasv128di */

        case E_V256DImode:
          if (pattern138 (x2, 
E_V256DImode, 
E_V256SImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31594; /* *single_widen_fmasv256di */

        case E_V512DImode:
          if (pattern138 (x2, 
E_V512DImode, 
E_V512SImode) != 0
              || !(
#line 1029 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31596; /* *single_widen_fmasv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[2] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      return recog_17 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_19 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      switch (pattern239 (x2))
        {
        case 0:
          if (!
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30434; /* *single_widen_subsrvvm8hi */

        case 1:
          if (!
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30436; /* *single_widen_subsrvvm4hi */

        case 2:
          if (!
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30438; /* *single_widen_subsrvvm2hi */

        case 3:
          if (!
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30440; /* *single_widen_subsrvvm1hi */

        case 4:
          if (!
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30442; /* *single_widen_subsrvvmf2hi */

        case 5:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30444; /* *single_widen_subsrvvmf4hi */

        case 6:
          if (!
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30446; /* *single_widen_subsrvvm8si */

        case 7:
          if (!
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30448; /* *single_widen_subsrvvm4si */

        case 8:
          if (!
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30450; /* *single_widen_subsrvvm2si */

        case 9:
          if (!
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30452; /* *single_widen_subsrvvm1si */

        case 10:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30454; /* *single_widen_subsrvvmf2si */

        case 11:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30456; /* *single_widen_subsrvvm8di */

        case 12:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30458; /* *single_widen_subsrvvm4di */

        case 13:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30460; /* *single_widen_subsrvvm2di */

        case 14:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30462; /* *single_widen_subsrvvm1di */

        case 15:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 30464; /* *single_widen_subsv1hi */

        case 16:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 30466; /* *single_widen_subsv2hi */

        case 17:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 30468; /* *single_widen_subsv4hi */

        case 18:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 30470; /* *single_widen_subsv8hi */

        case 19:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 30472; /* *single_widen_subsv16hi */

        case 20:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30474; /* *single_widen_subsv32hi */

        case 21:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30476; /* *single_widen_subsv64hi */

        case 22:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30478; /* *single_widen_subsv128hi */

        case 23:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30480; /* *single_widen_subsv256hi */

        case 24:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30482; /* *single_widen_subsv512hi */

        case 25:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30484; /* *single_widen_subsv1024hi */

        case 26:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30486; /* *single_widen_subsv2048hi */

        case 27:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 30488; /* *single_widen_subsv1si */

        case 28:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 30490; /* *single_widen_subsv2si */

        case 29:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 30492; /* *single_widen_subsv4si */

        case 30:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 30494; /* *single_widen_subsv8si */

        case 31:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30496; /* *single_widen_subsv16si */

        case 32:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30498; /* *single_widen_subsv32si */

        case 33:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30500; /* *single_widen_subsv64si */

        case 34:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30502; /* *single_widen_subsv128si */

        case 35:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30504; /* *single_widen_subsv256si */

        case 36:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30506; /* *single_widen_subsv512si */

        case 37:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30508; /* *single_widen_subsv1024si */

        case 38:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30510; /* *single_widen_subsv1di */

        case 39:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30512; /* *single_widen_subsv2di */

        case 40:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30514; /* *single_widen_subsv4di */

        case 41:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30516; /* *single_widen_subsv8di */

        case 42:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30518; /* *single_widen_subsv16di */

        case 43:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30520; /* *single_widen_subsv32di */

        case 44:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30522; /* *single_widen_subsv64di */

        case 45:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30524; /* *single_widen_subsv128di */

        case 46:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30526; /* *single_widen_subsv256di */

        case 47:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30528; /* *single_widen_subsv512di */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern239 (x2))
        {
        case 0:
          if (!
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30435; /* *single_widen_suburvvm8hi */

        case 1:
          if (!
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30437; /* *single_widen_suburvvm4hi */

        case 2:
          if (!
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30439; /* *single_widen_suburvvm2hi */

        case 3:
          if (!
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30441; /* *single_widen_suburvvm1hi */

        case 4:
          if (!
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30443; /* *single_widen_suburvvmf2hi */

        case 5:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30445; /* *single_widen_suburvvmf4hi */

        case 6:
          if (!
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30447; /* *single_widen_suburvvm8si */

        case 7:
          if (!
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30449; /* *single_widen_suburvvm4si */

        case 8:
          if (!
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30451; /* *single_widen_suburvvm2si */

        case 9:
          if (!
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
            return -1;
          return 30453; /* *single_widen_suburvvm1si */

        case 10:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30455; /* *single_widen_suburvvmf2si */

        case 11:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30457; /* *single_widen_suburvvm8di */

        case 12:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30459; /* *single_widen_suburvvm4di */

        case 13:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30461; /* *single_widen_suburvvm2di */

        case 14:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30463; /* *single_widen_suburvvm1di */

        case 15:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 30465; /* *single_widen_subuv1hi */

        case 16:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 30467; /* *single_widen_subuv2hi */

        case 17:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 30469; /* *single_widen_subuv4hi */

        case 18:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 30471; /* *single_widen_subuv8hi */

        case 19:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 30473; /* *single_widen_subuv16hi */

        case 20:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30475; /* *single_widen_subuv32hi */

        case 21:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30477; /* *single_widen_subuv64hi */

        case 22:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30479; /* *single_widen_subuv128hi */

        case 23:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30481; /* *single_widen_subuv256hi */

        case 24:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30483; /* *single_widen_subuv512hi */

        case 25:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30485; /* *single_widen_subuv1024hi */

        case 26:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30487; /* *single_widen_subuv2048hi */

        case 27:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 30489; /* *single_widen_subuv1si */

        case 28:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 30491; /* *single_widen_subuv2si */

        case 29:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 30493; /* *single_widen_subuv4si */

        case 30:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 30495; /* *single_widen_subuv8si */

        case 31:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30497; /* *single_widen_subuv16si */

        case 32:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30499; /* *single_widen_subuv32si */

        case 33:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30501; /* *single_widen_subuv64si */

        case 34:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30503; /* *single_widen_subuv128si */

        case 35:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30505; /* *single_widen_subuv256si */

        case 36:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30507; /* *single_widen_subuv512si */

        case 37:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30509; /* *single_widen_subuv1024si */

        case 38:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30511; /* *single_widen_subuv1di */

        case 39:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30513; /* *single_widen_subuv2di */

        case 40:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 30515; /* *single_widen_subuv4di */

        case 41:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 30517; /* *single_widen_subuv8di */

        case 42:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 30519; /* *single_widen_subuv16di */

        case 43:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 30521; /* *single_widen_subuv32di */

        case 44:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 30523; /* *single_widen_subuv64di */

        case 45:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 30525; /* *single_widen_subuv128di */

        case 46:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 30527; /* *single_widen_subuv256di */

        case 47:
          if (!(
#line 629 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 30529; /* *single_widen_subuv512di */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      switch (pattern240 (x2))
        {
        case 0:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31034; /* *single_widen_subrvvm8sf */

        case 1:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31035; /* *single_widen_subrvvm4sf */

        case 2:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31036; /* *single_widen_subrvvm2sf */

        case 3:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31037; /* *single_widen_subrvvm1sf */

        case 4:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 31038; /* *single_widen_subrvvmf2sf */

        case 5:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31039; /* *single_widen_subrvvm8df */

        case 6:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31040; /* *single_widen_subrvvm4df */

        case 7:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31041; /* *single_widen_subrvvm2df */

        case 8:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31042; /* *single_widen_subrvvm1df */

        case 9:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31043; /* *single_widen_subv1sf */

        case 10:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31044; /* *single_widen_subv2sf */

        case 11:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31045; /* *single_widen_subv4sf */

        case 12:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 31046; /* *single_widen_subv8sf */

        case 13:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31047; /* *single_widen_subv16sf */

        case 14:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31048; /* *single_widen_subv32sf */

        case 15:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31049; /* *single_widen_subv64sf */

        case 16:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31050; /* *single_widen_subv128sf */

        case 17:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31051; /* *single_widen_subv256sf */

        case 18:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31052; /* *single_widen_subv512sf */

        case 19:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31053; /* *single_widen_subv1024sf */

        case 20:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31054; /* *single_widen_subv1df */

        case 21:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31055; /* *single_widen_subv2df */

        case 22:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 31056; /* *single_widen_subv4df */

        case 23:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 31057; /* *single_widen_subv8df */

        case 24:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 31058; /* *single_widen_subv16df */

        case 25:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 31059; /* *single_widen_subv32df */

        case 26:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 31060; /* *single_widen_subv64df */

        case 27:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 31061; /* *single_widen_subv128df */

        case 28:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 31062; /* *single_widen_subv256df */

        case 29:
          if (!(
#line 792 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 31063; /* *single_widen_subv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (XWINT (x5, 0) != 0L)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      switch (pattern444 (x2))
        {
        case 0:
          if (!
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19949; /* *pred_extract_firstrvvm8qi */

        case 1:
          if (!
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19950; /* *pred_extract_firstrvvm4qi */

        case 2:
          if (!
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19951; /* *pred_extract_firstrvvm2qi */

        case 3:
          if (!
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19952; /* *pred_extract_firstrvvm1qi */

        case 4:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 19965; /* *pred_extract_firstrvvmf2qi */

        case 5:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 19966; /* *pred_extract_firstrvvmf4qi */

        case 6:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 19967; /* *pred_extract_firstrvvmf8qi */

        case 7:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 19971; /* *pred_extract_firstv1qi */

        case 8:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 19972; /* *pred_extract_firstv2qi */

        case 9:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 19973; /* *pred_extract_firstv4qi */

        case 10:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 19974; /* *pred_extract_firstv8qi */

        case 11:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 19975; /* *pred_extract_firstv16qi */

        case 12:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 19976; /* *pred_extract_firstv32qi */

        case 13:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19977; /* *pred_extract_firstv64qi */

        case 14:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19978; /* *pred_extract_firstv128qi */

        case 15:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19979; /* *pred_extract_firstv256qi */

        case 16:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19980; /* *pred_extract_firstv512qi */

        case 17:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19981; /* *pred_extract_firstv1024qi */

        case 18:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19982; /* *pred_extract_firstv2048qi */

        case 19:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19983; /* *pred_extract_firstv4096qi */

        default:
          return -1;
        }

    case E_HImode:
      switch (pattern445 (x2))
        {
        case 0:
          if (!
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19953; /* *pred_extract_firstrvvm8hi */

        case 1:
          if (!
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19954; /* *pred_extract_firstrvvm4hi */

        case 2:
          if (!
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19955; /* *pred_extract_firstrvvm2hi */

        case 3:
          if (!
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19956; /* *pred_extract_firstrvvm1hi */

        case 4:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 19968; /* *pred_extract_firstrvvmf2hi */

        case 5:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 19969; /* *pred_extract_firstrvvmf4hi */

        case 6:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 19984; /* *pred_extract_firstv1hi */

        case 7:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 19985; /* *pred_extract_firstv2hi */

        case 8:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 19986; /* *pred_extract_firstv4hi */

        case 9:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 19987; /* *pred_extract_firstv8hi */

        case 10:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 19988; /* *pred_extract_firstv16hi */

        case 11:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19989; /* *pred_extract_firstv32hi */

        case 12:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19990; /* *pred_extract_firstv64hi */

        case 13:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19991; /* *pred_extract_firstv128hi */

        case 14:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19992; /* *pred_extract_firstv256hi */

        case 15:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19993; /* *pred_extract_firstv512hi */

        case 16:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19994; /* *pred_extract_firstv1024hi */

        case 17:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19995; /* *pred_extract_firstv2048hi */

        default:
          return -1;
        }

    case E_SImode:
      switch (pattern446 (x2))
        {
        case 0:
          if (!
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19957; /* *pred_extract_firstrvvm8si */

        case 1:
          if (!
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19958; /* *pred_extract_firstrvvm4si */

        case 2:
          if (!
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19959; /* *pred_extract_firstrvvm2si */

        case 3:
          if (!
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 19960; /* *pred_extract_firstrvvm1si */

        case 4:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 19970; /* *pred_extract_firstrvvmf2si */

        case 5:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 19996; /* *pred_extract_firstv1si */

        case 6:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 19997; /* *pred_extract_firstv2si */

        case 7:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 19998; /* *pred_extract_firstv4si */

        case 8:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 19999; /* *pred_extract_firstv8si */

        case 9:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20000; /* *pred_extract_firstv16si */

        case 10:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20001; /* *pred_extract_firstv32si */

        case 11:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20002; /* *pred_extract_firstv64si */

        case 12:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20003; /* *pred_extract_firstv128si */

        case 13:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20004; /* *pred_extract_firstv256si */

        case 14:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20005; /* *pred_extract_firstv512si */

        case 15:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20006; /* *pred_extract_firstv1024si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern447 (x2))
        {
        case 0:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19961; /* *pred_extract_firstrvvm8di */

        case 1:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19962; /* *pred_extract_firstrvvm4di */

        case 2:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19963; /* *pred_extract_firstrvvm2di */

        case 3:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19964; /* *pred_extract_firstrvvm1di */

        case 4:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20007; /* *pred_extract_firstv1di */

        case 5:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20008; /* *pred_extract_firstv2di */

        case 6:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20009; /* *pred_extract_firstv4di */

        case 7:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20010; /* *pred_extract_firstv8di */

        case 8:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20011; /* *pred_extract_firstv16di */

        case 9:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20012; /* *pred_extract_firstv32di */

        case 10:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20013; /* *pred_extract_firstv64di */

        case 11:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20014; /* *pred_extract_firstv128di */

        case 12:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20015; /* *pred_extract_firstv256di */

        case 13:
          if (!(
#line 8031 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20016; /* *pred_extract_firstv512di */

        default:
          return -1;
        }

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x2) != E_HFmode
          || GET_MODE (x3) != E_HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_RVVM8HFmode:
          if (!register_operand (operands[1], E_RVVM8HFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20031; /* *pred_extract_firstrvvm8hf */

        case E_RVVM4HFmode:
          if (!register_operand (operands[1], E_RVVM4HFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20032; /* *pred_extract_firstrvvm4hf */

        case E_RVVM2HFmode:
          if (!register_operand (operands[1], E_RVVM2HFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20033; /* *pred_extract_firstrvvm2hf */

        case E_RVVM1HFmode:
          if (!register_operand (operands[1], E_RVVM1HFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20034; /* *pred_extract_firstrvvm1hf */

        case E_RVVMF2HFmode:
          if (!register_operand (operands[1], E_RVVMF2HFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 20035; /* *pred_extract_firstrvvmf2hf */

        case E_RVVMF4HFmode:
          if (!register_operand (operands[1], E_RVVMF4HFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20036; /* *pred_extract_firstrvvmf4hf */

        case E_V1HFmode:
          if (!register_operand (operands[1], E_V1HFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 20046; /* *pred_extract_firstv1hf */

        case E_V2HFmode:
          if (!register_operand (operands[1], E_V2HFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 20047; /* *pred_extract_firstv2hf */

        case E_V4HFmode:
          if (!register_operand (operands[1], E_V4HFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 20048; /* *pred_extract_firstv4hf */

        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 20049; /* *pred_extract_firstv8hf */

        case E_V16HFmode:
          if (!register_operand (operands[1], E_V16HFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 20050; /* *pred_extract_firstv16hf */

        case E_V32HFmode:
          if (!register_operand (operands[1], E_V32HFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20051; /* *pred_extract_firstv32hf */

        case E_V64HFmode:
          if (!register_operand (operands[1], E_V64HFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20052; /* *pred_extract_firstv64hf */

        case E_V128HFmode:
          if (!register_operand (operands[1], E_V128HFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20053; /* *pred_extract_firstv128hf */

        case E_V256HFmode:
          if (!register_operand (operands[1], E_V256HFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20054; /* *pred_extract_firstv256hf */

        case E_V512HFmode:
          if (!register_operand (operands[1], E_V512HFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20055; /* *pred_extract_firstv512hf */

        case E_V1024HFmode:
          if (!register_operand (operands[1], E_V1024HFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20056; /* *pred_extract_firstv1024hf */

        case E_V2048HFmode:
          if (!register_operand (operands[1], E_V2048HFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20057; /* *pred_extract_firstv2048hf */

        default:
          return -1;
        }

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || GET_MODE (x3) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_RVVM8SFmode:
          if (!register_operand (operands[1], E_RVVM8SFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20037; /* *pred_extract_firstrvvm8sf */

        case E_RVVM4SFmode:
          if (!register_operand (operands[1], E_RVVM4SFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20038; /* *pred_extract_firstrvvm4sf */

        case E_RVVM2SFmode:
          if (!register_operand (operands[1], E_RVVM2SFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20039; /* *pred_extract_firstrvvm2sf */

        case E_RVVM1SFmode:
          if (!register_operand (operands[1], E_RVVM1SFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20040; /* *pred_extract_firstrvvm1sf */

        case E_RVVMF2SFmode:
          if (!register_operand (operands[1], E_RVVMF2SFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 20041; /* *pred_extract_firstrvvmf2sf */

        case E_V1SFmode:
          if (!register_operand (operands[1], E_V1SFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20058; /* *pred_extract_firstv1sf */

        case E_V2SFmode:
          if (!register_operand (operands[1], E_V2SFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20059; /* *pred_extract_firstv2sf */

        case E_V4SFmode:
          if (!register_operand (operands[1], E_V4SFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20060; /* *pred_extract_firstv4sf */

        case E_V8SFmode:
          if (!register_operand (operands[1], E_V8SFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 20061; /* *pred_extract_firstv8sf */

        case E_V16SFmode:
          if (!register_operand (operands[1], E_V16SFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20062; /* *pred_extract_firstv16sf */

        case E_V32SFmode:
          if (!register_operand (operands[1], E_V32SFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20063; /* *pred_extract_firstv32sf */

        case E_V64SFmode:
          if (!register_operand (operands[1], E_V64SFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20064; /* *pred_extract_firstv64sf */

        case E_V128SFmode:
          if (!register_operand (operands[1], E_V128SFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20065; /* *pred_extract_firstv128sf */

        case E_V256SFmode:
          if (!register_operand (operands[1], E_V256SFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20066; /* *pred_extract_firstv256sf */

        case E_V512SFmode:
          if (!register_operand (operands[1], E_V512SFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20067; /* *pred_extract_firstv512sf */

        case E_V1024SFmode:
          if (!register_operand (operands[1], E_V1024SFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20068; /* *pred_extract_firstv1024sf */

        default:
          return -1;
        }

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode
          || GET_MODE (x3) != E_DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_RVVM8DFmode:
          if (!register_operand (operands[1], E_RVVM8DFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20042; /* *pred_extract_firstrvvm8df */

        case E_RVVM4DFmode:
          if (!register_operand (operands[1], E_RVVM4DFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20043; /* *pred_extract_firstrvvm4df */

        case E_RVVM2DFmode:
          if (!register_operand (operands[1], E_RVVM2DFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20044; /* *pred_extract_firstrvvm2df */

        case E_RVVM1DFmode:
          if (!register_operand (operands[1], E_RVVM1DFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20045; /* *pred_extract_firstrvvm1df */

        case E_V1DFmode:
          if (!register_operand (operands[1], E_V1DFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20069; /* *pred_extract_firstv1df */

        case E_V2DFmode:
          if (!register_operand (operands[1], E_V2DFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20070; /* *pred_extract_firstv2df */

        case E_V4DFmode:
          if (!register_operand (operands[1], E_V4DFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 20071; /* *pred_extract_firstv4df */

        case E_V8DFmode:
          if (!register_operand (operands[1], E_V8DFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 20072; /* *pred_extract_firstv8df */

        case E_V16DFmode:
          if (!register_operand (operands[1], E_V16DFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 20073; /* *pred_extract_firstv16df */

        case E_V32DFmode:
          if (!register_operand (operands[1], E_V32DFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 20074; /* *pred_extract_firstv32df */

        case E_V64DFmode:
          if (!register_operand (operands[1], E_V64DFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 20075; /* *pred_extract_firstv64df */

        case E_V128DFmode:
          if (!register_operand (operands[1], E_V128DFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 20076; /* *pred_extract_firstv128df */

        case E_V256DFmode:
          if (!register_operand (operands[1], E_V256DFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 20077; /* *pred_extract_firstv256df */

        case E_V512DFmode:
          if (!register_operand (operands[1], E_V512DFmode)
              || !(
#line 8094 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 20078; /* *pred_extract_firstv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 10)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (GET_MODE (x3) != E_SImode
          || !symbolic_operand (operands[0], E_SImode)
          || !(
#line 2400 "../../gcc/config/riscv/riscv.md"
(TARGET_TLSDESC) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
        return -1;
      *pnum_clobbers = 1;
      return 268; /* tlsdescsi */

    case E_DImode:
      if (GET_MODE (x3) != E_DImode
          || !symbolic_operand (operands[0], E_DImode)
          || !(
#line 2400 "../../gcc/config/riscv/riscv.md"
(TARGET_TLSDESC) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
        return -1;
      *pnum_clobbers = 1;
      return 269; /* tlsdescdi */

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern589 (x2, 
E_RVVMF32BImode) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_RVVMF4QImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF4QImode
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !
#line 3496 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8694; /* pred_madcrvvmf4qi_scalar */

    case E_RVVMF2HImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVMF2HImode
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_RVVMF2HImode)
          || !
#line 3496 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8700; /* pred_madcrvvmf2hi_scalar */

    case E_RVVM1SImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM1SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_RVVM1SImode)
          || !
#line 3496 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 8705; /* pred_madcrvvm1si_scalar */

    case E_RVVM2DImode:
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_RVVM2DImode
          || !reg_or_0_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_RVVM2DImode)
          || !(
#line 3567 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 8799; /* *pred_madcrvvm2di_scalar */

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18673; /* pred_redmin_vl0srvvm8qi */

        case 1:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18681; /* pred_redmin_vl0srvvm4qi */

        case 2:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18689; /* pred_redmin_vl0srvvm2qi */

        case 3:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18697; /* pred_redmin_vl0srvvm1qi */

        case 4:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18801; /* pred_redmin_vl0srvvmf2qi */

        case 5:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18809; /* pred_redmin_vl0srvvmf4qi */

        case 6:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18817; /* pred_redmin_vl0srvvmf8qi */

        case 7:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18849; /* pred_redmin_vl0sv1qi */

        case 8:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18857; /* pred_redmin_vl0sv2qi */

        case 9:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18865; /* pred_redmin_vl0sv4qi */

        case 10:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18873; /* pred_redmin_vl0sv8qi */

        case 11:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18881; /* pred_redmin_vl0sv16qi */

        case 12:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18889; /* pred_redmin_vl0sv32qi */

        case 13:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18897; /* pred_redmin_vl0sv64qi */

        case 14:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18905; /* pred_redmin_vl0sv128qi */

        case 15:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18913; /* pred_redmin_vl0sv256qi */

        case 16:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18921; /* pred_redmin_vl0sv512qi */

        case 17:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18929; /* pred_redmin_vl0sv1024qi */

        case 18:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18937; /* pred_redmin_vl0sv2048qi */

        case 19:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18945; /* pred_redmin_vl0sv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18705; /* pred_redmin_vl0srvvm8hi */

        case 1:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18713; /* pred_redmin_vl0srvvm4hi */

        case 2:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18721; /* pred_redmin_vl0srvvm2hi */

        case 3:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18729; /* pred_redmin_vl0srvvm1hi */

        case 4:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18825; /* pred_redmin_vl0srvvmf2hi */

        case 5:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18833; /* pred_redmin_vl0srvvmf4hi */

        case 6:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18953; /* pred_redmin_vl0sv1hi */

        case 7:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18961; /* pred_redmin_vl0sv2hi */

        case 8:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18969; /* pred_redmin_vl0sv4hi */

        case 9:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18977; /* pred_redmin_vl0sv8hi */

        case 10:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18985; /* pred_redmin_vl0sv16hi */

        case 11:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18993; /* pred_redmin_vl0sv32hi */

        case 12:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19001; /* pred_redmin_vl0sv64hi */

        case 13:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19009; /* pred_redmin_vl0sv128hi */

        case 14:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19017; /* pred_redmin_vl0sv256hi */

        case 15:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19025; /* pred_redmin_vl0sv512hi */

        case 16:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19033; /* pred_redmin_vl0sv1024hi */

        case 17:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19041; /* pred_redmin_vl0sv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18737; /* pred_redmin_vl0srvvm8si */

        case 1:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18745; /* pred_redmin_vl0srvvm4si */

        case 2:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18753; /* pred_redmin_vl0srvvm2si */

        case 3:
          if (!
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18761; /* pred_redmin_vl0srvvm1si */

        case 4:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18841; /* pred_redmin_vl0srvvmf2si */

        case 5:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 19049; /* pred_redmin_vl0sv1si */

        case 6:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 19057; /* pred_redmin_vl0sv2si */

        case 7:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 19065; /* pred_redmin_vl0sv4si */

        case 8:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 19073; /* pred_redmin_vl0sv8si */

        case 9:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19081; /* pred_redmin_vl0sv16si */

        case 10:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19089; /* pred_redmin_vl0sv32si */

        case 11:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19097; /* pred_redmin_vl0sv64si */

        case 12:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19105; /* pred_redmin_vl0sv128si */

        case 13:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19113; /* pred_redmin_vl0sv256si */

        case 14:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19121; /* pred_redmin_vl0sv512si */

        case 15:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19129; /* pred_redmin_vl0sv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18769; /* pred_redmin_vl0srvvm8di */

        case 1:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18777; /* pred_redmin_vl0srvvm4di */

        case 2:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18785; /* pred_redmin_vl0srvvm2di */

        case 3:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18793; /* pred_redmin_vl0srvvm1di */

        case 4:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19137; /* pred_redmin_vl0sv1di */

        case 5:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19145; /* pred_redmin_vl0sv2di */

        case 6:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19153; /* pred_redmin_vl0sv4di */

        case 7:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19161; /* pred_redmin_vl0sv8di */

        case 8:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19169; /* pred_redmin_vl0sv16di */

        case 9:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19177; /* pred_redmin_vl0sv32di */

        case 10:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19185; /* pred_redmin_vl0sv64di */

        case 11:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19193; /* pred_redmin_vl0sv128di */

        case 12:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19201; /* pred_redmin_vl0sv256di */

        case 13:
          if (!(
#line 7803 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19209; /* pred_redmin_vl0sv512di */

        default:
          return -1;
        }

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern681 (x2, 
E_RVVM1HFmode))
        {
        case 0:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19526; /* pred_redmin_vl0srvvm8hf */

        case 1:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19528; /* pred_redmin_vl0srvvm4hf */

        case 2:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19530; /* pred_redmin_vl0srvvm2hf */

        case 3:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19532; /* pred_redmin_vl0srvvm1hf */

        case 4:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19534; /* pred_redmin_vl0srvvmf2hf */

        case 5:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19536; /* pred_redmin_vl0srvvmf4hf */

        case 6:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 19556; /* pred_redmin_vl0sv1hf */

        case 7:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 19558; /* pred_redmin_vl0sv2hf */

        case 8:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 19560; /* pred_redmin_vl0sv4hf */

        case 9:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 19562; /* pred_redmin_vl0sv8hf */

        case 10:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 19564; /* pred_redmin_vl0sv16hf */

        case 11:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19566; /* pred_redmin_vl0sv32hf */

        case 12:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19568; /* pred_redmin_vl0sv64hf */

        case 13:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19570; /* pred_redmin_vl0sv128hf */

        case 14:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19572; /* pred_redmin_vl0sv256hf */

        case 15:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19574; /* pred_redmin_vl0sv512hf */

        case 16:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19576; /* pred_redmin_vl0sv1024hf */

        case 17:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19578; /* pred_redmin_vl0sv2048hf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern682 (x2, 
E_RVVM1SFmode))
        {
        case 0:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19538; /* pred_redmin_vl0srvvm8sf */

        case 1:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19540; /* pred_redmin_vl0srvvm4sf */

        case 2:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19542; /* pred_redmin_vl0srvvm2sf */

        case 3:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19544; /* pred_redmin_vl0srvvm1sf */

        case 4:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19546; /* pred_redmin_vl0srvvmf2sf */

        case 5:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19580; /* pred_redmin_vl0sv1sf */

        case 6:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19582; /* pred_redmin_vl0sv2sf */

        case 7:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19584; /* pred_redmin_vl0sv4sf */

        case 8:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19586; /* pred_redmin_vl0sv8sf */

        case 9:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19588; /* pred_redmin_vl0sv16sf */

        case 10:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19590; /* pred_redmin_vl0sv32sf */

        case 11:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19592; /* pred_redmin_vl0sv64sf */

        case 12:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19594; /* pred_redmin_vl0sv128sf */

        case 13:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19596; /* pred_redmin_vl0sv256sf */

        case 14:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19598; /* pred_redmin_vl0sv512sf */

        case 15:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19600; /* pred_redmin_vl0sv1024sf */

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      switch (pattern683 (x2))
        {
        case 0:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19548; /* pred_redmin_vl0srvvm8df */

        case 1:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19550; /* pred_redmin_vl0srvvm4df */

        case 2:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19552; /* pred_redmin_vl0srvvm2df */

        case 3:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19554; /* pred_redmin_vl0srvvm1df */

        case 4:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19602; /* pred_redmin_vl0sv1df */

        case 5:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19604; /* pred_redmin_vl0sv2df */

        case 6:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19606; /* pred_redmin_vl0sv4df */

        case 7:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19608; /* pred_redmin_vl0sv8df */

        case 8:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19610; /* pred_redmin_vl0sv16df */

        case 9:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19612; /* pred_redmin_vl0sv32df */

        case 10:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19614; /* pred_redmin_vl0sv64df */

        case 11:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19616; /* pred_redmin_vl0sv128df */

        case 12:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19618; /* pred_redmin_vl0sv256df */

        case 13:
          if (!(
#line 7889 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19620; /* pred_redmin_vl0sv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      switch (pattern677 (x2, 
E_RVVM1QImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18131; /* pred_redorrvvm8qi */

        case 1:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18139; /* pred_redorrvvm4qi */

        case 2:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18147; /* pred_redorrvvm2qi */

        case 3:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18155; /* pred_redorrvvm1qi */

        case 4:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18259; /* pred_redorrvvmf2qi */

        case 5:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18267; /* pred_redorrvvmf4qi */

        case 6:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18275; /* pred_redorrvvmf8qi */

        case 7:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 18307; /* pred_redorv1qi */

        case 8:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 18315; /* pred_redorv2qi */

        case 9:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 18323; /* pred_redorv4qi */

        case 10:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 18331; /* pred_redorv8qi */

        case 11:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 18339; /* pred_redorv16qi */

        case 12:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 18347; /* pred_redorv32qi */

        case 13:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18355; /* pred_redorv64qi */

        case 14:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18363; /* pred_redorv128qi */

        case 15:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18371; /* pred_redorv256qi */

        case 16:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18379; /* pred_redorv512qi */

        case 17:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18387; /* pred_redorv1024qi */

        case 18:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18395; /* pred_redorv2048qi */

        case 19:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18403; /* pred_redorv4096qi */

        default:
          return -1;
        }

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      switch (pattern678 (x2, 
E_RVVM1HImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18163; /* pred_redorrvvm8hi */

        case 1:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18171; /* pred_redorrvvm4hi */

        case 2:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18179; /* pred_redorrvvm2hi */

        case 3:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18187; /* pred_redorrvvm1hi */

        case 4:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 18283; /* pred_redorrvvmf2hi */

        case 5:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18291; /* pred_redorrvvmf4hi */

        case 6:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 18411; /* pred_redorv1hi */

        case 7:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 18419; /* pred_redorv2hi */

        case 8:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 18427; /* pred_redorv4hi */

        case 9:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 18435; /* pred_redorv8hi */

        case 10:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 18443; /* pred_redorv16hi */

        case 11:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18451; /* pred_redorv32hi */

        case 12:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18459; /* pred_redorv64hi */

        case 13:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18467; /* pred_redorv128hi */

        case 14:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18475; /* pred_redorv256hi */

        case 15:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18483; /* pred_redorv512hi */

        case 16:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18491; /* pred_redorv1024hi */

        case 17:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18499; /* pred_redorv2048hi */

        default:
          return -1;
        }

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      switch (pattern679 (x2, 
E_RVVM1SImode))
        {
        case 0:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18195; /* pred_redorrvvm8si */

        case 1:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18203; /* pred_redorrvvm4si */

        case 2:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18211; /* pred_redorrvvm2si */

        case 3:
          if (!
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 18219; /* pred_redorrvvm1si */

        case 4:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 18299; /* pred_redorrvvmf2si */

        case 5:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 18507; /* pred_redorv1si */

        case 6:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 18515; /* pred_redorv2si */

        case 7:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 18523; /* pred_redorv4si */

        case 8:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 18531; /* pred_redorv8si */

        case 9:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18539; /* pred_redorv16si */

        case 10:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18547; /* pred_redorv32si */

        case 11:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18555; /* pred_redorv64si */

        case 12:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18563; /* pred_redorv128si */

        case 13:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18571; /* pred_redorv256si */

        case 14:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18579; /* pred_redorv512si */

        case 15:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18587; /* pred_redorv1024si */

        default:
          return -1;
        }

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      switch (pattern680 (x2))
        {
        case 0:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18227; /* pred_redorrvvm8di */

        case 1:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18235; /* pred_redorrvvm4di */

        case 2:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18243; /* pred_redorrvvm2di */

        case 3:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18251; /* pred_redorrvvm1di */

        case 4:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18595; /* pred_redorv1di */

        case 5:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18603; /* pred_redorv2di */

        case 6:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 18611; /* pred_redorv4di */

        case 7:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 18619; /* pred_redorv8di */

        case 8:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 18627; /* pred_redorv16di */

        case 9:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 18635; /* pred_redorv32di */

        case 10:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 18643; /* pred_redorv64di */

        case 11:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 18651; /* pred_redorv128di */

        case 12:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 18659; /* pred_redorv256di */

        case 13:
          if (!(
#line 7781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 18667; /* pred_redorv512di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      switch (pattern681 (x2, 
E_RVVM1HFmode))
        {
        case 0:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19622; /* pred_redusumrvvm8hf */

        case 1:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19624; /* pred_redusumrvvm4hf */

        case 2:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19626; /* pred_redusumrvvm2hf */

        case 3:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19628; /* pred_redusumrvvm1hf */

        case 4:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
            return -1;
          return 19630; /* pred_redusumrvvmf2hf */

        case 5:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19632; /* pred_redusumrvvmf4hf */

        case 6:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
            return -1;
          return 19652; /* pred_redusumv1hf */

        case 7:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
            return -1;
          return 19654; /* pred_redusumv2hf */

        case 8:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
            return -1;
          return 19656; /* pred_redusumv4hf */

        case 9:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
            return -1;
          return 19658; /* pred_redusumv8hf */

        case 10:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
            return -1;
          return 19660; /* pred_redusumv16hf */

        case 11:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19662; /* pred_redusumv32hf */

        case 12:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19664; /* pred_redusumv64hf */

        case 13:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19666; /* pred_redusumv128hf */

        case 14:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19668; /* pred_redusumv256hf */

        case 15:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19670; /* pred_redusumv512hf */

        case 16:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19672; /* pred_redusumv1024hf */

        case 17:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19674; /* pred_redusumv2048hf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern682 (x2, 
E_RVVM1SFmode))
        {
        case 0:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19634; /* pred_redusumrvvm8sf */

        case 1:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19636; /* pred_redusumrvvm4sf */

        case 2:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19638; /* pred_redusumrvvm2sf */

        case 3:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19640; /* pred_redusumrvvm1sf */

        case 4:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 19642; /* pred_redusumrvvmf2sf */

        case 5:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19676; /* pred_redusumv1sf */

        case 6:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19678; /* pred_redusumv2sf */

        case 7:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19680; /* pred_redusumv4sf */

        case 8:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 19682; /* pred_redusumv8sf */

        case 9:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19684; /* pred_redusumv16sf */

        case 10:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19686; /* pred_redusumv32sf */

        case 11:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19688; /* pred_redusumv64sf */

        case 12:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19690; /* pred_redusumv128sf */

        case 13:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19692; /* pred_redusumv256sf */

        case 14:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19694; /* pred_redusumv512sf */

        case 15:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19696; /* pred_redusumv1024sf */

        default:
          return -1;
        }

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      switch (pattern683 (x2))
        {
        case 0:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19644; /* pred_redusumrvvm8df */

        case 1:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19646; /* pred_redusumrvvm4df */

        case 2:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19648; /* pred_redusumrvvm2df */

        case 3:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19650; /* pred_redusumrvvm1df */

        case 4:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19698; /* pred_redusumv1df */

        case 5:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19700; /* pred_redusumv2df */

        case 6:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
            return -1;
          return 19702; /* pred_redusumv4df */

        case 7:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 19704; /* pred_redusumv8df */

        case 8:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 19706; /* pred_redusumv16df */

        case 9:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 19708; /* pred_redusumv32df */

        case 10:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 19710; /* pred_redusumv64df */

        case 11:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 19712; /* pred_redusumv128df */

        case 12:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 19714; /* pred_redusumv256df */

        case 13:
          if (!(
#line 7912 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 19716; /* pred_redusumv512df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern451 (x2))
    {
    case 0:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 940; /* pred_th_whole_movrvvm8qi */

    case 1:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 941; /* pred_th_whole_movrvvm4qi */

    case 2:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 942; /* pred_th_whole_movrvvm2qi */

    case 3:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 943; /* pred_th_whole_movrvvm1qi */

    case 4:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 944; /* pred_th_whole_movrvvm8hi */

    case 5:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 945; /* pred_th_whole_movrvvm4hi */

    case 6:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 946; /* pred_th_whole_movrvvm2hi */

    case 7:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 947; /* pred_th_whole_movrvvm1hi */

    case 8:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 948; /* pred_th_whole_movrvvm8si */

    case 9:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 949; /* pred_th_whole_movrvvm4si */

    case 10:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 950; /* pred_th_whole_movrvvm2si */

    case 11:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 951; /* pred_th_whole_movrvvm1si */

    case 12:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 952; /* pred_th_whole_movrvvm8di */

    case 13:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 953; /* pred_th_whole_movrvvm4di */

    case 14:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 954; /* pred_th_whole_movrvvm2di */

    case 15:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 955; /* pred_th_whole_movrvvm1di */

    case 16:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 956; /* pred_th_whole_movrvvmf8qi */

    case 17:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 957; /* pred_th_whole_movrvvmf4hi */

    case 18:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 958; /* pred_th_whole_movrvvmf2si */

    case 19:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 959; /* pred_th_whole_movrvvm8bf */

    case 20:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 960; /* pred_th_whole_movrvvm4bf */

    case 21:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 961; /* pred_th_whole_movrvvm2bf */

    case 22:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 962; /* pred_th_whole_movrvvm1bf */

    case 23:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 963; /* pred_th_whole_movrvvmf2bf */

    case 24:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 964; /* pred_th_whole_movrvvmf4bf */

    case 25:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 965; /* pred_th_whole_movrvvm8hf */

    case 26:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 966; /* pred_th_whole_movrvvm4hf */

    case 27:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 967; /* pred_th_whole_movrvvm2hf */

    case 28:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 968; /* pred_th_whole_movrvvm1hf */

    case 29:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 969; /* pred_th_whole_movrvvmf2hf */

    case 30:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 970; /* pred_th_whole_movrvvmf4hf */

    case 31:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 971; /* pred_th_whole_movrvvm8sf */

    case 32:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 972; /* pred_th_whole_movrvvm4sf */

    case 33:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 973; /* pred_th_whole_movrvvm2sf */

    case 34:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 974; /* pred_th_whole_movrvvm1sf */

    case 35:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 975; /* pred_th_whole_movrvvmf2sf */

    case 36:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 976; /* pred_th_whole_movrvvm8df */

    case 37:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 977; /* pred_th_whole_movrvvm4df */

    case 38:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 978; /* pred_th_whole_movrvvm2df */

    case 39:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 979; /* pred_th_whole_movrvvm1df */

    case 40:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 980; /* pred_th_whole_movv1qi */

    case 41:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 981; /* pred_th_whole_movv2qi */

    case 42:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 982; /* pred_th_whole_movv4qi */

    case 43:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 983; /* pred_th_whole_movv8qi */

    case 44:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 984; /* pred_th_whole_movv16qi */

    case 45:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 985; /* pred_th_whole_movv32qi */

    case 46:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 986; /* pred_th_whole_movv64qi */

    case 47:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 987; /* pred_th_whole_movv128qi */

    case 48:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 988; /* pred_th_whole_movv256qi */

    case 49:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 989; /* pred_th_whole_movv512qi */

    case 50:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 990; /* pred_th_whole_movv1024qi */

    case 51:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 991; /* pred_th_whole_movv2048qi */

    case 52:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 992; /* pred_th_whole_movv4096qi */

    case 53:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 993; /* pred_th_whole_movv1hi */

    case 54:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 994; /* pred_th_whole_movv2hi */

    case 55:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 995; /* pred_th_whole_movv4hi */

    case 56:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 996; /* pred_th_whole_movv8hi */

    case 57:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 997; /* pred_th_whole_movv16hi */

    case 58:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 998; /* pred_th_whole_movv32hi */

    case 59:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 999; /* pred_th_whole_movv64hi */

    case 60:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1000; /* pred_th_whole_movv128hi */

    case 61:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1001; /* pred_th_whole_movv256hi */

    case 62:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1002; /* pred_th_whole_movv512hi */

    case 63:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1003; /* pred_th_whole_movv1024hi */

    case 64:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1004; /* pred_th_whole_movv2048hi */

    case 65:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 1005; /* pred_th_whole_movv1si */

    case 66:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 1006; /* pred_th_whole_movv2si */

    case 67:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 1007; /* pred_th_whole_movv4si */

    case 68:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 1008; /* pred_th_whole_movv8si */

    case 69:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1009; /* pred_th_whole_movv16si */

    case 70:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1010; /* pred_th_whole_movv32si */

    case 71:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1011; /* pred_th_whole_movv64si */

    case 72:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1012; /* pred_th_whole_movv128si */

    case 73:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1013; /* pred_th_whole_movv256si */

    case 74:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1014; /* pred_th_whole_movv512si */

    case 75:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1015; /* pred_th_whole_movv1024si */

    case 76:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1016; /* pred_th_whole_movv1di */

    case 77:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1017; /* pred_th_whole_movv2di */

    case 78:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1018; /* pred_th_whole_movv4di */

    case 79:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1019; /* pred_th_whole_movv8di */

    case 80:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1020; /* pred_th_whole_movv16di */

    case 81:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1021; /* pred_th_whole_movv32di */

    case 82:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1022; /* pred_th_whole_movv64di */

    case 83:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1023; /* pred_th_whole_movv128di */

    case 84:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1024; /* pred_th_whole_movv256di */

    case 85:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1025; /* pred_th_whole_movv512di */

    case 86:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1026; /* pred_th_whole_movv1hf */

    case 87:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1027; /* pred_th_whole_movv2hf */

    case 88:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1028; /* pred_th_whole_movv4hf */

    case 89:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1029; /* pred_th_whole_movv8hf */

    case 90:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1030; /* pred_th_whole_movv16hf */

    case 91:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1031; /* pred_th_whole_movv32hf */

    case 92:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1032; /* pred_th_whole_movv64hf */

    case 93:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1033; /* pred_th_whole_movv128hf */

    case 94:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1034; /* pred_th_whole_movv256hf */

    case 95:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1035; /* pred_th_whole_movv512hf */

    case 96:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1036; /* pred_th_whole_movv1024hf */

    case 97:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1037; /* pred_th_whole_movv2048hf */

    case 98:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1038; /* pred_th_whole_movv1sf */

    case 99:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1039; /* pred_th_whole_movv2sf */

    case 100:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1040; /* pred_th_whole_movv4sf */

    case 101:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1041; /* pred_th_whole_movv8sf */

    case 102:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1042; /* pred_th_whole_movv16sf */

    case 103:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1043; /* pred_th_whole_movv32sf */

    case 104:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1044; /* pred_th_whole_movv64sf */

    case 105:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1045; /* pred_th_whole_movv128sf */

    case 106:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1046; /* pred_th_whole_movv256sf */

    case 107:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 293 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1047; /* pred_th_whole_movv512sf */

    case 108:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1048; /* pred_th_whole_movv1024sf */

    case 109:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1049; /* pred_th_whole_movv1df */

    case 110:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1050; /* pred_th_whole_movv2df */

    case 111:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1051; /* pred_th_whole_movv4df */

    case 112:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1052; /* pred_th_whole_movv8df */

    case 113:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1053; /* pred_th_whole_movv16df */

    case 114:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1054; /* pred_th_whole_movv32df */

    case 115:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1055; /* pred_th_whole_movv64df */

    case 116:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1056; /* pred_th_whole_movv128df */

    case 117:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1057; /* pred_th_whole_movv256df */

    case 118:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1058; /* pred_th_whole_movv512df */

    case 119:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1059; /* pred_th_whole_movrvvmf8x2qi */

    case 120:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1060; /* pred_th_whole_movrvvmf8x3qi */

    case 121:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1061; /* pred_th_whole_movrvvmf8x4qi */

    case 122:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1062; /* pred_th_whole_movrvvmf8x5qi */

    case 123:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1063; /* pred_th_whole_movrvvmf8x6qi */

    case 124:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1064; /* pred_th_whole_movrvvmf8x7qi */

    case 125:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1065; /* pred_th_whole_movrvvmf8x8qi */

    case 126:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1066; /* pred_th_whole_movrvvmf4x2hi */

    case 127:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1067; /* pred_th_whole_movrvvmf4x3hi */

    case 128:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1068; /* pred_th_whole_movrvvmf4x4hi */

    case 129:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1069; /* pred_th_whole_movrvvmf4x5hi */

    case 130:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1070; /* pred_th_whole_movrvvmf4x6hi */

    case 131:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1071; /* pred_th_whole_movrvvmf4x7hi */

    case 132:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1072; /* pred_th_whole_movrvvmf4x8hi */

    case 133:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1073; /* pred_th_whole_movrvvmf2x2si */

    case 134:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1074; /* pred_th_whole_movrvvmf2x3si */

    case 135:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1075; /* pred_th_whole_movrvvmf2x4si */

    case 136:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1076; /* pred_th_whole_movrvvmf2x5si */

    case 137:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1077; /* pred_th_whole_movrvvmf2x6si */

    case 138:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1078; /* pred_th_whole_movrvvmf2x7si */

    case 139:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1079; /* pred_th_whole_movrvvmf2x8si */

    case 140:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1080; /* pred_th_whole_movrvvm1x2di */

    case 141:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1081; /* pred_th_whole_movrvvm1x3di */

    case 142:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1082; /* pred_th_whole_movrvvm1x4di */

    case 143:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1083; /* pred_th_whole_movrvvm1x5di */

    case 144:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1084; /* pred_th_whole_movrvvm1x6di */

    case 145:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1085; /* pred_th_whole_movrvvm1x7di */

    case 146:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1086; /* pred_th_whole_movrvvm1x8di */

    case 147:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1087; /* pred_th_whole_movrvvmf4x2bf */

    case 148:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1088; /* pred_th_whole_movrvvmf4x3bf */

    case 149:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1089; /* pred_th_whole_movrvvmf4x4bf */

    case 150:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1090; /* pred_th_whole_movrvvmf4x5bf */

    case 151:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1091; /* pred_th_whole_movrvvmf4x6bf */

    case 152:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1092; /* pred_th_whole_movrvvmf4x7bf */

    case 153:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1093; /* pred_th_whole_movrvvmf4x8bf */

    case 154:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1094; /* pred_th_whole_movrvvmf4x2hf */

    case 155:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1095; /* pred_th_whole_movrvvmf4x3hf */

    case 156:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1096; /* pred_th_whole_movrvvmf4x4hf */

    case 157:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1097; /* pred_th_whole_movrvvmf4x5hf */

    case 158:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1098; /* pred_th_whole_movrvvmf4x6hf */

    case 159:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1099; /* pred_th_whole_movrvvmf4x7hf */

    case 160:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1100; /* pred_th_whole_movrvvmf4x8hf */

    case 161:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1101; /* pred_th_whole_movrvvmf2x2sf */

    case 162:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1102; /* pred_th_whole_movrvvmf2x3sf */

    case 163:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1103; /* pred_th_whole_movrvvmf2x4sf */

    case 164:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1104; /* pred_th_whole_movrvvmf2x5sf */

    case 165:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1105; /* pred_th_whole_movrvvmf2x6sf */

    case 166:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1106; /* pred_th_whole_movrvvmf2x7sf */

    case 167:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1107; /* pred_th_whole_movrvvmf2x8sf */

    case 168:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1108; /* pred_th_whole_movrvvm1x2df */

    case 169:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1109; /* pred_th_whole_movrvvm1x3df */

    case 170:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1110; /* pred_th_whole_movrvvm1x4df */

    case 171:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1111; /* pred_th_whole_movrvvm1x5df */

    case 172:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1112; /* pred_th_whole_movrvvm1x6df */

    case 173:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1113; /* pred_th_whole_movrvvm1x7df */

    case 174:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1114; /* pred_th_whole_movrvvm1x8df */

    case 175:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1115; /* pred_th_whole_movrvvmf4x2qi */

    case 176:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1116; /* pred_th_whole_movrvvmf4x3qi */

    case 177:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1117; /* pred_th_whole_movrvvmf4x4qi */

    case 178:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1118; /* pred_th_whole_movrvvmf4x5qi */

    case 179:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1119; /* pred_th_whole_movrvvmf4x6qi */

    case 180:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1120; /* pred_th_whole_movrvvmf4x7qi */

    case 181:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1121; /* pred_th_whole_movrvvmf4x8qi */

    case 182:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1122; /* pred_th_whole_movrvvmf2x2hi */

    case 183:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1123; /* pred_th_whole_movrvvmf2x3hi */

    case 184:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1124; /* pred_th_whole_movrvvmf2x4hi */

    case 185:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1125; /* pred_th_whole_movrvvmf2x5hi */

    case 186:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1126; /* pred_th_whole_movrvvmf2x6hi */

    case 187:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1127; /* pred_th_whole_movrvvmf2x7hi */

    case 188:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1128; /* pred_th_whole_movrvvmf2x8hi */

    case 189:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1129; /* pred_th_whole_movrvvm1x2si */

    case 190:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1130; /* pred_th_whole_movrvvm1x3si */

    case 191:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1131; /* pred_th_whole_movrvvm1x4si */

    case 192:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1132; /* pred_th_whole_movrvvm1x5si */

    case 193:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1133; /* pred_th_whole_movrvvm1x6si */

    case 194:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1134; /* pred_th_whole_movrvvm1x7si */

    case 195:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1135; /* pred_th_whole_movrvvm1x8si */

    case 196:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1136; /* pred_th_whole_movrvvm2x2di */

    case 197:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1137; /* pred_th_whole_movrvvm2x3di */

    case 198:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1138; /* pred_th_whole_movrvvm2x4di */

    case 199:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1139; /* pred_th_whole_movrvvmf2x2bf */

    case 200:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1140; /* pred_th_whole_movrvvmf2x3bf */

    case 201:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1141; /* pred_th_whole_movrvvmf2x4bf */

    case 202:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1142; /* pred_th_whole_movrvvmf2x5bf */

    case 203:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1143; /* pred_th_whole_movrvvmf2x6bf */

    case 204:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1144; /* pred_th_whole_movrvvmf2x7bf */

    case 205:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1145; /* pred_th_whole_movrvvmf2x8bf */

    case 206:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1146; /* pred_th_whole_movrvvmf2x2hf */

    case 207:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1147; /* pred_th_whole_movrvvmf2x3hf */

    case 208:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1148; /* pred_th_whole_movrvvmf2x4hf */

    case 209:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1260 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1149; /* pred_th_whole_movrvvmf2x5hf */

    case 210:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1261 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1150; /* pred_th_whole_movrvvmf2x6hf */

    case 211:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1262 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1151; /* pred_th_whole_movrvvmf2x7hf */

    case 212:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1263 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1152; /* pred_th_whole_movrvvmf2x8hf */

    case 213:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1264 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1153; /* pred_th_whole_movrvvm1x2sf */

    case 214:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1265 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1154; /* pred_th_whole_movrvvm1x3sf */

    case 215:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1266 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1155; /* pred_th_whole_movrvvm1x4sf */

    case 216:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1267 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1156; /* pred_th_whole_movrvvm1x5sf */

    case 217:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1268 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1157; /* pred_th_whole_movrvvm1x6sf */

    case 218:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1269 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1158; /* pred_th_whole_movrvvm1x7sf */

    case 219:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1270 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1159; /* pred_th_whole_movrvvm1x8sf */

    case 220:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1271 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1160; /* pred_th_whole_movrvvm2x2df */

    case 221:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1272 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1161; /* pred_th_whole_movrvvm2x3df */

    case 222:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1273 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1162; /* pred_th_whole_movrvvm2x4df */

    case 223:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1163; /* pred_th_whole_movrvvmf2x2qi */

    case 224:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1164; /* pred_th_whole_movrvvmf2x3qi */

    case 225:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1165; /* pred_th_whole_movrvvmf2x4qi */

    case 226:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1166; /* pred_th_whole_movrvvmf2x5qi */

    case 227:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1167; /* pred_th_whole_movrvvmf2x6qi */

    case 228:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1168; /* pred_th_whole_movrvvmf2x7qi */

    case 229:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1169; /* pred_th_whole_movrvvmf2x8qi */

    case 230:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1170; /* pred_th_whole_movrvvm1x2hi */

    case 231:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1171; /* pred_th_whole_movrvvm1x3hi */

    case 232:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1172; /* pred_th_whole_movrvvm1x4hi */

    case 233:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1173; /* pred_th_whole_movrvvm1x5hi */

    case 234:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1174; /* pred_th_whole_movrvvm1x6hi */

    case 235:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1175; /* pred_th_whole_movrvvm1x7hi */

    case 236:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1176; /* pred_th_whole_movrvvm1x8hi */

    case 237:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1177; /* pred_th_whole_movrvvm2x2si */

    case 238:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1178; /* pred_th_whole_movrvvm2x3si */

    case 239:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1179; /* pred_th_whole_movrvvm2x4si */

    case 240:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1180; /* pred_th_whole_movrvvm4x2di */

    case 241:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1181; /* pred_th_whole_movrvvm1x2bf */

    case 242:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1182; /* pred_th_whole_movrvvm1x3bf */

    case 243:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1183; /* pred_th_whole_movrvvm1x4bf */

    case 244:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1184; /* pred_th_whole_movrvvm1x5bf */

    case 245:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1299 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1185; /* pred_th_whole_movrvvm1x6bf */

    case 246:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1300 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1186; /* pred_th_whole_movrvvm1x7bf */

    case 247:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1301 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1187; /* pred_th_whole_movrvvm1x8bf */

    case 248:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1302 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1188; /* pred_th_whole_movrvvm1x2hf */

    case 249:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1303 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1189; /* pred_th_whole_movrvvm1x3hf */

    case 250:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1304 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1190; /* pred_th_whole_movrvvm1x4hf */

    case 251:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1305 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1191; /* pred_th_whole_movrvvm1x5hf */

    case 252:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1306 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1192; /* pred_th_whole_movrvvm1x6hf */

    case 253:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1307 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1193; /* pred_th_whole_movrvvm1x7hf */

    case 254:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1308 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1194; /* pred_th_whole_movrvvm1x8hf */

    case 255:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1309 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1195; /* pred_th_whole_movrvvm2x2sf */

    case 256:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1196; /* pred_th_whole_movrvvm2x3sf */

    case 257:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1197; /* pred_th_whole_movrvvm2x4sf */

    case 258:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1312 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1198; /* pred_th_whole_movrvvm4x2df */

    case 259:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1199; /* pred_th_whole_movrvvm1x2qi */

    case 260:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1200; /* pred_th_whole_movrvvm1x3qi */

    case 261:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1201; /* pred_th_whole_movrvvm1x4qi */

    case 262:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1202; /* pred_th_whole_movrvvm1x5qi */

    case 263:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1203; /* pred_th_whole_movrvvm1x6qi */

    case 264:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1204; /* pred_th_whole_movrvvm1x7qi */

    case 265:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1205; /* pred_th_whole_movrvvm1x8qi */

    case 266:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1206; /* pred_th_whole_movrvvm2x2hi */

    case 267:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1207; /* pred_th_whole_movrvvm2x3hi */

    case 268:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1208; /* pred_th_whole_movrvvm2x4hi */

    case 269:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1209; /* pred_th_whole_movrvvm4x2si */

    case 270:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1210; /* pred_th_whole_movrvvm2x2bf */

    case 271:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1211; /* pred_th_whole_movrvvm2x3bf */

    case 272:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1329 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1212; /* pred_th_whole_movrvvm2x4bf */

    case 273:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1330 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1213; /* pred_th_whole_movrvvm2x2hf */

    case 274:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1214; /* pred_th_whole_movrvvm2x3hf */

    case 275:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1332 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1215; /* pred_th_whole_movrvvm2x4hf */

    case 276:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1216; /* pred_th_whole_movrvvm4x2sf */

    case 277:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1217; /* pred_th_whole_movrvvm2x2qi */

    case 278:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1218; /* pred_th_whole_movrvvm2x3qi */

    case 279:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1219; /* pred_th_whole_movrvvm2x4qi */

    case 280:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1220; /* pred_th_whole_movrvvm4x2hi */

    case 281:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1341 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1221; /* pred_th_whole_movrvvm4x2bf */

    case 282:
      if (!(
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1342 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1222; /* pred_th_whole_movrvvm4x2hf */

    case 283:
      if (!
#line 116 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1223; /* pred_th_whole_movrvvm4x2qi */

    case 284:
      if (!(
#line 141 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1224; /* pred_th_whole_movrvvmf64bi */

    case 285:
      if (!
#line 141 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1225; /* pred_th_whole_movrvvmf32bi */

    case 286:
      if (!
#line 141 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1226; /* pred_th_whole_movrvvmf16bi */

    case 287:
      if (!
#line 141 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1227; /* pred_th_whole_movrvvmf8bi */

    case 288:
      if (!
#line 141 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1228; /* pred_th_whole_movrvvmf4bi */

    case 289:
      if (!
#line 141 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1229; /* pred_th_whole_movrvvmf2bi */

    case 290:
      if (!
#line 141 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
        return -1;
      return 1230; /* pred_th_whole_movrvvm1bi */

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  if (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
    return 114; /* one_cmplsi2 */
  if (!
#line 1787 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
    return -1;
  return 116; /* *one_cmplsi2_internal */
}

 int
recog_112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return recog_111 (x1, insn, pnum_clobbers);

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
        return -1;
      return 115; /* one_cmpldi2 */

    case E_RVVMF64BImode:
      if (!register_operand (operands[0], E_RVVMF64BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || !(
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 25961; /* one_cmplrvvmf64bi2 */

    case E_RVVMF32BImode:
      if (!register_operand (operands[0], E_RVVMF32BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || !
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25962; /* one_cmplrvvmf32bi2 */

    case E_RVVMF16BImode:
      if (!register_operand (operands[0], E_RVVMF16BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || !
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25963; /* one_cmplrvvmf16bi2 */

    case E_RVVMF8BImode:
      if (!register_operand (operands[0], E_RVVMF8BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || !
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25964; /* one_cmplrvvmf8bi2 */

    case E_RVVMF4BImode:
      if (!register_operand (operands[0], E_RVVMF4BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4BImode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || !
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25965; /* one_cmplrvvmf4bi2 */

    case E_RVVMF2BImode:
      if (!register_operand (operands[0], E_RVVMF2BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2BImode
          || !register_operand (operands[1], E_RVVMF2BImode)
          || !
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25966; /* one_cmplrvvmf2bi2 */

    case E_RVVM1BImode:
      if (!register_operand (operands[0], E_RVVM1BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1BImode
          || !register_operand (operands[1], E_RVVM1BImode)
          || !
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 25967; /* one_cmplrvvm1bi2 */

    case E_V1BImode:
      if (!register_operand (operands[0], E_V1BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1BImode
          || !register_operand (operands[1], E_V1BImode)
          || !(
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))))
        return -1;
      return 25968; /* one_cmplv1bi2 */

    case E_V2BImode:
      if (!register_operand (operands[0], E_V2BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2BImode
          || !register_operand (operands[1], E_V2BImode)
          || !(
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))))
        return -1;
      return 25969; /* one_cmplv2bi2 */

    case E_V4BImode:
      if (!register_operand (operands[0], E_V4BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4BImode
          || !register_operand (operands[1], E_V4BImode)
          || !(
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))))
        return -1;
      return 25970; /* one_cmplv4bi2 */

    case E_V8BImode:
      if (!register_operand (operands[0], E_V8BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8BImode
          || !register_operand (operands[1], E_V8BImode)
          || !(
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))))
        return -1;
      return 25971; /* one_cmplv8bi2 */

    case E_V16BImode:
      if (!register_operand (operands[0], E_V16BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16BImode
          || !register_operand (operands[1], E_V16BImode)
          || !(
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))))
        return -1;
      return 25972; /* one_cmplv16bi2 */

    case E_V32BImode:
      if (!register_operand (operands[0], E_V32BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32BImode
          || !register_operand (operands[1], E_V32BImode)
          || !(
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))))
        return -1;
      return 25973; /* one_cmplv32bi2 */

    case E_V64BImode:
      if (!register_operand (operands[0], E_V64BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64BImode
          || !register_operand (operands[1], E_V64BImode)
          || !(
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 25974; /* one_cmplv64bi2 */

    case E_V128BImode:
      if (!register_operand (operands[0], E_V128BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128BImode
          || !register_operand (operands[1], E_V128BImode)
          || !(
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 25975; /* one_cmplv128bi2 */

    case E_V256BImode:
      if (!register_operand (operands[0], E_V256BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256BImode
          || !register_operand (operands[1], E_V256BImode)
          || !(
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 25976; /* one_cmplv256bi2 */

    case E_V512BImode:
      if (!register_operand (operands[0], E_V512BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512BImode
          || !register_operand (operands[1], E_V512BImode)
          || !(
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 25977; /* one_cmplv512bi2 */

    case E_V1024BImode:
      if (!register_operand (operands[0], E_V1024BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024BImode
          || !register_operand (operands[1], E_V1024BImode)
          || !(
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 25978; /* one_cmplv1024bi2 */

    case E_V2048BImode:
      if (!register_operand (operands[0], E_V2048BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048BImode
          || !register_operand (operands[1], E_V2048BImode)
          || !(
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 25979; /* one_cmplv2048bi2 */

    case E_V4096BImode:
      if (!register_operand (operands[0], E_V4096BImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096BImode
          || !register_operand (operands[1], E_V4096BImode)
          || !(
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 25980; /* one_cmplv4096bi2 */

    case E_RVVM8QImode:
      if (!register_operand (operands[0], E_RVVM8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8QImode
          || !register_operand (operands[1], E_RVVM8QImode)
          || !
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26900; /* one_cmplrvvm8qi2 */

    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM4QImode)
          || !
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26902; /* one_cmplrvvm4qi2 */

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM2QImode)
          || !
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26904; /* one_cmplrvvm2qi2 */

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM1QImode)
          || !
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26906; /* one_cmplrvvm1qi2 */

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM8HImode)
          || !
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26908; /* one_cmplrvvm8hi2 */

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM4HImode)
          || !
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26910; /* one_cmplrvvm4hi2 */

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM2HImode)
          || !
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26912; /* one_cmplrvvm2hi2 */

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM1HImode)
          || !
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26914; /* one_cmplrvvm1hi2 */

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVM8SImode)
          || !
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26916; /* one_cmplrvvm8si2 */

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM4SImode)
          || !
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26918; /* one_cmplrvvm4si2 */

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM2SImode)
          || !
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26920; /* one_cmplrvvm2si2 */

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM1SImode)
          || !
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()))
        return -1;
      return 26922; /* one_cmplrvvm1si2 */

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DImode
          || !register_operand (operands[1], E_RVVM8DImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26924; /* one_cmplrvvm8di2 */

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DImode
          || !register_operand (operands[1], E_RVVM4DImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26926; /* one_cmplrvvm4di2 */

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DImode
          || !register_operand (operands[1], E_RVVM2DImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26928; /* one_cmplrvvm2di2 */

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DImode
          || !register_operand (operands[1], E_RVVM1DImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26930; /* one_cmplrvvm1di2 */

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26932; /* one_cmplrvvmf2qi2 */

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26934; /* one_cmplrvvmf4qi2 */

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26936; /* one_cmplrvvmf8qi2 */

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF2HImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 26938; /* one_cmplrvvmf2hi2 */

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF4HImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26940; /* one_cmplrvvmf4hi2 */

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVMF2SImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 26942; /* one_cmplrvvmf2si2 */

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 26944; /* one_cmplv1qi2 */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 26946; /* one_cmplv2qi2 */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 26948; /* one_cmplv4qi2 */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 26950; /* one_cmplv8qi2 */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 26952; /* one_cmplv16qi2 */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 26954; /* one_cmplv32qi2 */

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64QImode
          || !register_operand (operands[1], E_V64QImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26956; /* one_cmplv64qi2 */

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128QImode
          || !register_operand (operands[1], E_V128QImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26958; /* one_cmplv128qi2 */

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256QImode
          || !register_operand (operands[1], E_V256QImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26960; /* one_cmplv256qi2 */

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512QImode
          || !register_operand (operands[1], E_V512QImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26962; /* one_cmplv512qi2 */

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024QImode
          || !register_operand (operands[1], E_V1024QImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26964; /* one_cmplv1024qi2 */

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048QImode
          || !register_operand (operands[1], E_V2048QImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26966; /* one_cmplv2048qi2 */

    case E_V4096QImode:
      if (!register_operand (operands[0], E_V4096QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096QImode
          || !register_operand (operands[1], E_V4096QImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26968; /* one_cmplv4096qi2 */

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 26970; /* one_cmplv1hi2 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 26972; /* one_cmplv2hi2 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 26974; /* one_cmplv4hi2 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 26976; /* one_cmplv8hi2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 26978; /* one_cmplv16hi2 */

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HImode
          || !register_operand (operands[1], E_V32HImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26980; /* one_cmplv32hi2 */

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64HImode
          || !register_operand (operands[1], E_V64HImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26982; /* one_cmplv64hi2 */

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128HImode
          || !register_operand (operands[1], E_V128HImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26984; /* one_cmplv128hi2 */

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256HImode
          || !register_operand (operands[1], E_V256HImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26986; /* one_cmplv256hi2 */

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512HImode
          || !register_operand (operands[1], E_V512HImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26988; /* one_cmplv512hi2 */

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024HImode
          || !register_operand (operands[1], E_V1024HImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26990; /* one_cmplv1024hi2 */

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048HImode
          || !register_operand (operands[1], E_V2048HImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26992; /* one_cmplv2048hi2 */

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 26994; /* one_cmplv1si2 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 26996; /* one_cmplv2si2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 26998; /* one_cmplv4si2 */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 27000; /* one_cmplv8si2 */

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16SImode
          || !register_operand (operands[1], E_V16SImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27002; /* one_cmplv16si2 */

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32SImode
          || !register_operand (operands[1], E_V32SImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27004; /* one_cmplv32si2 */

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64SImode
          || !register_operand (operands[1], E_V64SImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27006; /* one_cmplv64si2 */

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128SImode
          || !register_operand (operands[1], E_V128SImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27008; /* one_cmplv128si2 */

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256SImode
          || !register_operand (operands[1], E_V256SImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27010; /* one_cmplv256si2 */

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512SImode
          || !register_operand (operands[1], E_V512SImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27012; /* one_cmplv512si2 */

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024SImode
          || !register_operand (operands[1], E_V1024SImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27014; /* one_cmplv1024si2 */

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27016; /* one_cmplv1di2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27018; /* one_cmplv2di2 */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 27020; /* one_cmplv4di2 */

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8DImode
          || !register_operand (operands[1], E_V8DImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 27022; /* one_cmplv8di2 */

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16DImode
          || !register_operand (operands[1], E_V16DImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 27024; /* one_cmplv16di2 */

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32DImode
          || !register_operand (operands[1], E_V32DImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 27026; /* one_cmplv32di2 */

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64DImode
          || !register_operand (operands[1], E_V64DImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 27028; /* one_cmplv64di2 */

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128DImode
          || !register_operand (operands[1], E_V128DImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 27030; /* one_cmplv128di2 */

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256DImode
          || !register_operand (operands[1], E_V256DImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 27032; /* one_cmplv256di2 */

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512DImode
          || !register_operand (operands[1], E_V512DImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 27034; /* one_cmplv512di2 */

    default:
      return -1;
    }
}

 int
recog_212 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V8SImode)
      && reg_or_mem_operand (operands[1], E_V8SImode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V8SImode)
       || register_operand (operands[1], V8SImode))) && 
#line 4317 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return 3205; /* *movv8si */
  if (!register_operand (operands[0], E_V8SImode)
      || !register_operand (operands[1], E_V8SImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return -1;
  return 3364; /* *movv8si_vls */
}

 int
recog_219 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2HImode)
      && reg_or_mem_operand (operands[1], E_V2HImode)
      && (
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2HImode)
       || register_operand (operands[1], V2HImode))) && 
#line 4310 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return 3198; /* *movv2hi */
  if (!register_operand (operands[0], E_V2HImode)
      || !register_operand (operands[1], E_V2HImode)
      || !(
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
    return -1;
  return 3350; /* *movv2hi_vls */
}

 int
recog_226 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_SImode)
      && splittable_const_int_operand (operands[1], E_SImode)
      && 
#line 2471 "../../gcc/config/riscv/riscv.md"
(!ira_in_progress
   && !(p2m1_shift_operand (operands[1], SImode)
	|| high_mask_shift_operand (operands[1], SImode)
	|| exact_log2 (INTVAL (operands[1])) >= 0)))
    return 274; /* *mvconst_internal */
  if (!nonimmediate_operand (operands[0], E_SImode)
      || !move_operand (operands[1], E_SImode)
      || !
#line 2534 "../../gcc/config/riscv/riscv.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))
    && !(REG_P (operands[1]) && VL_REG_P (REGNO (operands[1])))))
    return -1;
  return 278; /* *movsi_internal */
}

 int
recog_234 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2SFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3176; /* *movrvvm4x2sf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3177; /* *movrvvm4x2sf_di */
}

 int
recog_241 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM4x2SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM4x2SImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3162; /* *movrvvm4x2si_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3163; /* *movrvvm4x2si_di */
}

 int
recog_248 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x5QImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x5QImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3148; /* *movrvvm1x5qi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3149; /* *movrvvm1x5qi_di */
}

 int
recog_255 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM2x2SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM2x2SFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1309 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3134; /* *movrvvm2x2sf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1309 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3135; /* *movrvvm2x2sf_di */
}

 int
recog_262 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2HFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1302 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3120; /* *movrvvm1x2hf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1302 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3121; /* *movrvvm1x2hf_di */
}

 int
recog_269 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x2BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x2BFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3106; /* *movrvvm1x2bf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3107; /* *movrvvm1x2bf_di */
}

 int
recog_277 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x5HImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x5HImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3090; /* *movrvvm1x5hi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3091; /* *movrvvm1x5hi_di */
}

 int
recog_285 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x4QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x4QImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3074; /* *movrvvmf2x4qi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3075; /* *movrvvmf2x4qi_di */
}

 int
recog_293 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6SFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1268 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3058; /* *movrvvm1x6sf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1268 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3059; /* *movrvvm1x6sf_di */
}

 int
recog_301 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x5HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x5HFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1260 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3042; /* *movrvvmf2x5hf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1260 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3043; /* *movrvvmf2x5hf_di */
}

 int
recog_309 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x4BFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x4BFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 3026; /* *movrvvmf2x4bf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 3027; /* *movrvvmf2x4bf_di */
}

 int
recog_317 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x6SImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x6SImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 3010; /* *movrvvm1x6si_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 3011; /* *movrvvm1x6si_di */
}

 int
recog_324 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x6HImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x6HImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2996; /* *movrvvmf2x6hi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2997; /* *movrvvmf2x6hi_di */
}

 int
recog_332 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x5QImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x5QImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 3;
      return 2980; /* *movrvvmf4x5qi_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 3;
  return 2981; /* *movrvvmf4x5qi_di */
}

 int
recog_340 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x4DFmode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x4DFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2964; /* *movrvvm1x4df_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2965; /* *movrvvm1x4df_di */
}

 int
recog_348 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x3SFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x3SFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2948; /* *movrvvmf2x3sf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2949; /* *movrvvmf2x3sf_di */
}

 int
recog_356 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF4x2HFmode)
      || !reg_or_mem_operand (operands[1], E_RVVMF4x2HFmode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2932; /* *movrvvmf4x2hf_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2933; /* *movrvvmf4x2hf_di */
}

 int
recog_364 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVM1x8DImode)
      || !reg_or_mem_operand (operands[1], E_RVVM1x8DImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2916; /* *movrvvm1x8di_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2917; /* *movrvvm1x8di_di */
}

 int
recog_372 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !reg_or_mem_operand (operands[0], E_RVVMF2x7SImode)
      || !reg_or_mem_operand (operands[1], E_RVVMF2x7SImode))
    return -1;
  if ((
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
    {
      *pnum_clobbers = 3;
      return 2900; /* *movrvvmf2x7si_si */
    }
  if (!(
#line 1405 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (((
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
    return -1;
  *pnum_clobbers = 3;
  return 2901; /* *movrvvmf2x7si_di */
}

 int
recog_380 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern205 (x2))
    {
    case 0:
      if (vector_shift_operand (operands[2], E_RVVM4QImode)
          && 
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32245; /* *vwsll_zext1_rvvm8hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32341; /* *vwsll_zext1_scalar_rvvm8hi */

    case 1:
      if (vector_shift_operand (operands[2], E_RVVM2QImode)
          && 
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32246; /* *vwsll_zext1_rvvm4hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32342; /* *vwsll_zext1_scalar_rvvm4hi */

    case 2:
      if (vector_shift_operand (operands[2], E_RVVM1QImode)
          && 
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32247; /* *vwsll_zext1_rvvm2hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32343; /* *vwsll_zext1_scalar_rvvm2hi */

    case 3:
      if (vector_shift_operand (operands[2], E_RVVMF2QImode)
          && 
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32248; /* *vwsll_zext1_rvvm1hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32344; /* *vwsll_zext1_scalar_rvvm1hi */

    case 4:
      if (vector_shift_operand (operands[2], E_RVVMF4QImode)
          && 
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32249; /* *vwsll_zext1_rvvmf2hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32345; /* *vwsll_zext1_scalar_rvvmf2hi */

    case 5:
      if (vector_shift_operand (operands[2], E_RVVMF8QImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32250; /* *vwsll_zext1_rvvmf4hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32346; /* *vwsll_zext1_scalar_rvvmf4hi */

    case 6:
      if (vector_shift_operand (operands[2], E_RVVM4HImode)
          && 
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32251; /* *vwsll_zext1_rvvm8si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32347; /* *vwsll_zext1_scalar_rvvm8si */

    case 7:
      if (vector_shift_operand (operands[2], E_RVVM2HImode)
          && 
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32252; /* *vwsll_zext1_rvvm4si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32348; /* *vwsll_zext1_scalar_rvvm4si */

    case 8:
      if (vector_shift_operand (operands[2], E_RVVM1HImode)
          && 
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32253; /* *vwsll_zext1_rvvm2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32349; /* *vwsll_zext1_scalar_rvvm2si */

    case 9:
      if (vector_shift_operand (operands[2], E_RVVMF2HImode)
          && 
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return 32254; /* *vwsll_zext1_rvvm1si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32350; /* *vwsll_zext1_scalar_rvvm1si */

    case 10:
      if (vector_shift_operand (operands[2], E_RVVMF4HImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32255; /* *vwsll_zext1_rvvmf2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32351; /* *vwsll_zext1_scalar_rvvmf2si */

    case 11:
      if (vector_shift_operand (operands[2], E_RVVM4SImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32256; /* *vwsll_zext1_rvvm8di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32352; /* *vwsll_zext1_scalar_rvvm8di */

    case 12:
      if (vector_shift_operand (operands[2], E_RVVM2SImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32257; /* *vwsll_zext1_rvvm4di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32353; /* *vwsll_zext1_scalar_rvvm4di */

    case 13:
      if (vector_shift_operand (operands[2], E_RVVM1SImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32258; /* *vwsll_zext1_rvvm2di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32354; /* *vwsll_zext1_scalar_rvvm2di */

    case 14:
      if (vector_shift_operand (operands[2], E_RVVMF2SImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 32259; /* *vwsll_zext1_rvvm1di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32355; /* *vwsll_zext1_scalar_rvvm1di */

    case 15:
      if (vector_shift_operand (operands[2], E_V1QImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return 32260; /* *vwsll_zext1_v1hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 32356; /* *vwsll_zext1_scalar_v1hi */

    case 16:
      if (vector_shift_operand (operands[2], E_V2QImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return 32261; /* *vwsll_zext1_v2hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 32357; /* *vwsll_zext1_scalar_v2hi */

    case 17:
      if (vector_shift_operand (operands[2], E_V4QImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 32262; /* *vwsll_zext1_v4hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 32358; /* *vwsll_zext1_scalar_v4hi */

    case 18:
      if (vector_shift_operand (operands[2], E_V8QImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 32263; /* *vwsll_zext1_v8hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 32359; /* *vwsll_zext1_scalar_v8hi */

    case 19:
      if (vector_shift_operand (operands[2], E_V16QImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return 32264; /* *vwsll_zext1_v16hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 32360; /* *vwsll_zext1_scalar_v16hi */

    case 20:
      if (vector_shift_operand (operands[2], E_V32QImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return 32265; /* *vwsll_zext1_v32hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32361; /* *vwsll_zext1_scalar_v32hi */

    case 21:
      if (vector_shift_operand (operands[2], E_V64QImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return 32266; /* *vwsll_zext1_v64hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32362; /* *vwsll_zext1_scalar_v64hi */

    case 22:
      if (vector_shift_operand (operands[2], E_V128QImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return 32267; /* *vwsll_zext1_v128hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32363; /* *vwsll_zext1_scalar_v128hi */

    case 23:
      if (vector_shift_operand (operands[2], E_V256QImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return 32268; /* *vwsll_zext1_v256hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32364; /* *vwsll_zext1_scalar_v256hi */

    case 24:
      if (vector_shift_operand (operands[2], E_V512QImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return 32269; /* *vwsll_zext1_v512hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32365; /* *vwsll_zext1_scalar_v512hi */

    case 25:
      if (vector_shift_operand (operands[2], E_V1024QImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return 32270; /* *vwsll_zext1_v1024hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32366; /* *vwsll_zext1_scalar_v1024hi */

    case 26:
      if (vector_shift_operand (operands[2], E_V2048QImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return 32271; /* *vwsll_zext1_v2048hi */
      if (!vector_scalar_shift_operand (operands[2], E_HImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32367; /* *vwsll_zext1_scalar_v2048hi */

    case 27:
      if (vector_shift_operand (operands[2], E_V1HImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return 32272; /* *vwsll_zext1_v1si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32368; /* *vwsll_zext1_scalar_v1si */

    case 28:
      if (vector_shift_operand (operands[2], E_V2HImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return 32273; /* *vwsll_zext1_v2si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32369; /* *vwsll_zext1_scalar_v2si */

    case 29:
      if (vector_shift_operand (operands[2], E_V4HImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 32274; /* *vwsll_zext1_v4si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32370; /* *vwsll_zext1_scalar_v4si */

    case 30:
      if (vector_shift_operand (operands[2], E_V8HImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 32275; /* *vwsll_zext1_v8si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32371; /* *vwsll_zext1_scalar_v8si */

    case 31:
      if (vector_shift_operand (operands[2], E_V16HImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return 32276; /* *vwsll_zext1_v16si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32372; /* *vwsll_zext1_scalar_v16si */

    case 32:
      if (vector_shift_operand (operands[2], E_V32HImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return 32277; /* *vwsll_zext1_v32si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32373; /* *vwsll_zext1_scalar_v32si */

    case 33:
      if (vector_shift_operand (operands[2], E_V64HImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return 32278; /* *vwsll_zext1_v64si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32374; /* *vwsll_zext1_scalar_v64si */

    case 34:
      if (vector_shift_operand (operands[2], E_V128HImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return 32279; /* *vwsll_zext1_v128si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32375; /* *vwsll_zext1_scalar_v128si */

    case 35:
      if (vector_shift_operand (operands[2], E_V256HImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return 32280; /* *vwsll_zext1_v256si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32376; /* *vwsll_zext1_scalar_v256si */

    case 36:
      if (vector_shift_operand (operands[2], E_V512HImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return 32281; /* *vwsll_zext1_v512si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32377; /* *vwsll_zext1_scalar_v512si */

    case 37:
      if (vector_shift_operand (operands[2], E_V1024HImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return 32282; /* *vwsll_zext1_v1024si */
      if (!vector_scalar_shift_operand (operands[2], E_SImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32378; /* *vwsll_zext1_scalar_v1024si */

    case 38:
      if (vector_shift_operand (operands[2], E_V1SImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return 32283; /* *vwsll_zext1_v1di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32379; /* *vwsll_zext1_scalar_v1di */

    case 39:
      if (vector_shift_operand (operands[2], E_V2SImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return 32284; /* *vwsll_zext1_v2di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32380; /* *vwsll_zext1_scalar_v2di */

    case 40:
      if (vector_shift_operand (operands[2], E_V4SImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 32285; /* *vwsll_zext1_v4di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32381; /* *vwsll_zext1_scalar_v4di */

    case 41:
      if (vector_shift_operand (operands[2], E_V8SImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 32286; /* *vwsll_zext1_v8di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32382; /* *vwsll_zext1_scalar_v8di */

    case 42:
      if (vector_shift_operand (operands[2], E_V16SImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return 32287; /* *vwsll_zext1_v16di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32383; /* *vwsll_zext1_scalar_v16di */

    case 43:
      if (vector_shift_operand (operands[2], E_V32SImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return 32288; /* *vwsll_zext1_v32di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32384; /* *vwsll_zext1_scalar_v32di */

    case 44:
      if (vector_shift_operand (operands[2], E_V64SImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return 32289; /* *vwsll_zext1_v64di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32385; /* *vwsll_zext1_scalar_v64di */

    case 45:
      if (vector_shift_operand (operands[2], E_V128SImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return 32290; /* *vwsll_zext1_v128di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32386; /* *vwsll_zext1_scalar_v128di */

    case 46:
      if (vector_shift_operand (operands[2], E_V256SImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return 32291; /* *vwsll_zext1_v256di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32387; /* *vwsll_zext1_scalar_v256di */

    case 47:
      if (vector_shift_operand (operands[2], E_V512SImode)
          && (
#line 1541 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return 32292; /* *vwsll_zext1_v512di */
      if (!vector_scalar_shift_operand (operands[2], E_DImode)
          || !(
#line 1577 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32388; /* *vwsll_zext1_scalar_v512di */

    case 48:
      if (!
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32293; /* *vwsll_zext2_rvvm8hi */

    case 49:
      if (!
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32294; /* *vwsll_zext2_rvvm4hi */

    case 50:
      if (!
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32295; /* *vwsll_zext2_rvvm2hi */

    case 51:
      if (!
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32296; /* *vwsll_zext2_rvvm1hi */

    case 52:
      if (!
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32297; /* *vwsll_zext2_rvvmf2hi */

    case 53:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32298; /* *vwsll_zext2_rvvmf4hi */

    case 54:
      if (!
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32299; /* *vwsll_zext2_rvvm8si */

    case 55:
      if (!
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32300; /* *vwsll_zext2_rvvm4si */

    case 56:
      if (!
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32301; /* *vwsll_zext2_rvvm2si */

    case 57:
      if (!
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()))
        return -1;
      return 32302; /* *vwsll_zext2_rvvm1si */

    case 58:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32303; /* *vwsll_zext2_rvvmf2si */

    case 59:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32304; /* *vwsll_zext2_rvvm8di */

    case 60:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32305; /* *vwsll_zext2_rvvm4di */

    case 61:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32306; /* *vwsll_zext2_rvvm2di */

    case 62:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32307; /* *vwsll_zext2_rvvm1di */

    case 63:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 32308; /* *vwsll_zext2_v1hi */

    case 64:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 32309; /* *vwsll_zext2_v2hi */

    case 65:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 32310; /* *vwsll_zext2_v4hi */

    case 66:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 32311; /* *vwsll_zext2_v8hi */

    case 67:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 32312; /* *vwsll_zext2_v16hi */

    case 68:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32313; /* *vwsll_zext2_v32hi */

    case 69:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32314; /* *vwsll_zext2_v64hi */

    case 70:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32315; /* *vwsll_zext2_v128hi */

    case 71:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32316; /* *vwsll_zext2_v256hi */

    case 72:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32317; /* *vwsll_zext2_v512hi */

    case 73:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32318; /* *vwsll_zext2_v1024hi */

    case 74:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32319; /* *vwsll_zext2_v2048hi */

    case 75:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 32320; /* *vwsll_zext2_v1si */

    case 76:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 32321; /* *vwsll_zext2_v2si */

    case 77:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 32322; /* *vwsll_zext2_v4si */

    case 78:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 32323; /* *vwsll_zext2_v8si */

    case 79:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32324; /* *vwsll_zext2_v16si */

    case 80:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32325; /* *vwsll_zext2_v32si */

    case 81:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32326; /* *vwsll_zext2_v64si */

    case 82:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32327; /* *vwsll_zext2_v128si */

    case 83:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32328; /* *vwsll_zext2_v256si */

    case 84:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32329; /* *vwsll_zext2_v512si */

    case 85:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32330; /* *vwsll_zext2_v1024si */

    case 86:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32331; /* *vwsll_zext2_v1di */

    case 87:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32332; /* *vwsll_zext2_v2di */

    case 88:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 32333; /* *vwsll_zext2_v4di */

    case 89:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 32334; /* *vwsll_zext2_v8di */

    case 90:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 32335; /* *vwsll_zext2_v16di */

    case 91:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 32336; /* *vwsll_zext2_v32di */

    case 92:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 32337; /* *vwsll_zext2_v64di */

    case 93:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 32338; /* *vwsll_zext2_v128di */

    case 94:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 32339; /* *vwsll_zext2_v256di */

    case 95:
      if (!(
#line 1559 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_ZVBB && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 32340; /* *vwsll_zext2_v512di */

    default:
      return -1;
    }
}

 int
recog_404 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern481 (x2))
    {
    case 0:
      if (
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33506; /* pred_crypto_vvaeszvsrvvm8si */
      if (!
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33566; /* pred_crypto_vvaeszvsx1rvvm8si_scalar */

    case 1:
      if (!
#line 538 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33626; /* pred_crypto_vvaeszvsx2rvvm4si_scalar */

    case 2:
      if (!
#line 556 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33674; /* pred_crypto_vvaeszvsx4rvvm2si_scalar */

    case 3:
      if (!
#line 574 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33710; /* pred_crypto_vvaeszvsx8rvvm1si_scalar */

    case 4:
      if (!(
#line 592 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4419 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33734; /* pred_crypto_vvaeszvsx16rvvmf2si_scalar */

    case 5:
      if (
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33518; /* pred_crypto_vvaeszvsrvvm4si */
      if (!
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33578; /* pred_crypto_vvaeszvsx1rvvm4si_scalar */

    case 6:
      if (!
#line 538 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33638; /* pred_crypto_vvaeszvsx2rvvm2si_scalar */

    case 7:
      if (!
#line 556 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33686; /* pred_crypto_vvaeszvsx4rvvm1si_scalar */

    case 8:
      if (!(
#line 574 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4415 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33722; /* pred_crypto_vvaeszvsx8rvvmf2si_scalar */

    case 9:
      if (
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33530; /* pred_crypto_vvaeszvsrvvm2si */
      if (!
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33590; /* pred_crypto_vvaeszvsx1rvvm2si_scalar */

    case 10:
      if (!
#line 538 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33650; /* pred_crypto_vvaeszvsx2rvvm1si_scalar */

    case 11:
      if (!(
#line 556 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4411 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33698; /* pred_crypto_vvaeszvsx4rvvmf2si_scalar */

    case 12:
      if (
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG))
        return 33542; /* pred_crypto_vvaeszvsrvvm1si */
      if (!
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED))
        return -1;
      return 33602; /* pred_crypto_vvaeszvsx1rvvm1si_scalar */

    case 13:
      if (!(
#line 538 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4407 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33662; /* pred_crypto_vvaeszvsx2rvvmf2si_scalar */

    case 14:
      if ((
#line 502 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED || TARGET_ZVKG) && 
#line 4403 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return 33554; /* pred_crypto_vvaeszvsrvvmf2si */
      if (!(
#line 520 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSED) && 
#line 4403 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33614; /* pred_crypto_vvaeszvsx1rvvmf2si_scalar */

    default:
      return -1;
    }
}

 int
recog_407 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[5] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[6] = x6;
  x7 = XEXP (x2, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[1] = x8;
  x9 = XVECEXP (x7, 0, 1);
  operands[2] = x9;
  x10 = XVECEXP (x7, 0, 2);
  operands[3] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (XINT (x7, 1))
    {
    case 201:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SImode:
          if (pattern646 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33377; /* pred_vghshrvvm8si */

        case E_RVVM4SImode:
          if (pattern646 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33381; /* pred_vghshrvvm4si */

        case E_RVVM2SImode:
          if (pattern646 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33385; /* pred_vghshrvvm2si */

        case E_RVVM1SImode:
          if (pattern646 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33389; /* pred_vghshrvvm1si */

        case E_RVVMF2SImode:
          if (pattern646 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33393; /* pred_vghshrvvmf2si */

        case E_RVVM8DImode:
          if (pattern646 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33397; /* pred_vghshrvvm8di */

        case E_RVVM4DImode:
          if (pattern646 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33401; /* pred_vghshrvvm4di */

        case E_RVVM2DImode:
          if (pattern646 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33405; /* pred_vghshrvvm2di */

        case E_RVVM1DImode:
          if (pattern646 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33409; /* pred_vghshrvvm1di */

        case E_V1SImode:
          if (pattern646 (x2, 
E_V1SImode, 
E_V1BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 33413; /* pred_vghshv1si */

        case E_V2SImode:
          if (pattern646 (x2, 
E_V2SImode, 
E_V2BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 33417; /* pred_vghshv2si */

        case E_V4SImode:
          if (pattern646 (x2, 
E_V4SImode, 
E_V4BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 33421; /* pred_vghshv4si */

        case E_V8SImode:
          if (pattern646 (x2, 
E_V8SImode, 
E_V8BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 33425; /* pred_vghshv8si */

        case E_V16SImode:
          if (pattern646 (x2, 
E_V16SImode, 
E_V16BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33429; /* pred_vghshv16si */

        case E_V32SImode:
          if (pattern646 (x2, 
E_V32SImode, 
E_V32BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33433; /* pred_vghshv32si */

        case E_V64SImode:
          if (pattern646 (x2, 
E_V64SImode, 
E_V64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33437; /* pred_vghshv64si */

        case E_V128SImode:
          if (pattern646 (x2, 
E_V128SImode, 
E_V128BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1118 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33441; /* pred_vghshv128si */

        case E_V256SImode:
          if (pattern646 (x2, 
E_V256SImode, 
E_V256BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1119 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33445; /* pred_vghshv256si */

        case E_V512SImode:
          if (pattern646 (x2, 
E_V512SImode, 
E_V512BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1120 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33449; /* pred_vghshv512si */

        case E_V1024SImode:
          if (pattern646 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1121 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33453; /* pred_vghshv1024si */

        case E_V1DImode:
          if (pattern646 (x2, 
E_V1DImode, 
E_V1BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1122 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33457; /* pred_vghshv1di */

        case E_V2DImode:
          if (pattern646 (x2, 
E_V2DImode, 
E_V2BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1123 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33461; /* pred_vghshv2di */

        case E_V4DImode:
          if (pattern646 (x2, 
E_V4DImode, 
E_V4BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1124 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33465; /* pred_vghshv4di */

        case E_V8DImode:
          if (pattern646 (x2, 
E_V8DImode, 
E_V8BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1125 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33469; /* pred_vghshv8di */

        case E_V16DImode:
          if (pattern646 (x2, 
E_V16DImode, 
E_V16BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1126 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33473; /* pred_vghshv16di */

        case E_V32DImode:
          if (pattern646 (x2, 
E_V32DImode, 
E_V32BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1127 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33477; /* pred_vghshv32di */

        case E_V64DImode:
          if (pattern646 (x2, 
E_V64DImode, 
E_V64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1128 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33481; /* pred_vghshv64di */

        case E_V128DImode:
          if (pattern646 (x2, 
E_V128DImode, 
E_V128BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1129 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33485; /* pred_vghshv128di */

        case E_V256DImode:
          if (pattern646 (x2, 
E_V256DImode, 
E_V256BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1130 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33489; /* pred_vghshv256di */

        case E_V512DImode:
          if (pattern646 (x2, 
E_V512DImode, 
E_V512BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1131 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33493; /* pred_vghshv512di */

        default:
          return -1;
        }

    case 220:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SImode:
          if (pattern646 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33378; /* pred_vsha2msrvvm8si */

        case E_RVVM4SImode:
          if (pattern646 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33382; /* pred_vsha2msrvvm4si */

        case E_RVVM2SImode:
          if (pattern646 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33386; /* pred_vsha2msrvvm2si */

        case E_RVVM1SImode:
          if (pattern646 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33390; /* pred_vsha2msrvvm1si */

        case E_RVVMF2SImode:
          if (pattern646 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33394; /* pred_vsha2msrvvmf2si */

        case E_RVVM8DImode:
          if (pattern646 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33398; /* pred_vsha2msrvvm8di */

        case E_RVVM4DImode:
          if (pattern646 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33402; /* pred_vsha2msrvvm4di */

        case E_RVVM2DImode:
          if (pattern646 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33406; /* pred_vsha2msrvvm2di */

        case E_RVVM1DImode:
          if (pattern646 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33410; /* pred_vsha2msrvvm1di */

        case E_V1SImode:
          if (pattern646 (x2, 
E_V1SImode, 
E_V1BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 33414; /* pred_vsha2msv1si */

        case E_V2SImode:
          if (pattern646 (x2, 
E_V2SImode, 
E_V2BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 33418; /* pred_vsha2msv2si */

        case E_V4SImode:
          if (pattern646 (x2, 
E_V4SImode, 
E_V4BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 33422; /* pred_vsha2msv4si */

        case E_V8SImode:
          if (pattern646 (x2, 
E_V8SImode, 
E_V8BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 33426; /* pred_vsha2msv8si */

        case E_V16SImode:
          if (pattern646 (x2, 
E_V16SImode, 
E_V16BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33430; /* pred_vsha2msv16si */

        case E_V32SImode:
          if (pattern646 (x2, 
E_V32SImode, 
E_V32BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33434; /* pred_vsha2msv32si */

        case E_V64SImode:
          if (pattern646 (x2, 
E_V64SImode, 
E_V64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33438; /* pred_vsha2msv64si */

        case E_V128SImode:
          if (pattern646 (x2, 
E_V128SImode, 
E_V128BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1118 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33442; /* pred_vsha2msv128si */

        case E_V256SImode:
          if (pattern646 (x2, 
E_V256SImode, 
E_V256BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1119 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33446; /* pred_vsha2msv256si */

        case E_V512SImode:
          if (pattern646 (x2, 
E_V512SImode, 
E_V512BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1120 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33450; /* pred_vsha2msv512si */

        case E_V1024SImode:
          if (pattern646 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1121 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33454; /* pred_vsha2msv1024si */

        case E_V1DImode:
          if (pattern646 (x2, 
E_V1DImode, 
E_V1BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1122 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33458; /* pred_vsha2msv1di */

        case E_V2DImode:
          if (pattern646 (x2, 
E_V2DImode, 
E_V2BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1123 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33462; /* pred_vsha2msv2di */

        case E_V4DImode:
          if (pattern646 (x2, 
E_V4DImode, 
E_V4BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1124 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33466; /* pred_vsha2msv4di */

        case E_V8DImode:
          if (pattern646 (x2, 
E_V8DImode, 
E_V8BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1125 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33470; /* pred_vsha2msv8di */

        case E_V16DImode:
          if (pattern646 (x2, 
E_V16DImode, 
E_V16BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1126 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33474; /* pred_vsha2msv16di */

        case E_V32DImode:
          if (pattern646 (x2, 
E_V32DImode, 
E_V32BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1127 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33478; /* pred_vsha2msv32di */

        case E_V64DImode:
          if (pattern646 (x2, 
E_V64DImode, 
E_V64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1128 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33482; /* pred_vsha2msv64di */

        case E_V128DImode:
          if (pattern646 (x2, 
E_V128DImode, 
E_V128BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1129 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33486; /* pred_vsha2msv128di */

        case E_V256DImode:
          if (pattern646 (x2, 
E_V256DImode, 
E_V256BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1130 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33490; /* pred_vsha2msv256di */

        case E_V512DImode:
          if (pattern646 (x2, 
E_V512DImode, 
E_V512BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1131 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33494; /* pred_vsha2msv512di */

        default:
          return -1;
        }

    case 221:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8SImode:
          if (pattern646 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33379; /* pred_vsha2chrvvm8si */

        case E_RVVM4SImode:
          if (pattern646 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33383; /* pred_vsha2chrvvm4si */

        case E_RVVM2SImode:
          if (pattern646 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33387; /* pred_vsha2chrvvm2si */

        case E_RVVM1SImode:
          if (pattern646 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
              || !
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG))
            return -1;
          return 33391; /* pred_vsha2chrvvm1si */

        case E_RVVMF2SImode:
          if (pattern646 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1106 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33395; /* pred_vsha2chrvvmf2si */

        case E_RVVM8DImode:
          if (pattern646 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33399; /* pred_vsha2chrvvm8di */

        case E_RVVM4DImode:
          if (pattern646 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1108 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33403; /* pred_vsha2chrvvm4di */

        case E_RVVM2DImode:
          if (pattern646 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33407; /* pred_vsha2chrvvm2di */

        case E_RVVM1DImode:
          if (pattern646 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1109 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33411; /* pred_vsha2chrvvm1di */

        case E_V1SImode:
          if (pattern646 (x2, 
E_V1SImode, 
E_V1BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1111 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 33415; /* pred_vsha2chv1si */

        case E_V2SImode:
          if (pattern646 (x2, 
E_V2SImode, 
E_V2BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1112 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 33419; /* pred_vsha2chv2si */

        case E_V4SImode:
          if (pattern646 (x2, 
E_V4SImode, 
E_V4BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1113 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 33423; /* pred_vsha2chv4si */

        case E_V8SImode:
          if (pattern646 (x2, 
E_V8SImode, 
E_V8BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1114 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 33427; /* pred_vsha2chv8si */

        case E_V16SImode:
          if (pattern646 (x2, 
E_V16SImode, 
E_V16BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1115 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33431; /* pred_vsha2chv16si */

        case E_V32SImode:
          if (pattern646 (x2, 
E_V32SImode, 
E_V32BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1116 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33435; /* pred_vsha2chv32si */

        case E_V64SImode:
          if (pattern646 (x2, 
E_V64SImode, 
E_V64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1117 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33439; /* pred_vsha2chv64si */

        case E_V128SImode:
          if (pattern646 (x2, 
E_V128SImode, 
E_V128BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1118 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33443; /* pred_vsha2chv128si */

        case E_V256SImode:
          if (pattern646 (x2, 
E_V256SImode, 
E_V256BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1119 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33447; /* pred_vsha2chv256si */

        case E_V512SImode:
          if (pattern646 (x2, 
E_V512SImode, 
E_V512BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1120 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33451; /* pred_vsha2chv512si */

        case E_V1024SImode:
          if (pattern646 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1121 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33455; /* pred_vsha2chv1024si */

        case E_V1DImode:
          if (pattern646 (x2, 
E_V1DImode, 
E_V1BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1122 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33459; /* pred_vsha2chv1di */

        case E_V2DImode:
          if (pattern646 (x2, 
E_V2DImode, 
E_V2BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1123 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33463; /* pred_vsha2chv2di */

        case E_V4DImode:
          if (pattern646 (x2, 
E_V4DImode, 
E_V4BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1124 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33467; /* pred_vsha2chv4di */

        case E_V8DImode:
          if (pattern646 (x2, 
E_V8DImode, 
E_V8BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1125 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 33471; /* pred_vsha2chv8di */

        case E_V16DImode:
          if (pattern646 (x2, 
E_V16DImode, 
E_V16BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1126 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 33475; /* pred_vsha2chv16di */

        case E_V32DImode:
          if (pattern646 (x2, 
E_V32DImode, 
E_V32BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1127 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 33479; /* pred_vsha2chv32di */

        case E_V64DImode:
          if (pattern646 (x2, 
E_V64DImode, 
E_V64BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1128 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 33483; /* pred_vsha2chv64di */

        case E_V128DImode:
          if (pattern646 (x2, 
E_V128DImode, 
E_V128BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1129 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 33487; /* pred_vsha2chv128di */

        case E_V256DImode:
          if (pattern646 (x2, 
E_V256DImode, 
E_V256BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1130 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 33491; /* pred_vsha2chv256di */

        case E_V512DImode:
          if (pattern646 (x2, 
E_V512DImode, 
E_V512BImode) != 0
              || !(
#line 480 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNHA || TARGET_ZVKNHB || TARGET_ZVKG) && 
#line 1131 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 33495; /* pred_vsha2chv512di */

        default:
          return -1;
        }

    case 222:
      return recog_406 (x1, insn, pnum_clobbers);

    case 219:
      switch (pattern600 (x2))
        {
        case 0:
          if (!
#line 631 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33747; /* pred_viaeskf2rvvm8si_nomaskedoff_scalar */

        case 1:
          if (!
#line 631 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33749; /* pred_viaeskf2rvvm4si_nomaskedoff_scalar */

        case 2:
          if (!
#line 631 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33751; /* pred_viaeskf2rvvm2si_nomaskedoff_scalar */

        case 3:
          if (!
#line 631 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33753; /* pred_viaeskf2rvvm1si_nomaskedoff_scalar */

        case 4:
          if (!(
#line 631 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH) && 
#line 4403 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33755; /* pred_viaeskf2rvvmf2si_nomaskedoff_scalar */

        default:
          return -1;
        }

    case 228:
      switch (pattern600 (x2))
        {
        case 0:
          if (!
#line 631 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33748; /* pred_vism3crvvm8si_nomaskedoff_scalar */

        case 1:
          if (!
#line 631 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33750; /* pred_vism3crvvm4si_nomaskedoff_scalar */

        case 2:
          if (!
#line 631 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33752; /* pred_vism3crvvm2si_nomaskedoff_scalar */

        case 3:
          if (!
#line 631 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH))
            return -1;
          return 33754; /* pred_vism3crvvm1si_nomaskedoff_scalar */

        case 4:
          if (!(
#line 631 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVKNED || TARGET_ZVKSH) && 
#line 4403 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 33756; /* pred_vism3crvvmf2si_nomaskedoff_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_424 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V1DFmode, 
E_V1BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1BImode)
      && vector_const_0_operand (operands[3], E_V1DFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 4343; /* *pred_broadcastv1df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1DFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 4465; /* *pred_broadcastv1df_imm */
}

 int
recog_428 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V128SFmode, 
E_V128BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V128BImode)
      && vector_const_0_operand (operands[3], E_V128SFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return 4339; /* *pred_broadcastv128sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V128BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V128SFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 4461; /* *pred_broadcastv128sf_imm */
}

 int
recog_432 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V8SFmode, 
E_V8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V8BImode)
      && vector_const_0_operand (operands[3], E_V8SFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 4335; /* *pred_broadcastv8sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V8SFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4457; /* *pred_broadcastv8sf_imm */
}

 int
recog_435 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V1SFmode, 
E_V1BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V1BImode)
      && vector_const_0_operand (operands[3], E_V1SFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 4332; /* *pred_broadcastv1sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V1BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V1SFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4454; /* *pred_broadcastv1sf_imm */
}

 int
recog_440 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V128HFmode, 
E_V128BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V128BImode)
      && vector_const_0_operand (operands[3], E_V128HFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
    return 4327; /* *pred_broadcastv128hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V128BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V128HFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 4449; /* *pred_broadcastv128hf_imm */
}

 int
recog_445 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V4HFmode, 
E_V4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V4BImode)
      && vector_const_0_operand (operands[3], E_V4HFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return 4322; /* *pred_broadcastv4hf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V4HFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
    return -1;
  return 4444; /* *pred_broadcastv4hf_imm */
}

 int
recog_450 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V128DImode, 
E_V128BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V128BImode)
      && vector_const_0_operand (operands[3], E_V128DImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return 4317; /* *pred_broadcastv128di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V128BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V128DImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 4439; /* *pred_broadcastv128di_imm */
}

 int
recog_455 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V4DImode, 
E_V4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V4BImode)
      && vector_const_0_operand (operands[3], E_V4DImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return 4312; /* *pred_broadcastv4di_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V4DImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
    return -1;
  return 4434; /* *pred_broadcastv4di_imm */
}

 int
recog_459 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V512SImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V512BImode)
      && vector_const_0_operand (operands[3], E_V512SImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return 4308; /* *pred_broadcastv512si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V512BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V512SImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 4430; /* *pred_broadcastv512si_imm */
}

 int
recog_465 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V8SImode, 
E_V8BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V8BImode)
      && vector_const_0_operand (operands[3], E_V8SImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return 4302; /* *pred_broadcastv8si_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V8BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V8SImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
    return -1;
  return 4424; /* *pred_broadcastv8si_imm */
}

 int
recog_471 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V512HImode, 
E_V512BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V512BImode)
      && vector_const_0_operand (operands[3], E_V512HImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return 4296; /* *pred_broadcastv512hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V512BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V512HImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 4418; /* *pred_broadcastv512hi_imm */
}

 int
recog_478 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V4HImode, 
E_V4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V4BImode)
      && vector_const_0_operand (operands[3], E_V4HImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return 4289; /* *pred_broadcastv4hi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V4HImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
    return -1;
  return 4411; /* *pred_broadcastv4hi_imm */
}

 int
recog_486 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_V128QImode, 
E_V128BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_V128BImode)
      && vector_const_0_operand (operands[3], E_V128QImode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return 4281; /* *pred_broadcastv128qi_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_V128BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_V128QImode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 4403; /* *pred_broadcastv128qi_imm */
}

 int
recog_494 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF64BImode)
      && vector_const_0_operand (operands[3], E_RVVM1DFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 4273; /* *pred_broadcastrvvm1df_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF64BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM1DFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 4395; /* *pred_broadcastrvvm1df_imm */
}

 int
recog_502 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern602 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
    return -1;
  if (vector_least_significant_set_mask_operand (operands[1], E_RVVMF4BImode)
      && vector_const_0_operand (operands[3], E_RVVM8SFmode)
      && (
#line 2340 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 4265; /* *pred_broadcastrvvm8sf_zero */
  if (!vector_all_trues_mask_operand (operands[1], E_RVVMF4BImode)
      || !vector_const_int_or_double_0_operand (operands[3], E_RVVM8SFmode)
      || !(
#line 2360 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 4387; /* *pred_broadcastrvvm8sf_imm */
}

 int
recog_510 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern669 (x2))
    {
    case 0:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4720; /* pred_indexed_uloadrvvm8qi_same_eew */

    case 1:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4722; /* pred_indexed_uloadrvvm4qi_same_eew */

    case 2:
      if (!
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5088; /* pred_indexed_uloadrvvm4qi_x2_smaller_eew */

    case 3:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4724; /* pred_indexed_uloadrvvm2qi_same_eew */

    case 4:
      if (!
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5090; /* pred_indexed_uloadrvvm2qi_x2_smaller_eew */

    case 5:
      if (!
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5146; /* pred_indexed_uloadrvvm2qi_x4_smaller_eew */

    case 6:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4726; /* pred_indexed_uloadrvvm1qi_same_eew */

    case 7:
      if (!
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5092; /* pred_indexed_uloadrvvm1qi_x2_smaller_eew */

    case 8:
      if (!
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5148; /* pred_indexed_uloadrvvm1qi_x4_smaller_eew */

    case 9:
      if (!(
#line 2571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 395 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5180; /* pred_indexed_uloadrvvm1qi_x8_smaller_eew */

    case 10:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4728; /* pred_indexed_uloadrvvmf2qi_same_eew */

    case 11:
      if (!
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5094; /* pred_indexed_uloadrvvmf2qi_x2_smaller_eew */

    case 12:
      if (!
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5150; /* pred_indexed_uloadrvvmf2qi_x4_smaller_eew */

    case 13:
      if (!(
#line 2571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 396 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5182; /* pred_indexed_uloadrvvmf2qi_x8_smaller_eew */

    case 14:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4730; /* pred_indexed_uloadrvvmf4qi_same_eew */

    case 15:
      if (!
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5096; /* pred_indexed_uloadrvvmf4qi_x2_smaller_eew */

    case 16:
      if (!
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5152; /* pred_indexed_uloadrvvmf4qi_x4_smaller_eew */

    case 17:
      if (!(
#line 2571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 397 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5184; /* pred_indexed_uloadrvvmf4qi_x8_smaller_eew */

    case 18:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1542 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4732; /* pred_indexed_uloadrvvmf8qi_same_eew */

    case 19:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 352 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5098; /* pred_indexed_uloadrvvmf8qi_x2_smaller_eew */

    case 20:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 376 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5154; /* pred_indexed_uloadrvvmf8qi_x4_smaller_eew */

    case 21:
      if (!(
#line 2571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 398 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5186; /* pred_indexed_uloadrvvmf8qi_x8_smaller_eew */

    case 22:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4734; /* pred_indexed_uloadrvvm8hi_same_eew */

    case 23:
      if (!
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4964; /* pred_indexed_uloadrvvm8hi_x2_greater_eew */

    case 24:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4736; /* pred_indexed_uloadrvvm4hi_same_eew */

    case 25:
      if (!
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4966; /* pred_indexed_uloadrvvm4hi_x2_greater_eew */

    case 26:
      if (!
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5100; /* pred_indexed_uloadrvvm4hi_x2_smaller_eew */

    case 27:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4738; /* pred_indexed_uloadrvvm2hi_same_eew */

    case 28:
      if (!
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4968; /* pred_indexed_uloadrvvm2hi_x2_greater_eew */

    case 29:
      if (!
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5102; /* pred_indexed_uloadrvvm2hi_x2_smaller_eew */

    case 30:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 378 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5156; /* pred_indexed_uloadrvvm2hi_x4_smaller_eew */

    case 31:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4740; /* pred_indexed_uloadrvvm1hi_same_eew */

    case 32:
      if (!
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4970; /* pred_indexed_uloadrvvm1hi_x2_greater_eew */

    case 33:
      if (!
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5104; /* pred_indexed_uloadrvvm1hi_x2_smaller_eew */

    case 34:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 379 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5158; /* pred_indexed_uloadrvvm1hi_x4_smaller_eew */

    case 35:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4742; /* pred_indexed_uloadrvvmf2hi_same_eew */

    case 36:
      if (!
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4972; /* pred_indexed_uloadrvvmf2hi_x2_greater_eew */

    case 37:
      if (!
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5106; /* pred_indexed_uloadrvvmf2hi_x2_smaller_eew */

    case 38:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 380 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5160; /* pred_indexed_uloadrvvmf2hi_x4_smaller_eew */

    case 39:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1544 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4744; /* pred_indexed_uloadrvvmf4hi_same_eew */

    case 40:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 308 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4974; /* pred_indexed_uloadrvvmf4hi_x2_greater_eew */

    case 41:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 354 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5108; /* pred_indexed_uloadrvvmf4hi_x2_smaller_eew */

    case 42:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 381 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5162; /* pred_indexed_uloadrvvmf4hi_x4_smaller_eew */

    case 43:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4746; /* pred_indexed_uloadrvvm8si_same_eew */

    case 44:
      if (!
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5000; /* pred_indexed_uloadrvvm8si_x2_greater_eew */

    case 45:
      if (!
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5036; /* pred_indexed_uloadrvvm8si_x4_greater_eew */

    case 46:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4748; /* pred_indexed_uloadrvvm4si_same_eew */

    case 47:
      if (!
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5002; /* pred_indexed_uloadrvvm4si_x2_greater_eew */

    case 48:
      if (!
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5038; /* pred_indexed_uloadrvvm4si_x4_greater_eew */

    case 49:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 364 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5130; /* pred_indexed_uloadrvvm4si_x2_smaller_eew */

    case 50:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4750; /* pred_indexed_uloadrvvm2si_same_eew */

    case 51:
      if (!
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5004; /* pred_indexed_uloadrvvm2si_x2_greater_eew */

    case 52:
      if (!
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5040; /* pred_indexed_uloadrvvm2si_x4_greater_eew */

    case 53:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 365 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5132; /* pred_indexed_uloadrvvm2si_x2_smaller_eew */

    case 54:
      if (!
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 4752; /* pred_indexed_uloadrvvm1si_same_eew */

    case 55:
      if (!
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5006; /* pred_indexed_uloadrvvm1si_x2_greater_eew */

    case 56:
      if (!
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 5042; /* pred_indexed_uloadrvvm1si_x4_greater_eew */

    case 57:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 366 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_64BIT)))
        return -1;
      return 5134; /* pred_indexed_uloadrvvm1si_x2_smaller_eew */

    case 58:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1546 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4754; /* pred_indexed_uloadrvvmf2si_same_eew */

    case 59:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 318 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5008; /* pred_indexed_uloadrvvmf2si_x2_greater_eew */

    case 60:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5044; /* pred_indexed_uloadrvvmf2si_x4_greater_eew */

    case 61:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 367 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5136; /* pred_indexed_uloadrvvmf2si_x2_smaller_eew */

    case 62:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1548 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4756; /* pred_indexed_uloadrvvm8di_same_eew */

    case 63:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 323 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5020; /* pred_indexed_uloadrvvm8di_x2_greater_eew */

    case 64:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 336 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5056; /* pred_indexed_uloadrvvm8di_x4_greater_eew */

    case 65:
      if (!(
#line 2507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 344 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5072; /* pred_indexed_uloadrvvm8di_x8_greater_eew */

    case 66:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1549 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4758; /* pred_indexed_uloadrvvm4di_same_eew */

    case 67:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 323 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5022; /* pred_indexed_uloadrvvm4di_x2_greater_eew */

    case 68:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 336 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5058; /* pred_indexed_uloadrvvm4di_x4_greater_eew */

    case 69:
      if (!(
#line 2507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 344 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5074; /* pred_indexed_uloadrvvm4di_x8_greater_eew */

    case 70:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1550 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4760; /* pred_indexed_uloadrvvm2di_same_eew */

    case 71:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 324 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5024; /* pred_indexed_uloadrvvm2di_x2_greater_eew */

    case 72:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 337 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5060; /* pred_indexed_uloadrvvm2di_x4_greater_eew */

    case 73:
      if (!(
#line 2507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 345 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5076; /* pred_indexed_uloadrvvm2di_x8_greater_eew */

    case 74:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1551 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4762; /* pred_indexed_uloadrvvm1di_same_eew */

    case 75:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 324 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5026; /* pred_indexed_uloadrvvm1di_x2_greater_eew */

    case 76:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 337 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5062; /* pred_indexed_uloadrvvm1di_x4_greater_eew */

    case 77:
      if (!(
#line 2507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 345 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5078; /* pred_indexed_uloadrvvm1di_x8_greater_eew */

    case 78:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1553 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4764; /* pred_indexed_uloadrvvm8bf_same_eew */

    case 79:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4976; /* pred_indexed_uloadrvvm8bf_x2_greater_eew */

    case 80:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1554 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4766; /* pred_indexed_uloadrvvm4bf_same_eew */

    case 81:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4978; /* pred_indexed_uloadrvvm4bf_x2_greater_eew */

    case 82:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 356 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5110; /* pred_indexed_uloadrvvm4bf_x2_smaller_eew */

    case 83:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1555 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4768; /* pred_indexed_uloadrvvm2bf_same_eew */

    case 84:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4980; /* pred_indexed_uloadrvvm2bf_x2_greater_eew */

    case 85:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 356 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5112; /* pred_indexed_uloadrvvm2bf_x2_smaller_eew */

    case 86:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 383 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5164; /* pred_indexed_uloadrvvm2bf_x4_smaller_eew */

    case 87:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1556 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4770; /* pred_indexed_uloadrvvm1bf_same_eew */

    case 88:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4982; /* pred_indexed_uloadrvvm1bf_x2_greater_eew */

    case 89:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 357 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5114; /* pred_indexed_uloadrvvm1bf_x2_smaller_eew */

    case 90:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 384 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5166; /* pred_indexed_uloadrvvm1bf_x4_smaller_eew */

    case 91:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1557 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4772; /* pred_indexed_uloadrvvmf2bf_same_eew */

    case 92:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 4984; /* pred_indexed_uloadrvvmf2bf_x2_greater_eew */

    case 93:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 357 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5116; /* pred_indexed_uloadrvvmf2bf_x2_smaller_eew */

    case 94:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 385 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 5168; /* pred_indexed_uloadrvvmf2bf_x4_smaller_eew */

    case 95:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1558 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4774; /* pred_indexed_uloadrvvmf4bf_same_eew */

    case 96:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 312 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4986; /* pred_indexed_uloadrvvmf4bf_x2_greater_eew */

    case 97:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 358 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5118; /* pred_indexed_uloadrvvmf4bf_x2_smaller_eew */

    case 98:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 386 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5170; /* pred_indexed_uloadrvvmf4bf_x4_smaller_eew */

    case 99:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1560 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4776; /* pred_indexed_uloadrvvm8hf_same_eew */

    case 100:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 314 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4988; /* pred_indexed_uloadrvvm8hf_x2_greater_eew */

    case 101:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1560 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4778; /* pred_indexed_uloadrvvm4hf_same_eew */

    case 102:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 314 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4990; /* pred_indexed_uloadrvvm4hf_x2_greater_eew */

    case 103:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 360 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5120; /* pred_indexed_uloadrvvm4hf_x2_smaller_eew */

    case 104:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1560 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4780; /* pred_indexed_uloadrvvm2hf_same_eew */

    case 105:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 314 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4992; /* pred_indexed_uloadrvvm2hf_x2_greater_eew */

    case 106:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 360 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5122; /* pred_indexed_uloadrvvm2hf_x2_smaller_eew */

    case 107:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 388 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_64BIT)))
        return -1;
      return 5172; /* pred_indexed_uloadrvvm2hf_x4_smaller_eew */

    case 108:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1561 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4782; /* pred_indexed_uloadrvvm1hf_same_eew */

    case 109:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 315 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4994; /* pred_indexed_uloadrvvm1hf_x2_greater_eew */

    case 110:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 361 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5124; /* pred_indexed_uloadrvvm1hf_x2_smaller_eew */

    case 111:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 389 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_64BIT)))
        return -1;
      return 5174; /* pred_indexed_uloadrvvm1hf_x4_smaller_eew */

    case 112:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1561 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 4784; /* pred_indexed_uloadrvvmf2hf_same_eew */

    case 113:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 315 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 4996; /* pred_indexed_uloadrvvmf2hf_x2_greater_eew */

    case 114:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 361 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 5126; /* pred_indexed_uloadrvvmf2hf_x2_smaller_eew */

    case 115:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 390 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_64BIT)))
        return -1;
      return 5176; /* pred_indexed_uloadrvvmf2hf_x4_smaller_eew */

    case 116:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1562 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4786; /* pred_indexed_uloadrvvmf4hf_same_eew */

    case 117:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 316 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4998; /* pred_indexed_uloadrvvmf4hf_x2_greater_eew */

    case 118:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 362 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5128; /* pred_indexed_uloadrvvmf4hf_x2_smaller_eew */

    case 119:
      if (!(
#line 2550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 391 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5178; /* pred_indexed_uloadrvvmf4hf_x4_smaller_eew */

    case 120:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1564 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4788; /* pred_indexed_uloadrvvm8sf_same_eew */

    case 121:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 320 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5010; /* pred_indexed_uloadrvvm8sf_x2_greater_eew */

    case 122:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5046; /* pred_indexed_uloadrvvm8sf_x4_greater_eew */

    case 123:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1564 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4790; /* pred_indexed_uloadrvvm4sf_same_eew */

    case 124:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 320 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5012; /* pred_indexed_uloadrvvm4sf_x2_greater_eew */

    case 125:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5048; /* pred_indexed_uloadrvvm4sf_x4_greater_eew */

    case 126:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 369 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_64BIT)))
        return -1;
      return 5138; /* pred_indexed_uloadrvvm4sf_x2_smaller_eew */

    case 127:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1565 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4792; /* pred_indexed_uloadrvvm2sf_same_eew */

    case 128:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 320 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5014; /* pred_indexed_uloadrvvm2sf_x2_greater_eew */

    case 129:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5050; /* pred_indexed_uloadrvvm2sf_x4_greater_eew */

    case 130:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 370 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_64BIT)))
        return -1;
      return 5140; /* pred_indexed_uloadrvvm2sf_x2_smaller_eew */

    case 131:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1565 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4794; /* pred_indexed_uloadrvvm1sf_same_eew */

    case 132:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 321 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5016; /* pred_indexed_uloadrvvm1sf_x2_greater_eew */

    case 133:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 334 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 5052; /* pred_indexed_uloadrvvm1sf_x4_greater_eew */

    case 134:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 371 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_64BIT)))
        return -1;
      return 5142; /* pred_indexed_uloadrvvm1sf_x2_smaller_eew */

    case 135:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1566 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 4796; /* pred_indexed_uloadrvvmf2sf_same_eew */

    case 136:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 321 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5018; /* pred_indexed_uloadrvvmf2sf_x2_greater_eew */

    case 137:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 334 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 5054; /* pred_indexed_uloadrvvmf2sf_x4_greater_eew */

    case 138:
      if (!(
#line 2529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 372 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 5144; /* pred_indexed_uloadrvvmf2sf_x2_smaller_eew */

    case 139:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1568 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4798; /* pred_indexed_uloadrvvm8df_same_eew */

    case 140:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 326 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5028; /* pred_indexed_uloadrvvm8df_x2_greater_eew */

    case 141:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 339 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5064; /* pred_indexed_uloadrvvm8df_x4_greater_eew */

    case 142:
      if (!(
#line 2507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 347 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5080; /* pred_indexed_uloadrvvm8df_x8_greater_eew */

    case 143:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1569 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4800; /* pred_indexed_uloadrvvm4df_same_eew */

    case 144:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 326 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5030; /* pred_indexed_uloadrvvm4df_x2_greater_eew */

    case 145:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 339 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5066; /* pred_indexed_uloadrvvm4df_x4_greater_eew */

    case 146:
      if (!(
#line 2507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 347 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5082; /* pred_indexed_uloadrvvm4df_x8_greater_eew */

    case 147:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1570 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4802; /* pred_indexed_uloadrvvm2df_same_eew */

    case 148:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5032; /* pred_indexed_uloadrvvm2df_x2_greater_eew */

    case 149:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 340 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5068; /* pred_indexed_uloadrvvm2df_x4_greater_eew */

    case 150:
      if (!(
#line 2507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 348 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5084; /* pred_indexed_uloadrvvm2df_x8_greater_eew */

    case 151:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1571 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4804; /* pred_indexed_uloadrvvm1df_same_eew */

    case 152:
      if (!(
#line 2465 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5034; /* pred_indexed_uloadrvvm1df_x2_greater_eew */

    case 153:
      if (!(
#line 2486 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 340 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5070; /* pred_indexed_uloadrvvm1df_x4_greater_eew */

    case 154:
      if (!(
#line 2507 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 348 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 5086; /* pred_indexed_uloadrvvm1df_x8_greater_eew */

    case 155:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1573 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 4806; /* pred_indexed_uloadv1qi_same_eew */

    case 156:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1574 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 4808; /* pred_indexed_uloadv2qi_same_eew */

    case 157:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1575 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 4810; /* pred_indexed_uloadv4qi_same_eew */

    case 158:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1576 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 4812; /* pred_indexed_uloadv8qi_same_eew */

    case 159:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1577 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 4814; /* pred_indexed_uloadv16qi_same_eew */

    case 160:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1578 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 4816; /* pred_indexed_uloadv32qi_same_eew */

    case 161:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1579 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4818; /* pred_indexed_uloadv64qi_same_eew */

    case 162:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1580 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4820; /* pred_indexed_uloadv128qi_same_eew */

    case 163:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1581 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4822; /* pred_indexed_uloadv256qi_same_eew */

    case 164:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1582 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4824; /* pred_indexed_uloadv512qi_same_eew */

    case 165:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1583 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4826; /* pred_indexed_uloadv1024qi_same_eew */

    case 166:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1584 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4828; /* pred_indexed_uloadv2048qi_same_eew */

    case 167:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1585 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4830; /* pred_indexed_uloadv4096qi_same_eew */

    case 168:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1586 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 4832; /* pred_indexed_uloadv1hi_same_eew */

    case 169:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1587 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 4834; /* pred_indexed_uloadv2hi_same_eew */

    case 170:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1588 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 4836; /* pred_indexed_uloadv4hi_same_eew */

    case 171:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1589 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 4838; /* pred_indexed_uloadv8hi_same_eew */

    case 172:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1590 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 4840; /* pred_indexed_uloadv16hi_same_eew */

    case 173:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1591 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4842; /* pred_indexed_uloadv32hi_same_eew */

    case 174:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1592 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4844; /* pred_indexed_uloadv64hi_same_eew */

    case 175:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1593 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4846; /* pred_indexed_uloadv128hi_same_eew */

    case 176:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1594 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4848; /* pred_indexed_uloadv256hi_same_eew */

    case 177:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1595 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4850; /* pred_indexed_uloadv512hi_same_eew */

    case 178:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1596 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4852; /* pred_indexed_uloadv1024hi_same_eew */

    case 179:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1597 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4854; /* pred_indexed_uloadv2048hi_same_eew */

    case 180:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1598 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 4856; /* pred_indexed_uloadv1si_same_eew */

    case 181:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1599 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 4858; /* pred_indexed_uloadv2si_same_eew */

    case 182:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1600 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 4860; /* pred_indexed_uloadv4si_same_eew */

    case 183:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1601 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 4862; /* pred_indexed_uloadv8si_same_eew */

    case 184:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1602 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4864; /* pred_indexed_uloadv16si_same_eew */

    case 185:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1603 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4866; /* pred_indexed_uloadv32si_same_eew */

    case 186:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1604 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4868; /* pred_indexed_uloadv64si_same_eew */

    case 187:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1605 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4870; /* pred_indexed_uloadv128si_same_eew */

    case 188:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1606 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4872; /* pred_indexed_uloadv256si_same_eew */

    case 189:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1607 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4874; /* pred_indexed_uloadv512si_same_eew */

    case 190:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1608 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4876; /* pred_indexed_uloadv1024si_same_eew */

    case 191:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1609 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4878; /* pred_indexed_uloadv1di_same_eew */

    case 192:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1610 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4880; /* pred_indexed_uloadv2di_same_eew */

    case 193:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1611 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 4882; /* pred_indexed_uloadv4di_same_eew */

    case 194:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1612 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64 && TARGET_64BIT)))
        return -1;
      return 4884; /* pred_indexed_uloadv8di_same_eew */

    case 195:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1613 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128 && TARGET_64BIT)))
        return -1;
      return 4886; /* pred_indexed_uloadv16di_same_eew */

    case 196:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1614 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256 && TARGET_64BIT)))
        return -1;
      return 4888; /* pred_indexed_uloadv32di_same_eew */

    case 197:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1615 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512 && TARGET_64BIT)))
        return -1;
      return 4890; /* pred_indexed_uloadv64di_same_eew */

    case 198:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1616 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024 && TARGET_64BIT)))
        return -1;
      return 4892; /* pred_indexed_uloadv128di_same_eew */

    case 199:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1617 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048 && TARGET_64BIT)))
        return -1;
      return 4894; /* pred_indexed_uloadv256di_same_eew */

    case 200:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1618 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096 && TARGET_64BIT)))
        return -1;
      return 4896; /* pred_indexed_uloadv512di_same_eew */

    case 201:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1620 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 4898; /* pred_indexed_uloadv1hf_same_eew */

    case 202:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1621 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 4900; /* pred_indexed_uloadv2hf_same_eew */

    case 203:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1622 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 4902; /* pred_indexed_uloadv4hf_same_eew */

    case 204:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1623 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 4904; /* pred_indexed_uloadv8hf_same_eew */

    case 205:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1624 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 4906; /* pred_indexed_uloadv16hf_same_eew */

    case 206:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1625 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4908; /* pred_indexed_uloadv32hf_same_eew */

    case 207:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1626 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4910; /* pred_indexed_uloadv64hf_same_eew */

    case 208:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1627 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4912; /* pred_indexed_uloadv128hf_same_eew */

    case 209:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1628 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4914; /* pred_indexed_uloadv256hf_same_eew */

    case 210:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1629 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4916; /* pred_indexed_uloadv512hf_same_eew */

    case 211:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1630 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4918; /* pred_indexed_uloadv1024hf_same_eew */

    case 212:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1631 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4920; /* pred_indexed_uloadv2048hf_same_eew */

    case 213:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1632 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4922; /* pred_indexed_uloadv1sf_same_eew */

    case 214:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1633 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4924; /* pred_indexed_uloadv2sf_same_eew */

    case 215:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1634 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4926; /* pred_indexed_uloadv4sf_same_eew */

    case 216:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1635 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 4928; /* pred_indexed_uloadv8sf_same_eew */

    case 217:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1636 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 4930; /* pred_indexed_uloadv16sf_same_eew */

    case 218:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1637 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 4932; /* pred_indexed_uloadv32sf_same_eew */

    case 219:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1638 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 4934; /* pred_indexed_uloadv64sf_same_eew */

    case 220:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1639 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 4936; /* pred_indexed_uloadv128sf_same_eew */

    case 221:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1640 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 4938; /* pred_indexed_uloadv256sf_same_eew */

    case 222:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1641 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 4940; /* pred_indexed_uloadv512sf_same_eew */

    case 223:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1642 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 4942; /* pred_indexed_uloadv1024sf_same_eew */

    case 224:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1643 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4944; /* pred_indexed_uloadv1df_same_eew */

    case 225:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1644 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4946; /* pred_indexed_uloadv2df_same_eew */

    case 226:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1645 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_64BIT)))
        return -1;
      return 4948; /* pred_indexed_uloadv4df_same_eew */

    case 227:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1646 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64 && TARGET_64BIT)))
        return -1;
      return 4950; /* pred_indexed_uloadv8df_same_eew */

    case 228:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1647 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128 && TARGET_64BIT)))
        return -1;
      return 4952; /* pred_indexed_uloadv16df_same_eew */

    case 229:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1648 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256 && TARGET_64BIT)))
        return -1;
      return 4954; /* pred_indexed_uloadv32df_same_eew */

    case 230:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1649 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512 && TARGET_64BIT)))
        return -1;
      return 4956; /* pred_indexed_uloadv64df_same_eew */

    case 231:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1650 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024 && TARGET_64BIT)))
        return -1;
      return 4958; /* pred_indexed_uloadv128df_same_eew */

    case 232:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1651 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048 && TARGET_64BIT)))
        return -1;
      return 4960; /* pred_indexed_uloadv256df_same_eew */

    case 233:
      if (!(
#line 2443 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1652 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096 && TARGET_64BIT)))
        return -1;
      return 4962; /* pred_indexed_uloadv512df_same_eew */

    case 234:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21934; /* pred_indexed_uloadrvvmf8x2qirvvmf8qi */

    case 235:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21936; /* pred_indexed_uloadrvvmf8x2qirvvmf4hi */

    case 236:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21938; /* pred_indexed_uloadrvvmf8x2qirvvmf2si */

    case 237:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21940; /* pred_indexed_uloadrvvmf8x2qirvvm1di */

    case 238:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21942; /* pred_indexed_uloadrvvmf8x3qirvvmf8qi */

    case 239:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21944; /* pred_indexed_uloadrvvmf8x3qirvvmf4hi */

    case 240:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21946; /* pred_indexed_uloadrvvmf8x3qirvvmf2si */

    case 241:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21948; /* pred_indexed_uloadrvvmf8x3qirvvm1di */

    case 242:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21950; /* pred_indexed_uloadrvvmf8x4qirvvmf8qi */

    case 243:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21952; /* pred_indexed_uloadrvvmf8x4qirvvmf4hi */

    case 244:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21954; /* pred_indexed_uloadrvvmf8x4qirvvmf2si */

    case 245:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21956; /* pred_indexed_uloadrvvmf8x4qirvvm1di */

    case 246:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21958; /* pred_indexed_uloadrvvmf8x5qirvvmf8qi */

    case 247:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21960; /* pred_indexed_uloadrvvmf8x5qirvvmf4hi */

    case 248:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21962; /* pred_indexed_uloadrvvmf8x5qirvvmf2si */

    case 249:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21964; /* pred_indexed_uloadrvvmf8x5qirvvm1di */

    case 250:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21966; /* pred_indexed_uloadrvvmf8x6qirvvmf8qi */

    case 251:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21968; /* pred_indexed_uloadrvvmf8x6qirvvmf4hi */

    case 252:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21970; /* pred_indexed_uloadrvvmf8x6qirvvmf2si */

    case 253:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21972; /* pred_indexed_uloadrvvmf8x6qirvvm1di */

    case 254:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21974; /* pred_indexed_uloadrvvmf8x7qirvvmf8qi */

    case 255:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21976; /* pred_indexed_uloadrvvmf8x7qirvvmf4hi */

    case 256:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21978; /* pred_indexed_uloadrvvmf8x7qirvvmf2si */

    case 257:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21980; /* pred_indexed_uloadrvvmf8x7qirvvm1di */

    case 258:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21982; /* pred_indexed_uloadrvvmf8x8qirvvmf8qi */

    case 259:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21984; /* pred_indexed_uloadrvvmf8x8qirvvmf4hi */

    case 260:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21986; /* pred_indexed_uloadrvvmf8x8qirvvmf2si */

    case 261:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1173 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21988; /* pred_indexed_uloadrvvmf8x8qirvvm1di */

    case 262:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21990; /* pred_indexed_uloadrvvmf4x2hirvvmf8qi */

    case 263:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21992; /* pred_indexed_uloadrvvmf4x2hirvvmf4hi */

    case 264:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21994; /* pred_indexed_uloadrvvmf4x2hirvvmf2si */

    case 265:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1174 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 21996; /* pred_indexed_uloadrvvmf4x2hirvvm1di */

    case 266:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 21998; /* pred_indexed_uloadrvvmf4x3hirvvmf8qi */

    case 267:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22000; /* pred_indexed_uloadrvvmf4x3hirvvmf4hi */

    case 268:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22002; /* pred_indexed_uloadrvvmf4x3hirvvmf2si */

    case 269:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1175 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22004; /* pred_indexed_uloadrvvmf4x3hirvvm1di */

    case 270:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22006; /* pred_indexed_uloadrvvmf4x4hirvvmf8qi */

    case 271:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22008; /* pred_indexed_uloadrvvmf4x4hirvvmf4hi */

    case 272:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22010; /* pred_indexed_uloadrvvmf4x4hirvvmf2si */

    case 273:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22012; /* pred_indexed_uloadrvvmf4x4hirvvm1di */

    case 274:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22014; /* pred_indexed_uloadrvvmf4x5hirvvmf8qi */

    case 275:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22016; /* pred_indexed_uloadrvvmf4x5hirvvmf4hi */

    case 276:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22018; /* pred_indexed_uloadrvvmf4x5hirvvmf2si */

    case 277:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22020; /* pred_indexed_uloadrvvmf4x5hirvvm1di */

    case 278:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22022; /* pred_indexed_uloadrvvmf4x6hirvvmf8qi */

    case 279:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22024; /* pred_indexed_uloadrvvmf4x6hirvvmf4hi */

    case 280:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22026; /* pred_indexed_uloadrvvmf4x6hirvvmf2si */

    case 281:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22028; /* pred_indexed_uloadrvvmf4x6hirvvm1di */

    case 282:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22030; /* pred_indexed_uloadrvvmf4x7hirvvmf8qi */

    case 283:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22032; /* pred_indexed_uloadrvvmf4x7hirvvmf4hi */

    case 284:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22034; /* pred_indexed_uloadrvvmf4x7hirvvmf2si */

    case 285:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1179 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22036; /* pred_indexed_uloadrvvmf4x7hirvvm1di */

    case 286:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22038; /* pred_indexed_uloadrvvmf4x8hirvvmf8qi */

    case 287:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22040; /* pred_indexed_uloadrvvmf4x8hirvvmf4hi */

    case 288:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22042; /* pred_indexed_uloadrvvmf4x8hirvvmf2si */

    case 289:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22044; /* pred_indexed_uloadrvvmf4x8hirvvm1di */

    case 290:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22046; /* pred_indexed_uloadrvvmf2x2sirvvmf8qi */

    case 291:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22048; /* pred_indexed_uloadrvvmf2x2sirvvmf4hi */

    case 292:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22050; /* pred_indexed_uloadrvvmf2x2sirvvmf2si */

    case 293:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22052; /* pred_indexed_uloadrvvmf2x2sirvvm1di */

    case 294:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22054; /* pred_indexed_uloadrvvmf2x3sirvvmf8qi */

    case 295:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22056; /* pred_indexed_uloadrvvmf2x3sirvvmf4hi */

    case 296:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22058; /* pred_indexed_uloadrvvmf2x3sirvvmf2si */

    case 297:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1182 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22060; /* pred_indexed_uloadrvvmf2x3sirvvm1di */

    case 298:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22062; /* pred_indexed_uloadrvvmf2x4sirvvmf8qi */

    case 299:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22064; /* pred_indexed_uloadrvvmf2x4sirvvmf4hi */

    case 300:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22066; /* pred_indexed_uloadrvvmf2x4sirvvmf2si */

    case 301:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22068; /* pred_indexed_uloadrvvmf2x4sirvvm1di */

    case 302:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22070; /* pred_indexed_uloadrvvmf2x5sirvvmf8qi */

    case 303:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22072; /* pred_indexed_uloadrvvmf2x5sirvvmf4hi */

    case 304:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22074; /* pred_indexed_uloadrvvmf2x5sirvvmf2si */

    case 305:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22076; /* pred_indexed_uloadrvvmf2x5sirvvm1di */

    case 306:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22078; /* pred_indexed_uloadrvvmf2x6sirvvmf8qi */

    case 307:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22080; /* pred_indexed_uloadrvvmf2x6sirvvmf4hi */

    case 308:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22082; /* pred_indexed_uloadrvvmf2x6sirvvmf2si */

    case 309:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1185 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22084; /* pred_indexed_uloadrvvmf2x6sirvvm1di */

    case 310:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22086; /* pred_indexed_uloadrvvmf2x7sirvvmf8qi */

    case 311:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22088; /* pred_indexed_uloadrvvmf2x7sirvvmf4hi */

    case 312:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22090; /* pred_indexed_uloadrvvmf2x7sirvvmf2si */

    case 313:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1186 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22092; /* pred_indexed_uloadrvvmf2x7sirvvm1di */

    case 314:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22094; /* pred_indexed_uloadrvvmf2x8sirvvmf8qi */

    case 315:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22096; /* pred_indexed_uloadrvvmf2x8sirvvmf4hi */

    case 316:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22098; /* pred_indexed_uloadrvvmf2x8sirvvmf2si */

    case 317:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1187 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22100; /* pred_indexed_uloadrvvmf2x8sirvvm1di */

    case 318:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22102; /* pred_indexed_uloadrvvm1x2dirvvmf8qi */

    case 319:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22104; /* pred_indexed_uloadrvvm1x2dirvvmf4hi */

    case 320:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22106; /* pred_indexed_uloadrvvm1x2dirvvmf2si */

    case 321:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1188 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22108; /* pred_indexed_uloadrvvm1x2dirvvm1di */

    case 322:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22110; /* pred_indexed_uloadrvvm1x3dirvvmf8qi */

    case 323:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22112; /* pred_indexed_uloadrvvm1x3dirvvmf4hi */

    case 324:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22114; /* pred_indexed_uloadrvvm1x3dirvvmf2si */

    case 325:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1189 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22116; /* pred_indexed_uloadrvvm1x3dirvvm1di */

    case 326:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22118; /* pred_indexed_uloadrvvm1x4dirvvmf8qi */

    case 327:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22120; /* pred_indexed_uloadrvvm1x4dirvvmf4hi */

    case 328:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22122; /* pred_indexed_uloadrvvm1x4dirvvmf2si */

    case 329:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1190 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22124; /* pred_indexed_uloadrvvm1x4dirvvm1di */

    case 330:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22126; /* pred_indexed_uloadrvvm1x5dirvvmf8qi */

    case 331:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22128; /* pred_indexed_uloadrvvm1x5dirvvmf4hi */

    case 332:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22130; /* pred_indexed_uloadrvvm1x5dirvvmf2si */

    case 333:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1191 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22132; /* pred_indexed_uloadrvvm1x5dirvvm1di */

    case 334:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22134; /* pred_indexed_uloadrvvm1x6dirvvmf8qi */

    case 335:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22136; /* pred_indexed_uloadrvvm1x6dirvvmf4hi */

    case 336:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22138; /* pred_indexed_uloadrvvm1x6dirvvmf2si */

    case 337:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1192 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22140; /* pred_indexed_uloadrvvm1x6dirvvm1di */

    case 338:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22142; /* pred_indexed_uloadrvvm1x7dirvvmf8qi */

    case 339:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22144; /* pred_indexed_uloadrvvm1x7dirvvmf4hi */

    case 340:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22146; /* pred_indexed_uloadrvvm1x7dirvvmf2si */

    case 341:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1193 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22148; /* pred_indexed_uloadrvvm1x7dirvvm1di */

    case 342:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22150; /* pred_indexed_uloadrvvm1x8dirvvmf8qi */

    case 343:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22152; /* pred_indexed_uloadrvvm1x8dirvvmf4hi */

    case 344:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22154; /* pred_indexed_uloadrvvm1x8dirvvmf2si */

    case 345:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1194 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22156; /* pred_indexed_uloadrvvm1x8dirvvm1di */

    case 346:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22158; /* pred_indexed_uloadrvvmf4x2bfrvvmf8qi */

    case 347:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22160; /* pred_indexed_uloadrvvmf4x2bfrvvmf4hi */

    case 348:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22162; /* pred_indexed_uloadrvvmf4x2bfrvvmf2si */

    case 349:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1195 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22164; /* pred_indexed_uloadrvvmf4x2bfrvvm1di */

    case 350:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22166; /* pred_indexed_uloadrvvmf4x3bfrvvmf8qi */

    case 351:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22168; /* pred_indexed_uloadrvvmf4x3bfrvvmf4hi */

    case 352:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22170; /* pred_indexed_uloadrvvmf4x3bfrvvmf2si */

    case 353:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1196 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22172; /* pred_indexed_uloadrvvmf4x3bfrvvm1di */

    case 354:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22174; /* pred_indexed_uloadrvvmf4x4bfrvvmf8qi */

    case 355:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22176; /* pred_indexed_uloadrvvmf4x4bfrvvmf4hi */

    case 356:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22178; /* pred_indexed_uloadrvvmf4x4bfrvvmf2si */

    case 357:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1197 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22180; /* pred_indexed_uloadrvvmf4x4bfrvvm1di */

    case 358:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22182; /* pred_indexed_uloadrvvmf4x5bfrvvmf8qi */

    case 359:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22184; /* pred_indexed_uloadrvvmf4x5bfrvvmf4hi */

    case 360:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22186; /* pred_indexed_uloadrvvmf4x5bfrvvmf2si */

    case 361:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1198 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22188; /* pred_indexed_uloadrvvmf4x5bfrvvm1di */

    case 362:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22190; /* pred_indexed_uloadrvvmf4x6bfrvvmf8qi */

    case 363:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22192; /* pred_indexed_uloadrvvmf4x6bfrvvmf4hi */

    case 364:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22194; /* pred_indexed_uloadrvvmf4x6bfrvvmf2si */

    case 365:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1199 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22196; /* pred_indexed_uloadrvvmf4x6bfrvvm1di */

    case 366:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22198; /* pred_indexed_uloadrvvmf4x7bfrvvmf8qi */

    case 367:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22200; /* pred_indexed_uloadrvvmf4x7bfrvvmf4hi */

    case 368:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22202; /* pred_indexed_uloadrvvmf4x7bfrvvmf2si */

    case 369:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1200 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22204; /* pred_indexed_uloadrvvmf4x7bfrvvm1di */

    case 370:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22206; /* pred_indexed_uloadrvvmf4x8bfrvvmf8qi */

    case 371:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22208; /* pred_indexed_uloadrvvmf4x8bfrvvmf4hi */

    case 372:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22210; /* pred_indexed_uloadrvvmf4x8bfrvvmf2si */

    case 373:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1201 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22212; /* pred_indexed_uloadrvvmf4x8bfrvvm1di */

    case 374:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22214; /* pred_indexed_uloadrvvmf4x2hfrvvmf8qi */

    case 375:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22216; /* pred_indexed_uloadrvvmf4x2hfrvvmf4hi */

    case 376:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22218; /* pred_indexed_uloadrvvmf4x2hfrvvmf2si */

    case 377:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1202 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22220; /* pred_indexed_uloadrvvmf4x2hfrvvm1di */

    case 378:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22222; /* pred_indexed_uloadrvvmf4x3hfrvvmf8qi */

    case 379:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22224; /* pred_indexed_uloadrvvmf4x3hfrvvmf4hi */

    case 380:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22226; /* pred_indexed_uloadrvvmf4x3hfrvvmf2si */

    case 381:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1203 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22228; /* pred_indexed_uloadrvvmf4x3hfrvvm1di */

    case 382:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22230; /* pred_indexed_uloadrvvmf4x4hfrvvmf8qi */

    case 383:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22232; /* pred_indexed_uloadrvvmf4x4hfrvvmf4hi */

    case 384:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22234; /* pred_indexed_uloadrvvmf4x4hfrvvmf2si */

    case 385:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1204 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22236; /* pred_indexed_uloadrvvmf4x4hfrvvm1di */

    case 386:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22238; /* pred_indexed_uloadrvvmf4x5hfrvvmf8qi */

    case 387:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22240; /* pred_indexed_uloadrvvmf4x5hfrvvmf4hi */

    case 388:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22242; /* pred_indexed_uloadrvvmf4x5hfrvvmf2si */

    case 389:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1205 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22244; /* pred_indexed_uloadrvvmf4x5hfrvvm1di */

    case 390:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22246; /* pred_indexed_uloadrvvmf4x6hfrvvmf8qi */

    case 391:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22248; /* pred_indexed_uloadrvvmf4x6hfrvvmf4hi */

    case 392:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22250; /* pred_indexed_uloadrvvmf4x6hfrvvmf2si */

    case 393:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1206 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22252; /* pred_indexed_uloadrvvmf4x6hfrvvm1di */

    case 394:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22254; /* pred_indexed_uloadrvvmf4x7hfrvvmf8qi */

    case 395:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22256; /* pred_indexed_uloadrvvmf4x7hfrvvmf4hi */

    case 396:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22258; /* pred_indexed_uloadrvvmf4x7hfrvvmf2si */

    case 397:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1207 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22260; /* pred_indexed_uloadrvvmf4x7hfrvvm1di */

    case 398:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22262; /* pred_indexed_uloadrvvmf4x8hfrvvmf8qi */

    case 399:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22264; /* pred_indexed_uloadrvvmf4x8hfrvvmf4hi */

    case 400:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22266; /* pred_indexed_uloadrvvmf4x8hfrvvmf2si */

    case 401:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1208 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22268; /* pred_indexed_uloadrvvmf4x8hfrvvm1di */

    case 402:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22270; /* pred_indexed_uloadrvvmf2x2sfrvvmf8qi */

    case 403:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22272; /* pred_indexed_uloadrvvmf2x2sfrvvmf4hi */

    case 404:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22274; /* pred_indexed_uloadrvvmf2x2sfrvvmf2si */

    case 405:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1209 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22276; /* pred_indexed_uloadrvvmf2x2sfrvvm1di */

    case 406:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22278; /* pred_indexed_uloadrvvmf2x3sfrvvmf8qi */

    case 407:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22280; /* pred_indexed_uloadrvvmf2x3sfrvvmf4hi */

    case 408:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22282; /* pred_indexed_uloadrvvmf2x3sfrvvmf2si */

    case 409:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1210 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22284; /* pred_indexed_uloadrvvmf2x3sfrvvm1di */

    case 410:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22286; /* pred_indexed_uloadrvvmf2x4sfrvvmf8qi */

    case 411:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22288; /* pred_indexed_uloadrvvmf2x4sfrvvmf4hi */

    case 412:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22290; /* pred_indexed_uloadrvvmf2x4sfrvvmf2si */

    case 413:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1211 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22292; /* pred_indexed_uloadrvvmf2x4sfrvvm1di */

    case 414:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22294; /* pred_indexed_uloadrvvmf2x5sfrvvmf8qi */

    case 415:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22296; /* pred_indexed_uloadrvvmf2x5sfrvvmf4hi */

    case 416:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22298; /* pred_indexed_uloadrvvmf2x5sfrvvmf2si */

    case 417:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1212 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22300; /* pred_indexed_uloadrvvmf2x5sfrvvm1di */

    case 418:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22302; /* pred_indexed_uloadrvvmf2x6sfrvvmf8qi */

    case 419:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22304; /* pred_indexed_uloadrvvmf2x6sfrvvmf4hi */

    case 420:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22306; /* pred_indexed_uloadrvvmf2x6sfrvvmf2si */

    case 421:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1213 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22308; /* pred_indexed_uloadrvvmf2x6sfrvvm1di */

    case 422:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22310; /* pred_indexed_uloadrvvmf2x7sfrvvmf8qi */

    case 423:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22312; /* pred_indexed_uloadrvvmf2x7sfrvvmf4hi */

    case 424:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22314; /* pred_indexed_uloadrvvmf2x7sfrvvmf2si */

    case 425:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1214 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22316; /* pred_indexed_uloadrvvmf2x7sfrvvm1di */

    case 426:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22318; /* pred_indexed_uloadrvvmf2x8sfrvvmf8qi */

    case 427:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22320; /* pred_indexed_uloadrvvmf2x8sfrvvmf4hi */

    case 428:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22322; /* pred_indexed_uloadrvvmf2x8sfrvvmf2si */

    case 429:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1215 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22324; /* pred_indexed_uloadrvvmf2x8sfrvvm1di */

    case 430:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22326; /* pred_indexed_uloadrvvm1x2dfrvvmf8qi */

    case 431:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22328; /* pred_indexed_uloadrvvm1x2dfrvvmf4hi */

    case 432:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22330; /* pred_indexed_uloadrvvm1x2dfrvvmf2si */

    case 433:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1216 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22332; /* pred_indexed_uloadrvvm1x2dfrvvm1di */

    case 434:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22334; /* pred_indexed_uloadrvvm1x3dfrvvmf8qi */

    case 435:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22336; /* pred_indexed_uloadrvvm1x3dfrvvmf4hi */

    case 436:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22338; /* pred_indexed_uloadrvvm1x3dfrvvmf2si */

    case 437:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1217 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22340; /* pred_indexed_uloadrvvm1x3dfrvvm1di */

    case 438:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22342; /* pred_indexed_uloadrvvm1x4dfrvvmf8qi */

    case 439:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22344; /* pred_indexed_uloadrvvm1x4dfrvvmf4hi */

    case 440:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22346; /* pred_indexed_uloadrvvm1x4dfrvvmf2si */

    case 441:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1218 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22348; /* pred_indexed_uloadrvvm1x4dfrvvm1di */

    case 442:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22350; /* pred_indexed_uloadrvvm1x5dfrvvmf8qi */

    case 443:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22352; /* pred_indexed_uloadrvvm1x5dfrvvmf4hi */

    case 444:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22354; /* pred_indexed_uloadrvvm1x5dfrvvmf2si */

    case 445:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1219 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22356; /* pred_indexed_uloadrvvm1x5dfrvvm1di */

    case 446:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22358; /* pred_indexed_uloadrvvm1x6dfrvvmf8qi */

    case 447:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22360; /* pred_indexed_uloadrvvm1x6dfrvvmf4hi */

    case 448:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22362; /* pred_indexed_uloadrvvm1x6dfrvvmf2si */

    case 449:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1220 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22364; /* pred_indexed_uloadrvvm1x6dfrvvm1di */

    case 450:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22366; /* pred_indexed_uloadrvvm1x7dfrvvmf8qi */

    case 451:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22368; /* pred_indexed_uloadrvvm1x7dfrvvmf4hi */

    case 452:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22370; /* pred_indexed_uloadrvvm1x7dfrvvmf2si */

    case 453:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1221 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22372; /* pred_indexed_uloadrvvm1x7dfrvvm1di */

    case 454:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 870 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22374; /* pred_indexed_uloadrvvm1x8dfrvvmf8qi */

    case 455:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 871 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22376; /* pred_indexed_uloadrvvm1x8dfrvvmf4hi */

    case 456:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 872 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22378; /* pred_indexed_uloadrvvm1x8dfrvvmf2si */

    case 457:
      if (!(
#line 8487 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 873 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1222 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22380; /* pred_indexed_uloadrvvm1x8dfrvvm1di */

    case 458:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22382; /* pred_indexed_uloadrvvmf4x2qirvvmf4qi */

    case 459:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22478; /* pred_indexed_uloadrvvmf4x2qirvvmf2hi */

    case 460:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22574; /* pred_indexed_uloadrvvmf4x2qirvvm1si */

    case 461:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22670; /* pred_indexed_uloadrvvmf4x2qirvvm2di */

    case 462:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22384; /* pred_indexed_uloadrvvmf4x3qirvvmf4qi */

    case 463:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22480; /* pred_indexed_uloadrvvmf4x3qirvvmf2hi */

    case 464:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22576; /* pred_indexed_uloadrvvmf4x3qirvvm1si */

    case 465:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22672; /* pred_indexed_uloadrvvmf4x3qirvvm2di */

    case 466:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22386; /* pred_indexed_uloadrvvmf4x4qirvvmf4qi */

    case 467:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22482; /* pred_indexed_uloadrvvmf4x4qirvvmf2hi */

    case 468:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22578; /* pred_indexed_uloadrvvmf4x4qirvvm1si */

    case 469:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22674; /* pred_indexed_uloadrvvmf4x4qirvvm2di */

    case 470:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22388; /* pred_indexed_uloadrvvmf4x5qirvvmf4qi */

    case 471:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22484; /* pred_indexed_uloadrvvmf4x5qirvvmf2hi */

    case 472:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22580; /* pred_indexed_uloadrvvmf4x5qirvvm1si */

    case 473:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22676; /* pred_indexed_uloadrvvmf4x5qirvvm2di */

    case 474:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22390; /* pred_indexed_uloadrvvmf4x6qirvvmf4qi */

    case 475:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22486; /* pred_indexed_uloadrvvmf4x6qirvvmf2hi */

    case 476:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22582; /* pred_indexed_uloadrvvmf4x6qirvvm1si */

    case 477:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22678; /* pred_indexed_uloadrvvmf4x6qirvvm2di */

    case 478:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22392; /* pred_indexed_uloadrvvmf4x7qirvvmf4qi */

    case 479:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22488; /* pred_indexed_uloadrvvmf4x7qirvvmf2hi */

    case 480:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22584; /* pred_indexed_uloadrvvmf4x7qirvvm1si */

    case 481:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22680; /* pred_indexed_uloadrvvmf4x7qirvvm2di */

    case 482:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22394; /* pred_indexed_uloadrvvmf4x8qirvvmf4qi */

    case 483:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22490; /* pred_indexed_uloadrvvmf4x8qirvvmf2hi */

    case 484:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22586; /* pred_indexed_uloadrvvmf4x8qirvvm1si */

    case 485:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22682; /* pred_indexed_uloadrvvmf4x8qirvvm2di */

    case 486:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22396; /* pred_indexed_uloadrvvmf2x2hirvvmf4qi */

    case 487:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22492; /* pred_indexed_uloadrvvmf2x2hirvvmf2hi */

    case 488:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22588; /* pred_indexed_uloadrvvmf2x2hirvvm1si */

    case 489:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22684; /* pred_indexed_uloadrvvmf2x2hirvvm2di */

    case 490:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22398; /* pred_indexed_uloadrvvmf2x3hirvvmf4qi */

    case 491:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22494; /* pred_indexed_uloadrvvmf2x3hirvvmf2hi */

    case 492:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22590; /* pred_indexed_uloadrvvmf2x3hirvvm1si */

    case 493:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22686; /* pred_indexed_uloadrvvmf2x3hirvvm2di */

    case 494:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22400; /* pred_indexed_uloadrvvmf2x4hirvvmf4qi */

    case 495:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22496; /* pred_indexed_uloadrvvmf2x4hirvvmf2hi */

    case 496:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22592; /* pred_indexed_uloadrvvmf2x4hirvvm1si */

    case 497:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22688; /* pred_indexed_uloadrvvmf2x4hirvvm2di */

    case 498:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22402; /* pred_indexed_uloadrvvmf2x5hirvvmf4qi */

    case 499:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22498; /* pred_indexed_uloadrvvmf2x5hirvvmf2hi */

    case 500:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22594; /* pred_indexed_uloadrvvmf2x5hirvvm1si */

    case 501:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22690; /* pred_indexed_uloadrvvmf2x5hirvvm2di */

    case 502:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22404; /* pred_indexed_uloadrvvmf2x6hirvvmf4qi */

    case 503:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22500; /* pred_indexed_uloadrvvmf2x6hirvvmf2hi */

    case 504:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22596; /* pred_indexed_uloadrvvmf2x6hirvvm1si */

    case 505:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22692; /* pred_indexed_uloadrvvmf2x6hirvvm2di */

    case 506:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22406; /* pred_indexed_uloadrvvmf2x7hirvvmf4qi */

    case 507:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22502; /* pred_indexed_uloadrvvmf2x7hirvvmf2hi */

    case 508:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22598; /* pred_indexed_uloadrvvmf2x7hirvvm1si */

    case 509:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22694; /* pred_indexed_uloadrvvmf2x7hirvvm2di */

    case 510:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22408; /* pred_indexed_uloadrvvmf2x8hirvvmf4qi */

    case 511:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22504; /* pred_indexed_uloadrvvmf2x8hirvvmf2hi */

    case 512:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22600; /* pred_indexed_uloadrvvmf2x8hirvvm1si */

    case 513:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22696; /* pred_indexed_uloadrvvmf2x8hirvvm2di */

    case 514:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22410; /* pred_indexed_uloadrvvm1x2sirvvmf4qi */

    case 515:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22506; /* pred_indexed_uloadrvvm1x2sirvvmf2hi */

    case 516:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22602; /* pred_indexed_uloadrvvm1x2sirvvm1si */

    case 517:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22698; /* pred_indexed_uloadrvvm1x2sirvvm2di */

    case 518:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22412; /* pred_indexed_uloadrvvm1x3sirvvmf4qi */

    case 519:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22508; /* pred_indexed_uloadrvvm1x3sirvvmf2hi */

    case 520:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22604; /* pred_indexed_uloadrvvm1x3sirvvm1si */

    case 521:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22700; /* pred_indexed_uloadrvvm1x3sirvvm2di */

    case 522:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22414; /* pred_indexed_uloadrvvm1x4sirvvmf4qi */

    case 523:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22510; /* pred_indexed_uloadrvvm1x4sirvvmf2hi */

    case 524:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22606; /* pred_indexed_uloadrvvm1x4sirvvm1si */

    case 525:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22702; /* pred_indexed_uloadrvvm1x4sirvvm2di */

    case 526:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22416; /* pred_indexed_uloadrvvm1x5sirvvmf4qi */

    case 527:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22512; /* pred_indexed_uloadrvvm1x5sirvvmf2hi */

    case 528:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22608; /* pred_indexed_uloadrvvm1x5sirvvm1si */

    case 529:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22704; /* pred_indexed_uloadrvvm1x5sirvvm2di */

    case 530:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22418; /* pred_indexed_uloadrvvm1x6sirvvmf4qi */

    case 531:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22514; /* pred_indexed_uloadrvvm1x6sirvvmf2hi */

    case 532:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22610; /* pred_indexed_uloadrvvm1x6sirvvm1si */

    case 533:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22706; /* pred_indexed_uloadrvvm1x6sirvvm2di */

    case 534:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22420; /* pred_indexed_uloadrvvm1x7sirvvmf4qi */

    case 535:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22516; /* pred_indexed_uloadrvvm1x7sirvvmf2hi */

    case 536:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22612; /* pred_indexed_uloadrvvm1x7sirvvm1si */

    case 537:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22708; /* pred_indexed_uloadrvvm1x7sirvvm2di */

    case 538:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22422; /* pred_indexed_uloadrvvm1x8sirvvmf4qi */

    case 539:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22518; /* pred_indexed_uloadrvvm1x8sirvvmf2hi */

    case 540:
      if (!
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22614; /* pred_indexed_uloadrvvm1x8sirvvm1si */

    case 541:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22710; /* pred_indexed_uloadrvvm1x8sirvvm2di */

    case 542:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22424; /* pred_indexed_uloadrvvm2x2dirvvmf4qi */

    case 543:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22520; /* pred_indexed_uloadrvvm2x2dirvvmf2hi */

    case 544:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22616; /* pred_indexed_uloadrvvm2x2dirvvm1si */

    case 545:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1247 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22712; /* pred_indexed_uloadrvvm2x2dirvvm2di */

    case 546:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22426; /* pred_indexed_uloadrvvm2x3dirvvmf4qi */

    case 547:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22522; /* pred_indexed_uloadrvvm2x3dirvvmf2hi */

    case 548:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22618; /* pred_indexed_uloadrvvm2x3dirvvm1si */

    case 549:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1248 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22714; /* pred_indexed_uloadrvvm2x3dirvvm2di */

    case 550:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22428; /* pred_indexed_uloadrvvm2x4dirvvmf4qi */

    case 551:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22524; /* pred_indexed_uloadrvvm2x4dirvvmf2hi */

    case 552:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22620; /* pred_indexed_uloadrvvm2x4dirvvm1si */

    case 553:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1249 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 22716; /* pred_indexed_uloadrvvm2x4dirvvm2di */

    case 554:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22430; /* pred_indexed_uloadrvvmf2x2bfrvvmf4qi */

    case 555:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22526; /* pred_indexed_uloadrvvmf2x2bfrvvmf2hi */

    case 556:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22622; /* pred_indexed_uloadrvvmf2x2bfrvvm1si */

    case 557:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1250 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22718; /* pred_indexed_uloadrvvmf2x2bfrvvm2di */

    case 558:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22432; /* pred_indexed_uloadrvvmf2x3bfrvvmf4qi */

    case 559:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22528; /* pred_indexed_uloadrvvmf2x3bfrvvmf2hi */

    case 560:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22624; /* pred_indexed_uloadrvvmf2x3bfrvvm1si */

    case 561:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1251 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22720; /* pred_indexed_uloadrvvmf2x3bfrvvm2di */

    case 562:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22434; /* pred_indexed_uloadrvvmf2x4bfrvvmf4qi */

    case 563:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22530; /* pred_indexed_uloadrvvmf2x4bfrvvmf2hi */

    case 564:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22626; /* pred_indexed_uloadrvvmf2x4bfrvvm1si */

    case 565:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1252 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22722; /* pred_indexed_uloadrvvmf2x4bfrvvm2di */

    case 566:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22436; /* pred_indexed_uloadrvvmf2x5bfrvvmf4qi */

    case 567:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22532; /* pred_indexed_uloadrvvmf2x5bfrvvmf2hi */

    case 568:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22628; /* pred_indexed_uloadrvvmf2x5bfrvvm1si */

    case 569:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1253 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22724; /* pred_indexed_uloadrvvmf2x5bfrvvm2di */

    case 570:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22438; /* pred_indexed_uloadrvvmf2x6bfrvvmf4qi */

    case 571:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22534; /* pred_indexed_uloadrvvmf2x6bfrvvmf2hi */

    case 572:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22630; /* pred_indexed_uloadrvvmf2x6bfrvvm1si */

    case 573:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1254 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22726; /* pred_indexed_uloadrvvmf2x6bfrvvm2di */

    case 574:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22440; /* pred_indexed_uloadrvvmf2x7bfrvvmf4qi */

    case 575:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22536; /* pred_indexed_uloadrvvmf2x7bfrvvmf2hi */

    case 576:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22632; /* pred_indexed_uloadrvvmf2x7bfrvvm1si */

    case 577:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1255 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22728; /* pred_indexed_uloadrvvmf2x7bfrvvm2di */

    case 578:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22442; /* pred_indexed_uloadrvvmf2x8bfrvvmf4qi */

    case 579:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22538; /* pred_indexed_uloadrvvmf2x8bfrvvmf2hi */

    case 580:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22634; /* pred_indexed_uloadrvvmf2x8bfrvvm1si */

    case 581:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1256 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 22730; /* pred_indexed_uloadrvvmf2x8bfrvvm2di */

    case 582:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22444; /* pred_indexed_uloadrvvmf2x2hfrvvmf4qi */

    case 583:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22540; /* pred_indexed_uloadrvvmf2x2hfrvvmf2hi */

    case 584:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22636; /* pred_indexed_uloadrvvmf2x2hfrvvm1si */

    case 585:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1257 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22732; /* pred_indexed_uloadrvvmf2x2hfrvvm2di */

    case 586:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22446; /* pred_indexed_uloadrvvmf2x3hfrvvmf4qi */

    case 587:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22542; /* pred_indexed_uloadrvvmf2x3hfrvvmf2hi */

    case 588:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22638; /* pred_indexed_uloadrvvmf2x3hfrvvm1si */

    case 589:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1258 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22734; /* pred_indexed_uloadrvvmf2x3hfrvvm2di */

    case 590:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22448; /* pred_indexed_uloadrvvmf2x4hfrvvmf4qi */

    case 591:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22544; /* pred_indexed_uloadrvvmf2x4hfrvvmf2hi */

    case 592:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22640; /* pred_indexed_uloadrvvmf2x4hfrvvm1si */

    case 593:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1259 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22736; /* pred_indexed_uloadrvvmf2x4hfrvvm2di */

    case 594:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22450; /* pred_indexed_uloadrvvmf2x5hfrvvmf4qi */

    case 595:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22546; /* pred_indexed_uloadrvvmf2x5hfrvvmf2hi */

    case 596:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1260 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22642; /* pred_indexed_uloadrvvmf2x5hfrvvm1si */

    case 597:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1260 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1260 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22738; /* pred_indexed_uloadrvvmf2x5hfrvvm2di */

    case 598:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22452; /* pred_indexed_uloadrvvmf2x6hfrvvmf4qi */

    case 599:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22548; /* pred_indexed_uloadrvvmf2x6hfrvvmf2hi */

    case 600:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1261 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22644; /* pred_indexed_uloadrvvmf2x6hfrvvm1si */

    case 601:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1261 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1261 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22740; /* pred_indexed_uloadrvvmf2x6hfrvvm2di */

    case 602:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22454; /* pred_indexed_uloadrvvmf2x7hfrvvmf4qi */

    case 603:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22550; /* pred_indexed_uloadrvvmf2x7hfrvvmf2hi */

    case 604:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1262 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22646; /* pred_indexed_uloadrvvmf2x7hfrvvm1si */

    case 605:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1262 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1262 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22742; /* pred_indexed_uloadrvvmf2x7hfrvvm2di */

    case 606:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22456; /* pred_indexed_uloadrvvmf2x8hfrvvmf4qi */

    case 607:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22552; /* pred_indexed_uloadrvvmf2x8hfrvvmf2hi */

    case 608:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1263 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22648; /* pred_indexed_uloadrvvmf2x8hfrvvm1si */

    case 609:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1263 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1263 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 22744; /* pred_indexed_uloadrvvmf2x8hfrvvm2di */

    case 610:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22458; /* pred_indexed_uloadrvvm1x2sfrvvmf4qi */

    case 611:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22554; /* pred_indexed_uloadrvvm1x2sfrvvmf2hi */

    case 612:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1264 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22650; /* pred_indexed_uloadrvvm1x2sfrvvm1si */

    case 613:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1264 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1264 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22746; /* pred_indexed_uloadrvvm1x2sfrvvm2di */

    case 614:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22460; /* pred_indexed_uloadrvvm1x3sfrvvmf4qi */

    case 615:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22556; /* pred_indexed_uloadrvvm1x3sfrvvmf2hi */

    case 616:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1265 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22652; /* pred_indexed_uloadrvvm1x3sfrvvm1si */

    case 617:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1265 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1265 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22748; /* pred_indexed_uloadrvvm1x3sfrvvm2di */

    case 618:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22462; /* pred_indexed_uloadrvvm1x4sfrvvmf4qi */

    case 619:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22558; /* pred_indexed_uloadrvvm1x4sfrvvmf2hi */

    case 620:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1266 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22654; /* pred_indexed_uloadrvvm1x4sfrvvm1si */

    case 621:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1266 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1266 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22750; /* pred_indexed_uloadrvvm1x4sfrvvm2di */

    case 622:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22464; /* pred_indexed_uloadrvvm1x5sfrvvmf4qi */

    case 623:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22560; /* pred_indexed_uloadrvvm1x5sfrvvmf2hi */

    case 624:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1267 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22656; /* pred_indexed_uloadrvvm1x5sfrvvm1si */

    case 625:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1267 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1267 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22752; /* pred_indexed_uloadrvvm1x5sfrvvm2di */

    case 626:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22466; /* pred_indexed_uloadrvvm1x6sfrvvmf4qi */

    case 627:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22562; /* pred_indexed_uloadrvvm1x6sfrvvmf2hi */

    case 628:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1268 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22658; /* pred_indexed_uloadrvvm1x6sfrvvm1si */

    case 629:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1268 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1268 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22754; /* pred_indexed_uloadrvvm1x6sfrvvm2di */

    case 630:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22468; /* pred_indexed_uloadrvvm1x7sfrvvmf4qi */

    case 631:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22564; /* pred_indexed_uloadrvvm1x7sfrvvmf2hi */

    case 632:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1269 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22660; /* pred_indexed_uloadrvvm1x7sfrvvm1si */

    case 633:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1269 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1269 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22756; /* pred_indexed_uloadrvvm1x7sfrvvm2di */

    case 634:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22470; /* pred_indexed_uloadrvvm1x8sfrvvmf4qi */

    case 635:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22566; /* pred_indexed_uloadrvvm1x8sfrvvmf2hi */

    case 636:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1270 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22662; /* pred_indexed_uloadrvvm1x8sfrvvm1si */

    case 637:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1270 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1270 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 22758; /* pred_indexed_uloadrvvm1x8sfrvvm2di */

    case 638:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22472; /* pred_indexed_uloadrvvm2x2dfrvvmf4qi */

    case 639:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22568; /* pred_indexed_uloadrvvm2x2dfrvvmf2hi */

    case 640:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1271 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22664; /* pred_indexed_uloadrvvm2x2dfrvvm1si */

    case 641:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1271 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1271 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22760; /* pred_indexed_uloadrvvm2x2dfrvvm2di */

    case 642:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22474; /* pred_indexed_uloadrvvm2x3dfrvvmf4qi */

    case 643:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22570; /* pred_indexed_uloadrvvm2x3dfrvvmf2hi */

    case 644:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1272 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22666; /* pred_indexed_uloadrvvm2x3dfrvvm1si */

    case 645:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1272 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1272 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22762; /* pred_indexed_uloadrvvm2x3dfrvvm2di */

    case 646:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22476; /* pred_indexed_uloadrvvm2x4dfrvvmf4qi */

    case 647:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22572; /* pred_indexed_uloadrvvm2x4dfrvvmf2hi */

    case 648:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1273 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22668; /* pred_indexed_uloadrvvm2x4dfrvvm1si */

    case 649:
      if (!(
#line 8508 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1273 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 880 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1273 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 22764; /* pred_indexed_uloadrvvm2x4dfrvvm2di */

    case 650:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22766; /* pred_indexed_uloadrvvmf2x2qirvvmf2qi */

    case 651:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22838; /* pred_indexed_uloadrvvmf2x2qirvvm1hi */

    case 652:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22910; /* pred_indexed_uloadrvvmf2x2qirvvm2si */

    case 653:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22982; /* pred_indexed_uloadrvvmf2x2qirvvm4di */

    case 654:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22768; /* pred_indexed_uloadrvvmf2x3qirvvmf2qi */

    case 655:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22840; /* pred_indexed_uloadrvvmf2x3qirvvm1hi */

    case 656:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22912; /* pred_indexed_uloadrvvmf2x3qirvvm2si */

    case 657:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22984; /* pred_indexed_uloadrvvmf2x3qirvvm4di */

    case 658:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22770; /* pred_indexed_uloadrvvmf2x4qirvvmf2qi */

    case 659:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22842; /* pred_indexed_uloadrvvmf2x4qirvvm1hi */

    case 660:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22914; /* pred_indexed_uloadrvvmf2x4qirvvm2si */

    case 661:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22986; /* pred_indexed_uloadrvvmf2x4qirvvm4di */

    case 662:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22772; /* pred_indexed_uloadrvvmf2x5qirvvmf2qi */

    case 663:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22844; /* pred_indexed_uloadrvvmf2x5qirvvm1hi */

    case 664:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22916; /* pred_indexed_uloadrvvmf2x5qirvvm2si */

    case 665:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22988; /* pred_indexed_uloadrvvmf2x5qirvvm4di */

    case 666:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22774; /* pred_indexed_uloadrvvmf2x6qirvvmf2qi */

    case 667:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22846; /* pred_indexed_uloadrvvmf2x6qirvvm1hi */

    case 668:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22918; /* pred_indexed_uloadrvvmf2x6qirvvm2si */

    case 669:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22990; /* pred_indexed_uloadrvvmf2x6qirvvm4di */

    case 670:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22776; /* pred_indexed_uloadrvvmf2x7qirvvmf2qi */

    case 671:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22848; /* pred_indexed_uloadrvvmf2x7qirvvm1hi */

    case 672:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22920; /* pred_indexed_uloadrvvmf2x7qirvvm2si */

    case 673:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22992; /* pred_indexed_uloadrvvmf2x7qirvvm4di */

    case 674:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22778; /* pred_indexed_uloadrvvmf2x8qirvvmf2qi */

    case 675:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22850; /* pred_indexed_uloadrvvmf2x8qirvvm1hi */

    case 676:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22922; /* pred_indexed_uloadrvvmf2x8qirvvm2si */

    case 677:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22994; /* pred_indexed_uloadrvvmf2x8qirvvm4di */

    case 678:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22780; /* pred_indexed_uloadrvvm1x2hirvvmf2qi */

    case 679:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22852; /* pred_indexed_uloadrvvm1x2hirvvm1hi */

    case 680:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22924; /* pred_indexed_uloadrvvm1x2hirvvm2si */

    case 681:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22996; /* pred_indexed_uloadrvvm1x2hirvvm4di */

    case 682:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22782; /* pred_indexed_uloadrvvm1x3hirvvmf2qi */

    case 683:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22854; /* pred_indexed_uloadrvvm1x3hirvvm1hi */

    case 684:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22926; /* pred_indexed_uloadrvvm1x3hirvvm2si */

    case 685:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 22998; /* pred_indexed_uloadrvvm1x3hirvvm4di */

    case 686:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22784; /* pred_indexed_uloadrvvm1x4hirvvmf2qi */

    case 687:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22856; /* pred_indexed_uloadrvvm1x4hirvvm1hi */

    case 688:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22928; /* pred_indexed_uloadrvvm1x4hirvvm2si */

    case 689:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23000; /* pred_indexed_uloadrvvm1x4hirvvm4di */

    case 690:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22786; /* pred_indexed_uloadrvvm1x5hirvvmf2qi */

    case 691:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22858; /* pred_indexed_uloadrvvm1x5hirvvm1hi */

    case 692:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22930; /* pred_indexed_uloadrvvm1x5hirvvm2si */

    case 693:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23002; /* pred_indexed_uloadrvvm1x5hirvvm4di */

    case 694:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22788; /* pred_indexed_uloadrvvm1x6hirvvmf2qi */

    case 695:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22860; /* pred_indexed_uloadrvvm1x6hirvvm1hi */

    case 696:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22932; /* pred_indexed_uloadrvvm1x6hirvvm2si */

    case 697:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23004; /* pred_indexed_uloadrvvm1x6hirvvm4di */

    case 698:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22790; /* pred_indexed_uloadrvvm1x7hirvvmf2qi */

    case 699:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22862; /* pred_indexed_uloadrvvm1x7hirvvm1hi */

    case 700:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22934; /* pred_indexed_uloadrvvm1x7hirvvm2si */

    case 701:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23006; /* pred_indexed_uloadrvvm1x7hirvvm4di */

    case 702:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22792; /* pred_indexed_uloadrvvm1x8hirvvmf2qi */

    case 703:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22864; /* pred_indexed_uloadrvvm1x8hirvvm1hi */

    case 704:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22936; /* pred_indexed_uloadrvvm1x8hirvvm2si */

    case 705:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23008; /* pred_indexed_uloadrvvm1x8hirvvm4di */

    case 706:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22794; /* pred_indexed_uloadrvvm2x2sirvvmf2qi */

    case 707:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22866; /* pred_indexed_uloadrvvm2x2sirvvm1hi */

    case 708:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22938; /* pred_indexed_uloadrvvm2x2sirvvm2si */

    case 709:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23010; /* pred_indexed_uloadrvvm2x2sirvvm4di */

    case 710:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22796; /* pred_indexed_uloadrvvm2x3sirvvmf2qi */

    case 711:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22868; /* pred_indexed_uloadrvvm2x3sirvvm1hi */

    case 712:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22940; /* pred_indexed_uloadrvvm2x3sirvvm2si */

    case 713:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23012; /* pred_indexed_uloadrvvm2x3sirvvm4di */

    case 714:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22798; /* pred_indexed_uloadrvvm2x4sirvvmf2qi */

    case 715:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22870; /* pred_indexed_uloadrvvm2x4sirvvm1hi */

    case 716:
      if (!
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 22942; /* pred_indexed_uloadrvvm2x4sirvvm2si */

    case 717:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23014; /* pred_indexed_uloadrvvm2x4sirvvm4di */

    case 718:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22800; /* pred_indexed_uloadrvvm4x2dirvvmf2qi */

    case 719:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22872; /* pred_indexed_uloadrvvm4x2dirvvm1hi */

    case 720:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 22944; /* pred_indexed_uloadrvvm4x2dirvvm2si */

    case 721:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1294 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64))))
        return -1;
      return 23016; /* pred_indexed_uloadrvvm4x2dirvvm4di */

    case 722:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22802; /* pred_indexed_uloadrvvm1x2bfrvvmf2qi */

    case 723:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22874; /* pred_indexed_uloadrvvm1x2bfrvvm1hi */

    case 724:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22946; /* pred_indexed_uloadrvvm1x2bfrvvm2si */

    case 725:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1295 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23018; /* pred_indexed_uloadrvvm1x2bfrvvm4di */

    case 726:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22804; /* pred_indexed_uloadrvvm1x3bfrvvmf2qi */

    case 727:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22876; /* pred_indexed_uloadrvvm1x3bfrvvm1hi */

    case 728:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22948; /* pred_indexed_uloadrvvm1x3bfrvvm2si */

    case 729:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1296 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23020; /* pred_indexed_uloadrvvm1x3bfrvvm4di */

    case 730:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22806; /* pred_indexed_uloadrvvm1x4bfrvvmf2qi */

    case 731:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22878; /* pred_indexed_uloadrvvm1x4bfrvvm1hi */

    case 732:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22950; /* pred_indexed_uloadrvvm1x4bfrvvm2si */

    case 733:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1297 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23022; /* pred_indexed_uloadrvvm1x4bfrvvm4di */

    case 734:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22808; /* pred_indexed_uloadrvvm1x5bfrvvmf2qi */

    case 735:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22880; /* pred_indexed_uloadrvvm1x5bfrvvm1hi */

    case 736:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22952; /* pred_indexed_uloadrvvm1x5bfrvvm2si */

    case 737:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1298 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23024; /* pred_indexed_uloadrvvm1x5bfrvvm4di */

    case 738:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22810; /* pred_indexed_uloadrvvm1x6bfrvvmf2qi */

    case 739:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22882; /* pred_indexed_uloadrvvm1x6bfrvvm1hi */

    case 740:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1299 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22954; /* pred_indexed_uloadrvvm1x6bfrvvm2si */

    case 741:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1299 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1299 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23026; /* pred_indexed_uloadrvvm1x6bfrvvm4di */

    case 742:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22812; /* pred_indexed_uloadrvvm1x7bfrvvmf2qi */

    case 743:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22884; /* pred_indexed_uloadrvvm1x7bfrvvm1hi */

    case 744:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1300 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22956; /* pred_indexed_uloadrvvm1x7bfrvvm2si */

    case 745:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1300 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1300 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23028; /* pred_indexed_uloadrvvm1x7bfrvvm4di */

    case 746:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22814; /* pred_indexed_uloadrvvm1x8bfrvvmf2qi */

    case 747:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22886; /* pred_indexed_uloadrvvm1x8bfrvvm1hi */

    case 748:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1301 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 22958; /* pred_indexed_uloadrvvm1x8bfrvvm2si */

    case 749:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1301 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1301 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23030; /* pred_indexed_uloadrvvm1x8bfrvvm4di */

    case 750:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22816; /* pred_indexed_uloadrvvm1x2hfrvvmf2qi */

    case 751:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22888; /* pred_indexed_uloadrvvm1x2hfrvvm1hi */

    case 752:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1302 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22960; /* pred_indexed_uloadrvvm1x2hfrvvm2si */

    case 753:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1302 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1302 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23032; /* pred_indexed_uloadrvvm1x2hfrvvm4di */

    case 754:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22818; /* pred_indexed_uloadrvvm1x3hfrvvmf2qi */

    case 755:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22890; /* pred_indexed_uloadrvvm1x3hfrvvm1hi */

    case 756:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1303 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22962; /* pred_indexed_uloadrvvm1x3hfrvvm2si */

    case 757:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1303 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1303 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23034; /* pred_indexed_uloadrvvm1x3hfrvvm4di */

    case 758:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22820; /* pred_indexed_uloadrvvm1x4hfrvvmf2qi */

    case 759:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22892; /* pred_indexed_uloadrvvm1x4hfrvvm1hi */

    case 760:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1304 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22964; /* pred_indexed_uloadrvvm1x4hfrvvm2si */

    case 761:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1304 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1304 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23036; /* pred_indexed_uloadrvvm1x4hfrvvm4di */

    case 762:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22822; /* pred_indexed_uloadrvvm1x5hfrvvmf2qi */

    case 763:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22894; /* pred_indexed_uloadrvvm1x5hfrvvm1hi */

    case 764:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1305 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22966; /* pred_indexed_uloadrvvm1x5hfrvvm2si */

    case 765:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1305 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1305 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23038; /* pred_indexed_uloadrvvm1x5hfrvvm4di */

    case 766:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22824; /* pred_indexed_uloadrvvm1x6hfrvvmf2qi */

    case 767:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22896; /* pred_indexed_uloadrvvm1x6hfrvvm1hi */

    case 768:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1306 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22968; /* pred_indexed_uloadrvvm1x6hfrvvm2si */

    case 769:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1306 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1306 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23040; /* pred_indexed_uloadrvvm1x6hfrvvm4di */

    case 770:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22826; /* pred_indexed_uloadrvvm1x7hfrvvmf2qi */

    case 771:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22898; /* pred_indexed_uloadrvvm1x7hfrvvm1hi */

    case 772:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1307 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22970; /* pred_indexed_uloadrvvm1x7hfrvvm2si */

    case 773:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1307 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1307 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23042; /* pred_indexed_uloadrvvm1x7hfrvvm4di */

    case 774:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22828; /* pred_indexed_uloadrvvm1x8hfrvvmf2qi */

    case 775:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22900; /* pred_indexed_uloadrvvm1x8hfrvvm1hi */

    case 776:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1308 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 22972; /* pred_indexed_uloadrvvm1x8hfrvvm2si */

    case 777:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1308 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1308 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23044; /* pred_indexed_uloadrvvm1x8hfrvvm4di */

    case 778:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22830; /* pred_indexed_uloadrvvm2x2sfrvvmf2qi */

    case 779:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22902; /* pred_indexed_uloadrvvm2x2sfrvvm1hi */

    case 780:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1309 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22974; /* pred_indexed_uloadrvvm2x2sfrvvm2si */

    case 781:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1309 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1309 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23046; /* pred_indexed_uloadrvvm2x2sfrvvm4di */

    case 782:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22832; /* pred_indexed_uloadrvvm2x3sfrvvmf2qi */

    case 783:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22904; /* pred_indexed_uloadrvvm2x3sfrvvm1hi */

    case 784:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22976; /* pred_indexed_uloadrvvm2x3sfrvvm2si */

    case 785:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1310 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23048; /* pred_indexed_uloadrvvm2x3sfrvvm4di */

    case 786:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22834; /* pred_indexed_uloadrvvm2x4sfrvvmf2qi */

    case 787:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22906; /* pred_indexed_uloadrvvm2x4sfrvvm1hi */

    case 788:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 22978; /* pred_indexed_uloadrvvm2x4sfrvvm2si */

    case 789:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1311 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23050; /* pred_indexed_uloadrvvm2x4sfrvvm4di */

    case 790:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22836; /* pred_indexed_uloadrvvm4x2dfrvvmf2qi */

    case 791:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22908; /* pred_indexed_uloadrvvm4x2dfrvvm1hi */

    case 792:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1312 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 22980; /* pred_indexed_uloadrvvm4x2dfrvvm2si */

    case 793:
      if (!(
#line 8529 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1312 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64) && 
#line 887 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1312 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64))))
        return -1;
      return 23052; /* pred_indexed_uloadrvvm4x2dfrvvm4di */

    case 794:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23054; /* pred_indexed_uloadrvvm1x2qirvvm1qi */

    case 795:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23056; /* pred_indexed_uloadrvvm1x2qirvvm2hi */

    case 796:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23058; /* pred_indexed_uloadrvvm1x2qirvvm4si */

    case 797:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23060; /* pred_indexed_uloadrvvm1x2qirvvm8di */

    case 798:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23062; /* pred_indexed_uloadrvvm1x3qirvvm1qi */

    case 799:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23064; /* pred_indexed_uloadrvvm1x3qirvvm2hi */

    case 800:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23066; /* pred_indexed_uloadrvvm1x3qirvvm4si */

    case 801:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23068; /* pred_indexed_uloadrvvm1x3qirvvm8di */

    case 802:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23070; /* pred_indexed_uloadrvvm1x4qirvvm1qi */

    case 803:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23072; /* pred_indexed_uloadrvvm1x4qirvvm2hi */

    case 804:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23074; /* pred_indexed_uloadrvvm1x4qirvvm4si */

    case 805:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23076; /* pred_indexed_uloadrvvm1x4qirvvm8di */

    case 806:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23078; /* pred_indexed_uloadrvvm1x5qirvvm1qi */

    case 807:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23080; /* pred_indexed_uloadrvvm1x5qirvvm2hi */

    case 808:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23082; /* pred_indexed_uloadrvvm1x5qirvvm4si */

    case 809:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23084; /* pred_indexed_uloadrvvm1x5qirvvm8di */

    case 810:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23086; /* pred_indexed_uloadrvvm1x6qirvvm1qi */

    case 811:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23088; /* pred_indexed_uloadrvvm1x6qirvvm2hi */

    case 812:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23090; /* pred_indexed_uloadrvvm1x6qirvvm4si */

    case 813:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23092; /* pred_indexed_uloadrvvm1x6qirvvm8di */

    case 814:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23094; /* pred_indexed_uloadrvvm1x7qirvvm1qi */

    case 815:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23096; /* pred_indexed_uloadrvvm1x7qirvvm2hi */

    case 816:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23098; /* pred_indexed_uloadrvvm1x7qirvvm4si */

    case 817:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23100; /* pred_indexed_uloadrvvm1x7qirvvm8di */

    case 818:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23102; /* pred_indexed_uloadrvvm1x8qirvvm1qi */

    case 819:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23104; /* pred_indexed_uloadrvvm1x8qirvvm2hi */

    case 820:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23106; /* pred_indexed_uloadrvvm1x8qirvvm4si */

    case 821:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23108; /* pred_indexed_uloadrvvm1x8qirvvm8di */

    case 822:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23110; /* pred_indexed_uloadrvvm2x2hirvvm1qi */

    case 823:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23112; /* pred_indexed_uloadrvvm2x2hirvvm2hi */

    case 824:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23114; /* pred_indexed_uloadrvvm2x2hirvvm4si */

    case 825:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23116; /* pred_indexed_uloadrvvm2x2hirvvm8di */

    case 826:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23118; /* pred_indexed_uloadrvvm2x3hirvvm1qi */

    case 827:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23120; /* pred_indexed_uloadrvvm2x3hirvvm2hi */

    case 828:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23122; /* pred_indexed_uloadrvvm2x3hirvvm4si */

    case 829:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23124; /* pred_indexed_uloadrvvm2x3hirvvm8di */

    case 830:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23126; /* pred_indexed_uloadrvvm2x4hirvvm1qi */

    case 831:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23128; /* pred_indexed_uloadrvvm2x4hirvvm2hi */

    case 832:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23130; /* pred_indexed_uloadrvvm2x4hirvvm4si */

    case 833:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23132; /* pred_indexed_uloadrvvm2x4hirvvm8di */

    case 834:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23134; /* pred_indexed_uloadrvvm4x2sirvvm1qi */

    case 835:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23136; /* pred_indexed_uloadrvvm4x2sirvvm2hi */

    case 836:
      if (!
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23138; /* pred_indexed_uloadrvvm4x2sirvvm4si */

    case 837:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)))
        return -1;
      return 23140; /* pred_indexed_uloadrvvm4x2sirvvm8di */

    case 838:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23142; /* pred_indexed_uloadrvvm2x2bfrvvm1qi */

    case 839:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23144; /* pred_indexed_uloadrvvm2x2bfrvvm2hi */

    case 840:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23146; /* pred_indexed_uloadrvvm2x2bfrvvm4si */

    case 841:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1327 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23148; /* pred_indexed_uloadrvvm2x2bfrvvm8di */

    case 842:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23150; /* pred_indexed_uloadrvvm2x3bfrvvm1qi */

    case 843:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23152; /* pred_indexed_uloadrvvm2x3bfrvvm2hi */

    case 844:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23154; /* pred_indexed_uloadrvvm2x3bfrvvm4si */

    case 845:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1328 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23156; /* pred_indexed_uloadrvvm2x3bfrvvm8di */

    case 846:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23158; /* pred_indexed_uloadrvvm2x4bfrvvm1qi */

    case 847:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23160; /* pred_indexed_uloadrvvm2x4bfrvvm2hi */

    case 848:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1329 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23162; /* pred_indexed_uloadrvvm2x4bfrvvm4si */

    case 849:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1329 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1329 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16))))
        return -1;
      return 23164; /* pred_indexed_uloadrvvm2x4bfrvvm8di */

    case 850:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23166; /* pred_indexed_uloadrvvm2x2hfrvvm1qi */

    case 851:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23168; /* pred_indexed_uloadrvvm2x2hfrvvm2hi */

    case 852:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1330 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23170; /* pred_indexed_uloadrvvm2x2hfrvvm4si */

    case 853:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1330 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1330 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23172; /* pred_indexed_uloadrvvm2x2hfrvvm8di */

    case 854:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23174; /* pred_indexed_uloadrvvm2x3hfrvvm1qi */

    case 855:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23176; /* pred_indexed_uloadrvvm2x3hfrvvm2hi */

    case 856:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23178; /* pred_indexed_uloadrvvm2x3hfrvvm4si */

    case 857:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1331 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23180; /* pred_indexed_uloadrvvm2x3hfrvvm8di */

    case 858:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23182; /* pred_indexed_uloadrvvm2x4hfrvvm1qi */

    case 859:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23184; /* pred_indexed_uloadrvvm2x4hfrvvm2hi */

    case 860:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1332 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23186; /* pred_indexed_uloadrvvm2x4hfrvvm4si */

    case 861:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1332 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1332 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16))))
        return -1;
      return 23188; /* pred_indexed_uloadrvvm2x4hfrvvm8di */

    case 862:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23190; /* pred_indexed_uloadrvvm4x2sfrvvm1qi */

    case 863:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23192; /* pred_indexed_uloadrvvm4x2sfrvvm2hi */

    case 864:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 23194; /* pred_indexed_uloadrvvm4x2sfrvvm4si */

    case 865:
      if (!(
#line 8550 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && ((
#line 1333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32) && 
#line 894 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_64BIT)) && 
#line 1333 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32))))
        return -1;
      return 23196; /* pred_indexed_uloadrvvm4x2sfrvvm8di */

    case 866:
      if (!
#line 8571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23198; /* pred_indexed_uloadrvvm2x2qirvvm2qi */

    case 867:
      if (!
#line 8571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23200; /* pred_indexed_uloadrvvm2x2qirvvm4hi */

    case 868:
      if (!
#line 8571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23202; /* pred_indexed_uloadrvvm2x2qirvvm8si */

    case 869:
      if (!
#line 8571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23204; /* pred_indexed_uloadrvvm2x3qirvvm2qi */

    case 870:
      if (!
#line 8571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23206; /* pred_indexed_uloadrvvm2x3qirvvm4hi */

    case 871:
      if (!
#line 8571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23208; /* pred_indexed_uloadrvvm2x3qirvvm8si */

    case 872:
      if (!
#line 8571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23210; /* pred_indexed_uloadrvvm2x4qirvvm2qi */

    case 873:
      if (!
#line 8571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23212; /* pred_indexed_uloadrvvm2x4qirvvm4hi */

    case 874:
      if (!
#line 8571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23214; /* pred_indexed_uloadrvvm2x4qirvvm8si */

    case 875:
      if (!
#line 8571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23216; /* pred_indexed_uloadrvvm4x2hirvvm2qi */

    case 876:
      if (!
#line 8571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23218; /* pred_indexed_uloadrvvm4x2hirvvm4hi */

    case 877:
      if (!
#line 8571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23220; /* pred_indexed_uloadrvvm4x2hirvvm8si */

    case 878:
      if (!(
#line 8571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23222; /* pred_indexed_uloadrvvm4x2bfrvvm2qi */

    case 879:
      if (!(
#line 8571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23224; /* pred_indexed_uloadrvvm4x2bfrvvm4hi */

    case 880:
      if (!(
#line 8571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1341 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 23226; /* pred_indexed_uloadrvvm4x2bfrvvm8si */

    case 881:
      if (!(
#line 8571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23228; /* pred_indexed_uloadrvvm4x2hfrvvm2qi */

    case 882:
      if (!(
#line 8571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23230; /* pred_indexed_uloadrvvm4x2hfrvvm4hi */

    case 883:
      if (!(
#line 8571 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1342 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 23232; /* pred_indexed_uloadrvvm4x2hfrvvm8si */

    case 884:
      if (!
#line 8592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23234; /* pred_indexed_uloadrvvm4x2qirvvm4qi */

    case 885:
      if (!
#line 8592 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 23236; /* pred_indexed_uloadrvvm4x2qirvvm8hi */

    default:
      return -1;
    }
}

 int
recog_898 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[8] = x7;
  x8 = XEXP (x2, 2);
  operands[2] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  switch (GET_CODE (x10))
    {
    case REG:
    case SUBREG:
      operands[3] = x10;
      switch (pattern487 (x2))
        {
        case 0:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5499; /* pred_andrvvm8qi */

        case 1:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5516; /* pred_andrvvm4qi */

        case 2:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5533; /* pred_andrvvm2qi */

        case 3:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5550; /* pred_andrvvm1qi */

        case 4:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5567; /* pred_andrvvm8hi */

        case 5:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5584; /* pred_andrvvm4hi */

        case 6:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5601; /* pred_andrvvm2hi */

        case 7:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5618; /* pred_andrvvm1hi */

        case 8:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5635; /* pred_andrvvm8si */

        case 9:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5652; /* pred_andrvvm4si */

        case 10:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5669; /* pred_andrvvm2si */

        case 11:
          if (!
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 5686; /* pred_andrvvm1si */

        case 12:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 5703; /* pred_andrvvm8di */

        case 13:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 5720; /* pred_andrvvm4di */

        case 14:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 5737; /* pred_andrvvm2di */

        case 15:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
            return -1;
          return 5754; /* pred_andrvvm1di */

        case 16:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 5771; /* pred_andrvvmf2qi */

        case 17:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 5788; /* pred_andrvvmf4qi */

        case 18:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 5805; /* pred_andrvvmf8qi */

        case 19:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
            return -1;
          return 5822; /* pred_andrvvmf2hi */

        case 20:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 5839; /* pred_andrvvmf4hi */

        case 21:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
            return -1;
          return 5856; /* pred_andrvvmf2si */

        case 22:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
            return -1;
          return 5873; /* pred_andv1qi */

        case 23:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
            return -1;
          return 5890; /* pred_andv2qi */

        case 24:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
            return -1;
          return 5907; /* pred_andv4qi */

        case 25:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
            return -1;
          return 5924; /* pred_andv8qi */

        case 26:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
            return -1;
          return 5941; /* pred_andv16qi */

        case 27:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
            return -1;
          return 5958; /* pred_andv32qi */

        case 28:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 5975; /* pred_andv64qi */

        case 29:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 5992; /* pred_andv128qi */

        case 30:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 6009; /* pred_andv256qi */

        case 31:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 6026; /* pred_andv512qi */

        case 32:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 6043; /* pred_andv1024qi */

        case 33:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 6060; /* pred_andv2048qi */

        case 34:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 6077; /* pred_andv4096qi */

        case 35:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
            return -1;
          return 6094; /* pred_andv1hi */

        case 36:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
            return -1;
          return 6111; /* pred_andv2hi */

        case 37:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
            return -1;
          return 6128; /* pred_andv4hi */

        case 38:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
            return -1;
          return 6145; /* pred_andv8hi */

        case 39:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
            return -1;
          return 6162; /* pred_andv16hi */

        case 40:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 6179; /* pred_andv32hi */

        case 41:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 6196; /* pred_andv64hi */

        case 42:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 6213; /* pred_andv128hi */

        case 43:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 6230; /* pred_andv256hi */

        case 44:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 6247; /* pred_andv512hi */

        case 45:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 6264; /* pred_andv1024hi */

        case 46:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 6281; /* pred_andv2048hi */

        case 47:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
            return -1;
          return 6298; /* pred_andv1si */

        case 48:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
            return -1;
          return 6315; /* pred_andv2si */

        case 49:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
            return -1;
          return 6332; /* pred_andv4si */

        case 50:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
            return -1;
          return 6349; /* pred_andv8si */

        case 51:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 6366; /* pred_andv16si */

        case 52:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 6383; /* pred_andv32si */

        case 53:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 6400; /* pred_andv64si */

        case 54:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 6417; /* pred_andv128si */

        case 55:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 6434; /* pred_andv256si */

        case 56:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 6451; /* pred_andv512si */

        case 57:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 6468; /* pred_andv1024si */

        case 58:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 6485; /* pred_andv1di */

        case 59:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 6502; /* pred_andv2di */

        case 60:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 6519; /* pred_andv4di */

        case 61:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
            return -1;
          return 6536; /* pred_andv8di */

        case 62:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
            return -1;
          return 6553; /* pred_andv16di */

        case 63:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
            return -1;
          return 6570; /* pred_andv32di */

        case 64:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
            return -1;
          return 6587; /* pred_andv64di */

        case 65:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
            return -1;
          return 6604; /* pred_andv128di */

        case 66:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
            return -1;
          return 6621; /* pred_andv256di */

        case 67:
          if (!(
#line 2723 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
            return -1;
          return 6638; /* pred_andv512di */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x11 = XEXP (x9, 1);
      operands[3] = x11;
      x12 = XEXP (x10, 0);
      switch (GET_CODE (x12))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          switch (pattern489 (x2))
            {
            case 0:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6858; /* pred_andrvvm8qi_scalar */

            case 1:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6867; /* pred_andrvvm4qi_scalar */

            case 2:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6876; /* pred_andrvvm2qi_scalar */

            case 3:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6885; /* pred_andrvvm1qi_scalar */

            case 4:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6894; /* pred_andrvvmf2qi_scalar */

            case 5:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6903; /* pred_andrvvmf4qi_scalar */

            case 6:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 724 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 6912; /* pred_andrvvmf8qi_scalar */

            case 7:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6921; /* pred_andrvvm8hi_scalar */

            case 8:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6930; /* pred_andrvvm4hi_scalar */

            case 9:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6939; /* pred_andrvvm2hi_scalar */

            case 10:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6948; /* pred_andrvvm1hi_scalar */

            case 11:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6957; /* pred_andrvvmf2hi_scalar */

            case 12:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 726 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 6966; /* pred_andrvvmf4hi_scalar */

            case 13:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6975; /* pred_andrvvm8si_scalar */

            case 14:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6984; /* pred_andrvvm4si_scalar */

            case 15:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 6993; /* pred_andrvvm2si_scalar */

            case 16:
              if (!
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                return -1;
              return 7002; /* pred_andrvvm1si_scalar */

            case 17:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 728 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7011; /* pred_andrvvmf2si_scalar */

            case 18:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 730 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
                return -1;
              return 7020; /* pred_andv1qi_scalar */

            case 19:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 731 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
                return -1;
              return 7029; /* pred_andv2qi_scalar */

            case 20:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
                return -1;
              return 7038; /* pred_andv4qi_scalar */

            case 21:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 733 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
                return -1;
              return 7047; /* pred_andv8qi_scalar */

            case 22:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 734 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
                return -1;
              return 7056; /* pred_andv16qi_scalar */

            case 23:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 735 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
                return -1;
              return 7065; /* pred_andv32qi_scalar */

            case 24:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 736 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7074; /* pred_andv64qi_scalar */

            case 25:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 737 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7083; /* pred_andv128qi_scalar */

            case 26:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 738 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7092; /* pred_andv256qi_scalar */

            case 27:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7101; /* pred_andv512qi_scalar */

            case 28:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 740 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7110; /* pred_andv1024qi_scalar */

            case 29:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 741 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7119; /* pred_andv2048qi_scalar */

            case 30:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 742 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7128; /* pred_andv4096qi_scalar */

            case 31:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 743 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
                return -1;
              return 7137; /* pred_andv1hi_scalar */

            case 32:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 744 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
                return -1;
              return 7146; /* pred_andv2hi_scalar */

            case 33:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
                return -1;
              return 7155; /* pred_andv4hi_scalar */

            case 34:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 746 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
                return -1;
              return 7164; /* pred_andv8hi_scalar */

            case 35:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 747 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
                return -1;
              return 7173; /* pred_andv16hi_scalar */

            case 36:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 748 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7182; /* pred_andv32hi_scalar */

            case 37:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 749 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7191; /* pred_andv64hi_scalar */

            case 38:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 750 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7200; /* pred_andv128hi_scalar */

            case 39:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 751 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7209; /* pred_andv256hi_scalar */

            case 40:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7218; /* pred_andv512hi_scalar */

            case 41:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 753 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7227; /* pred_andv1024hi_scalar */

            case 42:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 754 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7236; /* pred_andv2048hi_scalar */

            case 43:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 755 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
                return -1;
              return 7245; /* pred_andv1si_scalar */

            case 44:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 756 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
                return -1;
              return 7254; /* pred_andv2si_scalar */

            case 45:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
                return -1;
              return 7263; /* pred_andv4si_scalar */

            case 46:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 758 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
                return -1;
              return 7272; /* pred_andv8si_scalar */

            case 47:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 759 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7281; /* pred_andv16si_scalar */

            case 48:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 760 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7290; /* pred_andv32si_scalar */

            case 49:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 761 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7299; /* pred_andv64si_scalar */

            case 50:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 762 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7308; /* pred_andv128si_scalar */

            case 51:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 763 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7317; /* pred_andv256si_scalar */

            case 52:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7326; /* pred_andv512si_scalar */

            case 53:
              if (!(
#line 2781 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 765 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7335; /* pred_andv1024si_scalar */

            case 54:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7668; /* *pred_andrvvm8di_scalar */

            case 55:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7677; /* *pred_andrvvm4di_scalar */

            case 56:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7686; /* *pred_andrvvm2di_scalar */

            case 57:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7695; /* *pred_andrvvm1di_scalar */

            case 58:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7704; /* *pred_andv1di_scalar */

            case 59:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7713; /* *pred_andv2di_scalar */

            case 60:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7722; /* *pred_andv4di_scalar */

            case 61:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7731; /* *pred_andv8di_scalar */

            case 62:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7740; /* *pred_andv16di_scalar */

            case 63:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7749; /* *pred_andv32di_scalar */

            case 64:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7758; /* *pred_andv64di_scalar */

            case 65:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7767; /* *pred_andv128di_scalar */

            case 66:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7776; /* *pred_andv256di_scalar */

            case 67:
              if (!(
#line 2879 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7785; /* *pred_andv512di_scalar */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern491 (x2))
            {
            case 0:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7794; /* *pred_andrvvm8di_extended_scalar */

            case 1:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 774 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7803; /* *pred_andrvvm4di_extended_scalar */

            case 2:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7812; /* *pred_andrvvm2di_extended_scalar */

            case 3:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 775 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7821; /* *pred_andrvvm1di_extended_scalar */

            case 4:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 777 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7830; /* *pred_andv1di_extended_scalar */

            case 5:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 778 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7839; /* *pred_andv2di_extended_scalar */

            case 6:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
                return -1;
              return 7848; /* *pred_andv4di_extended_scalar */

            case 7:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
                return -1;
              return 7857; /* *pred_andv8di_extended_scalar */

            case 8:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 781 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
                return -1;
              return 7866; /* *pred_andv16di_extended_scalar */

            case 9:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 782 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
                return -1;
              return 7875; /* *pred_andv32di_extended_scalar */

            case 10:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 783 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
                return -1;
              return 7884; /* *pred_andv64di_extended_scalar */

            case 11:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 784 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
                return -1;
              return 7893; /* *pred_andv128di_extended_scalar */

            case 12:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 785 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
                return -1;
              return 7902; /* *pred_andv256di_extended_scalar */

            case 13:
              if (!(
#line 2901 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
                return -1;
              return 7911; /* *pred_andv512di_extended_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      return recog_841 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_910 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern506 (x2))
    {
    case 0:
      if (!
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10887; /* pred_usaddrvvm8qi */

    case 1:
      if (!
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10891; /* pred_usaddrvvm4qi */

    case 2:
      if (!
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10895; /* pred_usaddrvvm2qi */

    case 3:
      if (!
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10899; /* pred_usaddrvvm1qi */

    case 4:
      if (!
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10903; /* pred_usaddrvvm8hi */

    case 5:
      if (!
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10907; /* pred_usaddrvvm4hi */

    case 6:
      if (!
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10911; /* pred_usaddrvvm2hi */

    case 7:
      if (!
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10915; /* pred_usaddrvvm1hi */

    case 8:
      if (!
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10919; /* pred_usaddrvvm8si */

    case 9:
      if (!
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10923; /* pred_usaddrvvm4si */

    case 10:
      if (!
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10927; /* pred_usaddrvvm2si */

    case 11:
      if (!
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 10931; /* pred_usaddrvvm1si */

    case 12:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10935; /* pred_usaddrvvm8di */

    case 13:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10939; /* pred_usaddrvvm4di */

    case 14:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10943; /* pred_usaddrvvm2di */

    case 15:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 10947; /* pred_usaddrvvm1di */

    case 16:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 10951; /* pred_usaddrvvmf2qi */

    case 17:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 10955; /* pred_usaddrvvmf4qi */

    case 18:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 10959; /* pred_usaddrvvmf8qi */

    case 19:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 10963; /* pred_usaddrvvmf2hi */

    case 20:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 10967; /* pred_usaddrvvmf4hi */

    case 21:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 10971; /* pred_usaddrvvmf2si */

    case 22:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 10975; /* pred_usaddv1qi */

    case 23:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 10979; /* pred_usaddv2qi */

    case 24:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 10983; /* pred_usaddv4qi */

    case 25:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 10987; /* pred_usaddv8qi */

    case 26:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 10991; /* pred_usaddv16qi */

    case 27:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 10995; /* pred_usaddv32qi */

    case 28:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 10999; /* pred_usaddv64qi */

    case 29:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11003; /* pred_usaddv128qi */

    case 30:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11007; /* pred_usaddv256qi */

    case 31:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11011; /* pred_usaddv512qi */

    case 32:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11015; /* pred_usaddv1024qi */

    case 33:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11019; /* pred_usaddv2048qi */

    case 34:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11023; /* pred_usaddv4096qi */

    case 35:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 11027; /* pred_usaddv1hi */

    case 36:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 11031; /* pred_usaddv2hi */

    case 37:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 11035; /* pred_usaddv4hi */

    case 38:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 11039; /* pred_usaddv8hi */

    case 39:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 11043; /* pred_usaddv16hi */

    case 40:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11047; /* pred_usaddv32hi */

    case 41:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11051; /* pred_usaddv64hi */

    case 42:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11055; /* pred_usaddv128hi */

    case 43:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11059; /* pred_usaddv256hi */

    case 44:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11063; /* pred_usaddv512hi */

    case 45:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11067; /* pred_usaddv1024hi */

    case 46:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11071; /* pred_usaddv2048hi */

    case 47:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 11075; /* pred_usaddv1si */

    case 48:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 11079; /* pred_usaddv2si */

    case 49:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 11083; /* pred_usaddv4si */

    case 50:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 11087; /* pred_usaddv8si */

    case 51:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11091; /* pred_usaddv16si */

    case 52:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11095; /* pred_usaddv32si */

    case 53:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11099; /* pred_usaddv64si */

    case 54:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11103; /* pred_usaddv128si */

    case 55:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11107; /* pred_usaddv256si */

    case 56:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11111; /* pred_usaddv512si */

    case 57:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11115; /* pred_usaddv1024si */

    case 58:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11119; /* pred_usaddv1di */

    case 59:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11123; /* pred_usaddv2di */

    case 60:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11127; /* pred_usaddv4di */

    case 61:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11131; /* pred_usaddv8di */

    case 62:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11135; /* pred_usaddv16di */

    case 63:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11139; /* pred_usaddv32di */

    case 64:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11143; /* pred_usaddv64di */

    case 65:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11147; /* pred_usaddv128di */

    case 66:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11151; /* pred_usaddv256di */

    case 67:
      if (!(
#line 4328 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11155; /* pred_usaddv512di */

    case 68:
      if (!
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11158; /* pred_usaddrvvm8qi_scalar */

    case 69:
      if (!
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11160; /* pred_usaddrvvm4qi_scalar */

    case 70:
      if (!
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11162; /* pred_usaddrvvm2qi_scalar */

    case 71:
      if (!
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11164; /* pred_usaddrvvm1qi_scalar */

    case 72:
      if (!
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11166; /* pred_usaddrvvmf2qi_scalar */

    case 73:
      if (!
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11168; /* pred_usaddrvvmf4qi_scalar */

    case 74:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 565 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11170; /* pred_usaddrvvmf8qi_scalar */

    case 75:
      if (!
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11172; /* pred_usaddrvvm8hi_scalar */

    case 76:
      if (!
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11174; /* pred_usaddrvvm4hi_scalar */

    case 77:
      if (!
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11176; /* pred_usaddrvvm2hi_scalar */

    case 78:
      if (!
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11178; /* pred_usaddrvvm1hi_scalar */

    case 79:
      if (!
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11180; /* pred_usaddrvvmf2hi_scalar */

    case 80:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 567 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11182; /* pred_usaddrvvmf4hi_scalar */

    case 81:
      if (!
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11184; /* pred_usaddrvvm8si_scalar */

    case 82:
      if (!
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11186; /* pred_usaddrvvm4si_scalar */

    case 83:
      if (!
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11188; /* pred_usaddrvvm2si_scalar */

    case 84:
      if (!
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
        return -1;
      return 11190; /* pred_usaddrvvm1si_scalar */

    case 85:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 569 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11192; /* pred_usaddrvvmf2si_scalar */

    case 86:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 571 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 11194; /* pred_usaddv1qi_scalar */

    case 87:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 572 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 11196; /* pred_usaddv2qi_scalar */

    case 88:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 573 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 11198; /* pred_usaddv4qi_scalar */

    case 89:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 574 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 11200; /* pred_usaddv8qi_scalar */

    case 90:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 575 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 11202; /* pred_usaddv16qi_scalar */

    case 91:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 576 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 11204; /* pred_usaddv32qi_scalar */

    case 92:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 577 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11206; /* pred_usaddv64qi_scalar */

    case 93:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 578 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11208; /* pred_usaddv128qi_scalar */

    case 94:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 579 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11210; /* pred_usaddv256qi_scalar */

    case 95:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 580 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11212; /* pred_usaddv512qi_scalar */

    case 96:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 581 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11214; /* pred_usaddv1024qi_scalar */

    case 97:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 582 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11216; /* pred_usaddv2048qi_scalar */

    case 98:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 583 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11218; /* pred_usaddv4096qi_scalar */

    case 99:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 584 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 11220; /* pred_usaddv1hi_scalar */

    case 100:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 585 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 11222; /* pred_usaddv2hi_scalar */

    case 101:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 586 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 11224; /* pred_usaddv4hi_scalar */

    case 102:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 587 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 11226; /* pred_usaddv8hi_scalar */

    case 103:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 588 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 11228; /* pred_usaddv16hi_scalar */

    case 104:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 589 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11230; /* pred_usaddv32hi_scalar */

    case 105:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 590 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11232; /* pred_usaddv64hi_scalar */

    case 106:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 591 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11234; /* pred_usaddv128hi_scalar */

    case 107:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 592 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11236; /* pred_usaddv256hi_scalar */

    case 108:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 593 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11238; /* pred_usaddv512hi_scalar */

    case 109:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 594 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11240; /* pred_usaddv1024hi_scalar */

    case 110:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 595 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11242; /* pred_usaddv2048hi_scalar */

    case 111:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 596 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 11244; /* pred_usaddv1si_scalar */

    case 112:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 597 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 11246; /* pred_usaddv2si_scalar */

    case 113:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 598 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 11248; /* pred_usaddv4si_scalar */

    case 114:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 599 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 11250; /* pred_usaddv8si_scalar */

    case 115:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 600 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 11252; /* pred_usaddv16si_scalar */

    case 116:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 601 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 11254; /* pred_usaddv32si_scalar */

    case 117:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 602 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 11256; /* pred_usaddv64si_scalar */

    case 118:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 603 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 11258; /* pred_usaddv128si_scalar */

    case 119:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 604 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 11260; /* pred_usaddv256si_scalar */

    case 120:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 605 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 11262; /* pred_usaddv512si_scalar */

    case 121:
      if (!(
#line 4358 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 606 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 11264; /* pred_usaddv1024si_scalar */

    case 122:
      if (!(
#line 4433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11374; /* *pred_usaddrvvm8di_scalar */

    case 123:
      if (!(
#line 4433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11376; /* *pred_usaddrvvm4di_scalar */

    case 124:
      if (!(
#line 4433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11378; /* *pred_usaddrvvm2di_scalar */

    case 125:
      if (!(
#line 4433 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11380; /* *pred_usaddrvvm1di_scalar */

    case 126:
      if (!(
#line 4455 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11382; /* *pred_usaddrvvm8di_extended_scalar */

    case 127:
      if (!(
#line 4455 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 769 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11384; /* *pred_usaddrvvm4di_extended_scalar */

    case 128:
      if (!(
#line 4455 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11386; /* *pred_usaddrvvm2di_extended_scalar */

    case 129:
      if (!(
#line 4455 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_64BIT) && 
#line 770 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 11388; /* *pred_usaddrvvm1di_extended_scalar */

    default:
      return -1;
    }
}

 int
recog_918 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[6] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[7] = x7;
  x8 = XEXP (x2, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8SFmode:
      if (pattern606 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM4HFmode:
          if (!register_operand (operands[3], E_RVVM4HFmode)
              || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 990 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17783; /* pred_extendrvvm8sf */

        case E_RVVM4BFmode:
          if (!register_operand (operands[3], E_RVVM4BFmode)
              || !(
#line 74 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 21 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 33767; /* pred_extend_bf16_to_rvvm8sf */

        default:
          return -1;
        }

    case E_RVVM4SFmode:
      if (pattern606 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM2HFmode:
          if (!register_operand (operands[3], E_RVVM2HFmode)
              || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 991 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17784; /* pred_extendrvvm4sf */

        case E_RVVM2BFmode:
          if (!register_operand (operands[3], E_RVVM2BFmode)
              || !(
#line 74 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 22 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 33768; /* pred_extend_bf16_to_rvvm4sf */

        default:
          return -1;
        }

    case E_RVVM2SFmode:
      if (pattern606 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVM1HFmode:
          if (!register_operand (operands[3], E_RVVM1HFmode)
              || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 992 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17785; /* pred_extendrvvm2sf */

        case E_RVVM1BFmode:
          if (!register_operand (operands[3], E_RVVM1BFmode)
              || !(
#line 74 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 23 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 33769; /* pred_extend_bf16_to_rvvm2sf */

        default:
          return -1;
        }

    case E_RVVM1SFmode:
      if (pattern606 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF2HFmode:
          if (!register_operand (operands[3], E_RVVMF2HFmode)
              || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 993 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 17786; /* pred_extendrvvm1sf */

        case E_RVVMF2BFmode:
          if (!register_operand (operands[3], E_RVVMF2BFmode)
              || !(
#line 74 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 24 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
            return -1;
          return 33770; /* pred_extend_bf16_to_rvvm1sf */

        default:
          return -1;
        }

    case E_RVVMF2SFmode:
      if (pattern606 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_RVVMF4HFmode:
          if (!register_operand (operands[3], E_RVVMF4HFmode)
              || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 994 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
            return -1;
          return 17787; /* pred_extendrvvmf2sf */

        case E_RVVMF4BFmode:
          if (!register_operand (operands[3], E_RVVMF4BFmode)
              || !(
#line 74 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFMIN) && 
#line 25 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN > 32)))
            return -1;
          return 33771; /* pred_extend_bf16_to_rvvmf2sf */

        default:
          return -1;
        }

    case E_RVVM8DFmode:
      if (pattern504 (x2, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17788; /* pred_extendrvvm8df */

    case E_RVVM4DFmode:
      if (pattern504 (x2, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 996 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17789; /* pred_extendrvvm4df */

    case E_RVVM2DFmode:
      if (pattern504 (x2, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17790; /* pred_extendrvvm2df */

    case E_RVVM1DFmode:
      if (pattern504 (x2, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 997 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17791; /* pred_extendrvvm1df */

    case E_V1SFmode:
      if (pattern504 (x2, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 999 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17792; /* pred_extendv1sf */

    case E_V2SFmode:
      if (pattern504 (x2, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1000 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17793; /* pred_extendv2sf */

    case E_V4SFmode:
      if (pattern504 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1001 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17794; /* pred_extendv4sf */

    case E_V8SFmode:
      if (pattern504 (x2, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1002 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17795; /* pred_extendv8sf */

    case E_V16SFmode:
      if (pattern504 (x2, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1003 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17796; /* pred_extendv16sf */

    case E_V32SFmode:
      if (pattern504 (x2, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1004 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17797; /* pred_extendv32sf */

    case E_V64SFmode:
      if (pattern504 (x2, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1005 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17798; /* pred_extendv64sf */

    case E_V128SFmode:
      if (pattern504 (x2, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1006 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17799; /* pred_extendv128sf */

    case E_V256SFmode:
      if (pattern504 (x2, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1007 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17800; /* pred_extendv256sf */

    case E_V512SFmode:
      if (pattern504 (x2, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1008 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17801; /* pred_extendv512sf */

    case E_V1024SFmode:
      if (pattern504 (x2, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1009 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17802; /* pred_extendv1024sf */

    case E_V1DFmode:
      if (pattern504 (x2, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1010 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17803; /* pred_extendv1df */

    case E_V2DFmode:
      if (pattern504 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1011 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17804; /* pred_extendv2df */

    case E_V4DFmode:
      if (pattern504 (x2, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1012 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17805; /* pred_extendv4df */

    case E_V8DFmode:
      if (pattern504 (x2, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1013 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17806; /* pred_extendv8df */

    case E_V16DFmode:
      if (pattern504 (x2, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1014 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17807; /* pred_extendv16df */

    case E_V32DFmode:
      if (pattern504 (x2, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1015 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 17808; /* pred_extendv32df */

    case E_V64DFmode:
      if (pattern504 (x2, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1016 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17809; /* pred_extendv64df */

    case E_V128DFmode:
      if (pattern504 (x2, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1017 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17810; /* pred_extendv128df */

    case E_V256DFmode:
      if (pattern504 (x2, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1018 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17811; /* pred_extendv256df */

    case E_V512DFmode:
      if (pattern504 (x2, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0
          || !(
#line 7627 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1019 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 17812; /* pred_extendv512df */

    default:
      return -1;
    }
}

 int
recog_925 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern474 (x2))
    {
    case 0:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))))
        return -1;
      return 1253; /* *pred_mov_widthhrvvm8qi */

    case 1:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))))
        return -1;
      return 1259; /* *pred_mov_widthhrvvm4qi */

    case 2:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))))
        return -1;
      return 1265; /* *pred_mov_widthhrvvm2qi */

    case 3:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))))
        return -1;
      return 1271; /* *pred_mov_widthhrvvm1qi */

    case 4:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))))
        return -1;
      return 1277; /* *pred_mov_widthhrvvm8hi */

    case 5:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))))
        return -1;
      return 1283; /* *pred_mov_widthhrvvm4hi */

    case 6:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))))
        return -1;
      return 1289; /* *pred_mov_widthhrvvm2hi */

    case 7:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))))
        return -1;
      return 1295; /* *pred_mov_widthhrvvm1hi */

    case 8:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))))
        return -1;
      return 1301; /* *pred_mov_widthhrvvm8si */

    case 9:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))))
        return -1;
      return 1307; /* *pred_mov_widthhrvvm4si */

    case 10:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))))
        return -1;
      return 1313; /* *pred_mov_widthhrvvm2si */

    case 11:
      if (!
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))))
        return -1;
      return 1319; /* *pred_mov_widthhrvvm1si */

    case 12:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1325; /* *pred_mov_widthhrvvm8di */

    case 13:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1331; /* *pred_mov_widthhrvvm4di */

    case 14:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1337; /* *pred_mov_widthhrvvm2di */

    case 15:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1343; /* *pred_mov_widthhrvvm1di */

    case 16:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1349; /* *pred_mov_widthhrvvmf2qi */

    case 17:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1355; /* *pred_mov_widthhrvvmf4qi */

    case 18:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1361; /* *pred_mov_widthhrvvmf8qi */

    case 19:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 1367; /* *pred_mov_widthhrvvmf2hi */

    case 20:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1373; /* *pred_mov_widthhrvvmf4hi */

    case 21:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 1379; /* *pred_mov_widthhrvvmf2si */

    case 22:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1385; /* *pred_mov_widthhrvvm8bf */

    case 23:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1391; /* *pred_mov_widthhrvvm4bf */

    case 24:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1397; /* *pred_mov_widthhrvvm2bf */

    case 25:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1403; /* *pred_mov_widthhrvvm1bf */

    case 26:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)))
        return -1;
      return 1409; /* *pred_mov_widthhrvvmf2bf */

    case 27:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1415; /* *pred_mov_widthhrvvmf4bf */

    case 28:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1421; /* *pred_mov_widthhrvvm8hf */

    case 29:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1427; /* *pred_mov_widthhrvvm4hf */

    case 30:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1433; /* *pred_mov_widthhrvvm2hf */

    case 31:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1439; /* *pred_mov_widthhrvvm1hf */

    case 32:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1445; /* *pred_mov_widthhrvvmf2hf */

    case 33:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1451; /* *pred_mov_widthhrvvmf4hf */

    case 34:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1457; /* *pred_mov_widthhrvvm8sf */

    case 35:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1463; /* *pred_mov_widthhrvvm4sf */

    case 36:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1469; /* *pred_mov_widthhrvvm2sf */

    case 37:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1475; /* *pred_mov_widthhrvvm1sf */

    case 38:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1481; /* *pred_mov_widthhrvvmf2sf */

    case 39:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1487; /* *pred_mov_widthhrvvm8df */

    case 40:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1493; /* *pred_mov_widthhrvvm4df */

    case 41:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1499; /* *pred_mov_widthhrvvm2df */

    case 42:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1505; /* *pred_mov_widthhrvvm1df */

    case 43:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 1511; /* *pred_mov_widthhv1qi */

    case 44:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 1517; /* *pred_mov_widthhv2qi */

    case 45:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 1523; /* *pred_mov_widthhv4qi */

    case 46:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 1529; /* *pred_mov_widthhv8qi */

    case 47:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 1535; /* *pred_mov_widthhv16qi */

    case 48:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 1541; /* *pred_mov_widthhv32qi */

    case 49:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1547; /* *pred_mov_widthhv64qi */

    case 50:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1553; /* *pred_mov_widthhv128qi */

    case 51:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1559; /* *pred_mov_widthhv256qi */

    case 52:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1565; /* *pred_mov_widthhv512qi */

    case 53:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1571; /* *pred_mov_widthhv1024qi */

    case 54:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1577; /* *pred_mov_widthhv2048qi */

    case 55:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1583; /* *pred_mov_widthhv4096qi */

    case 56:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 1589; /* *pred_mov_widthhv1hi */

    case 57:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 1595; /* *pred_mov_widthhv2hi */

    case 58:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 1601; /* *pred_mov_widthhv4hi */

    case 59:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 1607; /* *pred_mov_widthhv8hi */

    case 60:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 1613; /* *pred_mov_widthhv16hi */

    case 61:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1619; /* *pred_mov_widthhv32hi */

    case 62:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1625; /* *pred_mov_widthhv64hi */

    case 63:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1631; /* *pred_mov_widthhv128hi */

    case 64:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1637; /* *pred_mov_widthhv256hi */

    case 65:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1643; /* *pred_mov_widthhv512hi */

    case 66:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1649; /* *pred_mov_widthhv1024hi */

    case 67:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1655; /* *pred_mov_widthhv2048hi */

    case 68:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 1661; /* *pred_mov_widthhv1si */

    case 69:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 1667; /* *pred_mov_widthhv2si */

    case 70:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 1673; /* *pred_mov_widthhv4si */

    case 71:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 1679; /* *pred_mov_widthhv8si */

    case 72:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1685; /* *pred_mov_widthhv16si */

    case 73:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1691; /* *pred_mov_widthhv32si */

    case 74:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1697; /* *pred_mov_widthhv64si */

    case 75:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1703; /* *pred_mov_widthhv128si */

    case 76:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1709; /* *pred_mov_widthhv256si */

    case 77:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1715; /* *pred_mov_widthhv512si */

    case 78:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1721; /* *pred_mov_widthhv1024si */

    case 79:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1727; /* *pred_mov_widthhv1di */

    case 80:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1733; /* *pred_mov_widthhv2di */

    case 81:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 1739; /* *pred_mov_widthhv4di */

    case 82:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1745; /* *pred_mov_widthhv8di */

    case 83:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1751; /* *pred_mov_widthhv16di */

    case 84:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1757; /* *pred_mov_widthhv32di */

    case 85:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1763; /* *pred_mov_widthhv64di */

    case 86:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1769; /* *pred_mov_widthhv128di */

    case 87:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1775; /* *pred_mov_widthhv256di */

    case 88:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1781; /* *pred_mov_widthhv512di */

    case 89:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1787; /* *pred_mov_widthhv1hf */

    case 90:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1793; /* *pred_mov_widthhv2hf */

    case 91:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1799; /* *pred_mov_widthhv4hf */

    case 92:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1805; /* *pred_mov_widthhv8hf */

    case 93:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return -1;
      return 1811; /* *pred_mov_widthhv16hf */

    case 94:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1817; /* *pred_mov_widthhv32hf */

    case 95:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1823; /* *pred_mov_widthhv64hf */

    case 96:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1829; /* *pred_mov_widthhv128hf */

    case 97:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1835; /* *pred_mov_widthhv256hf */

    case 98:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1841; /* *pred_mov_widthhv512hf */

    case 99:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1847; /* *pred_mov_widthhv1024hf */

    case 100:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1853; /* *pred_mov_widthhv2048hf */

    case 101:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1859; /* *pred_mov_widthhv1sf */

    case 102:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1865; /* *pred_mov_widthhv2sf */

    case 103:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1871; /* *pred_mov_widthhv4sf */

    case 104:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 1877; /* *pred_mov_widthhv8sf */

    case 105:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1883; /* *pred_mov_widthhv16sf */

    case 106:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1889; /* *pred_mov_widthhv32sf */

    case 107:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1895; /* *pred_mov_widthhv64sf */

    case 108:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1901; /* *pred_mov_widthhv128sf */

    case 109:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1907; /* *pred_mov_widthhv256sf */

    case 110:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1913; /* *pred_mov_widthhv512sf */

    case 111:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1919; /* *pred_mov_widthhv1024sf */

    case 112:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1925; /* *pred_mov_widthhv1df */

    case 113:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1931; /* *pred_mov_widthhv2df */

    case 114:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 1937; /* *pred_mov_widthhv4df */

    case 115:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 1943; /* *pred_mov_widthhv8df */

    case 116:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 1949; /* *pred_mov_widthhv16df */

    case 117:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 1955; /* *pred_mov_widthhv32df */

    case 118:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 1961; /* *pred_mov_widthhv64df */

    case 119:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 1967; /* *pred_mov_widthhv128df */

    case 120:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 1973; /* *pred_mov_widthhv256df */

    case 121:
      if (!(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 1979; /* *pred_mov_widthhv512df */

    default:
      return -1;
    }
}

 int
recog_940 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM4HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM4HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM4HFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15256; /* *pred_mul_addrvvm4hf_undef */
}

 int
recog_943 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVMF2HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVMF2HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVMF2HFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15262; /* *pred_mul_addrvvmf2hf_undef */
}

 int
recog_946 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM4SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM4SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM4SFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15268; /* *pred_mul_addrvvm4sf_undef */
}

 int
recog_951 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM4DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM4DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM4DFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15278; /* *pred_mul_addrvvm4df_undef */
}

 int
recog_956 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V4HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V4HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V4HFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
    return -1;
  return 15288; /* *pred_mul_addv4hf_undef */
}

 int
recog_961 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V128HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V128HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V128HFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15298; /* *pred_mul_addv128hf_undef */
}

 int
recog_966 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V1SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V1SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V1SFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15308; /* *pred_mul_addv1sf_undef */
}

 int
recog_971 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V32SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V32SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V32SFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15318; /* *pred_mul_addv32sf_undef */
}

 int
recog_976 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V1024SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V1024SFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15328; /* *pred_mul_addv1024sf_undef */
}

 int
recog_981 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V16DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V16DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V16DFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15338; /* *pred_mul_addv16df_undef */
}

 int
recog_986 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V512DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V512DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V512DFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15348; /* *pred_mul_addv512df_undef */
}

 int
recog_991 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern731 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_RVVM4HFmode:
      if (!register_operand (operands[3], E_HFmode)
          || !register_operand (operands[4], E_RVVM4HFmode)
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16763; /* pred_widen_mul_addrvvm8sf_scalar */

    case E_RVVM4BFmode:
      if (!register_operand (operands[3], E_BFmode)
          || !register_operand (operands[4], E_RVVM4BFmode)
          || !(
#line 130 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFWMA) && 
#line 21 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 33777; /* pred_widen_bf16_mul_rvvm8sf_scalar */

    default:
      return -1;
    }
}

 int
recog_996 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern731 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM4HFmode:
      if (!register_operand (operands[3], E_RVVM4HFmode)
          || !register_operand (operands[4], E_RVVM4HFmode)
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16703; /* pred_widen_mul_addrvvm8sf */

    case E_RVVM4BFmode:
      if (!register_operand (operands[3], E_RVVM4BFmode)
          || !register_operand (operands[4], E_RVVM4BFmode)
          || !(
#line 101 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_ZVFBFWMA) && 
#line 21 "../../gcc/config/riscv/vector-bfloat16.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 33772; /* pred_widen_bf16_mul_rvvm8sf */

    default:
      return -1;
    }
}

 int
recog_1001 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_982 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V32DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V32DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return 15436; /* *pred_maddv32df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15532; /* *pred_maccv32df */
}

 int
recog_1006 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_977 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V1DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15426; /* *pred_maddv1df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15522; /* *pred_maccv1df */
}

 int
recog_1011 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_972 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V64SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V64SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return 15416; /* *pred_maddv64sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
    return -1;
  return 15512; /* *pred_maccv64sf */
}

 int
recog_1016 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_967 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15406; /* *pred_maddv2sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15502; /* *pred_maccv2sf */
}

 int
recog_1021 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_962 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return 15396; /* *pred_maddv256hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15492; /* *pred_maccv256hf */
}

 int
recog_1026 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_957 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return 15386; /* *pred_maddv8hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return -1;
  return 15482; /* *pred_maccv8hf */
}

 int
recog_1032 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_951 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM4DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM4DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15374; /* *pred_maddrvvm4df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15470; /* *pred_maccrvvm4df */
}

 int
recog_1038 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_945 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM8SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15362; /* *pred_maddrvvm8sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15458; /* *pred_maccrvvm8sf */
}

 int
recog_1044 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_939 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM8HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15350; /* *pred_maddrvvm8hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15446; /* *pred_maccrvvm8hf */
}

 int
recog_1054 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM1SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM1SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM1SFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15752; /* *pred_mul_neg_addrvvm1sf_undef */
}

 int
recog_1064 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V16HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V16HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V16HFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
    return -1;
  return 15772; /* *pred_mul_neg_addv16hf_undef */
}

 int
recog_1074 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V4SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V4SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V4SFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15792; /* *pred_mul_neg_addv4sf_undef */
}

 int
recog_1084 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V2DFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15812; /* *pred_mul_neg_addv2df_undef */
}

 int
recog_1094 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1091 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V256DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V256DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return 15922; /* *pred_nmsubv256df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 16018; /* *pred_nmsacv256df */
}

 int
recog_1104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1081 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V512SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V512SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return 15902; /* *pred_nmsubv512sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15998; /* *pred_nmsacv512sf */
}

 int
recog_1114 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1071 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V2048HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V2048HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return 15882; /* *pred_nmsubv2048hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15978; /* *pred_nmsacv2048hf */
}

 int
recog_1124 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1061 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V2HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return 15862; /* *pred_nmsubv2hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15958; /* *pred_nmsacv2hf */
}

 int
recog_1134 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1051 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM8SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM8SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15842; /* *pred_nmsubrvvm8sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15938; /* *pred_nmsacrvvm8sf */
}

 int
recog_1144 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM8HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM8HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM8HFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15255; /* *pred_mul_subrvvm8hf_undef */
}

 int
recog_1151 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM4SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM4SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM4SFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15269; /* *pred_mul_subrvvm4sf_undef */
}

 int
recog_1158 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_RVVM1DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_RVVM1DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_RVVM1DFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15283; /* *pred_mul_subrvvm1df_undef */
}

 int
recog_1165 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V64HFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V64HFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V64HFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15297; /* *pred_mul_subv64hf_undef */
}

 int
recog_1172 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V2SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V2SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V2SFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15311; /* *pred_mul_subv2sf_undef */
}

 int
recog_1179 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V256SFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V256SFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V256SFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
    return -1;
  return 15325; /* *pred_mul_subv256sf_undef */
}

 int
recog_1186 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  operands[4] = x11;
  if (!register_operand (operands[4], E_V16DFmode))
    return -1;
  x12 = XEXP (x9, 1);
  operands[5] = x12;
  if (!register_operand (operands[5], E_V16DFmode))
    return -1;
  x13 = XEXP (x2, 2);
  operands[2] = x13;
  if (!vector_undef_operand (operands[2], E_V16DFmode)
      || !(
#line 6502 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15339; /* *pred_mul_subv16df_undef */
}

 int
recog_1193 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1190 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V256DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V256DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return 15443; /* *pred_msubv256df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15539; /* *pred_msacv256df */
}

 int
recog_1200 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1183 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V2DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V2DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return 15429; /* *pred_msubv2df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15525; /* *pred_msacv2df */
}

 int
recog_1207 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1176 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V32SFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V32SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return 15415; /* *pred_msubv32sf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
    return -1;
  return 15511; /* *pred_msacv32sf */
}

 int
recog_1214 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1169 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V1024HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V1024HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
    return 15401; /* *pred_msubv1024hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
    return -1;
  return 15497; /* *pred_msacv1024hf */
}

 int
recog_1221 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1162 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_V8HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_V8HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return 15387; /* *pred_msubv8hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
    return -1;
  return 15483; /* *pred_msacv8hf */
}

 int
recog_1228 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1155 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVM8DFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVM8DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return 15373; /* *pred_msubrvvm8df */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
    return -1;
  return 15469; /* *pred_msacrvvm8df */
}

 int
recog_1235 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  res = recog_1148 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  x7 = XVECEXP (x6, 0, 1);
  operands[5] = x7;
  x8 = XVECEXP (x6, 0, 2);
  operands[6] = x8;
  x9 = XVECEXP (x6, 0, 3);
  operands[7] = x9;
  x10 = XVECEXP (x6, 0, 4);
  operands[8] = x10;
  x11 = XVECEXP (x6, 0, 5);
  operands[9] = x11;
  x12 = XEXP (x4, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_RVVMF2HFmode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[4] = x13;
  if (!register_operand (operands[4], E_RVVMF2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  if (rtx_equal_p (x14, operands[2])
      && (
#line 6532 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return 15359; /* *pred_msubrvvmf2hf */
  if (!rtx_equal_p (x14, operands[4])
      || !(
#line 6565 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15455; /* *pred_msacrvvmf2hf */
}

 int
recog_1242 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM2HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM2HFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
    return -1;
  return 15739; /* *pred_mul_neg_subrvvm2hf_undef */
}

 int
recog_1249 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_RVVM1SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_RVVM1SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_RVVM1SFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15753; /* *pred_mul_neg_subrvvm1sf_undef */
}

 int
recog_1256 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V2HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V2HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V2HFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
    return -1;
  return 15767; /* *pred_mul_neg_subv2hf_undef */
}

 int
recog_1263 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V256HFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V256HFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15781; /* *pred_mul_neg_subv256hf_undef */
}

 int
recog_1270 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V8SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V8SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V8SFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15795; /* *pred_mul_neg_subv8sf_undef */
}

 int
recog_1277 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V1024SFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V1024SFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 15809; /* *pred_mul_neg_subv1024sf_undef */
}

 int
recog_1284 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[6] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[7] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[8] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[9] = x7;
  x8 = XVECEXP (x3, 0, 5);
  operands[10] = x8;
  x9 = XEXP (x2, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 1);
  operands[4] = x12;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x13 = XEXP (x9, 1);
  operands[5] = x13;
  if (!register_operand (operands[5], E_V64DFmode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[2] = x14;
  if (!vector_undef_operand (operands[2], E_V64DFmode)
      || !(
#line 6715 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15823; /* *pred_mul_neg_subv64df_undef */
}

 int
recog_1291 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1284 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V64DFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V64DFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return 15919; /* *pred_nmaddv64df */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 16015; /* *pred_nmaccv64df */
}

 int
recog_1298 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1277 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1024SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1024SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return 15905; /* *pred_nmaddv1024sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return -1;
  return 16001; /* *pred_nmaccv1024sf */
}

 int
recog_1305 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1270 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V8SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V8SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return 15891; /* *pred_nmaddv8sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15987; /* *pred_nmaccv8sf */
}

 int
recog_1312 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1263 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V256HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V256HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return 15877; /* *pred_nmaddv256hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
    return -1;
  return 15973; /* *pred_nmaccv256hf */
}

 int
recog_1320 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1255 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_V1HFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_V1HFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return 15861; /* *pred_nmaddv1hf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
    return -1;
  return 15957; /* *pred_nmaccv1hf */
}

 int
recog_1328 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  res = recog_1247 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 1);
  operands[5] = x8;
  x9 = XVECEXP (x7, 0, 2);
  operands[6] = x9;
  x10 = XVECEXP (x7, 0, 3);
  operands[7] = x10;
  x11 = XVECEXP (x7, 0, 4);
  operands[8] = x11;
  x12 = XVECEXP (x7, 0, 5);
  operands[9] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!register_operand (operands[3], E_RVVM4SFmode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  if (!register_operand (operands[4], E_RVVM4SFmode))
    return -1;
  x15 = XEXP (x2, 2);
  if (rtx_equal_p (x15, operands[2])
      && (
#line 6746 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return 15845; /* *pred_nmaddrvvm4sf */
  if (!rtx_equal_p (x15, operands[4])
      || !(
#line 6780 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
    return -1;
  return 15941; /* *pred_nmaccrvvm4sf */
}

 int
recog_1336 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern583 (x2))
    {
    case 0:
      return recog_1239 (x1, insn, pnum_clobbers);

    case 1:
      return recog_1238 (x1, insn, pnum_clobbers);

    case 2:
      return recog_1237 (x1, insn, pnum_clobbers);

    case 3:
      return recog_1236 (x1, insn, pnum_clobbers);

    case 4:
      return recog_1235 (x1, insn, pnum_clobbers);

    case 5:
      return recog_1234 (x1, insn, pnum_clobbers);

    case 6:
      return recog_1233 (x1, insn, pnum_clobbers);

    case 7:
      return recog_1232 (x1, insn, pnum_clobbers);

    case 8:
      return recog_1231 (x1, insn, pnum_clobbers);

    case 9:
      return recog_1230 (x1, insn, pnum_clobbers);

    case 10:
      return recog_1229 (x1, insn, pnum_clobbers);

    case 11:
      return recog_1228 (x1, insn, pnum_clobbers);

    case 12:
      return recog_1227 (x1, insn, pnum_clobbers);

    case 13:
      return recog_1226 (x1, insn, pnum_clobbers);

    case 14:
      return recog_1225 (x1, insn, pnum_clobbers);

    case 15:
      return recog_1224 (x1, insn, pnum_clobbers);

    case 16:
      return recog_1223 (x1, insn, pnum_clobbers);

    case 17:
      return recog_1222 (x1, insn, pnum_clobbers);

    case 18:
      return recog_1221 (x1, insn, pnum_clobbers);

    case 19:
      return recog_1220 (x1, insn, pnum_clobbers);

    case 20:
      return recog_1219 (x1, insn, pnum_clobbers);

    case 21:
      return recog_1218 (x1, insn, pnum_clobbers);

    case 22:
      return recog_1217 (x1, insn, pnum_clobbers);

    case 23:
      return recog_1216 (x1, insn, pnum_clobbers);

    case 24:
      return recog_1215 (x1, insn, pnum_clobbers);

    case 25:
      return recog_1214 (x1, insn, pnum_clobbers);

    case 26:
      return recog_1213 (x1, insn, pnum_clobbers);

    case 27:
      return recog_1212 (x1, insn, pnum_clobbers);

    case 28:
      return recog_1211 (x1, insn, pnum_clobbers);

    case 29:
      return recog_1210 (x1, insn, pnum_clobbers);

    case 30:
      return recog_1209 (x1, insn, pnum_clobbers);

    case 31:
      return recog_1208 (x1, insn, pnum_clobbers);

    case 32:
      return recog_1207 (x1, insn, pnum_clobbers);

    case 33:
      return recog_1206 (x1, insn, pnum_clobbers);

    case 34:
      return recog_1205 (x1, insn, pnum_clobbers);

    case 35:
      return recog_1204 (x1, insn, pnum_clobbers);

    case 36:
      return recog_1203 (x1, insn, pnum_clobbers);

    case 37:
      return recog_1202 (x1, insn, pnum_clobbers);

    case 38:
      return recog_1201 (x1, insn, pnum_clobbers);

    case 39:
      return recog_1200 (x1, insn, pnum_clobbers);

    case 40:
      return recog_1199 (x1, insn, pnum_clobbers);

    case 41:
      return recog_1198 (x1, insn, pnum_clobbers);

    case 42:
      return recog_1197 (x1, insn, pnum_clobbers);

    case 43:
      return recog_1196 (x1, insn, pnum_clobbers);

    case 44:
      return recog_1195 (x1, insn, pnum_clobbers);

    case 45:
      return recog_1194 (x1, insn, pnum_clobbers);

    case 46:
      return recog_1193 (x1, insn, pnum_clobbers);

    case 47:
      return recog_1192 (x1, insn, pnum_clobbers);

    case 48:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15543; /* *pred_msubrvvm8hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15639; /* *pred_msacrvvm8hf_scalar */

    case 49:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15545; /* *pred_msubrvvm4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15641; /* *pred_msacrvvm4hf_scalar */

    case 50:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15547; /* *pred_msubrvvm2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15643; /* *pred_msacrvvm2hf_scalar */

    case 51:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15549; /* *pred_msubrvvm1hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15645; /* *pred_msacrvvm1hf_scalar */

    case 52:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return 15551; /* *pred_msubrvvmf2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 15647; /* *pred_msacrvvmf2hf_scalar */

    case 53:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return 15553; /* *pred_msubrvvmf4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 15649; /* *pred_msacrvvmf4hf_scalar */

    case 54:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 15555; /* *pred_msubrvvm8sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15651; /* *pred_msacrvvm8sf_scalar */

    case 55:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 15557; /* *pred_msubrvvm4sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15653; /* *pred_msacrvvm4sf_scalar */

    case 56:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 15559; /* *pred_msubrvvm2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15655; /* *pred_msacrvvm2sf_scalar */

    case 57:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return 15561; /* *pred_msubrvvm1sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15657; /* *pred_msacrvvm1sf_scalar */

    case 58:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return 15563; /* *pred_msubrvvmf2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 15659; /* *pred_msacrvvmf2sf_scalar */

    case 59:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 15565; /* *pred_msubrvvm8df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15661; /* *pred_msacrvvm8df_scalar */

    case 60:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 15567; /* *pred_msubrvvm4df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15663; /* *pred_msacrvvm4df_scalar */

    case 61:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 15569; /* *pred_msubrvvm2df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15665; /* *pred_msacrvvm2df_scalar */

    case 62:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return 15571; /* *pred_msubrvvm1df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15667; /* *pred_msacrvvm1df_scalar */

    case 63:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return 15573; /* *pred_msubv1hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 15669; /* *pred_msacv1hf_scalar */

    case 64:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return 15575; /* *pred_msubv2hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 15671; /* *pred_msacv2hf_scalar */

    case 65:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return 15577; /* *pred_msubv4hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 15673; /* *pred_msacv4hf_scalar */

    case 66:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return 15579; /* *pred_msubv8hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 15675; /* *pred_msacv8hf_scalar */

    case 67:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return 15581; /* *pred_msubv16hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 15677; /* *pred_msacv16hf_scalar */

    case 68:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return 15583; /* *pred_msubv32hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15679; /* *pred_msacv32hf_scalar */

    case 69:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return 15585; /* *pred_msubv64hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15681; /* *pred_msacv64hf_scalar */

    case 70:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return 15587; /* *pred_msubv128hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15683; /* *pred_msacv128hf_scalar */

    case 71:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return 15589; /* *pred_msubv256hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15685; /* *pred_msacv256hf_scalar */

    case 72:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return 15591; /* *pred_msubv512hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15687; /* *pred_msacv512hf_scalar */

    case 73:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return 15593; /* *pred_msubv1024hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15689; /* *pred_msacv1024hf_scalar */

    case 74:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return 15595; /* *pred_msubv2048hf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15691; /* *pred_msacv2048hf_scalar */

    case 75:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 15597; /* *pred_msubv1sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15693; /* *pred_msacv1sf_scalar */

    case 76:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 15599; /* *pred_msubv2sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15695; /* *pred_msacv2sf_scalar */

    case 77:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 15601; /* *pred_msubv4sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15697; /* *pred_msacv4sf_scalar */

    case 78:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return 15603; /* *pred_msubv8sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 15699; /* *pred_msacv8sf_scalar */

    case 79:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return 15605; /* *pred_msubv16sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15701; /* *pred_msacv16sf_scalar */

    case 80:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return 15607; /* *pred_msubv32sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15703; /* *pred_msacv32sf_scalar */

    case 81:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return 15609; /* *pred_msubv64sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15705; /* *pred_msacv64sf_scalar */

    case 82:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return 15611; /* *pred_msubv128sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15707; /* *pred_msacv128sf_scalar */

    case 83:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return 15613; /* *pred_msubv256sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15709; /* *pred_msacv256sf_scalar */

    case 84:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return 15615; /* *pred_msubv512sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15711; /* *pred_msacv512sf_scalar */

    case 85:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return 15617; /* *pred_msubv1024sf_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15713; /* *pred_msacv1024sf_scalar */

    case 86:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 15619; /* *pred_msubv1df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15715; /* *pred_msacv1df_scalar */

    case 87:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 15621; /* *pred_msubv2df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15717; /* *pred_msacv2df_scalar */

    case 88:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return 15623; /* *pred_msubv4df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 15719; /* *pred_msacv4df_scalar */

    case 89:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return 15625; /* *pred_msubv8df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 15721; /* *pred_msacv8df_scalar */

    case 90:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return 15627; /* *pred_msubv16df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 15723; /* *pred_msacv16df_scalar */

    case 91:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return 15629; /* *pred_msubv32df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 15725; /* *pred_msacv32df_scalar */

    case 92:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return 15631; /* *pred_msubv64df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 15727; /* *pred_msacv64df_scalar */

    case 93:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return 15633; /* *pred_msubv128df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 15729; /* *pred_msacv128df_scalar */

    case 94:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return 15635; /* *pred_msubv256df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 15731; /* *pred_msacv256df_scalar */

    case 95:
      x3 = XEXP (x2, 2);
      if (rtx_equal_p (x3, operands[3])
          && (
#line 6622 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return 15637; /* *pred_msubv512df_scalar */
      if (!rtx_equal_p (x3, operands[4])
          || !(
#line 6656 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 15733; /* *pred_msacv512df_scalar */

    case 96:
      if (pattern702 (x2, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16704; /* pred_widen_mul_subrvvm8sf */

    case 97:
      if (pattern702 (x2, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16706; /* pred_widen_mul_subrvvm4sf */

    case 98:
      if (pattern702 (x2, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16708; /* pred_widen_mul_subrvvm2sf */

    case 99:
      if (pattern702 (x2, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16710; /* pred_widen_mul_subrvvm1sf */

    case 100:
      if (pattern702 (x2, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 16712; /* pred_widen_mul_subrvvmf2sf */

    case 101:
      if (pattern702 (x2, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16714; /* pred_widen_mul_subrvvm8df */

    case 102:
      if (pattern702 (x2, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16716; /* pred_widen_mul_subrvvm4df */

    case 103:
      if (pattern702 (x2, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16718; /* pred_widen_mul_subrvvm2df */

    case 104:
      if (pattern702 (x2, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16720; /* pred_widen_mul_subrvvm1df */

    case 105:
      if (pattern702 (x2, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16722; /* pred_widen_mul_subv1sf */

    case 106:
      if (pattern702 (x2, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16724; /* pred_widen_mul_subv2sf */

    case 107:
      if (pattern702 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16726; /* pred_widen_mul_subv4sf */

    case 108:
      if (pattern702 (x2, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16728; /* pred_widen_mul_subv8sf */

    case 109:
      if (pattern702 (x2, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16730; /* pred_widen_mul_subv16sf */

    case 110:
      if (pattern702 (x2, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16732; /* pred_widen_mul_subv32sf */

    case 111:
      if (pattern702 (x2, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16734; /* pred_widen_mul_subv64sf */

    case 112:
      if (pattern702 (x2, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16736; /* pred_widen_mul_subv128sf */

    case 113:
      if (pattern702 (x2, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16738; /* pred_widen_mul_subv256sf */

    case 114:
      if (pattern702 (x2, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16740; /* pred_widen_mul_subv512sf */

    case 115:
      if (pattern702 (x2, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16742; /* pred_widen_mul_subv1024sf */

    case 116:
      if (pattern702 (x2, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16744; /* pred_widen_mul_subv1df */

    case 117:
      if (pattern702 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16746; /* pred_widen_mul_subv2df */

    case 118:
      if (pattern702 (x2, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16748; /* pred_widen_mul_subv4df */

    case 119:
      if (pattern702 (x2, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16750; /* pred_widen_mul_subv8df */

    case 120:
      if (pattern702 (x2, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16752; /* pred_widen_mul_subv16df */

    case 121:
      if (pattern702 (x2, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16754; /* pred_widen_mul_subv32df */

    case 122:
      if (pattern702 (x2, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16756; /* pred_widen_mul_subv64df */

    case 123:
      if (pattern702 (x2, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16758; /* pred_widen_mul_subv128df */

    case 124:
      if (pattern702 (x2, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16760; /* pred_widen_mul_subv256df */

    case 125:
      if (pattern702 (x2, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode) != 0
          || !(
#line 7176 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16762; /* pred_widen_mul_subv512df */

    case 126:
      if (pattern704 (x2, 
E_RVVM8SFmode, 
E_RVVM4HFmode, 
E_RVVMF4BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1023 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16764; /* pred_widen_mul_subrvvm8sf_scalar */

    case 127:
      if (pattern704 (x2, 
E_RVVM4SFmode, 
E_RVVM2HFmode, 
E_RVVMF8BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1024 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16766; /* pred_widen_mul_subrvvm4sf_scalar */

    case 128:
      if (pattern704 (x2, 
E_RVVM2SFmode, 
E_RVVM1HFmode, 
E_RVVMF16BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1025 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16768; /* pred_widen_mul_subrvvm2sf_scalar */

    case 129:
      if (pattern704 (x2, 
E_RVVM1SFmode, 
E_RVVMF2HFmode, 
E_RVVMF32BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1026 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16770; /* pred_widen_mul_subrvvm1sf_scalar */

    case 130:
      if (pattern704 (x2, 
E_RVVMF2SFmode, 
E_RVVMF4HFmode, 
E_RVVMF64BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1027 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 16772; /* pred_widen_mul_subrvvmf2sf_scalar */

    case 131:
      if (pattern704 (x2, 
E_RVVM8DFmode, 
E_RVVM4SFmode, 
E_RVVMF8BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16774; /* pred_widen_mul_subrvvm8df_scalar */

    case 132:
      if (pattern704 (x2, 
E_RVVM4DFmode, 
E_RVVM2SFmode, 
E_RVVMF16BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1029 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16776; /* pred_widen_mul_subrvvm4df_scalar */

    case 133:
      if (pattern704 (x2, 
E_RVVM2DFmode, 
E_RVVM1SFmode, 
E_RVVMF32BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16778; /* pred_widen_mul_subrvvm2df_scalar */

    case 134:
      if (pattern704 (x2, 
E_RVVM1DFmode, 
E_RVVMF2SFmode, 
E_RVVMF64BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1030 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16780; /* pred_widen_mul_subrvvm1df_scalar */

    case 135:
      if (pattern704 (x2, 
E_V1SFmode, 
E_V1HFmode, 
E_V1BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1032 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16782; /* pred_widen_mul_subv1sf_scalar */

    case 136:
      if (pattern704 (x2, 
E_V2SFmode, 
E_V2HFmode, 
E_V2BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1033 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16784; /* pred_widen_mul_subv2sf_scalar */

    case 137:
      if (pattern704 (x2, 
E_V4SFmode, 
E_V4HFmode, 
E_V4BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1034 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16786; /* pred_widen_mul_subv4sf_scalar */

    case 138:
      if (pattern704 (x2, 
E_V8SFmode, 
E_V8HFmode, 
E_V8BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1035 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16788; /* pred_widen_mul_subv8sf_scalar */

    case 139:
      if (pattern704 (x2, 
E_V16SFmode, 
E_V16HFmode, 
E_V16BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1036 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16790; /* pred_widen_mul_subv16sf_scalar */

    case 140:
      if (pattern704 (x2, 
E_V32SFmode, 
E_V32HFmode, 
E_V32BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1037 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16792; /* pred_widen_mul_subv32sf_scalar */

    case 141:
      if (pattern704 (x2, 
E_V64SFmode, 
E_V64HFmode, 
E_V64BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1038 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16794; /* pred_widen_mul_subv64sf_scalar */

    case 142:
      if (pattern704 (x2, 
E_V128SFmode, 
E_V128HFmode, 
E_V128BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1039 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16796; /* pred_widen_mul_subv128sf_scalar */

    case 143:
      if (pattern704 (x2, 
E_V256SFmode, 
E_V256HFmode, 
E_V256BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1040 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16798; /* pred_widen_mul_subv256sf_scalar */

    case 144:
      if (pattern704 (x2, 
E_V512SFmode, 
E_V512HFmode, 
E_V512BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1041 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16800; /* pred_widen_mul_subv512sf_scalar */

    case 145:
      if (pattern704 (x2, 
E_V1024SFmode, 
E_V1024HFmode, 
E_V1024BImode, 
E_HFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1042 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16802; /* pred_widen_mul_subv1024sf_scalar */

    case 146:
      if (pattern704 (x2, 
E_V1DFmode, 
E_V1SFmode, 
E_V1BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1043 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16804; /* pred_widen_mul_subv1df_scalar */

    case 147:
      if (pattern704 (x2, 
E_V2DFmode, 
E_V2SFmode, 
E_V2BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1044 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16806; /* pred_widen_mul_subv2df_scalar */

    case 148:
      if (pattern704 (x2, 
E_V4DFmode, 
E_V4SFmode, 
E_V4BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1045 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 16808; /* pred_widen_mul_subv4df_scalar */

    case 149:
      if (pattern704 (x2, 
E_V8DFmode, 
E_V8SFmode, 
E_V8BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1046 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 16810; /* pred_widen_mul_subv8df_scalar */

    case 150:
      if (pattern704 (x2, 
E_V16DFmode, 
E_V16SFmode, 
E_V16BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1047 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 16812; /* pred_widen_mul_subv16df_scalar */

    case 151:
      if (pattern704 (x2, 
E_V32DFmode, 
E_V32SFmode, 
E_V32BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1048 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 16814; /* pred_widen_mul_subv32df_scalar */

    case 152:
      if (pattern704 (x2, 
E_V64DFmode, 
E_V64SFmode, 
E_V64BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1049 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 16816; /* pred_widen_mul_subv64df_scalar */

    case 153:
      if (pattern704 (x2, 
E_V128DFmode, 
E_V128SFmode, 
E_V128BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1050 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 16818; /* pred_widen_mul_subv128df_scalar */

    case 154:
      if (pattern704 (x2, 
E_V256DFmode, 
E_V256SFmode, 
E_V256BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1051 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 16820; /* pred_widen_mul_subv256df_scalar */

    case 155:
      if (pattern704 (x2, 
E_V512DFmode, 
E_V512SFmode, 
E_V512BImode, 
E_SFmode) != 0
          || !(
#line 7205 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1052 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 16822; /* pred_widen_mul_subv512df_scalar */

    default:
      return -1;
    }
}

 int
recog_1399 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern537 (x2, 
E_V4BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V4BImode))
    {
      res = recog_1382 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V4BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  x10 = XEXP (x2, 2);
  operands[2] = x10;
  if (!vector_merge_operand (operands[2], E_V4BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V4QImode:
      if (!register_operand (operands[4], E_V4QImode)
          || !vector_neg_arith_operand (operands[5], E_V4QImode))
        return -1;
      if ((
#line 4875 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4QImode)) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return 12723; /* *pred_ltgev4qi */
      if (!(
#line 4896 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4QImode)) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 12791; /* *pred_ltgev4qi_narrow */

    case E_V4HImode:
      if (!register_operand (operands[4], E_V4HImode)
          || !vector_neg_arith_operand (operands[5], E_V4HImode))
        return -1;
      if ((
#line 4875 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4HImode)) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return 12736; /* *pred_ltgev4hi */
      if (!(
#line 4896 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4HImode)) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12804; /* *pred_ltgev4hi_narrow */

    case E_V4SImode:
      if (!register_operand (operands[4], E_V4SImode)
          || !vector_neg_arith_operand (operands[5], E_V4SImode))
        return -1;
      if ((
#line 4875 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4SImode)) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return 12748; /* *pred_ltgev4si */
      if (!(
#line 4896 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4SImode)) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12816; /* *pred_ltgev4si_narrow */

    case E_V4DImode:
      if (!register_operand (operands[4], E_V4DImode)
          || !vector_neg_arith_operand (operands[5], E_V4DImode))
        return -1;
      if ((
#line 4875 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V4DImode)) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return 12759; /* *pred_ltgev4di */
      if (!(
#line 4896 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V4DImode)) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 12827; /* *pred_ltgev4di_narrow */

    default:
      return -1;
    }
}

 int
recog_1409 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4QImode:
      if (!register_operand (operands[3], E_V4QImode)
          || GET_MODE (x9) != E_V4QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4935 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 732 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 12855; /* *pred_cmpv4qi_scalar_merge_tie_mask */

    case E_V4HImode:
      if (!register_operand (operands[3], E_V4HImode)
          || GET_MODE (x9) != E_V4HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4935 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 745 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 12868; /* *pred_cmpv4hi_scalar_merge_tie_mask */

    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode)
          || GET_MODE (x9) != E_V4SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4935 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 757 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 12880; /* *pred_cmpv4si_scalar_merge_tie_mask */

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode)
          || GET_MODE (x9) != E_V4DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5045 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 779 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 13003; /* *pred_cmpv4di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1416 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V512QImode:
      if (!register_operand (operands[3], E_V512QImode)
          || GET_MODE (x9) != E_V512QImode
          || !register_operand (operands[4], E_QImode)
          || !(
#line 4935 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 739 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 12862; /* *pred_cmpv512qi_scalar_merge_tie_mask */

    case E_V512HImode:
      if (!register_operand (operands[3], E_V512HImode)
          || GET_MODE (x9) != E_V512HImode
          || !register_operand (operands[4], E_HImode)
          || !(
#line 4935 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 752 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 12875; /* *pred_cmpv512hi_scalar_merge_tie_mask */

    case E_V512SImode:
      if (!register_operand (operands[3], E_V512SImode)
          || GET_MODE (x9) != E_V512SImode
          || !register_operand (operands[4], E_SImode)
          || !(
#line 4935 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 764 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 12887; /* *pred_cmpv512si_scalar_merge_tie_mask */

    case E_V512DImode:
      if (!register_operand (operands[3], E_V512DImode)
          || GET_MODE (x9) != E_V512DImode
          || !register_operand (operands[4], E_DImode)
          || !(
#line 5045 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 786 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 13010; /* *pred_cmpv512di_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1425 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern571 (x2, 
E_V8BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V8BImode))
    {
      res = recog_1410 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V8BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V8BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V8QImode:
      if (!register_operand (operands[4], E_V8QImode)
          || GET_MODE (x9) != E_V8QImode
          || !register_operand (operands[5], E_QImode))
        return -1;
      if ((
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8QImode)) && 
#line 733 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return 12910; /* *pred_cmpv8qi_scalar */
      if (!(
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8QImode)) && 
#line 733 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 12964; /* *pred_cmpv8qi_scalar_narrow */

    case E_V8HImode:
      if (!register_operand (operands[4], E_V8HImode)
          || GET_MODE (x9) != E_V8HImode
          || !register_operand (operands[5], E_HImode))
        return -1;
      if ((
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8HImode)) && 
#line 746 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return 12923; /* *pred_cmpv8hi_scalar */
      if (!(
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8HImode)) && 
#line 746 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 12977; /* *pred_cmpv8hi_scalar_narrow */

    case E_V8SImode:
      if (!register_operand (operands[4], E_V8SImode)
          || GET_MODE (x9) != E_V8SImode
          || !register_operand (operands[5], E_SImode))
        return -1;
      if ((
#line 4960 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8SImode)) && 
#line 758 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return 12935; /* *pred_cmpv8si_scalar */
      if (!(
#line 4982 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8SImode)) && 
#line 758 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 12989; /* *pred_cmpv8si_scalar_narrow */

    case E_V8DImode:
      if (!register_operand (operands[4], E_V8DImode)
          || GET_MODE (x9) != E_V8DImode
          || !register_operand (operands[5], E_DImode))
        return -1;
      if ((
#line 5070 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V8DImode)) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return 13018; /* *pred_cmpv8di_scalar */
      if (!(
#line 5092 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V8DImode)) && 
#line 780 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 13032; /* *pred_cmpv8di_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1432 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM2HFmode:
      if (!register_operand (operands[3], E_RVVM2HFmode)
          || !register_operand (operands[4], E_RVVM2HFmode)
          || !(
#line 7330 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16993; /* *pred_cmprvvm2hf_narrow_merge_tie_mask */

    case E_RVVM4SFmode:
      if (!register_operand (operands[3], E_RVVM4SFmode)
          || !register_operand (operands[4], E_RVVM4SFmode)
          || !(
#line 7330 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 16998; /* *pred_cmprvvm4sf_narrow_merge_tie_mask */

    case E_RVVM8DFmode:
      if (!register_operand (operands[3], E_RVVM8DFmode)
          || !register_operand (operands[4], E_RVVM8DFmode)
          || !(
#line 7330 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17002; /* *pred_cmprvvm8df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1434 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVMF2HFmode:
      if (!register_operand (operands[3], E_RVVMF2HFmode)
          || !register_operand (operands[4], E_RVVMF2HFmode)
          || !(
#line 7330 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 16995; /* *pred_cmprvvmf2hf_narrow_merge_tie_mask */

    case E_RVVM1SFmode:
      if (!register_operand (operands[3], E_RVVM1SFmode)
          || !register_operand (operands[4], E_RVVM1SFmode)
          || !(
#line 7330 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17000; /* *pred_cmprvvm1sf_narrow_merge_tie_mask */

    case E_RVVM2DFmode:
      if (!register_operand (operands[3], E_RVVM2DFmode)
          || !register_operand (operands[4], E_RVVM2DFmode)
          || !(
#line 7330 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17004; /* *pred_cmprvvm2df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1439 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[3], E_V8HFmode)
          || !register_operand (operands[4], E_V8HFmode)
          || !(
#line 7330 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 17009; /* *pred_cmpv8hf_narrow_merge_tie_mask */

    case E_V8SFmode:
      if (!register_operand (operands[3], E_V8SFmode)
          || !register_operand (operands[4], E_V8SFmode)
          || !(
#line 7330 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17021; /* *pred_cmpv8sf_narrow_merge_tie_mask */

    case E_V8DFmode:
      if (!register_operand (operands[3], E_V8DFmode)
          || !register_operand (operands[4], E_V8DFmode)
          || !(
#line 7330 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17032; /* *pred_cmpv8df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1444 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V256HFmode:
      if (!register_operand (operands[3], E_V256HFmode)
          || !register_operand (operands[4], E_V256HFmode)
          || !(
#line 7330 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17014; /* *pred_cmpv256hf_narrow_merge_tie_mask */

    case E_V256SFmode:
      if (!register_operand (operands[3], E_V256SFmode)
          || !register_operand (operands[4], E_V256SFmode)
          || !(
#line 7330 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17026; /* *pred_cmpv256sf_narrow_merge_tie_mask */

    case E_V256DFmode:
      if (!register_operand (operands[3], E_V256DFmode)
          || !register_operand (operands[4], E_V256DFmode)
          || !(
#line 7330 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17037; /* *pred_cmpv256df_narrow_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1449 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_RVVM1HFmode:
      if (!register_operand (operands[3], E_RVVM1HFmode)
          || GET_MODE (x9) != E_RVVM1HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7393 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 17090; /* *pred_cmprvvm1hf_scalar_merge_tie_mask */

    case E_RVVM2SFmode:
      if (!register_operand (operands[3], E_RVVM2SFmode)
          || GET_MODE (x9) != E_RVVM2SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7393 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17095; /* *pred_cmprvvm2sf_scalar_merge_tie_mask */

    case E_RVVM4DFmode:
      if (!register_operand (operands[3], E_RVVM4DFmode)
          || GET_MODE (x9) != E_RVVM4DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7393 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17099; /* *pred_cmprvvm4df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1454 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4HFmode:
      if (!register_operand (operands[3], E_V4HFmode)
          || GET_MODE (x9) != E_V4HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7393 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 17104; /* *pred_cmpv4hf_scalar_merge_tie_mask */

    case E_V4SFmode:
      if (!register_operand (operands[3], E_V4SFmode)
          || GET_MODE (x9) != E_V4SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7393 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 17116; /* *pred_cmpv4sf_scalar_merge_tie_mask */

    case E_V4DFmode:
      if (!register_operand (operands[3], E_V4DFmode)
          || GET_MODE (x9) != E_V4DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7393 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 17127; /* *pred_cmpv4df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1460 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 1);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[7] = x6;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XEXP (x2, 2);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V256HFmode:
      if (!register_operand (operands[3], E_V256HFmode)
          || GET_MODE (x9) != E_V256HFmode
          || !register_operand (operands[4], E_HFmode)
          || !(
#line 7393 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 17110; /* *pred_cmpv256hf_scalar_merge_tie_mask */

    case E_V256SFmode:
      if (!register_operand (operands[3], E_V256SFmode)
          || GET_MODE (x9) != E_V256SFmode
          || !register_operand (operands[4], E_SFmode)
          || !(
#line 7393 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 17122; /* *pred_cmpv256sf_scalar_merge_tie_mask */

    case E_V256DFmode:
      if (!register_operand (operands[3], E_V256DFmode)
          || GET_MODE (x9) != E_V256DFmode
          || !register_operand (operands[4], E_DFmode)
          || !(
#line 7393 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 17133; /* *pred_cmpv256df_scalar_merge_tie_mask */

    default:
      return -1;
    }
}

 int
recog_1468 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern548 (x2, 
E_V16BImode) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (register_operand (operands[1], E_V16BImode))
    {
      res = recog_1456 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x3;
  if (!vector_mask_operand (operands[1], E_V16BImode))
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XVECEXP (x4, 0, 1);
  operands[6] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[7] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[8] = x7;
  x8 = XEXP (x3, 0);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  x11 = XEXP (x2, 2);
  operands[2] = x11;
  if (!vector_merge_operand (operands[2], E_V16BImode))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_V16HFmode:
      if (!register_operand (operands[4], E_V16HFmode)
          || GET_MODE (x9) != E_V16HFmode
          || !register_operand (operands[5], E_HFmode))
        return -1;
      if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16HFmode)) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return 17154; /* *pred_cmpv16hf_scalar */
      if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16HFmode)) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 17202; /* *pred_cmpv16hf_scalar_narrow */

    case E_V16SFmode:
      if (!register_operand (operands[4], E_V16SFmode)
          || GET_MODE (x9) != E_V16SFmode
          || !register_operand (operands[5], E_SFmode))
        return -1;
      if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16SFmode)) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return 17166; /* *pred_cmpv16sf_scalar */
      if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16SFmode)) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 17214; /* *pred_cmpv16sf_scalar_narrow */

    case E_V16DFmode:
      if (!register_operand (operands[4], E_V16DFmode)
          || GET_MODE (x9) != E_V16DFmode
          || !register_operand (operands[5], E_DFmode))
        return -1;
      if ((
#line 7418 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_le_one (V16DFmode)) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return 17177; /* *pred_cmpv16df_scalar */
      if (!(
#line 7440 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && riscv_vector::cmp_lmul_gt_one (V16DFmode)) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 17225; /* *pred_cmpv16df_scalar_narrow */

    default:
      return -1;
    }
}

 int
recog_1476 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
          res = recog_386 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (pnum_clobbers != NULL)
        {
          res = recog_388 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (ordered_comparison_operator (x3, E_VOIDmode))
        {
          res = recog_389 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != LABEL_REF)
        return -1;
      x5 = XEXP (x2, 2);
      if (GET_CODE (x5) != PC)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_CODE (x6) != PC)
        return -1;
      operands[1] = x3;
      x7 = XEXP (x3, 0);
      operands[2] = x7;
      x8 = XEXP (x3, 1);
      operands[3] = x8;
      x9 = XEXP (x4, 0);
      operands[0] = x9;
      if (equality_operator (operands[1], E_VOIDmode))
        {
          switch (GET_MODE (operands[2]))
            {
            case E_SImode:
              if (register_operand (operands[2], E_SImode)
                  && const_int5s_operand (operands[3], E_SImode)
                  && (
#line 2627 "../../gcc/config/riscv/corev.md"
(TARGET_XCVBI) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return 34088; /* *cv_branchsi */
              break;

            case E_DImode:
              if (register_operand (operands[2], E_DImode)
                  && const_int5s_operand (operands[3], E_DImode)
                  && (
#line 2627 "../../gcc/config/riscv/corev.md"
(TARGET_XCVBI) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return 34089; /* *cv_branchdi */
              break;

            default:
              break;
            }
        }
      if (!ordered_comparison_operator (operands[1], E_VOIDmode))
        return -1;
      switch (pattern414 ())
        {
        case 0:
          if (!(
#line 2645 "../../gcc/config/riscv/corev.md"
(TARGET_XCVBI) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 34090; /* *branchsi */

        case 1:
          if (!(
#line 2645 "../../gcc/config/riscv/corev.md"
(TARGET_XCVBI) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 34091; /* *branchdi */

        default:
          return -1;
        }

    case UNSPEC:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      switch (XVECLEN (x3, 0))
        {
        case 5:
          if (pattern265 (x3) != 0)
            return -1;
          switch (XINT (x3, 1))
            {
            case 93:
              return recog_412 (x1, insn, pnum_clobbers);

            case 174:
              switch (pattern435 (x2))
                {
                case 0:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1983; /* pred_store_widthbrvvm8qi */

                case 1:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1986; /* pred_store_widthbrvvm4qi */

                case 2:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1989; /* pred_store_widthbrvvm2qi */

                case 3:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1992; /* pred_store_widthbrvvm1qi */

                case 4:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1995; /* pred_store_widthbrvvm8hi */

                case 5:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1998; /* pred_store_widthbrvvm4hi */

                case 6:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2001; /* pred_store_widthbrvvm2hi */

                case 7:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2004; /* pred_store_widthbrvvm1hi */

                case 8:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2007; /* pred_store_widthbrvvm8si */

                case 9:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2010; /* pred_store_widthbrvvm4si */

                case 10:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2013; /* pred_store_widthbrvvm2si */

                case 11:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2016; /* pred_store_widthbrvvm1si */

                case 12:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2019; /* pred_store_widthbrvvm8di */

                case 13:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2022; /* pred_store_widthbrvvm4di */

                case 14:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2025; /* pred_store_widthbrvvm2di */

                case 15:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2028; /* pred_store_widthbrvvm1di */

                case 16:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2031; /* pred_store_widthbrvvmf8qi */

                case 17:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2034; /* pred_store_widthbrvvmf4hi */

                case 18:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2037; /* pred_store_widthbrvvmf2si */

                default:
                  return -1;
                }

            case 176:
              switch (pattern435 (x2))
                {
                case 0:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1984; /* pred_store_widthhrvvm8qi */

                case 1:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1987; /* pred_store_widthhrvvm4qi */

                case 2:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1990; /* pred_store_widthhrvvm2qi */

                case 3:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1993; /* pred_store_widthhrvvm1qi */

                case 4:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1996; /* pred_store_widthhrvvm8hi */

                case 5:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1999; /* pred_store_widthhrvvm4hi */

                case 6:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2002; /* pred_store_widthhrvvm2hi */

                case 7:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2005; /* pred_store_widthhrvvm1hi */

                case 8:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2008; /* pred_store_widthhrvvm8si */

                case 9:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2011; /* pred_store_widthhrvvm4si */

                case 10:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2014; /* pred_store_widthhrvvm2si */

                case 11:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2017; /* pred_store_widthhrvvm1si */

                case 12:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2020; /* pred_store_widthhrvvm8di */

                case 13:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2023; /* pred_store_widthhrvvm4di */

                case 14:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2026; /* pred_store_widthhrvvm2di */

                case 15:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2029; /* pred_store_widthhrvvm1di */

                case 16:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2032; /* pred_store_widthhrvvmf8qi */

                case 17:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2035; /* pred_store_widthhrvvmf4hi */

                case 18:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2038; /* pred_store_widthhrvvmf2si */

                default:
                  return -1;
                }

            case 178:
              switch (pattern435 (x2))
                {
                case 0:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1985; /* pred_store_widthwrvvm8qi */

                case 1:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1988; /* pred_store_widthwrvvm4qi */

                case 2:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1991; /* pred_store_widthwrvvm2qi */

                case 3:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1994; /* pred_store_widthwrvvm1qi */

                case 4:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 1997; /* pred_store_widthwrvvm8hi */

                case 5:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2000; /* pred_store_widthwrvvm4hi */

                case 6:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2003; /* pred_store_widthwrvvm2hi */

                case 7:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2006; /* pred_store_widthwrvvm1hi */

                case 8:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2009; /* pred_store_widthwrvvm8si */

                case 9:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2012; /* pred_store_widthwrvvm4si */

                case 10:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2015; /* pred_store_widthwrvvm2si */

                case 11:
                  if (!
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2018; /* pred_store_widthwrvvm1si */

                case 12:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2021; /* pred_store_widthwrvvm8di */

                case 13:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2024; /* pred_store_widthwrvvm4di */

                case 14:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2027; /* pred_store_widthwrvvm2di */

                case 15:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2030; /* pred_store_widthwrvvm1di */

                case 16:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2033; /* pred_store_widthwrvvmf8qi */

                case 17:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2036; /* pred_store_widthwrvvmf4hi */

                case 18:
                  if (!(
#line 248 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2039; /* pred_store_widthwrvvmf2si */

                default:
                  return -1;
                }

            case 180:
              switch (pattern437 (x2, 
180))
                {
                case 0:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2154; /* pred_strided_store_widthbrvvm8qi */

                case 1:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2157; /* pred_strided_store_widthbrvvm4qi */

                case 2:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2160; /* pred_strided_store_widthbrvvm2qi */

                case 3:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2163; /* pred_strided_store_widthbrvvm1qi */

                case 4:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2166; /* pred_strided_store_widthbrvvm8hi */

                case 5:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2169; /* pred_strided_store_widthbrvvm4hi */

                case 6:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2172; /* pred_strided_store_widthbrvvm2hi */

                case 7:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2175; /* pred_strided_store_widthbrvvm1hi */

                case 8:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2178; /* pred_strided_store_widthbrvvm8si */

                case 9:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2181; /* pred_strided_store_widthbrvvm4si */

                case 10:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2184; /* pred_strided_store_widthbrvvm2si */

                case 11:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2187; /* pred_strided_store_widthbrvvm1si */

                case 12:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2190; /* pred_strided_store_widthbrvvm8di */

                case 13:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2193; /* pred_strided_store_widthbrvvm4di */

                case 14:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2196; /* pred_strided_store_widthbrvvm2di */

                case 15:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2199; /* pred_strided_store_widthbrvvm1di */

                case 16:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2202; /* pred_strided_store_widthbrvvmf8qi */

                case 17:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2205; /* pred_strided_store_widthbrvvmf4hi */

                case 18:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2208; /* pred_strided_store_widthbrvvmf2si */

                default:
                  return -1;
                }

            case 182:
              switch (pattern437 (x2, 
182))
                {
                case 0:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2155; /* pred_strided_store_widthhrvvm8qi */

                case 1:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2158; /* pred_strided_store_widthhrvvm4qi */

                case 2:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2161; /* pred_strided_store_widthhrvvm2qi */

                case 3:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2164; /* pred_strided_store_widthhrvvm1qi */

                case 4:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2167; /* pred_strided_store_widthhrvvm8hi */

                case 5:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2170; /* pred_strided_store_widthhrvvm4hi */

                case 6:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2173; /* pred_strided_store_widthhrvvm2hi */

                case 7:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2176; /* pred_strided_store_widthhrvvm1hi */

                case 8:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2179; /* pred_strided_store_widthhrvvm8si */

                case 9:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2182; /* pred_strided_store_widthhrvvm4si */

                case 10:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2185; /* pred_strided_store_widthhrvvm2si */

                case 11:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2188; /* pred_strided_store_widthhrvvm1si */

                case 12:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2191; /* pred_strided_store_widthhrvvm8di */

                case 13:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2194; /* pred_strided_store_widthhrvvm4di */

                case 14:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2197; /* pred_strided_store_widthhrvvm2di */

                case 15:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2200; /* pred_strided_store_widthhrvvm1di */

                case 16:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2203; /* pred_strided_store_widthhrvvmf8qi */

                case 17:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2206; /* pred_strided_store_widthhrvvmf4hi */

                case 18:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2209; /* pred_strided_store_widthhrvvmf2si */

                default:
                  return -1;
                }

            case 184:
              switch (pattern437 (x2, 
184))
                {
                case 0:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2156; /* pred_strided_store_widthwrvvm8qi */

                case 1:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2159; /* pred_strided_store_widthwrvvm4qi */

                case 2:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2162; /* pred_strided_store_widthwrvvm2qi */

                case 3:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2165; /* pred_strided_store_widthwrvvm1qi */

                case 4:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2168; /* pred_strided_store_widthwrvvm8hi */

                case 5:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2171; /* pred_strided_store_widthwrvvm4hi */

                case 6:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2174; /* pred_strided_store_widthwrvvm2hi */

                case 7:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2177; /* pred_strided_store_widthwrvvm1hi */

                case 8:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2180; /* pred_strided_store_widthwrvvm8si */

                case 9:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2183; /* pred_strided_store_widthwrvvm4si */

                case 10:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2186; /* pred_strided_store_widthwrvvm2si */

                case 11:
                  if (!
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
                    return -1;
                  return 2189; /* pred_strided_store_widthwrvvm1si */

                case 12:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2192; /* pred_strided_store_widthwrvvm8di */

                case 13:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2195; /* pred_strided_store_widthwrvvm4di */

                case 14:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2198; /* pred_strided_store_widthwrvvm2di */

                case 15:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                    return -1;
                  return 2201; /* pred_strided_store_widthwrvvm1di */

                case 16:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2204; /* pred_strided_store_widthwrvvmf8qi */

                case 17:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2207; /* pred_strided_store_widthwrvvmf4hi */

                case 18:
                  if (!(
#line 288 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
                    return -1;
                  return 2210; /* pred_strided_store_widthwrvvmf2si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 7:
          return recog_1472 (x1, insn, pnum_clobbers);

        case 9:
          return recog_1473 (x1, insn, pnum_clobbers);

        case 6:
          if (pattern267 (x3) != 0)
            return -1;
          x10 = XVECEXP (x3, 0, 0);
          operands[1] = x10;
          x11 = XVECEXP (x3, 0, 1);
          if (!vector_length_operand (x11, E_VOIDmode))
            return -1;
          x12 = XVECEXP (x3, 0, 2);
          if (!const_int_operand (x12, E_VOIDmode))
            return -1;
          x13 = XVECEXP (x3, 0, 3);
          if (!const_int_operand (x13, E_VOIDmode))
            return -1;
          x4 = XEXP (x2, 1);
          switch (GET_CODE (x4))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
              return recog_1471 (x1, insn, pnum_clobbers);

            case UNSPEC:
              if (XVECLEN (x4, 0) != 1)
                return -1;
              operands[4] = x11;
              operands[5] = x12;
              operands[6] = x13;
              x14 = XVECEXP (x4, 0, 0);
              operands[3] = x14;
              x5 = XEXP (x2, 2);
              operands[2] = x5;
              switch (XINT (x4, 1))
                {
                case 116:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_RVVMF64BImode:
                      if (pattern627 (x2, 
E_RVVMF64BImode) != 0
                          || !(
#line 6133 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                        return -1;
                      return 14387; /* pred_sbfrvvmf64bi */

                    case E_RVVMF32BImode:
                      if (pattern627 (x2, 
E_RVVMF32BImode) != 0
                          || !
#line 6133 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14390; /* pred_sbfrvvmf32bi */

                    case E_RVVMF16BImode:
                      if (pattern627 (x2, 
E_RVVMF16BImode) != 0
                          || !
#line 6133 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14393; /* pred_sbfrvvmf16bi */

                    case E_RVVMF8BImode:
                      if (pattern627 (x2, 
E_RVVMF8BImode) != 0
                          || !
#line 6133 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14396; /* pred_sbfrvvmf8bi */

                    case E_RVVMF4BImode:
                      if (pattern627 (x2, 
E_RVVMF4BImode) != 0
                          || !
#line 6133 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14399; /* pred_sbfrvvmf4bi */

                    case E_RVVMF2BImode:
                      if (pattern627 (x2, 
E_RVVMF2BImode) != 0
                          || !
#line 6133 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14402; /* pred_sbfrvvmf2bi */

                    case E_RVVM1BImode:
                      if (pattern627 (x2, 
E_RVVM1BImode) != 0
                          || !
#line 6133 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14405; /* pred_sbfrvvm1bi */

                    default:
                      return -1;
                    }

                case 117:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_RVVMF64BImode:
                      if (pattern627 (x2, 
E_RVVMF64BImode) != 0
                          || !(
#line 6133 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                        return -1;
                      return 14388; /* pred_sifrvvmf64bi */

                    case E_RVVMF32BImode:
                      if (pattern627 (x2, 
E_RVVMF32BImode) != 0
                          || !
#line 6133 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14391; /* pred_sifrvvmf32bi */

                    case E_RVVMF16BImode:
                      if (pattern627 (x2, 
E_RVVMF16BImode) != 0
                          || !
#line 6133 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14394; /* pred_sifrvvmf16bi */

                    case E_RVVMF8BImode:
                      if (pattern627 (x2, 
E_RVVMF8BImode) != 0
                          || !
#line 6133 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14397; /* pred_sifrvvmf8bi */

                    case E_RVVMF4BImode:
                      if (pattern627 (x2, 
E_RVVMF4BImode) != 0
                          || !
#line 6133 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14400; /* pred_sifrvvmf4bi */

                    case E_RVVMF2BImode:
                      if (pattern627 (x2, 
E_RVVMF2BImode) != 0
                          || !
#line 6133 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14403; /* pred_sifrvvmf2bi */

                    case E_RVVM1BImode:
                      if (pattern627 (x2, 
E_RVVM1BImode) != 0
                          || !
#line 6133 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14406; /* pred_sifrvvm1bi */

                    default:
                      return -1;
                    }

                case 118:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_RVVMF64BImode:
                      if (pattern627 (x2, 
E_RVVMF64BImode) != 0
                          || !(
#line 6133 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                        return -1;
                      return 14389; /* pred_sofrvvmf64bi */

                    case E_RVVMF32BImode:
                      if (pattern627 (x2, 
E_RVVMF32BImode) != 0
                          || !
#line 6133 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14392; /* pred_sofrvvmf32bi */

                    case E_RVVMF16BImode:
                      if (pattern627 (x2, 
E_RVVMF16BImode) != 0
                          || !
#line 6133 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14395; /* pred_sofrvvmf16bi */

                    case E_RVVMF8BImode:
                      if (pattern627 (x2, 
E_RVVMF8BImode) != 0
                          || !
#line 6133 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14398; /* pred_sofrvvmf8bi */

                    case E_RVVMF4BImode:
                      if (pattern627 (x2, 
E_RVVMF4BImode) != 0
                          || !
#line 6133 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14401; /* pred_sofrvvmf4bi */

                    case E_RVVMF2BImode:
                      if (pattern627 (x2, 
E_RVVMF2BImode) != 0
                          || !
#line 6133 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14404; /* pred_sofrvvmf2bi */

                    case E_RVVM1BImode:
                      if (pattern627 (x2, 
E_RVVM1BImode) != 0
                          || !
#line 6133 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
                        return -1;
                      return 14407; /* pred_sofrvvm1bi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      return recog_1474 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_1484 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern52 (x1))
    {
    case 0:
      if (!
#line 2111 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
        return -1;
      return 147; /* *fixuns_truncsfsi2 */

    case 1:
      if (!(
#line 2111 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 149; /* *fixuns_truncdfsi2 */

    case 2:
      if (!(
#line 2111 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 151; /* *fixuns_trunchfsi2 */

    case 3:
      if (!(
#line 2129 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX)))
        return -1;
      return 159; /* fixuns_truncsfdi2 */

    case 4:
      if (!(
#line 2129 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
        return -1;
      return 161; /* fixuns_truncdfdi2 */

    case 5:
      if (!(
#line 2129 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && (TARGET_HARD_FLOAT || TARGET_ZFINX)) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
        return -1;
      return 163; /* fixuns_trunchfdi2 */

    case 6:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26396; /* fixuns_truncrvvm8hfrvvm8hi2 */

    case 7:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26398; /* fixuns_truncrvvm4hfrvvm4hi2 */

    case 8:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26756; /* fixuns_truncrvvm8sfrvvm4hi2 */

    case 9:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26400; /* fixuns_truncrvvm2hfrvvm2hi2 */

    case 10:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26758; /* fixuns_truncrvvm4sfrvvm2hi2 */

    case 11:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26402; /* fixuns_truncrvvm1hfrvvm1hi2 */

    case 12:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26760; /* fixuns_truncrvvm2sfrvvm1hi2 */

    case 13:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26404; /* fixuns_truncrvvmf2hfrvvmf2hi2 */

    case 14:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26762; /* fixuns_truncrvvm1sfrvvmf2hi2 */

    case 15:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26406; /* fixuns_truncrvvmf4hfrvvmf4hi2 */

    case 16:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26764; /* fixuns_truncrvvmf2sfrvvmf4hi2 */

    case 17:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26408; /* fixuns_truncrvvm8sfrvvm8si2 */

    case 18:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26588; /* fixuns_truncrvvm4hfrvvm8si2 */

    case 19:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26410; /* fixuns_truncrvvm4sfrvvm4si2 */

    case 20:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26590; /* fixuns_truncrvvm2hfrvvm4si2 */

    case 21:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26766; /* fixuns_truncrvvm8dfrvvm4si2 */

    case 22:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26412; /* fixuns_truncrvvm2sfrvvm2si2 */

    case 23:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26592; /* fixuns_truncrvvm1hfrvvm2si2 */

    case 24:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26768; /* fixuns_truncrvvm4dfrvvm2si2 */

    case 25:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26414; /* fixuns_truncrvvm1sfrvvm1si2 */

    case 26:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26594; /* fixuns_truncrvvmf2hfrvvm1si2 */

    case 27:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26770; /* fixuns_truncrvvm2dfrvvm1si2 */

    case 28:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26416; /* fixuns_truncrvvmf2sfrvvmf2si2 */

    case 29:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26596; /* fixuns_truncrvvmf4hfrvvmf2si2 */

    case 30:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26772; /* fixuns_truncrvvm1dfrvvmf2si2 */

    case 31:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26418; /* fixuns_truncrvvm8dfrvvm8di2 */

    case 32:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26598; /* fixuns_truncrvvm4sfrvvm8di2 */

    case 33:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26420; /* fixuns_truncrvvm4dfrvvm4di2 */

    case 34:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26600; /* fixuns_truncrvvm2sfrvvm4di2 */

    case 35:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26422; /* fixuns_truncrvvm2dfrvvm2di2 */

    case 36:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26602; /* fixuns_truncrvvm1sfrvvm2di2 */

    case 37:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26424; /* fixuns_truncrvvm1dfrvvm1di2 */

    case 38:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26604; /* fixuns_truncrvvmf2sfrvvm1di2 */

    case 39:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 26426; /* fixuns_truncv1hfv1hi2 */

    case 40:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26798; /* fixuns_truncv1sfv1hi2 */

    case 41:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 26428; /* fixuns_truncv2hfv2hi2 */

    case 42:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26800; /* fixuns_truncv2sfv2hi2 */

    case 43:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 26430; /* fixuns_truncv4hfv4hi2 */

    case 44:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26802; /* fixuns_truncv4sfv4hi2 */

    case 45:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 26432; /* fixuns_truncv8hfv8hi2 */

    case 46:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26804; /* fixuns_truncv8sfv8hi2 */

    case 47:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 26434; /* fixuns_truncv16hfv16hi2 */

    case 48:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26806; /* fixuns_truncv16sfv16hi2 */

    case 49:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26436; /* fixuns_truncv32hfv32hi2 */

    case 50:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26808; /* fixuns_truncv32sfv32hi2 */

    case 51:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26438; /* fixuns_truncv64hfv64hi2 */

    case 52:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26810; /* fixuns_truncv64sfv64hi2 */

    case 53:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26440; /* fixuns_truncv128hfv128hi2 */

    case 54:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26812; /* fixuns_truncv128sfv128hi2 */

    case 55:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26442; /* fixuns_truncv256hfv256hi2 */

    case 56:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26814; /* fixuns_truncv256sfv256hi2 */

    case 57:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26444; /* fixuns_truncv512hfv512hi2 */

    case 58:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26816; /* fixuns_truncv512sfv512hi2 */

    case 59:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26446; /* fixuns_truncv1024hfv1024hi2 */

    case 60:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26818; /* fixuns_truncv1024sfv1024hi2 */

    case 61:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26448; /* fixuns_truncv2048hfv2048hi2 */

    case 62:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26450; /* fixuns_truncv1sfv1si2 */

    case 63:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)))
        return -1;
      return 26606; /* fixuns_truncv1hfv1si2 */

    case 64:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26820; /* fixuns_truncv1dfv1si2 */

    case 65:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26452; /* fixuns_truncv2sfv2si2 */

    case 66:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)))
        return -1;
      return 26608; /* fixuns_truncv2hfv2si2 */

    case 67:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26822; /* fixuns_truncv2dfv2si2 */

    case 68:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26454; /* fixuns_truncv4sfv4si2 */

    case 69:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)))
        return -1;
      return 26610; /* fixuns_truncv4hfv4si2 */

    case 70:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26824; /* fixuns_truncv4dfv4si2 */

    case 71:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26456; /* fixuns_truncv8sfv8si2 */

    case 72:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)))
        return -1;
      return 26612; /* fixuns_truncv8hfv8si2 */

    case 73:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26826; /* fixuns_truncv8dfv8si2 */

    case 74:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26458; /* fixuns_truncv16sfv16si2 */

    case 75:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26614; /* fixuns_truncv16hfv16si2 */

    case 76:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26828; /* fixuns_truncv16dfv16si2 */

    case 77:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26460; /* fixuns_truncv32sfv32si2 */

    case 78:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26616; /* fixuns_truncv32hfv32si2 */

    case 79:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26830; /* fixuns_truncv32dfv32si2 */

    case 80:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26462; /* fixuns_truncv64sfv64si2 */

    case 81:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26618; /* fixuns_truncv64hfv64si2 */

    case 82:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26832; /* fixuns_truncv64dfv64si2 */

    case 83:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26464; /* fixuns_truncv128sfv128si2 */

    case 84:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26620; /* fixuns_truncv128hfv128si2 */

    case 85:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26834; /* fixuns_truncv128dfv128si2 */

    case 86:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26466; /* fixuns_truncv256sfv256si2 */

    case 87:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26622; /* fixuns_truncv256hfv256si2 */

    case 88:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26836; /* fixuns_truncv256dfv256si2 */

    case 89:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26468; /* fixuns_truncv512sfv512si2 */

    case 90:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26624; /* fixuns_truncv512hfv512si2 */

    case 91:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26838; /* fixuns_truncv512dfv512si2 */

    case 92:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26470; /* fixuns_truncv1024sfv1024si2 */

    case 93:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26626; /* fixuns_truncv1024hfv1024si2 */

    case 94:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26472; /* fixuns_truncv1dfv1di2 */

    case 95:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26628; /* fixuns_truncv1sfv1di2 */

    case 96:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26474; /* fixuns_truncv2dfv2di2 */

    case 97:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26630; /* fixuns_truncv2sfv2di2 */

    case 98:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return -1;
      return 26476; /* fixuns_truncv4dfv4di2 */

    case 99:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)))
        return -1;
      return 26632; /* fixuns_truncv4sfv4di2 */

    case 100:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26478; /* fixuns_truncv8dfv8di2 */

    case 101:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26634; /* fixuns_truncv8sfv8di2 */

    case 102:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26480; /* fixuns_truncv16dfv16di2 */

    case 103:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26636; /* fixuns_truncv16sfv16di2 */

    case 104:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26482; /* fixuns_truncv32dfv32di2 */

    case 105:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26638; /* fixuns_truncv32sfv32di2 */

    case 106:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26484; /* fixuns_truncv64dfv64di2 */

    case 107:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26640; /* fixuns_truncv64sfv64di2 */

    case 108:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26486; /* fixuns_truncv128dfv128di2 */

    case 109:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26642; /* fixuns_truncv128sfv128di2 */

    case 110:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26488; /* fixuns_truncv256dfv256di2 */

    case 111:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26644; /* fixuns_truncv256sfv256di2 */

    case 112:
      if (!(
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26490; /* fixuns_truncv512dfv512di2 */

    case 113:
      if (!(
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26646; /* fixuns_truncv512sfv512di2 */

    case 114:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26744; /* fixuns_truncrvvm8hfrvvm4qi2 */

    case 115:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26746; /* fixuns_truncrvvm4hfrvvm2qi2 */

    case 116:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26748; /* fixuns_truncrvvm2hfrvvm1qi2 */

    case 117:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26750; /* fixuns_truncrvvm1hfrvvmf2qi2 */

    case 118:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)))
        return -1;
      return 26752; /* fixuns_truncrvvmf2hfrvvmf4qi2 */

    case 119:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 26754; /* fixuns_truncrvvmf4hfrvvmf8qi2 */

    case 120:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)))
        return -1;
      return 26774; /* fixuns_truncv1hfv1qi2 */

    case 121:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)))
        return -1;
      return 26776; /* fixuns_truncv2hfv2qi2 */

    case 122:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)))
        return -1;
      return 26778; /* fixuns_truncv4hfv4qi2 */

    case 123:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)))
        return -1;
      return 26780; /* fixuns_truncv8hfv8qi2 */

    case 124:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)))
        return -1;
      return 26782; /* fixuns_truncv16hfv16qi2 */

    case 125:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 26784; /* fixuns_truncv32hfv32qi2 */

    case 126:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 26786; /* fixuns_truncv64hfv64qi2 */

    case 127:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 26788; /* fixuns_truncv128hfv128qi2 */

    case 128:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 26790; /* fixuns_truncv256hfv256qi2 */

    case 129:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 26792; /* fixuns_truncv512hfv512qi2 */

    case 130:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 26794; /* fixuns_truncv1024hfv1024qi2 */

    case 131:
      if (!(
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 26796; /* fixuns_truncv2048hfv2048qi2 */

    default:
      return -1;
    }
}

 int
recog_1496 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern110 (x1))
    {
    case 0:
      if (
#line 276 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBB))
        return 525; /* *clzsi2 */
      if (!(
#line 121 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return -1;
      return 885; /* *th_clzsi2 */

    case 1:
      if (
#line 304 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBB))
        return 537; /* *clzdi2 */
      if (!(
#line 121 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADBB) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 886; /* *th_clzdi2 */

    case 2:
      if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33149; /* pred_vclzrvvm8qi */

    case 3:
      if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33152; /* pred_vclzrvvm4qi */

    case 4:
      if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33155; /* pred_vclzrvvm2qi */

    case 5:
      if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33158; /* pred_vclzrvvm1qi */

    case 6:
      if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33161; /* pred_vclzrvvm8hi */

    case 7:
      if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33164; /* pred_vclzrvvm4hi */

    case 8:
      if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33167; /* pred_vclzrvvm2hi */

    case 9:
      if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33170; /* pred_vclzrvvm1hi */

    case 10:
      if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33173; /* pred_vclzrvvm8si */

    case 11:
      if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33176; /* pred_vclzrvvm4si */

    case 12:
      if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33179; /* pred_vclzrvvm2si */

    case 13:
      if (!
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB))
        return -1;
      return 33182; /* pred_vclzrvvm1si */

    case 14:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33185; /* pred_vclzrvvm8di */

    case 15:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33188; /* pred_vclzrvvm4di */

    case 16:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33191; /* pred_vclzrvvm2di */

    case 17:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33194; /* pred_vclzrvvm1di */

    case 18:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 33197; /* pred_vclzrvvmf2qi */

    case 19:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 33200; /* pred_vclzrvvmf4qi */

    case 20:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 33203; /* pred_vclzrvvmf8qi */

    case 21:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)))
        return -1;
      return 33206; /* pred_vclzrvvmf2hi */

    case 22:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 33209; /* pred_vclzrvvmf4hi */

    case 23:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
        return -1;
      return 33212; /* pred_vclzrvvmf2si */

    case 24:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return -1;
      return 33215; /* pred_vclzv1qi */

    case 25:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))))
        return -1;
      return 33218; /* pred_vclzv2qi */

    case 26:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))))
        return -1;
      return 33221; /* pred_vclzv4qi */

    case 27:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))))
        return -1;
      return 33224; /* pred_vclzv8qi */

    case 28:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))))
        return -1;
      return 33227; /* pred_vclzv16qi */

    case 29:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))))
        return -1;
      return 33230; /* pred_vclzv32qi */

    case 30:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33233; /* pred_vclzv64qi */

    case 31:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33236; /* pred_vclzv128qi */

    case 32:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33239; /* pred_vclzv256qi */

    case 33:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33242; /* pred_vclzv512qi */

    case 34:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33245; /* pred_vclzv1024qi */

    case 35:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33248; /* pred_vclzv2048qi */

    case 36:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33251; /* pred_vclzv4096qi */

    case 37:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))))
        return -1;
      return 33254; /* pred_vclzv1hi */

    case 38:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return -1;
      return 33257; /* pred_vclzv2hi */

    case 39:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))))
        return -1;
      return 33260; /* pred_vclzv4hi */

    case 40:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))))
        return -1;
      return 33263; /* pred_vclzv8hi */

    case 41:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))))
        return -1;
      return 33266; /* pred_vclzv16hi */

    case 42:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33269; /* pred_vclzv32hi */

    case 43:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33272; /* pred_vclzv64hi */

    case 44:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33275; /* pred_vclzv128hi */

    case 45:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33278; /* pred_vclzv256hi */

    case 46:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33281; /* pred_vclzv512hi */

    case 47:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33284; /* pred_vclzv1024hi */

    case 48:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33287; /* pred_vclzv2048hi */

    case 49:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))))
        return -1;
      return 33290; /* pred_vclzv1si */

    case 50:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))))
        return -1;
      return 33293; /* pred_vclzv2si */

    case 51:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return -1;
      return 33296; /* pred_vclzv4si */

    case 52:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))))
        return -1;
      return 33299; /* pred_vclzv8si */

    case 53:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33302; /* pred_vclzv16si */

    case 54:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33305; /* pred_vclzv32si */

    case 55:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33308; /* pred_vclzv64si */

    case 56:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33311; /* pred_vclzv128si */

    case 57:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33314; /* pred_vclzv256si */

    case 58:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33317; /* pred_vclzv512si */

    case 59:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33320; /* pred_vclzv1024si */

    case 60:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33323; /* pred_vclzv1di */

    case 61:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33326; /* pred_vclzv2di */

    case 62:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return -1;
      return 33329; /* pred_vclzv4di */

    case 63:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)))
        return -1;
      return 33332; /* pred_vclzv8di */

    case 64:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)))
        return -1;
      return 33335; /* pred_vclzv16di */

    case 65:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)))
        return -1;
      return 33338; /* pred_vclzv32di */

    case 66:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)))
        return -1;
      return 33341; /* pred_vclzv64di */

    case 67:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)))
        return -1;
      return 33344; /* pred_vclzv128di */

    case 68:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)))
        return -1;
      return 33347; /* pred_vclzv256di */

    case 69:
      if (!(
#line 359 "../../gcc/config/riscv/vector-crypto.md"
(TARGET_ZVBB) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)))
        return -1;
      return 33350; /* pred_vclzv512di */

    default:
      return -1;
    }
}

 int
recog_1504 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      res = recog_377 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PC:
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (register_operand (operands[0], E_SImode)
              && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))
            return 442; /* indirect_jumpsi */
          break;

        case E_DImode:
          if (register_operand (operands[0], E_DImode)
              && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))
            return 443; /* indirect_jumpdi */
          break;

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      res = recog_378 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case LABEL_REF:
      if (GET_CODE (x2) != PC)
        return -1;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      return 441; /* jump */

    case MEM:
      operands[0] = x2;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          if (pcrel_symbol_operand (operands[1], E_VOIDmode)
              && 
#line 4542 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT && riscv_cmodel == CM_LARGE))
            return 490; /* *large_load_address */
          if (!absolute_symbolic_operand (operands[1], E_VOIDmode)
              || !(
#line 28 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 808; /* *local_pic_loaddi */

        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !absolute_symbolic_operand (operands[1], E_VOIDmode)
              || !
#line 28 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 805; /* *local_pic_loadqi */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !absolute_symbolic_operand (operands[1], E_VOIDmode)
              || !
#line 28 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 806; /* *local_pic_loadhi */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !absolute_symbolic_operand (operands[1], E_VOIDmode)
              || !
#line 28 "../../gcc/config/riscv/pic.md"
(USE_LOAD_ADDRESS_MACRO (operands[1])))
            return -1;
          return 807; /* *local_pic_loadsi */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !absolute_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          if (pnum_clobbers != NULL)
            {
              if ((
#line 56 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 110 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
                {
                  *pnum_clobbers = 1;
                  return 827; /* *local_pic_loadsf */
                }
              if ((
#line 56 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 110 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
                {
                  *pnum_clobbers = 1;
                  return 830; /* *local_pic_loadsf */
                }
              if ((
#line 72 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 110 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
                {
                  *pnum_clobbers = 1;
                  return 833; /* *local_pic_load_32dsf */
                }
              if ((
#line 72 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 110 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
                {
                  *pnum_clobbers = 1;
                  return 836; /* *local_pic_load_32dsf */
                }
            }
          if (
#line 81 "../../gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])))
            return 839; /* *local_pic_load_sfsf */
          if (pnum_clobbers == NULL)
            return -1;
          if ((
#line 118 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 110 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            {
              *pnum_clobbers = 1;
              return 856; /* *local_pic_store_32dsf */
            }
          if (!(
#line 118 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 110 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            return -1;
          *pnum_clobbers = 1;
          return 859; /* *local_pic_store_32dsf */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !absolute_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          if (pnum_clobbers != NULL)
            {
              if ((
#line 56 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 111 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
                {
                  *pnum_clobbers = 1;
                  return 828; /* *local_pic_loaddf */
                }
              if ((
#line 56 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 111 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
                {
                  *pnum_clobbers = 1;
                  return 831; /* *local_pic_loaddf */
                }
              if ((
#line 72 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 111 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
                {
                  *pnum_clobbers = 1;
                  return 834; /* *local_pic_load_32ddf */
                }
              if ((
#line 72 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 111 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
                {
                  *pnum_clobbers = 1;
                  return 837; /* *local_pic_load_32ddf */
                }
            }
          if ((
#line 81 "../../gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 115 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 840; /* *local_pic_load_sfdf */
          if (pnum_clobbers == NULL)
            return -1;
          if ((
#line 118 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 111 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            {
              *pnum_clobbers = 1;
              return 857; /* *local_pic_store_32ddf */
            }
          if (!(
#line 118 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 111 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            return -1;
          *pnum_clobbers = 1;
          return 860; /* *local_pic_store_32ddf */

        case E_HFmode:
          if (!register_operand (operands[0], E_HFmode)
              || GET_MODE (x3) != E_HFmode
              || !absolute_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          if (pnum_clobbers != NULL)
            {
              if ((
#line 56 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 112 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
                {
                  *pnum_clobbers = 1;
                  return 829; /* *local_pic_loadhf */
                }
              if ((
#line 56 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (!TARGET_DOUBLE_FLOAT || TARGET_64BIT)) && (
#line 112 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
                {
                  *pnum_clobbers = 1;
                  return 832; /* *local_pic_loadhf */
                }
              if ((
#line 72 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 112 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
                {
                  *pnum_clobbers = 1;
                  return 835; /* *local_pic_load_32dhf */
                }
              if ((
#line 72 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 112 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
                {
                  *pnum_clobbers = 1;
                  return 838; /* *local_pic_load_32dhf */
                }
            }
          if ((
#line 81 "../../gcc/config/riscv/pic.md"
(!TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])) && 
#line 115 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN)))
            return 841; /* *local_pic_load_sfhf */
          if (pnum_clobbers == NULL)
            return -1;
          if ((
#line 118 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 112 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode))))
            {
              *pnum_clobbers = 1;
              return 858; /* *local_pic_store_32dhf */
            }
          if (!(
#line 118 "../../gcc/config/riscv/pic.md"
(TARGET_HARD_FLOAT && USE_LOAD_ADDRESS_MACRO (operands[1])
   && (TARGET_DOUBLE_FLOAT && !TARGET_64BIT)) && (
#line 112 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFHMIN || TARGET_ZHINXMIN) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode))))
            return -1;
          *pnum_clobbers = 1;
          return 861; /* *local_pic_store_32dhf */

        default:
          return -1;
        }

    case REG:
      operands[0] = x2;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (REGNO (x3))
        {
        case 69:
          if (!
#line 1136 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 2725; /* frrmsi */

        case 66:
          if (!
#line 8313 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR))
            return -1;
          return 21063; /* read_vlsi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1512 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (equality_operator (x4, E_VOIDmode))
    {
      switch (pattern419 (x3))
        {
        case 0:
          if (shifted_const_arith_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && (
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 338; /* *branchqi_shiftedarith_equals_zero */
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && (
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 341; /* *branchqi_shiftedarith_equals_zero */
                  break;

                default:
                  break;
                }
            }
          if (consecutive_bits_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && (
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 361; /* *branchqi_shiftedmask_equals_zero */
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && (
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 365; /* *branchqi_shiftedmask_equals_zero */
                  break;

                default:
                  break;
                }
            }
          break;

        case 1:
          if (shifted_const_arith_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && (
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 339; /* *branchhi_shiftedarith_equals_zero */
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && (
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 342; /* *branchhi_shiftedarith_equals_zero */
                  break;

                default:
                  break;
                }
            }
          if (consecutive_bits_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && (
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 362; /* *branchhi_shiftedmask_equals_zero */
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && (
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 366; /* *branchhi_shiftedmask_equals_zero */
                  break;

                default:
                  break;
                }
            }
          break;

        case 2:
          if (shifted_const_arith_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && (
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 340; /* *branchsi_shiftedarith_equals_zero */
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && (
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 343; /* *branchsi_shiftedarith_equals_zero */
                  break;

                default:
                  break;
                }
            }
          if (consecutive_bits_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && (
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 363; /* *branchsi_shiftedmask_equals_zero */
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && (
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 367; /* *branchsi_shiftedmask_equals_zero */
                  break;

                default:
                  break;
                }
            }
          break;

        case 3:
          if (shifted_const_arith_operand (operands[3], E_VOIDmode)
              && scratch_operand (operands[4], E_DImode)
              && (
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return 344; /* *branchdi_shiftedarith_equals_zero */
          if (consecutive_bits_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && (
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && ((((
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
                    return 364; /* *branchdi_shiftedmask_equals_zero */
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && (
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 368; /* *branchdi_shiftedmask_equals_zero */
                  break;

                default:
                  break;
                }
            }
          break;

        case 4:
          x5 = XEXP (x4, 0);
          x6 = XEXP (x5, 1);
          if (XWINT (x6, 0) == 1L)
            {
              switch (pattern465 (x3))
                {
                case 0:
                  if (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
                    return 383; /* *branch_on_bitsi */
                  break;

                case 1:
                  if (
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                    return 384; /* *branch_on_bitdi */
                  break;

                case 2:
                  if ((
#line 1145 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return 653; /* *branchsi_bext */
                  break;

                case 3:
                  if ((
#line 1145 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return 654; /* *branchdi_bext */
                  break;

                default:
                  break;
                }
            }
          x7 = XEXP (x5, 2);
          if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (pattern466 (x3))
                {
                case 0:
                  if (
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))
                    return 385; /* *branch_on_bit_rangesi */
                  break;

                case 1:
                  if (
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))
                    return 386; /* *branch_on_bit_rangedi */
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
    }
  if (!ne_operator (x4, E_VOIDmode))
    return -1;
  switch (pattern411 (x3))
    {
    case 0:
      if (!(
#line 3408 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
        return -1;
      return 377; /* *cbranchsf4 */

    case 1:
      if (!(
#line 3408 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
        return -1;
      return 378; /* *cbranchsf4 */

    case 2:
      if (!(
#line 3408 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
        return -1;
      return 379; /* *cbranchdf4 */

    case 3:
      if (!(
#line 3408 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
        return -1;
      return 380; /* *cbranchdf4 */

    case 4:
      if (!(
#line 3408 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))))
        return -1;
      return 381; /* *cbranchhf4 */

    case 5:
      if (!(
#line 3408 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))))
        return -1;
      return 382; /* *cbranchhf4 */

    default:
      return -1;
    }
}

 int
recog_1526 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_1525 (x1, insn, pnum_clobbers);

    case SIMPLE_RETURN:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != USE)
        return -1;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (!pmode_register_operand (operands[0], E_VOIDmode))
        return -1;
      return 450; /* simple_return_internal */

    case UNSPEC:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 0)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[0] = x5;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !scratch_operand (operands[1], E_SImode)
              || !
#line 3886 "../../gcc/config/riscv/riscv.md"
(! TARGET_64BIT))
            return -1;
          return 451; /* eh_set_lr_si */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !scratch_operand (operands[1], E_DImode)
              || !
#line 3893 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          return 452; /* eh_set_lr_di */

        default:
          return -1;
        }

    case CALL:
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (pattern272 (x3) != 0)
        return -1;
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      if (!call_insn_operand (operands[0], E_VOIDmode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[1] = x8;
      x4 = XEXP (x3, 0);
      x9 = XVECEXP (x4, 0, 0);
      operands[2] = x9;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      if (
#line 3942 "../../gcc/config/riscv/riscv.md"
(SIBLING_CALL_P (insn)))
        return 454; /* sibcall_internal */
      if (pnum_clobbers == NULL)
        return -1;
      *pnum_clobbers = 1;
      return 456; /* call_internal */

    case RETURN:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != UNSPEC_VOLATILE
          || XVECLEN (x3, 0) != 1)
        return -1;
      x10 = XVECEXP (x3, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (XINT (x3, 1))
        {
        case 7:
          return 470; /* riscv_mret */

        case 8:
          return 471; /* riscv_sret */

        case 9:
          return 472; /* riscv_uret */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1528 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case SUBREG:
    case MEM:
      operands[1] = x4;
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != UNSPEC_VOLATILE
          || XVECLEN (x5, 0) != 2)
        return -1;
      x6 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x5) != E_SImode)
        return -1;
      x8 = XVECEXP (x5, 0, 1);
      operands[3] = x8;
      x9 = XVECEXP (x1, 0, 2);
      operands[4] = x9;
      x10 = XVECEXP (x1, 0, 3);
      operands[5] = x10;
      if (!register_operand (operands[5], E_SImode))
        return -1;
      x11 = XEXP (x6, 0);
      operands[7] = x11;
      if (!scratch_operand (operands[7], E_SImode))
        return -1;
      x12 = XEXP (x3, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      switch (XINT (x5, 1))
        {
        case 83:
          x13 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x13) != CLOBBER)
            return -1;
          x14 = XVECEXP (x5, 0, 0);
          if (GET_MODE (x14) != E_SImode
              || !const_int_operand (operands[3], E_SImode)
              || !register_operand (operands[4], E_SImode))
            return -1;
          x15 = XEXP (x13, 0);
          operands[6] = x15;
          if (!scratch_operand (operands[6], E_SImode))
            return -1;
          switch (pattern577 (x14))
            {
            case 0:
              if (!
#line 217 "../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              return 760; /* subword_atomic_fetch_strong_add */

            case 1:
              if (!
#line 217 "../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              return 761; /* subword_atomic_fetch_strong_or */

            case 2:
              if (!
#line 217 "../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              return 762; /* subword_atomic_fetch_strong_xor */

            case 3:
              if (!
#line 217 "../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              return 763; /* subword_atomic_fetch_strong_and */

            case 4:
              if (!
#line 284 "../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
                return -1;
              return 764; /* subword_atomic_fetch_strong_nand */

            default:
              return -1;
            }

        case 81:
          x14 = XVECEXP (x5, 0, 0);
          operands[2] = x14;
          if (!reg_or_0_operand (operands[2], E_SImode)
              || !reg_or_0_operand (operands[3], E_SImode)
              || !const_int_operand (operands[4], E_SImode))
            return -1;
          x13 = XVECEXP (x1, 0, 4);
          operands[6] = x13;
          if (!register_operand (operands[6], E_SImode)
              || !
#line 778 "../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
            return -1;
          return 786; /* subword_atomic_cas_strong */

        default:
          return -1;
        }

    case PLUS:
      if (pattern274 (x1) != 0)
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      x16 = XEXP (x9, 0);
      if (GET_CODE (x16) != REG)
        return -1;
      x17 = XEXP (x4, 1);
      operands[0] = x17;
      x5 = XEXP (x3, 1);
      x18 = XEXP (x5, 0);
      x19 = XEXP (x18, 1);
      switch (XWINT (x19, 0))
        {
        case -4L:
          switch (pattern539 (x1, 
E_SImode, 
-20, 
-16, 
-12, 
-8))
            {
            case 0:
              if (!(
#line 102 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33813; /* gpr_multi_pop_up_to_s3_si */

            case 1:
              if (!(
#line 398 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33833; /* gpr_multi_popret_up_to_s1_si */

            case 2:
              if (!(
#line 723 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33853; /* gpr_multi_popretz_up_to_ra_si */

            default:
              return -1;
            }

        case -8L:
          switch (pattern539 (x1, 
E_DImode, 
-40, 
-32, 
-24, 
-16))
            {
            case 0:
              if (!(
#line 102 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33814; /* gpr_multi_pop_up_to_s3_di */

            case 1:
              if (!(
#line 398 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33834; /* gpr_multi_popret_up_to_s1_di */

            case 2:
              if (!(
#line 723 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33854; /* gpr_multi_popretz_up_to_ra_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      if (pattern275 (x1, 
9, 
18, 
19) != 0
          || pattern674 (x1, 
8) != 0)
        return -1;
      x13 = XVECEXP (x1, 0, 4);
      if (pattern735 (x13, 
1) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x6) != SET)
        return -1;
      x20 = XEXP (x6, 1);
      if (GET_CODE (x20) != PLUS)
        return -1;
      x21 = XEXP (x20, 0);
      if (GET_CODE (x21) != REG
          || REGNO (x21) != 2)
        return -1;
      x11 = XEXP (x6, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 2)
        return -1;
      x22 = XEXP (x20, 1);
      operands[0] = x22;
      if (!stack_push_up_to_s3_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern746 (x1))
        {
        case 0:
          if (pattern749 (x1, 
E_SImode) != 0
              || !(
#line 1185 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33885; /* gpr_multi_push_up_to_s3_si */

        case 1:
          if (pattern749 (x1, 
E_DImode) != 0
              || !(
#line 1185 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33886; /* gpr_multi_push_up_to_s3_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1532 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case SUBREG:
    case MEM:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x4;
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      if (pattern375 (x5, 
81, 
2, 
UNSPEC_VOLATILE) != 0)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      if (!reg_or_0_operand (operands[2], E_SImode))
        return -1;
      x8 = XVECEXP (x5, 0, 1);
      operands[3] = x8;
      if (!reg_or_0_operand (operands[3], E_SImode))
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      operands[4] = x9;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      operands[5] = x10;
      if (!register_operand (operands[5], E_SImode))
        return -1;
      x11 = XVECEXP (x1, 0, 4);
      operands[6] = x11;
      if (!register_operand (operands[6], E_SImode))
        return -1;
      x12 = XEXP (x3, 0);
      if (!rtx_equal_p (x12, operands[1])
          || !
#line 778 "../../gcc/config/riscv/sync.md"
(TARGET_ZALRSC && TARGET_INLINE_SUBWORD_ATOMIC))
        return -1;
      *pnum_clobbers = 1;
      return 786; /* subword_atomic_cas_strong */

    case PLUS:
      if (pattern274 (x1) != 0)
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      if (pattern463 (x9) != 0)
        return -1;
      x13 = XEXP (x4, 1);
      operands[0] = x13;
      x5 = XEXP (x3, 1);
      x14 = XEXP (x5, 0);
      x15 = XEXP (x14, 1);
      switch (XWINT (x15, 0))
        {
        case -4L:
          x16 = XEXP (x9, 1);
          x17 = XEXP (x16, 0);
          x18 = XEXP (x17, 1);
          if (XWINT (x18, 0) != -8L)
            return -1;
          switch (pattern628 (x1, 
E_SImode, 
-16, 
-12))
            {
            case 0:
              if (!(
#line 79 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33811; /* gpr_multi_pop_up_to_s2_si */

            case 1:
              if (!(
#line 379 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33831; /* gpr_multi_popret_up_to_s0_si */

            default:
              return -1;
            }

        case -8L:
          x16 = XEXP (x9, 1);
          x17 = XEXP (x16, 0);
          x18 = XEXP (x17, 1);
          if (XWINT (x18, 0) != -16L)
            return -1;
          switch (pattern628 (x1, 
E_DImode, 
-32, 
-24))
            {
            case 0:
              if (!(
#line 79 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33812; /* gpr_multi_pop_up_to_s2_di */

            case 1:
              if (!(
#line 379 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33832; /* gpr_multi_popret_up_to_s0_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      if (pattern275 (x1, 
8, 
9, 
18) != 0)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      if (pattern675 (x10, 
1) != 0)
        return -1;
      x11 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x11) != SET)
        return -1;
      x19 = XEXP (x11, 1);
      if (GET_CODE (x19) != PLUS)
        return -1;
      x20 = XEXP (x19, 0);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 2)
        return -1;
      x21 = XEXP (x11, 0);
      if (GET_CODE (x21) != REG
          || REGNO (x21) != 2)
        return -1;
      x22 = XEXP (x19, 1);
      operands[0] = x22;
      if (!stack_push_up_to_s2_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern736 (x1))
        {
        case 0:
          x23 = XEXP (x10, 0);
          x24 = XEXP (x23, 0);
          x25 = XEXP (x24, 1);
          if (XWINT (x25, 0) != -16L
              || pattern744 (x1, 
E_SImode) != 0
              || !(
#line 1162 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33883; /* gpr_multi_push_up_to_s2_si */

        case 1:
          x23 = XEXP (x10, 0);
          x24 = XEXP (x23, 0);
          x25 = XEXP (x24, 1);
          if (XWINT (x25, 0) != -32L
              || pattern744 (x1, 
E_DImode) != 0
              || !(
#line 1162 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33884; /* gpr_multi_push_up_to_s2_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1534 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  if (pattern112 (x1, 
SET) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 2)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 2)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (pattern394 (x6) != 0)
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      if (pattern463 (x7) != 0)
        return -1;
      x8 = XVECEXP (x1, 0, 3);
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG)
        return -1;
      x10 = XEXP (x3, 1);
      operands[0] = x10;
      x11 = XEXP (x6, 1);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      switch (XWINT (x13, 0))
        {
        case -4L:
          x14 = XEXP (x7, 1);
          x15 = XEXP (x14, 0);
          x16 = XEXP (x15, 1);
          if (XWINT (x16, 0) != -8L)
            return -1;
          switch (pattern676 (x1, 
E_SImode, 
-24, 
-20, 
-16, 
-12))
            {
            case 0:
              if (!(
#line 128 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33815; /* gpr_multi_pop_up_to_s4_si */

            case 1:
              if (!(
#line 420 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33835; /* gpr_multi_popret_up_to_s2_si */

            case 2:
              if (!(
#line 742 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33855; /* gpr_multi_popretz_up_to_s0_si */

            default:
              return -1;
            }

        case -8L:
          x14 = XEXP (x7, 1);
          x15 = XEXP (x14, 0);
          x16 = XEXP (x15, 1);
          if (XWINT (x16, 0) != -16L)
            return -1;
          switch (pattern676 (x1, 
E_DImode, 
-48, 
-40, 
-32, 
-24))
            {
            case 0:
              if (!(
#line 128 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33816; /* gpr_multi_pop_up_to_s4_di */

            case 1:
              if (!(
#line 420 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33836; /* gpr_multi_popret_up_to_s2_di */

            case 2:
              if (!(
#line 742 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33856; /* gpr_multi_popretz_up_to_s0_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      if (REGNO (x3) != 20)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != MEM)
        return -1;
      x17 = XEXP (x5, 0);
      if (GET_CODE (x17) != PLUS)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != REG
          || REGNO (x18) != 2)
        return -1;
      x19 = XEXP (x17, 1);
      if (GET_CODE (x19) != CONST_INT)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x11 = XEXP (x6, 1);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 19)
        return -1;
      x20 = XEXP (x6, 0);
      if (GET_CODE (x20) != MEM)
        return -1;
      x21 = XEXP (x20, 0);
      if (GET_CODE (x21) != PLUS)
        return -1;
      x22 = XEXP (x21, 0);
      if (GET_CODE (x22) != REG
          || REGNO (x22) != 2)
        return -1;
      x23 = XEXP (x21, 1);
      if (GET_CODE (x23) != CONST_INT)
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      if (pattern553 (x7, 
18) != 0
          || pattern674 (x1, 
9) != 0
          || pattern737 (x1, 
8) != 0)
        return -1;
      x24 = XVECEXP (x1, 0, 5);
      if (pattern740 (x24, 
1) != 0)
        return -1;
      x25 = XVECEXP (x1, 0, 6);
      if (GET_CODE (x25) != SET)
        return -1;
      x26 = XEXP (x25, 1);
      if (GET_CODE (x26) != PLUS)
        return -1;
      x27 = XEXP (x26, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 2)
        return -1;
      x28 = XEXP (x25, 0);
      if (GET_CODE (x28) != REG
          || REGNO (x28) != 2)
        return -1;
      x29 = XEXP (x26, 1);
      operands[0] = x29;
      if (!stack_push_up_to_s4_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern746 (x1))
        {
        case 0:
          x30 = XEXP (x24, 0);
          x31 = XEXP (x30, 0);
          x32 = XEXP (x31, 1);
          if (XWINT (x32, 0) != -24L
              || pattern758 (x1, 
E_SImode) != 0
              || !(
#line 1211 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33887; /* gpr_multi_push_up_to_s4_si */

        case 1:
          x30 = XEXP (x24, 0);
          x31 = XEXP (x30, 0);
          x32 = XEXP (x31, 1);
          if (XWINT (x32, 0) != -48L
              || pattern758 (x1, 
E_DImode) != 0
              || !(
#line 1211 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33888; /* gpr_multi_push_up_to_s4_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1537 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46;
  int res ATTRIBUTE_UNUSED;
  if (pattern114 (x1) != 0)
    return -1;
  switch (pattern396 (x1, 
22, 
23))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 6);
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG)
        return -1;
      switch (pattern743 (x1))
        {
        case 0:
          switch (pattern748 (x1, 
-24, 
E_SImode, 
-28))
            {
            case 0:
              x4 = XVECEXP (x1, 0, 7);
              if (GET_CODE (x4) != SET)
                return -1;
              x5 = XEXP (x4, 1);
              if (GET_CODE (x5) != MEM
                  || GET_MODE (x5) != E_SImode)
                return -1;
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) != PLUS
                  || GET_MODE (x6) != E_SImode)
                return -1;
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 2
                  || GET_MODE (x7) != E_SImode)
                return -1;
              x8 = XEXP (x6, 1);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + -28])
                return -1;
              x9 = XEXP (x4, 0);
              if (GET_CODE (x9) != REG
                  || REGNO (x9) != 9
                  || GET_MODE (x9) != E_SImode
                  || pattern779 (x1, 
8) != 0)
                return -1;
              x10 = XVECEXP (x1, 0, 9);
              x11 = XEXP (x10, 0);
              if (pattern787 (x11, 
E_SImode) != 0
                  || !(
#line 224 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33821; /* gpr_multi_pop_up_to_s7_si */

            case 1:
              if (!(
#line 504 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33841; /* gpr_multi_popret_up_to_s5_si */

            case 2:
              if (!(
#line 817 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                return -1;
              return 33861; /* gpr_multi_popretz_up_to_s3_si */

            default:
              return -1;
            }

        case 1:
          switch (pattern748 (x1, 
-48, 
E_DImode, 
-56))
            {
            case 0:
              x4 = XVECEXP (x1, 0, 7);
              if (GET_CODE (x4) != SET)
                return -1;
              x5 = XEXP (x4, 1);
              if (GET_CODE (x5) != MEM
                  || GET_MODE (x5) != E_DImode)
                return -1;
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) != PLUS
                  || GET_MODE (x6) != E_DImode)
                return -1;
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 2
                  || GET_MODE (x7) != E_DImode)
                return -1;
              x8 = XEXP (x6, 1);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + -56])
                return -1;
              x9 = XEXP (x4, 0);
              if (GET_CODE (x9) != REG
                  || REGNO (x9) != 9
                  || GET_MODE (x9) != E_DImode)
                return -1;
              x12 = XVECEXP (x1, 0, 8);
              if (GET_CODE (x12) != SET)
                return -1;
              x13 = XEXP (x12, 1);
              if (GET_CODE (x13) != MEM
                  || GET_MODE (x13) != E_DImode)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != PLUS
                  || GET_MODE (x14) != E_DImode)
                return -1;
              x15 = XEXP (x14, 0);
              if (GET_CODE (x15) != REG
                  || REGNO (x15) != 2
                  || GET_MODE (x15) != E_DImode)
                return -1;
              x16 = XEXP (x14, 1);
              if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + -64])
                return -1;
              x17 = XEXP (x12, 0);
              if (GET_CODE (x17) != REG
                  || REGNO (x17) != 8
                  || GET_MODE (x17) != E_DImode)
                return -1;
              x10 = XVECEXP (x1, 0, 9);
              if (GET_CODE (x10) != SET)
                return -1;
              x18 = XEXP (x10, 1);
              if (GET_CODE (x18) != MEM
                  || GET_MODE (x18) != E_DImode)
                return -1;
              x19 = XEXP (x18, 0);
              if (GET_CODE (x19) != PLUS
                  || GET_MODE (x19) != E_DImode)
                return -1;
              x20 = XEXP (x19, 0);
              if (GET_CODE (x20) != REG
                  || REGNO (x20) != 2
                  || GET_MODE (x20) != E_DImode)
                return -1;
              x21 = XEXP (x19, 1);
              if (GET_CODE (x21) != CONST_INT
                  || XWINT (x21, 0) != -72L)
                return -1;
              x11 = XEXP (x10, 0);
              if (pattern787 (x11, 
E_DImode) != 0
                  || !(
#line 224 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33822; /* gpr_multi_pop_up_to_s7_di */

            case 1:
              if (!(
#line 504 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33842; /* gpr_multi_popret_up_to_s5_di */

            case 2:
              if (!(
#line 817 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                return -1;
              return 33862; /* gpr_multi_popretz_up_to_s3_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x22 = XVECEXP (x1, 0, 1);
      x23 = XEXP (x22, 0);
      if (GET_CODE (x23) != MEM)
        return -1;
      x24 = XEXP (x23, 0);
      if (GET_CODE (x24) != PLUS)
        return -1;
      x25 = XEXP (x24, 0);
      if (GET_CODE (x25) != REG
          || REGNO (x25) != 2)
        return -1;
      x26 = XEXP (x24, 1);
      if (GET_CODE (x26) != CONST_INT)
        return -1;
      x27 = XVECEXP (x1, 0, 2);
      x28 = XEXP (x27, 1);
      if (GET_CODE (x28) != REG
          || REGNO (x28) != 21)
        return -1;
      x29 = XEXP (x27, 0);
      if (GET_CODE (x29) != MEM)
        return -1;
      x30 = XEXP (x29, 0);
      if (GET_CODE (x30) != PLUS)
        return -1;
      x31 = XEXP (x30, 0);
      if (GET_CODE (x31) != REG
          || REGNO (x31) != 2)
        return -1;
      x32 = XEXP (x30, 1);
      if (GET_CODE (x32) != CONST_INT)
        return -1;
      x33 = XVECEXP (x1, 0, 3);
      x34 = XEXP (x33, 1);
      if (GET_CODE (x34) != REG
          || REGNO (x34) != 20)
        return -1;
      x35 = XEXP (x33, 0);
      if (GET_CODE (x35) != MEM)
        return -1;
      x36 = XEXP (x35, 0);
      if (GET_CODE (x36) != PLUS)
        return -1;
      x37 = XEXP (x36, 0);
      if (GET_CODE (x37) != REG
          || REGNO (x37) != 2)
        return -1;
      x38 = XEXP (x36, 1);
      if (GET_CODE (x38) != CONST_INT)
        return -1;
      x39 = XVECEXP (x1, 0, 4);
      x40 = XEXP (x39, 1);
      if (GET_CODE (x40) != REG
          || REGNO (x40) != 19)
        return -1;
      x41 = XEXP (x39, 0);
      if (GET_CODE (x41) != MEM)
        return -1;
      x42 = XEXP (x41, 0);
      if (GET_CODE (x42) != PLUS)
        return -1;
      x43 = XEXP (x42, 0);
      if (GET_CODE (x43) != REG
          || REGNO (x43) != 2)
        return -1;
      x44 = XEXP (x42, 1);
      if (GET_CODE (x44) != CONST_INT)
        return -1;
      x45 = XVECEXP (x1, 0, 5);
      if (pattern740 (x45, 
18) != 0
          || pattern747 (x1, 
9) != 0
          || pattern753 (x1, 
8) != 0)
        return -1;
      x12 = XVECEXP (x1, 0, 8);
      if (pattern761 (x12, 
1) != 0)
        return -1;
      x10 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x10) != SET)
        return -1;
      x18 = XEXP (x10, 1);
      if (GET_CODE (x18) != PLUS)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != REG
          || REGNO (x19) != 2)
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 2)
        return -1;
      x46 = XEXP (x18, 1);
      operands[0] = x46;
      if (!stack_push_up_to_s7_operand (operands[0], E_VOIDmode))
        return -1;
      switch (pattern770 (x1))
        {
        case 0:
          if (pattern774 (x1, 
E_SImode) != 0
              || !(
#line 1307 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
            return -1;
          return 33893; /* gpr_multi_push_up_to_s7_si */

        case 1:
          if (pattern774 (x1, 
E_DImode) != 0
              || !(
#line 1307 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
            return -1;
          return 33894; /* gpr_multi_push_up_to_s7_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_1543 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET
      || pattern120 (x1, 
20, 
21, 
22, 
23, 
24) != 0
      || pattern745 (x1, 
1, 
8, 
9, 
18, 
19) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 10)
    return -1;
  x6 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 10)
    return -1;
  x8 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x8) != RETURN)
    return -1;
  x9 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x9) != USE)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 1
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XEXP (x2, 1);
  x12 = XEXP (x11, 1);
  operands[0] = x12;
  if (!stack_pop_up_to_s8_operand (operands[0], E_VOIDmode))
    return -1;
  switch (pattern766 (x1))
    {
    case 0:
      x13 = XVECEXP (x1, 0, 10);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -40L
          || pattern786 (x1, 
E_SImode) != 0
          || !(
#line 1002 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
        return -1;
      return 33871; /* gpr_multi_popretz_up_to_s8_si */

    case 1:
      x13 = XVECEXP (x1, 0, 10);
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 1);
      if (XWINT (x16, 0) != -80L
          || pattern786 (x1, 
E_DImode) != 0
          || !(
#line 1002 "../../gcc/config/riscv/zc.md"
(TARGET_ZCMP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
        return -1;
      return 33872; /* gpr_multi_popretz_up_to_s8_di */

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_1544 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_1526 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_1527 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          res = recog_1528 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_1531 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_1532 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 17:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) == UNSPEC_VOLATILE
              && pattern119 (x1, 
USE, 
27) == 0
              && 
#line 253 "../../gcc/config/riscv/thead.md"
(TARGET_XTHEADINT && !TARGET_64BIT))
            return 899; /* th_int_push */
          break;

        case 18:
          res = recog_1533 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 7:
          res = recog_1534 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 8:
          res = recog_1535 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 9:
          res = recog_1536 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 10:
          res = recog_1537 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 11:
          res = recog_1538 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 12:
          res = recog_1539 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 14:
          res = recog_1540 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 13:
          res = recog_1541 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 16:
          res = recog_1542 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 15:
          res = recog_1543 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) < 1)
        return -1;
      operands[1] = x1;
      if (!gpr_save_operation (operands[1], E_VOIDmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != UNSPEC_VOLATILE
          || XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[0] = x3;
      if (!const_int_operand (operands[0], E_VOIDmode))
        return -1;
      return 460; /* gpr_save */

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 11:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 293; /* fence */

            case 12:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !
#line 2853 "../../gcc/config/riscv/riscv.md"
(TARGET_ZIFENCEI))
                return -1;
              return 294; /* fence_i */

            case 18:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 295; /* riscv_pause */

            case 10:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 448; /* blockage */

            case 1:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              return 461; /* gpr_restore */

            case 3:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 4108 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
                return -1;
              return 464; /* riscv_fscsr */

            case 5:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!csr_operand (operands[0], E_SImode)
                  || !
#line 4121 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
                return -1;
              return 466; /* riscv_fsflags */

            case 13:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (x1))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !(
#line 4354 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 479; /* riscv_clean_si */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 4354 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 480; /* riscv_clean_di */

                default:
                  return -1;
                }

            case 14:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (x1))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !(
#line 4362 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 481; /* riscv_flush_si */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 4362 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 482; /* riscv_flush_di */

                default:
                  return -1;
                }

            case 15:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (x1))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !(
#line 4370 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 483; /* riscv_inval_si */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 4370 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOM) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 484; /* riscv_inval_di */

                default:
                  return -1;
                }

            case 16:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (x1))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !(
#line 4378 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOZ) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 485; /* riscv_zero_si */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 4378 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOZ) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 486; /* riscv_zero_di */

                default:
                  return -1;
                }

            case 19:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!x1x5_operand (operands[0], E_SImode)
                      || !(
#line 4752 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICFISS) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 494; /* sspushsi */

                case E_DImode:
                  if (!x1x5_operand (operands[0], E_DImode)
                      || !(
#line 4752 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICFISS) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 495; /* sspushdi */

                default:
                  return -1;
                }

            case 20:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!x1x5_operand (operands[0], E_SImode)
                      || !(
#line 4759 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICFISS) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 496; /* sspopchksi */

                case E_DImode:
                  if (!x1x5_operand (operands[0], E_DImode)
                      || !(
#line 4759 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICFISS) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 497; /* sspopchkdi */

                default:
                  return -1;
                }

            case 22:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !(
#line 4774 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICFISS) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == SImode)))
                    return -1;
                  return 500; /* write_sspsi */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 4774 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICFISS) && 
#line 35 "../../gcc/config/riscv/iterators.md"
(Pmode == DImode)))
                    return -1;
                  return 501; /* write_sspdi */

                default:
                  return -1;
                }

            case 23:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!immediate_operand (operands[0], E_VOIDmode)
                  || !
#line 4783 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICFILP))
                return -1;
              return 502; /* lpad */

            case 25:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !
#line 4797 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICFILP))
                return -1;
              return 505; /* lpad_align */

            default:
              return -1;
            }

        case 2:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          x4 = XVECEXP (x1, 0, 1);
          operands[1] = x4;
          switch (XINT (x1, 1))
            {
            case 6:
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (!register_operand (operands[0], E_SFmode)
                      || !register_operand (operands[1], E_SFmode)
                      || !
#line 4129 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX))
                    return -1;
                  return 467; /* *riscv_fsnvsnansf2 */

                case E_DFmode:
                  if (!register_operand (operands[0], E_DFmode)
                      || !register_operand (operands[1], E_DFmode)
                      || !(
#line 4129 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX)))
                    return -1;
                  return 468; /* *riscv_fsnvsnandf2 */

                case E_HFmode:
                  if (!register_operand (operands[0], E_HFmode)
                      || !register_operand (operands[1], E_HFmode)
                      || !(
#line 4129 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX)))
                    return -1;
                  return 469; /* *riscv_fsnvsnanhf2 */

                default:
                  return -1;
                }

            case 17:
              switch (GET_MODE (x1))
                {
                case E_SImode:
                  if (!address_operand (operands[0], E_SImode)
                      || !imm5_operand (operands[1], E_SImode)
                      || !(
#line 4407 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return -1;
                  return 488; /* riscv_prefetchi_si */

                case E_DImode:
                  if (!address_operand (operands[0], E_DImode)
                      || !imm5_operand (operands[1], E_DImode)
                      || !(
#line 4407 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOP) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return -1;
                  return 489; /* riscv_prefetchi_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIMPLE_RETURN:
      return 449; /* simple_return */

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 0)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[0] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !
#line 3886 "../../gcc/config/riscv/riscv.md"
(! TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 451; /* eh_set_lr_si */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !
#line 3893 "../../gcc/config/riscv/riscv.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 452; /* eh_set_lr_di */

        default:
          return -1;
        }

    case EH_RETURN:
      return 453; /* eh_return_internal */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 458; /* nop */

    case TRAP_IF:
      x5 = XEXP (x1, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x1, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 459; /* trap */

    case PREFETCH:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!address_operand (operands[0], E_VOIDmode))
        return -1;
      x6 = XEXP (x1, 1);
      operands[1] = x6;
      if (!imm5_operand (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x1, 2);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 4387 "../../gcc/config/riscv/riscv.md"
(TARGET_ZICBOP))
        return -1;
      return 487; /* prefetch */

    default:
      return -1;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      x4 = XEXP (x2, 0);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (pattern145 (x2))
        {
        case 0:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8133 (insn, operands);

        case 1:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8139 (insn, operands);

        case 2:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8145 (insn, operands);

        case 3:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8151 (insn, operands);

        case 4:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8157 (insn, operands);

        case 5:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8163 (insn, operands);

        case 6:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8169 (insn, operands);

        case 7:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8175 (insn, operands);

        case 8:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8181 (insn, operands);

        case 9:
          if (!(
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8187 (insn, operands);

        case 10:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8193 (insn, operands);

        case 11:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8199 (insn, operands);

        case 12:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8205 (insn, operands);

        case 13:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8211 (insn, operands);

        case 14:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8217 (insn, operands);

        case 15:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8223 (insn, operands);

        case 16:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8229 (insn, operands);

        case 17:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8235 (insn, operands);

        case 18:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8241 (insn, operands);

        case 19:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8247 (insn, operands);

        case 20:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8253 (insn, operands);

        case 21:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8259 (insn, operands);

        case 22:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8265 (insn, operands);

        case 23:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8271 (insn, operands);

        case 24:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8277 (insn, operands);

        case 25:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8283 (insn, operands);

        case 26:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8289 (insn, operands);

        case 27:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8295 (insn, operands);

        case 28:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8301 (insn, operands);

        case 29:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8307 (insn, operands);

        case 30:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8313 (insn, operands);

        case 31:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8319 (insn, operands);

        case 32:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8325 (insn, operands);

        case 33:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8331 (insn, operands);

        case 34:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8337 (insn, operands);

        case 35:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8343 (insn, operands);

        case 36:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8349 (insn, operands);

        case 37:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8355 (insn, operands);

        case 38:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8361 (insn, operands);

        case 39:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8367 (insn, operands);

        case 40:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8373 (insn, operands);

        case 41:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8379 (insn, operands);

        case 42:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8385 (insn, operands);

        case 43:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8391 (insn, operands);

        case 44:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8397 (insn, operands);

        case 45:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8403 (insn, operands);

        case 46:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8409 (insn, operands);

        case 47:
          if (!((
#line 610 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 612 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8415 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      switch (pattern153 (x2))
        {
        case 0:
          if (!(
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8613 (insn, operands);

        case 1:
          if (!(
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8615 (insn, operands);

        case 2:
          if (!(
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8617 (insn, operands);

        case 3:
          if (!(
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8619 (insn, operands);

        case 4:
          if (!(
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8621 (insn, operands);

        case 5:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 946 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8623 (insn, operands);

        case 6:
          if (!(
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8625 (insn, operands);

        case 7:
          if (!(
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8627 (insn, operands);

        case 8:
          if (!(
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8629 (insn, operands);

        case 9:
          if (!(
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8631 (insn, operands);

        case 10:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 948 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8633 (insn, operands);

        case 11:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8635 (insn, operands);

        case 12:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 950 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8637 (insn, operands);

        case 13:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8639 (insn, operands);

        case 14:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 951 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8641 (insn, operands);

        case 15:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 953 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8643 (insn, operands);

        case 16:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 954 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8645 (insn, operands);

        case 17:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 955 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8647 (insn, operands);

        case 18:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 956 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8649 (insn, operands);

        case 19:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 957 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8651 (insn, operands);

        case 20:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 958 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8653 (insn, operands);

        case 21:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 959 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8655 (insn, operands);

        case 22:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 960 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8657 (insn, operands);

        case 23:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 961 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8659 (insn, operands);

        case 24:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 962 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8661 (insn, operands);

        case 25:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 963 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8663 (insn, operands);

        case 26:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 964 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8665 (insn, operands);

        case 27:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 965 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8667 (insn, operands);

        case 28:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 966 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8669 (insn, operands);

        case 29:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 967 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8671 (insn, operands);

        case 30:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 968 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8673 (insn, operands);

        case 31:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 969 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8675 (insn, operands);

        case 32:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 970 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8677 (insn, operands);

        case 33:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 971 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8679 (insn, operands);

        case 34:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 972 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8681 (insn, operands);

        case 35:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 973 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8683 (insn, operands);

        case 36:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 974 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8685 (insn, operands);

        case 37:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 975 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8687 (insn, operands);

        case 38:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 976 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8689 (insn, operands);

        case 39:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 977 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8691 (insn, operands);

        case 40:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 978 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8693 (insn, operands);

        case 41:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 979 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8695 (insn, operands);

        case 42:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 980 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8697 (insn, operands);

        case 43:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 981 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8699 (insn, operands);

        case 44:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 982 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8701 (insn, operands);

        case 45:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 983 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8703 (insn, operands);

        case 46:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 984 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8705 (insn, operands);

        case 47:
          if (!((
#line 675 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 985 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 677 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
            return NULL;
          return gen_split_8707 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_14 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1DFmode)
      && reg_or_mem_operand (operands[1], E_V1DFmode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)))
        return gen_split_313 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1DFmode)
       || register_operand (operands[1], V1DFmode))) && 
#line 4334 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1DFmode)
       || !register_operand (operands[1], V1DFmode)))))
        return gen_split_1977 (insn, operands);
    }
  if (!register_operand (operands[0], E_V1DFmode)
      || !register_operand (operands[1], E_V1DFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2160 (insn, operands);
}

 rtx_insn *
split_18 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2SFmode)
      && reg_or_mem_operand (operands[1], E_V2SFmode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)))
        return gen_split_303 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2SFmode)
       || register_operand (operands[1], V2SFmode))) && 
#line 4330 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V2SFmode)
       || !register_operand (operands[1], V2SFmode)))))
        return gen_split_1973 (insn, operands);
    }
  if (!register_operand (operands[0], E_V2SFmode)
      || !register_operand (operands[1], E_V2SFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2150 (insn, operands);
}

 rtx_insn *
split_22 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4HFmode)
      && reg_or_mem_operand (operands[1], E_V4HFmode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)))
        return gen_split_292 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4HFmode)
       || register_operand (operands[1], V4HFmode))) && 
#line 4326 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4HFmode)
       || !register_operand (operands[1], V4HFmode)))))
        return gen_split_1969 (insn, operands);
    }
  if (!register_operand (operands[0], E_V4HFmode)
      || !register_operand (operands[1], E_V4HFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2139 (insn, operands);
}

 rtx_insn *
split_27 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4DImode)
      && reg_or_mem_operand (operands[1], E_V4DImode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)))
        return gen_split_282 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4DImode)
       || register_operand (operands[1], V4DImode))) && 
#line 4321 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4DImode)
       || !register_operand (operands[1], V4DImode)))))
        return gen_split_1964 (insn, operands);
    }
  if (!register_operand (operands[0], E_V4DImode)
      || !register_operand (operands[1], E_V4DImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2129 (insn, operands);
}

 rtx_insn *
split_32 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V4SImode)
      && reg_or_mem_operand (operands[1], E_V4SImode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))))
        return gen_split_271 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[1], V4SImode))) && 
#line 4316 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V4SImode)
       || !register_operand (operands[1], V4SImode)))))
        return gen_split_1959 (insn, operands);
    }
  if (!register_operand (operands[0], E_V4SImode)
      || !register_operand (operands[1], E_V4SImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2118 (insn, operands);
}

 rtx_insn *
split_38 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2HImode)
      && reg_or_mem_operand (operands[1], E_V2HImode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))))
        return gen_split_258 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V2HImode)
       || register_operand (operands[1], V2HImode))) && 
#line 4310 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V2HImode)
       || !register_operand (operands[1], V2HImode)))))
        return gen_split_1953 (insn, operands);
    }
  if (!register_operand (operands[0], E_V2HImode)
      || !register_operand (operands[1], E_V2HImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2105 (insn, operands);
}

 rtx_insn *
split_44 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1QImode)
      && reg_or_mem_operand (operands[1], E_V1QImode))
    {
      if ((
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))))
        return gen_split_244 (insn, operands);
      if (((
#line 1434 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR
   && (register_operand (operands[0], V1QImode)
       || register_operand (operands[1], V1QImode))) && 
#line 4304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1441 "../../gcc/config/riscv/vector.md"
( reload_completed
   && (!register_operand (operands[0], V1QImode)
       || !register_operand (operands[1], V1QImode)))))
        return gen_split_1947 (insn, operands);
    }
  if (!register_operand (operands[0], E_V1QImode)
      || !register_operand (operands[1], E_V1QImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2091 (insn, operands);
}

 rtx_insn *
split_50 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V512DFmode)
      && reg_or_mem_operand (operands[1], E_V512DFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)))
    return gen_split_322 (insn, operands);
  if (!register_operand (operands[0], E_V512DFmode)
      || !register_operand (operands[1], E_V512DFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2169 (insn, operands);
}

 rtx_insn *
split_55 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1024SFmode)
      && reg_or_mem_operand (operands[1], E_V1024SFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)))
    return gen_split_312 (insn, operands);
  if (!register_operand (operands[0], E_V1024SFmode)
      || !register_operand (operands[1], E_V1024SFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2159 (insn, operands);
}

 rtx_insn *
split_61 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2048HFmode)
      && reg_or_mem_operand (operands[1], E_V2048HFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)))
    return gen_split_301 (insn, operands);
  if (!register_operand (operands[0], E_V2048HFmode)
      || !register_operand (operands[1], E_V2048HFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2148 (insn, operands);
}

 rtx_insn *
split_67 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V32HFmode)
      && reg_or_mem_operand (operands[1], E_V32HFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)))
    return gen_split_295 (insn, operands);
  if (!register_operand (operands[0], E_V32HFmode)
      || !register_operand (operands[1], E_V32HFmode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2142 (insn, operands);
}

 rtx_insn *
split_73 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1024SImode)
      && reg_or_mem_operand (operands[1], E_V1024SImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)))
    return gen_split_279 (insn, operands);
  if (!register_operand (operands[0], E_V1024SImode)
      || !register_operand (operands[1], E_V1024SImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2126 (insn, operands);
}

 rtx_insn *
split_80 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V1024HImode)
      && reg_or_mem_operand (operands[1], E_V1024HImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)))
    return gen_split_267 (insn, operands);
  if (!register_operand (operands[0], E_V1024HImode)
      || !register_operand (operands[1], E_V1024HImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2114 (insn, operands);
}

 rtx_insn *
split_87 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_V2048QImode)
      && reg_or_mem_operand (operands[1], E_V2048QImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)))
    return gen_split_255 (insn, operands);
  if (!register_operand (operands[0], E_V2048QImode)
      || !register_operand (operands[1], E_V2048QImode)
      || !((
#line 1509 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1511 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_2102 (insn, operands);
}

 rtx_insn *
split_94 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVM1BImode)
      && reg_or_mem_operand (operands[1], E_RVVM1BImode)
      && 
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR))
    return gen_split_243 (insn, operands);
  if (!register_operand (operands[0], E_RVVM1BImode)
      || !register_operand (operands[1], E_RVVM1BImode)
      || !(
#line 1294 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR && !TARGET_XTHEADVECTOR) && 
#line 1296 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1580 (insn, operands);
}

 rtx_insn *
split_101 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF2SFmode)
      && reg_or_mem_operand (operands[1], E_RVVMF2SFmode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)))
    return gen_split_232 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF2SFmode)
      || !register_operand (operands[1], E_RVVMF2SFmode)
      || !((
#line 1257 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 942 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 1259 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1573 (insn, operands);
}

 rtx_insn *
split_108 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (reg_or_mem_operand (operands[0], E_RVVMF8QImode)
      && reg_or_mem_operand (operands[1], E_RVVMF8QImode)
      && (
#line 99 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))))
    return gen_split_213 (insn, operands);
  if (!register_operand (operands[0], E_RVVMF8QImode)
      || !register_operand (operands[1], E_RVVMF8QImode)
      || !((
#line 1257 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 932 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1259 "../../gcc/config/riscv/vector.md"
( 1)))
    return NULL;
  return gen_split_1565 (insn, operands);
}

 rtx_insn *
split_115 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      switch (pattern107 (x2))
        {
        case 0:
          if (const_nottwobits_not_arith_operand (operands[2], E_SImode)
              && ((
#line 849 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && !paradoxical_subreg_p (operands[1])) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 851 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return gen_split_165 (insn, operands);
          if (!not_uimm_extra_bit_or_nottwobits (operands[2], E_SImode)
              || !((
#line 1041 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && !not_single_bit_mask_operand (operands[2], VOIDmode)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 1043 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return NULL;
          return gen_split_180 (insn, operands);

        case 1:
          if (const_nottwobits_not_arith_operand (operands[2], E_DImode))
            {
              if (((
#line 849 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && !paradoxical_subreg_p (operands[1])) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 851 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return gen_split_166 (insn, operands);
              if ((
#line 869 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT && TARGET_ZBS
   && clz_hwi (~UINTVAL (operands[2])) > 33) && 
#line 872 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                return gen_split_167 (insn, operands);
            }
          if (not_uimm_extra_bit_or_nottwobits (operands[2], E_DImode)
              && ((
#line 1041 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS && !not_single_bit_mask_operand (operands[2], VOIDmode)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 1043 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
            return gen_split_181 (insn, operands);
          if (!const_int_operand (operands[2], E_VOIDmode)
              || !(
#line 1067 "../../gcc/config/riscv/bitmanip.md"
(TARGET_64BIT
   && TARGET_ZBA
   && !paradoxical_subreg_p (operands[1])
   /* Only profitable if synthesis takes more than one insn.  */
   && riscv_const_insns (operands[2], false) != 1
   /* We need the upper half to be zero.  */
   && (INTVAL (operands[2]) & HOST_WIDE_INT_C (0xffffffff00000000)) == 0
   /* And the the adjusted constant must either be something we can
      implement with andi or bclri.  */
   && ((SMALL_OPERAND (sext_hwi (INTVAL (operands[2]), 32))
        || (TARGET_ZBS && popcount_hwi (INTVAL (operands[2])) == 31))
       && INTVAL (operands[2]) != 0x7fffffff)) && 
#line 1080 "../../gcc/config/riscv/bitmanip.md"
( 1)))
            return NULL;
          return gen_split_182 (insn, operands);

        default:
          return NULL;
        }

    case CONST_VECTOR:
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_RVVM8QImode:
          if (pattern233 (x2, 
E_RVVM8QImode) != 0
              || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2589 (insn, operands);

        case E_RVVM4QImode:
          if (pattern233 (x2, 
E_RVVM4QImode) != 0
              || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2603 (insn, operands);

        case E_RVVM2QImode:
          if (pattern233 (x2, 
E_RVVM2QImode) != 0
              || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2617 (insn, operands);

        case E_RVVM1QImode:
          if (pattern233 (x2, 
E_RVVM1QImode) != 0
              || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2631 (insn, operands);

        case E_RVVM8HImode:
          if (pattern233 (x2, 
E_RVVM8HImode) != 0
              || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2645 (insn, operands);

        case E_RVVM4HImode:
          if (pattern233 (x2, 
E_RVVM4HImode) != 0
              || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2659 (insn, operands);

        case E_RVVM2HImode:
          if (pattern233 (x2, 
E_RVVM2HImode) != 0
              || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2673 (insn, operands);

        case E_RVVM1HImode:
          if (pattern233 (x2, 
E_RVVM1HImode) != 0
              || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2687 (insn, operands);

        case E_RVVM8SImode:
          if (pattern233 (x2, 
E_RVVM8SImode) != 0
              || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2701 (insn, operands);

        case E_RVVM4SImode:
          if (pattern233 (x2, 
E_RVVM4SImode) != 0
              || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2715 (insn, operands);

        case E_RVVM2SImode:
          if (pattern233 (x2, 
E_RVVM2SImode) != 0
              || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2729 (insn, operands);

        case E_RVVM1SImode:
          if (pattern233 (x2, 
E_RVVM1SImode) != 0
              || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2743 (insn, operands);

        case E_RVVM8DImode:
          if (pattern233 (x2, 
E_RVVM8DImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2757 (insn, operands);

        case E_RVVM4DImode:
          if (pattern233 (x2, 
E_RVVM4DImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2771 (insn, operands);

        case E_RVVM2DImode:
          if (pattern233 (x2, 
E_RVVM2DImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2785 (insn, operands);

        case E_RVVM1DImode:
          if (pattern233 (x2, 
E_RVVM1DImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2799 (insn, operands);

        case E_RVVMF2QImode:
          if (pattern233 (x2, 
E_RVVMF2QImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2813 (insn, operands);

        case E_RVVMF4QImode:
          if (pattern233 (x2, 
E_RVVMF4QImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2827 (insn, operands);

        case E_RVVMF8QImode:
          if (pattern233 (x2, 
E_RVVMF8QImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2841 (insn, operands);

        case E_RVVMF2HImode:
          if (pattern233 (x2, 
E_RVVMF2HImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2855 (insn, operands);

        case E_RVVMF4HImode:
          if (pattern233 (x2, 
E_RVVMF4HImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2869 (insn, operands);

        case E_RVVMF2SImode:
          if (pattern233 (x2, 
E_RVVMF2SImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2883 (insn, operands);

        case E_V1QImode:
          if (pattern233 (x2, 
E_V1QImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2897 (insn, operands);

        case E_V2QImode:
          if (pattern233 (x2, 
E_V2QImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2911 (insn, operands);

        case E_V4QImode:
          if (pattern233 (x2, 
E_V4QImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2925 (insn, operands);

        case E_V8QImode:
          if (pattern233 (x2, 
E_V8QImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2939 (insn, operands);

        case E_V16QImode:
          if (pattern233 (x2, 
E_V16QImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2953 (insn, operands);

        case E_V32QImode:
          if (pattern233 (x2, 
E_V32QImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2967 (insn, operands);

        case E_V64QImode:
          if (pattern233 (x2, 
E_V64QImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2981 (insn, operands);

        case E_V128QImode:
          if (pattern233 (x2, 
E_V128QImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_2995 (insn, operands);

        case E_V256QImode:
          if (pattern233 (x2, 
E_V256QImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3009 (insn, operands);

        case E_V512QImode:
          if (pattern233 (x2, 
E_V512QImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3023 (insn, operands);

        case E_V1024QImode:
          if (pattern233 (x2, 
E_V1024QImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3037 (insn, operands);

        case E_V2048QImode:
          if (pattern233 (x2, 
E_V2048QImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3051 (insn, operands);

        case E_V4096QImode:
          if (pattern233 (x2, 
E_V4096QImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3065 (insn, operands);

        case E_V1HImode:
          if (pattern233 (x2, 
E_V1HImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3079 (insn, operands);

        case E_V2HImode:
          if (pattern233 (x2, 
E_V2HImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3093 (insn, operands);

        case E_V4HImode:
          if (pattern233 (x2, 
E_V4HImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3107 (insn, operands);

        case E_V8HImode:
          if (pattern233 (x2, 
E_V8HImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3121 (insn, operands);

        case E_V16HImode:
          if (pattern233 (x2, 
E_V16HImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3135 (insn, operands);

        case E_V32HImode:
          if (pattern233 (x2, 
E_V32HImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3149 (insn, operands);

        case E_V64HImode:
          if (pattern233 (x2, 
E_V64HImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3163 (insn, operands);

        case E_V128HImode:
          if (pattern233 (x2, 
E_V128HImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3177 (insn, operands);

        case E_V256HImode:
          if (pattern233 (x2, 
E_V256HImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3191 (insn, operands);

        case E_V512HImode:
          if (pattern233 (x2, 
E_V512HImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3205 (insn, operands);

        case E_V1024HImode:
          if (pattern233 (x2, 
E_V1024HImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3219 (insn, operands);

        case E_V2048HImode:
          if (pattern233 (x2, 
E_V2048HImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3233 (insn, operands);

        case E_V1SImode:
          if (pattern233 (x2, 
E_V1SImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3247 (insn, operands);

        case E_V2SImode:
          if (pattern233 (x2, 
E_V2SImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3261 (insn, operands);

        case E_V4SImode:
          if (pattern233 (x2, 
E_V4SImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3275 (insn, operands);

        case E_V8SImode:
          if (pattern233 (x2, 
E_V8SImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3289 (insn, operands);

        case E_V16SImode:
          if (pattern233 (x2, 
E_V16SImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3303 (insn, operands);

        case E_V32SImode:
          if (pattern233 (x2, 
E_V32SImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3317 (insn, operands);

        case E_V64SImode:
          if (pattern233 (x2, 
E_V64SImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3331 (insn, operands);

        case E_V128SImode:
          if (pattern233 (x2, 
E_V128SImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3345 (insn, operands);

        case E_V256SImode:
          if (pattern233 (x2, 
E_V256SImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3359 (insn, operands);

        case E_V512SImode:
          if (pattern233 (x2, 
E_V512SImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3373 (insn, operands);

        case E_V1024SImode:
          if (pattern233 (x2, 
E_V1024SImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3387 (insn, operands);

        case E_V1DImode:
          if (pattern233 (x2, 
E_V1DImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3401 (insn, operands);

        case E_V2DImode:
          if (pattern233 (x2, 
E_V2DImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3415 (insn, operands);

        case E_V4DImode:
          if (pattern233 (x2, 
E_V4DImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3429 (insn, operands);

        case E_V8DImode:
          if (pattern233 (x2, 
E_V8DImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3443 (insn, operands);

        case E_V16DImode:
          if (pattern233 (x2, 
E_V16DImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3457 (insn, operands);

        case E_V32DImode:
          if (pattern233 (x2, 
E_V32DImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3471 (insn, operands);

        case E_V64DImode:
          if (pattern233 (x2, 
E_V64DImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3485 (insn, operands);

        case E_V128DImode:
          if (pattern233 (x2, 
E_V128DImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3499 (insn, operands);

        case E_V256DImode:
          if (pattern233 (x2, 
E_V256DImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3513 (insn, operands);

        case E_V512DImode:
          if (pattern233 (x2, 
E_V512DImode) != 0
              || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3527 (insn, operands);

        case E_RVVMF64BImode:
          if (pattern0 (x2, 
E_RVVMF64BImode) != 0
              || !((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3947 (insn, operands);

        case E_RVVMF32BImode:
          if (pattern0 (x2, 
E_RVVMF32BImode) != 0
              || !(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3950 (insn, operands);

        case E_RVVMF16BImode:
          if (pattern0 (x2, 
E_RVVMF16BImode) != 0
              || !(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3953 (insn, operands);

        case E_RVVMF8BImode:
          if (pattern0 (x2, 
E_RVVMF8BImode) != 0
              || !(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3956 (insn, operands);

        case E_RVVMF4BImode:
          if (pattern0 (x2, 
E_RVVMF4BImode) != 0
              || !(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3959 (insn, operands);

        case E_RVVMF2BImode:
          if (pattern0 (x2, 
E_RVVMF2BImode) != 0
              || !(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3962 (insn, operands);

        case E_RVVM1BImode:
          if (pattern0 (x2, 
E_RVVM1BImode) != 0
              || !(
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3965 (insn, operands);

        case E_V1BImode:
          if (pattern0 (x2, 
E_V1BImode) != 0
              || !((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3968 (insn, operands);

        case E_V2BImode:
          if (pattern0 (x2, 
E_V2BImode) != 0
              || !((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3971 (insn, operands);

        case E_V4BImode:
          if (pattern0 (x2, 
E_V4BImode) != 0
              || !((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3974 (insn, operands);

        case E_V8BImode:
          if (pattern0 (x2, 
E_V8BImode) != 0
              || !((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3977 (insn, operands);

        case E_V16BImode:
          if (pattern0 (x2, 
E_V16BImode) != 0
              || !((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3980 (insn, operands);

        case E_V32BImode:
          if (pattern0 (x2, 
E_V32BImode) != 0
              || !((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3983 (insn, operands);

        case E_V64BImode:
          if (pattern0 (x2, 
E_V64BImode) != 0
              || !((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3986 (insn, operands);

        case E_V128BImode:
          if (pattern0 (x2, 
E_V128BImode) != 0
              || !((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3989 (insn, operands);

        case E_V256BImode:
          if (pattern0 (x2, 
E_V256BImode) != 0
              || !((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3992 (insn, operands);

        case E_V512BImode:
          if (pattern0 (x2, 
E_V512BImode) != 0
              || !((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3995 (insn, operands);

        case E_V1024BImode:
          if (pattern0 (x2, 
E_V1024BImode) != 0
              || !((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_3998 (insn, operands);

        case E_V2048BImode:
          if (pattern0 (x2, 
E_V2048BImode) != 0
              || !((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4001 (insn, operands);

        case E_V4096BImode:
          if (pattern0 (x2, 
E_V4096BImode) != 0
              || !((
#line 558 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 560 "../../gcc/config/riscv/autovec.md"
( 1)))
            return NULL;
          return gen_split_4004 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_119 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern244 (x2))
    {
    case 0:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6237 (insn, operands);

    case 1:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6238 (insn, operands);

    case 2:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6239 (insn, operands);

    case 3:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6240 (insn, operands);

    case 4:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6241 (insn, operands);

    case 5:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6242 (insn, operands);

    case 6:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6252 (insn, operands);

    case 7:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6253 (insn, operands);

    case 8:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6254 (insn, operands);

    case 9:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6255 (insn, operands);

    case 10:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6256 (insn, operands);

    case 11:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6257 (insn, operands);

    case 12:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6258 (insn, operands);

    case 13:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6259 (insn, operands);

    case 14:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6260 (insn, operands);

    case 15:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6261 (insn, operands);

    case 16:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6262 (insn, operands);

    case 17:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6263 (insn, operands);

    case 18:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6243 (insn, operands);

    case 19:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6244 (insn, operands);

    case 20:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6245 (insn, operands);

    case 21:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6246 (insn, operands);

    case 22:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6247 (insn, operands);

    case 23:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6264 (insn, operands);

    case 24:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6265 (insn, operands);

    case 25:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6266 (insn, operands);

    case 26:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6267 (insn, operands);

    case 27:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6268 (insn, operands);

    case 28:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6269 (insn, operands);

    case 29:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6270 (insn, operands);

    case 30:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6271 (insn, operands);

    case 31:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6272 (insn, operands);

    case 32:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6273 (insn, operands);

    case 33:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6274 (insn, operands);

    case 34:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6248 (insn, operands);

    case 35:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6249 (insn, operands);

    case 36:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6250 (insn, operands);

    case 37:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6251 (insn, operands);

    case 38:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6275 (insn, operands);

    case 39:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6276 (insn, operands);

    case 40:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6277 (insn, operands);

    case 41:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6278 (insn, operands);

    case 42:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6279 (insn, operands);

    case 43:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6280 (insn, operands);

    case 44:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6281 (insn, operands);

    case 45:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6282 (insn, operands);

    case 46:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6283 (insn, operands);

    case 47:
      if (!((
#line 2407 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 2409 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_6284 (insn, operands);

    case 48:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 685 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9236 (insn, operands);

    case 49:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 686 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9237 (insn, operands);

    case 50:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 687 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9238 (insn, operands);

    case 51:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 688 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9239 (insn, operands);

    case 52:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 689 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9240 (insn, operands);

    case 53:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 695 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9245 (insn, operands);

    case 54:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 696 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9246 (insn, operands);

    case 55:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 697 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9247 (insn, operands);

    case 56:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 698 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9248 (insn, operands);

    case 57:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 699 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9249 (insn, operands);

    case 58:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 700 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9250 (insn, operands);

    case 59:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 701 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9251 (insn, operands);

    case 60:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 702 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9252 (insn, operands);

    case 61:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 703 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9253 (insn, operands);

    case 62:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 704 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9254 (insn, operands);

    case 63:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 705 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9255 (insn, operands);

    case 64:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 690 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9241 (insn, operands);

    case 65:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 691 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9242 (insn, operands);

    case 66:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 692 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9243 (insn, operands);

    case 67:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 693 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9244 (insn, operands);

    case 68:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 706 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9256 (insn, operands);

    case 69:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 707 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9257 (insn, operands);

    case 70:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 708 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9258 (insn, operands);

    case 71:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 709 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9259 (insn, operands);

    case 72:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 710 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9260 (insn, operands);

    case 73:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 711 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9261 (insn, operands);

    case 74:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 712 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9262 (insn, operands);

    case 75:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 713 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9263 (insn, operands);

    case 76:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 714 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9264 (insn, operands);

    case 77:
      if (!((
#line 904 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 715 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 906 "../../gcc/config/riscv/autovec-opt.md"
( 1)))
        return NULL;
      return gen_split_9265 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_126 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8QImode, 
E_RVVM1BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8QImode)
	|| register_operand (operands[3], RVVM8QImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8QImode, 7))))
        return NULL;
      return gen_split_800 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4QImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4QImode)
	|| register_operand (operands[3], RVVM4QImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4QImode, 7))))
        return NULL;
      return gen_split_806 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2QImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2QImode)
	|| register_operand (operands[3], RVVM2QImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2QImode, 7))))
        return NULL;
      return gen_split_812 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1QImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1QImode)
	|| register_operand (operands[3], RVVM1QImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1QImode, 7))))
        return NULL;
      return gen_split_818 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8HImode, 
E_RVVMF2BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HImode)
	|| register_operand (operands[3], RVVM8HImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HImode, 7))))
        return NULL;
      return gen_split_824 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4HImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HImode)
	|| register_operand (operands[3], RVVM4HImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HImode, 7))))
        return NULL;
      return gen_split_830 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2HImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HImode)
	|| register_operand (operands[3], RVVM2HImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HImode, 7))))
        return NULL;
      return gen_split_836 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1HImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HImode)
	|| register_operand (operands[3], RVVM1HImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HImode, 7))))
        return NULL;
      return gen_split_842 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8SImode, 
E_RVVMF4BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SImode)
	|| register_operand (operands[3], RVVM8SImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SImode, 7))))
        return NULL;
      return gen_split_848 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4SImode, 
E_RVVMF8BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SImode)
	|| register_operand (operands[3], RVVM4SImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SImode, 7))))
        return NULL;
      return gen_split_854 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2SImode, 
E_RVVMF16BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SImode)
	|| register_operand (operands[3], RVVM2SImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SImode, 7))))
        return NULL;
      return gen_split_860 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1SImode, 
E_RVVMF32BImode) != 0
          || !(
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SImode)
	|| register_operand (operands[3], RVVM1SImode)))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SImode, 7))))
        return NULL;
      return gen_split_866 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8DImode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DImode)
	|| register_operand (operands[3], RVVM8DImode)))) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DImode, 7))))
        return NULL;
      return gen_split_872 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4DImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DImode)
	|| register_operand (operands[3], RVVM4DImode)))) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DImode, 7))))
        return NULL;
      return gen_split_878 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2DImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DImode)
	|| register_operand (operands[3], RVVM2DImode)))) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DImode, 7))))
        return NULL;
      return gen_split_884 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1DImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DImode)
	|| register_operand (operands[3], RVVM1DImode)))) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DImode, 7))))
        return NULL;
      return gen_split_890 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2QImode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2QImode)
	|| register_operand (operands[3], RVVMF2QImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2QImode, 7))))
        return NULL;
      return gen_split_896 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4QImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4QImode)
	|| register_operand (operands[3], RVVMF4QImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4QImode, 7))))
        return NULL;
      return gen_split_902 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF8QImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF8QImode)
	|| register_operand (operands[3], RVVMF8QImode)))) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF8QImode, 7))))
        return NULL;
      return gen_split_908 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2HImode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HImode)
	|| register_operand (operands[3], RVVMF2HImode)))) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HImode, 7))))
        return NULL;
      return gen_split_914 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4HImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HImode)
	|| register_operand (operands[3], RVVMF4HImode)))) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HImode, 7))))
        return NULL;
      return gen_split_920 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2SImode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SImode)
	|| register_operand (operands[3], RVVMF2SImode)))) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SImode, 7))))
        return NULL;
      return gen_split_926 (insn, operands);

    case E_RVVM8BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8BFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8BFmode)
	|| register_operand (operands[3], RVVM8BFmode)))) && 
#line 167 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8BFmode, 7))))
        return NULL;
      return gen_split_932 (insn, operands);

    case E_RVVM4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4BFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4BFmode)
	|| register_operand (operands[3], RVVM4BFmode)))) && 
#line 168 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4BFmode, 7))))
        return NULL;
      return gen_split_938 (insn, operands);

    case E_RVVM2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2BFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2BFmode)
	|| register_operand (operands[3], RVVM2BFmode)))) && 
#line 169 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2BFmode, 7))))
        return NULL;
      return gen_split_944 (insn, operands);

    case E_RVVM1BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1BFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1BFmode)
	|| register_operand (operands[3], RVVM1BFmode)))) && 
#line 170 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1BFmode, 7))))
        return NULL;
      return gen_split_950 (insn, operands);

    case E_RVVMF2BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2BFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2BFmode)
	|| register_operand (operands[3], RVVMF2BFmode)))) && 
#line 171 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2BFmode, 7))))
        return NULL;
      return gen_split_956 (insn, operands);

    case E_RVVMF4BFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4BFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4BFmode)
	|| register_operand (operands[3], RVVMF4BFmode)))) && 
#line 172 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_BF_16 && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4BFmode, 7))))
        return NULL;
      return gen_split_962 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8HFmode, 
E_RVVMF2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8HFmode)
	|| register_operand (operands[3], RVVM8HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8HFmode, 7))))
        return NULL;
      return gen_split_968 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4HFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4HFmode)
	|| register_operand (operands[3], RVVM4HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4HFmode, 7))))
        return NULL;
      return gen_split_974 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2HFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2HFmode)
	|| register_operand (operands[3], RVVM2HFmode)))) && 
#line 176 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2HFmode, 7))))
        return NULL;
      return gen_split_980 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1HFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1HFmode)
	|| register_operand (operands[3], RVVM1HFmode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1HFmode, 7))))
        return NULL;
      return gen_split_986 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2HFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2HFmode)
	|| register_operand (operands[3], RVVMF2HFmode)))) && 
#line 177 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2HFmode, 7))))
        return NULL;
      return gen_split_992 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF4HFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF4HFmode)
	|| register_operand (operands[3], RVVMF4HFmode)))) && 
#line 178 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_16 && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4HFmode, 7))))
        return NULL;
      return gen_split_998 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8SFmode, 
E_RVVMF4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8SFmode)
	|| register_operand (operands[3], RVVM8SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8SFmode, 7))))
        return NULL;
      return gen_split_1004 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4SFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4SFmode)
	|| register_operand (operands[3], RVVM4SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4SFmode, 7))))
        return NULL;
      return gen_split_1010 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2SFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2SFmode)
	|| register_operand (operands[3], RVVM2SFmode)))) && 
#line 180 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2SFmode, 7))))
        return NULL;
      return gen_split_1016 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1SFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1SFmode)
	|| register_operand (operands[3], RVVM1SFmode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1SFmode, 7))))
        return NULL;
      return gen_split_1022 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVMF2SFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVMF2SFmode)
	|| register_operand (operands[3], RVVMF2SFmode)))) && 
#line 181 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2SFmode, 7))))
        return NULL;
      return gen_split_1028 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM8DFmode, 
E_RVVMF8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM8DFmode)
	|| register_operand (operands[3], RVVM8DFmode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM8DFmode, 7))))
        return NULL;
      return gen_split_1034 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM4DFmode, 
E_RVVMF16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM4DFmode)
	|| register_operand (operands[3], RVVM4DFmode)))) && 
#line 183 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM4DFmode, 7))))
        return NULL;
      return gen_split_1040 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM2DFmode, 
E_RVVMF32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM2DFmode)
	|| register_operand (operands[3], RVVM2DFmode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM2DFmode, 7))))
        return NULL;
      return gen_split_1046 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_RVVM1DFmode, 
E_RVVMF64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], RVVM1DFmode)
	|| register_operand (operands[3], RVVM1DFmode)))) && 
#line 184 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1DFmode, 7))))
        return NULL;
      return gen_split_1052 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1QImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1QImode)
	|| register_operand (operands[3], V1QImode)))) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1QImode, 7))))
        return NULL;
      return gen_split_1058 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2QImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2QImode)
	|| register_operand (operands[3], V2QImode)))) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2QImode, 7))))
        return NULL;
      return gen_split_1064 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4QImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4QImode)
	|| register_operand (operands[3], V4QImode)))) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4QImode, 7))))
        return NULL;
      return gen_split_1070 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8QImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8QImode)
	|| register_operand (operands[3], V8QImode)))) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8QImode, 7))))
        return NULL;
      return gen_split_1076 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16QImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16QImode)
	|| register_operand (operands[3], V16QImode)))) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16QImode, 7))))
        return NULL;
      return gen_split_1082 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32QImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32QImode)
	|| register_operand (operands[3], V32QImode)))) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32QImode, 7))))
        return NULL;
      return gen_split_1088 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64QImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64QImode)
	|| register_operand (operands[3], V64QImode)))) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64QImode, 7))))
        return NULL;
      return gen_split_1094 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128QImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128QImode)
	|| register_operand (operands[3], V128QImode)))) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128QImode, 7))))
        return NULL;
      return gen_split_1100 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256QImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256QImode)
	|| register_operand (operands[3], V256QImode)))) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256QImode, 7))))
        return NULL;
      return gen_split_1106 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512QImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512QImode)
	|| register_operand (operands[3], V512QImode)))) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512QImode, 7))))
        return NULL;
      return gen_split_1112 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024QImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024QImode)
	|| register_operand (operands[3], V1024QImode)))) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024QImode, 7))))
        return NULL;
      return gen_split_1118 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048QImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048QImode)
	|| register_operand (operands[3], V2048QImode)))) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048QImode, 7))))
        return NULL;
      return gen_split_1124 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4096QImode, 
E_V4096BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4096QImode)
	|| register_operand (operands[3], V4096QImode)))) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4096QImode, 7))))
        return NULL;
      return gen_split_1130 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1HImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HImode)
	|| register_operand (operands[3], V1HImode)))) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HImode, 7))))
        return NULL;
      return gen_split_1136 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2HImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HImode)
	|| register_operand (operands[3], V2HImode)))) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HImode, 7))))
        return NULL;
      return gen_split_1142 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4HImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HImode)
	|| register_operand (operands[3], V4HImode)))) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HImode, 7))))
        return NULL;
      return gen_split_1148 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8HImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HImode)
	|| register_operand (operands[3], V8HImode)))) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HImode, 7))))
        return NULL;
      return gen_split_1154 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16HImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HImode)
	|| register_operand (operands[3], V16HImode)))) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HImode, 7))))
        return NULL;
      return gen_split_1160 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32HImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HImode)
	|| register_operand (operands[3], V32HImode)))) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HImode, 7))))
        return NULL;
      return gen_split_1166 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64HImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HImode)
	|| register_operand (operands[3], V64HImode)))) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HImode, 7))))
        return NULL;
      return gen_split_1172 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128HImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HImode)
	|| register_operand (operands[3], V128HImode)))) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HImode, 7))))
        return NULL;
      return gen_split_1178 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256HImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HImode)
	|| register_operand (operands[3], V256HImode)))) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HImode, 7))))
        return NULL;
      return gen_split_1184 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512HImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HImode)
	|| register_operand (operands[3], V512HImode)))) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HImode, 7))))
        return NULL;
      return gen_split_1190 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024HImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HImode)
	|| register_operand (operands[3], V1024HImode)))) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HImode, 7))))
        return NULL;
      return gen_split_1196 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048HImode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HImode)
	|| register_operand (operands[3], V2048HImode)))) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HImode, 7))))
        return NULL;
      return gen_split_1202 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1SImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SImode)
	|| register_operand (operands[3], V1SImode)))) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SImode, 7))))
        return NULL;
      return gen_split_1208 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2SImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SImode)
	|| register_operand (operands[3], V2SImode)))) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SImode, 7))))
        return NULL;
      return gen_split_1214 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4SImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SImode)
	|| register_operand (operands[3], V4SImode)))) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SImode, 7))))
        return NULL;
      return gen_split_1220 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8SImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SImode)
	|| register_operand (operands[3], V8SImode)))) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SImode, 7))))
        return NULL;
      return gen_split_1226 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16SImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SImode)
	|| register_operand (operands[3], V16SImode)))) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SImode, 7))))
        return NULL;
      return gen_split_1232 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32SImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SImode)
	|| register_operand (operands[3], V32SImode)))) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SImode, 7))))
        return NULL;
      return gen_split_1238 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64SImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SImode)
	|| register_operand (operands[3], V64SImode)))) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SImode, 7))))
        return NULL;
      return gen_split_1244 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128SImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SImode)
	|| register_operand (operands[3], V128SImode)))) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SImode, 7))))
        return NULL;
      return gen_split_1250 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256SImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SImode)
	|| register_operand (operands[3], V256SImode)))) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SImode, 7))))
        return NULL;
      return gen_split_1256 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512SImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SImode)
	|| register_operand (operands[3], V512SImode)))) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SImode, 7))))
        return NULL;
      return gen_split_1262 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024SImode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SImode)
	|| register_operand (operands[3], V1024SImode)))) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SImode, 7))))
        return NULL;
      return gen_split_1268 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1DImode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DImode)
	|| register_operand (operands[3], V1DImode)))) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DImode, 7))))
        return NULL;
      return gen_split_1274 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2DImode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DImode)
	|| register_operand (operands[3], V2DImode)))) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DImode, 7))))
        return NULL;
      return gen_split_1280 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4DImode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DImode)
	|| register_operand (operands[3], V4DImode)))) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DImode, 7))))
        return NULL;
      return gen_split_1286 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8DImode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DImode)
	|| register_operand (operands[3], V8DImode)))) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DImode, 7))))
        return NULL;
      return gen_split_1292 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16DImode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DImode)
	|| register_operand (operands[3], V16DImode)))) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DImode, 7))))
        return NULL;
      return gen_split_1298 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32DImode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DImode)
	|| register_operand (operands[3], V32DImode)))) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DImode, 7))))
        return NULL;
      return gen_split_1304 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64DImode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DImode)
	|| register_operand (operands[3], V64DImode)))) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DImode, 7))))
        return NULL;
      return gen_split_1310 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128DImode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DImode)
	|| register_operand (operands[3], V128DImode)))) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DImode, 7))))
        return NULL;
      return gen_split_1316 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256DImode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DImode)
	|| register_operand (operands[3], V256DImode)))) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DImode, 7))))
        return NULL;
      return gen_split_1322 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512DImode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DImode)
	|| register_operand (operands[3], V512DImode)))) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DImode, 7))))
        return NULL;
      return gen_split_1328 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1HFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1HFmode)
	|| register_operand (operands[3], V1HFmode)))) && 
#line 272 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1HFmode, 7))))
        return NULL;
      return gen_split_1334 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2HFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2HFmode)
	|| register_operand (operands[3], V2HFmode)))) && 
#line 273 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2HFmode, 7))))
        return NULL;
      return gen_split_1340 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4HFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4HFmode)
	|| register_operand (operands[3], V4HFmode)))) && 
#line 274 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4HFmode, 7))))
        return NULL;
      return gen_split_1346 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8HFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8HFmode)
	|| register_operand (operands[3], V8HFmode)))) && 
#line 275 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8HFmode, 7))))
        return NULL;
      return gen_split_1352 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16HFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16HFmode)
	|| register_operand (operands[3], V16HFmode)))) && 
#line 276 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_VECTOR_ELEN_FP_16)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16HFmode, 7))))
        return NULL;
      return gen_split_1358 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32HFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32HFmode)
	|| register_operand (operands[3], V32HFmode)))) && 
#line 277 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32HFmode, 7))))
        return NULL;
      return gen_split_1364 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64HFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64HFmode)
	|| register_operand (operands[3], V64HFmode)))) && 
#line 278 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64HFmode, 7))))
        return NULL;
      return gen_split_1370 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128HFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128HFmode)
	|| register_operand (operands[3], V128HFmode)))) && 
#line 279 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128HFmode, 7))))
        return NULL;
      return gen_split_1376 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256HFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256HFmode)
	|| register_operand (operands[3], V256HFmode)))) && 
#line 280 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256HFmode, 7))))
        return NULL;
      return gen_split_1382 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512HFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512HFmode)
	|| register_operand (operands[3], V512HFmode)))) && 
#line 281 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512HFmode, 7))))
        return NULL;
      return gen_split_1388 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024HFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024HFmode)
	|| register_operand (operands[3], V1024HFmode)))) && 
#line 282 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024HFmode, 7))))
        return NULL;
      return gen_split_1394 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2048HFmode, 
E_V2048BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2048HFmode)
	|| register_operand (operands[3], V2048HFmode)))) && 
#line 283 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_VECTOR_ELEN_FP_16 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048HFmode, 7))))
        return NULL;
      return gen_split_1400 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1SFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1SFmode)
	|| register_operand (operands[3], V1SFmode)))) && 
#line 284 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1SFmode, 7))))
        return NULL;
      return gen_split_1406 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2SFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2SFmode)
	|| register_operand (operands[3], V2SFmode)))) && 
#line 285 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2SFmode, 7))))
        return NULL;
      return gen_split_1412 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4SFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4SFmode)
	|| register_operand (operands[3], V4SFmode)))) && 
#line 286 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4SFmode, 7))))
        return NULL;
      return gen_split_1418 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8SFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8SFmode)
	|| register_operand (operands[3], V8SFmode)))) && 
#line 287 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8SFmode, 7))))
        return NULL;
      return gen_split_1424 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16SFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16SFmode)
	|| register_operand (operands[3], V16SFmode)))) && 
#line 288 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16SFmode, 7))))
        return NULL;
      return gen_split_1430 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32SFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32SFmode)
	|| register_operand (operands[3], V32SFmode)))) && 
#line 289 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32SFmode, 7))))
        return NULL;
      return gen_split_1436 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64SFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64SFmode)
	|| register_operand (operands[3], V64SFmode)))) && 
#line 290 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64SFmode, 7))))
        return NULL;
      return gen_split_1442 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128SFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128SFmode)
	|| register_operand (operands[3], V128SFmode)))) && 
#line 291 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128SFmode, 7))))
        return NULL;
      return gen_split_1448 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256SFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256SFmode)
	|| register_operand (operands[3], V256SFmode)))) && 
#line 292 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256SFmode, 7))))
        return NULL;
      return gen_split_1454 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512SFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512SFmode)
	|| register_operand (operands[3], V512SFmode)))) && 
#line 293 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512SFmode, 7))))
        return NULL;
      return gen_split_1460 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1024SFmode, 
E_V1024BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1024SFmode)
	|| register_operand (operands[3], V1024SFmode)))) && 
#line 294 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024SFmode, 7))))
        return NULL;
      return gen_split_1466 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V1DFmode, 
E_V1BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V1DFmode)
	|| register_operand (operands[3], V1DFmode)))) && 
#line 295 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1DFmode, 7))))
        return NULL;
      return gen_split_1472 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V2DFmode, 
E_V2BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V2DFmode)
	|| register_operand (operands[3], V2DFmode)))) && 
#line 296 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2DFmode, 7))))
        return NULL;
      return gen_split_1478 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V4DFmode, 
E_V4BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V4DFmode)
	|| register_operand (operands[3], V4DFmode)))) && 
#line 297 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4DFmode, 7))))
        return NULL;
      return gen_split_1484 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V8DFmode, 
E_V8BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V8DFmode)
	|| register_operand (operands[3], V8DFmode)))) && 
#line 298 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8DFmode, 7))))
        return NULL;
      return gen_split_1490 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V16DFmode, 
E_V16BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V16DFmode)
	|| register_operand (operands[3], V16DFmode)))) && 
#line 299 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16DFmode, 7))))
        return NULL;
      return gen_split_1496 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V32DFmode, 
E_V32BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V32DFmode)
	|| register_operand (operands[3], V32DFmode)))) && 
#line 300 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32DFmode, 7))))
        return NULL;
      return gen_split_1502 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V64DFmode, 
E_V64BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V64DFmode)
	|| register_operand (operands[3], V64DFmode)))) && 
#line 301 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64DFmode, 7))))
        return NULL;
      return gen_split_1508 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V128DFmode, 
E_V128BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V128DFmode)
	|| register_operand (operands[3], V128DFmode)))) && 
#line 302 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128DFmode, 7))))
        return NULL;
      return gen_split_1514 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V256DFmode, 
E_V256BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V256DFmode)
	|| register_operand (operands[3], V256DFmode)))) && 
#line 303 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256DFmode, 7))))
        return NULL;
      return gen_split_1520 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern473 (x2, 
E_V512DFmode, 
E_V512BImode) != 0
          || !((
#line 221 "../../gcc/config/riscv/thead-vector.md"
((TARGET_XTHEADVECTOR
    && (register_operand (operands[0], V512DFmode)
	|| register_operand (operands[3], V512DFmode)))) && 
#line 304 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 231 "../../gcc/config/riscv/thead-vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512DFmode, 7))))
        return NULL;
      return gen_split_1526 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_134 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVM8QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM8QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2588 (insn, operands);

    case E_RVVM4QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM4QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2602 (insn, operands);

    case E_RVVM2QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM2QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2616 (insn, operands);

    case E_RVVM1QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM1QImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2630 (insn, operands);

    case E_RVVM8HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM8HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2644 (insn, operands);

    case E_RVVM4HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM4HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2658 (insn, operands);

    case E_RVVM2HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM2HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2672 (insn, operands);

    case E_RVVM1HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM1HImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2686 (insn, operands);

    case E_RVVM8SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM8SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2700 (insn, operands);

    case E_RVVM4SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM4SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2714 (insn, operands);

    case E_RVVM2SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM2SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2728 (insn, operands);

    case E_RVVM1SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM1SImode) != 0
          || !(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2742 (insn, operands);

    case E_RVVM8DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM8DImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2756 (insn, operands);

    case E_RVVM4DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM4DImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2770 (insn, operands);

    case E_RVVM2DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM2DImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2784 (insn, operands);

    case E_RVVM1DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVM1DImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2798 (insn, operands);

    case E_RVVMF2QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVMF2QImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2812 (insn, operands);

    case E_RVVMF4QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVMF4QImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2826 (insn, operands);

    case E_RVVMF8QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVMF8QImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2840 (insn, operands);

    case E_RVVMF2HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVMF2HImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2854 (insn, operands);

    case E_RVVMF4HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVMF4HImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2868 (insn, operands);

    case E_RVVMF2SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_RVVMF2SImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2882 (insn, operands);

    case E_V1QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V1QImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2896 (insn, operands);

    case E_V2QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V2QImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2910 (insn, operands);

    case E_V4QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V4QImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2924 (insn, operands);

    case E_V8QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V8QImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2938 (insn, operands);

    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V16QImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2952 (insn, operands);

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V32QImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2966 (insn, operands);

    case E_V64QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V64QImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2980 (insn, operands);

    case E_V128QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V128QImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2994 (insn, operands);

    case E_V256QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V256QImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3008 (insn, operands);

    case E_V512QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V512QImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3022 (insn, operands);

    case E_V1024QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V1024QImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3036 (insn, operands);

    case E_V2048QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V2048QImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3050 (insn, operands);

    case E_V4096QImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V4096QImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3064 (insn, operands);

    case E_V1HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V1HImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3078 (insn, operands);

    case E_V2HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V2HImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3092 (insn, operands);

    case E_V4HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V4HImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3106 (insn, operands);

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V8HImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3120 (insn, operands);

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V16HImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3134 (insn, operands);

    case E_V32HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V32HImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3148 (insn, operands);

    case E_V64HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V64HImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3162 (insn, operands);

    case E_V128HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V128HImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3176 (insn, operands);

    case E_V256HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V256HImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3190 (insn, operands);

    case E_V512HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V512HImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3204 (insn, operands);

    case E_V1024HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V1024HImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3218 (insn, operands);

    case E_V2048HImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V2048HImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3232 (insn, operands);

    case E_V1SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V1SImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3246 (insn, operands);

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V2SImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3260 (insn, operands);

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V4SImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3274 (insn, operands);

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V8SImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3288 (insn, operands);

    case E_V16SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V16SImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3302 (insn, operands);

    case E_V32SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V32SImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3316 (insn, operands);

    case E_V64SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V64SImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3330 (insn, operands);

    case E_V128SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V128SImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3344 (insn, operands);

    case E_V256SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V256SImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3358 (insn, operands);

    case E_V512SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V512SImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3372 (insn, operands);

    case E_V1024SImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V1024SImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3386 (insn, operands);

    case E_V1DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V1DImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3400 (insn, operands);

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V2DImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3414 (insn, operands);

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V4DImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3428 (insn, operands);

    case E_V8DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V8DImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3442 (insn, operands);

    case E_V16DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V16DImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3456 (insn, operands);

    case E_V32DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V32DImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3470 (insn, operands);

    case E_V64DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V64DImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3484 (insn, operands);

    case E_V128DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V128DImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3498 (insn, operands);

    case E_V256DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V256DImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3512 (insn, operands);

    case E_V512DImode:
      x2 = XEXP (x1, 1);
      if (pattern359 (x2, 
E_V512DImode) != 0
          || !((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3526 (insn, operands);

    case E_RVVM8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8HFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5555 (insn, operands);

    case E_RVVM4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4HFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5559 (insn, operands);

    case E_RVVM2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2HFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5563 (insn, operands);

    case E_RVVM1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1HFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5567 (insn, operands);

    case E_RVVMF2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2HFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5571 (insn, operands);

    case E_RVVMF4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF4HFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5575 (insn, operands);

    case E_RVVM8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8SFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5579 (insn, operands);

    case E_RVVM4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4SFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5583 (insn, operands);

    case E_RVVM2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2SFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5587 (insn, operands);

    case E_RVVM1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1SFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5591 (insn, operands);

    case E_RVVMF2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVMF2SFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5595 (insn, operands);

    case E_RVVM8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM8DFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5599 (insn, operands);

    case E_RVVM4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM4DFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5603 (insn, operands);

    case E_RVVM2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM2DFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5607 (insn, operands);

    case E_RVVM1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_RVVM1DFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5611 (insn, operands);

    case E_V1HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1HFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5615 (insn, operands);

    case E_V2HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2HFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5619 (insn, operands);

    case E_V4HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4HFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5623 (insn, operands);

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8HFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5627 (insn, operands);

    case E_V16HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16HFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5631 (insn, operands);

    case E_V32HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32HFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5635 (insn, operands);

    case E_V64HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64HFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5639 (insn, operands);

    case E_V128HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128HFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5643 (insn, operands);

    case E_V256HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256HFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5647 (insn, operands);

    case E_V512HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512HFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5651 (insn, operands);

    case E_V1024HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024HFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5655 (insn, operands);

    case E_V2048HFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2048HFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5659 (insn, operands);

    case E_V1SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1SFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5663 (insn, operands);

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2SFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5667 (insn, operands);

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4SFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5671 (insn, operands);

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8SFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5675 (insn, operands);

    case E_V16SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16SFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5679 (insn, operands);

    case E_V32SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32SFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5683 (insn, operands);

    case E_V64SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64SFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5687 (insn, operands);

    case E_V128SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128SFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5691 (insn, operands);

    case E_V256SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256SFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5695 (insn, operands);

    case E_V512SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512SFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5699 (insn, operands);

    case E_V1024SFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1024SFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5703 (insn, operands);

    case E_V1DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V1DFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5707 (insn, operands);

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V2DFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5711 (insn, operands);

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V4DFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5715 (insn, operands);

    case E_V8DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V8DFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5719 (insn, operands);

    case E_V16DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V16DFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5723 (insn, operands);

    case E_V32DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V32DFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5727 (insn, operands);

    case E_V64DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V64DFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5731 (insn, operands);

    case E_V128DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V128DFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5735 (insn, operands);

    case E_V256DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V256DFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5739 (insn, operands);

    case E_V512DFmode:
      x2 = XEXP (x1, 1);
      if (pattern0 (x2, 
E_V512DFmode) != 0
          || !((
#line 1560 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1562 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5743 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_142 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_RVVMF64BImode:
      if (!register_operand (operands[0], E_RVVMF64BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF64BImode
          || !register_operand (operands[1], E_RVVMF64BImode)
          || !((
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 582 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4007 (insn, operands);

    case E_RVVMF32BImode:
      if (!register_operand (operands[0], E_RVVMF32BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF32BImode
          || !register_operand (operands[1], E_RVVMF32BImode)
          || !(
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 582 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4008 (insn, operands);

    case E_RVVMF16BImode:
      if (!register_operand (operands[0], E_RVVMF16BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF16BImode
          || !register_operand (operands[1], E_RVVMF16BImode)
          || !(
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 582 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4009 (insn, operands);

    case E_RVVMF8BImode:
      if (!register_operand (operands[0], E_RVVMF8BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8BImode
          || !register_operand (operands[1], E_RVVMF8BImode)
          || !(
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 582 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4010 (insn, operands);

    case E_RVVMF4BImode:
      if (!register_operand (operands[0], E_RVVMF4BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4BImode
          || !register_operand (operands[1], E_RVVMF4BImode)
          || !(
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 582 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4011 (insn, operands);

    case E_RVVMF2BImode:
      if (!register_operand (operands[0], E_RVVMF2BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2BImode
          || !register_operand (operands[1], E_RVVMF2BImode)
          || !(
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 582 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4012 (insn, operands);

    case E_RVVM1BImode:
      if (!register_operand (operands[0], E_RVVM1BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1BImode
          || !register_operand (operands[1], E_RVVM1BImode)
          || !(
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 582 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4013 (insn, operands);

    case E_V1BImode:
      if (!register_operand (operands[0], E_V1BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1BImode
          || !register_operand (operands[1], E_V1BImode)
          || !((
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 582 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4014 (insn, operands);

    case E_V2BImode:
      if (!register_operand (operands[0], E_V2BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2BImode
          || !register_operand (operands[1], E_V2BImode)
          || !((
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 582 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4015 (insn, operands);

    case E_V4BImode:
      if (!register_operand (operands[0], E_V4BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4BImode
          || !register_operand (operands[1], E_V4BImode)
          || !((
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 582 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4016 (insn, operands);

    case E_V8BImode:
      if (!register_operand (operands[0], E_V8BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8BImode
          || !register_operand (operands[1], E_V8BImode)
          || !((
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 582 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4017 (insn, operands);

    case E_V16BImode:
      if (!register_operand (operands[0], E_V16BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16BImode
          || !register_operand (operands[1], E_V16BImode)
          || !((
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 582 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4018 (insn, operands);

    case E_V32BImode:
      if (!register_operand (operands[0], E_V32BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32BImode
          || !register_operand (operands[1], E_V32BImode)
          || !((
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 582 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4019 (insn, operands);

    case E_V64BImode:
      if (!register_operand (operands[0], E_V64BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64BImode
          || !register_operand (operands[1], E_V64BImode)
          || !((
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 582 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4020 (insn, operands);

    case E_V128BImode:
      if (!register_operand (operands[0], E_V128BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128BImode
          || !register_operand (operands[1], E_V128BImode)
          || !((
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 582 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4021 (insn, operands);

    case E_V256BImode:
      if (!register_operand (operands[0], E_V256BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256BImode
          || !register_operand (operands[1], E_V256BImode)
          || !((
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 582 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4022 (insn, operands);

    case E_V512BImode:
      if (!register_operand (operands[0], E_V512BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512BImode
          || !register_operand (operands[1], E_V512BImode)
          || !((
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 582 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4023 (insn, operands);

    case E_V1024BImode:
      if (!register_operand (operands[0], E_V1024BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024BImode
          || !register_operand (operands[1], E_V1024BImode)
          || !((
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 582 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4024 (insn, operands);

    case E_V2048BImode:
      if (!register_operand (operands[0], E_V2048BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048BImode
          || !register_operand (operands[1], E_V2048BImode)
          || !((
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 582 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4025 (insn, operands);

    case E_V4096BImode:
      if (!register_operand (operands[0], E_V4096BImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096BImode
          || !register_operand (operands[1], E_V4096BImode)
          || !((
#line 580 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 582 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4026 (insn, operands);

    case E_RVVM8QImode:
      if (!register_operand (operands[0], E_RVVM8QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8QImode
          || !register_operand (operands[1], E_RVVM8QImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4946 (insn, operands);

    case E_RVVM4QImode:
      if (!register_operand (operands[0], E_RVVM4QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4QImode
          || !register_operand (operands[1], E_RVVM4QImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4948 (insn, operands);

    case E_RVVM2QImode:
      if (!register_operand (operands[0], E_RVVM2QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2QImode
          || !register_operand (operands[1], E_RVVM2QImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4950 (insn, operands);

    case E_RVVM1QImode:
      if (!register_operand (operands[0], E_RVVM1QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1QImode
          || !register_operand (operands[1], E_RVVM1QImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4952 (insn, operands);

    case E_RVVM8HImode:
      if (!register_operand (operands[0], E_RVVM8HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8HImode
          || !register_operand (operands[1], E_RVVM8HImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4954 (insn, operands);

    case E_RVVM4HImode:
      if (!register_operand (operands[0], E_RVVM4HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4HImode
          || !register_operand (operands[1], E_RVVM4HImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4956 (insn, operands);

    case E_RVVM2HImode:
      if (!register_operand (operands[0], E_RVVM2HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2HImode
          || !register_operand (operands[1], E_RVVM2HImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4958 (insn, operands);

    case E_RVVM1HImode:
      if (!register_operand (operands[0], E_RVVM1HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1HImode
          || !register_operand (operands[1], E_RVVM1HImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4960 (insn, operands);

    case E_RVVM8SImode:
      if (!register_operand (operands[0], E_RVVM8SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8SImode
          || !register_operand (operands[1], E_RVVM8SImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4962 (insn, operands);

    case E_RVVM4SImode:
      if (!register_operand (operands[0], E_RVVM4SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4SImode
          || !register_operand (operands[1], E_RVVM4SImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4964 (insn, operands);

    case E_RVVM2SImode:
      if (!register_operand (operands[0], E_RVVM2SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2SImode
          || !register_operand (operands[1], E_RVVM2SImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4966 (insn, operands);

    case E_RVVM1SImode:
      if (!register_operand (operands[0], E_RVVM1SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1SImode
          || !register_operand (operands[1], E_RVVM1SImode)
          || !(
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4968 (insn, operands);

    case E_RVVM8DImode:
      if (!register_operand (operands[0], E_RVVM8DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM8DImode
          || !register_operand (operands[1], E_RVVM8DImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4970 (insn, operands);

    case E_RVVM4DImode:
      if (!register_operand (operands[0], E_RVVM4DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM4DImode
          || !register_operand (operands[1], E_RVVM4DImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4972 (insn, operands);

    case E_RVVM2DImode:
      if (!register_operand (operands[0], E_RVVM2DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM2DImode
          || !register_operand (operands[1], E_RVVM2DImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4974 (insn, operands);

    case E_RVVM1DImode:
      if (!register_operand (operands[0], E_RVVM1DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVM1DImode
          || !register_operand (operands[1], E_RVVM1DImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4976 (insn, operands);

    case E_RVVMF2QImode:
      if (!register_operand (operands[0], E_RVVMF2QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2QImode
          || !register_operand (operands[1], E_RVVMF2QImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4978 (insn, operands);

    case E_RVVMF4QImode:
      if (!register_operand (operands[0], E_RVVMF4QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4QImode
          || !register_operand (operands[1], E_RVVMF4QImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4980 (insn, operands);

    case E_RVVMF8QImode:
      if (!register_operand (operands[0], E_RVVMF8QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF8QImode
          || !register_operand (operands[1], E_RVVMF8QImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4982 (insn, operands);

    case E_RVVMF2HImode:
      if (!register_operand (operands[0], E_RVVMF2HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2HImode
          || !register_operand (operands[1], E_RVVMF2HImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4984 (insn, operands);

    case E_RVVMF4HImode:
      if (!register_operand (operands[0], E_RVVMF4HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF4HImode
          || !register_operand (operands[1], E_RVVMF4HImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4986 (insn, operands);

    case E_RVVMF2SImode:
      if (!register_operand (operands[0], E_RVVMF2SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_RVVMF2SImode
          || !register_operand (operands[1], E_RVVMF2SImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4988 (insn, operands);

    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4990 (insn, operands);

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4992 (insn, operands);

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4994 (insn, operands);

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4996 (insn, operands);

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4998 (insn, operands);

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5000 (insn, operands);

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64QImode
          || !register_operand (operands[1], E_V64QImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5002 (insn, operands);

    case E_V128QImode:
      if (!register_operand (operands[0], E_V128QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128QImode
          || !register_operand (operands[1], E_V128QImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5004 (insn, operands);

    case E_V256QImode:
      if (!register_operand (operands[0], E_V256QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256QImode
          || !register_operand (operands[1], E_V256QImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5006 (insn, operands);

    case E_V512QImode:
      if (!register_operand (operands[0], E_V512QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512QImode
          || !register_operand (operands[1], E_V512QImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5008 (insn, operands);

    case E_V1024QImode:
      if (!register_operand (operands[0], E_V1024QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024QImode
          || !register_operand (operands[1], E_V1024QImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5010 (insn, operands);

    case E_V2048QImode:
      if (!register_operand (operands[0], E_V2048QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048QImode
          || !register_operand (operands[1], E_V2048QImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5012 (insn, operands);

    case E_V4096QImode:
      if (!register_operand (operands[0], E_V4096QImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4096QImode
          || !register_operand (operands[1], E_V4096QImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5014 (insn, operands);

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5016 (insn, operands);

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5018 (insn, operands);

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5020 (insn, operands);

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5022 (insn, operands);

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5024 (insn, operands);

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HImode
          || !register_operand (operands[1], E_V32HImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5026 (insn, operands);

    case E_V64HImode:
      if (!register_operand (operands[0], E_V64HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64HImode
          || !register_operand (operands[1], E_V64HImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5028 (insn, operands);

    case E_V128HImode:
      if (!register_operand (operands[0], E_V128HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128HImode
          || !register_operand (operands[1], E_V128HImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5030 (insn, operands);

    case E_V256HImode:
      if (!register_operand (operands[0], E_V256HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256HImode
          || !register_operand (operands[1], E_V256HImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5032 (insn, operands);

    case E_V512HImode:
      if (!register_operand (operands[0], E_V512HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512HImode
          || !register_operand (operands[1], E_V512HImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5034 (insn, operands);

    case E_V1024HImode:
      if (!register_operand (operands[0], E_V1024HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024HImode
          || !register_operand (operands[1], E_V1024HImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5036 (insn, operands);

    case E_V2048HImode:
      if (!register_operand (operands[0], E_V2048HImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2048HImode
          || !register_operand (operands[1], E_V2048HImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5038 (insn, operands);

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5040 (insn, operands);

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5042 (insn, operands);

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5044 (insn, operands);

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5046 (insn, operands);

    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16SImode
          || !register_operand (operands[1], E_V16SImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5048 (insn, operands);

    case E_V32SImode:
      if (!register_operand (operands[0], E_V32SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32SImode
          || !register_operand (operands[1], E_V32SImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5050 (insn, operands);

    case E_V64SImode:
      if (!register_operand (operands[0], E_V64SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64SImode
          || !register_operand (operands[1], E_V64SImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5052 (insn, operands);

    case E_V128SImode:
      if (!register_operand (operands[0], E_V128SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128SImode
          || !register_operand (operands[1], E_V128SImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5054 (insn, operands);

    case E_V256SImode:
      if (!register_operand (operands[0], E_V256SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256SImode
          || !register_operand (operands[1], E_V256SImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5056 (insn, operands);

    case E_V512SImode:
      if (!register_operand (operands[0], E_V512SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512SImode
          || !register_operand (operands[1], E_V512SImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5058 (insn, operands);

    case E_V1024SImode:
      if (!register_operand (operands[0], E_V1024SImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1024SImode
          || !register_operand (operands[1], E_V1024SImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5060 (insn, operands);

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5062 (insn, operands);

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5064 (insn, operands);

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5066 (insn, operands);

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8DImode
          || !register_operand (operands[1], E_V8DImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5068 (insn, operands);

    case E_V16DImode:
      if (!register_operand (operands[0], E_V16DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16DImode
          || !register_operand (operands[1], E_V16DImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5070 (insn, operands);

    case E_V32DImode:
      if (!register_operand (operands[0], E_V32DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32DImode
          || !register_operand (operands[1], E_V32DImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5072 (insn, operands);

    case E_V64DImode:
      if (!register_operand (operands[0], E_V64DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V64DImode
          || !register_operand (operands[1], E_V64DImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5074 (insn, operands);

    case E_V128DImode:
      if (!register_operand (operands[0], E_V128DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V128DImode
          || !register_operand (operands[1], E_V128DImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5076 (insn, operands);

    case E_V256DImode:
      if (!register_operand (operands[0], E_V256DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V256DImode
          || !register_operand (operands[1], E_V256DImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5078 (insn, operands);

    case E_V512DImode:
      if (!register_operand (operands[0], E_V512DImode))
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V512DImode
          || !register_operand (operands[1], E_V512DImode)
          || !((
#line 1093 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1095 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_5080 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_152 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern125 (x2))
    {
    case 0:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4442 (insn, operands);

    case 1:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4444 (insn, operands);

    case 2:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4802 (insn, operands);

    case 3:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4446 (insn, operands);

    case 4:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4804 (insn, operands);

    case 5:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4448 (insn, operands);

    case 6:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4806 (insn, operands);

    case 7:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4450 (insn, operands);

    case 8:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4808 (insn, operands);

    case 9:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4452 (insn, operands);

    case 10:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4810 (insn, operands);

    case 11:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4454 (insn, operands);

    case 12:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4634 (insn, operands);

    case 13:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4456 (insn, operands);

    case 14:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4636 (insn, operands);

    case 15:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4812 (insn, operands);

    case 16:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 159 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4458 (insn, operands);

    case 17:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4638 (insn, operands);

    case 18:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4814 (insn, operands);

    case 19:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4460 (insn, operands);

    case 20:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1056 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4640 (insn, operands);

    case 21:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4816 (insn, operands);

    case 22:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 160 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_32 && TARGET_VECTOR_ELEN_64)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4462 (insn, operands);

    case 23:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1057 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4642 (insn, operands);

    case 24:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4818 (insn, operands);

    case 25:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4464 (insn, operands);

    case 26:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1059 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4644 (insn, operands);

    case 27:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 162 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4466 (insn, operands);

    case 28:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1060 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4646 (insn, operands);

    case 29:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4468 (insn, operands);

    case 30:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1061 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4648 (insn, operands);

    case 31:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 163 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_FP_64)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4470 (insn, operands);

    case 32:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1062 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4650 (insn, operands);

    case 33:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4472 (insn, operands);

    case 34:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4844 (insn, operands);

    case 35:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4474 (insn, operands);

    case 36:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4846 (insn, operands);

    case 37:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4476 (insn, operands);

    case 38:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4848 (insn, operands);

    case 39:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4478 (insn, operands);

    case 40:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4850 (insn, operands);

    case 41:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4480 (insn, operands);

    case 42:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4852 (insn, operands);

    case 43:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4482 (insn, operands);

    case 44:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4854 (insn, operands);

    case 45:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4484 (insn, operands);

    case 46:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4856 (insn, operands);

    case 47:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4486 (insn, operands);

    case 48:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4858 (insn, operands);

    case 49:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4488 (insn, operands);

    case 50:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4860 (insn, operands);

    case 51:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4490 (insn, operands);

    case 52:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4862 (insn, operands);

    case 53:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4492 (insn, operands);

    case 54:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4864 (insn, operands);

    case 55:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4494 (insn, operands);

    case 56:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 248 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4496 (insn, operands);

    case 57:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1064 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode) && TARGET_ZVFH)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4652 (insn, operands);

    case 58:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4866 (insn, operands);

    case 59:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 249 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4498 (insn, operands);

    case 60:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1065 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode) && TARGET_ZVFH)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4654 (insn, operands);

    case 61:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4868 (insn, operands);

    case 62:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 250 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4500 (insn, operands);

    case 63:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1066 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode) && TARGET_ZVFH)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4656 (insn, operands);

    case 64:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4870 (insn, operands);

    case 65:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 251 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SFmode) && TARGET_VECTOR_ELEN_FP_32)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4502 (insn, operands);

    case 66:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1067 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode) && TARGET_ZVFH)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4658 (insn, operands);

    case 67:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4872 (insn, operands);

    case 68:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 252 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4504 (insn, operands);

    case 69:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1068 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4660 (insn, operands);

    case 70:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4874 (insn, operands);

    case 71:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 253 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4506 (insn, operands);

    case 72:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1069 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4662 (insn, operands);

    case 73:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4876 (insn, operands);

    case 74:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 254 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4508 (insn, operands);

    case 75:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1070 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4664 (insn, operands);

    case 76:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4878 (insn, operands);

    case 77:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 255 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4510 (insn, operands);

    case 78:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1071 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4666 (insn, operands);

    case 79:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4880 (insn, operands);

    case 80:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 256 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4512 (insn, operands);

    case 81:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1072 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4668 (insn, operands);

    case 82:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4882 (insn, operands);

    case 83:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 257 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4514 (insn, operands);

    case 84:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1073 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4670 (insn, operands);

    case 85:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4884 (insn, operands);

    case 86:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 258 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SFmode) && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4516 (insn, operands);

    case 87:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1074 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4672 (insn, operands);

    case 88:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 259 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4518 (insn, operands);

    case 89:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1075 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4674 (insn, operands);

    case 90:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 260 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4520 (insn, operands);

    case 91:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1076 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4676 (insn, operands);

    case 92:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 261 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DFmode) && TARGET_VECTOR_ELEN_FP_64)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4522 (insn, operands);

    case 93:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1077 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4678 (insn, operands);

    case 94:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 262 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 64)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4524 (insn, operands);

    case 95:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1078 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 64)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4680 (insn, operands);

    case 96:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 263 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 128)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4526 (insn, operands);

    case 97:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1079 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 128)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4682 (insn, operands);

    case 98:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 264 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 256)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4528 (insn, operands);

    case 99:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1080 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 256)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4684 (insn, operands);

    case 100:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 265 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 512)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4530 (insn, operands);

    case 101:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1081 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 512)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4686 (insn, operands);

    case 102:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 266 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4532 (insn, operands);

    case 103:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1082 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 1024)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4688 (insn, operands);

    case 104:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 267 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4534 (insn, operands);

    case 105:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1083 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 2048)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4690 (insn, operands);

    case 106:
      if (!((
#line 934 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 268 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DFmode) && TARGET_VECTOR_ELEN_FP_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 936 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4536 (insn, operands);

    case 107:
      if (!((
#line 983 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 1084 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_VECTOR_ELEN_FP_32 && TARGET_MIN_VLEN >= 4096)) && 
#line 985 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4692 (insn, operands);

    case 108:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4790 (insn, operands);

    case 109:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4792 (insn, operands);

    case 110:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 155 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4794 (insn, operands);

    case 111:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4796 (insn, operands);

    case 112:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 156 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4798 (insn, operands);

    case 113:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 157 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_ZVFH && TARGET_VECTOR_ELEN_64)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4800 (insn, operands);

    case 114:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 236 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HFmode) && TARGET_ZVFH)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4820 (insn, operands);

    case 115:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 237 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HFmode) && TARGET_ZVFH)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4822 (insn, operands);

    case 116:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 238 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HFmode) && TARGET_ZVFH)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4824 (insn, operands);

    case 117:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 239 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HFmode) && TARGET_ZVFH)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4826 (insn, operands);

    case 118:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 240 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HFmode) && TARGET_ZVFH)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4828 (insn, operands);

    case 119:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 241 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 64)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4830 (insn, operands);

    case 120:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 242 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 128)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4832 (insn, operands);

    case 121:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 243 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 256)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4834 (insn, operands);

    case 122:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 244 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 512)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4836 (insn, operands);

    case 123:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 245 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 1024)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4838 (insn, operands);

    case 124:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 246 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 2048)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4840 (insn, operands);

    case 125:
      if (!((
#line 1027 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 247 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HFmode) && TARGET_ZVFH && TARGET_MIN_VLEN >= 4096)) && 
#line 1029 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_4842 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_160 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case UNSPEC:
      switch (XVECLEN (x3, 0))
        {
        case 5:
          if (XINT (x3, 1) != 93
              || pattern265 (x3) != 0)
            return NULL;
          x4 = XVECEXP (x3, 0, 0);
          switch (GET_CODE (x4))
            {
            case CONST_VECTOR:
              operands[1] = x4;
              x5 = XVECEXP (x3, 0, 1);
              operands[4] = x5;
              if (!vector_length_operand (operands[4], E_VOIDmode))
                return NULL;
              x6 = XVECEXP (x3, 0, 2);
              operands[5] = x6;
              x7 = XEXP (x2, 1);
              operands[3] = x7;
              x8 = XEXP (x2, 2);
              operands[2] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_RVVMF64BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF64BImode)
                      || pattern578 (x2, 
E_RVVMF64BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_779 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF64BImode, 5))))
                    return NULL;
                  return gen_split_2431 (insn, operands);

                case E_RVVMF32BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF32BImode)
                      || pattern578 (x2, 
E_RVVMF32BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_780 (insn, operands);
                  if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF32BImode, 5))))
                    return NULL;
                  return gen_split_2432 (insn, operands);

                case E_RVVMF16BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF16BImode)
                      || pattern578 (x2, 
E_RVVMF16BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_781 (insn, operands);
                  if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF16BImode, 5))))
                    return NULL;
                  return gen_split_2433 (insn, operands);

                case E_RVVMF8BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF8BImode)
                      || pattern578 (x2, 
E_RVVMF8BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_782 (insn, operands);
                  if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF8BImode, 5))))
                    return NULL;
                  return gen_split_2434 (insn, operands);

                case E_RVVMF4BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF4BImode)
                      || pattern578 (x2, 
E_RVVMF4BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_783 (insn, operands);
                  if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF4BImode, 5))))
                    return NULL;
                  return gen_split_2435 (insn, operands);

                case E_RVVMF2BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVMF2BImode)
                      || pattern578 (x2, 
E_RVVMF2BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_784 (insn, operands);
                  if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVMF2BImode, 5))))
                    return NULL;
                  return gen_split_2436 (insn, operands);

                case E_RVVM1BImode:
                  if (!nonimmediate_operand (operands[0], E_RVVM1BImode)
                      || pattern578 (x2, 
E_RVVM1BImode) != 0)
                    return NULL;
                  if ((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_785 (insn, operands);
                  if (!(
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, RVVM1BImode, 5))))
                    return NULL;
                  return gen_split_2437 (insn, operands);

                case E_V1BImode:
                  if (!nonimmediate_operand (operands[0], E_V1BImode)
                      || pattern578 (x2, 
E_V1BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_786 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1518 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1BImode))) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1BImode, 5))))
                    return NULL;
                  return gen_split_2438 (insn, operands);

                case E_V2BImode:
                  if (!nonimmediate_operand (operands[0], E_V2BImode)
                      || pattern578 (x2, 
E_V2BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_787 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1519 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2BImode))) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2BImode, 5))))
                    return NULL;
                  return gen_split_2439 (insn, operands);

                case E_V4BImode:
                  if (!nonimmediate_operand (operands[0], E_V4BImode)
                      || pattern578 (x2, 
E_V4BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_788 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1520 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4BImode))) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4BImode, 5))))
                    return NULL;
                  return gen_split_2440 (insn, operands);

                case E_V8BImode:
                  if (!nonimmediate_operand (operands[0], E_V8BImode)
                      || pattern578 (x2, 
E_V8BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_789 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1521 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8BImode))) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V8BImode, 5))))
                    return NULL;
                  return gen_split_2441 (insn, operands);

                case E_V16BImode:
                  if (!nonimmediate_operand (operands[0], E_V16BImode)
                      || pattern578 (x2, 
E_V16BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_790 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1522 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16BImode))) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V16BImode, 5))))
                    return NULL;
                  return gen_split_2442 (insn, operands);

                case E_V32BImode:
                  if (!nonimmediate_operand (operands[0], E_V32BImode)
                      || pattern578 (x2, 
E_V32BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_791 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1523 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32BImode))) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V32BImode, 5))))
                    return NULL;
                  return gen_split_2443 (insn, operands);

                case E_V64BImode:
                  if (!nonimmediate_operand (operands[0], E_V64BImode)
                      || pattern578 (x2, 
E_V64BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_792 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1524 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64BImode) && TARGET_MIN_VLEN >= 64)) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V64BImode, 5))))
                    return NULL;
                  return gen_split_2444 (insn, operands);

                case E_V128BImode:
                  if (!nonimmediate_operand (operands[0], E_V128BImode)
                      || pattern578 (x2, 
E_V128BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_793 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1525 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128BImode) && TARGET_MIN_VLEN >= 128)) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V128BImode, 5))))
                    return NULL;
                  return gen_split_2445 (insn, operands);

                case E_V256BImode:
                  if (!nonimmediate_operand (operands[0], E_V256BImode)
                      || pattern578 (x2, 
E_V256BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_794 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1526 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256BImode) && TARGET_MIN_VLEN >= 256)) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V256BImode, 5))))
                    return NULL;
                  return gen_split_2446 (insn, operands);

                case E_V512BImode:
                  if (!nonimmediate_operand (operands[0], E_V512BImode)
                      || pattern578 (x2, 
E_V512BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_795 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1527 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512BImode) && TARGET_MIN_VLEN >= 512)) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V512BImode, 5))))
                    return NULL;
                  return gen_split_2447 (insn, operands);

                case E_V1024BImode:
                  if (!nonimmediate_operand (operands[0], E_V1024BImode)
                      || pattern578 (x2, 
E_V1024BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_796 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1528 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024BImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V1024BImode, 5))))
                    return NULL;
                  return gen_split_2448 (insn, operands);

                case E_V2048BImode:
                  if (!nonimmediate_operand (operands[0], E_V2048BImode)
                      || pattern578 (x2, 
E_V2048BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_797 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1529 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048BImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V2048BImode, 5))))
                    return NULL;
                  return gen_split_2449 (insn, operands);

                case E_V4096BImode:
                  if (!nonimmediate_operand (operands[0], E_V4096BImode)
                      || pattern578 (x2, 
E_V4096BImode) != 0)
                    return NULL;
                  if (((
#line 170 "../../gcc/config/riscv/thead-vector.md"
(TARGET_XTHEADVECTOR) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 177 "../../gcc/config/riscv/thead-vector.md"
( !reload_completed)))
                    return gen_split_798 (insn, operands);
                  if (!((
#line 1964 "../../gcc/config/riscv/vector.md"
(TARGET_VECTOR) && 
#line 1530 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096BImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 1971 "../../gcc/config/riscv/vector.md"
( riscv_vector::whole_reg_to_reg_move_p (operands, V4096BImode, 5))))
                    return NULL;
                  return gen_split_2450 (insn, operands);

                default:
                  return NULL;
                }

            case CONST_INT:
            case REG:
            case SUBREG:
              return split_124 (x1, insn);

            default:
              return NULL;
            }

        case 7:
          return split_132 (x1, insn);

        case 6:
          if (pattern267 (x3) != 0)
            return NULL;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x3, 0, 1);
          operands[4] = x5;
          if (!vector_length_operand (operands[4], E_VOIDmode))
            return NULL;
          x6 = XVECEXP (x3, 0, 2);
          operands[5] = x6;
          if (!const_int_operand (operands[5], E_VOIDmode))
            return NULL;
          x9 = XVECEXP (x3, 0, 3);
          operands[6] = x9;
          if (!const_int_operand (operands[6], E_VOIDmode))
            return NULL;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          x8 = XEXP (x2, 2);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_RVVMF64BImode:
              if (!register_operand (operands[0], E_RVVMF64BImode)
                  || pattern578 (x2, 
E_RVVMF64BImode) != 0
                  || !(
#line 51 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR) && 
#line 1533 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)))
                return NULL;
              return gen_split_6307 (insn, operands);

            case E_RVVMF32BImode:
              if (!register_operand (operands[0], E_RVVMF32BImode)
                  || pattern578 (x2, 
E_RVVMF32BImode) != 0
                  || !
#line 51 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6308 (insn, operands);

            case E_RVVMF16BImode:
              if (!register_operand (operands[0], E_RVVMF16BImode)
                  || pattern578 (x2, 
E_RVVMF16BImode) != 0
                  || !
#line 51 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6309 (insn, operands);

            case E_RVVMF8BImode:
              if (!register_operand (operands[0], E_RVVMF8BImode)
                  || pattern578 (x2, 
E_RVVMF8BImode) != 0
                  || !
#line 51 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6310 (insn, operands);

            case E_RVVMF4BImode:
              if (!register_operand (operands[0], E_RVVMF4BImode)
                  || pattern578 (x2, 
E_RVVMF4BImode) != 0
                  || !
#line 51 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6311 (insn, operands);

            case E_RVVMF2BImode:
              if (!register_operand (operands[0], E_RVVMF2BImode)
                  || pattern578 (x2, 
E_RVVMF2BImode) != 0
                  || !
#line 51 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6312 (insn, operands);

            case E_RVVM1BImode:
              if (!register_operand (operands[0], E_RVVM1BImode)
                  || pattern578 (x2, 
E_RVVM1BImode) != 0
                  || !
#line 51 "../../gcc/config/riscv/autovec-opt.md"
(TARGET_VECTOR))
                return NULL;
              return gen_split_6313 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      return split_133 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
split_166 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern124 (x2))
    {
    case 0:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2600 (insn, operands);

    case 1:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2614 (insn, operands);

    case 2:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2628 (insn, operands);

    case 3:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2642 (insn, operands);

    case 4:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2656 (insn, operands);

    case 5:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2670 (insn, operands);

    case 6:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2684 (insn, operands);

    case 7:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2698 (insn, operands);

    case 8:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2712 (insn, operands);

    case 9:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2726 (insn, operands);

    case 10:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2740 (insn, operands);

    case 11:
      if (!(
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2754 (insn, operands);

    case 12:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2768 (insn, operands);

    case 13:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 141 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2782 (insn, operands);

    case 14:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2796 (insn, operands);

    case 15:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 142 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2810 (insn, operands);

    case 16:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2824 (insn, operands);

    case 17:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2838 (insn, operands);

    case 18:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 131 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2852 (insn, operands);

    case 19:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2866 (insn, operands);

    case 20:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 132 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2880 (insn, operands);

    case 21:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && (
#line 133 "../../gcc/config/riscv/vector-iterators.md"
(TARGET_VECTOR_ELEN_64) && 
#line 145 "../../gcc/config/riscv/vector-iterators.md"
(!TARGET_XTHEADVECTOR))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2894 (insn, operands);

    case 22:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 188 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2908 (insn, operands);

    case 23:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 189 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2922 (insn, operands);

    case 24:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 190 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2936 (insn, operands);

    case 25:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 191 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2950 (insn, operands);

    case 26:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 192 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2964 (insn, operands);

    case 27:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 193 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32QImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2978 (insn, operands);

    case 28:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 194 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64QImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_2992 (insn, operands);

    case 29:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 195 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128QImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3006 (insn, operands);

    case 30:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 196 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256QImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3020 (insn, operands);

    case 31:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 197 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512QImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3034 (insn, operands);

    case 32:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 198 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024QImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3048 (insn, operands);

    case 33:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 199 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048QImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3062 (insn, operands);

    case 34:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4096QImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3076 (insn, operands);

    case 35:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3090 (insn, operands);

    case 36:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 202 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3104 (insn, operands);

    case 37:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 203 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3118 (insn, operands);

    case 38:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 204 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3132 (insn, operands);

    case 39:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 205 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16HImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3146 (insn, operands);

    case 40:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 206 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32HImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3160 (insn, operands);

    case 41:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 207 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64HImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3174 (insn, operands);

    case 42:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 208 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128HImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3188 (insn, operands);

    case 43:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 209 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256HImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3202 (insn, operands);

    case 44:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 210 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512HImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3216 (insn, operands);

    case 45:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 211 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024HImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3230 (insn, operands);

    case 46:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 212 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2048HImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3244 (insn, operands);

    case 47:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 213 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1SImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3258 (insn, operands);

    case 48:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 214 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2SImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3272 (insn, operands);

    case 49:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 215 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4SImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3286 (insn, operands);

    case 50:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 216 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8SImode))) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3300 (insn, operands);

    case 51:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 217 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16SImode) && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3314 (insn, operands);

    case 52:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 218 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32SImode) && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3328 (insn, operands);

    case 53:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 219 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64SImode) && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3342 (insn, operands);

    case 54:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 220 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128SImode) && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3356 (insn, operands);

    case 55:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 221 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256SImode) && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3370 (insn, operands);

    case 56:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 222 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512SImode) && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3384 (insn, operands);

    case 57:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 223 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1024SImode) && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3398 (insn, operands);

    case 58:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 224 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V1DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3412 (insn, operands);

    case 59:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 225 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V2DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3426 (insn, operands);

    case 60:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 226 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V4DImode) && TARGET_VECTOR_ELEN_64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3440 (insn, operands);

    case 61:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 227 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V8DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 64)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3454 (insn, operands);

    case 62:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 228 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V16DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 128)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3468 (insn, operands);

    case 63:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 229 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V32DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 256)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3482 (insn, operands);

    case 64:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 230 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V64DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 512)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3496 (insn, operands);

    case 65:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 231 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V128DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 1024)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3510 (insn, operands);

    case 66:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 232 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V256DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 2048)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3524 (insn, operands);

    case 67:
      if (!((
#line 484 "../../gcc/config/riscv/autovec.md"
(TARGET_VECTOR && can_create_pseudo_p ()) && 
#line 233 "../../gcc/config/riscv/vector-iterators.md"
(riscv_vector::vls_mode_valid_p (V512DImode) && TARGET_VECTOR_ELEN_64 && TARGET_MIN_VLEN >= 4096)) && 
#line 486 "../../gcc/config/riscv/autovec.md"
( 1)))
        return NULL;
      return gen_split_3538 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_174 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (equality_operator (x4, E_VOIDmode))
    {
      switch (pattern419 (x3))
        {
        case 0:
          if (shifted_const_arith_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && ((
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3170 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_54 (insn, operands);
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && ((
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3170 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_57 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          if (consecutive_bits_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && ((
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3239 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_77 (insn, operands);
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && ((
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3239 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_81 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case 1:
          if (shifted_const_arith_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && ((
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3170 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_55 (insn, operands);
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && ((
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3170 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_58 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          if (consecutive_bits_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && ((
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3239 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_78 (insn, operands);
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && ((
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3239 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_82 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case 2:
          if (shifted_const_arith_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && ((
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3170 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_56 (insn, operands);
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && ((
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3170 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_59 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          if (consecutive_bits_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && ((
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 3239 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_79 (insn, operands);
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && ((
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3239 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_83 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case 3:
          if (shifted_const_arith_operand (operands[3], E_VOIDmode)
              && scratch_operand (operands[4], E_DImode)
              && ((
#line 3168 "../../gcc/config/riscv/riscv.md"
(!SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3170 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
            return gen_split_60 (insn, operands);
          if (consecutive_bits_operand (operands[3], E_VOIDmode))
            {
              switch (GET_MODE (operands[4]))
                {
                case E_SImode:
                  if (scratch_operand (operands[4], E_SImode)
                      && ((
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && ((((
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3239 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_80 (insn, operands);
                  break;

                case E_DImode:
                  if (scratch_operand (operands[4], E_DImode)
                      && ((
#line 3235 "../../gcc/config/riscv/riscv.md"
((INTVAL (operands[3]) >= 0 || !partial_subreg_p (operands[2]))
    && popcount_hwi (INTVAL (operands[3])) > 1
    && !SMALL_OPERAND (INTVAL (operands[3]))) && 
#line 69 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 3239 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
                    return gen_split_84 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case 4:
          x5 = XEXP (x4, 0);
          x6 = XEXP (x5, 1);
          if (XWINT (x6, 0) == 1L)
            {
              switch (pattern465 (x3))
                {
                case 0:
                  if ((
#line 3445 "../../gcc/config/riscv/riscv.md"
(reload_completed) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return gen_split_97 (insn, operands);
                  break;

                case 1:
                  if ((
#line 3445 "../../gcc/config/riscv/riscv.md"
(reload_completed) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return gen_split_98 (insn, operands);
                  break;

                case 2:
                  if (((
#line 1145 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 1147 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_185 (insn, operands);
                  break;

                case 3:
                  if (((
#line 1145 "../../gcc/config/riscv/bitmanip.md"
(TARGET_ZBS) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 1147 "../../gcc/config/riscv/bitmanip.md"
( reload_completed)))
                    return gen_split_186 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          x7 = XEXP (x5, 2);
          if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (pattern466 (x3))
                {
                case 0:
                  if ((
#line 3477 "../../gcc/config/riscv/riscv.md"
(reload_completed) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)))
                    return gen_split_99 (insn, operands);
                  break;

                case 1:
                  if ((
#line 3477 "../../gcc/config/riscv/riscv.md"
(reload_completed) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)))
                    return gen_split_100 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
    }
  if (!ne_operator (x4, E_VOIDmode))
    return NULL;
  switch (pattern411 (x3))
    {
    case 0:
      if (!((
#line 3408 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3410 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_91 (insn, operands);

    case 1:
      if (!((
#line 3408 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 105 "../../gcc/config/riscv/iterators.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))) && 
#line 3410 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_92 (insn, operands);

    case 2:
      if (!((
#line 3408 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3410 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_93 (insn, operands);

    case 3:
      if (!((
#line 3408 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 106 "../../gcc/config/riscv/iterators.md"
(TARGET_DOUBLE_FLOAT || TARGET_ZDINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))) && 
#line 3410 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_94 (insn, operands);

    case 4:
      if (!((
#line 3408 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(!TARGET_64BIT))) && 
#line 3410 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_95 (insn, operands);

    case 5:
      if (!((
#line 3408 "../../gcc/config/riscv/riscv.md"
(TARGET_HARD_FLOAT || TARGET_ZFINX) && (((
#line 107 "../../gcc/config/riscv/iterators.md"
(TARGET_ZFH || TARGET_ZHINX) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT)) && 
#line 38 "../../gcc/config/riscv/iterators.md"
(TARGET_64BIT))) && 
#line 3410 "../../gcc/config/riscv/riscv.md"
( reload_completed)))
        return NULL;
      return gen_split_96 (insn, operands);

    default:
      return NULL;
    }
}
